(function () {
	var global = this,
		objectPrototype = Object.prototype,
		toString = objectPrototype.toString,
		enumerables = true,
		enumerablesTest = {
			toString: 1
		},
		emptyFn = function () {},
		i;
	if (typeof Ext === "undefined") {
		global.Ext = {}
	}
	Ext.global = global;
	for (i in enumerablesTest) {
		enumerables = null
	}
	if (enumerables) {
		enumerables = ["hasOwnProperty", "valueOf", "isPrototypeOf", "propertyIsEnumerable", "toLocaleString", "toString", "constructor"]
	}
	Ext.enumerables = enumerables;
	Ext.apply = function (object, config, defaults) {
		if (defaults) {
			Ext.apply(object, defaults)
		}
		if (object && config && typeof config === "object") {
			var i, j, k;
			for (i in config) {
				object[i] = config[i]
			}
			if (enumerables) {
				for (j = enumerables.length; j--;) {
					k = enumerables[j];
					if (config.hasOwnProperty(k)) {
						object[k] = config[k]
					}
				}
			}
		}
		return object
	};
	Ext.buildSettings = Ext.apply({
		baseCSSPrefix: "x-",
		scopeResetCSS: false
	}, Ext.buildSettings || {});
	Ext.apply(Ext, {
		emptyFn: emptyFn,
		baseCSSPrefix: Ext.buildSettings.baseCSSPrefix,
		applyIf: function (object, config) {
			var property;
			if (object) {
				for (property in config) {
					if (object[property] === undefined) {
						object[property] = config[property]
					}
				}
			}
			return object
		},
		iterate: function (object, fn, scope) {
			if (Ext.isEmpty(object)) {
				return
			}
			if (scope === undefined) {
				scope = object
			}
			if (Ext.isIterable(object)) {
				Ext.Array.each.call(Ext.Array, object, fn, scope)
			} else {
				Ext.Object.each.call(Ext.Object, object, fn, scope)
			}
		}
	});
	Ext.apply(Ext, {
		extend: function () {
			var objectConstructor = objectPrototype.constructor,
				inlineOverrides = function (o) {
					for (var m in o) {
						if (!o.hasOwnProperty(m)) {
							continue
						}
						this[m] = o[m]
					}
				};
			return function (subclass, superclass, overrides) {
				if (Ext.isObject(superclass)) {
					overrides = superclass;
					superclass = subclass;
					subclass = overrides.constructor !== objectConstructor ? overrides.constructor : function () {
						superclass.apply(this, arguments)
					}
				}
				var F = function () {},
					subclassProto, superclassProto = superclass.prototype;
				F.prototype = superclassProto;
				subclassProto = subclass.prototype = new F();
				subclassProto.constructor = subclass;
				subclass.superclass = superclassProto;
				if (superclassProto.constructor === objectConstructor) {
					superclassProto.constructor = superclass
				}
				subclass.override = function (overrides) {
					Ext.override(subclass, overrides)
				};
				subclassProto.override = inlineOverrides;
				subclassProto.proto = subclassProto;
				subclass.override(overrides);
				subclass.extend = function (o) {
					return Ext.extend(subclass, o)
				};
				return subclass
			}
		}(),
		override: function (cls, overrides) {
			if (cls.$isClass) {
				return cls.override(overrides)
			} else {
				Ext.apply(cls.prototype, overrides)
			}
		}
	});
	Ext.apply(Ext, {
		valueFrom: function (value, defaultValue, allowBlank) {
			return Ext.isEmpty(value, allowBlank) ? defaultValue : value
		},
		typeOf: function (value) {
			if (value === null) {
				return "null"
			}
			var type = typeof value;
			if (type === "undefined" || type === "string" || type === "number" || type === "boolean") {
				return type
			}
			var typeToString = toString.call(value);
			switch (typeToString) {
			case "[object Array]":
				return "array";
			case "[object Date]":
				return "date";
			case "[object Boolean]":
				return "boolean";
			case "[object Number]":
				return "number";
			case "[object RegExp]":
				return "regexp"
			}
			if (type === "function") {
				return "function"
			}
			if (type === "object") {
				if (value.nodeType !== undefined) {
					if (value.nodeType === 3) {
						return (/\S/).test(value.nodeValue) ? "textnode" : "whitespace"
					} else {
						return "element"
					}
				}
				return "object"
			}
		},
		isEmpty: function (value, allowEmptyString) {
			return (value === null) || (value === undefined) || (!allowEmptyString ? value === "" : false) || (Ext.isArray(value) && value.length === 0)
		},
		isArray: ("isArray" in Array) ? Array.isArray : function (value) {
			return toString.call(value) === "[object Array]"
		},
		isDate: function (value) {
			return toString.call(value) === "[object Date]"
		},
		isMSDate: function (value) {
			if (!Ext.isString(value)) {
				return false
			} else {
				return value.match("\\\\?/Date\\(([-+])?(\\d+)(?:[+-]\\d{4})?\\)\\\\?/") !== null
			}
		},
		isObject: (toString.call(null) === "[object Object]") ?
		function (value) {
			return value !== null && value !== undefined && toString.call(value) === "[object Object]" && value.ownerDocument === undefined
		} : function (value) {
			return toString.call(value) === "[object Object]"
		},
		isSimpleObject: function (value) {
			return value instanceof Object && value.constructor === Object
		},
		isPrimitive: function (value) {
			var type = typeof value;
			return type === "string" || type === "number" || type === "boolean"
		},
		isFunction: (typeof document !== "undefined" && typeof document.getElementsByTagName("body") === "function") ?
		function (value) {
			return toString.call(value) === "[object Function]"
		} : function (value) {
			return typeof value === "function"
		},
		isNumber: function (value) {
			return typeof value === "number" && isFinite(value)
		},
		isNumeric: function (value) {
			return !isNaN(parseFloat(value)) && isFinite(value)
		},
		isString: function (value) {
			return typeof value === "string"
		},
		isBoolean: function (value) {
			return typeof value === "boolean"
		},
		isElement: function (value) {
			return value ? value.nodeType === 1 : false
		},
		isTextNode: function (value) {
			return value ? value.nodeName === "#text" : false
		},
		isDefined: function (value) {
			return typeof value !== "undefined"
		},
		isIterable: function (value) {
			return (value && typeof value !== "string") ? value.length !== undefined : false
		}
	});
	Ext.apply(Ext, {
		clone: function (item) {
			if (item === null || item === undefined) {
				return item
			}
			if (item.nodeType && item.cloneNode) {
				return item.cloneNode(true)
			}
			var type = toString.call(item);
			if (type === "[object Date]") {
				return new Date(item.getTime())
			}
			var i, j, k, clone, key;
			if (type === "[object Array]") {
				i = item.length;
				clone = [];
				while (i--) {
					clone[i] = Ext.clone(item[i])
				}
			} else {
				if (type === "[object Object]" && item.constructor === Object) {
					clone = {};
					for (key in item) {
						clone[key] = Ext.clone(item[key])
					}
					if (enumerables) {
						for (j = enumerables.length; j--;) {
							k = enumerables[j];
							clone[k] = item[k]
						}
					}
				}
			}
			return clone || item
		},
		getUniqueGlobalNamespace: function () {
			var uniqueGlobalNamespace = this.uniqueGlobalNamespace;
			if (uniqueGlobalNamespace === undefined) {
				var i = 0;
				do {
					uniqueGlobalNamespace = "ExtBox" + (++i)
				} while (Ext.global[uniqueGlobalNamespace] !== undefined);
				Ext.global[uniqueGlobalNamespace] = Ext;
				this.uniqueGlobalNamespace = uniqueGlobalNamespace
			}
			return uniqueGlobalNamespace
		},
		functionFactory: function () {
			var args = Array.prototype.slice.call(arguments),
				ln = args.length;
			if (ln > 0) {
				args[ln - 1] = "var Ext=window." + this.getUniqueGlobalNamespace() + ";" + args[ln - 1]
			}
			return Function.prototype.constructor.apply(Function.prototype, args)
		},
		globalEval: ("execScript" in global) ?
		function (code) {
			global.execScript(code)
		} : function (code) {
			(function () {
				eval(code)
			})()
		}
	});
	Ext.type = Ext.typeOf
})();
(function () {
	var a = "4.1.0",
		b;
	Ext.Version = b = Ext.extend(Object, {
		constructor: function (d) {
			var c = this.toNumber,
				f, e;
			if (d instanceof b) {
				return d
			}
			this.version = this.shortVersion = String(d).toLowerCase().replace(/_/g, ".").replace(/[\-+]/g, "");
			e = this.version.search(/([^\d\.])/);
			if (e !== -1) {
				this.release = this.version.substr(e, d.length);
				this.shortVersion = this.version.substr(0, e)
			}
			this.shortVersion = this.shortVersion.replace(/[^\d]/g, "");
			f = this.version.split(".");
			this.major = c(f.shift());
			this.minor = c(f.shift());
			this.patch = c(f.shift());
			this.build = c(f.shift());
			return this
		},
		toNumber: function (c) {
			c = parseInt(c || 0, 10);
			if (isNaN(c)) {
				c = 0
			}
			return c
		},
		toString: function () {
			return this.version
		},
		valueOf: function () {
			return this.version
		},
		getMajor: function () {
			return this.major || 0
		},
		getMinor: function () {
			return this.minor || 0
		},
		getPatch: function () {
			return this.patch || 0
		},
		getBuild: function () {
			return this.build || 0
		},
		getRelease: function () {
			return this.release || ""
		},
		isGreaterThan: function (c) {
			return b.compare(this.version, c) === 1
		},
		isGreaterThanOrEqual: function (c) {
			return b.compare(this.version, c) >= 0
		},
		isLessThan: function (c) {
			return b.compare(this.version, c) === -1
		},
		isLessThanOrEqual: function (c) {
			return b.compare(this.version, c) <= 0
		},
		equals: function (c) {
			return b.compare(this.version, c) === 0
		},
		match: function (c) {
			c = String(c);
			return this.version.substr(0, c.length) === c
		},
		toArray: function () {
			return [this.getMajor(), this.getMinor(), this.getPatch(), this.getBuild(), this.getRelease()]
		},
		getShortVersion: function () {
			return this.shortVersion
		},
		gt: function () {
			return this.isGreaterThan.apply(this, arguments)
		},
		lt: function () {
			return this.isLessThan.apply(this, arguments)
		},
		gtEq: function () {
			return this.isGreaterThanOrEqual.apply(this, arguments)
		},
		ltEq: function () {
			return this.isLessThanOrEqual.apply(this, arguments)
		}
	});
	Ext.apply(b, {
		releaseValueMap: {
			dev: -6,
			alpha: -5,
			a: -5,
			beta: -4,
			b: -4,
			rc: -3,
			"#": -2,
			p: -1,
			pl: -1
		},
		getComponentValue: function (c) {
			return !c ? 0 : (isNaN(c) ? this.releaseValueMap[c] || c : parseInt(c, 10))
		},
		compare: function (g, f) {
			var d, e, c;
			g = new b(g).toArray();
			f = new b(f).toArray();
			for (c = 0; c < Math.max(g.length, f.length); c++) {
				d = this.getComponentValue(g[c]);
				e = this.getComponentValue(f[c]);
				if (d < e) {
					return -1
				} else {
					if (d > e) {
						return 1
					}
				}
			}
			return 0
		}
	});
	Ext.apply(Ext, {
		versions: {},
		lastRegisteredVersion: null,
		setVersion: function (d, c) {
			Ext.versions[d] = new b(c);
			Ext.lastRegisteredVersion = Ext.versions[d];
			return this
		},
		getVersion: function (c) {
			if (c === undefined) {
				return Ext.lastRegisteredVersion
			}
			return Ext.versions[c]
		},
		deprecate: function (c, e, f, d) {
			if (b.compare(Ext.getVersion(c), e) < 1) {
				f.call(d)
			}
		}
	});
	Ext.setVersion("core", a)
})();
Ext.String = {
	trimRegex: /^[\x09\x0a\x0b\x0c\x0d\x20\xa0\u1680\u180e\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200a\u2028\u2029\u202f\u205f\u3000]+|[\x09\x0a\x0b\x0c\x0d\x20\xa0\u1680\u180e\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200a\u2028\u2029\u202f\u205f\u3000]+$/g,
	escapeRe: /('|\\)/g,
	formatRe: /\{(\d+)\}/g,
	escapeRegexRe: /([-.*+?^${}()|[\]\/\\])/g,
	htmlEncode: (function () {
		var d = {
			"&": "&amp;",
			">": "&gt;",
			"<": "&lt;",
			'"': "&quot;"
		},
			b = [],
			c, a;
		for (c in d) {
			b.push(c)
		}
		a = new RegExp("(" + b.join("|") + ")", "g");
		return function (e) {
			return (!e) ? e : String(e).replace(a, function (g, f) {
				return d[f]
			})
		}
	})(),
	htmlDecode: (function () {
		var d = {
			"&amp;": "&",
			"&gt;": ">",
			"&lt;": "<",
			"&quot;": '"'
		},
			b = [],
			c, a;
		for (c in d) {
			b.push(c)
		}
		a = new RegExp("(" + b.join("|") + "|&#[0-9]{1,5};)", "g");
		return function (e) {
			return (!e) ? e : String(e).replace(a, function (g, f) {
				if (f in d) {
					return d[f]
				} else {
					return String.fromCharCode(parseInt(f.substr(2), 10))
				}
			})
		}
	})(),
	urlAppend: function (b, a) {
		if (!Ext.isEmpty(a)) {
			return b + (b.indexOf("?") === -1 ? "?" : "&") + a
		}
		return b
	},
	trim: function (a) {
		return a.replace(Ext.String.trimRegex, "")
	},
	capitalize: function (a) {
		return a.charAt(0).toUpperCase() + a.substr(1)
	},
	ellipsis: function (c, a, d) {
		if (c && c.length > a) {
			if (d) {
				var e = c.substr(0, a - 2),
					b = Math.max(e.lastIndexOf(" "), e.lastIndexOf("."), e.lastIndexOf("!"), e.lastIndexOf("?"));
				if (b !== -1 && b >= (a - 15)) {
					return e.substr(0, b) + "..."
				}
			}
			return c.substr(0, a - 3) + "..."
		}
		return c
	},
	escapeRegex: function (a) {
		return a.replace(Ext.String.escapeRegexRe, "\\$1")
	},
	escape: function (a) {
		return a.replace(Ext.String.escapeRe, "\\$1")
	},
	toggle: function (b, c, a) {
		return b === c ? a : c
	},
	leftPad: function (b, c, d) {
		var a = String(b);
		d = d || " ";
		while (a.length < c) {
			a = d + a
		}
		return a
	},
	format: function (b) {
		var a = Ext.Array.toArray(arguments, 1);
		return b.replace(Ext.String.formatRe, function (c, d) {
			return a[d]
		})
	},
	repeat: function (e, d, b) {
		for (var a = [], c = d; c--;) {
			a.push(e)
		}
		return a.join(b || "")
	}
};
Ext.htmlEncode = Ext.String.htmlEncode;
Ext.htmlDecode = Ext.String.htmlDecode;
Ext.urlAppend = Ext.String.urlAppend;
(function () {
	var f = Array.prototype,
		o = f.slice,
		q = function () {
			var A = [],
				e, z = 20;
			if (!A.splice) {
				return false
			}
			while (z--) {
				A.push("A")
			}
			A.splice(15, 0, "F", "F", "F", "F", "F", "F", "F", "F", "F", "F", "F", "F", "F", "F", "F", "F", "F", "F", "F", "F", "F");
			e = A.length;
			A.splice(13, 0, "XXX");
			if (e + 1 != A.length) {
				return false
			}
			return true
		}(),
		j = "forEach" in f,
		u = "map" in f,
		p = "indexOf" in f,
		y = "every" in f,
		c = "some" in f,
		d = "filter" in f,
		n = function () {
			var e = [1, 2, 3, 4, 5].sort(function () {
				return 0
			});
			return e[0] === 1 && e[1] === 2 && e[2] === 3 && e[3] === 4 && e[4] === 5
		}(),
		k = true,
		a;
	try {
		if (typeof document !== "undefined") {
			o.call(document.getElementsByTagName("body"))
		}
	} catch (s) {
		k = false
	}
	function m(z, e) {
		return (e < 0) ? Math.max(0, z.length + e) : Math.min(z.length, e)
	}
	function x(G, F, z, J) {
		var K = J ? J.length : 0,
			B = G.length,
			H = m(G, F);
		if (H === B) {
			if (K) {
				G.push.apply(G, J)
			}
		} else {
			var E = Math.min(z, B - H),
				I = H + E,
				A = I + K - E,
				e = B - I,
				C = B - E,
				D;
			if (A < I) {
				for (D = 0; D < e; ++D) {
					G[A + D] = G[I + D]
				}
			} else {
				if (A > I) {
					for (D = e; D--;) {
						G[A + D] = G[I + D]
					}
				}
			}
			if (K && H === C) {
				G.length = C;
				G.push.apply(G, J)
			} else {
				G.length = C + K;
				for (D = 0; D < K; ++D) {
					G[H + D] = J[D]
				}
			}
		}
		return G
	}
	function h(B, e, A, z) {
		if (z && z.length) {
			if (e < B.length) {
				B.splice.apply(B, [e, A].concat(z))
			} else {
				B.push.apply(B, z)
			}
		} else {
			B.splice(e, A)
		}
		return B
	}
	function b(A, e, z) {
		return x(A, e, z)
	}
	function r(A, e, z) {
		A.splice(e, z);
		return A
	}
	function l(C, e, A) {
		var B = m(C, e),
			z = C.slice(e, m(C, B + A));
		if (arguments.length < 4) {
			x(C, B, A)
		} else {
			x(C, B, A, o.call(arguments, 3))
		}
		return z
	}
	function g(e) {
		return e.splice.apply(e, o.call(arguments, 1))
	}
	var w = q ? r : b,
		t = q ? h : x,
		v = q ? g : l;
	a = Ext.Array = {
		each: function (D, B, A, e) {
			D = a.from(D);
			var z, C = D.length;
			if (e !== true) {
				for (z = 0; z < C; z++) {
					if (B.call(A || D[z], D[z], z, D) === false) {
						return z
					}
				}
			} else {
				for (z = C - 1; z > -1; z--) {
					if (B.call(A || D[z], D[z], z, D) === false) {
						return z
					}
				}
			}
			return true
		},
		forEach: j ?
		function (A, z, e) {
			return A.forEach(z, e)
		} : function (C, A, z) {
			var e = 0,
				B = C.length;
			for (; e < B; e++) {
				A.call(z, C[e], e, C)
			}
		},
		indexOf: (p) ?
		function (A, e, z) {
			return A.indexOf(e, z)
		} : function (C, A, B) {
			var e, z = C.length;
			for (e = (B < 0) ? Math.max(0, z + B) : B || 0; e < z; e++) {
				if (C[e] === A) {
					return e
				}
			}
			return -1
		},
		contains: p ?
		function (z, e) {
			return z.indexOf(e) !== -1
		} : function (B, A) {
			var e, z;
			for (e = 0, z = B.length; e < z; e++) {
				if (B[e] === A) {
					return true
				}
			}
			return false
		},
		toArray: function (A, C, e) {
			if (!A || !A.length) {
				return []
			}
			if (typeof A === "string") {
				A = A.split("")
			}
			if (k) {
				return o.call(A, C || 0, e || A.length)
			}
			var B = [],
				z;
			C = C || 0;
			e = e ? ((e < 0) ? A.length + e : e) : A.length;
			for (z = C; z < e; z++) {
				B.push(A[z])
			}
			return B
		},
		pluck: function (D, e) {
			var z = [],
				A, C, B;
			for (A = 0, C = D.length; A < C; A++) {
				B = D[A];
				z.push(B[e])
			}
			return z
		},
		map: u ?
		function (A, z, e) {
			return A.map(z, e)
		} : function (D, C, B) {
			var A = [],
				z = 0,
				e = D.length;
			for (; z < e; z++) {
				A[z] = C.call(B, D[z], z, D)
			}
			return A
		},
		every: function (C, A, z) {
			if (y) {
				return C.every(A, z)
			}
			var e = 0,
				B = C.length;
			for (; e < B; ++e) {
				if (!A.call(z, C[e], e, C)) {
					return false
				}
			}
			return true
		},
		some: function (C, A, z) {
			if (c) {
				return C.some(A, z)
			}
			var e = 0,
				B = C.length;
			for (; e < B; ++e) {
				if (A.call(z, C[e], e, C)) {
					return true
				}
			}
			return false
		},
		clean: function (C) {
			var z = [],
				e = 0,
				B = C.length,
				A;
			for (; e < B; e++) {
				A = C[e];
				if (!Ext.isEmpty(A)) {
					z.push(A)
				}
			}
			return z
		},
		unique: function (C) {
			var B = [],
				e = 0,
				A = C.length,
				z;
			for (; e < A; e++) {
				z = C[e];
				if (a.indexOf(B, z) === -1) {
					B.push(z)
				}
			}
			return B
		},
		filter: function (D, B, A) {
			if (d) {
				return D.filter(B, A)
			}
			var z = [],
				e = 0,
				C = D.length;
			for (; e < C; e++) {
				if (B.call(A, D[e], e, D)) {
					z.push(D[e])
				}
			}
			return z
		},
		from: function (z, e) {
			if (z === undefined || z === null) {
				return []
			}
			if (Ext.isArray(z)) {
				return (e) ? o.call(z) : z
			}
			if (z && z.length !== undefined && typeof z !== "string") {
				return a.toArray(z)
			}
			return [z]
		},
		remove: function (A, z) {
			var e = a.indexOf(A, z);
			if (e !== -1) {
				w(A, e, 1)
			}
			return A
		},
		include: function (z, e) {
			if (!a.contains(z, e)) {
				z.push(e)
			}
		},
		clone: function (e) {
			return o.call(e)
		},
		merge: function () {
			var e = o.call(arguments),
				B = [],
				z, A;
			for (z = 0, A = e.length; z < A; z++) {
				B = B.concat(e[z])
			}
			return a.unique(B)
		},
		intersect: function () {
			var e = [],
				C = o.call(arguments),
				B, D, A, z;
			if (!C.length) {
				return e
			}
			C = C.sort(function (F, E) {
				if (F.length > E.length) {
					return 1
				} else {
					if (F.length < E.length) {
						return -1
					} else {
						return 0
					}
				}
			});
			D = a.unique(C[0]);
			for (A = 0; A < D.length; A++) {
				B = D[A];
				for (z = 1; z < C.length; z++) {
					if (C[z].indexOf(B) === -1) {
						break
					}
					if (z == (C.length - 1)) {
						e.push(B)
					}
				}
			}
			return e
		},
		difference: function (z, e) {
			var E = o.call(z),
				C = E.length,
				B, A, D;
			for (B = 0, D = e.length; B < D; B++) {
				for (A = 0; A < C; A++) {
					if (E[A] === e[B]) {
						w(E, A, 1);
						A--;
						C--
					}
				}
			}
			return E
		},
		slice: function (A, z, e) {
			return o.call(A, z, e)
		},
		sort: function (F, E) {
			if (n) {
				if (E) {
					return F.sort(E)
				} else {
					return F.sort()
				}
			}
			var C = F.length,
				B = 0,
				D, e, A, z;
			for (; B < C; B++) {
				A = B;
				for (e = B + 1; e < C; e++) {
					if (E) {
						D = E(F[e], F[A]);
						if (D < 0) {
							A = e
						}
					} else {
						if (F[e] < F[A]) {
							A = e
						}
					}
				}
				if (A !== B) {
					z = F[B];
					F[B] = F[A];
					F[A] = z
				}
			}
			return F
		},
		flatten: function (A) {
			var z = [];

			function e(B) {
				var D, E, C;
				for (D = 0, E = B.length; D < E; D++) {
					C = B[D];
					if (Ext.isArray(C)) {
						e(C)
					} else {
						z.push(C)
					}
				}
				return z
			}
			return e(A)
		},
		min: function (D, C) {
			var z = D[0],
				e, B, A;
			for (e = 0, B = D.length; e < B; e++) {
				A = D[e];
				if (C) {
					if (C(z, A) === 1) {
						z = A
					}
				} else {
					if (A < z) {
						z = A
					}
				}
			}
			return z
		},
		max: function (D, C) {
			var e = D[0],
				z, B, A;
			for (z = 0, B = D.length; z < B; z++) {
				A = D[z];
				if (C) {
					if (C(e, A) === -1) {
						e = A
					}
				} else {
					if (A > e) {
						e = A
					}
				}
			}
			return e
		},
		mean: function (e) {
			return e.length > 0 ? a.sum(e) / e.length : undefined
		},
		sum: function (C) {
			var z = 0,
				e, B, A;
			for (e = 0, B = C.length; e < B; e++) {
				A = C[e];
				z += A
			}
			return z
		},
		erase: w,
		insert: function (A, z, e) {
			return t(A, z, 0, e)
		},
		replace: t,
		splice: v
	};
	Ext.each = a.each;
	a.union = a.merge;
	Ext.min = a.min;
	Ext.max = a.max;
	Ext.sum = a.sum;
	Ext.mean = a.mean;
	Ext.flatten = a.flatten;
	Ext.clean = a.clean;
	Ext.unique = a.unique;
	Ext.pluck = a.pluck;
	Ext.toArray = function () {
		return a.toArray.apply(a, arguments)
	}
})();
(function () {
	var a = (0.9).toFixed() !== "1";
	Ext.Number = {
		constrain: function (d, c, b) {
			d = parseFloat(d);
			if (!isNaN(c)) {
				d = Math.max(d, c)
			}
			if (!isNaN(b)) {
				d = Math.min(d, b)
			}
			return d
		},
		snap: function (e, c, d, g) {
			var f = e,
				b;
			if (!(c && e)) {
				return e
			}
			b = e % c;
			if (b !== 0) {
				f -= b;
				if (b * 2 >= c) {
					f += c
				} else {
					if (b * 2 < -c) {
						f -= c
					}
				}
			}
			return Ext.Number.constrain(f, d, g)
		},
		toFixed: function (d, b) {
			if (a) {
				b = b || 0;
				var c = Math.pow(10, b);
				return (Math.round(d * c) / c).toFixed(b)
			}
			return d.toFixed(b)
		},
		from: function (c, b) {
			if (isFinite(c)) {
				c = parseFloat(c)
			}
			return !isNaN(c) ? c : b
		}
	}
})();
Ext.num = function () {
	return Ext.Number.from.apply(this, arguments)
};
(function () {
	var a = function () {};
	var b = Ext.Object = {
		chain: ("create" in Object) ?
		function (c) {
			return Object.create(c)
		} : function (d) {
			a.prototype = d;
			var c = new a();
			a.prototype = null;
			return c
		},
		toQueryObjects: function (e, j, d) {
			var c = b.toQueryObjects,
				h = [],
				f, g;
			if (Ext.isArray(j)) {
				for (f = 0, g = j.length; f < g; f++) {
					if (d) {
						h = h.concat(c(e + "[" + f + "]", j[f], true))
					} else {
						h.push({
							name: e,
							value: j[f]
						})
					}
				}
			} else {
				if (Ext.isObject(j)) {
					for (f in j) {
						if (j.hasOwnProperty(f)) {
							if (d) {
								h = h.concat(c(e + "[" + f + "]", j[f], true))
							} else {
								h.push({
									name: e,
									value: j[f]
								})
							}
						}
					}
				} else {
					h.push({
						name: e,
						value: j
					})
				}
			}
			return h
		},
		toQueryString: function (f, d) {
			var g = [],
				e = [],
				k, h, l, c, m;
			for (k in f) {
				if (f.hasOwnProperty(k)) {
					g = g.concat(b.toQueryObjects(k, f[k], d))
				}
			}
			for (h = 0, l = g.length; h < l; h++) {
				c = g[h];
				m = c.value;
				if (Ext.isEmpty(m)) {
					m = ""
				} else {
					if (Ext.isDate(m)) {
						m = Ext.Date.toString(m)
					}
				}
				e.push(encodeURIComponent(c.name) + "=" + encodeURIComponent(String(m)))
			}
			return e.join("&")
		},
		fromQueryString: function (d, q) {
			var l = d.replace(/^\?/, "").split("&"),
				t = {},
				r, h, v, m, p, f, n, o, c, g, s, k, u, e;
			for (p = 0, f = l.length; p < f; p++) {
				n = l[p];
				if (n.length > 0) {
					h = n.split("=");
					v = decodeURIComponent(h[0]);
					m = (h[1] !== undefined) ? decodeURIComponent(h[1]) : "";
					if (!q) {
						if (t.hasOwnProperty(v)) {
							if (!Ext.isArray(t[v])) {
								t[v] = [t[v]]
							}
							t[v].push(m)
						} else {
							t[v] = m
						}
					} else {
						g = v.match(/(\[):?([^\]]*)\]/g);
						s = v.match(/^([^\[]+)/);
						v = s[0];
						k = [];
						if (g === null) {
							t[v] = m;
							continue
						}
						for (o = 0, c = g.length; o < c; o++) {
							u = g[o];
							u = (u.length === 2) ? "" : u.substring(1, u.length - 1);
							k.push(u)
						}
						k.unshift(v);
						r = t;
						for (o = 0, c = k.length; o < c; o++) {
							u = k[o];
							if (o === c - 1) {
								if (Ext.isArray(r) && u === "") {
									r.push(m)
								} else {
									r[u] = m
								}
							} else {
								if (r[u] === undefined || typeof r[u] === "string") {
									e = k[o + 1];
									r[u] = (Ext.isNumeric(e) || e === "") ? [] : {}
								}
								r = r[u]
							}
						}
					}
				}
			}
			return t
		},
		each: function (c, e, d) {
			for (var f in c) {
				if (c.hasOwnProperty(f)) {
					if (e.call(d || c, f, c[f], c) === false) {
						return
					}
				}
			}
		},
		merge: function (c) {
			var h = 1,
				j = arguments.length,
				d = b.merge,
				f = Ext.clone,
				g, l, k, e;
			for (; h < j; h++) {
				g = arguments[h];
				for (l in g) {
					k = g[l];
					if (k && k.constructor === Object) {
						e = c[l];
						if (e && e.constructor === Object) {
							d(e, k)
						} else {
							c[l] = f(k)
						}
					} else {
						c[l] = k
					}
				}
			}
			return c
		},
		mergeIf: function (j) {
			var f = 1,
				g = arguments.length,
				d = Ext.clone,
				c, e, h;
			for (; f < g; f++) {
				c = arguments[f];
				for (e in c) {
					if (!(e in j)) {
						h = c[e];
						if (h && h.constructor === Object) {
							j[e] = d(h)
						} else {
							j[e] = h
						}
					}
				}
			}
			return j
		},
		getKey: function (c, e) {
			for (var d in c) {
				if (c.hasOwnProperty(d) && c[d] === e) {
					return d
				}
			}
			return null
		},
		getValues: function (d) {
			var c = [],
				e;
			for (e in d) {
				if (d.hasOwnProperty(e)) {
					c.push(d[e])
				}
			}
			return c
		},
		getKeys: ("keys" in Object) ? Object.keys : function (c) {
			var d = [],
				e;
			for (e in c) {
				if (c.hasOwnProperty(e)) {
					d.push(e)
				}
			}
			return d
		},
		getSize: function (c) {
			var d = 0,
				e;
			for (e in c) {
				if (c.hasOwnProperty(e)) {
					d++
				}
			}
			return d
		},
		classify: function (f) {
			var j = [],
				c = [],
				e = {},
				d = function () {
					var l = 0,
						m = j.length,
						n;
					for (; l < m; l++) {
						n = j[l];
						this[n] = new e[n]
					}
					m = c.length;
					for (l = 0; l < m; l++) {
						n = c[l];
						this[n] = f[n].slice()
					}
				},
				g, k, h;
			for (g in f) {
				if (f.hasOwnProperty(g)) {
					k = f[g];
					if (k) {
						h = k.constructor;
						if (h === Object) {
							j.push(g);
							e[g] = b.classify(k)
						} else {
							if (h === Array) {
								c.push(g)
							}
						}
					}
				}
			}
			d.prototype = f;
			return d
		},
		equals: function (c, f) {
			var g = typeof c,
				e = typeof f,
				d;
			if (e === e) {
				if (g === "object") {
					for (d in c) {
						if (!(d in f)) {
							return false
						}
						if (!b.equals(c[d], f[d])) {
							return false
						}
					}
					for (d in f) {
						if (!(d in c)) {
							return false
						}
					}
					return true
				} else {
					return c === f
				}
			}
			return false
		},
		defineProperty: ("defineProperty" in Object) ? Object.defineProperty : function (d, c, e) {
			if (e.get) {
				d.__defineGetter__(c, e.get)
			}
			if (e.set) {
				d.__defineSetter__(c, e.set)
			}
		}
	};
	Ext.merge = Ext.Object.merge;
	Ext.mergeIf = Ext.Object.mergeIf;
	Ext.urlEncode = function () {
		var c = Ext.Array.from(arguments),
			d = "";
		if ((typeof c[1] === "string")) {
			d = c[1] + "&";
			c[1] = false
		}
		return d + b.toQueryString.apply(b, c)
	};
	Ext.urlDecode = function () {
		return b.fromQueryString.apply(b, arguments)
	}
})();
Ext.Function = {
	flexSetter: function (a) {
		return function (d, c) {
			var e, f;
			if (d === null) {
				return this
			}
			if (typeof d !== "string") {
				for (e in d) {
					if (d.hasOwnProperty(e)) {
						a.call(this, e, d[e])
					}
				}
				if (Ext.enumerables) {
					for (f = Ext.enumerables.length; f--;) {
						e = Ext.enumerables[f];
						if (d.hasOwnProperty(e)) {
							a.call(this, e, d[e])
						}
					}
				}
			} else {
				a.call(this, d, c)
			}
			return this
		}
	},
	bind: function (d, c, b, a) {
		if (arguments.length === 2) {
			return function () {
				return d.apply(c, arguments)
			}
		}
		var f = d,
			e = Array.prototype.slice;
		return function () {
			var g = b || arguments;
			if (a === true) {
				g = e.call(arguments, 0);
				g = g.concat(b)
			} else {
				if (typeof a == "number") {
					g = e.call(arguments, 0);
					Ext.Array.insert(g, a, b)
				}
			}
			return f.apply(c || window, g)
		}
	},
	pass: function (c, a, b) {
		if (!Ext.isArray(a)) {
			a = Ext.Array.clone(a)
		}
		return function () {
			a.push.apply(a, arguments);
			return c.apply(b || this, a)
		}
	},
	alias: function (b, a) {
		return function () {
			return b[a].apply(b, arguments)
		}
	},
	clone: function (a) {
		return function () {
			return a.apply(this, arguments)
		}
	},
	createInterceptor: function (d, c, b, a) {
		var e = d;
		if (!Ext.isFunction(c)) {
			return d
		} else {
			return function () {
				var g = this,
					f = arguments;
				c.target = g;
				c.method = d;
				return (c.apply(b || g || window, f) !== false) ? d.apply(g || window, f) : a || null
			}
		}
	},
	createDelayed: function (e, c, d, b, a) {
		if (d || b) {
			e = Ext.Function.bind(e, d, b, a)
		}
		return function () {
			var g = this,
				f = Array.prototype.slice.call(arguments);
			setTimeout(function () {
				e.apply(g, f)
			}, c)
		}
	},
	defer: function (e, c, d, b, a) {
		e = Ext.Function.bind(e, d, b, a);
		if (c > 0) {
			return setTimeout(e, c)
		}
		e();
		return 0
	},
	createSequence: function (b, c, a) {
		if (!c) {
			return b
		} else {
			return function () {
				var d = b.apply(this, arguments);
				c.apply(a || this, arguments);
				return d
			}
		}
	},
	createBuffered: function (e, b, d, c) {
		var a;
		return function () {
			var g = c || Array.prototype.slice.call(arguments, 0),
				f = d || this;
			if (a) {
				clearTimeout(a)
			}
			a = setTimeout(function () {
				e.apply(f, g)
			}, b)
		}
	},
	createThrottled: function (e, b, d) {
		var f, a, c, h, g = function () {
				e.apply(d || this, c);
				f = new Date().getTime()
			};
		return function () {
			a = new Date().getTime() - f;
			c = arguments;
			clearTimeout(h);
			if (!f || (a >= b)) {
				g()
			} else {
				h = setTimeout(g, b - a)
			}
		}
	},
	interceptBefore: function (b, a, c) {
		var d = b[a] || Ext.emptyFn;
		return b[a] = function () {
			var e = c.apply(this, arguments);
			d.apply(this, arguments);
			return e
		}
	},
	interceptAfter: function (b, a, c) {
		var d = b[a] || Ext.emptyFn;
		return b[a] = function () {
			d.apply(this, arguments);
			return c.apply(this, arguments)
		}
	}
};
Ext.defer = Ext.Function.alias(Ext.Function, "defer");
Ext.pass = Ext.Function.alias(Ext.Function, "pass");
Ext.bind = Ext.Function.alias(Ext.Function, "bind");
Ext.JSON = new(function () {
	var useHasOwn = !! {}.hasOwnProperty,
		isNative = function () {
			var useNative = null;
			return function () {
				if (useNative === null) {
					useNative = Ext.USE_NATIVE_JSON && window.JSON && JSON.toString() == "[object JSON]"
				}
				return useNative
			}
		}(),
		pad = function (n) {
			return n < 10 ? "0" + n : n
		},
		doDecode = function (json) {
			return eval("(" + json + ")")
		},
		doEncode = function (o) {
			if (!Ext.isDefined(o) || o === null) {
				return "null"
			} else {
				if (Ext.isArray(o)) {
					return encodeArray(o)
				} else {
					if (Ext.isDate(o)) {
						return Ext.JSON.encodeDate(o)
					} else {
						if (Ext.isString(o)) {
							if (Ext.isMSDate(o)) {
								return encodeMSDate(o)
							} else {
								return encodeString(o)
							}
						} else {
							if (typeof o == "number") {
								return isFinite(o) ? String(o) : "null"
							} else {
								if (Ext.isBoolean(o)) {
									return String(o)
								} else {
									if (Ext.isObject(o)) {
										return encodeObject(o)
									} else {
										if (typeof o === "function") {
											return "null"
										}
									}
								}
							}
						}
					}
				}
			}
			return "undefined"
		},
		m = {
			"\b": "\\b",
			"\t": "\\t",
			"\n": "\\n",
			"\f": "\\f",
			"\r": "\\r",
			'"': '\\"',
			"\\": "\\\\",
			"\x0b": "\\u000b"
		},
		charToReplace = /[\\\"\x00-\x1f\x7f-\uffff]/g,
		encodeString = function (s) {
			return '"' + s.replace(charToReplace, function (a) {
				var c = m[a];
				return typeof c === "string" ? c : "\\u" + ("0000" + a.charCodeAt(0).toString(16)).slice(-4)
			}) + '"'
		},
		encodeArray = function (o) {
			var a = ["[", ""],
				len = o.length,
				i;
			for (i = 0; i < len; i += 1) {
				a.push(doEncode(o[i]), ",")
			}
			a[a.length - 1] = "]";
			return a.join("")
		},
		encodeObject = function (o) {
			var a = ["{", ""],
				i;
			for (i in o) {
				if (!useHasOwn || o.hasOwnProperty(i)) {
					a.push(doEncode(i), ":", doEncode(o[i]), ",")
				}
			}
			a[a.length - 1] = "}";
			return a.join("")
		},
		encodeMSDate = function (o) {
			return '"' + o + '"'
		};
	this.encodeDate = function (o) {
		return '"' + o.getFullYear() + "-" + pad(o.getMonth() + 1) + "-" + pad(o.getDate()) + "T" + pad(o.getHours()) + ":" + pad(o.getMinutes()) + ":" + pad(o.getSeconds()) + '"'
	};
	this.encode = function () {
		var ec;
		return function (o) {
			if (!ec) {
				ec = isNative() ? JSON.stringify : doEncode
			}
			return ec(o)
		}
	}();
	this.decode = function () {
		var dc;
		return function (json, safe) {
			if (!dc) {
				dc = isNative() ? JSON.parse : doDecode
			}
			try {
				return dc(json)
			} catch (e) {
				if (safe === true) {
					return null
				}
				Ext.Error.raise({
					sourceClass: "Ext.JSON",
					sourceMethod: "decode",
					msg: "You're trying to decode an invalid JSON String: " + json
				})
			}
		}
	}()
})();
Ext.encode = Ext.JSON.encode;
Ext.decode = Ext.JSON.decode;
Ext.Error = {
	raise: function (a) {
		throw new Error(a.msg)
	}
};
Ext.Date = {
	now: Date.now,
	toString: function (a) {
		if (!a) {
			a = new Date()
		}
		var b = Ext.String.leftPad;
		return a.getFullYear() + "-" + b(a.getMonth() + 1, 2, "0") + "-" + b(a.getDate(), 2, "0") + "T" + b(a.getHours(), 2, "0") + ":" + b(a.getMinutes(), 2, "0") + ":" + b(a.getSeconds(), 2, "0")
	}
};
(function (a) {
	var c = [],
		b = function () {};
	Ext.apply(b, {
		$className: "Ext.Base",
		$isClass: true,
		create: function () {
			return Ext.create.apply(Ext, [this].concat(Array.prototype.slice.call(arguments, 0)))
		},
		extend: function (h) {
			var d = h.prototype,
				f, g, j, e, k;
			f = this.prototype = Ext.Object.chain(d);
			f.self = this;
			this.superclass = f.superclass = d;
			if (!h.$isClass) {
				Ext.apply(f, Ext.Base.prototype);
				f.constructor = function () {
					d.constructor.apply(this, arguments)
				}
			}
			k = d.$inheritableStatics;
			if (k) {
				for (g = 0, j = k.length; g < j; g++) {
					e = k[g];
					if (!this.hasOwnProperty(e)) {
						this[e] = h[e]
					}
				}
			}
			if (h.$onExtended) {
				this.$onExtended = h.$onExtended.slice()
			}
			f.config = f.defaultConfig = new f.configClass;
			f.initConfigList = f.initConfigList.slice();
			f.initConfigMap = Ext.Object.chain(f.initConfigMap)
		},
		"$onExtended": [],
		triggerExtended: function () {
			var f = this.$onExtended,
				e = f.length,
				d, g;
			if (e > 0) {
				for (d = 0; d < e; d++) {
					g = f[d];
					g.fn.apply(g.scope || this, arguments)
				}
			}
		},
		onExtended: function (e, d) {
			this.$onExtended.push({
				fn: e,
				scope: d
			});
			return this
		},
		addConfig: function (f, j) {
			var k = this.prototype,
				g = k.initConfigList,
				e = k.initConfigMap,
				h = k.defaultConfig,
				m, d, l;
			j = Boolean(j);
			for (d in f) {
				if (f.hasOwnProperty(d) && (j || !(d in h))) {
					l = f[d];
					m = e[d];
					if (l !== null) {
						if (!m) {
							e[d] = true;
							g.push(d)
						}
					} else {
						if (m) {
							e[d] = false;
							Ext.Array.remove(g, d)
						}
					}
				}
			}
			if (j) {
				Ext.merge(h, f)
			} else {
				Ext.mergeIf(h, f)
			}
			k.configClass = Ext.Object.classify(h)
		},
		addStatics: function (d) {
			var f, e;
			for (e in d) {
				if (d.hasOwnProperty(e)) {
					f = d[e];
					this[e] = f
				}
			}
			return this
		},
		addInheritableStatics: function (e) {
			var h, d, g = this.prototype,
				f, j;
			h = g.$inheritableStatics;
			d = g.$hasInheritableStatics;
			if (!h) {
				h = g.$inheritableStatics = [];
				d = g.$hasInheritableStatics = {}
			}
			for (f in e) {
				if (e.hasOwnProperty(f)) {
					j = e[f];
					this[f] = j;
					if (!d[f]) {
						d[f] = true;
						h.push(f)
					}
				}
			}
			return this
		},
		addMembers: function (d) {
			var f = this.prototype,
				g = [],
				e, h;
			for (e in d) {
				if (d.hasOwnProperty(e)) {
					h = d[e];
					if (typeof h == "function" && !h.$isClass && h !== Ext.emptyFn) {
						h.$owner = this;
						h.$name = e
					}
					f[e] = h
				}
			}
			return this
		},
		addMember: function (d, e) {
			if (typeof e == "function" && !e.$isClass && e !== Ext.emptyFn) {
				e.$owner = this;
				e.$name = d
			}
			this.prototype[d] = e;
			return this
		},
		implement: function () {
			this.addMembers.apply(this, arguments)
		},
		borrow: function (h, f) {
			var m = this.prototype,
				l = h.prototype,
				g, j, e, k, d;
			f = Ext.Array.from(f);
			for (g = 0, j = f.length; g < j; g++) {
				e = f[g];
				d = l[e];
				if (typeof d == "function") {
					k = function () {
						return d.apply(this, arguments)
					};
					k.$owner = this;
					k.$name = e;
					m[e] = k
				} else {
					m[e] = d
				}
			}
			return this
		},
		override: function (g) {
			var p = this,
				r = Ext.enumerables,
				n = p.prototype,
				j = Ext.Function.clone,
				l = n.config,
				e, m, h, q, o, k, f, d;
			if (arguments.length === 2) {
				e = g;
				g = {};
				g[e] = arguments[1];
				r = null
			}
			do {
				o = [];
				q = null;
				for (e in g) {
					if (e == "statics") {
						q = g[e]
					} else {
						if (e == "config") {
							f = g[e];
							p.addConfig(f, true)
						} else {
							o.push(e)
						}
					}
				}
				if (r) {
					o.push.apply(o, r)
				}
				for (m = o.length; m--;) {
					e = o[m];
					if (g.hasOwnProperty(e)) {
						h = g[e];
						if (typeof h == "function" && !h.$className && h !== Ext.emptyFn) {
							if (typeof h.$owner != "undefined") {
								h = j(h)
							}
							h.$owner = p;
							h.$name = e;
							k = n[e];
							if (k) {
								h.$previous = k
							}
						}
						n[e] = h
					}
				}
				n = p;
				g = q
			} while (g);
			return this
		},
		callParent: function (d) {
			var e;
			return (e = this.callParent.caller) && (e.$previous || ((e = e.$owner ? e : e.caller) && e.$owner.superclass.$class[e.$name])).apply(this, d || c)
		},
		mixin: function (f, h) {
			var d = h.prototype,
				e = this.prototype,
				g;
			if (typeof d.onClassMixedIn != "undefined") {
				d.onClassMixedIn.call(h, this)
			}
			if (!e.hasOwnProperty("mixins")) {
				if ("mixins" in e) {
					e.mixins = Ext.Object.chain(e.mixins)
				} else {
					e.mixins = {}
				}
			}
			for (g in d) {
				if (g === "mixins") {
					Ext.merge(e.mixins, d[g])
				} else {
					if (typeof e[g] == "undefined" && g != "mixinId" && g != "config") {
						e[g] = d[g]
					}
				}
			}
			if ("config" in d) {
				this.addConfig(d.config, false)
			}
			e.mixins[f] = d
		},
		getName: function () {
			return Ext.getClassName(this)
		},
		createAlias: a(function (e, d) {
			this.override(e, function () {
				return this[d].apply(this, arguments)
			})
		}),
		addXtype: function (h) {
			var e = this.prototype,
				g = e.xtypesMap,
				f = e.xtypes,
				d = e.xtypesChain;
			if (!e.hasOwnProperty("xtypesMap")) {
				g = e.xtypesMap = Ext.merge({}, e.xtypesMap || {});
				f = e.xtypes = e.xtypes ? [].concat(e.xtypes) : [];
				d = e.xtypesChain = e.xtypesChain ? [].concat(e.xtypesChain) : [];
				e.xtype = h
			}
			if (!g[h]) {
				g[h] = true;
				f.push(h);
				d.push(h);
				Ext.ClassManager.setAlias(this, "widget." + h)
			}
			return this
		}
	});
	b.implement({
		isInstance: true,
		$className: "Ext.Base",
		configClass: Ext.emptyFn,
		initConfigList: [],
		initConfigMap: {},
		statics: function () {
			var e = this.statics.caller,
				d = this.self;
			if (!e) {
				return d
			}
			return e.$owner
		},
		callParent: function (e) {
			var f, d = (f = this.callParent.caller) && (f.$previous || ((f = f.$owner ? f : f.caller) && f.$owner.superclass[f.$name]));
			return d.apply(this, e || c)
		},
		callSuper: function (e) {
			var f, d = (f = this.callSuper.caller) && ((f = f.$owner ? f : f.caller) && f.$owner.superclass[f.$name]);
			return d.apply(this, e || c)
		},
		callOverridden: function (d) {
			var e = this.callOverridden.caller;
			return e && e.$previous.apply(this, d || c)
		},
		self: b,
		constructor: function () {
			return this
		},
		wasInstantiated: false,
		initConfig: function (m) {
			var l = Ext.Class.configNameCache,
				p = this.self.prototype,
				h = this.initConfigList,
				f = this.initConfigMap,
				g = new this.configClass,
				j = this.defaultConfig,
				k, o, e, q, n, d;
			this.initConfig = Ext.emptyFn;
			this.initialConfig = m || {};
			if (m) {
				Ext.merge(g, m)
			}
			this.config = g;
			if (!p.hasOwnProperty("wasInstantiated")) {
				p.wasInstantiated = true;
				for (k = 0, o = h.length; k < o; k++) {
					e = h[k];
					n = l[e];
					q = j[e];
					if (!(n.apply in p) && !(n.update in p) && p[n.set].$isDefault && typeof q != "object") {
						p[n.internal] = j[e];
						f[e] = false;
						Ext.Array.remove(h, e);
						k--;
						o--
					}
				}
			}
			if (m) {
				h = h.slice();
				for (e in m) {
					if (e in j && !f[e]) {
						h.push(e)
					}
				}
			}
			for (k = 0, o = h.length; k < o; k++) {
				e = h[k];
				n = l[e];
				this[n.get] = this[n.initGet]
			}
			this.beforeInitConfig(g);
			for (k = 0, o = h.length; k < o; k++) {
				e = h[k];
				n = l[e];
				d = n.get;
				if (this.hasOwnProperty(d)) {
					this[n.set].call(this, g[e]);
					delete this[d]
				}
			}
			return this
		},
		beforeInitConfig: Ext.emptyFn,
		getCurrentConfig: function () {
			var d = this.defaultConfig,
				g = Ext.Class.configNameCache,
				f = {},
				e, h;
			for (e in d) {
				h = g[e];
				f[e] = this[h.get].call(this)
			}
			return f
		},
		setConfig: function (e, l) {
			if (!e) {
				return this
			}
			var h = Ext.Class.configNameCache,
				j = this.config,
				f = this.defaultConfig,
				o = this.initialConfig,
				k = [],
				d, g, n, m;
			l = Boolean(l);
			for (d in e) {
				if ((l && (d in o))) {
					continue
				}
				j[d] = e[d];
				if (d in f) {
					k.push(d);
					m = h[d];
					this[m.get] = this[m.initGet]
				}
			}
			for (g = 0, n = k.length; g < n; g++) {
				d = k[g];
				m = h[d];
				this[m.set].call(this, e[d]);
				delete this[m.get]
			}
			return this
		},
		set: function (d, e) {
			return this[Ext.Class.configNameCache[d].set].call(this, e)
		},
		get: function (d) {
			return this[Ext.Class.configNameCache[d].get].call(this)
		},
		getConfig: function (d) {
			return this[Ext.Class.configNameCache[d].get].call(this)
		},
		hasConfig: function (d) {
			return (d in this.defaultConfig)
		},
		getInitialConfig: function (e) {
			var d = this.config;
			if (!e) {
				return d
			} else {
				return d[e]
			}
		},
		onConfigUpdate: function (j, l, m) {
			var n = this.self,
				f, h, d, g, k, e;
			j = Ext.Array.from(j);
			m = m || this;
			for (f = 0, h = j.length; f < h; f++) {
				d = j[f];
				g = "update" + Ext.String.capitalize(d);
				k = this[g] || Ext.emptyFn;
				e = function () {
					k.apply(this, arguments);
					m[l].apply(m, arguments)
				};
				e.$name = g;
				e.$owner = n;
				this[g] = e
			}
		},
		link: function (d, e) {
			this.$links = {};
			this.link = this.doLink;
			return this.link.apply(this, arguments)
		},
		doLink: function (d, e) {
			this.$links[d] = true;
			this[d] = e;
			return e
		},
		unlink: function () {
			var d, f, e, g;
			for (d = 0, f = arguments.length; d < f; d++) {
				e = arguments[d];
				if (this.hasOwnProperty(e)) {
					g = this[e];
					if (g) {
						if (g.isInstance && !g.isDestroyed) {
							g.destroy()
						} else {
							if (g.parentNode && "nodeType" in g) {
								g.parentNode.removeChild(g)
							}
						}
					}
					delete this[e]
				}
			}
			return this
		},
		destroy: function () {
			this.destroy = Ext.emptyFn;
			this.isDestroyed = true;
			if (this.hasOwnProperty("$links")) {
				this.unlink.apply(this, Ext.Object.getKeys(this.$links));
				delete this.$links
			}
		}
	});
	Ext.Base = b
})(Ext.Function.flexSetter);
(function () {
	var b, a = Ext.Base,
		e = [],
		d, c;
	for (d in a) {
		if (a.hasOwnProperty(d)) {
			e.push(d)
		}
	}
	c = e.length;
	Ext.Class = b = function (g, h, f) {
		if (typeof g != "function") {
			f = h;
			h = g;
			g = null
		}
		if (!h) {
			h = {}
		}
		g = b.create(g);
		b.process(g, h, f);
		return g
	};
	Ext.apply(b, {
		onBeforeCreated: function (g, h, f) {
			g.addMembers(h);
			f.onCreated.call(g, g)
		},
		create: function (f) {
			var g, h;
			if (!f) {
				f = function () {
					return this.constructor.apply(this, arguments)
				}
			}
			for (h = 0; h < c; h++) {
				g = e[h];
				f[g] = a[g]
			}
			return f
		},
		process: function (g, m, k) {
			var j = m.preprocessors || b.defaultPreprocessors,
				q = this.preprocessors,
				t = {
					onBeforeCreated: this.onBeforeCreated,
					onCreated: k || Ext.emptyFn
				},
				n = 0,
				f, u, p, l, o, r, s, h;
			delete m.preprocessors;
			h = function (w, x, v) {
				r = null;
				while (r === null) {
					f = j[n++];
					if (f) {
						u = q[f];
						p = u.properties;
						if (p === true) {
							r = u.fn
						} else {
							for (l = 0, o = p.length; l < o; l++) {
								s = p[l];
								if (x.hasOwnProperty(s)) {
									r = u.fn;
									break
								}
							}
						}
					} else {
						v.onBeforeCreated.apply(this, arguments);
						return
					}
				}
				if (r.call(this, w, x, v, h) !== false) {
					h.apply(this, arguments)
				}
			};
			h.call(this, g, m, t)
		},
		preprocessors: {},
		registerPreprocessor: function (g, k, h, f, j) {
			if (!f) {
				f = "last"
			}
			if (!h) {
				h = [g]
			}
			this.preprocessors[g] = {
				name: g,
				properties: h || false,
				fn: k
			};
			this.setDefaultPreprocessorPosition(g, f, j);
			return this
		},
		getPreprocessor: function (f) {
			return this.preprocessors[f]
		},
		getPreprocessors: function () {
			return this.preprocessors
		},
		defaultPreprocessors: [],
		getDefaultPreprocessors: function () {
			return this.defaultPreprocessors
		},
		setDefaultPreprocessors: function (f) {
			this.defaultPreprocessors = Ext.Array.from(f);
			return this
		},
		setDefaultPreprocessorPosition: function (h, k, j) {
			var f = this.defaultPreprocessors,
				g;
			if (typeof k == "string") {
				if (k === "first") {
					f.unshift(h);
					return this
				} else {
					if (k === "last") {
						f.push(h);
						return this
					}
				}
				k = (k === "after") ? 1 : -1
			}
			g = Ext.Array.indexOf(f, j);
			if (g !== -1) {
				Ext.Array.splice(f, Math.max(0, g + k), 0, h)
			}
			return this
		},
		configNameCache: {},
		getConfigNameMap: function (h) {
			var g = this.configNameCache,
				j = g[h],
				f;
			if (!j) {
				f = h.charAt(0).toUpperCase() + h.substr(1);
				j = g[h] = {
					name: h,
					internal: "_" + h,
					initializing: "is" + f + "Initializing",
					apply: "apply" + f,
					update: "update" + f,
					set: "set" + f,
					get: "get" + f,
					initGet: "initGet" + f,
					doSet: "doSet" + f,
					changeEvent: h.toLowerCase() + "change"
				}
			}
			return j
		},
		generateSetter: function (j) {
			var g = j.internal,
				h = j.get,
				f = j.apply,
				l = j.update,
				k;
			k = function (o) {
				var n = this[g],
					m = this[f],
					p = this[l];
				delete this[h];
				if (m) {
					o = m.call(this, o, n);
					if (typeof o == "undefined") {
						return this
					}
				}
				this[g] = o;
				if (p && o !== n) {
					p.call(this, o, n)
				}
				return this
			};
			k.$isDefault = true;
			return k
		},
		generateInitGetter: function (k) {
			var f = k.name,
				j = k.set,
				g = k.get,
				h = k.initializing;
			return function () {
				this[h] = true;
				delete this[g];
				this[j].call(this, this.config[f]);
				delete this[h];
				return this[g].apply(this, arguments)
			}
		},
		generateGetter: function (g) {
			var f = g.internal;
			return function () {
				return this[f]
			}
		}
	});
	b.registerPreprocessor("extend", function (f, j) {
		var h = Ext.Base,
			k = j.extend,
			g;
		delete j.extend;
		if (k && k !== Object) {
			g = k
		} else {
			g = h
		}
		f.extend(g);
		f.triggerExtended.apply(f, arguments);
		if (j.onClassExtended) {
			f.onExtended(j.onClassExtended, f);
			delete j.onClassExtended
		}
	}, true);
	b.registerPreprocessor("statics", function (f, g) {
		f.addStatics(g.statics);
		delete g.statics
	});
	b.registerPreprocessor("inheritableStatics", function (f, g) {
		f.addInheritableStatics(g.inheritableStatics);
		delete g.inheritableStatics
	});
	b.registerPreprocessor("platformConfig", function (h, p, s) {
		var q = p.platformConfig,
			l = p.config || {},
			k, o, g, n, r, m, f;
		delete p.platformConfig;
		if (!Ext.filterPlatform) {
			Ext.filterPlatform = function (w) {
				var F = false,
					u = navigator.userAgent,
					y, C;
				w = [].concat(w);

				function B(G) {
					var j = /Mobile(\/|\s)/.test(G);
					return /(iPhone|iPod)/.test(G) || (!/(Silk)/.test(G) && (/(Android)/.test(G) && (/(Android 2)/.test(G) || j))) || (/(BlackBerry|BB)/.test(G) && j) || /(Windows Phone)/.test(G)
				}
				function A(j) {
					return !B(j) && (/iPad/.test(j) || /Android/.test(j) || /(RIM Tablet OS)/.test(j) || (/MSIE 10/.test(j) && /; Touch/.test(j)))
				}
				var t = window.location.search.substr(1),
					v = t.split("&"),
					x = {},
					D, z;
				for (z = 0; z < v.length; z++) {
					var E = v[z].split("=");
					x[E[0]] = E[1]
				}
				D = x.platform;
				if (D) {
					return w.indexOf(D) != -1
				}
				for (y = 0, C = w.length; y < C; y++) {
					switch (w[y]) {
					case "phone":
						F = B(u);
						break;
					case "tablet":
						F = A(u);
						break;
					case "desktop":
						F = !B(u) && !A(u);
						break;
					case "ios":
						F = /(iPad|iPhone|iPod)/.test(u);
						break;
					case "android":
						F = /(Android|Silk)/.test(u);
						break;
					case "blackberry":
						F = /(BlackBerry|BB)/.test(u);
						break;
					case "safari":
						F = /Safari/.test(u) && !(/(BlackBerry|BB)/.test(u));
						break;
					case "chrome":
						F = /Chrome/.test(u);
						break;
					case "ie10":
						F = /MSIE 10/.test(u);
						break
					}
					if (F) {
						return true
					}
				}
				return false
			}
		}
		for (n = 0, r = q.length; n < r; n++) {
			g = q[n];
			k = g.platform;
			delete g.platform;
			o = [].concat(g.theme);
			f = o.length;
			delete g.theme;
			if (k && Ext.filterPlatform(k)) {
				Ext.merge(l, g)
			}
			if (f) {
				for (m = 0; m < f; m++) {
					if (Ext.theme.name == o[m]) {
						Ext.merge(l, g)
					}
				}
			}
		}
	});
	b.registerPreprocessor("config", function (h, n) {
		var k = n.config,
			q = h.prototype,
			m = q.config,
			p, g, o, f, j, l, r;
		delete n.config;
		for (g in k) {
			if (k.hasOwnProperty(g) && !(g in m)) {
				r = k[g];
				p = this.getConfigNameMap(g);
				o = p.set;
				f = p.get;
				j = p.initGet;
				l = p.internal;
				n[j] = this.generateInitGetter(p);
				if (r === null && !n.hasOwnProperty(l)) {
					n[l] = null
				}
				if (!n.hasOwnProperty(f)) {
					n[f] = this.generateGetter(p)
				}
				if (!n.hasOwnProperty(o)) {
					n[o] = this.generateSetter(p)
				}
			}
		}
		h.addConfig(k, true)
	});
	b.registerPreprocessor("mixins", function (j, n, f) {
		var g = n.mixins,
			k, h, l, m;
		delete n.mixins;
		Ext.Function.interceptBefore(f, "onCreated", function () {
			if (g instanceof Array) {
				for (l = 0, m = g.length; l < m; l++) {
					h = g[l];
					k = h.prototype.mixinId || h.$className;
					j.mixin(k, h)
				}
			} else {
				for (k in g) {
					if (g.hasOwnProperty(k)) {
						j.mixin(k, g[k])
					}
				}
			}
		})
	});
	Ext.extend = function (h, j, g) {
		if (arguments.length === 2 && Ext.isObject(j)) {
			g = j;
			j = h;
			h = null
		}
		var f;
		if (!j) {
			throw new Error("[Ext.extend] Attempting to extend from a class which has not been loaded on the page.")
		}
		g.extend = j;
		g.preprocessors = ["extend", "statics", "inheritableStatics", "mixins", "platformConfig", "config"];
		if (h) {
			f = new b(h, g)
		} else {
			f = new b(g)
		}
		f.prototype.override = function (l) {
			for (var k in l) {
				if (l.hasOwnProperty(k)) {
					this[k] = l[k]
				}
			}
		};
		return f
	}
})();
(function (b, d, f, c, e) {
	var a = Ext.ClassManager = {
		classes: {},
		existCache: {},
		namespaceRewrites: [{
			from: "Ext.",
			to: Ext
		}],
		maps: {
			alternateToName: {},
			aliasToName: {},
			nameToAliases: {},
			nameToAlternates: {}
		},
		enableNamespaceParseCache: true,
		namespaceParseCache: {},
		instantiators: [],
		isCreated: function (l) {
			var k = this.existCache,
				j, m, h, g, n;
			if (this.classes[l] || k[l]) {
				return true
			}
			g = e;
			n = this.parseNamespace(l);
			for (j = 0, m = n.length; j < m; j++) {
				h = n[j];
				if (typeof h != "string") {
					g = h
				} else {
					if (!g || !g[h]) {
						return false
					}
					g = g[h]
				}
			}
			k[l] = true;
			this.triggerCreated(l);
			return true
		},
		createdListeners: [],
		nameCreatedListeners: {},
		triggerCreated: function (q) {
			var s = this.createdListeners,
				k = this.nameCreatedListeners,
				l = this.maps.nameToAlternates[q],
				r = [q],
				n, p, m, o, h, g;
			for (n = 0, p = s.length; n < p; n++) {
				h = s[n];
				h.fn.call(h.scope, q)
			}
			if (l) {
				r.push.apply(r, l)
			}
			for (n = 0, p = r.length; n < p; n++) {
				g = r[n];
				s = k[g];
				if (s) {
					for (m = 0, o = s.length; m < o; m++) {
						h = s[m];
						h.fn.call(h.scope, g)
					}
					delete k[g]
				}
			}
		},
		onCreated: function (l, k, j) {
			var h = this.createdListeners,
				g = this.nameCreatedListeners,
				m = {
					fn: l,
					scope: k
				};
			if (j) {
				if (this.isCreated(j)) {
					l.call(k, j);
					return
				}
				if (!g[j]) {
					g[j] = []
				}
				g[j].push(m)
			} else {
				h.push(m)
			}
		},
		parseNamespace: function (j) {
			var g = this.namespaceParseCache;
			if (this.enableNamespaceParseCache) {
				if (g.hasOwnProperty(j)) {
					return g[j]
				}
			}
			var k = [],
				m = this.namespaceRewrites,
				o = e,
				h = j,
				r, q, p, l, n;
			for (l = 0, n = m.length; l < n; l++) {
				r = m[l];
				q = r.from;
				p = r.to;
				if (h === q || h.substring(0, q.length) === q) {
					h = h.substring(q.length);
					if (typeof p != "string") {
						o = p
					} else {
						k = k.concat(p.split("."))
					}
					break
				}
			}
			k.push(o);
			k = k.concat(h.split("."));
			if (this.enableNamespaceParseCache) {
				g[j] = k
			}
			return k
		},
		setNamespace: function (k, n) {
			var h = e,
				o = this.parseNamespace(k),
				m = o.length - 1,
				g = o[m],
				l, j;
			for (l = 0; l < m; l++) {
				j = o[l];
				if (typeof j != "string") {
					h = j
				} else {
					if (!h[j]) {
						h[j] = {}
					}
					h = h[j]
				}
			}
			h[g] = n;
			return h[g]
		},
		createNamespaces: function () {
			var g = e,
				n, k, l, h, m, o;
			for (l = 0, m = arguments.length; l < m; l++) {
				n = this.parseNamespace(arguments[l]);
				for (h = 0, o = n.length; h < o; h++) {
					k = n[h];
					if (typeof k != "string") {
						g = k
					} else {
						if (!g[k]) {
							g[k] = {}
						}
						g = g[k]
					}
				}
			}
			return g
		},
		set: function (g, l) {
			var k = this,
				n = k.maps,
				m = n.nameToAlternates,
				j = k.getName(l),
				h;
			k.classes[g] = k.setNamespace(g, l);
			if (j && j !== g) {
				n.alternateToName[g] = j;
				h = m[j] || (m[j] = []);
				h.push(g)
			}
			return this
		},
		get: function (j) {
			var l = this.classes;
			if (l[j]) {
				return l[j]
			}
			var g = e,
				n = this.parseNamespace(j),
				h, k, m;
			for (k = 0, m = n.length; k < m; k++) {
				h = n[k];
				if (typeof h != "string") {
					g = h
				} else {
					if (!g || !g[h]) {
						return null
					}
					g = g[h]
				}
			}
			return g
		},
		setAlias: function (g, h) {
			var k = this.maps.aliasToName,
				l = this.maps.nameToAliases,
				j;
			if (typeof g == "string") {
				j = g
			} else {
				j = this.getName(g)
			}
			if (h && k[h] !== j) {
				k[h] = j
			}
			if (!l[j]) {
				l[j] = []
			}
			if (h) {
				Ext.Array.include(l[j], h)
			}
			return this
		},
		addNameAliasMappings: function (g) {
			var m = this.maps.aliasToName,
				n = this.maps.nameToAliases,
				k, l, j, h;
			for (k in g) {
				l = n[k] || (n[k] = []);
				for (h = 0; h < g[k].length; h++) {
					j = g[k][h];
					if (!m[j]) {
						m[j] = k;
						l.push(j)
					}
				}
			}
			return this
		},
		addNameAlternateMappings: function (k) {
			var g = this.maps.alternateToName,
				n = this.maps.nameToAlternates,
				j, l, m, h;
			for (j in k) {
				l = n[j] || (n[j] = []);
				for (h = 0; h < k[j].length; h++) {
					m = k[j];
					if (!g[m]) {
						g[m] = j;
						l.push(m)
					}
				}
			}
			return this
		},
		getByAlias: function (g) {
			return this.get(this.getNameByAlias(g))
		},
		getNameByAlias: function (g) {
			return this.maps.aliasToName[g] || ""
		},
		getNameByAlternate: function (g) {
			return this.maps.alternateToName[g] || ""
		},
		getAliasesByName: function (g) {
			return this.maps.nameToAliases[g] || []
		},
		getName: function (g) {
			return g && g.$className || ""
		},
		getClass: function (g) {
			return g && g.self || null
		},
		create: function (h, j, g) {
			j.$className = h;
			return new b(j, function () {
				var m = j.postprocessors || a.defaultPostprocessors,
					t = a.postprocessors,
					q = 0,
					u = [],
					s, k, n, r, l, p, o, v;
				delete j.postprocessors;
				for (n = 0, r = m.length; n < r; n++) {
					s = m[n];
					if (typeof s == "string") {
						s = t[s];
						o = s.properties;
						if (o === true) {
							u.push(s.fn)
						} else {
							if (o) {
								for (l = 0, p = o.length; l < p; l++) {
									v = o[l];
									if (j.hasOwnProperty(v)) {
										u.push(s.fn);
										break
									}
								}
							}
						}
					} else {
						u.push(s)
					}
				}
				k = function (x, w, y) {
					s = u[q++];
					if (!s) {
						a.set(h, w);
						if (g) {
							g.call(w, w)
						}
						a.triggerCreated(h);
						return
					}
					if (s.call(this, x, w, y, k) !== false) {
						k.apply(this, arguments)
					}
				};
				k.call(a, h, this, j)
			})
		},
		createOverride: function (h, k) {
			var j = k.override,
				g = Ext.Array.from(k.requires);
			delete k.override;
			delete k.requires;
			this.existCache[h] = true;
			Ext.require(g, function () {
				this.onCreated(function () {
					var l = this.get(j);
					if (l.singleton) {
						l.self.override(k)
					} else {
						l.override(k)
					}
					this.triggerCreated(h)
				}, this, j)
			}, this);
			return this
		},
		instantiateByAlias: function () {
			var h = arguments[0],
				g = f.call(arguments),
				j = this.getNameByAlias(h);
			if (!j) {
				j = this.maps.aliasToName[h];
				Ext.syncRequire(j)
			}
			g[0] = j;
			return this.instantiate.apply(this, g)
		},
		instantiate: function () {
			var j = arguments[0],
				h = f.call(arguments, 1),
				k = j,
				l, g;
			if (typeof j != "function") {
				g = this.get(j)
			} else {
				g = j
			}
			if (!g) {
				l = this.getNameByAlias(j);
				if (l) {
					j = l;
					g = this.get(j)
				}
			}
			if (!g) {
				l = this.getNameByAlternate(j);
				if (l) {
					j = l;
					g = this.get(j)
				}
			}
			if (!g) {
				Ext.syncRequire(j);
				g = this.get(j)
			}
			return this.getInstantiator(h.length)(g, h)
		},
		dynInstantiate: function (h, g) {
			g = c(g, true);
			g.unshift(h);
			return this.instantiate.apply(this, g)
		},
		getInstantiator: function (k) {
			var j = this.instantiators,
				l;
			l = j[k];
			if (!l) {
				var h = k,
					g = [];
				for (h = 0; h < k; h++) {
					g.push("a[" + h + "]")
				}
				l = j[k] = new Function("c", "a", "return new c(" + g.join(",") + ")")
			}
			return l
		},
		postprocessors: {},
		defaultPostprocessors: [],
		registerPostprocessor: function (h, l, j, g, k) {
			if (!g) {
				g = "last"
			}
			if (!j) {
				j = [h]
			}
			this.postprocessors[h] = {
				name: h,
				properties: j || false,
				fn: l
			};
			this.setDefaultPostprocessorPosition(h, g, k);
			return this
		},
		setDefaultPostprocessors: function (g) {
			this.defaultPostprocessors = c(g);
			return this
		},
		setDefaultPostprocessorPosition: function (h, l, k) {
			var j = this.defaultPostprocessors,
				g;
			if (typeof l == "string") {
				if (l === "first") {
					j.unshift(h);
					return this
				} else {
					if (l === "last") {
						j.push(h);
						return this
					}
				}
				l = (l === "after") ? 1 : -1
			}
			g = Ext.Array.indexOf(j, k);
			if (g !== -1) {
				Ext.Array.splice(j, Math.max(0, g + l), 0, h)
			}
			return this
		},
		getNamesByExpression: function (o) {
			var m = this.maps.nameToAliases,
				p = [],
				g, l, j, h, q, k, n;
			if (o.indexOf("*") !== -1) {
				o = o.replace(/\*/g, "(.*?)");
				q = new RegExp("^" + o + "$");
				for (g in m) {
					if (m.hasOwnProperty(g)) {
						j = m[g];
						if (g.search(q) !== -1) {
							p.push(g)
						} else {
							for (k = 0, n = j.length; k < n; k++) {
								l = j[k];
								if (l.search(q) !== -1) {
									p.push(g);
									break
								}
							}
						}
					}
				}
			} else {
				h = this.getNameByAlias(o);
				if (h) {
					p.push(h)
				} else {
					h = this.getNameByAlternate(o);
					if (h) {
						p.push(h)
					} else {
						p.push(o)
					}
				}
			}
			return p
		}
	};
	a.registerPostprocessor("alias", function (j, h, m) {
		var g = m.alias,
			k, l;
		for (k = 0, l = g.length; k < l; k++) {
			d = g[k];
			this.setAlias(h, d)
		}
	}, ["xtype", "alias"]);
	a.registerPostprocessor("singleton", function (h, g, k, j) {
		j.call(this, h, new g(), k);
		return false
	});
	a.registerPostprocessor("alternateClassName", function (h, g, m) {
		var k = m.alternateClassName,
			j, l, n;
		if (!(k instanceof Array)) {
			k = [k]
		}
		for (j = 0, l = k.length; j < l; j++) {
			n = k[j];
			this.set(n, g)
		}
	});
	Ext.apply(Ext, {
		create: d(a, "instantiate"),
		widget: function (h) {
			var g = f.call(arguments);
			g[0] = "widget." + h;
			return a.instantiateByAlias.apply(a, g)
		},
		createByAlias: d(a, "instantiateByAlias"),
		define: function (h, j, g) {
			if ("override" in j) {
				return a.createOverride.apply(a, arguments)
			}
			return a.create.apply(a, arguments)
		},
		getClassName: d(a, "getName"),
		getDisplayName: function (g) {
			if (g) {
				if (g.displayName) {
					return g.displayName
				}
				if (g.$name && g.$class) {
					return Ext.getClassName(g.$class) + "#" + g.$name
				}
				if (g.$className) {
					return g.$className
				}
			}
			return "Anonymous"
		},
		getClass: d(a, "getClass"),
		namespace: d(a, "createNamespaces")
	});
	Ext.createWidget = Ext.widget;
	Ext.ns = Ext.namespace;
	b.registerPreprocessor("className", function (g, h) {
		if (h.$className) {
			g.$className = h.$className
		}
	}, true, "first");
	b.registerPreprocessor("alias", function (s, m) {
		var q = s.prototype,
			j = c(m.xtype),
			g = c(m.alias),
			t = "widget.",
			r = t.length,
			n = Array.prototype.slice.call(q.xtypesChain || []),
			k = Ext.merge({}, q.xtypesMap || {}),
			l, p, o, h;
		for (l = 0, p = g.length; l < p; l++) {
			o = g[l];
			if (o.substring(0, r) === t) {
				h = o.substring(r);
				Ext.Array.include(j, h)
			}
		}
		s.xtype = m.xtype = j[0];
		m.xtypes = j;
		for (l = 0, p = j.length; l < p; l++) {
			h = j[l];
			if (!k[h]) {
				k[h] = true;
				n.push(h)
			}
		}
		m.xtypesChain = n;
		m.xtypesMap = k;
		Ext.Function.interceptAfter(m, "onClassCreated", function () {
			var u = q.mixins,
				w, v;
			for (w in u) {
				if (u.hasOwnProperty(w)) {
					v = u[w];
					j = v.xtypes;
					if (j) {
						for (l = 0, p = j.length; l < p; l++) {
							h = j[l];
							if (!k[h]) {
								k[h] = true;
								n.push(h)
							}
						}
					}
				}
			}
		});
		for (l = 0, p = j.length; l < p; l++) {
			h = j[l];
			Ext.Array.include(g, t + h)
		}
		m.alias = g
	}, ["xtype", "alias"])
})(Ext.Class, Ext.Function.alias, Array.prototype.slice, Ext.Array.from, Ext.global);
(function (a, c, d, h, k, j, g, l) {
	var e = ["extend", "mixins", "requires"],
		b, f = 0;
	b = Ext.Loader = {
		isInHistory: {},
		history: [],
		config: {
			enabled: true,
			disableCaching: true,
			disableCachingParam: "_dc",
			paths: {
				Ext: "."
			}
		},
		setConfig: function (m, n) {
			if (Ext.isObject(m) && arguments.length === 1) {
				Ext.merge(this.config, m)
			} else {
				this.config[m] = (Ext.isObject(n)) ? Ext.merge(this.config[m], n) : n
			}
			f += 1;
			return this
		},
		getConfig: function (m) {
			if (m) {
				return this.config[m]
			}
			return this.config
		},
		setPath: d(function (m, n) {
			this.config.paths[m] = n;
			f += 1;
			return this
		}),
		addClassPathMappings: function (n) {
			var m;
			if (f == 0) {
				b.config.paths = n
			} else {
				for (m in n) {
					b.config.paths[m] = n[m]
				}
			}
			f++;
			return b
		},
		getPath: function (m) {
			var o = "",
				p = this.config.paths,
				n = this.getPrefix(m);
			if (n.length > 0) {
				if (n === m) {
					return p[n]
				}
				o = p[n];
				m = m.substring(n.length + 1)
			}
			if (o.length > 0) {
				o += "/"
			}
			return o.replace(/\/\.\//g, "/") + m.replace(/\./g, "/") + ".js"
		},
		getPrefix: function (n) {
			var p = this.config.paths,
				o, m = "";
			if (p.hasOwnProperty(n)) {
				return n
			}
			for (o in p) {
				if (p.hasOwnProperty(o) && o + "." === n.substring(0, o.length + 1)) {
					if (o.length > m.length) {
						m = o
					}
				}
			}
			return m
		},
		require: function (o, n, m, p) {
			if (n) {
				n.call(m)
			}
		},
		syncRequire: function () {},
		exclude: function (n) {
			var m = this;
			return {
				require: function (q, p, o) {
					return m.require(q, p, o, n)
				},
				syncRequire: function (q, p, o) {
					return m.syncRequire(q, p, o, n)
				}
			}
		},
		onReady: function (p, o, q, m) {
			var n;
			if (q !== false && Ext.onDocumentReady) {
				n = p;
				p = function () {
					Ext.onDocumentReady(n, o, m)
				}
			}
			p.call(o)
		}
	};
	Ext.apply(b, {
		documentHead: typeof document != "undefined" && (document.head || document.getElementsByTagName("head")[0]),
		isLoading: false,
		queue: [],
		isClassFileLoaded: {},
		isFileLoaded: {},
		readyListeners: [],
		optionalRequires: [],
		requiresMap: {},
		numPendingFiles: 0,
		numLoadedFiles: 0,
		hasFileLoadError: false,
		classNameToFilePathMap: {},
		syncModeEnabled: false,
		scriptElements: {},
		refreshQueue: function () {
			var m = this.queue,
				s = m.length,
				p, r, n, q, o;
			if (s === 0) {
				this.triggerReady();
				return
			}
			for (p = 0; p < s; p++) {
				r = m[p];
				if (r) {
					q = r.requires;
					o = r.references;
					if (q.length > this.numLoadedFiles) {
						continue
					}
					n = 0;
					do {
						if (a.isCreated(q[n])) {
							g(q, n, 1)
						} else {
							n++
						}
					} while (n < q.length);
					if (r.requires.length === 0) {
						g(m, p, 1);
						r.callback.call(r.scope);
						this.refreshQueue();
						break
					}
				}
			}
			return this
		},
		injectScriptElement: function (o, q, s, p) {
			var n = document.createElement("script"),
				r = this,
				m = function () {
					r.cleanupScriptElement(n);
					q.call(p)
				},
				t = function () {
					r.cleanupScriptElement(n);
					s.call(p)
				};
			n.type = "text/javascript";
			n.src = o;
			n.onload = m;
			n.onerror = t;
			n.onreadystatechange = function () {
				if (this.readyState === "loaded" || this.readyState === "complete") {
					m()
				}
			};
			this.documentHead.appendChild(n);
			return n
		},
		removeScriptElement: function (n) {
			var m = this.scriptElements;
			if (m[n]) {
				this.cleanupScriptElement(m[n], true);
				delete m[n]
			}
			return this
		},
		cleanupScriptElement: function (n, m) {
			n.onload = null;
			n.onreadystatechange = null;
			n.onerror = null;
			if (m) {
				this.documentHead.removeChild(n)
			}
			return this
		},
		loadScriptFile: function (n, u, q, y, m) {
			var t = this,
				z = this.isFileLoaded,
				o = this.scriptElements,
				x = n + (this.getConfig("disableCaching") ? ("?" + this.getConfig("disableCachingParam") + "=" + Ext.Date.now()) : ""),
				w, p, s, v;
			if (z[n]) {
				return this
			}
			y = y || this;
			this.isLoading = true;
			if (!m) {
				v = function () {};
				if (!Ext.isReady && Ext.onDocumentReady) {
					Ext.onDocumentReady(function () {
						if (!z[n]) {
							o[n] = t.injectScriptElement(x, u, v, y)
						}
					})
				} else {
					o[n] = this.injectScriptElement(x, u, v, y)
				}
			} else {
				if (typeof XMLHttpRequest != "undefined") {
					w = new XMLHttpRequest()
				} else {
					w = new ActiveXObject("Microsoft.XMLHTTP")
				}
				try {
					w.open("GET", x, false);
					w.send(null)
				} catch (r) {}
				p = (w.status == 1223) ? 204 : w.status;
				s = w.responseText;
				if ((p >= 200 && p < 300) || p == 304 || (p == 0 && s.length > 0)) {
					Ext.globalEval(s + "\n//@ sourceURL=" + n);
					u.call(y)
				} else {}
				w = null
			}
		},
		syncRequire: function () {
			var m = this.syncModeEnabled;
			if (!m) {
				this.syncModeEnabled = true
			}
			this.require.apply(this, arguments);
			if (!m) {
				this.syncModeEnabled = false
			}
			this.refreshQueue()
		},
		require: function (H, v, p, s) {
			var x = {},
				o = {},
				A = this.queue,
				E = this.classNameToFilePathMap,
				C = this.isClassFileLoaded,
				u = [],
				J = [],
				G = [],
				n = [],
				t, I, z, y, m, r, F, D, B, w, q;
			if (s) {
				s = j(s);
				for (D = 0, w = s.length; D < w; D++) {
					m = s[D];
					if (typeof m == "string" && m.length > 0) {
						u = a.getNamesByExpression(m);
						for (B = 0, q = u.length; B < q; B++) {
							x[u[B]] = true
						}
					}
				}
			}
			H = j(H);
			if (v) {
				if (v.length > 0) {
					t = function () {
						var M = [],
							L, N, K;
						for (L = 0, N = n.length; L < N; L++) {
							K = n[L];
							M.push(a.get(K))
						}
						return v.apply(this, M)
					}
				} else {
					t = v
				}
			} else {
				t = Ext.emptyFn
			}
			p = p || Ext.global;
			for (D = 0, w = H.length; D < w; D++) {
				y = H[D];
				if (typeof y == "string" && y.length > 0) {
					J = a.getNamesByExpression(y);
					q = J.length;
					for (B = 0; B < q; B++) {
						F = J[B];
						if (x[F] !== true) {
							n.push(F);
							if (!a.isCreated(F) && !o[F]) {
								o[F] = true;
								G.push(F)
							}
						}
					}
				}
			}
			if (G.length > 0) {
				if (!this.config.enabled) {
					throw new Error("Ext.Loader is not enabled, so dependencies cannot be resolved dynamically. Missing required class" + ((G.length > 1) ? "es" : "") + ": " + G.join(", "))
				}
			} else {
				t.call(p);
				return this
			}
			I = this.syncModeEnabled;
			if (!I) {
				A.push({
					requires: G.slice(),
					callback: t,
					scope: p
				})
			}
			w = G.length;
			for (D = 0; D < w; D++) {
				r = G[D];
				z = this.getPath(r);
				if (I && C.hasOwnProperty(r)) {
					this.numPendingFiles--;
					this.removeScriptElement(z);
					delete C[r]
				}
				if (!C.hasOwnProperty(r)) {
					C[r] = false;
					E[r] = z;
					this.numPendingFiles++;
					this.loadScriptFile(z, k(this.onFileLoaded, [r, z], this), k(this.onFileLoadError, [r, z]), this, I)
				}
			}
			if (I) {
				t.call(p);
				if (w === 1) {
					return a.get(r)
				}
			}
			return this
		},
		onFileLoaded: function (n, m) {
			this.numLoadedFiles++;
			this.isClassFileLoaded[n] = true;
			this.isFileLoaded[m] = true;
			this.numPendingFiles--;
			if (this.numPendingFiles === 0) {
				this.refreshQueue()
			}
		},
		onFileLoadError: function (o, n, m, p) {
			this.numPendingFiles--;
			this.hasFileLoadError = true
		},
		addOptionalRequires: function (o) {
			var q = this.optionalRequires,
				n, p, m;
			o = j(o);
			for (n = 0, p = o.length; n < p; n++) {
				m = o[n];
				l(q, m)
			}
			return this
		},
		triggerReady: function (n) {
			var p = this.readyListeners,
				o = this.optionalRequires,
				m;
			if (this.isLoading || n) {
				this.isLoading = false;
				if (o.length !== 0) {
					o = o.slice();
					this.optionalRequires.length = 0;
					this.require(o, k(this.triggerReady, [true], this), this);
					return this
				}
				while (p.length) {
					m = p.shift();
					m.fn.call(m.scope);
					if (this.isLoading) {
						return this
					}
				}
			}
			return this
		},
		onReady: function (p, o, q, m) {
			var n;
			if (q !== false && Ext.onDocumentReady) {
				n = p;
				p = function () {
					Ext.onDocumentReady(n, o, m)
				}
			}
			if (!this.isLoading) {
				p.call(o)
			} else {
				this.readyListeners.push({
					fn: p,
					scope: o
				})
			}
		},
		historyPush: function (n) {
			var m = this.isInHistory;
			if (n && this.isClassFileLoaded.hasOwnProperty(n) && !m[n]) {
				m[n] = true;
				this.history.push(n)
			}
			return this
		}
	});
	Ext.require = h(b, "require");
	Ext.syncRequire = h(b, "syncRequire");
	Ext.exclude = h(b, "exclude");
	Ext.onReady = function (o, n, m) {
		b.onReady(o, n, true, m)
	};
	c.registerPreprocessor("loader", function (z, o, y, x) {
		var v = this,
			t = [],
			u = a.getName(z),
			p, n, s, r, w, q, m;
		for (p = 0, s = e.length; p < s; p++) {
			q = e[p];
			if (o.hasOwnProperty(q)) {
				m = o[q];
				if (typeof m == "string") {
					t.push(m)
				} else {
					if (m instanceof Array) {
						for (n = 0, r = m.length; n < r; n++) {
							w = m[n];
							if (typeof w == "string") {
								t.push(w)
							}
						}
					} else {
						if (typeof m != "function") {
							for (n in m) {
								if (m.hasOwnProperty(n)) {
									w = m[n];
									if (typeof w == "string") {
										t.push(w)
									}
								}
							}
						}
					}
				}
			}
		}
		if (t.length === 0) {
			return
		}
		b.require(t, function () {
			for (p = 0, s = e.length; p < s; p++) {
				q = e[p];
				if (o.hasOwnProperty(q)) {
					m = o[q];
					if (typeof m == "string") {
						o[q] = a.get(m)
					} else {
						if (m instanceof Array) {
							for (n = 0, r = m.length; n < r; n++) {
								w = m[n];
								if (typeof w == "string") {
									o[q][n] = a.get(w)
								}
							}
						} else {
							if (typeof m != "function") {
								for (var A in m) {
									if (m.hasOwnProperty(A)) {
										w = m[A];
										if (typeof w == "string") {
											o[q][A] = a.get(w)
										}
									}
								}
							}
						}
					}
				}
			}
			x.call(v, z, o, y)
		});
		return false
	}, true, "after", "className");
	a.registerPostprocessor("uses", function (p, n, t) {
		var m = j(t.uses),
			o = [],
			q, s, r;
		for (q = 0, s = m.length; q < s; q++) {
			r = m[q];
			if (typeof r == "string") {
				o.push(r)
			}
		}
		b.addOptionalRequires(o)
	});
	a.onCreated(function (m) {
		this.historyPush(m)
	}, b)
})(Ext.ClassManager, Ext.Class, Ext.Function.flexSetter, Ext.Function.alias, Ext.Function.pass, Ext.Array.from, Ext.Array.erase, Ext.Array.include);
(function () {
	var a = document.getElementsByTagName("script"),
		b = a[a.length - 1],
		d = b.src,
		c = d.substring(0, d.lastIndexOf("/") + 1),
		e = Ext.Loader;
	e.setConfig({
		enabled: true,
		disableCaching: !/[?&](cache|breakpoint)/i.test(location.search),
		paths: {
			Ext: c + "src"
		}
	})
})();
Ext.setVersion("touch", "2.2.1");
Ext.apply(Ext, {
	version: Ext.getVersion("touch"),
	idSeed: 0,
	repaint: function () {
		var a = Ext.getBody().createChild({
			cls: Ext.baseCSSPrefix + "mask " + Ext.baseCSSPrefix + "mask-transparent"
		});
		setTimeout(function () {
			a.destroy()
		}, 0)
	},
	id: function (a, b) {
		if (a && a.id) {
			return a.id
		}
		a = Ext.getDom(a) || {};
		if (a === document || a === document.documentElement) {
			a.id = "ext-app"
		} else {
			if (a === document.body) {
				a.id = "ext-body"
			} else {
				if (a === window) {
					a.id = "ext-window"
				}
			}
		}
		a.id = a.id || ((b || "ext-") + (++Ext.idSeed));
		return a.id
	},
	getBody: function () {
		if (!Ext.documentBodyElement) {
			if (!document.body) {
				throw new Error("[Ext.getBody] document.body does not exist at this point")
			}
			Ext.documentBodyElement = Ext.get(document.body)
		}
		return Ext.documentBodyElement
	},
	getHead: function () {
		if (!Ext.documentHeadElement) {
			Ext.documentHeadElement = Ext.get(document.head || document.getElementsByTagName("head")[0])
		}
		return Ext.documentHeadElement
	},
	getDoc: function () {
		if (!Ext.documentElement) {
			Ext.documentElement = Ext.get(document)
		}
		return Ext.documentElement
	},
	getCmp: function (a) {
		return Ext.ComponentMgr.get(a)
	},
	copyTo: function (a, b, d, c) {
		if (typeof d == "string") {
			d = d.split(/[,;\s]/)
		}
		Ext.each(d, function (e) {
			if (c || b.hasOwnProperty(e)) {
				a[e] = b[e]
			}
		}, this);
		return a
	},
	destroy: function () {
		var a = arguments,
			d = a.length,
			b, c;
		for (b = 0; b < d; b++) {
			c = a[b];
			if (c) {
				if (Ext.isArray(c)) {
					this.destroy.apply(this, c)
				} else {
					if (Ext.isFunction(c.destroy)) {
						c.destroy()
					}
				}
			}
		}
	},
	getDom: function (a) {
		if (!a || !document) {
			return null
		}
		return a.dom ? a.dom : (typeof a == "string" ? document.getElementById(a) : a)
	},
	removeNode: function (a) {
		if (a && a.parentNode && a.tagName != "BODY") {
			Ext.get(a).clearListeners();
			a.parentNode.removeChild(a);
			delete Ext.cache[a.id]
		}
	},
	defaultSetupConfig: {
		eventPublishers: {
			dom: {
				xclass: "Ext.event.publisher.Dom"
			},
			touchGesture: {
				xclass: "Ext.event.publisher.TouchGesture",
				recognizers: {
					drag: {
						xclass: "Ext.event.recognizer.Drag"
					},
					tap: {
						xclass: "Ext.event.recognizer.Tap"
					},
					doubleTap: {
						xclass: "Ext.event.recognizer.DoubleTap"
					},
					longPress: {
						xclass: "Ext.event.recognizer.LongPress"
					},
					swipe: {
						xclass: "Ext.event.recognizer.HorizontalSwipe"
					},
					pinch: {
						xclass: "Ext.event.recognizer.Pinch"
					},
					rotate: {
						xclass: "Ext.event.recognizer.Rotate"
					}
				}
			},
			componentDelegation: {
				xclass: "Ext.event.publisher.ComponentDelegation"
			},
			componentPaint: {
				xclass: "Ext.event.publisher.ComponentPaint"
			},
			elementPaint: {
				xclass: "Ext.event.publisher.ElementPaint"
			},
			elementSize: {
				xclass: "Ext.event.publisher.ElementSize"
			}
		},
		animator: {
			xclass: "Ext.fx.Runner"
		},
		viewport: {
			xclass: "Ext.viewport.Viewport"
		}
	},
	isSetup: false,
	frameStartTime: +new Date(),
	setupListeners: [],
	onSetup: function (b, a) {
		if (Ext.isSetup) {
			b.call(a)
		} else {
			Ext.setupListeners.push({
				fn: b,
				scope: a
			})
		}
	},
	setup: function (t) {
		var l = Ext.defaultSetupConfig,
			n = Ext.emptyFn,
			b = t.onReady || n,
			f = t.onUpdated || n,
			a = t.scope,
			d = Ext.Array.from(t.requires),
			m = Ext.onReady,
			h = Ext.getHead(),
			g, r, j;
		Ext.setup = function () {
			throw new Error("Ext.setup has already been called before")
		};
		delete t.requires;
		delete t.onReady;
		delete t.onUpdated;
		delete t.scope;
		Ext.require(["Ext.event.Dispatcher"]);
		g = function () {
			var w = Ext.setupListeners,
				x = w.length,
				v, y;
			delete Ext.setupListeners;
			Ext.isSetup = true;
			for (v = 0; v < x; v++) {
				y = w[v];
				y.fn.call(y.scope)
			}
			Ext.onReady = m;
			Ext.onReady(b, a)
		};
		Ext.onUpdated = f;
		Ext.onReady = function (x, w) {
			var v = b;
			b = function () {
				v();
				Ext.onReady(x, w)
			}
		};
		t = Ext.merge({}, l, t);
		Ext.onDocumentReady(function () {
			Ext.factoryConfig(t, function (w) {
				Ext.event.Dispatcher.getInstance().setPublishers(w.eventPublishers);
				if (w.logger) {
					Ext.Logger = w.logger
				}
				if (w.animator) {
					Ext.Animator = w.animator
				}
				if (w.viewport) {
					Ext.Viewport = r = w.viewport;
					if (!a) {
						a = r
					}
					Ext.require(d, function () {
						Ext.Viewport.on("ready", g, null, {
							single: true
						})
					})
				} else {
					Ext.require(d, g)
				}
			});
			if (!Ext.microloaded && navigator.userAgent.match(/IEMobile\/10\.0/)) {
				var v = document.createElement("style");
				v.appendChild(document.createTextNode("@media screen and (orientation: portrait) {@-ms-viewport {width: 320px !important;}}@media screen and (orientation: landscape) {@-ms-viewport {width: 560px !important;}}"));
				h.appendChild(v)
			}
		});

		function k(v, w) {
			var x = document.createElement("meta");
			x.setAttribute("name", v);
			x.setAttribute("content", w);
			h.append(x)
		}
		function o(v, x, y) {
			var w = document.createElement("link");
			w.setAttribute("rel", "apple-touch-icon" + (y ? "-precomposed" : ""));
			w.setAttribute("href", v);
			if (x) {
				w.setAttribute("sizes", x)
			}
			h.append(w)
		}
		function e(v, x) {
			var w = document.createElement("link");
			w.setAttribute("rel", "apple-touch-startup-image");
			w.setAttribute("href", v);
			if (x) {
				w.setAttribute("media", x)
			}
			h.append(w)
		}
		var q = t.icon,
			u = Boolean(t.isIconPrecomposed),
			s = t.startupImage || {},
			c = t.statusBarStyle,
			p = window.devicePixelRatio || 1;
		if (navigator.standalone) {
			k("viewport", "width=device-width, initial-scale=1.0, maximum-scale=1.0, minimum-scale=1.0")
		} else {
			k("viewport", "initial-scale=1.0, maximum-scale=1.0, minimum-scale=1.0")
		}
		k("apple-mobile-web-app-capable", "yes");
		k("apple-touch-fullscreen", "yes");
		if (Ext.browser.is.ie) {
			k("msapplication-tap-highlight", "no")
		}
		if (c) {
			k("apple-mobile-web-app-status-bar-style", c)
		}
		if (Ext.isString(q)) {
			q = {
				57: q,
				72: q,
				114: q,
				144: q
			}
		} else {
			if (!q) {
				q = {}
			}
		}
		if (Ext.os.is.iPad) {
			if (p >= 2) {
				if ("1496x2048" in s) {
					e(s["1496x2048"], "(orientation: landscape)")
				}
				if ("1536x2008" in s) {
					e(s["1536x2008"], "(orientation: portrait)")
				}
				if ("144" in q) {
					o(q["144"], "144x144", u)
				}
			} else {
				if ("748x1024" in s) {
					e(s["748x1024"], "(orientation: landscape)")
				}
				if ("768x1004" in s) {
					e(s["768x1004"], "(orientation: portrait)")
				}
				if ("72" in q) {
					o(q["72"], "72x72", u)
				}
			}
		} else {
			if (p >= 2 && Ext.os.version.gtEq("4.3")) {
				if (Ext.os.is.iPhone5) {
					e(s["640x1096"])
				} else {
					e(s["640x920"])
				}
				if ("114" in q) {
					o(q["114"], "114x114", u)
				}
			} else {
				e(s["320x460"]);
				if ("57" in q) {
					o(q["57"], null, u)
				}
			}
		}
	},
	application: function (b) {
		var a = b.name,
			e, d, c;
		if (!b) {
			b = {}
		}
		if (!Ext.Loader.config.paths[a]) {
			Ext.Loader.setPath(a, b.appFolder || "app")
		}
		c = Ext.Array.from(b.requires);
		b.requires = ["Ext.app.Application"];
		e = b.onReady;
		d = b.scope;
		b.onReady = function () {
			b.requires = c;
			new Ext.app.Application(b);
			if (e) {
				e.call(d)
			}
		};
		Ext.setup(b)
	},
	factoryConfig: function (a, l) {
		var g = Ext.isSimpleObject(a);
		if (g && a.xclass) {
			var f = a.xclass;
			delete a.xclass;
			Ext.require(f, function () {
				Ext.factoryConfig(a, function (n) {
					l(Ext.create(f, n))
				})
			});
			return
		}
		var d = Ext.isArray(a),
			m = [],
			k, j, c, e;
		if (g || d) {
			if (g) {
				for (k in a) {
					if (a.hasOwnProperty(k)) {
						j = a[k];
						if (Ext.isSimpleObject(j) || Ext.isArray(j)) {
							m.push(k)
						}
					}
				}
			} else {
				for (c = 0, e = a.length; c < e; c++) {
					j = a[c];
					if (Ext.isSimpleObject(j) || Ext.isArray(j)) {
						m.push(c)
					}
				}
			}
			c = 0;
			e = m.length;
			if (e === 0) {
				l(a);
				return
			}
			function h(n) {
				a[k] = n;
				c++;
				b()
			}
			function b() {
				if (c >= e) {
					l(a);
					return
				}
				k = m[c];
				j = a[k];
				Ext.factoryConfig(j, h)
			}
			b();
			return
		}
		l(a)
	},
	factory: function (b, e, a, f) {
		var d = Ext.ClassManager,
			c;
		if (!b || b.isInstance) {
			if (a && a !== b) {
				a.destroy()
			}
			return b
		}
		if (f) {
			if (typeof b == "string") {
				return d.instantiateByAlias(f + "." + b)
			} else {
				if (Ext.isObject(b) && "type" in b) {
					return d.instantiateByAlias(f + "." + b.type, b)
				}
			}
		}
		if (b === true) {
			return a || d.instantiate(e)
		}
		if ("xtype" in b) {
			c = d.instantiateByAlias("widget." + b.xtype, b)
		} else {
			if ("xclass" in b) {
				c = d.instantiate(b.xclass, b)
			}
		}
		if (c) {
			if (a) {
				a.destroy()
			}
			return c
		}
		if (a) {
			return a.setConfig(b)
		}
		return d.instantiate(e, b)
	},
	deprecateClassMember: function (b, c, a, d) {
		return this.deprecateProperty(b.prototype, c, a, d)
	},
	deprecateClassMembers: function (b, c) {
		var d = b.prototype,
			e, a;
		for (e in c) {
			if (c.hasOwnProperty(e)) {
				a = c[e];
				this.deprecateProperty(d, e, a)
			}
		}
	},
	deprecateProperty: function (b, c, a, d) {
		if (!d) {
			d = "'" + c + "' is deprecated"
		}
		if (a) {
			d += ", please use '" + a + "' instead"
		}
		if (a) {
			Ext.Object.defineProperty(b, c, {
				get: function () {
					return this[a]
				},
				set: function (e) {
					this[a] = e
				},
				configurable: true
			})
		}
	},
	deprecatePropertyValue: function (b, a, d, c) {
		Ext.Object.defineProperty(b, a, {
			get: function () {
				return d
			},
			configurable: true
		})
	},
	deprecateMethod: function (b, a, d, c) {
		b[a] = function () {
			if (d) {
				return d.apply(this, arguments)
			}
		}
	},
	deprecateClassMethod: function (a, b, h, d) {
		if (typeof b != "string") {
			var g, f;
			for (g in b) {
				if (b.hasOwnProperty(g)) {
					f = b[g];
					Ext.deprecateClassMethod(a, g, f)
				}
			}
			return
		}
		var c = typeof h == "string",
			e;
		if (!d) {
			d = "'" + b + "()' is deprecated, please use '" + (c ? h : h.name) + "()' instead"
		}
		if (c) {
			e = function () {
				return this[h].apply(this, arguments)
			}
		} else {
			e = function () {
				return h.apply(this, arguments)
			}
		}
		if (b in a.prototype) {
			Ext.Object.defineProperty(a.prototype, b, {
				value: null,
				writable: true,
				configurable: true
			})
		}
		a.addMember(b, e)
	},
	isReady: false,
	readyListeners: [],
	triggerReady: function () {
		var b = Ext.readyListeners,
			a, c, d;
		if (!Ext.isReady) {
			Ext.isReady = true;
			for (a = 0, c = b.length; a < c; a++) {
				d = b[a];
				d.fn.call(d.scope)
			}
			delete Ext.readyListeners
		}
	},
	onDocumentReady: function (d, c) {
		if (Ext.isReady) {
			d.call(c)
		} else {
			var b = Ext.triggerReady;
			Ext.readyListeners.push({
				fn: d,
				scope: c
			});
			if (Ext.browser.is.PhoneGap && !Ext.os.is.Desktop) {
				if (!Ext.readyListenerAttached) {
					Ext.readyListenerAttached = true;
					document.addEventListener("deviceready", b, false)
				}
			} else {
				var a = (/MSIE 10/.test(navigator.userAgent)) ? /complete|loaded/ : /interactive|complete|loaded/;
				if (document.readyState.match(a) !== null) {
					b()
				} else {
					if (!Ext.readyListenerAttached) {
						Ext.readyListenerAttached = true;
						window.addEventListener("DOMContentLoaded", function () {
							if (navigator.standalone) {
								setTimeout(function () {
									setTimeout(function () {
										b()
									}, 1)
								}, 1)
							} else {
								setTimeout(function () {
									b()
								}, 1)
							}
						}, false)
					}
				}
			}
		}
	},
	callback: function (d, c, b, a) {
		if (Ext.isFunction(d)) {
			b = b || [];
			c = c || window;
			if (a) {
				Ext.defer(d, a, c, b)
			} else {
				d.apply(c, b)
			}
		}
	}
});
Ext.define("Ext.env.Browser", {
	statics: {
		browserNames: {
			ie: "IE",
			firefox: "Firefox",
			safari: "Safari",
			chrome: "Chrome",
			opera: "Opera",
			dolfin: "Dolfin",
			webosbrowser: "webOSBrowser",
			chromeMobile: "ChromeMobile",
			silk: "Silk",
			other: "Other"
		},
		engineNames: {
			webkit: "WebKit",
			gecko: "Gecko",
			presto: "Presto",
			trident: "Trident",
			other: "Other"
		},
		enginePrefixes: {
			webkit: "AppleWebKit/",
			gecko: "Gecko/",
			presto: "Presto/",
			trident: "Trident/"
		},
		browserPrefixes: {
			ie: "MSIE ",
			firefox: "Firefox/",
			chrome: "Chrome/",
			safari: "Version/",
			opera: "OPR/",
			dolfin: "Dolfin/",
			webosbrowser: "wOSBrowser/",
			chromeMobile: "CrMo/",
			silk: "Silk/"
		}
	},
	styleDashPrefixes: {
		WebKit: "-webkit-",
		Gecko: "-moz-",
		Trident: "-ms-",
		Presto: "-o-",
		Other: ""
	},
	stylePrefixes: {
		WebKit: "Webkit",
		Gecko: "Moz",
		Trident: "ms",
		Presto: "O",
		Other: ""
	},
	propertyPrefixes: {
		WebKit: "webkit",
		Gecko: "moz",
		Trident: "ms",
		Presto: "o",
		Other: ""
	},
	is: Ext.emptyFn,
	name: null,
	version: null,
	engineName: null,
	engineVersion: null,
	setFlag: function (a, b) {
		if (typeof b == "undefined") {
			b = true
		}
		this.is[a] = b;
		this.is[a.toLowerCase()] = b;
		return this
	},
	constructor: function (o) {
		this.userAgent = o;
		var k = this.statics(),
			c = o.match(new RegExp("((?:" + Ext.Object.getValues(k.browserPrefixes).join(")|(?:") + "))([\\w\\._]+)")),
			b = o.match(new RegExp("((?:" + Ext.Object.getValues(k.enginePrefixes).join(")|(?:") + "))([\\w\\._]+)")),
			g = k.browserNames,
			j = g.other,
			f = k.engineNames,
			n = f.other,
			m = "",
			l = "",
			h = false,
			e, d, a;
		e = this.is = function (p) {
			return e[p] === true
		};
		if (c) {
			j = g[Ext.Object.getKey(k.browserPrefixes, c[1])];
			m = new Ext.Version(c[2])
		}
		if (b) {
			n = f[Ext.Object.getKey(k.enginePrefixes, b[1])];
			l = new Ext.Version(b[2])
		}
		if (o.match(/FB/) && j == "Other") {
			j = g.safari;
			n = f.webkit
		}
		if (o.match(/Android.*Chrome/g)) {
			j = "ChromeMobile"
		}
		if (o.match(/OPR/)) {
			j = "Opera";
			c = o.match(/OPR\/(\d+.\d+)/);
			m = new Ext.Version(c[1])
		}
		Ext.apply(this, {
			engineName: n,
			engineVersion: l,
			name: j,
			version: m
		});
		this.setFlag(j);
		if (m) {
			this.setFlag(j + (m.getMajor() || ""));
			this.setFlag(j + m.getShortVersion())
		}
		for (d in g) {
			if (g.hasOwnProperty(d)) {
				a = g[d];
				this.setFlag(a, j === a)
			}
		}
		this.setFlag(a);
		if (l) {
			this.setFlag(n + (l.getMajor() || ""));
			this.setFlag(n + l.getShortVersion())
		}
		for (d in f) {
			if (f.hasOwnProperty(d)) {
				a = f[d];
				this.setFlag(a, n === a)
			}
		}
		this.setFlag("Standalone", !! navigator.standalone);
		this.setFlag("Ripple", !! document.getElementById("tinyhippos-injected") && !Ext.isEmpty(window.top.ripple));
		this.setFlag("WebWorks", !! window.blackberry);
		if (typeof window.PhoneGap != "undefined" || typeof window.Cordova != "undefined" || typeof window.cordova != "undefined") {
			h = true;
			this.setFlag("PhoneGap");
			this.setFlag("Cordova")
		} else {
			if ( !! window.isNK) {
				h = true;
				this.setFlag("Sencha")
			}
		}
		if (/(iPhone|iPod|iPad).*AppleWebKit(?!.*Safari)(?!.*FBAN)/i.test(o)) {
			h = true
		}
		this.setFlag("WebView", h);
		this.isStrict = document.compatMode == "CSS1Compat";
		this.isSecure = /^https/i.test(window.location.protocol);
		return this
	},
	getStyleDashPrefix: function () {
		return this.styleDashPrefixes[this.engineName]
	},
	getStylePrefix: function () {
		return this.stylePrefixes[this.engineName]
	},
	getVendorProperyName: function (a) {
		var b = this.propertyPrefixes[this.engineName];
		if (b.length > 0) {
			return b + Ext.String.capitalize(a)
		}
		return a
	},
	getPreferredTranslationMethod: function (a) {
		if (typeof a == "object" && "translationMethod" in a && a.translationMethod !== "auto") {
			return a.translationMethod
		} else {
			if (this.is.AndroidStock2 || this.is.IE) {
				return "scrollposition"
			} else {
				return "csstransform"
			}
		}
	}
}, function () {
	var a = Ext.browser = new this(Ext.global.navigator.userAgent)
});
Ext.define("Ext.env.OS", {
	statics: {
		names: {
			ios: "iOS",
			android: "Android",
			windowsPhone: "WindowsPhone",
			webos: "webOS",
			blackberry: "BlackBerry",
			rimTablet: "RIMTablet",
			mac: "MacOS",
			win: "Windows",
			linux: "Linux",
			bada: "Bada",
			chrome: "ChromeOS",
			other: "Other"
		},
		prefixes: {
			ios: "i(?:Pad|Phone|Pod)(?:.*)CPU(?: iPhone)? OS ",
			android: "(Android |HTC_|Silk/)",
			windowsPhone: "Windows Phone ",
			blackberry: "(?:BlackBerry|BB)(?:.*)Version/",
			rimTablet: "RIM Tablet OS ",
			webos: "(?:webOS|hpwOS)/",
			bada: "Bada/",
			chrome: "CrOS "
		}
	},
	is: Ext.emptyFn,
	name: null,
	version: null,
	setFlag: function (a, b) {
		if (typeof b == "undefined") {
			b = true
		}
		this.is[a] = b;
		this.is[a.toLowerCase()] = b;
		return this
	},
	constructor: function (o, b, k) {
		var l = this.statics(),
			j = l.names,
			d = l.prefixes,
			a, h = "",
			c, g, f, n, e, m;
		k = k || Ext.browser;
		e = this.is = function (p) {
			return this.is[p] === true
		};
		for (c in d) {
			if (d.hasOwnProperty(c)) {
				g = d[c];
				f = o.match(new RegExp("(?:" + g + ")([^\\s;]+)"));
				if (f) {
					a = j[c];
					m = f[1];
					if (m && m == "HTC_") {
						h = new Ext.Version("2.3")
					} else {
						if (m && m == "Silk/") {
							h = new Ext.Version("2.3")
						} else {
							h = new Ext.Version(f[f.length - 1])
						}
					}
					break
				}
			}
		}
		if (!a) {
			a = j[(o.toLowerCase().match(/mac|win|linux/) || ["other"])[0]];
			h = new Ext.Version("")
		}
		this.name = a;
		this.version = h;
		if (b) {
			this.setFlag(b.replace(/ simulator$/i, ""))
		}
		this.setFlag(a);
		if (h) {
			this.setFlag(a + (h.getMajor() || ""));
			this.setFlag(a + h.getShortVersion())
		}
		for (c in j) {
			if (j.hasOwnProperty(c)) {
				n = j[c];
				if (!e.hasOwnProperty(a)) {
					this.setFlag(n, (a === n))
				}
			}
		}
		if (this.name == "iOS" && window.screen.height == 568) {
			this.setFlag("iPhone5")
		}
		if (k.is.Safari || k.is.Silk) {
			if (this.is.Android2 || this.is.Android3 || k.version.shortVersion == 501) {
				k.setFlag("AndroidStock");
				k.setFlag("AndroidStock2")
			}
			if (this.is.Android4) {
				k.setFlag("AndroidStock");
				k.setFlag("AndroidStock4")
			}
		}
		return this
	}
}, function () {
	var a = Ext.global.navigator,
		e = a.userAgent,
		b, g, d;
	Ext.os = b = new this(e, a.platform);
	g = b.name;
	var c = window.location.search.match(/deviceType=(Tablet|Phone)/),
		f = window.deviceType;
	if (c && c[1]) {
		d = c[1]
	} else {
		if (f === "iPhone") {
			d = "Phone"
		} else {
			if (f === "iPad") {
				d = "Tablet"
			} else {
				if (!b.is.Android && !b.is.iOS && !b.is.WindowsPhone && /Windows|Linux|MacOS/.test(g)) {
					d = "Desktop";
					Ext.browser.is.WebView = false
				} else {
					if (b.is.iPad || b.is.RIMTablet || b.is.Android3 || Ext.browser.is.Silk || (b.is.Android4 && e.search(/mobile/i) == -1)) {
						d = "Tablet"
					} else {
						d = "Phone"
					}
				}
			}
		}
	}
	b.setFlag(d, true);
	b.deviceType = d
});
Ext.define("Ext.env.Feature", {
	constructor: function () {
		this.testElements = {};
		this.has = function (a) {
			return !!this.has[a]
		};
		if (!Ext.theme) {
			Ext.theme = {
				name: "Default"
			}
		}
		Ext.onDocumentReady(function () {
			this.registerTest({
				ProperHBoxStretching: function () {
					var b = document.createElement("div"),
						c = b.appendChild(document.createElement("div")),
						d = c.appendChild(document.createElement("div")),
						a;
					b.setAttribute("style", "width: 100px; height: 100px; position: relative;");
					c.setAttribute("style", "position: absolute; display: -ms-flexbox; display: -webkit-flex; display: -moz-flexbox; display: flex; -ms-flex-direction: row; -webkit-flex-direction: row; -moz-flex-direction: row; flex-direction: row; min-width: 100%;");
					d.setAttribute("style", "width: 200px; height: 50px;");
					document.body.appendChild(b);
					a = c.offsetWidth;
					document.body.removeChild(b);
					return (a > 100)
				}
			})
		}, this)
	},
	getTestElement: function (a, b) {
		if (a === undefined) {
			a = "div"
		} else {
			if (typeof a !== "string") {
				return a
			}
		}
		if (b) {
			return document.createElement(a)
		}
		if (!this.testElements[a]) {
			this.testElements[a] = document.createElement(a)
		}
		return this.testElements[a]
	},
	isStyleSupported: function (c, b) {
		var d = this.getTestElement(b).style,
			a = Ext.String.capitalize(c);
		if (typeof d[c] !== "undefined" || typeof d[Ext.browser.getStylePrefix(c) + a] !== "undefined") {
			return true
		}
		return false
	},
	isStyleSupportedWithoutPrefix: function (b, a) {
		var c = this.getTestElement(a).style;
		if (typeof c[b] !== "undefined") {
			return true
		}
		return false
	},
	isEventSupported: function (c, a) {
		if (a === undefined) {
			a = window
		}
		var e = this.getTestElement(a),
			b = "on" + c.toLowerCase(),
			d = (b in e);
		if (!d) {
			if (e.setAttribute && e.removeAttribute) {
				e.setAttribute(b, "");
				d = typeof e[b] === "function";
				if (typeof e[b] !== "undefined") {
					e[b] = undefined
				}
				e.removeAttribute(b)
			}
		}
		return d
	},
	getSupportedPropertyName: function (b, a) {
		var c = Ext.browser.getVendorProperyName(a);
		if (c in b) {
			return c
		} else {
			if (a in b) {
				return a
			}
		}
		return null
	},
	registerTest: Ext.Function.flexSetter(function (a, b) {
		this.has[a] = b.call(this);
		return this
	})
}, function () {
	Ext.feature = new this;
	var a = Ext.feature.has;
	Ext.feature.registerTest({
		Canvas: function () {
			var b = this.getTestElement("canvas");
			return !!(b && b.getContext && b.getContext("2d"))
		},
		Svg: function () {
			var b = document;
			return !!(b.createElementNS && !! b.createElementNS("http://www.w3.org/2000/svg", "svg").createSVGRect)
		},
		Vml: function () {
			var c = this.getTestElement(),
				b = false;
			c.innerHTML = "<!--[if vml]><br><![endif]-->";
			b = (c.childNodes.length === 1);
			c.innerHTML = "";
			return b
		},
		Touch: function () {
			return Ext.browser.is.Ripple || (this.isEventSupported("touchstart") && !(Ext.os && Ext.os.name.match(/Windows|MacOS|Linux/) && !Ext.os.is.BlackBerry6))
		},
		Pointer: function () {
			return !!window.navigator.msPointerEnabled
		},
		Orientation: function () {
			return ("orientation" in window) && this.isEventSupported("orientationchange")
		},
		OrientationChange: function () {
			return this.isEventSupported("orientationchange")
		},
		DeviceMotion: function () {
			return this.isEventSupported("devicemotion")
		},
		Geolocation: function () {
			return "geolocation" in window.navigator
		},
		SqlDatabase: function () {
			return "openDatabase" in window
		},
		WebSockets: function () {
			return "WebSocket" in window
		},
		Range: function () {
			return !!document.createRange
		},
		CreateContextualFragment: function () {
			var b = !! document.createRange ? document.createRange() : false;
			return b && !! b.createContextualFragment
		},
		History: function () {
			return ("history" in window && "pushState" in window.history)
		},
		CssTransforms: function () {
			return this.isStyleSupported("transform")
		},
		CssTransformNoPrefix: function () {
			return this.isStyleSupportedWithoutPrefix("transform")
		},
		Css3dTransforms: function () {
			return this.has("CssTransforms") && this.isStyleSupported("perspective") && !Ext.browser.is.AndroidStock2
		},
		CssAnimations: function () {
			return this.isStyleSupported("animationName")
		},
		CssTransitions: function () {
			return this.isStyleSupported("transitionProperty")
		},
		Audio: function () {
			return !!this.getTestElement("audio").canPlayType
		},
		Video: function () {
			return !!this.getTestElement("video").canPlayType
		},
		ClassList: function () {
			return "classList" in this.getTestElement()
		},
		LocalStorage: function () {
			var b = false;
			try {
				if ("localStorage" in window && window.localStorage !== null) {
					localStorage.setItem("sencha-localstorage-test", "test success");
					localStorage.removeItem("sencha-localstorage-test");
					b = true
				}
			} catch (c) {}
			return b
		}
	})
});
Ext.define("Ext.dom.Query", {
	select: function (h, b) {
		var g = [],
			d, f, e, c, a;
		b = b || document;
		if (typeof b == "string") {
			b = document.getElementById(b)
		}
		h = h.split(",");
		for (f = 0, c = h.length; f < c; f++) {
			if (typeof h[f] == "string") {
				if (h[f][0] == "@") {
					d = b.getAttributeNode(h[f].substring(1));
					g.push(d)
				} else {
					d = b.querySelectorAll(h[f]);
					for (e = 0, a = d.length; e < a; e++) {
						g.push(d[e])
					}
				}
			}
		}
		return g
	},
	selectNode: function (b, a) {
		return this.select(b, a)[0]
	},
	is: function (b, d) {
		var a = b.parentNode,
			c;
		if (typeof b == "string") {
			b = document.getElementById(b)
		}
		if (!a) {
			a = document.createDocumentFragment();
			a.appendChild(b);
			c = this.select(d, a).indexOf(b) !== -1;
			a.removeChild(b);
			a = null
		} else {
			c = this.select(d).indexOf(b) !== -1
		}
		return c
	},
	isXml: function (a) {
		var b = (a ? a.ownerDocument || a : 0).documentElement;
		return b ? b.nodeName !== "HTML" : false
	}
}, function () {
	Ext.ns("Ext.core");
	Ext.core.DomQuery = Ext.DomQuery = new this();
	Ext.query = Ext.Function.alias(Ext.DomQuery, "select")
});
Ext.define("Ext.dom.Helper", {
	emptyTags: /^(?:br|frame|hr|img|input|link|meta|range|spacer|wbr|area|param|col)$/i,
	confRe: /tag|children|cn|html|tpl|tplData$/i,
	endRe: /end/i,
	attribXlat: {
		cls: "class",
		htmlFor: "for"
	},
	closeTags: {},
	decamelizeName: function () {
		var c = /([a-z])([A-Z])/g,
			b = {};

		function a(d, f, e) {
			return f + "-" + e.toLowerCase()
		}
		return function (d) {
			return b[d] || (b[d] = d.replace(c, a))
		}
	}(),
	generateMarkup: function (d, c) {
		var g = this,
			b, h, a, e, f;
		if (typeof d == "string") {
			c.push(d)
		} else {
			if (Ext.isArray(d)) {
				for (e = 0; e < d.length; e++) {
					if (d[e]) {
						g.generateMarkup(d[e], c)
					}
				}
			} else {
				a = d.tag || "div";
				c.push("<", a);
				for (b in d) {
					if (d.hasOwnProperty(b)) {
						h = d[b];
						if (!g.confRe.test(b)) {
							if (typeof h == "object") {
								c.push(" ", b, '="');
								g.generateStyles(h, c).push('"')
							} else {
								c.push(" ", g.attribXlat[b] || b, '="', h, '"')
							}
						}
					}
				}
				if (g.emptyTags.test(a)) {
					c.push("/>")
				} else {
					c.push(">");
					if ((h = d.tpl)) {
						h.applyOut(d.tplData, c)
					}
					if ((h = d.html)) {
						c.push(h)
					}
					if ((h = d.cn || d.children)) {
						g.generateMarkup(h, c)
					}
					f = g.closeTags;
					c.push(f[a] || (f[a] = "</" + a + ">"))
				}
			}
		}
		return c
	},
	generateStyles: function (e, c) {
		var b = c || [],
			d;
		for (d in e) {
			if (e.hasOwnProperty(d)) {
				b.push(this.decamelizeName(d), ":", e[d], ";")
			}
		}
		return c || b.join("")
	},
	markup: function (a) {
		if (typeof a == "string") {
			return a
		}
		var b = this.generateMarkup(a, []);
		return b.join("")
	},
	applyStyles: function (a, b) {
		Ext.fly(a).applyStyles(b)
	},
	createContextualFragment: function (c) {
		var f = document.createElement("div"),
			a = document.createDocumentFragment(),
			b = 0,
			d, e;
		f.innerHTML = c;
		e = f.childNodes;
		d = e.length;
		for (; b < d; b++) {
			a.appendChild(e[b].cloneNode(true))
		}
		return a
	},
	insertHtml: function (d, a, e) {
		var h, f, j, c, b, g;
		d = d.toLowerCase();
		if (Ext.isTextNode(a)) {
			if (d == "afterbegin") {
				d = "beforebegin"
			} else {
				if (d == "beforeend") {
					d = "afterend"
				}
			}
		}
		b = d == "beforebegin";
		g = d == "afterbegin";
		f = (Ext.feature.has.CreateContextualFragment && Ext.get(a).isPainted()) ? a.ownerDocument.createRange() : undefined;
		h = "setStart" + (this.endRe.test(d) ? "After" : "Before");
		if (b || d == "afterend") {
			if (f) {
				f[h](a);
				j = f.createContextualFragment(e)
			} else {
				j = this.createContextualFragment(e)
			}
			a.parentNode.insertBefore(j, b ? a : a.nextSibling);
			return a[(b ? "previous" : "next") + "Sibling"]
		} else {
			c = (g ? "first" : "last") + "Child";
			if (a.firstChild) {
				if (f) {
					f[h](a[c]);
					j = f.createContextualFragment(e)
				} else {
					j = this.createContextualFragment(e)
				}
				if (g) {
					a.insertBefore(j, a.firstChild)
				} else {
					a.appendChild(j)
				}
			} else {
				a.innerHTML = e
			}
			return a[c]
		}
	},
	insertBefore: function (a, c, b) {
		return this.doInsert(a, c, b, "beforebegin")
	},
	insertAfter: function (a, c, b) {
		return this.doInsert(a, c, b, "afterend")
	},
	insertFirst: function (a, c, b) {
		return this.doInsert(a, c, b, "afterbegin")
	},
	append: function (a, c, b) {
		return this.doInsert(a, c, b, "beforeend")
	},
	overwrite: function (a, c, b) {
		a = Ext.getDom(a);
		a.innerHTML = this.markup(c);
		return b ? Ext.get(a.firstChild) : a.firstChild
	},
	doInsert: function (b, d, c, e) {
		var a = this.insertHtml(e, Ext.getDom(b), this.markup(d));
		return c ? Ext.get(a, true) : a
	},
	createTemplate: function (b) {
		var a = this.markup(b);
		return new Ext.Template(a)
	}
}, function () {
	Ext.ns("Ext.core");
	Ext.core.DomHelper = Ext.DomHelper = new this
});
Ext.define("Ext.mixin.Identifiable", {
	statics: {
		uniqueIds: {}
	},
	isIdentifiable: true,
	mixinId: "identifiable",
	idCleanRegex: /\.|[^\w\-]/g,
	defaultIdPrefix: "ext-",
	defaultIdSeparator: "-",
	getOptimizedId: function () {
		return this.id
	},
	getUniqueId: function () {
		var f = this.id,
			b, d, e, a, c;
		if (!f) {
			b = this.self.prototype;
			d = this.defaultIdSeparator;
			a = Ext.mixin.Identifiable.uniqueIds;
			if (!b.hasOwnProperty("identifiablePrefix")) {
				e = this.xtype;
				if (e) {
					c = this.defaultIdPrefix + e + d
				} else {
					c = b.$className.replace(this.idCleanRegex, d).toLowerCase() + d
				}
				b.identifiablePrefix = c
			}
			c = this.identifiablePrefix;
			if (!a.hasOwnProperty(c)) {
				a[c] = 0
			}
			f = this.id = c + (++a[c])
		}
		this.getUniqueId = this.getOptimizedId;
		return f
	},
	setId: function (a) {
		this.id = a
	},
	getId: function () {
		var a = this.id;
		if (!a) {
			a = this.getUniqueId()
		}
		this.getId = this.getOptimizedId;
		return a
	}
});
Ext.define("Ext.dom.Element", {
	alternateClassName: "Ext.Element",
	mixins: [Ext.mixin.Identifiable],
	observableType: "element",
	xtype: "element",
	statics: {
		CREATE_ATTRIBUTES: {
			style: "style",
			className: "className",
			cls: "cls",
			classList: "classList",
			text: "text",
			hidden: "hidden",
			html: "html",
			children: "children"
		},
		create: function (c, b) {
			var f = this.CREATE_ATTRIBUTES,
				e, h, k, j, a, d, g;
			if (!c) {
				c = {}
			}
			if (c.isElement) {
				return c.dom
			} else {
				if ("nodeType" in c) {
					return c
				}
			}
			if (typeof c == "string") {
				return document.createTextNode(c)
			}
			k = c.tag;
			if (!k) {
				k = "div"
			}
			if (c.namespace) {
				e = document.createElementNS(c.namespace, k)
			} else {
				e = document.createElement(k)
			}
			h = e.style;
			for (a in c) {
				if (a != "tag") {
					j = c[a];
					switch (a) {
					case f.style:
						if (typeof j == "string") {
							e.setAttribute(a, j)
						} else {
							for (d in j) {
								if (j.hasOwnProperty(d)) {
									h[d] = j[d]
								}
							}
						}
						break;
					case f.className:
					case f.cls:
						e.className = j;
						break;
					case f.classList:
						e.className = j.join(" ");
						break;
					case f.text:
						e.textContent = j;
						break;
					case f.hidden:
						if (j) {
							e.style.display = "none"
						}
						break;
					case f.html:
						e.innerHTML = j;
						break;
					case f.children:
						for (d = 0, g = j.length; d < g; d++) {
							e.appendChild(this.create(j[d], true))
						}
						break;
					default:
						e.setAttribute(a, j)
					}
				}
			}
			if (b) {
				return e
			} else {
				return this.get(e)
			}
		},
		documentElement: null,
		cache: {},
		get: function (c) {
			var b = this.cache,
				a, d, e;
			if (!c) {
				return null
			}
			if (typeof c == "string") {
				if (b.hasOwnProperty(c)) {
					return b[c]
				}
				if (!(d = document.getElementById(c))) {
					return null
				}
				b[c] = a = new this(d);
				return a
			}
			if ("tagName" in c) {
				e = c.id;
				if (b.hasOwnProperty(e)) {
					return b[e]
				}
				a = new this(c);
				b[a.getId()] = a;
				return a
			}
			if (c.isElement) {
				return c
			}
			if (c.isComposite) {
				return c
			}
			if (Ext.isArray(c)) {
				return this.select(c)
			}
			if (c === document) {
				if (!this.documentElement) {
					this.documentElement = new this(document.documentElement);
					this.documentElement.setId("ext-application")
				}
				return this.documentElement
			}
			return null
		},
		data: function (c, b, e) {
			var a = Ext.cache,
				f, d;
			c = this.get(c);
			if (!c) {
				return null
			}
			f = c.id;
			d = a[f].data;
			if (!d) {
				a[f].data = d = {}
			}
			if (arguments.length == 2) {
				return d[b]
			} else {
				return (d[b] = e)
			}
		}
	},
	isElement: true,
	constructor: function (a) {
		if (typeof a == "string") {
			a = document.getElementById(a)
		}
		if (!a) {
			throw new Error("Invalid domNode reference or an id of an existing domNode: " + a)
		}
		this.dom = a;
		this.getUniqueId()
	},
	attach: function (a) {
		this.dom = a;
		this.id = a.id;
		return this
	},
	getUniqueId: function () {
		var b = this.id,
			a;
		if (!b) {
			a = this.dom;
			if (a.id.length > 0) {
				this.id = b = a.id
			} else {
				a.id = b = this.mixins.identifiable.getUniqueId.call(this)
			}
			Ext.Element.cache[b] = this
		}
		return b
	},
	setId: function (c) {
		var a = this.id,
			b = Ext.Element.cache;
		if (a) {
			delete b[a]
		}
		this.dom.id = c;
		this.id = c;
		b[c] = this;
		return this
	},
	setHtml: function (a) {
		this.dom.innerHTML = a
	},
	getHtml: function () {
		return this.dom.innerHTML
	},
	setText: function (a) {
		this.dom.textContent = a
	},
	redraw: function () {
		var b = this.dom,
			a = b.style;
		a.display = "none";
		b.offsetHeight;
		a.display = ""
	},
	isPainted: (function () {
		return !Ext.browser.is.IE ?
		function () {
			var a = this.dom;
			return Boolean(a && a.offsetParent)
		} : function () {
			var a = this.dom;
			return Boolean(a && (a.offsetHeight !== 0 && a.offsetWidth !== 0))
		}
	})(),
	set: function (a, b) {
		var e = this.dom,
			c, d;
		for (c in a) {
			if (a.hasOwnProperty(c)) {
				d = a[c];
				if (c == "style") {
					this.applyStyles(d)
				} else {
					if (c == "cls") {
						e.className = d
					} else {
						if (b !== false) {
							if (d === undefined) {
								e.removeAttribute(c)
							} else {
								e.setAttribute(c, d)
							}
						} else {
							e[c] = d
						}
					}
				}
			}
		}
		return this
	},
	is: function (a) {
		return Ext.DomQuery.is(this.dom, a)
	},
	getValue: function (b) {
		var a = this.dom.value;
		return b ? parseInt(a, 10) : a
	},
	getAttribute: function (a, b) {
		var c = this.dom;
		return c.getAttributeNS(b, a) || c.getAttribute(b + ":" + a) || c.getAttribute(a) || c[a]
	},
	setSizeState: function (d) {
		var c = ["x-sized", "x-unsized", "x-stretched"],
			a = [true, false, null],
			b = a.indexOf(d),
			e;
		if (b !== -1) {
			e = c[b];
			c.splice(b, 1);
			this.addCls(e)
		}
		this.removeCls(c);
		return this
	},
	destroy: function () {
		this.isDestroyed = true;
		var a = Ext.Element.cache,
			b = this.dom;
		if (b && b.parentNode && b.tagName != "BODY") {
			b.parentNode.removeChild(b)
		}
		delete a[this.id];
		delete this.dom
	}
}, function (a) {
	Ext.elements = Ext.cache = a.cache;
	this.addStatics({
		Fly: new Ext.Class({
			extend: a,
			constructor: function (b) {
				this.dom = b
			}
		}),
		_flyweights: {},
		fly: function (e, c) {
			var f = null,
				d = a._flyweights,
				b;
			c = c || "_global";
			e = Ext.getDom(e);
			if (e) {
				f = d[c] || (d[c] = new a.Fly());
				f.dom = e;
				f.isSynchronized = false;
				b = Ext.cache[e.id];
				if (b && b.isElement) {
					b.isSynchronized = false
				}
			}
			return f
		}
	});
	Ext.get = function (b) {
		return a.get.call(a, b)
	};
	Ext.fly = function () {
		return a.fly.apply(a, arguments)
	};
	Ext.ClassManager.onCreated(function () {
		a.mixin("observable", Ext.mixin.Observable)
	}, null, "Ext.mixin.Observable")
});
Ext.dom.Element.addStatics({
	numberRe: /\d+$/,
	unitRe: /\d+(px|em|%|en|ex|pt|in|cm|mm|pc)$/i,
	camelRe: /(-[a-z])/gi,
	cssRe: /([a-z0-9-]+)\s*:\s*([^;\s]+(?:\s*[^;\s]+)*);?/gi,
	opacityRe: /alpha\(opacity=(.*)\)/i,
	propertyCache: {},
	defaultUnit: "px",
	borders: {
		l: "border-left-width",
		r: "border-right-width",
		t: "border-top-width",
		b: "border-bottom-width"
	},
	paddings: {
		l: "padding-left",
		r: "padding-right",
		t: "padding-top",
		b: "padding-bottom"
	},
	margins: {
		l: "margin-left",
		r: "margin-right",
		t: "margin-top",
		b: "margin-bottom"
	},
	addUnits: function (b, a) {
		if (b === "" || b == "auto" || b === undefined || b === null) {
			return b || ""
		}
		if (Ext.isNumber(b) || this.numberRe.test(b)) {
			return b + (a || this.defaultUnit || "px")
		} else {
			if (!this.unitRe.test(b)) {
				return b || ""
			}
		}
		return b
	},
	isAncestor: function (b, d) {
		var a = false;
		b = Ext.getDom(b);
		d = Ext.getDom(d);
		if (b && d) {
			if (b.contains) {
				return b.contains(d)
			} else {
				if (b.compareDocumentPosition) {
					return !!(b.compareDocumentPosition(d) & 16)
				} else {
					while ((d = d.parentNode)) {
						a = d == b || a
					}
				}
			}
		}
		return a
	},
	parseBox: function (b) {
		if (typeof b != "string") {
			b = b.toString()
		}
		var c = b.split(" "),
			a = c.length;
		if (a == 1) {
			c[1] = c[2] = c[3] = c[0]
		} else {
			if (a == 2) {
				c[2] = c[0];
				c[3] = c[1]
			} else {
				if (a == 3) {
					c[3] = c[1]
				}
			}
		}
		return {
			top: c[0] || 0,
			right: c[1] || 0,
			bottom: c[2] || 0,
			left: c[3] || 0
		}
	},
	unitizeBox: function (c, a) {
		var b = this;
		c = b.parseBox(c);
		return b.addUnits(c.top, a) + " " + b.addUnits(c.right, a) + " " + b.addUnits(c.bottom, a) + " " + b.addUnits(c.left, a)
	},
	camelReplaceFn: function (b, c) {
		return c.charAt(1).toUpperCase()
	},
	normalize: function (a) {
		return this.propertyCache[a] || (this.propertyCache[a] = a.replace(this.camelRe, this.camelReplaceFn))
	},
	fromPoint: function (a, b) {
		return Ext.get(document.elementFromPoint(a, b))
	},
	parseStyles: function (c) {
		var a = {},
			b = this.cssRe,
			d;
		if (c) {
			b.lastIndex = 0;
			while ((d = b.exec(c))) {
				a[d[1]] = d[2]
			}
		}
		return a
	}
});
Ext.dom.Element.addMembers({
	appendChild: function (a) {
		this.dom.appendChild(Ext.getDom(a));
		return this
	},
	removeChild: function (a) {
		this.dom.removeChild(Ext.getDom(a));
		return this
	},
	append: function () {
		this.appendChild.apply(this, arguments)
	},
	appendTo: function (a) {
		Ext.getDom(a).appendChild(this.dom);
		return this
	},
	insertBefore: function (a) {
		a = Ext.getDom(a);
		a.parentNode.insertBefore(this.dom, a);
		return this
	},
	insertAfter: function (a) {
		a = Ext.getDom(a);
		a.parentNode.insertBefore(this.dom, a.nextSibling);
		return this
	},
	insertFirst: function (b) {
		var a = Ext.getDom(b),
			d = this.dom,
			c = d.firstChild;
		if (!c) {
			d.appendChild(a)
		} else {
			d.insertBefore(a, c)
		}
		return this
	},
	insertSibling: function (e, c, d) {
		var f = this,
			b, a = (c || "before").toLowerCase() == "after",
			g;
		if (Ext.isArray(e)) {
			g = f;
			Ext.each(e, function (h) {
				b = Ext.fly(g, "_internal").insertSibling(h, c, d);
				if (a) {
					g = b
				}
			});
			return b
		}
		e = e || {};
		if (e.nodeType || e.dom) {
			b = f.dom.parentNode.insertBefore(Ext.getDom(e), a ? f.dom.nextSibling : f.dom);
			if (!d) {
				b = Ext.get(b)
			}
		} else {
			if (a && !f.dom.nextSibling) {
				b = Ext.core.DomHelper.append(f.dom.parentNode, e, !d)
			} else {
				b = Ext.core.DomHelper[a ? "insertAfter" : "insertBefore"](f.dom, e, !d)
			}
		}
		return b
	},
	replace: function (a) {
		a = Ext.getDom(a);
		a.parentNode.replaceChild(this.dom, a);
		return this
	},
	replaceWith: function (a) {
		var b = this;
		if (a.nodeType || a.dom || typeof a == "string") {
			a = Ext.get(a);
			b.dom.parentNode.insertBefore(a, b.dom)
		} else {
			a = Ext.core.DomHelper.insertBefore(b.dom, a)
		}
		delete Ext.cache[b.id];
		Ext.removeNode(b.dom);
		b.id = Ext.id(b.dom = a);
		Ext.dom.Element.addToCache(b.isFlyweight ? new Ext.dom.Element(b.dom) : b);
		return b
	},
	doReplaceWith: function (a) {
		var b = this.dom;
		b.parentNode.replaceChild(Ext.getDom(a), b)
	},
	createChild: function (b, a, c) {
		b = b || {
			tag: "div"
		};
		if (a) {
			return Ext.core.DomHelper.insertBefore(a, b, c !== true)
		} else {
			return Ext.core.DomHelper[!this.dom.firstChild ? "insertFirst" : "append"](this.dom, b, c !== true)
		}
	},
	wrap: function (b, c) {
		var e = this.dom,
			f = this.self.create(b, c),
			d = (c) ? f : f.dom,
			a = e.parentNode;
		if (a) {
			a.insertBefore(d, e)
		}
		d.appendChild(e);
		return f
	},
	wrapAllChildren: function (a) {
		var d = this.dom,
			b = d.childNodes,
			e = this.self.create(a),
			c = e.dom;
		while (b.length > 0) {
			c.appendChild(d.firstChild)
		}
		d.appendChild(c);
		return e
	},
	unwrapAllChildren: function () {
		var c = this.dom,
			b = c.childNodes,
			a = c.parentNode;
		if (a) {
			while (b.length > 0) {
				a.insertBefore(c, c.firstChild)
			}
			this.destroy()
		}
	},
	unwrap: function () {
		var c = this.dom,
			a = c.parentNode,
			b;
		if (a) {
			b = a.parentNode;
			b.insertBefore(c, a);
			b.removeChild(a)
		} else {
			b = document.createDocumentFragment();
			b.appendChild(c)
		}
		return this
	},
	detach: function () {
		var a = this.dom;
		if (a && a.parentNode && a.tagName !== "BODY") {
			a.parentNode.removeChild(a)
		}
		return this
	},
	insertHtml: function (b, c, a) {
		var d = Ext.core.DomHelper.insertHtml(b, this.dom, c);
		return a ? Ext.get(d) : d
	}
});
Ext.dom.Element.override({
	getX: function (a) {
		return this.getXY(a)[0]
	},
	getY: function (a) {
		return this.getXY(a)[1]
	},
	getXY: function () {
		var b = this.dom.getBoundingClientRect(),
			a = Math.round;
		return [a(b.left + window.pageXOffset), a(b.top + window.pageYOffset)]
	},
	getOffsetsTo: function (a) {
		var c = this.getXY(),
			b = Ext.fly(a, "_internal").getXY();
		return [c[0] - b[0], c[1] - b[1]]
	},
	setX: function (a) {
		return this.setXY([a, this.getY()])
	},
	setY: function (a) {
		return this.setXY([this.getX(), a])
	},
	setXY: function (d) {
		var b = this;
		if (arguments.length > 1) {
			d = [d, arguments[1]]
		}
		var c = b.translatePoints(d),
			a = b.dom.style;
		for (d in c) {
			if (!c.hasOwnProperty(d)) {
				continue
			}
			if (!isNaN(c[d])) {
				a[d] = c[d] + "px"
			}
		}
		return b
	},
	getLeft: function () {
		return parseInt(this.getStyle("left"), 10) || 0
	},
	getRight: function () {
		return parseInt(this.getStyle("right"), 10) || 0
	},
	getTop: function () {
		return parseInt(this.getStyle("top"), 10) || 0
	},
	getBottom: function () {
		return parseInt(this.getStyle("bottom"), 10) || 0
	},
	translatePoints: function (a, g) {
		g = isNaN(a[1]) ? g : a[1];
		a = isNaN(a[0]) ? a : a[0];
		var d = this,
			e = d.isStyle("position", "relative"),
			f = d.getXY(),
			b = parseInt(d.getStyle("left"), 10),
			c = parseInt(d.getStyle("top"), 10);
		b = !isNaN(b) ? b : (e ? 0 : d.dom.offsetLeft);
		c = !isNaN(c) ? c : (e ? 0 : d.dom.offsetTop);
		return {
			left: (a - f[0] + b),
			top: (g - f[1] + c)
		}
	},
	setBox: function (d) {
		var c = this,
			b = d.width,
			a = d.height,
			f = d.top,
			e = d.left;
		if (e !== undefined) {
			c.setLeft(e)
		}
		if (f !== undefined) {
			c.setTop(f)
		}
		if (b !== undefined) {
			c.setWidth(b)
		}
		if (a !== undefined) {
			c.setHeight(a)
		}
		return this
	},
	getBox: function (g, k) {
		var h = this,
			e = h.dom,
			c = e.offsetWidth,
			m = e.offsetHeight,
			o, f, d, a, n, j;
		if (!k) {
			o = h.getXY()
		} else {
			if (g) {
				o = [0, 0]
			} else {
				o = [parseInt(h.getStyle("left"), 10) || 0, parseInt(h.getStyle("top"), 10) || 0]
			}
		}
		if (!g) {
			f = {
				x: o[0],
				y: o[1],
				0: o[0],
				1: o[1],
				width: c,
				height: m
			}
		} else {
			d = h.getBorderWidth.call(h, "l") + h.getPadding.call(h, "l");
			a = h.getBorderWidth.call(h, "r") + h.getPadding.call(h, "r");
			n = h.getBorderWidth.call(h, "t") + h.getPadding.call(h, "t");
			j = h.getBorderWidth.call(h, "b") + h.getPadding.call(h, "b");
			f = {
				x: o[0] + d,
				y: o[1] + n,
				0: o[0] + d,
				1: o[1] + n,
				width: c - (d + a),
				height: m - (n + j)
			}
		}
		f.left = f.x;
		f.top = f.y;
		f.right = f.x + f.width;
		f.bottom = f.y + f.height;
		return f
	},
	getPageBox: function (e) {
		var g = this,
			c = g.dom,
			k = c.offsetWidth,
			f = c.offsetHeight,
			n = g.getXY(),
			m = n[1],
			a = n[0] + k,
			j = n[1] + f,
			d = n[0];
		if (!c) {
			return new Ext.util.Region()
		}
		if (e) {
			return new Ext.util.Region(m, a, j, d)
		} else {
			return {
				left: d,
				top: m,
				width: k,
				height: f,
				right: a,
				bottom: j
			}
		}
	}
});
Ext.dom.Element.addMembers({
	WIDTH: "width",
	HEIGHT: "height",
	MIN_WIDTH: "min-width",
	MIN_HEIGHT: "min-height",
	MAX_WIDTH: "max-width",
	MAX_HEIGHT: "max-height",
	TOP: "top",
	RIGHT: "right",
	BOTTOM: "bottom",
	LEFT: "left",
	VISIBILITY: 1,
	DISPLAY: 2,
	OFFSETS: 3,
	SEPARATOR: "-",
	trimRe: /^\s+|\s+$/g,
	wordsRe: /\w/g,
	spacesRe: /\s+/,
	styleSplitRe: /\s*(?::|;)\s*/,
	transparentRe: /^(?:transparent|(?:rgba[(](?:\s*\d+\s*[,]){3}\s*0\s*[)]))$/i,
	classNameSplitRegex: /[\s]+/,
	borders: {
		t: "border-top-width",
		r: "border-right-width",
		b: "border-bottom-width",
		l: "border-left-width"
	},
	paddings: {
		t: "padding-top",
		r: "padding-right",
		b: "padding-bottom",
		l: "padding-left"
	},
	margins: {
		t: "margin-top",
		r: "margin-right",
		b: "margin-bottom",
		l: "margin-left"
	},
	defaultUnit: "px",
	isSynchronized: false,
	synchronize: function () {
		var g = this.dom,
			a = {},
			d = g.className,
			f, c, e, b;
		if (d.length > 0) {
			f = g.className.split(this.classNameSplitRegex);
			for (c = 0, e = f.length; c < e; c++) {
				b = f[c];
				a[b] = true
			}
		} else {
			f = []
		}
		this.classList = f;
		this.hasClassMap = a;
		this.isSynchronized = true;
		return this
	},
	addCls: function (j, g, k) {
		if (!j) {
			return this
		}
		if (!this.isSynchronized) {
			this.synchronize()
		}
		var e = this.dom,
			c = this.hasClassMap,
			d = this.classList,
			a = this.SEPARATOR,
			f, h, b;
		g = g ? g + a : "";
		k = k ? a + k : "";
		if (typeof j == "string") {
			j = j.split(this.spacesRe)
		}
		for (f = 0, h = j.length; f < h; f++) {
			b = g + j[f] + k;
			if (!c[b]) {
				c[b] = true;
				d.push(b)
			}
		}
		e.className = d.join(" ");
		return this
	},
	removeCls: function (j, g, k) {
		if (!j) {
			return this
		}
		if (!this.isSynchronized) {
			this.synchronize()
		}
		if (!k) {
			k = ""
		}
		var e = this.dom,
			c = this.hasClassMap,
			d = this.classList,
			a = this.SEPARATOR,
			f, h, b;
		g = g ? g + a : "";
		k = k ? a + k : "";
		if (typeof j == "string") {
			j = j.split(this.spacesRe)
		}
		for (f = 0, h = j.length; f < h; f++) {
			b = g + j[f] + k;
			if (c[b]) {
				delete c[b];
				Ext.Array.remove(d, b)
			}
		}
		e.className = d.join(" ");
		return this
	},
	replaceCls: function (d, k, h, l) {
		if (!d && !k) {
			return this
		}
		d = d || [];
		k = k || [];
		if (!this.isSynchronized) {
			this.synchronize()
		}
		if (!l) {
			l = ""
		}
		var f = this.dom,
			c = this.hasClassMap,
			e = this.classList,
			a = this.SEPARATOR,
			g, j, b;
		h = h ? h + a : "";
		l = l ? a + l : "";
		if (typeof d == "string") {
			d = d.split(this.spacesRe)
		}
		if (typeof k == "string") {
			k = k.split(this.spacesRe)
		}
		for (g = 0, j = d.length; g < j; g++) {
			b = h + d[g] + l;
			if (c[b]) {
				delete c[b];
				Ext.Array.remove(e, b)
			}
		}
		for (g = 0, j = k.length; g < j; g++) {
			b = h + k[g] + l;
			if (!c[b]) {
				c[b] = true;
				e.push(b)
			}
		}
		f.className = e.join(" ");
		return this
	},
	hasCls: function (a) {
		if (!this.isSynchronized) {
			this.synchronize()
		}
		return this.hasClassMap.hasOwnProperty(a)
	},
	setCls: function (c) {
		var e = this.hasClassMap,
			b, d, a;
		if (typeof c == "string") {
			c = c.split(this.spacesRe)
		}
		for (b = 0, d = c.length; b < d; b++) {
			a = c[b];
			if (!e[a]) {
				e[a] = true
			}
		}
		this.classList = c.slice();
		this.dom.className = c.join(" ")
	},
	toggleCls: function (a, b) {
		if (typeof b !== "boolean") {
			b = !this.hasCls(a)
		}
		return (b) ? this.addCls(a) : this.removeCls(a)
	},
	swapCls: function (b, f, a, d) {
		if (a === undefined) {
			a = true
		}
		var e = a ? b : f,
			c = a ? f : b;
		if (c) {
			this.removeCls(d ? d + "-" + c : c)
		}
		if (e) {
			this.addCls(d ? d + "-" + e : e)
		}
		return this
	},
	setWidth: function (a) {
		return this.setLengthValue(this.WIDTH, a)
	},
	setHeight: function (a) {
		return this.setLengthValue(this.HEIGHT, a)
	},
	setSize: function (b, a) {
		if (Ext.isObject(b)) {
			a = b.height;
			b = b.width
		}
		this.setWidth(b);
		this.setHeight(a);
		return this
	},
	setMinWidth: function (a) {
		return this.setLengthValue(this.MIN_WIDTH, a)
	},
	setMinHeight: function (a) {
		return this.setLengthValue(this.MIN_HEIGHT, a)
	},
	setMaxWidth: function (a) {
		return this.setLengthValue(this.MAX_WIDTH, a)
	},
	setMaxHeight: function (a) {
		return this.setLengthValue(this.MAX_HEIGHT, a)
	},
	setTop: function (a) {
		return this.setLengthValue(this.TOP, a)
	},
	setRight: function (a) {
		return this.setLengthValue(this.RIGHT, a)
	},
	setBottom: function (a) {
		return this.setLengthValue(this.BOTTOM, a)
	},
	setLeft: function (a) {
		return this.setLengthValue(this.LEFT, a)
	},
	setMargin: function (b) {
		var a = this.dom.style;
		if (b || b === 0) {
			b = this.self.unitizeBox((b === true) ? 5 : b);
			a.setProperty("margin", b, "important")
		} else {
			a.removeProperty("margin-top");
			a.removeProperty("margin-right");
			a.removeProperty("margin-bottom");
			a.removeProperty("margin-left")
		}
	},
	setPadding: function (b) {
		var a = this.dom.style;
		if (b || b === 0) {
			b = this.self.unitizeBox((b === true) ? 5 : b);
			a.setProperty("padding", b, "important")
		} else {
			a.removeProperty("padding-top");
			a.removeProperty("padding-right");
			a.removeProperty("padding-bottom");
			a.removeProperty("padding-left")
		}
	},
	setBorder: function (a) {
		var b = this.dom.style;
		if (a || a === 0) {
			a = this.self.unitizeBox((a === true) ? 1 : a);
			b.setProperty("border-width", a, "important")
		} else {
			b.removeProperty("border-top-width");
			b.removeProperty("border-right-width");
			b.removeProperty("border-bottom-width");
			b.removeProperty("border-left-width")
		}
	},
	setLengthValue: function (a, c) {
		var b = this.dom.style;
		if (c === null) {
			b.removeProperty(a);
			return this
		}
		if (typeof c == "number") {
			c = c + "px"
		}
		b.setProperty(a, c, "important");
		return this
	},
	setVisible: function (b) {
		var a = this.getVisibilityMode(),
			c = b ? "removeCls" : "addCls";
		switch (a) {
		case this.VISIBILITY:
			this.removeCls(["x-hidden-display", "x-hidden-offsets"]);
			this[c]("x-hidden-visibility");
			break;
		case this.DISPLAY:
			this.removeCls(["x-hidden-visibility", "x-hidden-offsets"]);
			this[c]("x-hidden-display");
			break;
		case this.OFFSETS:
			this.removeCls(["x-hidden-visibility", "x-hidden-display"]);
			this[c]("x-hidden-offsets");
			break
		}
		return this
	},
	getVisibilityMode: function () {
		var b = this.dom,
			a = Ext.dom.Element.data(b, "visibilityMode");
		if (a === undefined) {
			Ext.dom.Element.data(b, "visibilityMode", a = this.DISPLAY)
		}
		return a
	},
	setVisibilityMode: function (a) {
		this.self.data(this.dom, "visibilityMode", a);
		return this
	},
	show: function () {
		var a = this.dom;
		if (a) {
			a.style.removeProperty("display")
		}
	},
	hide: function () {
		this.dom.style.setProperty("display", "none", "important")
	},
	setVisibility: function (a) {
		var b = this.dom.style;
		if (a) {
			b.removeProperty("visibility")
		} else {
			b.setProperty("visibility", "hidden", "important")
		}
	},
	styleHooks: {},
	addStyles: function (h, g) {
		var b = 0,
			f = h.match(this.wordsRe),
			e = 0,
			a = f.length,
			d, c;
		for (; e < a; e++) {
			d = f[e];
			c = d && parseInt(this.getStyle(g[d]), 10);
			if (c) {
				b += Math.abs(c)
			}
		}
		return b
	},
	isStyle: function (a, b) {
		return this.getStyle(a) == b
	},
	getStyleValue: function (a) {
		return this.dom.style.getPropertyValue(a)
	},
	getStyle: function (f) {
		var c = this,
			e = c.dom,
			d = c.styleHooks[f],
			b, a;
		if (e == document) {
			return null
		}
		if (!d) {
			c.styleHooks[f] = d = {
				name: Ext.dom.Element.normalize(f)
			}
		}
		if (d.get) {
			return d.get(e, c)
		}
		b = window.getComputedStyle(e, "");
		a = (b && b[d.name]);
		return a
	},
	setStyle: function (a, h) {
		var f = this,
			d = f.dom,
			j = f.styleHooks,
			b = d.style,
			e = Ext.valueFrom,
			c, g;
		if (typeof a == "string") {
			g = j[a];
			if (!g) {
				j[a] = g = {
					name: Ext.dom.Element.normalize(a)
				}
			}
			h = e(h, "");
			if (g.set) {
				g.set(d, h, f)
			} else {
				b[g.name] = h
			}
		} else {
			for (c in a) {
				if (a.hasOwnProperty(c)) {
					g = j[c];
					if (!g) {
						j[c] = g = {
							name: Ext.dom.Element.normalize(c)
						}
					}
					h = e(a[c], "");
					if (g.set) {
						g.set(d, h, f)
					} else {
						b[g.name] = h
					}
				}
			}
		}
		return f
	},
	getHeight: function (b) {
		var c = this.dom,
			a = b ? (c.clientHeight - this.getPadding("tb")) : c.offsetHeight;
		return a > 0 ? a : 0
	},
	getWidth: function (a) {
		var c = this.dom,
			b = a ? (c.clientWidth - this.getPadding("lr")) : c.offsetWidth;
		return b > 0 ? b : 0
	},
	getBorderWidth: function (a) {
		return this.addStyles(a, this.borders)
	},
	getPadding: function (a) {
		return this.addStyles(a, this.paddings)
	},
	applyStyles: function (d) {
		if (d) {
			var e = this.dom,
				c, b, a;
			if (typeof d == "function") {
				d = d.call()
			}
			c = typeof d;
			if (c == "string") {
				d = Ext.util.Format.trim(d).split(this.styleSplitRe);
				for (b = 0, a = d.length; b < a;) {
					e.style[Ext.dom.Element.normalize(d[b++])] = d[b++]
				}
			} else {
				if (c == "object") {
					this.setStyle(d)
				}
			}
		}
		return this
	},
	getSize: function (b) {
		var a = this.dom;
		return {
			width: Math.max(0, b ? (a.clientWidth - this.getPadding("lr")) : a.offsetWidth),
			height: Math.max(0, b ? (a.clientHeight - this.getPadding("tb")) : a.offsetHeight)
		}
	},
	repaint: function () {
		var a = this.dom;
		this.addCls(Ext.baseCSSPrefix + "repaint");
		setTimeout(function () {
			Ext.fly(a).removeCls(Ext.baseCSSPrefix + "repaint")
		}, 1);
		return this
	},
	getMargin: function (b) {
		var c = this,
			d = {
				t: "top",
				l: "left",
				r: "right",
				b: "bottom"
			},
			e = {},
			a;
		if (!b) {
			for (a in c.margins) {
				e[d[a]] = parseFloat(c.getStyle(c.margins[a])) || 0
			}
			return e
		} else {
			return c.addStyles.call(c, b, c.margins)
		}
	},
	translate: function () {
		var a = "webkitTransform" in document.createElement("div").style ? "webkitTransform" : "transform";
		return function (b, d, c) {
			this.dom.style[a] = "translate3d(" + (b || 0) + "px, " + (d || 0) + "px, " + (c || 0) + "px)"
		}
	}()
});
Ext.dom.Element.addMembers({
	getParent: function () {
		return Ext.get(this.dom.parentNode)
	},
	getFirstChild: function () {
		return Ext.get(this.dom.firstElementChild)
	},
	contains: function (a) {
		if (!a) {
			return false
		}
		var b = Ext.getDom(a);
		return (b === this.dom) || this.self.isAncestor(this.dom, b)
	},
	findParent: function (h, g, c) {
		var e = this.dom,
			a = document.body,
			f = 0,
			d;
		g = g || 50;
		if (isNaN(g)) {
			d = Ext.getDom(g);
			g = Number.MAX_VALUE
		}
		while (e && e.nodeType == 1 && f < g && e != a && e != d) {
			if (Ext.DomQuery.is(e, h)) {
				return c ? Ext.get(e) : e
			}
			f++;
			e = e.parentNode
		}
		return null
	},
	findParentNode: function (d, c, a) {
		var b = Ext.fly(this.dom.parentNode, "_internal");
		return b ? b.findParent(d, c, a) : null
	},
	up: function (b, a) {
		return this.findParentNode(b, a, true)
	},
	select: function (a, b) {
		return Ext.dom.Element.select(a, b, this.dom)
	},
	query: function (a) {
		return Ext.DomQuery.select(a, this.dom)
	},
	down: function (a, b) {
		var c = Ext.DomQuery.selectNode(a, this.dom);
		return b ? c : Ext.get(c)
	},
	child: function (a, b) {
		var d, c = this,
			e;
		e = Ext.get(c).id;
		e = e.replace(/[\.:]/g, "\\$0");
		d = Ext.DomQuery.selectNode("#" + e + " > " + a, c.dom);
		return b ? d : Ext.get(d)
	},
	parent: function (a, b) {
		return this.matchNode("parentNode", "parentNode", a, b)
	},
	next: function (a, b) {
		return this.matchNode("nextSibling", "nextSibling", a, b)
	},
	prev: function (a, b) {
		return this.matchNode("previousSibling", "previousSibling", a, b)
	},
	first: function (a, b) {
		return this.matchNode("nextSibling", "firstChild", a, b)
	},
	last: function (a, b) {
		return this.matchNode("previousSibling", "lastChild", a, b)
	},
	matchNode: function (b, e, a, c) {
		if (!this.dom) {
			return null
		}
		var d = this.dom[e];
		while (d) {
			if (d.nodeType == 1 && (!a || Ext.DomQuery.is(d, a))) {
				return !c ? Ext.get(d) : d
			}
			d = d[b]
		}
		return null
	},
	isAncestor: function (a) {
		return this.self.isAncestor.call(this.self, this.dom, a)
	}
});
Ext.define("Ext.dom.CompositeElementLite", {
	alternateClassName: ["Ext.CompositeElementLite", "Ext.CompositeElement"],
	statics: {
		importElementMethods: function () {}
	},
	constructor: function (b, a) {
		this.elements = [];
		this.add(b, a);
		this.el = new Ext.dom.Element.Fly()
	},
	isComposite: true,
	getElement: function (a) {
		return this.el.attach(a).synchronize()
	},
	transformElement: function (a) {
		return Ext.getDom(a)
	},
	getCount: function () {
		return this.elements.length
	},
	add: function (c, a) {
		var e = this.elements,
			b, d;
		if (!c) {
			return this
		}
		if (typeof c == "string") {
			c = Ext.dom.Element.selectorFunction(c, a)
		} else {
			if (c.isComposite) {
				c = c.elements
			} else {
				if (!Ext.isIterable(c)) {
					c = [c]
				}
			}
		}
		for (b = 0, d = c.length; b < d; ++b) {
			e.push(this.transformElement(c[b]))
		}
		return this
	},
	invoke: function (d, a) {
		var f = this.elements,
			e = f.length,
			c, b;
		for (b = 0; b < e; b++) {
			c = f[b];
			if (c) {
				Ext.dom.Element.prototype[d].apply(this.getElement(c), a)
			}
		}
		return this
	},
	item: function (b) {
		var c = this.elements[b],
			a = null;
		if (c) {
			a = this.getElement(c)
		}
		return a
	},
	addListener: function (b, h, g, f) {
		var d = this.elements,
			a = d.length,
			c, j;
		for (c = 0; c < a; c++) {
			j = d[c];
			if (j) {
				j.on(b, h, g || j, f)
			}
		}
		return this
	},
	each: function (f, d) {
		var g = this,
			c = g.elements,
			a = c.length,
			b, h;
		for (b = 0; b < a; b++) {
			h = c[b];
			if (h) {
				h = this.getElement(h);
				if (f.call(d || h, h, g, b) === false) {
					break
				}
			}
		}
		return g
	},
	fill: function (a) {
		var b = this;
		b.elements = [];
		b.add(a);
		return b
	},
	filter: function (a) {
		var b = [],
			d = this,
			c = Ext.isFunction(a) ? a : function (e) {
				return e.is(a)
			};
		d.each(function (g, e, f) {
			if (c(g, f) !== false) {
				b[b.length] = d.transformElement(g)
			}
		});
		d.elements = b;
		return d
	},
	indexOf: function (a) {
		return Ext.Array.indexOf(this.elements, this.transformElement(a))
	},
	replaceElement: function (e, c, a) {
		var b = !isNaN(e) ? e : this.indexOf(e),
			f;
		if (b > -1) {
			c = Ext.getDom(c);
			if (a) {
				f = this.elements[b];
				f.parentNode.insertBefore(c, f);
				Ext.removeNode(f)
			}
			Ext.Array.splice(this.elements, b, 1, c)
		}
		return this
	},
	clear: function () {
		this.elements = []
	},
	addElements: function (c, a) {
		if (!c) {
			return this
		}
		if (typeof c == "string") {
			c = Ext.dom.Element.selectorFunction(c, a)
		}
		var b = this.elements;
		Ext.each(c, function (d) {
			b.push(Ext.get(d))
		});
		return this
	},
	first: function () {
		return this.item(0)
	},
	last: function () {
		return this.item(this.getCount() - 1)
	},
	contains: function (a) {
		return this.indexOf(a) != -1
	},
	removeElement: function (c, e) {
		var b = this,
			d = this.elements,
			a;
		Ext.each(c, function (f) {
			if ((a = (d[f] || d[f = b.indexOf(f)]))) {
				if (e) {
					if (a.dom) {
						a.remove()
					} else {
						Ext.removeNode(a)
					}
				}
				Ext.Array.erase(d, f, 1)
			}
		});
		return this
	}
}, function () {
	var a = Ext.dom.Element,
		d = a.prototype,
		c = this.prototype,
		b;
	for (b in d) {
		if (typeof d[b] == "function") {
			(function (e) {
				c[e] = c[e] ||
				function () {
					return this.invoke(e, arguments)
				}
			}).call(c, b)
		}
	}
	c.on = c.addListener;
	a.selectorFunction = Ext.DomQuery.select;
	Ext.dom.Element.select = function (e, h, f) {
		var g;
		if (typeof e == "string") {
			g = Ext.dom.Element.selectorFunction(e, f)
		} else {
			if (e.length !== undefined) {
				g = e
			} else {}
		}
		return (h === true) ? new Ext.dom.CompositeElement(g) : new Ext.dom.CompositeElementLite(g)
	};
	Ext.select = function () {
		return a.select.apply(a, arguments)
	}
});
Ext.define("Ext.event.ListenerStack", {
	currentOrder: "current",
	length: 0,
	constructor: function () {
		this.listeners = {
			before: [],
			current: [],
			after: []
		};
		this.lateBindingMap = {};
		return this
	},
	add: function (h, j, k, e) {
		var a = this.lateBindingMap,
			g = this.getAll(e),
			f = g.length,
			b, d, c;
		if (typeof h == "string" && j.isIdentifiable) {
			c = j.getId();
			b = a[c];
			if (b) {
				if (b[h]) {
					return false
				} else {
					b[h] = true
				}
			} else {
				a[c] = b = {};
				b[h] = true
			}
		} else {
			if (f > 0) {
				while (f--) {
					d = g[f];
					if (d.fn === h && d.scope === j) {
						d.options = k;
						return false
					}
				}
			}
		}
		d = this.create(h, j, k, e);
		if (k && k.prepend) {
			delete k.prepend;
			g.unshift(d)
		} else {
			g.push(d)
		}
		this.length++;
		return true
	},
	getAt: function (b, a) {
		return this.getAll(a)[b]
	},
	getAll: function (a) {
		if (!a) {
			a = this.currentOrder
		}
		return this.listeners[a]
	},
	count: function (a) {
		return this.getAll(a).length
	},
	create: function (d, c, b, a) {
		return {
			stack: this,
			fn: d,
			firingFn: false,
			boundFn: false,
			isLateBinding: typeof d == "string",
			scope: c,
			options: b || {},
			order: a
		}
	},
	remove: function (h, j, e) {
		var g = this.getAll(e),
			f = g.length,
			b = false,
			a = this.lateBindingMap,
			d, c;
		if (f > 0) {
			while (f--) {
				d = g[f];
				if (d.fn === h && d.scope === j) {
					g.splice(f, 1);
					b = true;
					this.length--;
					if (typeof h == "string" && j.isIdentifiable) {
						c = j.getId();
						if (a[c] && a[c][h]) {
							delete a[c][h]
						}
					}
					break
				}
			}
		}
		return b
	}
});
Ext.define("Ext.event.Controller", {
	isFiring: false,
	listenerStack: null,
	constructor: function (a) {
		this.firingListeners = [];
		this.firingArguments = [];
		this.setInfo(a);
		return this
	},
	setInfo: function (a) {
		this.info = a
	},
	getInfo: function () {
		return this.info
	},
	setListenerStacks: function (a) {
		this.listenerStacks = a
	},
	fire: function (h, e) {
		var n = this.listenerStacks,
			m = this.firingListeners,
			d = this.firingArguments,
			k = m.push,
			g = n.length,
			j, l, c, o, a = false,
			b = false,
			f;
		m.length = 0;
		if (e) {
			if (e.order !== "after") {
				a = true
			} else {
				b = true
			}
		}
		if (g === 1) {
			j = n[0].listeners;
			l = j.before;
			c = j.current;
			o = j.after;
			if (l.length > 0) {
				k.apply(m, l)
			}
			if (a) {
				k.call(m, e)
			}
			if (c.length > 0) {
				k.apply(m, c)
			}
			if (b) {
				k.call(m, e)
			}
			if (o.length > 0) {
				k.apply(m, o)
			}
		} else {
			for (f = 0; f < g; f++) {
				l = n[f].listeners.before;
				if (l.length > 0) {
					k.apply(m, l)
				}
			}
			if (a) {
				k.call(m, e)
			}
			for (f = 0; f < g; f++) {
				c = n[f].listeners.current;
				if (c.length > 0) {
					k.apply(m, c)
				}
			}
			if (b) {
				k.call(m, e)
			}
			for (f = 0; f < g; f++) {
				o = n[f].listeners.after;
				if (o.length > 0) {
					k.apply(m, o)
				}
			}
		}
		if (m.length === 0) {
			return this
		}
		if (!h) {
			h = []
		}
		d.length = 0;
		d.push.apply(d, h);
		d.push(null, this);
		this.doFire();
		return this
	},
	doFire: function () {
		var k = this.firingListeners,
			c = this.firingArguments,
			g = c.length - 2,
			d, f, b, o, h, n, a, j, l, e, m;
		this.isPausing = false;
		this.isPaused = false;
		this.isStopped = false;
		this.isFiring = true;
		for (d = 0, f = k.length; d < f; d++) {
			b = k[d];
			o = b.options;
			h = b.fn;
			n = b.firingFn;
			a = b.boundFn;
			j = b.isLateBinding;
			l = b.scope;
			if (j && a && a !== l[h]) {
				a = false;
				n = false
			}
			if (!a) {
				if (j) {
					a = l[h];
					if (!a) {
						continue
					}
				} else {
					a = h
				}
				b.boundFn = a
			}
			if (!n) {
				n = a;
				if (o.buffer) {
					n = Ext.Function.createBuffered(n, o.buffer, l)
				}
				if (o.delay) {
					n = Ext.Function.createDelayed(n, o.delay, l)
				}
				b.firingFn = n
			}
			c[g] = o;
			e = c;
			if (o.args) {
				e = o.args.concat(e)
			}
			if (o.single === true) {
				b.stack.remove(h, l, b.order)
			}
			m = n.apply(l, e);
			if (m === false) {
				this.stop()
			}
			if (this.isStopped) {
				break
			}
			if (this.isPausing) {
				this.isPaused = true;
				k.splice(0, d + 1);
				return
			}
		}
		this.isFiring = false;
		this.listenerStacks = null;
		k.length = 0;
		c.length = 0;
		this.connectingController = null
	},
	connect: function (a) {
		this.connectingController = a
	},
	resume: function () {
		var a = this.connectingController;
		this.isPausing = false;
		if (this.isPaused && this.firingListeners.length > 0) {
			this.isPaused = false;
			this.doFire()
		}
		if (a) {
			a.resume()
		}
		return this
	},
	isInterrupted: function () {
		return this.isStopped || this.isPaused
	},
	stop: function () {
		var a = this.connectingController;
		this.isStopped = true;
		if (a) {
			this.connectingController = null;
			a.stop()
		}
		this.isFiring = false;
		this.listenerStacks = null;
		return this
	},
	pause: function () {
		var a = this.connectingController;
		this.isPausing = true;
		if (a) {
			a.pause()
		}
		return this
	}
});
Ext.define("Ext.event.Dispatcher", {
	statics: {
		getInstance: function () {
			if (!this.instance) {
				this.instance = new this()
			}
			return this.instance
		},
		setInstance: function (a) {
			this.instance = a;
			return this
		}
	},
	config: {
		publishers: {}
	},
	wildcard: "*",
	constructor: function (a) {
		this.listenerStacks = {};
		this.activePublishers = {};
		this.publishersCache = {};
		this.noActivePublishers = [];
		this.controller = null;
		this.initConfig(a);
		return this
	},
	getListenerStack: function (e, g, c, b) {
		var d = this.listenerStacks,
			f = d[e],
			a;
		b = Boolean(b);
		if (!f) {
			if (b) {
				d[e] = f = {}
			} else {
				return null
			}
		}
		f = f[g];
		if (!f) {
			if (b) {
				d[e][g] = f = {}
			} else {
				return null
			}
		}
		a = f[c];
		if (!a) {
			if (b) {
				f[c] = a = new Ext.event.ListenerStack()
			} else {
				return null
			}
		}
		return a
	},
	getController: function (d, f, c, b) {
		var a = this.controller,
			e = {
				targetType: d,
				target: f,
				eventName: c
			};
		if (!a) {
			this.controller = a = new Ext.event.Controller()
		}
		if (a.isFiring) {
			a = new Ext.event.Controller()
		}
		a.setInfo(e);
		if (b && a !== b) {
			a.connect(b)
		}
		return a
	},
	applyPublishers: function (c) {
		var a, b;
		this.publishersCache = {};
		for (a in c) {
			if (c.hasOwnProperty(a)) {
				b = c[a];
				this.registerPublisher(b)
			}
		}
		return c
	},
	registerPublisher: function (b) {
		var a = this.activePublishers,
			c = b.getTargetType(),
			d = a[c];
		if (!d) {
			a[c] = d = []
		}
		d.push(b);
		b.setDispatcher(this);
		return this
	},
	getCachedActivePublishers: function (c, b) {
		var a = this.publishersCache,
			d;
		if ((d = a[c]) && (d = d[b])) {
			return d
		}
		return null
	},
	cacheActivePublishers: function (c, b, d) {
		var a = this.publishersCache;
		if (!a[c]) {
			a[c] = {}
		}
		a[c][b] = d;
		return d
	},
	getActivePublishers: function (f, b) {
		var g, a, c, e, d;
		if ((g = this.getCachedActivePublishers(f, b))) {
			return g
		}
		a = this.activePublishers[f];
		if (a) {
			g = [];
			for (c = 0, e = a.length; c < e; c++) {
				d = a[c];
				if (d.handles(b)) {
					g.push(d)
				}
			}
		} else {
			g = this.noActivePublishers
		}
		return this.cacheActivePublishers(f, b, g)
	},
	hasListener: function (c, d, b) {
		var a = this.getListenerStack(c, d, b);
		if (a) {
			return a.count() > 0
		}
		return false
	},
	addListener: function (e, f, b) {
		var g = this.getActivePublishers(e, b),
			d = g.length,
			c, a;
		a = this.doAddListener.apply(this, arguments);
		if (a && d > 0) {
			for (c = 0; c < d; c++) {
				g[c].subscribe(f, b)
			}
		}
		return a
	},
	doAddListener: function (g, h, c, f, e, d, a) {
		var b = this.getListenerStack(g, h, c, true);
		return b.add(f, e, d, a)
	},
	removeListener: function (e, f, b) {
		var g = this.getActivePublishers(e, b),
			d = g.length,
			c, a;
		a = this.doRemoveListener.apply(this, arguments);
		if (a && d > 0) {
			for (c = 0; c < d; c++) {
				g[c].unsubscribe(f, b)
			}
		}
		return a
	},
	doRemoveListener: function (f, g, c, e, d, a) {
		var b = this.getListenerStack(f, g, c);
		if (b === null) {
			return false
		}
		return b.remove(e, d, a)
	},
	clearListeners: function (a, e, d) {
		var j = this.listenerStacks,
			f = arguments.length,
			b, h, c, g;
		if (f === 3) {
			if (j[a] && j[a][e]) {
				this.removeListener(a, e, d);
				delete j[a][e][d]
			}
		} else {
			if (f === 2) {
				if (j[a]) {
					b = j[a][e];
					if (b) {
						for (d in b) {
							if (b.hasOwnProperty(d)) {
								h = this.getActivePublishers(a, d);
								for (c = 0, f = h.length; c < f; c++) {
									h[c].unsubscribe(e, d, true)
								}
							}
						}
						delete j[a][e]
					}
				}
			} else {
				if (f === 1) {
					h = this.activePublishers[a];
					for (c = 0, f = h.length; c < f; c++) {
						h[c].unsubscribeAll()
					}
					delete j[a]
				} else {
					h = this.activePublishers;
					for (a in h) {
						if (h.hasOwnProperty(a)) {
							g = h[a];
							for (c = 0, f = g.length; c < f; c++) {
								g[c].unsubscribeAll()
							}
						}
					}
					delete this.listenerStacks;
					this.listenerStacks = {}
				}
			}
		}
		return this
	},
	dispatchEvent: function (d, e, a) {
		var f = this.getActivePublishers(d, a),
			c = f.length,
			b;
		if (c > 0) {
			for (b = 0; b < c; b++) {
				f[b].notify(e, a)
			}
		}
		return this.doDispatchEvent.apply(this, arguments)
	},
	doDispatchEvent: function (a, g, f, j, c, b) {
		var h = this.getListenerStack(a, g, f),
			d = this.getWildcardListenerStacks(a, g, f),
			e;
		if ((h === null || h.length == 0)) {
			if (d.length == 0 && !c) {
				return
			}
		} else {
			d.push(h)
		}
		e = this.getController(a, g, f, b);
		e.setListenerStacks(d);
		e.fire(j, c);
		return !e.isInterrupted()
	},
	getWildcardListenerStacks: function (g, h, d) {
		var f = [],
			b = this.wildcard,
			c = d !== b,
			e = h !== b,
			a;
		if (c && (a = this.getListenerStack(g, h, b))) {
			f.push(a)
		}
		if (e && (a = this.getListenerStack(g, b, d))) {
			f.push(a)
		}
		return f
	},
	getPublisher: function (a) {
		return this.getPublishers()[a]
	}
});
Ext.define("Ext.mixin.Mixin", {
	onClassExtended: function (b, e) {
		var a = e.mixinConfig,
			d, f, c;
		if (a) {
			d = b.superclass.mixinConfig;
			if (d) {
				a = e.mixinConfig = Ext.merge({}, d, a)
			}
			e.mixinId = a.id;
			f = a.beforeHooks;
			c = a.hooks || a.afterHooks;
			if (f || c) {
				Ext.Function.interceptBefore(e, "onClassMixedIn", function (h) {
					var g = this.prototype;
					if (f) {
						Ext.Object.each(f, function (k, j) {
							h.override(j, function () {
								if (g[k].apply(this, arguments) !== false) {
									return this.callOverridden(arguments)
								}
							})
						})
					}
					if (c) {
						Ext.Object.each(c, function (k, j) {
							h.override(j, function () {
								var l = this.callOverridden(arguments);
								g[k].apply(this, arguments);
								return l
							})
						})
					}
				})
			}
		}
	}
});
Ext.define("Ext.mixin.Observable", {
	extend: Ext.mixin.Mixin,
	mixins: [Ext.mixin.Identifiable],
	mixinConfig: {
		id: "observable",
		hooks: {
			destroy: "destroy"
		}
	},
	alternateClassName: "Ext.util.Observable",
	isObservable: true,
	observableType: "observable",
	validIdRegex: /^([\w\-]+)$/,
	observableIdPrefix: "#",
	listenerOptionsRegex: /^(?:delegate|single|delay|buffer|args|prepend)$/,
	eventFiringSuspended: false,
	config: {
		listeners: null,
		bubbleEvents: null
	},
	constructor: function (a) {
		this.initConfig(a)
	},
	applyListeners: function (a) {
		if (a) {
			this.addListener(a)
		}
	},
	applyBubbleEvents: function (a) {
		if (a) {
			this.enableBubble(a)
		}
	},
	getOptimizedObservableId: function () {
		return this.observableId
	},
	getObservableId: function () {
		if (!this.observableId) {
			var a = this.getUniqueId();
			this.observableId = this.observableIdPrefix + a;
			this.getObservableId = this.getOptimizedObservableId
		}
		return this.observableId
	},
	getOptimizedEventDispatcher: function () {
		return this.eventDispatcher
	},
	getEventDispatcher: function () {
		if (!this.eventDispatcher) {
			this.eventDispatcher = Ext.event.Dispatcher.getInstance();
			this.getEventDispatcher = this.getOptimizedEventDispatcher;
			this.getListeners();
			this.getBubbleEvents()
		}
		return this.eventDispatcher
	},
	getManagedListeners: function (c, b) {
		var d = c.getUniqueId(),
			a = this.managedListeners;
		if (!a) {
			this.managedListeners = a = {}
		}
		if (!a[d]) {
			a[d] = {};
			c.doAddListener("destroy", "clearManagedListeners", this, {
				single: true,
				args: [c]
			})
		}
		if (!a[d][b]) {
			a[d][b] = []
		}
		return a[d][b]
	},
	getUsedSelectors: function () {
		var a = this.usedSelectors;
		if (!a) {
			a = this.usedSelectors = [];
			a.$map = {}
		}
		return a
	},
	fireEvent: function (a) {
		var b = Array.prototype.slice.call(arguments, 1);
		return this.doFireEvent(a, b)
	},
	fireAction: function (c, e, g, f, d, a) {
		var b = typeof g,
			h;
		if (e === undefined) {
			e = []
		}
		if (b != "undefined") {
			h = {
				fn: g,
				isLateBinding: b == "string",
				scope: f || this,
				options: d || {},
				order: a
			}
		}
		return this.doFireEvent(c, e, h)
	},
	doFireEvent: function (c, e, g, a) {
		var f = this,
			d = true,
			b;
		if (f.eventFiringSuspended) {
			b = f.eventQueue;
			if (!b) {
				f.eventQueue = b = []
			}
			b.push([c, e, g, a])
		} else {
			d = f.getEventDispatcher().dispatchEvent(f.observableType, f.getObservableId(), c, e, g, a)
		}
		return d
	},
	doAddListener: function (a, j, l, m, c) {
		var e = (l && l !== this && l.isIdentifiable),
			b = this.getUsedSelectors(),
			f = b.$map,
			d = this.getObservableId(),
			g, k, h;
		if (!m) {
			m = {}
		}
		if (!l) {
			l = this
		}
		if (m.delegate) {
			h = m.delegate;
			d += " " + h
		}
		if (!(d in f)) {
			f[d] = true;
			b.push(d)
		}
		g = this.addDispatcherListener(d, a, j, l, m, c);
		if (g && e) {
			k = this.getManagedListeners(l, a);
			k.push({
				delegate: h,
				scope: l,
				fn: j,
				order: c
			})
		}
		return g
	},
	addDispatcherListener: function (b, d, f, e, c, a) {
		return this.getEventDispatcher().addListener(this.observableType, b, d, f, e, c, a)
	},
	doRemoveListener: function (b, k, m, n, d) {
		var g = (m && m !== this && m.isIdentifiable),
			e = this.getObservableId(),
			a, l, f, h, c, j;
		if (n && n.delegate) {
			j = n.delegate;
			e += " " + j
		}
		if (!m) {
			m = this
		}
		a = this.removeDispatcherListener(e, b, k, m, d);
		if (a && g) {
			l = this.getManagedListeners(m, b);
			for (f = 0, h = l.length; f < h; f++) {
				c = l[f];
				if (c.fn === k && c.scope === m && c.delegate === j && c.order === d) {
					l.splice(f, 1);
					break
				}
			}
		}
		return a
	},
	removeDispatcherListener: function (b, c, e, d, a) {
		return this.getEventDispatcher().removeListener(this.observableType, b, c, e, d, a)
	},
	clearManagedListeners: function (d) {
		var j = this.managedListeners,
			a, c, h, f, e, g, b, k;
		if (!j) {
			return this
		}
		if (d) {
			if (typeof d != "string") {
				a = d.getUniqueId()
			} else {
				a = d
			}
			c = j[a];
			for (f in c) {
				if (c.hasOwnProperty(f)) {
					h = c[f];
					for (e = 0, g = h.length; e < g; e++) {
						b = h[e];
						k = {};
						if (b.delegate) {
							k.delegate = b.delegate
						}
						if (this.doRemoveListener(f, b.fn, b.scope, k, b.order)) {
							e--;
							g--
						}
					}
				}
			}
			delete j[a];
			return this
		}
		for (a in j) {
			if (j.hasOwnProperty(a)) {
				this.clearManagedListeners(a)
			}
		}
	},
	changeListener: function (l, h, n, p, q, d) {
		var b, m, g, j, a, o, f, k, c, e;
		if (typeof n != "undefined") {
			if (typeof h != "string") {
				for (f = 0, k = h.length; f < k; f++) {
					a = h[f];
					l.call(this, a, n, p, q, d)
				}
				return this
			}
			l.call(this, h, n, p, q, d)
		} else {
			if (Ext.isArray(h)) {
				m = h;
				for (f = 0, k = m.length; f < k; f++) {
					c = m[f];
					l.call(this, c.event, c.fn, c.scope, c, c.order)
				}
			} else {
				g = this.listenerOptionsRegex;
				q = h;
				b = [];
				m = [];
				j = {};
				for (a in q) {
					o = q[a];
					if (a === "scope") {
						p = o;
						continue
					} else {
						if (a === "order") {
							d = o;
							continue
						}
					}
					if (!g.test(a)) {
						e = typeof o;
						if (e != "string" && e != "function") {
							l.call(this, a, o.fn, o.scope || p, o, o.order || d);
							continue
						}
						b.push(a);
						m.push(o)
					} else {
						j[a] = o
					}
				}
				for (f = 0, k = b.length; f < k; f++) {
					l.call(this, b[f], m[f], p, j, d)
				}
			}
		}
		return this
	},
	addListener: function (b, e, d, c, a) {
		return this.changeListener(this.doAddListener, b, e, d, c, a)
	},
	toggleListener: function (b, c, f, e, d, a) {
		return this.changeListener(b ? this.doAddListener : this.doRemoveListener, c, f, e, d, a)
	},
	addBeforeListener: function (a, d, c, b) {
		return this.addListener(a, d, c, b, "before")
	},
	addAfterListener: function (a, d, c, b) {
		return this.addListener(a, d, c, b, "after")
	},
	removeListener: function (b, e, d, c, a) {
		return this.changeListener(this.doRemoveListener, b, e, d, c, a)
	},
	removeBeforeListener: function (a, d, c, b) {
		return this.removeListener(a, d, c, b, "before")
	},
	removeAfterListener: function (a, d, c, b) {
		return this.removeListener(a, d, c, b, "after")
	},
	clearListeners: function () {
		var e = this.getUsedSelectors(),
			c = this.getEventDispatcher(),
			b, d, a;
		for (b = 0, d = e.length; b < d; b++) {
			a = e[b];
			c.clearListeners(this.observableType, a)
		}
	},
	hasListener: function (a) {
		return this.getEventDispatcher().hasListener(this.observableType, this.getObservableId(), a)
	},
	suspendEvents: function () {
		this.eventFiringSuspended = true
	},
	resumeEvents: function (e) {
		var d = this,
			a = d.eventQueue || [],
			b, c;
		d.eventFiringSuspended = false;
		if (!e) {
			for (b = 0, c = a.length; b < c; b++) {
				d.doFireEvent.apply(d, a[b])
			}
		}
		d.eventQueue = []
	},
	relayEvents: function (b, d, g) {
		var c, f, e, a;
		if (typeof g == "undefined") {
			g = ""
		}
		if (typeof d == "string") {
			d = [d]
		}
		if (Ext.isArray(d)) {
			for (c = 0, f = d.length; c < f; c++) {
				e = d[c];
				a = g + e;
				b.addListener(e, this.createEventRelayer(a), this)
			}
		} else {
			for (e in d) {
				if (d.hasOwnProperty(e)) {
					a = g + d[e];
					b.addListener(e, this.createEventRelayer(a), this)
				}
			}
		}
		return this
	},
	relayEvent: function (e, f, h, j, a) {
		var g = typeof f,
			c = e[e.length - 1],
			d = c.getInfo().eventName,
			b;
		e = Array.prototype.slice.call(e, 0, -2);
		e[0] = this;
		if (g != "undefined") {
			b = {
				fn: f,
				scope: h || this,
				options: j || {},
				order: a,
				isLateBinding: g == "string"
			}
		}
		return this.doFireEvent(d, e, b, c)
	},
	createEventRelayer: function (a) {
		return function () {
			return this.doFireEvent(a, Array.prototype.slice.call(arguments, 0, -2))
		}
	},
	enableBubble: function (d) {
		var a = this.isBubblingEnabled,
			c, e, b;
		if (!a) {
			a = this.isBubblingEnabled = {}
		}
		if (typeof d == "string") {
			d = Ext.Array.clone(arguments)
		}
		for (c = 0, e = d.length; c < e; c++) {
			b = d[c];
			if (!a[b]) {
				a[b] = true;
				this.addListener(b, this.createEventBubbler(b), this)
			}
		}
	},
	createEventBubbler: function (a) {
		return function b() {
			var c = ("getBubbleTarget" in this) ? this.getBubbleTarget() : null;
			if (c && c !== this && c.isObservable) {
				c.fireAction(a, Array.prototype.slice.call(arguments, 0, -2), b, c, null, "after")
			}
		}
	},
	getBubbleTarget: function () {
		return false
	},
	destroy: function () {
		if (this.observableId) {
			this.fireEvent("destroy", this);
			this.clearListeners();
			this.clearManagedListeners()
		}
	},
	addEvents: Ext.emptyFn
}, function () {
	this.createAlias({
		on: "addListener",
		un: "removeListener",
		onBefore: "addBeforeListener",
		onAfter: "addAfterListener",
		unBefore: "removeBeforeListener",
		unAfter: "removeAfterListener"
	})
});
Ext.define("Ext.Evented", {
	alternateClassName: "Ext.EventedBase",
	mixins: [Ext.mixin.Observable],
	statics: {
		generateSetter: function (e) {
			var c = e.internal,
				b = e.apply,
				a = e.changeEvent,
				d = e.doSet;
			return function (h) {
				var j = this.initialized,
					g = this[c],
					f = this[b];
				if (f) {
					h = f.call(this, h, g);
					if (typeof h == "undefined") {
						return this
					}
				}
				g = this[c];
				if (h !== g) {
					if (j) {
						this.fireAction(a, [this, h, g], this.doSet, this, {
							nameMap: e
						})
					} else {
						this[c] = h;
						if (this[d]) {
							this[d].call(this, h, g)
						}
					}
				}
				return this
			}
		}
	},
	initialized: false,
	constructor: function (a) {
		this.initialConfig = a;
		this.initialize()
	},
	initialize: function () {
		this.initConfig(this.initialConfig);
		this.initialized = true
	},
	doSet: function (c, d, b, a) {
		var e = a.nameMap;
		c[e.internal] = d;
		if (c[e.doSet]) {
			c[e.doSet].call(this, d, b)
		}
	},
	onClassExtended: function (a, e) {
		if (!e.hasOwnProperty("eventedConfig")) {
			return
		}
		var d = Ext.Class,
			c = e.config,
			g = e.eventedConfig,
			b, f;
		e.config = (c) ? Ext.applyIf(c, g) : g;
		for (b in g) {
			if (g.hasOwnProperty(b)) {
				f = d.getConfigNameMap(b);
				e[f.set] = this.generateSetter(f)
			}
		}
	}
});
Ext.define("Ext.AbstractComponent", {
	extend: Ext.Evented,
	onClassExtended: function (b, f) {
		if (!f.hasOwnProperty("cachedConfig")) {
			return
		}
		var g = b.prototype,
			c = f.config,
			e = f.cachedConfig,
			d = g.cachedConfigList,
			j = g.hasCachedConfig,
			a, h;
		delete f.cachedConfig;
		g.cachedConfigList = d = (d) ? d.slice() : [];
		g.hasCachedConfig = j = (j) ? Ext.Object.chain(j) : {};
		if (!c) {
			f.config = c = {}
		}
		for (a in e) {
			if (e.hasOwnProperty(a)) {
				h = e[a];
				if (!j[a]) {
					j[a] = true;
					d.push(a)
				}
				c[a] = h
			}
		}
	},
	getElementConfig: Ext.emptyFn,
	referenceAttributeName: "reference",
	referenceSelector: "[reference]",
	addReferenceNode: function (a, b) {
		Ext.Object.defineProperty(this, a, {
			get: function () {
				var c;
				delete this[a];
				this[a] = c = new Ext.Element(b);
				return c
			},
			configurable: true
		})
	},
	initElement: function () {
		var k = this.self.prototype,
			n = this.getId(),
			s = [],
			g = true,
			x = this.referenceAttributeName,
			p = false,
			e, v, b, o, t, d, l, c, f, j, w, m, a, q, h, y, u, r;
		if (k.hasOwnProperty("renderTemplate")) {
			e = this.renderTemplate.cloneNode(true);
			v = e.firstChild
		} else {
			g = false;
			p = true;
			e = document.createDocumentFragment();
			v = Ext.Element.create(this.getElementConfig(), true);
			e.appendChild(v)
		}
		o = e.querySelectorAll(this.referenceSelector);
		for (t = 0, d = o.length; t < d; t++) {
			l = o[t];
			c = l.getAttribute(x);
			if (g) {
				l.removeAttribute(x)
			}
			if (c == "element") {
				l.id = n;
				this.element = b = new Ext.Element(l)
			} else {
				this.addReferenceNode(c, l)
			}
			s.push(c)
		}
		this.referenceList = s;
		if (!this.innerElement) {
			this.innerElement = b
		}
		if (!this.bodyElement) {
			this.bodyElement = this.innerElement
		}
		if (v === b.dom) {
			this.renderElement = b
		} else {
			this.addReferenceNode("renderElement", v)
		}
		if (p) {
			f = Ext.Class.configNameCache;
			j = this.config;
			w = this.cachedConfigList;
			m = this.initConfigList;
			a = this.initConfigMap;
			q = [];
			for (t = 0, d = w.length; t < d; t++) {
				y = w[t];
				u = f[y];
				if (a[y]) {
					a[y] = false;
					Ext.Array.remove(m, y)
				}
				if (j[y] !== null) {
					q.push(y);
					this[u.get] = this[u.initGet]
				}
			}
			for (t = 0, d = q.length; t < d; t++) {
				y = q[t];
				u = f[y];
				r = u.internal;
				this[r] = null;
				this[u.set].call(this, j[y]);
				delete this[u.get];
				k[r] = this[r]
			}
			v = this.renderElement.dom;
			k.renderTemplate = e = document.createDocumentFragment();
			e.appendChild(v.cloneNode(true));
			h = e.querySelectorAll("[id]");
			for (t = 0, d = h.length; t < d; t++) {
				b = h[t];
				b.removeAttribute("id")
			}
			for (t = 0, d = s.length; t < d; t++) {
				c = s[t];
				this[c].dom.removeAttribute("reference")
			}
		}
		return this
	}
});
Ext.define("Ext.util.HashMap", {
	mixins: {
		observable: Ext.mixin.Observable
	},
	constructor: function (a) {
		this.callParent();
		this.mixins.observable.constructor.call(this);
		this.clear(true)
	},
	getCount: function () {
		return this.length
	},
	getData: function (a, b) {
		if (b === undefined) {
			b = a;
			a = this.getKey(b)
		}
		return [a, b]
	},
	getKey: function (a) {
		return a.id
	},
	add: function (a, d) {
		var b = this,
			c;
		if (b.containsKey(a)) {
			throw new Error("This key already exists in the HashMap")
		}
		c = this.getData(a, d);
		a = c[0];
		d = c[1];
		b.map[a] = d;
		++b.length;
		b.fireEvent("add", b, a, d);
		return d
	},
	replace: function (b, d) {
		var c = this,
			e = c.map,
			a;
		if (!c.containsKey(b)) {
			c.add(b, d)
		}
		a = e[b];
		e[b] = d;
		c.fireEvent("replace", c, b, d, a);
		return d
	},
	remove: function (b) {
		var a = this.findKey(b);
		if (a !== undefined) {
			return this.removeByKey(a)
		}
		return false
	},
	removeByKey: function (a) {
		var b = this,
			c;
		if (b.containsKey(a)) {
			c = b.map[a];
			delete b.map[a];
			--b.length;
			b.fireEvent("remove", b, a, c);
			return true
		}
		return false
	},
	get: function (a) {
		return this.map[a]
	},
	clear: function (a) {
		var b = this;
		b.map = {};
		b.length = 0;
		if (a !== true) {
			b.fireEvent("clear", b)
		}
		return b
	},
	containsKey: function (a) {
		return this.map[a] !== undefined
	},
	contains: function (a) {
		return this.containsKey(this.findKey(a))
	},
	getKeys: function () {
		return this.getArray(true)
	},
	getValues: function () {
		return this.getArray(false)
	},
	getArray: function (d) {
		var a = [],
			b, c = this.map;
		for (b in c) {
			if (c.hasOwnProperty(b)) {
				a.push(d ? b : c[b])
			}
		}
		return a
	},
	each: function (d, c) {
		var a = Ext.apply({}, this.map),
			b, e = this.length;
		c = c || this;
		for (b in a) {
			if (a.hasOwnProperty(b)) {
				if (d.call(c, b, a[b], e) === false) {
					break
				}
			}
		}
		return this
	},
	clone: function () {
		var c = new Ext.util.HashMap(),
			b = this.map,
			a;
		c.suspendEvents();
		for (a in b) {
			if (b.hasOwnProperty(a)) {
				c.add(a, b[a])
			}
		}
		c.resumeEvents();
		return c
	},
	findKey: function (b) {
		var a, c = this.map;
		for (a in c) {
			if (c.hasOwnProperty(a) && c[a] === b) {
				return a
			}
		}
		return undefined
	}
});
Ext.define("Ext.AbstractManager", {
	typeName: "type",
	constructor: function (a) {
		Ext.apply(this, a || {});
		this.all = Ext.create("Ext.util.HashMap");
		this.types = {}
	},
	get: function (a) {
		return this.all.get(a)
	},
	register: function (a) {
		this.all.add(a)
	},
	unregister: function (a) {
		this.all.remove(a)
	},
	registerType: function (b, a) {
		this.types[b] = a;
		a[this.typeName] = b
	},
	isRegistered: function (a) {
		return this.types[a] !== undefined
	},
	create: function (a, d) {
		var b = a[this.typeName] || a.type || d,
			c = this.types[b];
		return new c(a)
	},
	onAvailable: function (e, c, b) {
		var a = this.all,
			d;
		if (a.containsKey(e)) {
			d = a.get(e);
			c.call(b || d, d)
		} else {
			a.on("add", function (h, f, g) {
				if (f == e) {
					c.call(b || g, g);
					a.un("add", c, b)
				}
			})
		}
	},
	each: function (b, a) {
		this.all.each(b, a || this)
	},
	getCount: function () {
		return this.all.getCount()
	}
});
Ext.define("Ext.mixin.Traversable", {
	extend: Ext.mixin.Mixin,
	mixinConfig: {
		id: "traversable"
	},
	setParent: function (a) {
		this.parent = a;
		return this
	},
	hasParent: function () {
		return Boolean(this.parent)
	},
	getParent: function () {
		return this.parent
	},
	getAncestors: function () {
		var b = [],
			a = this.getParent();
		while (a) {
			b.push(a);
			a = a.getParent()
		}
		return b
	},
	getAncestorIds: function () {
		var b = [],
			a = this.getParent();
		while (a) {
			b.push(a.getId());
			a = a.getParent()
		}
		return b
	}
});
Ext.define("Ext.ComponentManager", {
	alternateClassName: "Ext.ComponentMgr",
	singleton: true,
	constructor: function () {
		var a = {};
		this.all = {
			map: a,
			getArray: function () {
				var b = [],
					c;
				for (c in a) {
					b.push(a[c])
				}
				return b
			}
		};
		this.map = a
	},
	register: function (a) {
		var b = a.getId();
		this.map[a.getId()] = a
	},
	unregister: function (a) {
		delete this.map[a.getId()]
	},
	isRegistered: function (a) {
		return this.map[a] !== undefined
	},
	get: function (a) {
		return this.map[a]
	},
	create: function (a, c) {
		if (a.isComponent) {
			return a
		} else {
			if (Ext.isString(a)) {
				return Ext.createByAlias("widget." + a)
			} else {
				var b = a.xtype || c;
				return Ext.createByAlias("widget." + b, a)
			}
		}
	},
	registerType: Ext.emptyFn
});
(function () {
	function b(d) {
		var c = Array.prototype.slice.call(arguments, 1);
		return d.replace(/\{(\d+)\}/g, function (e, f) {
			return c[f]
		})
	}
	Ext.DateExtras = {
		now: Date.now ||
		function () {
			return +new Date()
		},
		getElapsed: function (d, c) {
			return Math.abs(d - (c || new Date()))
		},
		useStrict: false,
		formatCodeToRegex: function (d, c) {
			var e = a.parseCodes[d];
			if (e) {
				e = typeof e == "function" ? e() : e;
				a.parseCodes[d] = e
			}
			return e ? Ext.applyIf({
				c: e.c ? b(e.c, c || "{0}") : e.c
			}, e) : {
				g: 0,
				c: null,
				s: Ext.String.escapeRegex(d)
			}
		},
		parseFunctions: {
			MS: function (d, c) {
				var e = new RegExp("\\\\?/Date\\(([-+])?(\\d+)(?:[+-]\\d{4})?\\)\\\\?/");
				var f = (d || "").match(e);
				return f ? new Date(((f[1] || "") + f[2]) * 1) : null
			}
		},
		parseRegexes: [],
		formatFunctions: {
			MS: function () {
				return "\\/Date(" + this.getTime() + ")\\/"
			}
		},
		y2kYear: 50,
		MILLI: "ms",
		SECOND: "s",
		MINUTE: "mi",
		HOUR: "h",
		DAY: "d",
		MONTH: "mo",
		YEAR: "y",
		defaults: {},
		dayNames: ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"],
		monthNames: ["January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"],
		monthNumbers: {
			Jan: 0,
			Feb: 1,
			Mar: 2,
			Apr: 3,
			May: 4,
			Jun: 5,
			Jul: 6,
			Aug: 7,
			Sep: 8,
			Oct: 9,
			Nov: 10,
			Dec: 11
		},
		defaultFormat: "m/d/Y",
		getShortMonthName: function (c) {
			return a.monthNames[c].substring(0, 3)
		},
		getShortDayName: function (c) {
			return a.dayNames[c].substring(0, 3)
		},
		getMonthNumber: function (c) {
			return a.monthNumbers[c.substring(0, 1).toUpperCase() + c.substring(1, 3).toLowerCase()]
		},
		formatCodes: {
			d: "Ext.String.leftPad(this.getDate(), 2, '0')",
			D: "Ext.Date.getShortDayName(this.getDay())",
			j: "this.getDate()",
			l: "Ext.Date.dayNames[this.getDay()]",
			N: "(this.getDay() ? this.getDay() : 7)",
			S: "Ext.Date.getSuffix(this)",
			w: "this.getDay()",
			z: "Ext.Date.getDayOfYear(this)",
			W: "Ext.String.leftPad(Ext.Date.getWeekOfYear(this), 2, '0')",
			F: "Ext.Date.monthNames[this.getMonth()]",
			m: "Ext.String.leftPad(this.getMonth() + 1, 2, '0')",
			M: "Ext.Date.getShortMonthName(this.getMonth())",
			n: "(this.getMonth() + 1)",
			t: "Ext.Date.getDaysInMonth(this)",
			L: "(Ext.Date.isLeapYear(this) ? 1 : 0)",
			o: "(this.getFullYear() + (Ext.Date.getWeekOfYear(this) == 1 && this.getMonth() > 0 ? +1 : (Ext.Date.getWeekOfYear(this) >= 52 && this.getMonth() < 11 ? -1 : 0)))",
			Y: "Ext.String.leftPad(this.getFullYear(), 4, '0')",
			y: "('' + this.getFullYear()).substring(2, 4)",
			a: "(this.getHours() < 12 ? 'am' : 'pm')",
			A: "(this.getHours() < 12 ? 'AM' : 'PM')",
			g: "((this.getHours() % 12) ? this.getHours() % 12 : 12)",
			G: "this.getHours()",
			h: "Ext.String.leftPad((this.getHours() % 12) ? this.getHours() % 12 : 12, 2, '0')",
			H: "Ext.String.leftPad(this.getHours(), 2, '0')",
			i: "Ext.String.leftPad(this.getMinutes(), 2, '0')",
			s: "Ext.String.leftPad(this.getSeconds(), 2, '0')",
			u: "Ext.String.leftPad(this.getMilliseconds(), 3, '0')",
			O: "Ext.Date.getGMTOffset(this)",
			P: "Ext.Date.getGMTOffset(this, true)",
			T: "Ext.Date.getTimezone(this)",
			Z: "(this.getTimezoneOffset() * -60)",
			c: function () {
				for (var j = "Y-m-dTH:i:sP", g = [], f = 0, d = j.length; f < d; ++f) {
					var h = j.charAt(f);
					g.push(h == "T" ? "'T'" : a.getFormatCode(h))
				}
				return g.join(" + ")
			},
			U: "Math.round(this.getTime() / 1000)"
		},
		isValid: function (n, c, l, j, f, g, e) {
			j = j || 0;
			f = f || 0;
			g = g || 0;
			e = e || 0;
			var k = a.add(new Date(n < 100 ? 100 : n, c - 1, l, j, f, g, e), a.YEAR, n < 100 ? n - 100 : 0);
			return n == k.getFullYear() && c == k.getMonth() + 1 && l == k.getDate() && j == k.getHours() && f == k.getMinutes() && g == k.getSeconds() && e == k.getMilliseconds()
		},
		parse: function (d, f, c) {
			var e = a.parseFunctions;
			if (e[f] == null) {
				a.createParser(f)
			}
			return e[f](d, Ext.isDefined(c) ? c : a.useStrict)
		},
		parseDate: function (d, e, c) {
			return a.parse(d, e, c)
		},
		getFormatCode: function (d) {
			var c = a.formatCodes[d];
			if (c) {
				c = typeof c == "function" ? c() : c;
				a.formatCodes[d] = c
			}
			return c || ("'" + Ext.String.escape(d) + "'")
		},
		createFormat: function (g) {
			var f = [],
				c = false,
				e = "";
			for (var d = 0; d < g.length; ++d) {
				e = g.charAt(d);
				if (!c && e == "\\") {
					c = true
				} else {
					if (c) {
						c = false;
						f.push("'" + Ext.String.escape(e) + "'")
					} else {
						if (e == "\n") {
							f.push(Ext.JSON.encode(e))
						} else {
							f.push(a.getFormatCode(e))
						}
					}
				}
			}
			a.formatFunctions[g] = Ext.functionFactory("return " + f.join("+"))
		},
		createParser: (function () {
			var c = ["var dt, y, m, d, h, i, s, ms, o, z, zz, u, v,", "def = Ext.Date.defaults,", "results = String(input).match(Ext.Date.parseRegexes[{0}]);", "if(results){", "{1}", "if(u != null){", "v = new Date(u * 1000);", "}else{", "dt = Ext.Date.clearTime(new Date);", "y = Ext.Number.from(y, Ext.Number.from(def.y, dt.getFullYear()));", "m = Ext.Number.from(m, Ext.Number.from(def.m - 1, dt.getMonth()));", "d = Ext.Number.from(d, Ext.Number.from(def.d, dt.getDate()));", "h  = Ext.Number.from(h, Ext.Number.from(def.h, dt.getHours()));", "i  = Ext.Number.from(i, Ext.Number.from(def.i, dt.getMinutes()));", "s  = Ext.Number.from(s, Ext.Number.from(def.s, dt.getSeconds()));", "ms = Ext.Number.from(ms, Ext.Number.from(def.ms, dt.getMilliseconds()));", "if(z >= 0 && y >= 0){", "v = Ext.Date.add(new Date(y < 100 ? 100 : y, 0, 1, h, i, s, ms), Ext.Date.YEAR, y < 100 ? y - 100 : 0);", "v = !strict? v : (strict === true && (z <= 364 || (Ext.Date.isLeapYear(v) && z <= 365))? Ext.Date.add(v, Ext.Date.DAY, z) : null);", "}else if(strict === true && !Ext.Date.isValid(y, m + 1, d, h, i, s, ms)){", "v = null;", "}else{", "v = Ext.Date.add(new Date(y < 100 ? 100 : y, m, d, h, i, s, ms), Ext.Date.YEAR, y < 100 ? y - 100 : 0);", "}", "}", "}", "if(v){", "if(zz != null){", "v = Ext.Date.add(v, Ext.Date.SECOND, -v.getTimezoneOffset() * 60 - zz);", "}else if(o){", "v = Ext.Date.add(v, Ext.Date.MINUTE, -v.getTimezoneOffset() + (sn == '+'? -1 : 1) * (hr * 60 + mn));", "}", "}", "return v;"].join("\n");
			return function (l) {
				var e = a.parseRegexes.length,
					m = 1,
					f = [],
					k = [],
					j = false,
					d = "";
				for (var h = 0; h < l.length; ++h) {
					d = l.charAt(h);
					if (!j && d == "\\") {
						j = true
					} else {
						if (j) {
							j = false;
							k.push(Ext.String.escape(d))
						} else {
							var g = a.formatCodeToRegex(d, m);
							m += g.g;
							k.push(g.s);
							if (g.g && g.c) {
								f.push(g.c)
							}
						}
					}
				}
				a.parseRegexes[e] = new RegExp("^" + k.join("") + "$", "i");
				a.parseFunctions[l] = Ext.functionFactory("input", "strict", b(c, e, f.join("")))
			}
		})(),
		parseCodes: {
			d: {
				g: 1,
				c: "d = parseInt(results[{0}], 10);\n",
				s: "(\\d{2})"
			},
			j: {
				g: 1,
				c: "d = parseInt(results[{0}], 10);\n",
				s: "(\\d{1,2})"
			},
			D: function () {
				for (var c = [], d = 0; d < 7; c.push(a.getShortDayName(d)), ++d) {}
				return {
					g: 0,
					c: null,
					s: "(?:" + c.join("|") + ")"
				}
			},
			l: function () {
				return {
					g: 0,
					c: null,
					s: "(?:" + a.dayNames.join("|") + ")"
				}
			},
			N: {
				g: 0,
				c: null,
				s: "[1-7]"
			},
			S: {
				g: 0,
				c: null,
				s: "(?:st|nd|rd|th)"
			},
			w: {
				g: 0,
				c: null,
				s: "[0-6]"
			},
			z: {
				g: 1,
				c: "z = parseInt(results[{0}], 10);\n",
				s: "(\\d{1,3})"
			},
			W: {
				g: 0,
				c: null,
				s: "(?:\\d{2})"
			},
			F: function () {
				return {
					g: 1,
					c: "m = parseInt(Ext.Date.getMonthNumber(results[{0}]), 10);\n",
					s: "(" + a.monthNames.join("|") + ")"
				}
			},
			M: function () {
				for (var c = [], d = 0; d < 12; c.push(a.getShortMonthName(d)), ++d) {}
				return Ext.applyIf({
					s: "(" + c.join("|") + ")"
				}, a.formatCodeToRegex("F"))
			},
			m: {
				g: 1,
				c: "m = parseInt(results[{0}], 10) - 1;\n",
				s: "(\\d{2})"
			},
			n: {
				g: 1,
				c: "m = parseInt(results[{0}], 10) - 1;\n",
				s: "(\\d{1,2})"
			},
			t: {
				g: 0,
				c: null,
				s: "(?:\\d{2})"
			},
			L: {
				g: 0,
				c: null,
				s: "(?:1|0)"
			},
			o: function () {
				return a.formatCodeToRegex("Y")
			},
			Y: {
				g: 1,
				c: "y = parseInt(results[{0}], 10);\n",
				s: "(\\d{4})"
			},
			y: {
				g: 1,
				c: "var ty = parseInt(results[{0}], 10);\ny = ty > Ext.Date.y2kYear ? 1900 + ty : 2000 + ty;\n",
				s: "(\\d{1,2})"
			},
			a: {
				g: 1,
				c: "if (/(am)/i.test(results[{0}])) {\nif (!h || h == 12) { h = 0; }\n} else { if (!h || h < 12) { h = (h || 0) + 12; }}",
				s: "(am|pm|AM|PM)"
			},
			A: {
				g: 1,
				c: "if (/(am)/i.test(results[{0}])) {\nif (!h || h == 12) { h = 0; }\n} else { if (!h || h < 12) { h = (h || 0) + 12; }}",
				s: "(AM|PM|am|pm)"
			},
			g: function () {
				return a.formatCodeToRegex("G")
			},
			G: {
				g: 1,
				c: "h = parseInt(results[{0}], 10);\n",
				s: "(\\d{1,2})"
			},
			h: function () {
				return a.formatCodeToRegex("H")
			},
			H: {
				g: 1,
				c: "h = parseInt(results[{0}], 10);\n",
				s: "(\\d{2})"
			},
			i: {
				g: 1,
				c: "i = parseInt(results[{0}], 10);\n",
				s: "(\\d{2})"
			},
			s: {
				g: 1,
				c: "s = parseInt(results[{0}], 10);\n",
				s: "(\\d{2})"
			},
			u: {
				g: 1,
				c: "ms = results[{0}]; ms = parseInt(ms, 10)/Math.pow(10, ms.length - 3);\n",
				s: "(\\d+)"
			},
			O: {
				g: 1,
				c: ["o = results[{0}];", "var sn = o.substring(0,1),", "hr = o.substring(1,3)*1 + Math.floor(o.substring(3,5) / 60),", "mn = o.substring(3,5) % 60;", "o = ((-12 <= (hr*60 + mn)/60) && ((hr*60 + mn)/60 <= 14))? (sn + Ext.String.leftPad(hr, 2, '0') + Ext.String.leftPad(mn, 2, '0')) : null;\n"].join("\n"),
				s: "([+-]\\d{4})"
			},
			P: {
				g: 1,
				c: ["o = results[{0}];", "var sn = o.substring(0,1),", "hr = o.substring(1,3)*1 + Math.floor(o.substring(4,6) / 60),", "mn = o.substring(4,6) % 60;", "o = ((-12 <= (hr*60 + mn)/60) && ((hr*60 + mn)/60 <= 14))? (sn + Ext.String.leftPad(hr, 2, '0') + Ext.String.leftPad(mn, 2, '0')) : null;\n"].join("\n"),
				s: "([+-]\\d{2}:\\d{2})"
			},
			T: {
				g: 0,
				c: null,
				s: "[A-Z]{1,4}"
			},
			Z: {
				g: 1,
				c: "zz = results[{0}] * 1;\nzz = (-43200 <= zz && zz <= 50400)? zz : null;\n",
				s: "([+-]?\\d{1,5})"
			},
			c: function () {
				var e = [],
					c = [a.formatCodeToRegex("Y", 1), a.formatCodeToRegex("m", 2), a.formatCodeToRegex("d", 3), a.formatCodeToRegex("h", 4), a.formatCodeToRegex("i", 5), a.formatCodeToRegex("s", 6),
					{
						c: "ms = results[7] || '0'; ms = parseInt(ms, 10)/Math.pow(10, ms.length - 3);\n"
					}, {
						c: ["if(results[8]) {", "if(results[8] == 'Z'){", "zz = 0;", "}else if (results[8].indexOf(':') > -1){", a.formatCodeToRegex("P", 8).c, "}else{", a.formatCodeToRegex("O", 8).c, "}", "}"].join("\n")
					}];
				for (var f = 0, d = c.length; f < d; ++f) {
					e.push(c[f].c)
				}
				return {
					g: 1,
					c: e.join(""),
					s: [c[0].s, "(?:", "-", c[1].s, "(?:", "-", c[2].s, "(?:", "(?:T| )?", c[3].s, ":", c[4].s, "(?::", c[5].s, ")?", "(?:(?:\\.|,)(\\d+))?", "(Z|(?:[-+]\\d{2}(?::)?\\d{2}))?", ")?", ")?", ")?"].join("")
				}
			},
			U: {
				g: 1,
				c: "u = parseInt(results[{0}], 10);\n",
				s: "(-?\\d+)"
			}
		},
		dateFormat: function (c, d) {
			return a.format(c, d)
		},
		format: function (d, e) {
			if (a.formatFunctions[e] == null) {
				a.createFormat(e)
			}
			var c = a.formatFunctions[e].call(d);
			return c + ""
		},
		getTimezone: function (c) {
			return c.toString().replace(/^.* (?:\((.*)\)|([A-Z]{1,4})(?:[\-+][0-9]{4})?(?: -?\d+)?)$/, "$1$2").replace(/[^A-Z]/g, "")
		},
		getGMTOffset: function (c, d) {
			var e = c.getTimezoneOffset();
			return (e > 0 ? "-" : "+") + Ext.String.leftPad(Math.floor(Math.abs(e) / 60), 2, "0") + (d ? ":" : "") + Ext.String.leftPad(Math.abs(e % 60), 2, "0")
		},
		getDayOfYear: function (f) {
			var e = 0,
				h = Ext.Date.clone(f),
				c = f.getMonth(),
				g;
			for (g = 0, h.setDate(1), h.setMonth(0); g < c; h.setMonth(++g)) {
				e += a.getDaysInMonth(h)
			}
			return e + f.getDate() - 1
		},
		getWeekOfYear: (function () {
			var c = 86400000,
				d = 7 * c;
			return function (f) {
				var g = Date.UTC(f.getFullYear(), f.getMonth(), f.getDate() + 3) / c,
					e = Math.floor(g / 7),
					h = new Date(e * d).getUTCFullYear();
				return e - Math.floor(Date.UTC(h, 0, 7) / d) + 1
			}
		})(),
		isLeapYear: function (c) {
			var d = c.getFullYear();
			return !!((d & 3) == 0 && (d % 100 || (d % 400 == 0 && d)))
		},
		getFirstDayOfMonth: function (d) {
			var c = (d.getDay() - (d.getDate() - 1)) % 7;
			return (c < 0) ? (c + 7) : c
		},
		getLastDayOfMonth: function (c) {
			return a.getLastDateOfMonth(c).getDay()
		},
		getFirstDateOfMonth: function (c) {
			return new Date(c.getFullYear(), c.getMonth(), 1)
		},
		getLastDateOfMonth: function (c) {
			return new Date(c.getFullYear(), c.getMonth(), a.getDaysInMonth(c))
		},
		getDaysInMonth: (function () {
			var c = [31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
			return function (e) {
				var d = e.getMonth();
				return d == 1 && a.isLeapYear(e) ? 29 : c[d]
			}
		})(),
		getSuffix: function (c) {
			switch (c.getDate()) {
			case 1:
			case 21:
			case 31:
				return "st";
			case 2:
			case 22:
				return "nd";
			case 3:
			case 23:
				return "rd";
			default:
				return "th"
			}
		},
		clone: function (c) {
			return new Date(c.getTime())
		},
		isDST: function (c) {
			return new Date(c.getFullYear(), 0, 1).getTimezoneOffset() != c.getTimezoneOffset()
		},
		clearTime: function (e, j) {
			if (j) {
				return Ext.Date.clearTime(Ext.Date.clone(e))
			}
			var g = e.getDate();
			e.setHours(0);
			e.setMinutes(0);
			e.setSeconds(0);
			e.setMilliseconds(0);
			if (e.getDate() != g) {
				for (var f = 1, h = a.add(e, Ext.Date.HOUR, f); h.getDate() != g; f++, h = a.add(e, Ext.Date.HOUR, f)) {}
				e.setDate(g);
				e.setHours(h.getHours())
			}
			return e
		},
		add: function (f, e, g) {
			var h = Ext.Date.clone(f);
			if (!e || g === 0) {
				return h
			}
			switch (e.toLowerCase()) {
			case Ext.Date.MILLI:
				h = new Date(h.valueOf() + g);
				break;
			case Ext.Date.SECOND:
				h = new Date(h.valueOf() + g * 1000);
				break;
			case Ext.Date.MINUTE:
				h = new Date(h.valueOf() + g * 60000);
				break;
			case Ext.Date.HOUR:
				h = new Date(h.valueOf() + g * 3600000);
				break;
			case Ext.Date.DAY:
				h = new Date(h.valueOf() + g * 86400000);
				break;
			case Ext.Date.MONTH:
				var c = f.getDate();
				if (c > 28) {
					c = Math.min(c, Ext.Date.getLastDateOfMonth(Ext.Date.add(Ext.Date.getFirstDateOfMonth(f), "mo", g)).getDate())
				}
				h.setDate(c);
				h.setMonth(f.getMonth() + g);
				break;
			case Ext.Date.YEAR:
				h.setFullYear(f.getFullYear() + g);
				break
			}
			return h
		},
		between: function (d, f, c) {
			var e = d.getTime();
			return f.getTime() <= e && e <= c.getTime()
		},
		diff: function (e, c, g) {
			var d = Ext.Date,
				f, h = +c - e;
			switch (g) {
			case d.MILLI:
				return h;
			case d.SECOND:
				return Math.floor(h / 1000);
			case d.MINUTE:
				return Math.floor(h / 60000);
			case d.HOUR:
				return Math.floor(h / 3600000);
			case d.DAY:
				return Math.floor(h / 86400000);
			case "w":
				return Math.floor(h / 604800000);
			case d.MONTH:
				f = (c.getFullYear() * 12 + c.getMonth()) - (e.getFullYear() * 12 + e.getMonth());
				if (Ext.Date.add(e, g, f) > c) {
					return f - 1
				} else {
					return f
				}
			case d.YEAR:
				f = c.getFullYear() - e.getFullYear();
				if (Ext.Date.add(e, g, f) > c) {
					return f - 1
				} else {
					return f
				}
			}
		},
		align: function (d, f, e) {
			var c = new Date(+d);
			switch (f.toLowerCase()) {
			case Ext.Date.MILLI:
				return c;
				break;
			case Ext.Date.SECOND:
				c.setUTCSeconds(c.getUTCSeconds() - c.getUTCSeconds() % e);
				c.setUTCMilliseconds(0);
				return c;
				break;
			case Ext.Date.MINUTE:
				c.setUTCMinutes(c.getUTCMinutes() - c.getUTCMinutes() % e);
				c.setUTCSeconds(0);
				c.setUTCMilliseconds(0);
				return c;
				break;
			case Ext.Date.HOUR:
				c.setUTCHours(c.getUTCHours() - c.getUTCHours() % e);
				c.setUTCMinutes(0);
				c.setUTCSeconds(0);
				c.setUTCMilliseconds(0);
				return c;
				break;
			case Ext.Date.DAY:
				if (e == 7 || e == 14) {
					c.setUTCDate(c.getUTCDate() - c.getUTCDay() + 1)
				}
				c.setUTCHours(0);
				c.setUTCMinutes(0);
				c.setUTCSeconds(0);
				c.setUTCMilliseconds(0);
				return c;
				break;
			case Ext.Date.MONTH:
				c.setUTCMonth(c.getUTCMonth() - (c.getUTCMonth() - 1) % e, 1);
				c.setUTCHours(0);
				c.setUTCMinutes(0);
				c.setUTCSeconds(0);
				c.setUTCMilliseconds(0);
				return c;
				break;
			case Ext.Date.YEAR:
				c.setUTCFullYear(c.getUTCFullYear() - c.getUTCFullYear() % e, 1, 1);
				c.setUTCHours(0);
				c.setUTCMinutes(0);
				c.setUTCSeconds(0);
				c.setUTCMilliseconds(0);
				return d;
				break
			}
		}
	};
	var a = Ext.DateExtras;
	Ext.apply(Ext.Date, a)
})();
Ext.define("Ext.util.Format", {
	singleton: true,
	defaultDateFormat: "m/d/Y",
	escapeRe: /('|\\)/g,
	trimRe: /^[\x09\x0a\x0b\x0c\x0d\x20\xa0\u1680\u180e\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200a\u2028\u2029\u202f\u205f\u3000]+|[\x09\x0a\x0b\x0c\x0d\x20\xa0\u1680\u180e\u2000\u2001\u2002\u2003\u2004\u2005\u2006\u2007\u2008\u2009\u200a\u2028\u2029\u202f\u205f\u3000]+$/g,
	formatRe: /\{(\d+)\}/g,
	escapeRegexRe: /([-.*+?^${}()|[\]\/\\])/g,
	dashesRe: /-/g,
	iso8601TestRe: /\d\dT\d\d/,
	iso8601SplitRe: /[- :T\.Z\+]/,
	ellipsis: function (c, a, d) {
		if (c && c.length > a) {
			if (d) {
				var e = c.substr(0, a - 2),
					b = Math.max(e.lastIndexOf(" "), e.lastIndexOf("."), e.lastIndexOf("!"), e.lastIndexOf("?"));
				if (b != -1 && b >= (a - 15)) {
					return e.substr(0, b) + "..."
				}
			}
			return c.substr(0, a - 3) + "..."
		}
		return c
	},
	escapeRegex: function (a) {
		return a.replace(Ext.util.Format.escapeRegexRe, "\\$1")
	},
	escape: function (a) {
		return a.replace(Ext.util.Format.escapeRe, "\\$1")
	},
	toggle: function (b, c, a) {
		return b == c ? a : c
	},
	trim: function (a) {
		return a.replace(Ext.util.Format.trimRe, "")
	},
	leftPad: function (d, b, c) {
		var a = String(d);
		c = c || " ";
		while (a.length < b) {
			a = c + a
		}
		return a
	},
	format: function (b) {
		var a = Ext.toArray(arguments, 1);
		return b.replace(Ext.util.Format.formatRe, function (c, d) {
			return a[d]
		})
	},
	htmlEncode: function (a) {
		return !a ? a : String(a).replace(/&/g, "&amp;").replace(/>/g, "&gt;").replace(/</g, "&lt;").replace(/"/g, "&quot;")
	},
	htmlDecode: function (a) {
		return !a ? a : String(a).replace(/&gt;/g, ">").replace(/&lt;/g, "<").replace(/&quot;/g, '"').replace(/&amp;/g, "&")
	},
	date: function (f, g) {
		var b = f;
		if (!f) {
			return ""
		}
		if (!Ext.isDate(f)) {
			b = new Date(Date.parse(f));
			if (isNaN(b)) {
				if (this.iso8601TestRe.test(f)) {
					if (Ext.os.is.Android && Ext.os.version.isLessThan("3.0")) {
						var h = [1, 4, 5, 6, 7, 10, 11];
						var e, d = 0;
						if ((e = /^(\d{4}|[+\-]\d{6})(?:-(\d{2})(?:-(\d{2}))?)?(?:T(\d{2}):(\d{2})(?::(\d{2})(?:\.(\d{3}))?)?(?:(Z)|([+\-])(\d{2})(?::(\d{2}))?)?)?$/.exec(f))) {
							for (var c = 0, a;
							(a = h[c]); ++c) {
								e[a] = +e[a] || 0
							}
							e[2] = (+e[2] || 1) - 1;
							e[3] = +e[3] || 1;
							if (e[8] !== "Z" && e[9] !== undefined) {
								d = e[10] * 60 + e[11];
								if (e[9] === "+") {
									d = 0 - d
								}
							}
							b = new Date(Date.UTC(e[1], e[2], e[3], e[4], e[5] + d, e[6], e[7]))
						}
					} else {
						b = f.split(this.iso8601SplitRe);
						b = new Date(b[0], b[1] - 1, b[2], b[3], b[4], b[5])
					}
				}
			}
			if (isNaN(b)) {
				b = new Date(Date.parse(f.replace(this.dashesRe, "/")))
			}
			f = b
		}
		return Ext.Date.format(f, g || Ext.util.Format.defaultDateFormat)
	}
});
Ext.define("Ext.Template", {
	inheritableStatics: {
		from: function (b, a) {
			b = Ext.getDom(b);
			return new this(b.value || b.innerHTML, a || "")
		}
	},
	constructor: function (d) {
		var f = this,
			b = arguments,
			a = [],
			c = 0,
			e = b.length,
			g;
		f.initialConfig = {};
		if (e === 1 && Ext.isArray(d)) {
			b = d;
			e = b.length
		}
		if (e > 1) {
			for (; c < e; c++) {
				g = b[c];
				if (typeof g == "object") {
					Ext.apply(f.initialConfig, g);
					Ext.apply(f, g)
				} else {
					a.push(g)
				}
			}
		} else {
			a.push(d)
		}
		f.html = a.join("");
		if (f.compiled) {
			f.compile()
		}
	},
	isTemplate: true,
	disableFormats: false,
	re: /\{([\w\-]+)(?:\:([\w\.]*)(?:\((.*?)?\))?)?\}/g,
	apply: function (a) {
		var g = this,
			d = g.disableFormats !== true,
			f = Ext.util.Format,
			c = g,
			b;
		if (g.compiled) {
			return g.compiled(a).join("")
		}
		function e(h, k, l, j) {
			if (l && d) {
				if (j) {
					j = [a[k]].concat(Ext.functionFactory("return [" + j + "];")())
				} else {
					j = [a[k]]
				}
				if (l.substr(0, 5) == "this.") {
					return c[l.substr(5)].apply(c, j)
				} else {
					return f[l].apply(f, j)
				}
			} else {
				return a[k] !== undefined ? a[k] : ""
			}
		}
		b = g.html.replace(g.re, e);
		return b
	},
	applyOut: function (a, b) {
		var c = this;
		if (c.compiled) {
			b.push.apply(b, c.compiled(a))
		} else {
			b.push(c.apply(a))
		}
		return b
	},
	applyTemplate: function () {
		return this.apply.apply(this, arguments)
	},
	set: function (a, c) {
		var b = this;
		b.html = a;
		b.compiled = null;
		return c ? b.compile() : b
	},
	compileARe: /\\/g,
	compileBRe: /(\r\n|\n)/g,
	compileCRe: /'/g,
	compile: function () {
		var me = this,
			fm = Ext.util.Format,
			useFormat = me.disableFormats !== true,
			body, bodyReturn;

		function fn(m, name, format, args) {
			if (format && useFormat) {
				args = args ? "," + args : "";
				if (format.substr(0, 5) != "this.") {
					format = "fm." + format + "("
				} else {
					format = "this." + format.substr(5) + "("
				}
			} else {
				args = "";
				format = "(values['" + name + "'] == undefined ? '' : "
			}
			return "'," + format + "values['" + name + "']" + args + ") ,'"
		}
		bodyReturn = me.html.replace(me.compileARe, "\\\\").replace(me.compileBRe, "\\n").replace(me.compileCRe, "\\'").replace(me.re, fn);
		body = "this.compiled = function(values){ return ['" + bodyReturn + "'];};";
		eval(body);
		return me
	},
	insertFirst: function (b, a, c) {
		return this.doInsert("afterBegin", b, a, c)
	},
	insertBefore: function (b, a, c) {
		return this.doInsert("beforeBegin", b, a, c)
	},
	insertAfter: function (b, a, c) {
		return this.doInsert("afterEnd", b, a, c)
	},
	append: function (b, a, c) {
		return this.doInsert("beforeEnd", b, a, c)
	},
	doInsert: function (b, d, a, e) {
		var c = Ext.DomHelper.insertHtml(b, Ext.getDom(d), this.apply(a));
		return e ? Ext.get(c) : c
	},
	overwrite: function (c, a, d) {
		var b = Ext.DomHelper.overwrite(Ext.getDom(c), this.apply(a));
		return d ? Ext.get(b) : b
	}
});
Ext.define("Ext.XTemplateParser", {
	constructor: function (a) {
		Ext.apply(this, a)
	},
	doTpl: Ext.emptyFn,
	parse: function (l) {
		var v = this,
			p = l.length,
			o = {
				elseif: "elif"
			},
			q = v.topRe,
			c = v.actionsRe,
			e, d, j, n, g, k, h, u, r, b, f, a;
		v.level = 0;
		v.stack = d = [];
		for (e = 0; e < p; e = b) {
			q.lastIndex = e;
			n = q.exec(l);
			if (!n) {
				v.doText(l.substring(e, p));
				break
			}
			r = n.index;
			b = q.lastIndex;
			if (e < r) {
				v.doText(l.substring(e, r))
			}
			if (n[1]) {
				b = l.indexOf("%}", r + 2);
				v.doEval(l.substring(r + 2, b));
				b += 2
			} else {
				if (n[2]) {
					b = l.indexOf("]}", r + 2);
					v.doExpr(l.substring(r + 2, b));
					b += 2
				} else {
					if (n[3]) {
						v.doTag(n[3])
					} else {
						if (n[4]) {
							f = null;
							while ((u = c.exec(n[4])) !== null) {
								j = u[2] || u[3];
								if (j) {
									j = Ext.String.htmlDecode(j);
									g = u[1];
									g = o[g] || g;
									f = f || {};
									k = f[g];
									if (typeof k == "string") {
										f[g] = [k, j]
									} else {
										if (k) {
											f[g].push(j)
										} else {
											f[g] = j
										}
									}
								}
							}
							if (!f) {
								if (v.elseRe.test(n[4])) {
									v.doElse()
								} else {
									if (v.defaultRe.test(n[4])) {
										v.doDefault()
									} else {
										v.doTpl();
										d.push({
											type: "tpl"
										})
									}
								}
							} else {
								if (f["if"]) {
									v.doIf(f["if"], f);
									d.push({
										type: "if"
									})
								} else {
									if (f["switch"]) {
										v.doSwitch(f["switch"], f);
										d.push({
											type: "switch"
										})
									} else {
										if (f["case"]) {
											v.doCase(f["case"], f)
										} else {
											if (f.elif) {
												v.doElseIf(f.elif, f)
											} else {
												if (f["for"]) {
													++v.level;
													if (a = v.propRe.exec(n[4])) {
														f.propName = a[1] || a[2]
													}
													v.doFor(f["for"], f);
													d.push({
														type: "for",
														actions: f
													})
												} else {
													if (f.exec) {
														v.doExec(f.exec, f);
														d.push({
															type: "exec",
															actions: f
														})
													}
												}
											}
										}
									}
								}
							}
						} else {
							if (n[0].length === 5) {
								d.push({
									type: "tpl"
								})
							} else {
								h = d.pop();
								v.doEnd(h.type, h.actions);
								if (h.type == "for") {
									--v.level
								}
							}
						}
					}
				}
			}
		}
	},
	topRe: /(?:(\{\%)|(\{\[)|\{([^{}]*)\})|(?:<tpl([^>]*)\>)|(?:<\/tpl>)/g,
	actionsRe: /\s*(elif|elseif|if|for|exec|switch|case|eval)\s*\=\s*(?:(?:"([^"]*)")|(?:'([^']*)'))\s*/g,
	propRe: /prop=(?:(?:"([^"]*)")|(?:'([^']*)'))/,
	defaultRe: /^\s*default\s*$/,
	elseRe: /^\s*else\s*$/
});
Ext.define("Ext.XTemplateCompiler", {
	extend: Ext.XTemplateParser,
	useEval: Ext.isGecko,
	useIndex: Ext.isIE6 || Ext.isIE7,
	useFormat: true,
	propNameRe: /^[\w\d\$]*$/,
	compile: function (a) {
		var c = this,
			b = c.generate(a);
		return c.useEval ? c.evalTpl(b) : (new Function("Ext", b))(Ext)
	},
	generate: function (a) {
		var d = this,
			b = "var fm=Ext.util.Format,ts=Object.prototype.toString;",
			c;
		d.maxLevel = 0;
		d.body = ["var c0=values, a0=" + d.createArrayTest(0) + ", p0=parent, n0=xcount, i0=xindex, v;\n"];
		if (d.definitions) {
			if (typeof d.definitions === "string") {
				d.definitions = [d.definitions, b]
			} else {
				d.definitions.push(b)
			}
		} else {
			d.definitions = [b]
		}
		d.switches = [];
		d.parse(a);
		d.definitions.push((d.useEval ? "$=" : "return") + " function (" + d.fnArgs + ") {", d.body.join(""), "}");
		c = d.definitions.join("\n");
		d.definitions.length = d.body.length = d.switches.length = 0;
		delete d.definitions;
		delete d.body;
		delete d.switches;
		return c
	},
	doText: function (c) {
		var b = this,
			a = b.body;
		c = c.replace(b.aposRe, "\\'").replace(b.newLineRe, "\\n");
		if (b.useIndex) {
			a.push("out[out.length]='", c, "'\n")
		} else {
			a.push("out.push('", c, "')\n")
		}
	},
	doExpr: function (b) {
		var a = this.body;
		a.push("v=" + b + "; if (v !== undefined && v !== null) out");
		if (this.useIndex) {
			a.push("[out.length]=v+''\n")
		} else {
			a.push(".push(v+'')\n")
		}
	},
	doTag: function (a) {
		this.doExpr(this.parseTag(a))
	},
	doElse: function () {
		this.body.push("} else {\n")
	},
	doEval: function (a) {
		this.body.push(a, "\n")
	},
	doIf: function (b, c) {
		var a = this;
		if (b === ".") {
			a.body.push("if (values) {\n")
		} else {
			if (a.propNameRe.test(b)) {
				a.body.push("if (", a.parseTag(b), ") {\n")
			} else {
				a.body.push("if (", a.addFn(b), a.callFn, ") {\n")
			}
		}
		if (c.exec) {
			a.doExec(c.exec)
		}
	},
	doElseIf: function (b, c) {
		var a = this;
		if (b === ".") {
			a.body.push("else if (values) {\n")
		} else {
			if (a.propNameRe.test(b)) {
				a.body.push("} else if (", a.parseTag(b), ") {\n")
			} else {
				a.body.push("} else if (", a.addFn(b), a.callFn, ") {\n")
			}
		}
		if (c.exec) {
			a.doExec(c.exec)
		}
	},
	doSwitch: function (b) {
		var a = this;
		if (b === ".") {
			a.body.push("switch (values) {\n")
		} else {
			if (a.propNameRe.test(b)) {
				a.body.push("switch (", a.parseTag(b), ") {\n")
			} else {
				a.body.push("switch (", a.addFn(b), a.callFn, ") {\n")
			}
		}
		a.switches.push(0)
	},
	doCase: function (e) {
		var d = this,
			c = Ext.isArray(e) ? e : [e],
			f = d.switches.length - 1,
			a, b;
		if (d.switches[f]) {
			d.body.push("break;\n")
		} else {
			d.switches[f]++
		}
		for (b = 0, f = c.length; b < f; ++b) {
			a = d.intRe.exec(c[b]);
			c[b] = a ? a[1] : ("'" + c[b].replace(d.aposRe, "\\'") + "'")
		}
		d.body.push("case ", c.join(": case "), ":\n")
	},
	doDefault: function () {
		var a = this,
			b = a.switches.length - 1;
		if (a.switches[b]) {
			a.body.push("break;\n")
		} else {
			a.switches[b]++
		}
		a.body.push("default:\n")
	},
	doEnd: function (b, d) {
		var c = this,
			a = c.level - 1;
		if (b == "for") {
			if (d.exec) {
				c.doExec(d.exec)
			}
			c.body.push("}\n");
			c.body.push("parent=p", a, ";values=r", a + 1, ";xcount=n", a, ";xindex=i", a, "\n")
		} else {
			if (b == "if" || b == "switch") {
				c.body.push("}\n")
			}
		}
	},
	doFor: function (f, h) {
		var e = this,
			d, b = e.level,
			a = b - 1,
			c = "p" + b,
			g;
		if (f === ".") {
			d = "values"
		} else {
			if (e.propNameRe.test(f)) {
				d = e.parseTag(f)
			} else {
				d = e.addFn(f) + e.callFn
			}
		}
		if (e.maxLevel < b) {
			e.maxLevel = b;
			e.body.push("var ")
		}
		if (f == ".") {
			g = "c" + b
		} else {
			g = "a" + a + "?c" + a + "[i" + a + "]:p" + b
		}
		e.body.push("i", b, "=0,n", b, "=0,c", b, "=", d, ",a", b, "=", e.createArrayTest(b), ",p", b, "=c", a, ",r", b, "=values;\n", "parent=", g, "\n", "if (c", b, "){if(a", b, "){n", b, "=c", b, ".length;}else if (c", b, ".isMixedCollection){c", b, "=c", b, ".items;n", b, "=c", b, ".length;}else if(c", b, ".isStore){c", b, "=c", b, ".data.items;n", b, "=c", b, ".length;}else{c", b, "=[c", b, "];n", b, "=1;}}\n", "for (xcount=n", b, ";i", b, "<n" + b + ";++i", b, "){\n", "values=c", b, "[i", b, "]");
		if (h.propName) {
			e.body.push(".", h.propName)
		}
		e.body.push("\n", "xindex=i", b, "+1\n")
	},
	createArrayTest: ("isArray" in Array) ?
	function (a) {
		return "Array.isArray(c" + a + ")"
	} : function (a) {
		return "ts.call(c" + a + ')==="[object Array]"'
	},
	doExec: function (c, d) {
		var b = this,
			a = "f" + b.definitions.length;
		b.definitions.push("function " + a + "(" + b.fnArgs + ") {", " try { with(values) {", "  " + c, " }} catch(e) {", "}", "}");
		b.body.push(a + b.callFn + "\n")
	},
	addFn: function (a) {
		var c = this,
			b = "f" + c.definitions.length;
		if (a === ".") {
			c.definitions.push("function " + b + "(" + c.fnArgs + ") {", " return values", "}")
		} else {
			if (a === "..") {
				c.definitions.push("function " + b + "(" + c.fnArgs + ") {", " return parent", "}")
			} else {
				c.definitions.push("function " + b + "(" + c.fnArgs + ") {", " try { with(values) {", "  return(" + a + ")", " }} catch(e) {", "}", "}")
			}
		}
		return b
	},
	parseTag: function (b) {
		var g = this,
			a = g.tagRe.exec(b),
			e = a[1],
			h = a[2],
			d = a[3],
			f = a[4],
			c;
		if (e == ".") {
			if (!g.validTypes) {
				g.definitions.push("var validTypes={string:1,number:1,boolean:1};");
				g.validTypes = true
			}
			c = 'validTypes[typeof values] || ts.call(values) === "[object Date]" ? values : ""'
		} else {
			if (e == "#") {
				c = "xindex"
			} else {
				if (e.substr(0, 7) == "parent.") {
					c = e
				} else {
					if (isNaN(e) && e.indexOf("-") == -1 && e.indexOf(".") != -1) {
						c = "values." + e
					} else {
						c = "values['" + e + "']"
					}
				}
			}
		}
		if (f) {
			c = "(" + c + f + ")"
		}
		if (h && g.useFormat) {
			d = d ? "," + d : "";
			if (h.substr(0, 5) != "this.") {
				h = "fm." + h + "("
			} else {
				h += "("
			}
		} else {
			return c
		}
		return h + c + d + ")"
	},
	evalTpl: function ($) {
		eval($);
		return $
	},
	newLineRe: /\r\n|\r|\n/g,
	aposRe: /[']/g,
	intRe: /^\s*(\d+)\s*$/,
	tagRe: /([\w-\.\#\$]+)(?:\:([\w\.]*)(?:\((.*?)?\))?)?(\s?[\+\-\*\/]\s?[\d\.\+\-\*\/\(\)]+)?/
}, function () {
	var a = this.prototype;
	a.fnArgs = "out,values,parent,xindex,xcount";
	a.callFn = ".call(this," + a.fnArgs + ")"
});
Ext.define("Ext.XTemplate", {
	extend: Ext.Template,
	emptyObj: {},
	apply: function (a) {
		return this.applyOut(a, []).join("")
	},
	applyOut: function (a, b, d) {
		var g = this,
			f = a.xindex,
			j = a.xcount,
			c;
		if (!g.fn) {
			c = new Ext.XTemplateCompiler({
				useFormat: g.disableFormats !== true,
				definitions: g.definitions
			});
			g.fn = c.compile(g.html)
		}
		try {
			f = typeof f === "number" ? f : 1;
			j = typeof j === "number" ? j : 1;
			g.fn.call(g, b, a, d || g.emptyObj, f, j)
		} catch (h) {}
		return b
	},
	compile: function () {
		return this
	},
	statics: {
		getTpl: function (a, c) {
			var b = a[c],
				d;
			if (b && !b.isTemplate) {
				b = Ext.ClassManager.dynInstantiate("Ext.XTemplate", b);
				if (a.hasOwnProperty(c)) {
					a[c] = b
				} else {
					for (d = a.self.prototype; d; d = d.superclass) {
						if (d.hasOwnProperty(c)) {
							d[c] = b;
							break
						}
					}
				}
			}
			return b || null
		}
	}
});
Ext.define("Ext.behavior.Behavior", {
	constructor: function (a) {
		this.component = a;
		a.on("destroy", "onComponentDestroy", this)
	},
	onComponentDestroy: Ext.emptyFn
});
Ext.define("Ext.fx.easing.Abstract", {
	config: {
		startTime: 0,
		startValue: 0
	},
	isEasing: true,
	isEnded: false,
	constructor: function (a) {
		this.initConfig(a);
		return this
	},
	applyStartTime: function (a) {
		if (!a) {
			a = Ext.Date.now()
		}
		return a
	},
	updateStartTime: function (a) {
		this.reset()
	},
	reset: function () {
		this.isEnded = false
	},
	getValue: Ext.emptyFn
});
Ext.define("Ext.fx.easing.Linear", {
	extend: Ext.fx.easing.Abstract,
	alias: "easing.linear",
	config: {
		duration: 0,
		endValue: 0
	},
	updateStartValue: function (a) {
		this.distance = this.getEndValue() - a
	},
	updateEndValue: function (a) {
		this.distance = a - this.getStartValue()
	},
	getValue: function () {
		var a = Ext.Date.now() - this.getStartTime(),
			b = this.getDuration();
		if (a > b) {
			this.isEnded = true;
			return this.getEndValue()
		} else {
			return this.getStartValue() + ((a / b) * this.distance)
		}
	}
});
Ext.define("Ext.util.translatable.Abstract", {
	extend: Ext.Evented,
	config: {
		useWrapper: null,
		easing: null,
		easingX: null,
		easingY: null
	},
	x: 0,
	y: 0,
	activeEasingX: null,
	activeEasingY: null,
	isAnimating: false,
	isTranslatable: true,
	constructor: function (a) {
		this.initConfig(a)
	},
	factoryEasing: function (a) {
		return Ext.factory(a, Ext.fx.easing.Linear, null, "easing")
	},
	applyEasing: function (a) {
		if (!this.getEasingX()) {
			this.setEasingX(this.factoryEasing(a))
		}
		if (!this.getEasingY()) {
			this.setEasingY(this.factoryEasing(a))
		}
	},
	applyEasingX: function (a) {
		return this.factoryEasing(a)
	},
	applyEasingY: function (a) {
		return this.factoryEasing(a)
	},
	doTranslate: Ext.emptyFn,
	translate: function (a, c, b) {
		if (b) {
			return this.translateAnimated(a, c, b)
		}
		if (this.isAnimating) {
			this.stopAnimation()
		}
		if (!isNaN(a) && typeof a == "number") {
			this.x = a
		}
		if (!isNaN(c) && typeof c == "number") {
			this.y = c
		}
		this.doTranslate(a, c)
	},
	translateAxis: function (b, d, c) {
		var a, e;
		if (b == "x") {
			a = d
		} else {
			e = d
		}
		return this.translate(a, e, c)
	},
	animate: function (b, a) {
		this.activeEasingX = b;
		this.activeEasingY = a;
		this.isAnimating = true;
		this.lastX = null;
		this.lastY = null;
		Ext.AnimationQueue.start(this.doAnimationFrame, this);
		this.fireEvent("animationstart", this, this.x, this.y);
		return this
	},
	translateAnimated: function (b, g, e) {
		if (!Ext.isObject(e)) {
			e = {}
		}
		if (this.isAnimating) {
			this.stopAnimation()
		}
		var d = Ext.Date.now(),
			f = e.easing,
			c = (typeof b == "number") ? (e.easingX || f || this.getEasingX() || true) : null,
			a = (typeof g == "number") ? (e.easingY || f || this.getEasingY() || true) : null;
		if (c) {
			c = this.factoryEasing(c);
			c.setStartTime(d);
			c.setStartValue(this.x);
			c.setEndValue(b);
			if ("duration" in e) {
				c.setDuration(e.duration)
			}
		}
		if (a) {
			a = this.factoryEasing(a);
			a.setStartTime(d);
			a.setStartValue(this.y);
			a.setEndValue(g);
			if ("duration" in e) {
				a.setDuration(e.duration)
			}
		}
		return this.animate(c, a)
	},
	doAnimationFrame: function () {
		var e = this,
			c = e.activeEasingX,
			b = e.activeEasingY,
			d = Date.now(),
			a, f;
		if (!e.isAnimating) {
			return
		}
		e.lastRun = d;
		if (c === null && b === null) {
			e.stopAnimation();
			return
		}
		if (c !== null) {
			e.x = a = Math.round(c.getValue());
			if (c.isEnded) {
				e.activeEasingX = null;
				e.fireEvent("axisanimationend", e, "x", a)
			}
		} else {
			a = e.x
		}
		if (b !== null) {
			e.y = f = Math.round(b.getValue());
			if (b.isEnded) {
				e.activeEasingY = null;
				e.fireEvent("axisanimationend", e, "y", f)
			}
		} else {
			f = e.y
		}
		if (e.lastX !== a || e.lastY !== f) {
			e.doTranslate(a, f);
			e.lastX = a;
			e.lastY = f
		}
		e.fireEvent("animationframe", e, a, f)
	},
	stopAnimation: function () {
		if (!this.isAnimating) {
			return
		}
		this.activeEasingX = null;
		this.activeEasingY = null;
		this.isAnimating = false;
		Ext.AnimationQueue.stop(this.doAnimationFrame, this);
		this.fireEvent("animationend", this, this.x, this.y)
	},
	refresh: function () {
		this.translate(this.x, this.y)
	},
	destroy: function () {
		if (this.isAnimating) {
			this.stopAnimation()
		}
		this.callParent(arguments)
	}
});
Ext.define("Ext.util.translatable.Dom", {
	extend: Ext.util.translatable.Abstract,
	config: {
		element: null
	},
	applyElement: function (a) {
		if (!a) {
			return
		}
		return Ext.get(a)
	},
	updateElement: function () {
		this.refresh()
	}
});
Ext.define("Ext.util.translatable.CssTransform", {
	extend: Ext.util.translatable.Dom,
	doTranslate: function (a, c) {
		var b = this.getElement();
		if (!this.isDestroyed && !b.isDestroyed) {
			b.translate(a, c)
		}
	},
	destroy: function () {
		var a = this.getElement();
		if (a && !a.isDestroyed) {
			a.dom.style.webkitTransform = null
		}
		this.callSuper()
	}
});
Ext.define("Ext.util.translatable.ScrollPosition", {
	extend: Ext.util.translatable.Dom,
	type: "scrollposition",
	config: {
		useWrapper: true
	},
	getWrapper: function () {
		var c = this.wrapper,
			b = this.getElement(),
			a;
		if (!c) {
			a = b.getParent();
			if (!a) {
				return null
			}
			if (a.hasCls(Ext.baseCSSPrefix + "translatable-hboxfix")) {
				a = a.getParent()
			}
			if (this.getUseWrapper()) {
				c = b.wrap()
			} else {
				c = a
			}
			b.addCls("x-translatable");
			c.addCls("x-translatable-container");
			this.wrapper = c;
			c.on("painted", "refresh", this);
			this.refresh()
		}
		return c
	},
	doTranslate: function (a, d) {
		var c = this.getWrapper(),
			b;
		if (c) {
			b = c.dom;
			if (typeof a == "number") {
				b.scrollLeft = 500000 - a
			}
			if (typeof d == "number") {
				b.scrollTop = 500000 - d
			}
		}
	},
	destroy: function () {
		var a = this.getElement(),
			b = this.wrapper;
		if (b) {
			if (!a.isDestroyed) {
				if (this.getUseWrapper()) {
					b.doReplaceWith(a)
				}
				a.removeCls("x-translatable")
			}
			if (!b.isDestroyed) {
				b.removeCls("x-translatable-container");
				b.un("painted", "refresh", this)
			}
			delete this.wrapper;
			delete this._element
		}
		this.callSuper()
	}
});
Ext.define("Ext.util.translatable.CssPosition", {
	extend: Ext.util.translatable.Dom,
	doTranslate: function (a, c) {
		var b = this.getElement().dom.style;
		if (typeof a == "number") {
			b.left = a + "px"
		}
		if (typeof c == "number") {
			b.top = c + "px"
		}
	},
	destroy: function () {
		var a = this.getElement().dom.style;
		a.left = null;
		a.top = null;
		this.callParent(arguments)
	}
});
Ext.define("Ext.util.Translatable", {
	constructor: function (a) {
		var b = Ext.util.translatable;
		switch (Ext.browser.getPreferredTranslationMethod(a)) {
		case "scrollposition":
			return new b.ScrollPosition(a);
		case "csstransform":
			return new b.CssTransform(a);
		case "cssposition":
			return new b.CssPosition(a)
		}
	}
});
Ext.define("Ext.behavior.Translatable", {
	extend: Ext.behavior.Behavior,
	setConfig: function (c) {
		var a = this.translatable,
			b = this.component;
		if (c) {
			if (!a) {
				this.translatable = a = new Ext.util.Translatable(c);
				a.setElement(b.renderElement);
				a.on("destroy", "onTranslatableDestroy", this)
			} else {
				if (Ext.isObject(c)) {
					a.setConfig(c)
				}
			}
		} else {
			if (a) {
				a.destroy()
			}
		}
		return this
	},
	getTranslatable: function () {
		return this.translatable
	},
	onTranslatableDestroy: function () {
		delete this.translatable
	},
	onComponentDestroy: function () {
		var a = this.translatable;
		if (a) {
			a.destroy()
		}
	}
});
Ext.define("Ext.util.Draggable", {
	isDraggable: true,
	mixins: [Ext.mixin.Observable],
	config: {
		cls: Ext.baseCSSPrefix + "draggable",
		draggingCls: Ext.baseCSSPrefix + "dragging",
		element: null,
		constraint: "container",
		disabled: null,
		direction: "both",
		initialOffset: {
			x: 0,
			y: 0
		},
		translatable: {}
	},
	DIRECTION_BOTH: "both",
	DIRECTION_VERTICAL: "vertical",
	DIRECTION_HORIZONTAL: "horizontal",
	defaultConstraint: {
		min: {
			x: -Infinity,
			y: -Infinity
		},
		max: {
			x: Infinity,
			y: Infinity
		}
	},
	containerWidth: 0,
	containerHeight: 0,
	width: 0,
	height: 0,
	constructor: function (a) {
		var b;
		this.extraConstraint = {};
		this.initialConfig = a;
		this.offset = {
			x: 0,
			y: 0
		};
		this.listeners = {
			dragstart: "onDragStart",
			drag: "onDrag",
			dragend: "onDragEnd",
			resize: "onElementResize",
			scope: this
		};
		if (a && a.element) {
			b = a.element;
			delete a.element;
			this.setElement(b)
		}
		return this
	},
	applyElement: function (a) {
		if (!a) {
			return
		}
		return Ext.get(a)
	},
	updateElement: function (a) {
		a.on(this.listeners);
		this.initConfig(this.initialConfig)
	},
	updateInitialOffset: function (b) {
		if (typeof b == "number") {
			b = {
				x: b,
				y: b
			}
		}
		var c = this.offset,
			a, d;
		c.x = a = b.x;
		c.y = d = b.y;
		this.getTranslatable().translate(a, d)
	},
	updateCls: function (a) {
		this.getElement().addCls(a)
	},
	applyTranslatable: function (a, b) {
		a = Ext.factory(a, Ext.util.Translatable, b);
		if (a) {
			a.setElement(this.getElement())
		}
		return a
	},
	setExtraConstraint: function (a) {
		this.extraConstraint = a || {};
		this.refreshConstraint();
		return this
	},
	addExtraConstraint: function (a) {
		Ext.merge(this.extraConstraint, a);
		this.refreshConstraint();
		return this
	},
	applyConstraint: function (a) {
		this.currentConstraint = a;
		if (!a) {
			a = this.defaultConstraint
		}
		if (a === "container") {
			return Ext.merge(this.getContainerConstraint(), this.extraConstraint)
		}
		return Ext.merge({}, this.extraConstraint, a)
	},
	updateConstraint: function () {
		this.refreshOffset()
	},
	getContainerConstraint: function () {
		var a = this.getContainer(),
			b = this.getElement();
		if (!a || !b.dom) {
			return this.defaultConstraint
		}
		return {
			min: {
				x: 0,
				y: 0
			},
			max: {
				x: this.containerWidth - this.width,
				y: this.containerHeight - this.height
			}
		}
	},
	getContainer: function () {
		var a = this.container;
		if (!a) {
			a = this.getElement().getParent();
			if (a) {
				this.container = a;
				a.on({
					resize: "onContainerResize",
					destroy: "onContainerDestroy",
					scope: this
				})
			}
		}
		return a
	},
	onElementResize: function (a, b) {
		this.width = b.width;
		this.height = b.height;
		this.refresh()
	},
	onContainerResize: function (a, b) {
		this.containerWidth = b.width;
		this.containerHeight = b.height;
		this.refresh()
	},
	onContainerDestroy: function () {
		delete this.container;
		delete this.containerSizeMonitor
	},
	detachListeners: function () {
		this.getElement().un(this.listeners)
	},
	isAxisEnabled: function (a) {
		var b = this.getDirection();
		if (a === "x") {
			return (b === this.DIRECTION_BOTH || b === this.DIRECTION_HORIZONTAL)
		}
		return (b === this.DIRECTION_BOTH || b === this.DIRECTION_VERTICAL)
	},
	onDragStart: function (a) {
		if (this.getDisabled()) {
			return false
		}
		var b = this.offset;
		this.fireAction("dragstart", [this, a, b.x, b.y], this.initDragStart)
	},
	initDragStart: function (b, c, a, d) {
		this.dragStartOffset = {
			x: a,
			y: d
		};
		this.isDragging = true;
		this.getElement().addCls(this.getDraggingCls())
	},
	onDrag: function (b) {
		if (!this.isDragging) {
			return
		}
		var a = this.dragStartOffset;
		this.fireAction("drag", [this, b, a.x + b.deltaX, a.y + b.deltaY], this.doDrag)
	},
	doDrag: function (b, c, a, d) {
		b.setOffset(a, d)
	},
	onDragEnd: function (a) {
		if (!this.isDragging) {
			return
		}
		this.onDrag(a);
		this.isDragging = false;
		this.getElement().removeCls(this.getDraggingCls());
		this.fireEvent("dragend", this, a, this.offset.x, this.offset.y)
	},
	setOffset: function (j, h, b) {
		var f = this.offset,
			a = this.getConstraint(),
			e = a.min,
			c = a.max,
			d = Math.min,
			g = Math.max;
		if (this.isAxisEnabled("x") && typeof j == "number") {
			j = d(g(j, e.x), c.x)
		} else {
			j = f.x
		}
		if (this.isAxisEnabled("y") && typeof h == "number") {
			h = d(g(h, e.y), c.y)
		} else {
			h = f.y
		}
		f.x = j;
		f.y = h;
		this.getTranslatable().translate(j, h, b)
	},
	getOffset: function () {
		return this.offset
	},
	refreshConstraint: function () {
		this.setConstraint(this.currentConstraint)
	},
	refreshOffset: function () {
		var a = this.offset;
		this.setOffset(a.x, a.y)
	},
	refresh: function () {
		this.refreshConstraint();
		this.getTranslatable().refresh();
		this.refreshOffset()
	},
	enable: function () {
		return this.setDisabled(false)
	},
	disable: function () {
		return this.setDisabled(true)
	},
	destroy: function () {
		var a = this.getTranslatable();
		var b = this.getElement();
		if (b && !b.isDestroyed) {
			b.removeCls(this.getCls())
		}
		this.detachListeners();
		if (a) {
			a.destroy()
		}
	}
}, function () {});
Ext.define("Ext.behavior.Draggable", {
	extend: Ext.behavior.Behavior,
	setConfig: function (c) {
		var a = this.draggable,
			b = this.component;
		if (c) {
			if (!a) {
				b.setTranslatable(c.translatable);
				this.draggable = a = new Ext.util.Draggable(c);
				a.setTranslatable(b.getTranslatable());
				a.setElement(b.renderElement);
				a.on("destroy", "onDraggableDestroy", this);
				b.on(this.listeners)
			} else {
				if (Ext.isObject(c)) {
					a.setConfig(c)
				}
			}
		} else {
			if (a) {
				a.destroy()
			}
		}
		return this
	},
	getDraggable: function () {
		return this.draggable
	},
	onDraggableDestroy: function () {
		delete this.draggable
	},
	onComponentDestroy: function () {
		var a = this.draggable;
		if (a) {
			a.destroy()
		}
	}
});
(function (a) {
	Ext.define("Ext.Component", {
		extend: Ext.AbstractComponent,
		alternateClassName: "Ext.lib.Component",
		mixins: [Ext.mixin.Traversable],
		xtype: "component",
		observableType: "component",
		cachedConfig: {
			baseCls: null,
			cls: null,
			floatingCls: a + "floating",
			hiddenCls: a + "item-hidden",
			ui: null,
			margin: null,
			padding: null,
			border: null,
			styleHtmlCls: a + "html",
			styleHtmlContent: null
		},
		eventedConfig: {
			flex: null,
			left: null,
			top: null,
			right: null,
			bottom: null,
			width: null,
			height: null,
			minWidth: null,
			minHeight: null,
			maxWidth: null,
			maxHeight: null,
			docked: null,
			centered: null,
			hidden: null,
			disabled: null
		},
		config: {
			style: null,
			html: null,
			draggable: null,
			translatable: null,
			renderTo: null,
			zIndex: null,
			tpl: null,
			enterAnimation: null,
			exitAnimation: null,
			showAnimation: null,
			hideAnimation: null,
			tplWriteMode: "overwrite",
			data: null,
			disabledCls: a + "item-disabled",
			contentEl: null,
			itemId: undefined,
			record: null,
			plugins: null
		},
		listenerOptionsRegex: /^(?:delegate|single|delay|buffer|args|prepend|element)$/,
		alignmentRegex: /^([a-z]+)-([a-z]+)(\?)?$/,
		isComponent: true,
		floating: false,
		rendered: false,
		isInner: true,
		dockPositions: {
			top: true,
			right: true,
			bottom: true,
			left: true
		},
		innerElement: null,
		element: null,
		template: [],
		widthLayoutSized: false,
		heightLayoutSized: false,
		layoutStretched: false,
		sizeState: false,
		sizeFlags: 0,
		LAYOUT_WIDTH: 1,
		LAYOUT_HEIGHT: 2,
		LAYOUT_BOTH: 3,
		LAYOUT_STRETCHED: 4,
		constructor: function (c) {
			var d = this,
				b = d.config,
				e;
			d.onInitializedListeners = [];
			d.initialConfig = c;
			if (c !== undefined && "id" in c) {
				e = c.id
			} else {
				if ("id" in b) {
					e = b.id
				} else {
					e = d.getId()
				}
			}
			d.id = e;
			d.setId(e);
			Ext.ComponentManager.register(d);
			d.initElement();
			d.initConfig(d.initialConfig);
			d.refreshSizeState = d.doRefreshSizeState;
			d.refreshFloating = d.doRefreshFloating;
			if (d.refreshSizeStateOnInitialized) {
				d.refreshSizeState()
			}
			if (d.refreshFloatingOnInitialized) {
				d.refreshFloating()
			}
			d.initialize();
			d.triggerInitialized();
			if (d.config.fullscreen) {
				d.fireEvent("fullscreen", d)
			}
			d.fireEvent("initialize", d)
		},
		beforeInitConfig: function (b) {
			this.beforeInitialize.apply(this, arguments)
		},
		beforeInitialize: Ext.emptyFn,
		initialize: Ext.emptyFn,
		getTemplate: function () {
			return this.template
		},
		getElementConfig: function () {
			return {
				reference: "element",
				classList: ["x-unsized"],
				children: this.getTemplate()
			}
		},
		triggerInitialized: function () {
			var f = this.onInitializedListeners,
				g = f.length,
				h, e, d, b, c;
			if (!this.initialized) {
				this.initialized = true;
				if (g > 0) {
					for (c = 0; c < g; c++) {
						h = f[c];
						e = h.fn;
						d = h.scope;
						b = h.args;
						if (typeof e == "string") {
							d[e].apply(d, b)
						} else {
							e.apply(d, b)
						}
					}
					f.length = 0
				}
			}
		},
		onInitialized: function (e, d, b) {
			var c = this.onInitializedListeners;
			if (!d) {
				d = this
			}
			if (this.initialized) {
				if (typeof e == "string") {
					d[e].apply(d, b)
				} else {
					e.apply(d, b)
				}
			} else {
				c.push({
					fn: e,
					scope: d,
					args: b
				})
			}
		},
		renderTo: function (b, d) {
			var f = this.renderElement.dom,
				e = Ext.getDom(b),
				c = Ext.getDom(d);
			if (e) {
				if (c) {
					e.insertBefore(f, c)
				} else {
					e.appendChild(f)
				}
				this.setRendered(Boolean(f.offsetParent))
			}
		},
		setParent: function (c) {
			var b = this.parent;
			if (c && b && b !== c) {
				b.remove(this, false)
			}
			this.parent = c;
			return this
		},
		applyPlugins: function (b) {
			var d, c, e;
			if (!b) {
				return b
			}
			b = [].concat(b);
			for (c = 0, d = b.length; c < d; c++) {
				e = b[c];
				b[c] = Ext.factory(e, "Ext.plugin.Plugin", null, "plugin")
			}
			return b
		},
		updatePlugins: function (e, b) {
			var d, c;
			if (e) {
				for (c = 0, d = e.length; c < d; c++) {
					e[c].init(this)
				}
			}
			if (b) {
				for (c = 0, d = b.length; c < d; c++) {
					Ext.destroy(b[c])
				}
			}
		},
		updateRenderTo: function (b) {
			this.renderTo(b)
		},
		updateStyle: function (b) {
			this.element.applyStyles(b)
		},
		updateBorder: function (b) {
			this.element.setBorder(b)
		},
		updatePadding: function (b) {
			this.innerElement.setPadding(b)
		},
		updateMargin: function (b) {
			this.element.setMargin(b)
		},
		updateUi: function (b, e) {
			var d = this.getBaseCls(),
				c = this.element,
				f = this.currentUi;
			if (d) {
				if (e) {
					if (f) {
						c.removeCls(f)
					} else {
						c.removeCls(d + "-" + e)
					}
				}
				if (b) {
					c.addCls(b, d);
					this.currentUi = d + "-" + b
				}
			}
		},
		applyBaseCls: function (b) {
			return b || a + this.xtype
		},
		updateBaseCls: function (b, c) {
			var d = this,
				e = d.getUi();
			if (c) {
				this.element.removeCls(c);
				if (e) {
					this.element.removeCls(this.currentUi)
				}
			}
			if (b) {
				this.element.addCls(b);
				if (e) {
					this.element.addCls(b, null, e);
					this.currentUi = b + "-" + e
				}
			}
		},
		addCls: function (b, h, j) {
			var e = this.getCls(),
				g = (e) ? e.slice() : [],
				f, d, c;
			h = h || "";
			j = j || "";
			if (typeof b == "string") {
				b = [b]
			}
			f = b.length;
			if (!g.length && h === "" && j === "") {
				g = b
			} else {
				for (d = 0; d < f; d++) {
					c = h + b[d] + j;
					if (g.indexOf(c) == -1) {
						g.push(c)
					}
				}
			}
			this.setCls(g)
		},
		removeCls: function (b, g, h) {
			var d = this.getCls(),
				f = (d) ? d.slice() : [],
				e, c;
			g = g || "";
			h = h || "";
			if (typeof b == "string") {
				f = Ext.Array.remove(f, g + b + h)
			} else {
				e = b.length;
				for (c = 0; c < e; c++) {
					f = Ext.Array.remove(f, g + b[c] + h)
				}
			}
			this.setCls(f)
		},
		replaceCls: function (e, j, d, h) {
			var k = this.getCls(),
				f = (k) ? k.slice() : [],
				g, c, b;
			d = d || "";
			h = h || "";
			if (typeof e == "string") {
				f = Ext.Array.remove(f, d + e + h)
			} else {
				if (e) {
					g = e.length;
					for (c = 0; c < g; c++) {
						f = Ext.Array.remove(f, d + e[c] + h)
					}
				}
			}
			if (typeof j == "string") {
				f.push(d + j + h)
			} else {
				if (j) {
					g = j.length;
					if (!f.length && d === "" && h === "") {
						f = j
					} else {
						for (c = 0; c < g; c++) {
							b = d + j[c] + h;
							if (f.indexOf(b) == -1) {
								f.push(b)
							}
						}
					}
				}
			}
			this.setCls(f)
		},
		toggleCls: function (b, c) {
			this.element.toggleCls(b, c);
			return this
		},
		applyCls: function (b) {
			if (typeof b == "string") {
				b = [b]
			}
			if (!b || !b.length) {
				b = null
			}
			return b
		},
		updateCls: function (c, b) {
			if (this.element && ((c && !b) || (!c && b) || c.length != b.length || Ext.Array.difference(c, b).length > 0)) {
				this.element.replaceCls(b, c)
			}
		},
		updateStyleHtmlCls: function (d, b) {
			var e = this.innerHtmlElement,
				c = this.innerElement;
			if (this.getStyleHtmlContent() && b) {
				if (e) {
					e.replaceCls(b, d)
				} else {
					c.replaceCls(b, d)
				}
			}
		},
		applyStyleHtmlContent: function (b) {
			return Boolean(b)
		},
		updateStyleHtmlContent: function (d) {
			var b = this.getStyleHtmlCls(),
				c = this.innerElement,
				e = this.innerHtmlElement;
			if (d) {
				if (e) {
					e.addCls(b)
				} else {
					c.addCls(b)
				}
			} else {
				if (e) {
					e.removeCls(b)
				} else {
					c.addCls(b)
				}
			}
		},
		applyContentEl: function (b) {
			if (b) {
				return Ext.get(b)
			}
		},
		updateContentEl: function (b, c) {
			if (c) {
				c.hide();
				Ext.getBody().append(c)
			}
			if (b) {
				this.setHtml(b.dom);
				b.show()
			}
		},
		getSize: function () {
			return {
				width: this.getWidth(),
				height: this.getHeight()
			}
		},
		isCentered: function () {
			return Boolean(this.getCentered())
		},
		isFloating: function () {
			return this.floating
		},
		isDocked: function () {
			return Boolean(this.getDocked())
		},
		isInnerItem: function () {
			return this.isInner
		},
		setIsInner: function (b) {
			if (b !== this.isInner) {
				this.isInner = b;
				if (this.initialized) {
					this.fireEvent("innerstatechange", this, b)
				}
			}
		},
		filterLengthValue: function (b) {
			if (b === "auto" || (!b && b !== 0)) {
				return null
			}
			return b
		},
		applyTop: function (b) {
			return this.filterLengthValue(b)
		},
		applyRight: function (b) {
			return this.filterLengthValue(b)
		},
		applyBottom: function (b) {
			return this.filterLengthValue(b)
		},
		applyLeft: function (b) {
			return this.filterLengthValue(b)
		},
		applyWidth: function (b) {
			return this.filterLengthValue(b)
		},
		applyHeight: function (b) {
			return this.filterLengthValue(b)
		},
		applyMinWidth: function (b) {
			return this.filterLengthValue(b)
		},
		applyMinHeight: function (b) {
			return this.filterLengthValue(b)
		},
		applyMaxWidth: function (b) {
			return this.filterLengthValue(b)
		},
		applyMaxHeight: function (b) {
			return this.filterLengthValue(b)
		},
		doSetTop: function (b) {
			this.element.setTop(b);
			this.refreshFloating()
		},
		doSetRight: function (b) {
			this.element.setRight(b);
			this.refreshFloating()
		},
		doSetBottom: function (b) {
			this.element.setBottom(b);
			this.refreshFloating()
		},
		doSetLeft: function (b) {
			this.element.setLeft(b);
			this.refreshFloating()
		},
		doSetWidth: function (b) {
			this.element.setWidth(b);
			this.refreshSizeState()
		},
		doSetHeight: function (b) {
			this.element.setHeight(b);
			this.refreshSizeState()
		},
		applyFlex: function (b) {
			if (b) {
				b = Number(b);
				if (isNaN(b)) {
					b = null
				}
			} else {
				b = null
			}
			return b
		},
		doSetFlex: Ext.emptyFn,
		refreshSizeState: function () {
			this.refreshSizeStateOnInitialized = true
		},
		doRefreshSizeState: function () {
			var c = this.getWidth() !== null || this.widthLayoutSized || (this.getLeft() !== null && this.getRight() !== null),
				d = this.getHeight() !== null || this.heightLayoutSized || (this.getTop() !== null && this.getBottom() !== null),
				f = this.layoutStretched || this.hasCSSMinHeight || (!d && this.getMinHeight() !== null),
				e = c && d,
				b = (c && this.LAYOUT_WIDTH) | (d && this.LAYOUT_HEIGHT) | (f && this.LAYOUT_STRETCHED);
			if (!e && f) {
				e = null
			}
			this.setSizeState(e);
			this.setSizeFlags(b)
		},
		setLayoutSizeFlags: function (b) {
			this.layoutStretched = !! (b & this.LAYOUT_STRETCHED);
			this.widthLayoutSized = !! (b & this.LAYOUT_WIDTH);
			this.heightLayoutSized = !! (b & this.LAYOUT_HEIGHT);
			this.refreshSizeState()
		},
		setSizeFlags: function (b) {
			if (b !== this.sizeFlags) {
				this.sizeFlags = b;
				var c = !! (b & this.LAYOUT_WIDTH),
					d = !! (b & this.LAYOUT_HEIGHT),
					e = !! (b & this.LAYOUT_STRETCHED);
				if (c && !e && !d) {
					this.element.addCls("x-has-width")
				} else {
					this.element.removeCls("x-has-width")
				}
				if (d && !e && !c) {
					this.element.addCls("x-has-height")
				} else {
					this.element.removeCls("x-has-height")
				}
				if (this.initialized) {
					this.fireEvent("sizeflagschange", this, b)
				}
			}
		},
		getSizeFlags: function () {
			if (!this.initialized) {
				this.doRefreshSizeState()
			}
			return this.sizeFlags
		},
		setSizeState: function (b) {
			if (b !== this.sizeState) {
				this.sizeState = b;
				this.element.setSizeState(b);
				if (this.initialized) {
					this.fireEvent("sizestatechange", this, b)
				}
			}
		},
		getSizeState: function () {
			if (!this.initialized) {
				this.doRefreshSizeState()
			}
			return this.sizeState
		},
		doSetMinWidth: function (b) {
			this.element.setMinWidth(b)
		},
		doSetMinHeight: function (b) {
			this.element.setMinHeight(b);
			this.refreshSizeState()
		},
		doSetMaxWidth: function (b) {
			this.element.setMaxWidth(b)
		},
		doSetMaxHeight: function (b) {
			this.element.setMaxHeight(b)
		},
		applyCentered: function (b) {
			b = Boolean(b);
			if (b) {
				this.refreshInnerState = Ext.emptyFn;
				if (this.isFloating()) {
					this.resetFloating()
				}
				if (this.isDocked()) {
					this.setDocked(false)
				}
				this.setIsInner(false);
				delete this.refreshInnerState
			}
			return b
		},
		doSetCentered: function (b) {
			this.toggleCls(this.getFloatingCls(), b);
			if (!b) {
				this.refreshInnerState()
			}
		},
		applyDocked: function (b) {
			if (!b) {
				return null
			}
			this.refreshInnerState = Ext.emptyFn;
			if (this.isFloating()) {
				this.resetFloating()
			}
			if (this.isCentered()) {
				this.setCentered(false)
			}
			this.setIsInner(false);
			delete this.refreshInnerState;
			return b
		},
		doSetDocked: function (c, b) {
			this.fireEvent("afterdockedchange", this, c, b);
			if (!c) {
				this.refreshInnerState()
			}
		},
		resetFloating: function () {
			this.setTop(null);
			this.setRight(null);
			this.setBottom(null);
			this.setLeft(null)
		},
		refreshInnerState: function () {
			this.setIsInner(!this.isCentered() && !this.isFloating() && !this.isDocked())
		},
		refreshFloating: function () {
			this.refreshFloatingOnInitialized = true
		},
		doRefreshFloating: function () {
			var c = true,
				b = this.getFloatingCls();
			if (this.getTop() === null && this.getBottom() === null && this.getRight() === null && this.getLeft() === null) {
				c = false
			} else {
				this.refreshSizeState()
			}
			if (c !== this.floating) {
				this.floating = c;
				if (c) {
					this.refreshInnerState = Ext.emptyFn;
					if (this.isCentered()) {
						this.setCentered(false)
					}
					if (this.isDocked()) {
						this.setDocked(false)
					}
					this.setIsInner(false);
					delete this.refreshInnerState
				}
				this.element.toggleCls(b, c);
				if (this.initialized) {
					this.fireEvent("floatingchange", this, c)
				}
				if (!c) {
					this.refreshInnerState()
				}
			}
		},
		updateFloatingCls: function (b, c) {
			if (this.isFloating()) {
				this.replaceCls(c, b)
			}
		},
		applyDisabled: function (b) {
			return Boolean(b)
		},
		doSetDisabled: function (b) {
			this.element[b ? "addCls" : "removeCls"](this.getDisabledCls())
		},
		updateDisabledCls: function (b, c) {
			if (this.isDisabled()) {
				this.element.replaceCls(c, b)
			}
		},
		disable: function () {
			this.setDisabled(true)
		},
		enable: function () {
			this.setDisabled(false)
		},
		isDisabled: function () {
			return this.getDisabled()
		},
		applyZIndex: function (b) {
			if (!b && b !== 0) {
				b = null
			}
			if (b !== null) {
				b = Number(b);
				if (isNaN(b)) {
					b = null
				}
			}
			return b
		},
		updateZIndex: function (d) {
			var c = this.element,
				b;
			if (c && !c.isDestroyed) {
				b = c.dom.style;
				if (d !== null) {
					b.setProperty("z-index", d, "important")
				} else {
					b.removeProperty("z-index")
				}
			}
		},
		getInnerHtmlElement: function () {
			var b = this.innerHtmlElement,
				c = this.getStyleHtmlCls();
			if (!b || !b.dom || !b.dom.parentNode) {
				this.innerHtmlElement = b = this.innerElement.createChild({
					cls: "x-innerhtml "
				});
				if (this.getStyleHtmlContent()) {
					this.innerHtmlElement.addCls(c);
					this.innerElement.removeCls(c)
				}
			}
			return b
		},
		updateHtml: function (b) {
			var c = this.getInnerHtmlElement();
			if (Ext.isElement(b)) {
				c.setHtml("");
				c.append(b)
			} else {
				c.setHtml(b)
			}
		},
		applyHidden: function (b) {
			return Boolean(b)
		},
		doSetHidden: function (c) {
			var b = this.renderElement;
			if (b.isDestroyed) {
				return
			}
			if (c) {
				b.hide()
			} else {
				b.show()
			}
			if (this.element) {
				this.element[c ? "addCls" : "removeCls"](this.getHiddenCls())
			}
			this.fireEvent(c ? "hide" : "show", this)
		},
		updateHiddenCls: function (b, c) {
			if (this.isHidden()) {
				this.element.replaceCls(c, b)
			}
		},
		isHidden: function () {
			return this.getHidden()
		},
		hide: function (b) {
			if (!this.getHidden()) {
				if (b === undefined || (b && b.isComponent)) {
					b = this.getHideAnimation()
				}
				if (b) {
					if (b === true) {
						b = "fadeOut"
					}
					this.onBefore({
						hiddenchange: "animateFn",
						scope: this,
						single: true,
						args: [b]
					})
				}
				this.setHidden(true)
			}
			return this
		},
		show: function (c) {
			var b = this.getHidden();
			if (b || b === null) {
				if (c === true) {
					c = "fadeIn"
				} else {
					if (c === undefined || (c && c.isComponent)) {
						c = this.getShowAnimation()
					}
				}
				if (c) {
					this.onBefore({
						hiddenchange: "animateFn",
						scope: this,
						single: true,
						args: [c]
					})
				}
				this.setHidden(false)
			}
			return this
		},
		animateFn: function (g, e, h, d, c, b) {
			if (g && (!h || (h && this.isPainted()))) {
				var f = new Ext.fx.Animation(g);
				f.setElement(e.element);
				if (h) {
					f.setOnEnd(function () {
						b.resume()
					});
					b.pause()
				}
				Ext.Animator.run(f)
			}
		},
		setVisibility: function (b) {
			this.renderElement.setVisibility(b)
		},
		isRendered: function () {
			return this.rendered
		},
		isPainted: function () {
			return this.renderElement.isPainted()
		},
		applyTpl: function (b) {
			return (Ext.isObject(b) && b.isTemplate) ? b : new Ext.XTemplate(b)
		},
		applyData: function (b) {
			if (Ext.isObject(b)) {
				return Ext.apply({}, b)
			} else {
				if (!b) {
					b = {}
				}
			}
			return b
		},
		updateData: function (d) {
			var e = this;
			if (d) {
				var c = e.getTpl(),
					b = e.getTplWriteMode();
				if (c) {
					c[b](e.getInnerHtmlElement(), d)
				}
				this.fireEvent("updatedata", e, d)
			}
		},
		applyRecord: function (b) {
			if (b && Ext.isObject(b) && b.isModel) {
				return b
			}
			return null
		},
		updateRecord: function (c, b) {
			var d = this;
			if (b) {
				b.unjoin(d)
			}
			if (!c) {
				d.updateData("")
			} else {
				c.join(d);
				d.updateData(c.getData(true))
			}
		},
		afterEdit: function () {
			this.updateRecord(this.getRecord())
		},
		afterErase: function () {
			this.setRecord(null)
		},
		applyItemId: function (b) {
			return b || this.getId()
		},
		isXType: function (c, b) {
			if (b) {
				return this.xtypes.indexOf(c) != -1
			}
			return Boolean(this.xtypesMap[c])
		},
		getXTypes: function () {
			return this.xtypesChain.join("/")
		},
		getDraggableBehavior: function () {
			var b = this.draggableBehavior;
			if (!b) {
				b = this.draggableBehavior = new Ext.behavior.Draggable(this)
			}
			return b
		},
		applyDraggable: function (b) {
			this.getDraggableBehavior().setConfig(b)
		},
		getDraggable: function () {
			return this.getDraggableBehavior().getDraggable()
		},
		getTranslatableBehavior: function () {
			var b = this.translatableBehavior;
			if (!b) {
				b = this.translatableBehavior = new Ext.behavior.Translatable(this)
			}
			return b
		},
		applyTranslatable: function (b) {
			this.getTranslatableBehavior().setConfig(b)
		},
		getTranslatable: function () {
			return this.getTranslatableBehavior().getTranslatable()
		},
		translateAxis: function (c, e, d) {
			var b, f;
			if (c === "x") {
				b = e
			} else {
				f = e
			}
			return this.translate(b, f, d)
		},
		translate: function () {
			var b = this.getTranslatable();
			if (!b) {
				this.setTranslatable(true);
				b = this.getTranslatable()
			}
			b.translate.apply(b, arguments)
		},
		setRendered: function (c) {
			var b = this.rendered;
			if (c !== b) {
				this.rendered = c;
				return true
			}
			return false
		},
		setSize: function (c, b) {
			if (c != undefined) {
				this.setWidth(c)
			}
			if (b != undefined) {
				this.setHeight(b)
			}
		},
		doAddListener: function (d, f, e, c, b) {
			if (c && "element" in c) {
				return this[c.element].doAddListener(d, f, e || this, c, b)
			}
			if (d == "painted" || d == "resize") {
				return this.element.doAddListener(d, f, e || this, c, b)
			}
			return this.callParent(arguments)
		},
		doRemoveListener: function (d, f, e, c, b) {
			if (c && "element" in c) {
				this[c.element].doRemoveListener(d, f, e || this, c, b)
			}
			return this.callParent(arguments)
		},
		showBy: function (c, f) {
			var e = this,
				b = Ext.Viewport,
				d = e.getParent();
			e.setVisibility(false);
			if (d !== b) {
				b.add(e)
			}
			e.show();
			e.on({
				hide: "onShowByErased",
				destroy: "onShowByErased",
				single: true,
				scope: e
			});
			b.on("resize", "alignTo", e, {
				args: [c, f]
			});
			e.alignTo(c, f);
			e.setVisibility(true)
		},
		onShowByErased: function () {
			Ext.Viewport.un("resize", "alignTo", this)
		},
		alignTo: function (p, k) {
			var f = p.isComponent ? p.renderElement : p,
				c = this.renderElement,
				r = f.getPageBox(),
				C = this.getParent().element.getPageBox(),
				o = c.getPageBox(),
				z = r.height,
				q = r.width,
				u = o.height,
				w = o.width;
			C.bottom -= 5;
			C.height -= 10;
			C.left += 5;
			C.right -= 5;
			C.top += 5;
			C.width -= 10;
			if (!k || k === "auto") {
				if (C.bottom - r.bottom < u) {
					if (r.top - C.top < u) {
						if (r.left - C.left < w) {
							k = "cl-cr?"
						} else {
							k = "cr-cl?"
						}
					} else {
						k = "bc-tc?"
					}
				} else {
					k = "tc-bc?"
				}
			}
			var b = k.match(this.alignmentRegex);
			var x = b[1].split(""),
				d = b[2].split(""),
				A = (b[3] === "?"),
				j = x[0],
				v = x[1] || j,
				n = d[0],
				m = d[1] || n,
				s = r.top,
				e = r.left,
				l = z / 2,
				g = q / 2,
				h = w / 2,
				t = u / 2,
				y, B;
			switch (j) {
			case "t":
				switch (n) {
				case "c":
					s += l;
					break;
				case "b":
					s += z
				}
				break;
			case "b":
				switch (n) {
				case "c":
					s -= (u - l);
					break;
				case "t":
					s -= u;
					break;
				case "b":
					s -= u - z
				}
				break;
			case "c":
				switch (n) {
				case "t":
					s -= t;
					break;
				case "c":
					s -= (t - l);
					break;
				case "b":
					s -= (t - z)
				}
				break
			}
			switch (v) {
			case "l":
				switch (m) {
				case "c":
					e += l;
					break;
				case "r":
					e += q
				}
				break;
			case "r":
				switch (m) {
				case "r":
					e -= (w - q);
					break;
				case "c":
					e -= (w - h);
					break;
				case "l":
					e -= w
				}
				break;
			case "c":
				switch (m) {
				case "l":
					e -= h;
					break;
				case "c":
					e -= (h - g);
					break;
				case "r":
					e -= (h - q)
				}
				break
			}
			if (A) {
				y = (C.left + C.width) - w;
				B = (C.top + C.height) - u;
				e = Math.max(C.left, Math.min(y, e));
				s = Math.max(C.top, Math.min(B, s))
			}
			this.setLeft(e);
			this.setTop(s)
		},
		up: function (c) {
			var b = this.parent;
			if (c) {
				for (; b; b = b.parent) {
					if (Ext.ComponentQuery.is(b, c)) {
						return b
					}
				}
			}
			return b
		},
		getBubbleTarget: function () {
			return this.getParent()
		},
		destroy: function () {
			this.destroy = Ext.emptyFn;
			var e = this.getParent(),
				c = this.referenceList,
				d, f, b;
			this.isDestroying = true;
			Ext.destroy(this.getTranslatable(), this.getPlugins());
			if (e) {
				e.remove(this, false)
			}
			for (d = 0, f = c.length; d < f; d++) {
				b = c[d];
				this[b].destroy();
				delete this[b]
			}
			Ext.destroy(this.innerHtmlElement);
			this.setRecord(null);
			this.callSuper();
			Ext.ComponentManager.unregister(this)
		}
	}, function () {})
})(Ext.baseCSSPrefix);
Ext.define("Ext.layout.wrapper.Inner", {
	config: {
		sizeState: null,
		container: null
	},
	constructor: function (a) {
		this.initConfig(a)
	},
	getElement: function () {
		return this.getContainer().bodyElement
	},
	setInnerWrapper: Ext.emptyFn,
	getInnerWrapper: Ext.emptyFn
});
Ext.define("Ext.layout.Abstract", {
	mixins: [Ext.mixin.Observable],
	isLayout: true,
	constructor: function (a) {
		this.initialConfig = a
	},
	setContainer: function (a) {
		this.container = a;
		this.initConfig(this.initialConfig);
		return this
	},
	onItemAdd: function () {},
	onItemRemove: function () {},
	onItemMove: function () {},
	onItemCenteredChange: function () {},
	onItemFloatingChange: function () {},
	onItemDockedChange: function () {},
	onItemInnerStateChange: function () {}
});
Ext.define("Ext.mixin.Bindable", {
	extend: Ext.mixin.Mixin,
	mixinConfig: {
		id: "bindable"
	},
	bind: function (a, d, h, c, b) {
		if (!h) {
			h = d
		}
		var f = a[d],
			e, g;
		if (f && f.hasOwnProperty("$binding")) {
			g = f.$binding;
			if (g.bindingMethod === h && g.bindingScope === this) {
				return this
			}
		}
		a[d] = e = function () {
			var l = e.$binding,
				k = l.bindingScope,
				j = Array.prototype.slice.call(arguments);
			j.push(arguments);
			if (b) {
				j.push.apply(j, b)
			}
			if (!l.preventDefault && k[l.bindingMethod].apply(k, j) !== false) {
				return l.boundFn.apply(this, arguments)
			}
		};
		e.$binding = {
			preventDefault: !! c,
			boundFn: f,
			bindingMethod: h,
			bindingScope: this
		};
		return this
	},
	unbind: function (a, b, g) {
		if (!g) {
			g = b
		}
		var d = a[b],
			e = d.$binding,
			c, f;
		while (e) {
			c = e.boundFn;
			if (e.bindingMethod === g && e.bindingScope === this) {
				if (f) {
					f.boundFn = c
				} else {
					a[b] = c
				}
				return this
			}
			f = e;
			e = c.$binding
		}
		return this
	}
});
Ext.define("Ext.util.Wrapper", {
	mixins: [Ext.mixin.Bindable],
	constructor: function (c, b) {
		var a = this.link("element", Ext.Element.create(c));
		if (b) {
			a.insertBefore(b);
			this.wrap(b)
		}
	},
	bindSize: function (b) {
		var c = this.wrappedElement,
			a;
		this.boundSizeName = b;
		this.boundMethodName = a = b === "width" ? "setWidth" : "setHeight";
		this.bind(c, a, "onBoundSizeChange");
		c[a].call(c, c.getStyleValue(b))
	},
	onBoundSizeChange: function (c, a) {
		var b = this.element;
		if (typeof c === "string" && c.substr(-1) === "%") {
			a[0] = "100%"
		} else {
			c = ""
		}
		b[this.boundMethodName].call(b, c)
	},
	wrap: function (c) {
		var b = this.element,
			a;
		this.wrappedElement = c;
		a = b.dom;
		while (a.firstElementChild !== null) {
			a = a.firstElementChild
		}
		a.appendChild(c.dom)
	},
	destroy: function () {
		var d = this.element,
			f = d.dom,
			e = this.wrappedElement,
			b = this.boundMethodName,
			a = f.parentNode,
			c;
		if (b) {
			this.unbind(e, b, "onBoundSizeChange");
			c = d.getStyle(this.boundSizeName);
			if (c) {
				e[b].call(e, c)
			}
		}
		if (a) {
			if (!e.isDestroyed) {
				a.replaceChild(f.firstElementChild, f)
			}
			delete this.wrappedElement
		}
		this.callSuper()
	}
});
Ext.define("Ext.layout.wrapper.BoxDock", {
	config: {
		direction: "horizontal",
		element: {
			className: "x-dock"
		},
		bodyElement: {
			className: "x-dock-body"
		},
		innerWrapper: null,
		sizeState: false,
		container: null
	},
	positionMap: {
		top: "start",
		left: "start",
		bottom: "end",
		right: "end"
	},
	constructor: function (a) {
		this.items = {
			start: [],
			end: []
		};
		this.itemsCount = 0;
		this.initConfig(a)
	},
	addItems: function (a) {
		var b, d, c;
		for (b = 0, d = a.length; b < d; b++) {
			c = a[b];
			this.addItem(c)
		}
	},
	addItem: function (n) {
		var o = n.getDocked(),
			g = this.positionMap[o],
			a = n.$dockWrapper,
			b = this.getContainer(),
			h = b.indexOf(n),
			f = n.element,
			l = this.items,
			k = l[g],
			e, j, m, d, c;
		if (a) {
			a.removeItem(n)
		}
		n.$dockWrapper = this;
		n.addCls("x-dock-item");
		n.addCls("x-docked-" + o);
		for (e = 0, j = k.length; e < j; e++) {
			m = k[e];
			c = b.indexOf(m);
			if (c > h) {
				d = m.element;
				k.splice(e, 0, n);
				break
			}
		}
		if (!d) {
			k.push(n);
			d = this.getBodyElement()
		}
		this.itemsCount++;
		if (g === "start") {
			f.insertBefore(d)
		} else {
			f.insertAfter(d)
		}
	},
	removeItem: function (c) {
		var a = c.getDocked(),
			b = this.items[this.positionMap[a]];
		Ext.Array.remove(b, c);
		c.element.detach();
		delete c.$dockWrapper;
		c.removeCls("x-dock-item");
		c.removeCls("x-docked-" + a);
		if (--this.itemsCount === 0) {
			this.destroy()
		}
	},
	getItemsSlice: function (c) {
		var a = this.getContainer(),
			b = this.items,
			h = [],
			g, d, f, e;
		for (g = b.start, d = 0, f = g.length; d < f; d++) {
			e = g[d];
			if (a.indexOf(e) > c) {
				h.push(e)
			}
		}
		for (g = b.end, d = 0, f = g.length; d < f; d++) {
			e = g[d];
			if (a.indexOf(e) > c) {
				h.push(e)
			}
		}
		return h
	},
	applyElement: function (a) {
		return Ext.Element.create(a)
	},
	updateElement: function (a) {
		a.addCls("x-dock-" + this.getDirection())
	},
	applyBodyElement: function (a) {
		return Ext.Element.create(a)
	},
	updateBodyElement: function (a) {
		this.getElement().append(a)
	},
	updateInnerWrapper: function (a, c) {
		var b = this.getBodyElement();
		if (c && c.$outerWrapper === this) {
			c.getElement().detach();
			delete c.$outerWrapper
		}
		if (a) {
			a.setSizeState(this.getSizeState());
			a.$outerWrapper = this;
			b.append(a.getElement())
		}
	},
	updateSizeState: function (b) {
		var a = this.getInnerWrapper();
		this.getElement().setSizeState(b);
		if (a) {
			a.setSizeState(b)
		}
	},
	destroy: function () {
		var c = this.getInnerWrapper(),
			b = this.$outerWrapper,
			a;
		if (c) {
			if (b) {
				b.setInnerWrapper(c)
			} else {
				a = c.getElement();
				if (!a.isDestroyed) {
					a.replace(this.getElement())
				}
				delete c.$outerWrapper
			}
		}
		delete this.$outerWrapper;
		this.setInnerWrapper(null);
		this.unlink("_bodyElement", "_element");
		this.callSuper()
	}
});
Ext.define("Ext.layout.Default", {
	extend: Ext.layout.Abstract,
	isAuto: true,
	alias: ["layout.default", "layout.auto"],
	config: {
		animation: null
	},
	centerWrapperClass: "x-center",
	dockWrapperClass: "x-dock",
	positionMap: {
		top: "start",
		left: "start",
		middle: "center",
		bottom: "end",
		right: "end"
	},
	positionDirectionMap: {
		top: "vertical",
		bottom: "vertical",
		left: "horizontal",
		right: "horizontal"
	},
	setContainer: function (a) {
		var b = {
			delegate: "> component"
		};
		this.dockedItems = [];
		this.callSuper(arguments);
		a.on("centeredchange", "onItemCenteredChange", this, b, "before").on("floatingchange", "onItemFloatingChange", this, b, "before").on("dockedchange", "onBeforeItemDockedChange", this, b, "before").on("afterdockedchange", "onAfterItemDockedChange", this, b)
	},
	monitorSizeStateChange: function () {
		this.monitorSizeStateChange = Ext.emptyFn;
		this.container.on("sizestatechange", "onContainerSizeStateChange", this)
	},
	monitorSizeFlagsChange: function () {
		this.monitorSizeFlagsChange = Ext.emptyFn;
		this.container.on("sizeflagschange", "onContainerSizeFlagsChange", this)
	},
	onItemAdd: function (a) {
		var b = a.getDocked();
		if (b !== null) {
			this.dockItem(a)
		} else {
			if (a.isCentered()) {
				this.onItemCenteredChange(a, true)
			} else {
				if (a.isFloating()) {
					this.onItemFloatingChange(a, true)
				} else {
					this.onItemInnerStateChange(a, true)
				}
			}
		}
	},
	onItemInnerStateChange: function (b, a, c) {
		if (a) {
			this.insertInnerItem(b, this.container.innerIndexOf(b))
		} else {
			this.removeInnerItem(b)
		}
	},
	insertInnerItem: function (f, d) {
		var b = this.container,
			h = b.innerElement.dom,
			e = f.element.dom,
			g = d !== -1 ? b.getInnerAt(d + 1) : null,
			c = null,
			a;
		if (g) {
			a = g.getTranslatable();
			if (a && a.getUseWrapper()) {
				c = a.getWrapper().dom
			} else {
				c = g ? g.element.dom : null
			}
		}
		h.insertBefore(e, c);
		return this
	},
	insertBodyItem: function (c) {
		var a = this.container.setUseBodyElement(true),
			b = a.bodyElement.dom;
		if (c.getZIndex() === null) {
			c.setZIndex((a.indexOf(c) + 1) * 2)
		}
		b.insertBefore(c.element.dom, b.firstChild);
		return this
	},
	removeInnerItem: function (a) {
		a.element.detach()
	},
	removeBodyItem: function (a) {
		a.setZIndex(null);
		a.element.detach()
	},
	onItemRemove: function (b, a, c) {
		var d = b.getDocked();
		if (d) {
			this.undockItem(b)
		} else {
			if (b.isCentered()) {
				this.onItemCenteredChange(b, false)
			} else {
				if (b.isFloating()) {
					this.onItemFloatingChange(b, false)
				} else {
					this.onItemInnerStateChange(b, false, c)
				}
			}
		}
	},
	onItemMove: function (b, c, a) {
		if (b.isCentered() || b.isFloating()) {
			b.setZIndex((c + 1) * 2)
		} else {
			if (b.isInnerItem()) {
				this.insertInnerItem(b, this.container.innerIndexOf(b))
			} else {
				this.undockItem(b);
				this.dockItem(b)
			}
		}
	},
	onItemCenteredChange: function (c, a) {
		var b = "$centerWrapper";
		if (a) {
			this.insertBodyItem(c);
			c.link(b, new Ext.util.Wrapper({
				className: this.centerWrapperClass
			}, c.element))
		} else {
			c.unlink(b);
			this.removeBodyItem(c)
		}
	},
	onItemFloatingChange: function (a, b) {
		if (b) {
			this.insertBodyItem(a)
		} else {
			this.removeBodyItem(a)
		}
	},
	onBeforeItemDockedChange: function (a, c, b) {
		if (b) {
			this.undockItem(a)
		}
	},
	onAfterItemDockedChange: function (a, c, b) {
		if (c) {
			this.dockItem(a)
		}
	},
	onContainerSizeStateChange: function () {
		var a = this.getDockWrapper();
		if (a) {
			a.setSizeState(this.container.getSizeState())
		}
	},
	onContainerSizeFlagsChange: function () {
		var a = this.dockedItems,
			b, d, c;
		for (b = 0, d = a.length; b < d; b++) {
			c = a[b];
			this.refreshDockedItemLayoutSizeFlags(c)
		}
	},
	refreshDockedItemLayoutSizeFlags: function (d) {
		var b = this.container,
			e = this.positionDirectionMap[d.getDocked()],
			c = (e === "horizontal") ? b.LAYOUT_HEIGHT : b.LAYOUT_WIDTH,
			a = (b.getSizeFlags() & c);
		d.setLayoutSizeFlags(a)
	},
	dockItem: function (s) {
		var b = Ext.layout.wrapper.BoxDock,
			p = this.dockedItems,
			g = p.length,
			h = this.container,
			t = h.indexOf(s),
			f = this.positionDirectionMap,
			u = f[s.getDocked()],
			r = this.dockInnerWrapper,
			l, m, v, e, q, k, n, a, d, o, c, j;
		this.monitorSizeStateChange();
		this.monitorSizeFlagsChange();
		if (!r) {
			r = this.link("dockInnerWrapper", new Ext.layout.wrapper.Inner({
				container: this.container
			}))
		}
		if (g === 0) {
			p.push(s);
			o = new b({
				container: this.container,
				direction: u
			});
			o.addItem(s);
			o.getElement().replace(r.getElement());
			o.setInnerWrapper(r);
			h.onInitialized("onContainerSizeStateChange", this)
		} else {
			for (m = 0; m < g; m++) {
				v = p[m];
				e = h.indexOf(v);
				if (e > t) {
					n = q || p[0];
					p.splice(m, 0, s);
					break
				}
				q = v
			}
			if (!n) {
				n = p[g - 1];
				p.push(s)
			}
			a = n.getDocked();
			d = n.$dockWrapper;
			l = f[a];
			if (u === l) {
				d.addItem(s)
			} else {
				k = d.getItemsSlice(t);
				o = new b({
					container: this.container,
					direction: u
				});
				if (k.length > 0) {
					if (k.length === d.itemsCount) {
						c = d;
						o.setSizeState(c.getSizeState());
						o.getElement().replace(c.getElement())
					} else {
						c = new b({
							container: this.container,
							direction: l
						});
						c.setInnerWrapper(d.getInnerWrapper());
						c.addItems(k);
						d.setInnerWrapper(o)
					}
					o.setInnerWrapper(c)
				} else {
					j = d.getInnerWrapper();
					d.setInnerWrapper(null);
					o.setInnerWrapper(j);
					d.setInnerWrapper(o)
				}
				o.addItem(s)
			}
		}
		h.onInitialized("refreshDockedItemLayoutSizeFlags", this, [s])
	},
	getDockWrapper: function () {
		var a = this.dockedItems;
		if (a.length > 0) {
			return a[0].$dockWrapper
		}
		return null
	},
	undockItem: function (b) {
		var a = this.dockedItems;
		if (b.$dockWrapper) {
			b.$dockWrapper.removeItem(b)
		}
		Ext.Array.remove(a, b);
		b.setLayoutSizeFlags(0)
	},
	destroy: function () {
		this.dockedItems.length = 0;
		delete this.dockedItems;
		this.callSuper()
	}
});
Ext.define("Ext.layout.Box", {
	extend: Ext.layout.Default,
	config: {
		orient: "horizontal",
		align: "start",
		pack: "start"
	},
	alias: "layout.tablebox",
	layoutBaseClass: "x-layout-tablebox",
	itemClass: "x-layout-tablebox-item",
	setContainer: function (a) {
		this.callSuper(arguments);
		a.innerElement.addCls(this.layoutBaseClass);
		a.on("flexchange", "onItemFlexChange", this, {
			delegate: "> component"
		})
	},
	onItemInnerStateChange: function (b, a) {
		this.callSuper(arguments);
		b.toggleCls(this.itemClass, a)
	},
	onItemFlexChange: function () {}
});
Ext.define("Ext.layout.FlexBox", {
	extend: Ext.layout.Box,
	alias: "layout.box",
	config: {
		align: "stretch"
	},
	layoutBaseClass: "x-layout-box",
	itemClass: "x-layout-box-item",
	setContainer: function (a) {
		this.callSuper(arguments);
		this.monitorSizeFlagsChange()
	},
	applyOrient: function (a) {
		return a
	},
	updateOrient: function (c, b) {
		var a = this.container,
			d = {
				delegate: "> component"
			};
		if (c === "horizontal") {
			this.sizePropertyName = "width"
		} else {
			this.sizePropertyName = "height"
		}
		a.innerElement.swapCls("x-" + c, "x-" + b);
		if (b) {
			a.un(b === "horizontal" ? "widthchange" : "heightchange", "onItemSizeChange", this, d);
			this.redrawContainer()
		}
		a.on(c === "horizontal" ? "widthchange" : "heightchange", "onItemSizeChange", this, d)
	},
	onItemInnerStateChange: function (d, c) {
		this.callSuper(arguments);
		var a, b;
		d.toggleCls(this.itemClass, c);
		if (c) {
			a = d.getFlex();
			b = d.get(this.sizePropertyName);
			if (a) {
				this.doItemFlexChange(d, a)
			} else {
				if (b) {
					this.doItemSizeChange(d, b)
				}
			}
		}
		this.refreshItemSizeState(d)
	},
	refreshItemSizeState: function (e) {
		var c = e.isInnerItem(),
			a = this.container,
			f = a.LAYOUT_HEIGHT,
			d = a.LAYOUT_WIDTH,
			g = this.sizePropertyName,
			b = 0,
			h = a.getSizeFlags();
		if (c) {
			b |= a.LAYOUT_STRETCHED;
			if (this.getAlign() === "stretch") {
				b |= h & (g === "width" ? f : d)
			}
			if (e.getFlex()) {
				b |= h & (g === "width" ? d : f)
			}
		}
		e.setLayoutSizeFlags(b)
	},
	refreshAllItemSizedStates: function () {
		var d = this.container.innerItems,
			a, c, b;
		for (a = 0, c = d.length; a < c; a++) {
			b = d[a];
			this.refreshItemSizeState(b)
		}
	},
	onContainerSizeFlagsChange: function () {
		this.refreshAllItemSizedStates();
		this.callSuper(arguments)
	},
	onItemSizeChange: function (b, a) {
		if (b.isInnerItem()) {
			this.doItemSizeChange(b, a)
		}
	},
	doItemSizeChange: function (b, a) {
		if (a) {
			b.setFlex(null);
			this.redrawContainer()
		}
	},
	onItemFlexChange: function (b, a) {
		if (b.isInnerItem()) {
			this.doItemFlexChange(b, a);
			this.refreshItemSizeState(b)
		}
	},
	doItemFlexChange: function (b, a) {
		this.setItemFlex(b, a);
		if (a) {
			b.set(this.sizePropertyName, null)
		} else {
			this.redrawContainer()
		}
	},
	redrawContainer: function () {
		var a = this.container,
			b = a.element.dom.parentNode;
		if (b && b.nodeType !== 11) {
			a.innerElement.redraw()
		}
	},
	setItemFlex: function (c, a) {
		var b = c.element;
		b.toggleCls("x-flexed", !! a);
		if (!a) {
			a = ""
		} else {
			a = String(a)
		}
		if (Ext.browser.is.WebKit) {
			b.dom.style.setProperty("-webkit-box-flex", a, null)
		} else {
			if (Ext.browser.is.IE) {
				b.dom.style.setProperty("-ms-flex", a + " 0 0px", null)
			} else {
				b.dom.style.setProperty("flex", a + " 0 0px", null)
			}
		}
	},
	convertPosition: function (a) {
		var b = this.positionMap;
		if (b.hasOwnProperty(a)) {
			return b[a]
		}
		return a
	},
	applyAlign: function (a) {
		return this.convertPosition(a)
	},
	updateAlign: function (c, b) {
		var a = this.container;
		a.innerElement.swapCls(c, b, true, "x-align");
		if (b !== undefined) {
			this.refreshAllItemSizedStates()
		}
	},
	applyPack: function (a) {
		return this.convertPosition(a)
	},
	updatePack: function (a, b) {
		this.container.innerElement.swapCls(a, b, true, "x-pack")
	}
});
Ext.define("Ext.layout.HBox", {
	extend: Ext.layout.FlexBox,
	alias: "layout.hbox"
});
Ext.define("Ext.layout.Fit", {
	extend: Ext.layout.Default,
	isFit: true,
	alias: "layout.fit",
	layoutClass: "x-layout-fit",
	itemClass: "x-layout-fit-item",
	setContainer: function (a) {
		this.callSuper(arguments);
		a.innerElement.addCls(this.layoutClass);
		this.onContainerSizeFlagsChange();
		this.monitorSizeFlagsChange()
	},
	onContainerSizeFlagsChange: function () {
		var a = this.container,
			b = a.getSizeFlags(),
			g = Boolean(b & a.LAYOUT_STRETCHED),
			f = a.innerItems,
			c, e, d;
		this.callSuper();
		for (c = 0, e = f.length; c < e; c++) {
			d = f[c];
			d.setLayoutSizeFlags(b)
		}
		a.innerElement.toggleCls("x-stretched", g)
	},
	onItemInnerStateChange: function (b, a) {
		this.callSuper(arguments);
		b.toggleCls(this.itemClass, a);
		b.setLayoutSizeFlags(a ? this.container.getSizeFlags() : 0)
	}
});
Ext.define("Ext.layout.Float", {
	extend: Ext.layout.Default,
	alias: "layout.float",
	config: {
		direction: "left"
	},
	layoutClass: "layout-float",
	itemClass: "layout-float-item",
	setContainer: function (a) {
		this.callSuper(arguments);
		a.innerElement.addCls(this.layoutClass)
	},
	onItemInnerStateChange: function (b, a) {
		this.callSuper(arguments);
		b.toggleCls(this.itemClass, a)
	},
	updateDirection: function (c, a) {
		var b = "direction-";
		this.container.innerElement.swapCls(b + c, b + a)
	}
});
Ext.define("Ext.layout.wrapper.Dock", {
	config: {
		direction: "horizontal",
		element: {
			className: "x-dock"
		},
		bodyElement: {
			className: "x-dock-body"
		},
		innerWrapper: null,
		sizeState: false,
		container: null
	},
	positionMap: {
		top: "start",
		left: "start",
		bottom: "end",
		right: "end"
	},
	constructor: function (a) {
		this.items = {
			start: [],
			end: []
		};
		this.itemsCount = 0;
		this.initConfig(a)
	},
	addItems: function (a) {
		var b, d, c;
		for (b = 0, d = a.length; b < d; b++) {
			c = a[b];
			this.addItem(c)
		}
	},
	addItem: function (o) {
		var p = o.getDocked(),
			h = this.positionMap[p],
			b = o.$dockWrapper,
			c = this.getContainer(),
			j = c.indexOf(o),
			m = this.items,
			l = m[h],
			a, g, f, k, n, e, d;
		if (b) {
			b.removeItem(o)
		}
		o.$dockWrapper = this;
		a = o.link("$dockItemWrapper", new Ext.util.Wrapper({
			className: "x-dock-item"
		}));
		o.addCls("x-docked-" + p);
		g = a.element;
		for (f = 0, k = l.length; f < k; f++) {
			n = l[f];
			d = c.indexOf(n);
			if (d > j) {
				e = n.element;
				l.splice(f, 0, o);
				break
			}
		}
		if (!e) {
			l.push(o);
			e = this.getBodyElement()
		}
		this.itemsCount++;
		if (h === "start") {
			g.insertBefore(e)
		} else {
			g.insertAfter(e)
		}
		a.wrap(o.element);
		a.bindSize(this.getDirection() === "horizontal" ? "width" : "height")
	},
	removeItem: function (c) {
		var a = c.getDocked(),
			b = this.items[this.positionMap[a]];
		c.removeCls("x-docked-" + a);
		Ext.Array.remove(b, c);
		c.unlink("$dockItemWrapper");
		c.element.detach();
		delete c.$dockWrapper;
		if (--this.itemsCount === 0) {
			this.destroy()
		}
	},
	getItemsSlice: function (c) {
		var a = this.getContainer(),
			b = this.items,
			h = [],
			g, d, f, e;
		for (g = b.start, d = 0, f = g.length; d < f; d++) {
			e = g[d];
			if (a.indexOf(e) > c) {
				h.push(e)
			}
		}
		for (g = b.end, d = 0, f = g.length; d < f; d++) {
			e = g[d];
			if (a.indexOf(e) > c) {
				h.push(e)
			}
		}
		return h
	},
	applyElement: function (a) {
		return Ext.Element.create(a)
	},
	updateElement: function (a) {
		a.addCls("x-dock-" + this.getDirection())
	},
	applyBodyElement: function (a) {
		return Ext.Element.create(a)
	},
	updateBodyElement: function (a) {
		this.getElement().append(a)
	},
	updateInnerWrapper: function (a, c) {
		var b = this.getBodyElement();
		if (c && c.$outerWrapper === this) {
			b.remove(c.getElement());
			delete c.$outerWrapper
		}
		if (a) {
			a.setSizeState(this.getSizeState());
			a.$outerWrapper = this;
			b.append(a.getElement())
		}
	},
	updateSizeState: function (b) {
		var a = this.getInnerWrapper();
		this.getElement().setSizeState(b);
		if (a) {
			a.setSizeState(b)
		}
	},
	destroy: function () {
		var b = this.getInnerWrapper(),
			a = this.$outerWrapper;
		if (b) {
			if (a) {
				a.setInnerWrapper(b)
			} else {
				b.getElement().replace(this.getElement());
				delete b.$outerWrapper
			}
		}
		delete this.$outerWrapper;
		this.setInnerWrapper(null);
		this.unlink("_bodyElement", "_element");
		this.callSuper()
	}
});
Ext.define("Ext.layout.VBox", {
	extend: Ext.layout.FlexBox,
	alias: "layout.vbox",
	config: {
		orient: "vertical"
	}
});
Ext.define("Ext.fx.layout.card.Abstract", {
	extend: Ext.Evented,
	isAnimation: true,
	config: {
		direction: "left",
		duration: null,
		reverse: null,
		layout: null
	},
	updateLayout: function () {
		this.enable()
	},
	enable: function () {
		var a = this.getLayout();
		if (a) {
			a.onBefore("activeitemchange", "onActiveItemChange", this)
		}
	},
	disable: function () {
		var a = this.getLayout();
		if (this.isAnimating) {
			this.stopAnimation()
		}
		if (a) {
			a.unBefore("activeitemchange", "onActiveItemChange", this)
		}
	},
	onActiveItemChange: Ext.emptyFn,
	destroy: function () {
		var a = this.getLayout();
		if (this.isAnimating) {
			this.stopAnimation()
		}
		if (a) {
			a.unBefore("activeitemchange", "onActiveItemChange", this)
		}
		this.setLayout(null);
		if (this.observableId) {
			this.fireEvent("destroy", this);
			this.clearListeners();
			this.clearManagedListeners()
		}
	}
});
Ext.define("Ext.fx.State", {
	isAnimatable: {
		"background-color": true,
		"background-image": true,
		"background-position": true,
		"border-bottom-color": true,
		"border-bottom-width": true,
		"border-color": true,
		"border-left-color": true,
		"border-left-width": true,
		"border-right-color": true,
		"border-right-width": true,
		"border-spacing": true,
		"border-top-color": true,
		"border-top-width": true,
		"border-width": true,
		bottom: true,
		color: true,
		crop: true,
		"font-size": true,
		"font-weight": true,
		height: true,
		left: true,
		"letter-spacing": true,
		"line-height": true,
		"margin-bottom": true,
		"margin-left": true,
		"margin-right": true,
		"margin-top": true,
		"max-height": true,
		"max-width": true,
		"min-height": true,
		"min-width": true,
		opacity: true,
		"outline-color": true,
		"outline-offset": true,
		"outline-width": true,
		"padding-bottom": true,
		"padding-left": true,
		"padding-right": true,
		"padding-top": true,
		right: true,
		"text-indent": true,
		"text-shadow": true,
		top: true,
		"vertical-align": true,
		visibility: true,
		width: true,
		"word-spacing": true,
		"z-index": true,
		zoom: true,
		transform: true
	},
	constructor: function (a) {
		this.data = {};
		this.set(a)
	},
	setConfig: function (a) {
		this.set(a);
		return this
	},
	setRaw: function (a) {
		this.data = a;
		return this
	},
	clear: function () {
		return this.setRaw({})
	},
	setTransform: function (c, g) {
		var f = this.data,
			a = Ext.isArray(g),
			b = f.transform,
			e, d;
		if (!b) {
			b = f.transform = {
				translateX: 0,
				translateY: 0,
				translateZ: 0,
				scaleX: 1,
				scaleY: 1,
				scaleZ: 1,
				rotate: 0,
				rotateX: 0,
				rotateY: 0,
				rotateZ: 0,
				skewX: 0,
				skewY: 0
			}
		}
		if (typeof c == "string") {
			switch (c) {
			case "translate":
				if (a) {
					e = g.length;
					if (e == 0) {
						break
					}
					b.translateX = g[0];
					if (e == 1) {
						break
					}
					b.translateY = g[1];
					if (e == 2) {
						break
					}
					b.translateZ = g[2]
				} else {
					b.translateX = g
				}
				break;
			case "rotate":
				if (a) {
					e = g.length;
					if (e == 0) {
						break
					}
					b.rotateX = g[0];
					if (e == 1) {
						break
					}
					b.rotateY = g[1];
					if (e == 2) {
						break
					}
					b.rotateZ = g[2]
				} else {
					b.rotate = g
				}
				break;
			case "scale":
				if (a) {
					e = g.length;
					if (e == 0) {
						break
					}
					b.scaleX = g[0];
					if (e == 1) {
						break
					}
					b.scaleY = g[1];
					if (e == 2) {
						break
					}
					b.scaleZ = g[2]
				} else {
					b.scaleX = g;
					b.scaleY = g
				}
				break;
			case "skew":
				if (a) {
					e = g.length;
					if (e == 0) {
						break
					}
					b.skewX = g[0];
					if (e == 1) {
						break
					}
					b.skewY = g[1]
				} else {
					b.skewX = g
				}
				break;
			default:
				b[c] = g
			}
		} else {
			for (d in c) {
				if (c.hasOwnProperty(d)) {
					g = c[d];
					this.setTransform(d, g)
				}
			}
		}
	},
	set: function (a, d) {
		var c = this.data,
			b;
		if (typeof a != "string") {
			for (b in a) {
				d = a[b];
				if (b === "transform") {
					this.setTransform(d)
				} else {
					c[b] = d
				}
			}
		} else {
			if (a === "transform") {
				this.setTransform(d)
			} else {
				c[a] = d
			}
		}
		return this
	},
	unset: function (a) {
		var b = this.data;
		if (b.hasOwnProperty(a)) {
			delete b[a]
		}
		return this
	},
	getData: function () {
		return this.data
	}
});
Ext.define("Ext.fx.animation.Abstract", {
	extend: Ext.Evented,
	isAnimation: true,
	config: {
		name: "",
		element: null,
		before: null,
		from: {},
		to: {},
		after: null,
		states: {},
		duration: 300,
		easing: "linear",
		iteration: 1,
		direction: "normal",
		delay: 0,
		onBeforeStart: null,
		onEnd: null,
		onBeforeEnd: null,
		scope: null,
		reverse: null,
		preserveEndState: false,
		replacePrevious: true
	},
	STATE_FROM: "0%",
	STATE_TO: "100%",
	DIRECTION_UP: "up",
	DIRECTION_DOWN: "down",
	DIRECTION_LEFT: "left",
	DIRECTION_RIGHT: "right",
	stateNameRegex: /^(?:[\d\.]+)%$/,
	constructor: function () {
		this.states = {};
		this.callParent(arguments);
		return this
	},
	applyElement: function (a) {
		return Ext.get(a)
	},
	applyBefore: function (a, b) {
		if (a) {
			return Ext.factory(a, Ext.fx.State, b)
		}
	},
	applyAfter: function (b, a) {
		if (b) {
			return Ext.factory(b, Ext.fx.State, a)
		}
	},
	setFrom: function (a) {
		return this.setState(this.STATE_FROM, a)
	},
	setTo: function (a) {
		return this.setState(this.STATE_TO, a)
	},
	getFrom: function () {
		return this.getState(this.STATE_FROM)
	},
	getTo: function () {
		return this.getState(this.STATE_TO)
	},
	setStates: function (a) {
		var c = this.stateNameRegex,
			b;
		for (b in a) {
			if (c.test(b)) {
				this.setState(b, a[b])
			}
		}
		return this
	},
	getStates: function () {
		return this.states
	},
	stop: function () {
		this.fireEvent("stop", this)
	},
	destroy: function () {
		this.stop();
		this.callParent()
	},
	setState: function (b, d) {
		var a = this.getStates(),
			c;
		c = Ext.factory(d, Ext.fx.State, a[b]);
		if (c) {
			a[b] = c
		}
		return this
	},
	getState: function (a) {
		return this.getStates()[a]
	},
	getData: function () {
		var l = this.getStates(),
			e = {},
			g = this.getBefore(),
			c = this.getAfter(),
			h = l[this.STATE_FROM],
			j = l[this.STATE_TO],
			k = h.getData(),
			f = j.getData(),
			d, b, a;
		for (b in l) {
			if (l.hasOwnProperty(b)) {
				a = l[b];
				d = a.getData();
				e[b] = d
			}
		}
		if (Ext.browser.is.AndroidStock2) {
			e["0.0001%"] = k
		}
		return {
			before: g ? g.getData() : {},
			after: c ? c.getData() : {},
			states: e,
			from: k,
			to: f,
			duration: this.getDuration(),
			iteration: this.getIteration(),
			direction: this.getDirection(),
			easing: this.getEasing(),
			delay: this.getDelay(),
			onEnd: this.getOnEnd(),
			onBeforeEnd: this.getOnBeforeEnd(),
			onBeforeStart: this.getOnBeforeStart(),
			scope: this.getScope(),
			preserveEndState: this.getPreserveEndState(),
			replacePrevious: this.getReplacePrevious()
		}
	}
});
Ext.define("Ext.fx.animation.Slide", {
	extend: Ext.fx.animation.Abstract,
	alternateClassName: "Ext.fx.animation.SlideIn",
	alias: ["animation.slide", "animation.slideIn"],
	config: {
		direction: "left",
		out: false,
		offset: 0,
		easing: "auto",
		containerBox: "auto",
		elementBox: "auto",
		isElementBoxFit: true,
		useCssTransform: true
	},
	reverseDirectionMap: {
		up: "down",
		down: "up",
		left: "right",
		right: "left"
	},
	applyEasing: function (a) {
		if (a === "auto") {
			return "ease-" + ((this.getOut()) ? "in" : "out")
		}
		return a
	},
	getContainerBox: function () {
		var a = this._containerBox;
		if (a === "auto") {
			a = this.getElement().getParent().getPageBox()
		}
		return a
	},
	getElementBox: function () {
		var a = this._elementBox;
		if (this.getIsElementBoxFit()) {
			return this.getContainerBox()
		}
		if (a === "auto") {
			a = this.getElement().getPageBox()
		}
		return a
	},
	getData: function () {
		var q = this.getElementBox(),
			c = this.getContainerBox(),
			g = q ? q : c,
			o = this.getFrom(),
			p = this.getTo(),
			f = this.getOut(),
			e = this.getOffset(),
			n = this.getDirection(),
			b = this.getUseCssTransform(),
			h = this.getReverse(),
			d = 0,
			a = 0,
			m, k, l, j;
		if (h) {
			n = this.reverseDirectionMap[n]
		}
		switch (n) {
		case this.DIRECTION_UP:
			if (f) {
				a = c.top - g.top - g.height - e
			} else {
				a = c.bottom - g.bottom + g.height + e
			}
			break;
		case this.DIRECTION_DOWN:
			if (f) {
				a = c.bottom - g.bottom + g.height + e
			} else {
				a = c.top - g.height - g.top - e
			}
			break;
		case this.DIRECTION_RIGHT:
			if (f) {
				d = c.right - g.right + g.width + e
			} else {
				d = c.left - g.left - g.width - e
			}
			break;
		case this.DIRECTION_LEFT:
			if (f) {
				d = c.left - g.left - g.width - e
			} else {
				d = c.right - g.right + g.width + e
			}
			break
		}
		m = (f) ? 0 : d;
		k = (f) ? 0 : a;
		if (b) {
			o.setTransform({
				translateX: m,
				translateY: k
			})
		} else {
			o.set("left", m);
			o.set("top", k)
		}
		l = (f) ? d : 0;
		j = (f) ? a : 0;
		if (b) {
			p.setTransform({
				translateX: l,
				translateY: j
			})
		} else {
			p.set("left", l);
			p.set("top", j)
		}
		return this.callParent(arguments)
	}
});
Ext.define("Ext.fx.animation.SlideOut", {
	extend: Ext.fx.animation.Slide,
	alias: ["animation.slideOut"],
	config: {
		out: true
	}
});
Ext.define("Ext.fx.animation.Fade", {
	extend: Ext.fx.animation.Abstract,
	alternateClassName: "Ext.fx.animation.FadeIn",
	alias: ["animation.fade", "animation.fadeIn"],
	config: {
		out: false,
		before: {
			display: null,
			opacity: 0
		},
		after: {
			opacity: null
		},
		reverse: null
	},
	updateOut: function (a) {
		var c = this.getTo(),
			b = this.getFrom();
		if (a) {
			b.set("opacity", 1);
			c.set("opacity", 0)
		} else {
			b.set("opacity", 0);
			c.set("opacity", 1)
		}
	}
});
Ext.define("Ext.fx.animation.FadeOut", {
	extend: Ext.fx.animation.Fade,
	alias: "animation.fadeOut",
	config: {
		out: true,
		before: {}
	}
});
Ext.define("Ext.fx.animation.Flip", {
	extend: Ext.fx.animation.Abstract,
	alias: "animation.flip",
	config: {
		easing: "ease-in",
		direction: "right",
		half: false,
		out: null
	},
	getData: function () {
		var h = this.getFrom(),
			j = this.getTo(),
			g = this.getDirection(),
			b = this.getOut(),
			m = this.getHalf(),
			c = (m) ? 90 : 180,
			e = 1,
			a = 1,
			l = 0,
			k = 0,
			f = 0,
			d = 0;
		if (b) {
			a = 0.8
		} else {
			e = 0.8
		}
		switch (g) {
		case this.DIRECTION_UP:
			if (b) {
				f = c
			} else {
				l = -c
			}
			break;
		case this.DIRECTION_DOWN:
			if (b) {
				f = -c
			} else {
				l = c
			}
			break;
		case this.DIRECTION_RIGHT:
			if (b) {
				d = -c
			} else {
				k = c
			}
			break;
		case this.DIRECTION_LEFT:
			if (b) {
				d = -c
			} else {
				k = c
			}
			break
		}
		h.setTransform({
			rotateX: l,
			rotateY: k,
			scale: e
		});
		j.setTransform({
			rotateX: f,
			rotateY: d,
			scale: a
		});
		return this.callParent(arguments)
	}
});
Ext.define("Ext.fx.animation.Pop", {
	extend: Ext.fx.animation.Abstract,
	alias: ["animation.pop", "animation.popIn"],
	alternateClassName: "Ext.fx.animation.PopIn",
	config: {
		out: false,
		before: {
			display: null,
			opacity: 0
		},
		after: {
			opacity: null
		}
	},
	getData: function () {
		var c = this.getTo(),
			b = this.getFrom(),
			a = this.getOut();
		if (a) {
			b.set("opacity", 1);
			b.setTransform({
				scale: 1
			});
			c.set("opacity", 0);
			c.setTransform({
				scale: 0
			})
		} else {
			b.set("opacity", 0);
			b.setTransform({
				scale: 0
			});
			c.set("opacity", 1);
			c.setTransform({
				scale: 1
			})
		}
		return this.callParent(arguments)
	}
});
Ext.define("Ext.fx.animation.PopOut", {
	extend: Ext.fx.animation.Pop,
	alias: "animation.popOut",
	config: {
		out: true,
		before: {}
	}
});
Ext.define("Ext.fx.Animation", {
	constructor: function (b) {
		var a = Ext.fx.animation.Abstract,
			c;
		if (typeof b == "string") {
			c = b;
			b = {}
		} else {
			if (b && b.type) {
				c = b.type
			}
		}
		if (c) {
			if (Ext.browser.is.AndroidStock2) {
				if (c == "pop") {
					c = "fade"
				}
				if (c == "popIn") {
					c = "fadeIn"
				}
				if (c == "popOut") {
					c = "fadeOut"
				}
			}
			a = Ext.ClassManager.getByAlias("animation." + c)
		}
		return Ext.factory(b, a)
	}
});
Ext.define("Ext.fx.layout.card.Style", {
	extend: Ext.fx.layout.card.Abstract,
	config: {
		inAnimation: {
			before: {
				visibility: null
			},
			preserveEndState: false,
			replacePrevious: true
		},
		outAnimation: {
			preserveEndState: false,
			replacePrevious: true
		}
	},
	constructor: function (b) {
		var c, a;
		this.initConfig(b);
		this.endAnimationCounter = 0;
		c = this.getInAnimation();
		a = this.getOutAnimation();
		c.on("animationend", "incrementEnd", this);
		a.on("animationend", "incrementEnd", this)
	},
	updateDirection: function (a) {
		this.getInAnimation().setDirection(a);
		this.getOutAnimation().setDirection(a)
	},
	updateDuration: function (a) {
		this.getInAnimation().setDuration(a);
		this.getOutAnimation().setDuration(a)
	},
	updateReverse: function (a) {
		this.getInAnimation().setReverse(a);
		this.getOutAnimation().setReverse(a)
	},
	incrementEnd: function () {
		this.endAnimationCounter++;
		if (this.endAnimationCounter > 1) {
			this.endAnimationCounter = 0;
			this.fireEvent("animationend", this)
		}
	},
	applyInAnimation: function (b, a) {
		return Ext.factory(b, Ext.fx.Animation, a)
	},
	applyOutAnimation: function (b, a) {
		return Ext.factory(b, Ext.fx.Animation, a)
	},
	updateInAnimation: function (a) {
		a.setScope(this)
	},
	updateOutAnimation: function (a) {
		a.setScope(this)
	},
	onActiveItemChange: function (a, e, h, j, d) {
		var b = this.getInAnimation(),
			g = this.getOutAnimation(),
			f, c;
		if (e && h && h.isPainted()) {
			f = e.renderElement;
			c = h.renderElement;
			b.setElement(f);
			g.setElement(c);
			g.setOnBeforeEnd(function (k, l) {
				if (l || Ext.Animator.hasRunningAnimations(k)) {
					d.firingArguments[1] = null;
					d.firingArguments[2] = null
				}
			});
			g.setOnEnd(function () {
				d.resume()
			});
			f.dom.style.setProperty("visibility", "hidden", "important");
			e.show();
			Ext.Animator.run([g, b]);
			d.pause()
		}
	},
	destroy: function () {
		Ext.destroy(this.getInAnimation(), this.getOutAnimation());
		this.callParent(arguments)
	}
});
Ext.define("Ext.fx.layout.card.Slide", {
	extend: Ext.fx.layout.card.Style,
	alias: "fx.layout.card.slide",
	config: {
		inAnimation: {
			type: "slide",
			easing: "ease-out"
		},
		outAnimation: {
			type: "slide",
			easing: "ease-out",
			out: true
		}
	},
	updateReverse: function (a) {
		this.getInAnimation().setReverse(a);
		this.getOutAnimation().setReverse(a)
	}
});
Ext.define("Ext.fx.layout.card.Cover", {
	extend: Ext.fx.layout.card.Style,
	alias: "fx.layout.card.cover",
	config: {
		reverse: null,
		inAnimation: {
			before: {
				"z-index": 100
			},
			after: {
				"z-index": 0
			},
			type: "slide",
			easing: "ease-out"
		},
		outAnimation: {
			easing: "ease-out",
			from: {
				opacity: 0.99
			},
			to: {
				opacity: 1
			},
			out: true
		}
	},
	updateReverse: function (a) {
		this.getInAnimation().setReverse(a);
		this.getOutAnimation().setReverse(a)
	}
});
Ext.define("Ext.fx.layout.card.Reveal", {
	extend: Ext.fx.layout.card.Style,
	alias: "fx.layout.card.reveal",
	config: {
		inAnimation: {
			easing: "ease-out",
			from: {
				opacity: 0.99
			},
			to: {
				opacity: 1
			}
		},
		outAnimation: {
			before: {
				"z-index": 100
			},
			after: {
				"z-index": 0
			},
			type: "slide",
			easing: "ease-out",
			out: true
		}
	},
	updateReverse: function (a) {
		this.getInAnimation().setReverse(a);
		this.getOutAnimation().setReverse(a)
	}
});
Ext.define("Ext.fx.layout.card.Fade", {
	extend: Ext.fx.layout.card.Style,
	alias: "fx.layout.card.fade",
	config: {
		reverse: null,
		inAnimation: {
			type: "fade",
			easing: "ease-out"
		},
		outAnimation: {
			type: "fade",
			easing: "ease-out",
			out: true
		}
	}
});
Ext.define("Ext.fx.layout.card.Flip", {
	extend: Ext.fx.layout.card.Style,
	alias: "fx.layout.card.flip",
	config: {
		duration: 500,
		inAnimation: {
			type: "flip",
			half: true,
			easing: "ease-out",
			before: {
				"backface-visibility": "hidden"
			},
			after: {
				"backface-visibility": null
			}
		},
		outAnimation: {
			type: "flip",
			half: true,
			easing: "ease-in",
			before: {
				"backface-visibility": "hidden"
			},
			after: {
				"backface-visibility": null
			},
			out: true
		}
	},
	onActiveItemChange: function (e, c, f, b, a) {
		var d = c.element.getParent();
		d.addCls("x-layout-card-perspective");
		this.on("animationend", function () {
			d.removeCls("x-layout-card-perspective")
		}, this, {
			single: true
		});
		this.callParent(arguments)
	},
	updateDuration: function (d) {
		var c = d / 2,
			b = this.getInAnimation(),
			a = this.getOutAnimation();
		b.setDelay(c);
		b.setDuration(c);
		a.setDuration(c)
	}
});
Ext.define("Ext.fx.layout.card.Pop", {
	extend: Ext.fx.layout.card.Style,
	alias: "fx.layout.card.pop",
	config: {
		duration: 500,
		inAnimation: {
			type: "pop",
			easing: "ease-out"
		},
		outAnimation: {
			type: "pop",
			easing: "ease-in",
			out: true
		}
	},
	updateDuration: function (d) {
		var c = d / 2,
			b = this.getInAnimation(),
			a = this.getOutAnimation();
		b.setDelay(c);
		b.setDuration(c);
		a.setDuration(c)
	}
});
Ext.define("Ext.fx.layout.card.Scroll", {
	extend: Ext.fx.layout.card.Abstract,
	alias: "fx.layout.card.scroll",
	config: {
		duration: 150
	},
	constructor: function (a) {
		this.initConfig(a)
	},
	getEasing: function () {
		var a = this.easing;
		if (!a) {
			this.easing = a = new Ext.fx.easing.Linear()
		}
		return a
	},
	updateDuration: function (a) {
		this.getEasing().setDuration(a)
	},
	onActiveItemChange: function (a, d, m, n, c) {
		var j = this.getDirection(),
			g = this.getEasing(),
			l, e, b, h, k, f;
		if (d && m) {
			if (this.isAnimating) {
				this.stopAnimation()
			}
			d.setWidth("100%");
			d.setHeight("100%");
			l = this.getLayout().container.innerElement;
			h = l.getWidth();
			k = l.getHeight();
			e = d.renderElement;
			b = m.renderElement;
			this.oldItem = m;
			this.newItem = d;
			this.currentEventController = c;
			this.containerElement = l;
			this.isReverse = f = this.getReverse();
			d.show();
			if (j == "right") {
				j = "left";
				this.isReverse = f = !f
			} else {
				if (j == "down") {
					j = "up";
					this.isReverse = f = !f
				}
			}
			if (j == "left") {
				if (f) {
					g.setConfig({
						startValue: h,
						endValue: 0
					});
					l.dom.scrollLeft = h;
					b.setLeft(h)
				} else {
					g.setConfig({
						startValue: 0,
						endValue: h
					});
					e.setLeft(h)
				}
			} else {
				if (f) {
					g.setConfig({
						startValue: k,
						endValue: 0
					});
					l.dom.scrollTop = k;
					b.setTop(k)
				} else {
					g.setConfig({
						startValue: 0,
						endValue: k
					});
					e.setTop(k)
				}
			}
			this.startAnimation();
			c.pause()
		}
	},
	startAnimation: function () {
		this.isAnimating = true;
		this.getEasing().setStartTime(Date.now());
		Ext.AnimationQueue.start(this.doAnimationFrame, this)
	},
	doAnimationFrame: function () {
		var d = this.getEasing(),
			c = this.getDirection(),
			a = "scrollTop",
			b;
		if (c == "left" || c == "right") {
			a = "scrollLeft"
		}
		if (d.isEnded) {
			this.stopAnimation()
		} else {
			b = d.getValue();
			this.containerElement.dom[a] = b
		}
	},
	stopAnimation: function () {
		var c = this,
			e = c.getDirection(),
			a = "setTop",
			d = c.oldItem,
			b = c.newItem;
		if (e == "left" || e == "right") {
			a = "setLeft"
		}
		c.currentEventController.resume();
		if (c.isReverse && d && d.renderElement && d.renderElement.dom) {
			d.renderElement[a](null)
		} else {
			if (b && b.renderElement && b.renderElement.dom) {
				b.renderElement[a](null)
			}
		}
		Ext.AnimationQueue.stop(this.doAnimationFrame, this);
		c.isAnimating = false;
		c.fireEvent("animationend", c)
	}
});
Ext.define("Ext.fx.layout.Card", {
	constructor: function (b) {
		var a = Ext.fx.layout.card.Abstract,
			c;
		if (!b) {
			return null
		}
		if (typeof b == "string") {
			c = b;
			b = {}
		} else {
			if (b.type) {
				c = b.type
			}
		}
		b.elementBox = false;
		if (c) {
			if (Ext.browser.is.AndroidStock2) {
				if (c != "fade") {
					c = "scroll"
				}
			}
			a = Ext.ClassManager.getByAlias("fx.layout.card." + c)
		}
		return Ext.factory(b, a)
	}
});
Ext.define("Ext.layout.Card", {
	extend: Ext.layout.Default,
	alias: "layout.card",
	isCard: true,
	layoutClass: "x-layout-card",
	itemClass: "x-layout-card-item",
	applyAnimation: function (a) {
		return new Ext.fx.layout.Card(a)
	},
	updateAnimation: function (b, a) {
		if (b && b.isAnimation) {
			b.setLayout(this)
		}
		if (a) {
			a.destroy()
		}
	},
	setContainer: function (a) {
		this.callSuper(arguments);
		a.innerElement.addCls(this.layoutClass);
		a.onInitialized("onContainerInitialized", this)
	},
	onContainerInitialized: function () {
		var a = this.container,
			b = a.getActiveItem();
		if (b) {
			b.show()
		}
		a.on("activeitemchange", "onContainerActiveItemChange", this)
	},
	onContainerActiveItemChange: function (a) {
		this.relayEvent(arguments, "doActiveItemChange")
	},
	onItemInnerStateChange: function (c, b, d) {
		this.callSuper(arguments);
		var a = this.container,
			e = a.getActiveItem();
		c.toggleCls(this.itemClass, b);
		c.setLayoutSizeFlags(b ? a.LAYOUT_BOTH : 0);
		if (b) {
			if (e !== a.innerIndexOf(c) && e !== c && c !== a.pendingActiveItem) {
				c.hide()
			}
		} else {
			if (!d && !c.isDestroyed && c.isDestroying !== true) {
				c.show()
			}
		}
	},
	doActiveItemChange: function (b, c, a) {
		if (a) {
			a.hide()
		}
		if (c) {
			c.show()
		}
	},
	destroy: function () {
		this.callParent(arguments);
		Ext.destroy(this.getAnimation())
	}
});
Ext.define("Ext.util.Filter", {
	isFilter: true,
	config: {
		property: null,
		value: null,
		filterFn: Ext.emptyFn,
		anyMatch: false,
		exactMatch: false,
		caseSensitive: false,
		root: null,
		id: undefined,
		scope: null
	},
	applyId: function (a) {
		if (!a) {
			if (this.getProperty()) {
				a = this.getProperty() + "-" + String(this.getValue())
			}
			if (!a) {
				a = Ext.id(null, "ext-filter-")
			}
		}
		return a
	},
	constructor: function (a) {
		this.initConfig(a)
	},
	applyFilterFn: function (b) {
		if (b === Ext.emptyFn) {
			b = this.getInitialConfig("filter");
			if (b) {
				return b
			}
			var a = this.getValue();
			if (!this.getProperty() && !a && a !== 0) {
				return Ext.emptyFn
			} else {
				return this.createFilterFn()
			}
		}
		return b
	},
	createFilterFn: function () {
		var a = this,
			b = a.createValueMatcher();
		return function (d) {
			var c = a.getRoot(),
				e = a.getProperty();
			if (c) {
				d = d[c]
			}
			return b.test(d[e])
		}
	},
	createValueMatcher: function () {
		var d = this,
			e = d.getValue(),
			f = d.getAnyMatch(),
			c = d.getExactMatch(),
			a = d.getCaseSensitive(),
			b = Ext.String.escapeRegex;
		if (e === null || e === undefined || !e.exec) {
			e = String(e);
			if (f === true) {
				e = b(e)
			} else {
				e = "^" + b(e);
				if (c === true) {
					e += "$"
				}
			}
			e = new RegExp(e, a ? "" : "i")
		}
		return e
	}
});
Ext.define("Ext.util.AbstractMixedCollection", {
	mixins: {
		observable: Ext.mixin.Observable
	},
	constructor: function (b, a) {
		var c = this;
		c.items = [];
		c.map = {};
		c.keys = [];
		c.length = 0;
		c.allowFunctions = b === true;
		if (a) {
			c.getKey = a
		}
		c.mixins.observable.constructor.call(c)
	},
	allowFunctions: false,
	add: function (b, e) {
		var d = this,
			f = e,
			c = b,
			a;
		if (arguments.length == 1) {
			f = c;
			c = d.getKey(f)
		}
		if (typeof c != "undefined" && c !== null) {
			a = d.map[c];
			if (typeof a != "undefined") {
				return d.replace(c, f)
			}
			d.map[c] = f
		}
		d.length++;
		d.items.push(f);
		d.keys.push(c);
		d.fireEvent("add", d.length - 1, f, c);
		return f
	},
	getKey: function (a) {
		return a.id
	},
	replace: function (c, e) {
		var d = this,
			a, b;
		if (arguments.length == 1) {
			e = arguments[0];
			c = d.getKey(e)
		}
		a = d.map[c];
		if (typeof c == "undefined" || c === null || typeof a == "undefined") {
			return d.add(c, e)
		}
		b = d.indexOfKey(c);
		d.items[b] = e;
		d.map[c] = e;
		d.fireEvent("replace", c, a, e);
		return e
	},
	addAll: function (f) {
		var e = this,
			d = 0,
			b, a, c;
		if (arguments.length > 1 || Ext.isArray(f)) {
			b = arguments.length > 1 ? arguments : f;
			for (a = b.length; d < a; d++) {
				e.add(b[d])
			}
		} else {
			for (c in f) {
				if (f.hasOwnProperty(c)) {
					if (e.allowFunctions || typeof f[c] != "function") {
						e.add(c, f[c])
					}
				}
			}
		}
	},
	each: function (e, d) {
		var b = [].concat(this.items),
			c = 0,
			a = b.length,
			f;
		for (; c < a; c++) {
			f = b[c];
			if (e.call(d || f, f, c, a) === false) {
				break
			}
		}
	},
	eachKey: function (e, d) {
		var f = this.keys,
			b = this.items,
			c = 0,
			a = f.length;
		for (; c < a; c++) {
			e.call(d || window, f[c], b[c], c, a)
		}
	},
	findBy: function (e, d) {
		var f = this.keys,
			b = this.items,
			c = 0,
			a = b.length;
		for (; c < a; c++) {
			if (e.call(d || window, b[c], f[c])) {
				return b[c]
			}
		}
		return null
	},
	insert: function (a, b, e) {
		var d = this,
			c = b,
			f = e;
		if (arguments.length == 2) {
			f = c;
			c = d.getKey(f)
		}
		if (d.containsKey(c)) {
			d.suspendEvents();
			d.removeAtKey(c);
			d.resumeEvents()
		}
		if (a >= d.length) {
			return d.add(c, f)
		}
		d.length++;
		Ext.Array.splice(d.items, a, 0, f);
		if (typeof c != "undefined" && c !== null) {
			d.map[c] = f
		}
		Ext.Array.splice(d.keys, a, 0, c);
		d.fireEvent("add", a, f, c);
		return f
	},
	remove: function (a) {
		return this.removeAt(this.indexOf(a))
	},
	removeAll: function (a) {
		Ext.each(a || [], function (b) {
			this.remove(b)
		}, this);
		return this
	},
	removeAt: function (a) {
		var c = this,
			d, b;
		if (a < c.length && a >= 0) {
			c.length--;
			d = c.items[a];
			Ext.Array.erase(c.items, a, 1);
			b = c.keys[a];
			if (typeof b != "undefined") {
				delete c.map[b]
			}
			Ext.Array.erase(c.keys, a, 1);
			c.fireEvent("remove", d, b);
			return d
		}
		return false
	},
	removeAtKey: function (a) {
		return this.removeAt(this.indexOfKey(a))
	},
	getCount: function () {
		return this.length
	},
	indexOf: function (a) {
		return Ext.Array.indexOf(this.items, a)
	},
	indexOfKey: function (a) {
		return Ext.Array.indexOf(this.keys, a)
	},
	get: function (b) {
		var d = this,
			a = d.map[b],
			c = a !== undefined ? a : (typeof b == "number") ? d.items[b] : undefined;
		return typeof c != "function" || d.allowFunctions ? c : null
	},
	getAt: function (a) {
		return this.items[a]
	},
	getByKey: function (a) {
		return this.map[a]
	},
	contains: function (a) {
		return Ext.Array.contains(this.items, a)
	},
	containsKey: function (a) {
		return typeof this.map[a] != "undefined"
	},
	clear: function () {
		var a = this;
		a.length = 0;
		a.items = [];
		a.keys = [];
		a.map = {};
		a.fireEvent("clear")
	},
	first: function () {
		return this.items[0]
	},
	last: function () {
		return this.items[this.length - 1]
	},
	sum: function (g, b, h, a) {
		var c = this.extractValues(g, b),
			f = c.length,
			e = 0,
			d;
		h = h || 0;
		a = (a || a === 0) ? a : f - 1;
		for (d = h; d <= a; d++) {
			e += c[d]
		}
		return e
	},
	collect: function (j, e, g) {
		var k = this.extractValues(j, e),
			a = k.length,
			b = {},
			c = [],
			h, f, d;
		for (d = 0; d < a; d++) {
			h = k[d];
			f = String(h);
			if ((g || !Ext.isEmpty(h)) && !b[f]) {
				b[f] = true;
				c.push(h)
			}
		}
		return c
	},
	extractValues: function (c, a) {
		var b = this.items;
		if (a) {
			b = Ext.Array.pluck(b, a)
		}
		return Ext.Array.pluck(b, c)
	},
	getRange: function (f, a) {
		var e = this,
			c = e.items,
			b = [],
			d;
		if (c.length < 1) {
			return b
		}
		f = f || 0;
		a = Math.min(typeof a == "undefined" ? e.length - 1 : a, e.length - 1);
		if (f <= a) {
			for (d = f; d <= a; d++) {
				b[b.length] = c[d]
			}
		} else {
			for (d = f; d >= a; d--) {
				b[b.length] = c[d]
			}
		}
		return b
	},
	filter: function (d, c, f, a) {
		var b = [],
			e;
		if (Ext.isString(d)) {
			b.push(Ext.create("Ext.util.Filter", {
				property: d,
				value: c,
				anyMatch: f,
				caseSensitive: a
			}))
		} else {
			if (Ext.isArray(d) || d instanceof Ext.util.Filter) {
				b = b.concat(d)
			}
		}
		e = function (g) {
			var m = true,
				n = b.length,
				h;
			for (h = 0; h < n; h++) {
				var l = b[h],
					k = l.getFilterFn(),
					j = l.getScope();
				m = m && k.call(j, g)
			}
			return m
		};
		return this.filterBy(e)
	},
	filterBy: function (e, d) {
		var h = this,
			a = new this.self(),
			g = h.keys,
			b = h.items,
			f = b.length,
			c;
		a.getKey = h.getKey;
		for (c = 0; c < f; c++) {
			if (e.call(d || h, b[c], g[c])) {
				a.add(g[c], b[c])
			}
		}
		return a
	},
	findIndex: function (c, b, e, d, a) {
		if (Ext.isEmpty(b, false)) {
			return -1
		}
		b = this.createValueMatcher(b, d, a);
		return this.findIndexBy(function (f) {
			return f && b.test(f[c])
		}, null, e)
	},
	findIndexBy: function (e, d, h) {
		var g = this,
			f = g.keys,
			b = g.items,
			c = h || 0,
			a = b.length;
		for (; c < a; c++) {
			if (e.call(d || g, b[c], f[c])) {
				return c
			}
		}
		return -1
	},
	createValueMatcher: function (c, e, a, b) {
		if (!c.exec) {
			var d = Ext.String.escapeRegex;
			c = String(c);
			if (e === true) {
				c = d(c)
			} else {
				c = "^" + d(c);
				if (b === true) {
					c += "$"
				}
			}
			c = new RegExp(c, a ? "" : "i")
		}
		return c
	},
	clone: function () {
		var e = this,
			f = new this.self(),
			d = e.keys,
			b = e.items,
			c = 0,
			a = b.length;
		for (; c < a; c++) {
			f.add(d[c], b[c])
		}
		f.getKey = e.getKey;
		return f
	}
});
Ext.define("Ext.util.Sorter", {
	isSorter: true,
	config: {
		property: null,
		sorterFn: null,
		root: null,
		transform: null,
		direction: "ASC",
		id: undefined
	},
	constructor: function (a) {
		this.initConfig(a)
	},
	applyId: function (a) {
		if (!a) {
			a = this.getProperty();
			if (!a) {
				a = Ext.id(null, "ext-sorter-")
			}
		}
		return a
	},
	createSortFunction: function (b) {
		var c = this,
			a = c.getDirection().toUpperCase() == "DESC" ? -1 : 1;
		return function (e, d) {
			return a * b.call(c, e, d)
		}
	},
	defaultSortFn: function (e, c) {
		var g = this,
			f = g._transform,
			b = g._root,
			d, a, h = g._property;
		if (b !== null && b !== undefined) {
			e = e[b];
			c = c[b]
		}
		d = e[h];
		a = c[h];
		if (f) {
			d = f(d);
			a = f(a)
		}
		return d > a ? 1 : (d < a ? -1 : 0)
	},
	updateDirection: function () {
		this.updateSortFn()
	},
	updateSortFn: function () {
		this.sort = this.createSortFunction(this.getSorterFn() || this.defaultSortFn)
	},
	toggle: function () {
		this.setDirection(Ext.String.toggle(this.getDirection(), "ASC", "DESC"))
	}
});
Ext.define("Ext.util.Sortable", {
	extend: Ext.mixin.Mixin,
	isSortable: true,
	mixinConfig: {
		hooks: {
			destroy: "destroy"
		}
	},
	defaultSortDirection: "ASC",
	initSortable: function () {
		var a = this,
			b = a.sorters;
		a.sorters = Ext.create("Ext.util.AbstractMixedCollection", false, function (c) {
			return c.id || c.property
		});
		if (b) {
			a.sorters.addAll(a.decodeSorters(b))
		}
	},
	sort: function (g, f, c, e) {
		var d = this,
			h, b, a;
		if (Ext.isArray(g)) {
			e = c;
			c = f;
			a = g
		} else {
			if (Ext.isObject(g)) {
				e = c;
				c = f;
				a = [g]
			} else {
				if (Ext.isString(g)) {
					h = d.sorters.get(g);
					if (!h) {
						h = {
							property: g,
							direction: f
						};
						a = [h]
					} else {
						if (f === undefined) {
							h.toggle()
						} else {
							h.setDirection(f)
						}
					}
				}
			}
		}
		if (a && a.length) {
			a = d.decodeSorters(a);
			if (Ext.isString(c)) {
				if (c === "prepend") {
					g = d.sorters.clone().items;
					d.sorters.clear();
					d.sorters.addAll(a);
					d.sorters.addAll(g)
				} else {
					d.sorters.addAll(a)
				}
			} else {
				d.sorters.clear();
				d.sorters.addAll(a)
			}
			if (e !== false) {
				d.onBeforeSort(a)
			}
		}
		if (e !== false) {
			g = d.sorters.items;
			if (g.length) {
				b = function (l, k) {
					var j = g[0].sort(l, k),
						n = g.length,
						m;
					for (m = 1; m < n; m++) {
						j = j || g[m].sort.call(this, l, k)
					}
					return j
				};
				d.doSort(b)
			}
		}
		return g
	},
	onBeforeSort: Ext.emptyFn,
	decodeSorters: function (f) {
		if (!Ext.isArray(f)) {
			if (f === undefined) {
				f = []
			} else {
				f = [f]
			}
		}
		var d = f.length,
			g = Ext.util.Sorter,
			a = this.model ? this.model.prototype.fields : null,
			e, b, c;
		for (c = 0; c < d; c++) {
			b = f[c];
			if (!(b instanceof g)) {
				if (Ext.isString(b)) {
					b = {
						property: b
					}
				}
				Ext.applyIf(b, {
					root: this.sortRoot,
					direction: "ASC"
				});
				if (b.fn) {
					b.sorterFn = b.fn
				}
				if (typeof b == "function") {
					b = {
						sorterFn: b
					}
				}
				if (a && !b.transform) {
					e = a.get(b.property);
					b.transform = e ? e.sortType : undefined
				}
				f[c] = Ext.create("Ext.util.Sorter", b)
			}
		}
		return f
	},
	getSorters: function () {
		return this.sorters.items
	},
	destroy: function () {
		this.callSuper();
		Ext.destroy(this.sorters)
	}
});
Ext.define("Ext.util.MixedCollection", {
	extend: Ext.util.AbstractMixedCollection,
	mixins: {
		sortable: Ext.util.Sortable
	},
	constructor: function () {
		var a = this;
		a.callParent(arguments);
		a.mixins.sortable.initSortable.call(a)
	},
	doSort: function (a) {
		this.sortBy(a)
	},
	_sort: function (k, a, j) {
		var h = this,
			d, e, b = String(a).toUpperCase() == "DESC" ? -1 : 1,
			g = [],
			l = h.keys,
			f = h.items;
		j = j ||
		function (m, c) {
			return m - c
		};
		for (d = 0, e = f.length; d < e; d++) {
			g[g.length] = {
				key: l[d],
				value: f[d],
				index: d
			}
		}
		Ext.Array.sort(g, function (m, c) {
			var n = j(m[k], c[k]) * b;
			if (n === 0) {
				n = (m.index < c.index ? -1 : 1)
			}
			return n
		});
		for (d = 0, e = g.length; d < e; d++) {
			f[d] = g[d].value;
			l[d] = g[d].key
		}
		h.fireEvent("sort", h)
	},
	sortBy: function (c) {
		var g = this,
			b = g.items,
			f = g.keys,
			e = b.length,
			a = [],
			d;
		for (d = 0; d < e; d++) {
			a[d] = {
				key: f[d],
				value: b[d],
				index: d
			}
		}
		Ext.Array.sort(a, function (j, h) {
			var k = c(j.value, h.value);
			if (k === 0) {
				k = (j.index < h.index ? -1 : 1)
			}
			return k
		});
		for (d = 0; d < e; d++) {
			b[d] = a[d].value;
			f[d] = a[d].key
		}
		g.fireEvent("sort", g, b, f)
	},
	reorder: function (d) {
		var g = this,
			b = g.items,
			c = 0,
			f = b.length,
			a = [],
			e = [],
			h;
		g.suspendEvents();
		for (h in d) {
			a[d[h]] = b[h]
		}
		for (c = 0; c < f; c++) {
			if (d[c] == undefined) {
				e.push(b[c])
			}
		}
		for (c = 0; c < f; c++) {
			if (a[c] == undefined) {
				a[c] = e.shift()
			}
		}
		g.clear();
		g.addAll(a);
		g.resumeEvents();
		g.fireEvent("sort", g)
	},
	sortByKey: function (a, b) {
		this._sort("key", a, b ||
		function (d, c) {
			var f = String(d).toUpperCase(),
				e = String(c).toUpperCase();
			return f > e ? 1 : (f < e ? -1 : 0)
		})
	}
});
Ext.define("Ext.ItemCollection", {
	extend: Ext.util.MixedCollection,
	getKey: function (a) {
		return a.getItemId()
	},
	has: function (a) {
		return this.map.hasOwnProperty(a.getId())
	}
});
Ext.define("Ext.fx.easing.Momentum", {
	extend: Ext.fx.easing.Abstract,
	config: {
		acceleration: 30,
		friction: 0,
		startVelocity: 0
	},
	alpha: 0,
	updateFriction: function (b) {
		var a = Math.log(1 - (b / 10));
		this.theta = a;
		this.alpha = a / this.getAcceleration()
	},
	updateStartVelocity: function (a) {
		this.velocity = a * this.getAcceleration()
	},
	updateAcceleration: function (a) {
		this.velocity = this.getStartVelocity() * a;
		this.alpha = this.theta / a
	},
	getValue: function () {
		return this.getStartValue() - this.velocity * (1 - this.getFrictionFactor()) / this.theta
	},
	getFrictionFactor: function () {
		var a = Ext.Date.now() - this.getStartTime();
		return Math.exp(a * this.alpha)
	},
	getVelocity: function () {
		return this.getFrictionFactor() * this.velocity
	}
});
Ext.define("Ext.fx.easing.Bounce", {
	extend: Ext.fx.easing.Abstract,
	config: {
		springTension: 0.3,
		acceleration: 30,
		startVelocity: 0
	},
	getValue: function () {
		var b = Ext.Date.now() - this.getStartTime(),
			c = (b / this.getAcceleration()),
			a = c * Math.pow(Math.E, -this.getSpringTension() * c);
		return this.getStartValue() + (this.getStartVelocity() * a)
	}
});
Ext.define("Ext.fx.easing.BoundMomentum", {
	extend: Ext.fx.easing.Abstract,
	config: {
		momentum: null,
		bounce: null,
		minMomentumValue: 0,
		maxMomentumValue: 0,
		minVelocity: 0.01,
		startVelocity: 0
	},
	applyMomentum: function (a, b) {
		return Ext.factory(a, Ext.fx.easing.Momentum, b)
	},
	applyBounce: function (a, b) {
		return Ext.factory(a, Ext.fx.easing.Bounce, b)
	},
	updateStartTime: function (a) {
		this.getMomentum().setStartTime(a);
		this.callParent(arguments)
	},
	updateStartVelocity: function (a) {
		this.getMomentum().setStartVelocity(a)
	},
	updateStartValue: function (a) {
		this.getMomentum().setStartValue(a)
	},
	reset: function () {
		this.lastValue = null;
		this.isBouncingBack = false;
		this.isOutOfBound = false;
		return this.callParent(arguments)
	},
	getValue: function () {
		var a = this.getMomentum(),
			k = this.getBounce(),
			e = a.getStartVelocity(),
			f = e > 0 ? 1 : -1,
			g = this.getMinMomentumValue(),
			d = this.getMaxMomentumValue(),
			c = (f == 1) ? d : g,
			h = this.lastValue,
			j, b;
		if (e === 0) {
			return this.getStartValue()
		}
		if (!this.isOutOfBound) {
			j = a.getValue();
			b = a.getVelocity();
			if (Math.abs(b) < this.getMinVelocity()) {
				this.isEnded = true
			}
			if (j >= g && j <= d) {
				return j
			}
			this.isOutOfBound = true;
			k.setStartTime(Ext.Date.now()).setStartVelocity(b).setStartValue(c)
		}
		j = k.getValue();
		if (!this.isEnded) {
			if (!this.isBouncingBack) {
				if (h !== null) {
					if ((f == 1 && j < h) || (f == -1 && j > h)) {
						this.isBouncingBack = true
					}
				}
			} else {
				if (Math.round(j) == c) {
					this.isEnded = true
				}
			}
		}
		this.lastValue = j;
		return j
	}
});
Ext.define("Ext.fx.easing.EaseOut", {
	extend: Ext.fx.easing.Linear,
	alias: "easing.ease-out",
	config: {
		exponent: 4,
		duration: 1500
	},
	getValue: function () {
		var f = Ext.Date.now() - this.getStartTime(),
			d = this.getDuration(),
			b = this.getStartValue(),
			h = this.getEndValue(),
			a = this.distance,
			c = f / d,
			g = 1 - c,
			e = 1 - Math.pow(g, this.getExponent()),
			j = b + (e * a);
		if (f >= d) {
			this.isEnded = true;
			return h
		}
		return j
	}
});
Ext.define("Ext.scroll.Scroller", {
	extend: Ext.Evented,
	config: {
		element: null,
		direction: "auto",
		fps: "auto",
		disabled: null,
		directionLock: false,
		momentumEasing: {
			momentum: {
				acceleration: 30,
				friction: 0.5
			},
			bounce: {
				acceleration: 30,
				springTension: 0.3
			},
			minVelocity: 1
		},
		bounceEasing: {
			duration: 400
		},
		outOfBoundRestrictFactor: 0.5,
		startMomentumResetTime: 300,
		maxAbsoluteVelocity: 6,
		containerSize: "auto",
		size: "auto",
		autoRefresh: true,
		initialOffset: {
			x: 0,
			y: 0
		},
		slotSnapSize: {
			x: 0,
			y: 0
		},
		slotSnapOffset: {
			x: 0,
			y: 0
		},
		slotSnapEasing: {
			duration: 150
		},
		translatable: {
			translationMethod: "auto",
			useWrapper: false
		}
	},
	cls: Ext.baseCSSPrefix + "scroll-scroller",
	containerCls: Ext.baseCSSPrefix + "scroll-container",
	dragStartTime: 0,
	dragEndTime: 0,
	isDragging: false,
	isAnimating: false,
	constructor: function (a) {
		var b = a && a.element;
		this.listeners = {
			scope: this,
			touchstart: "onTouchStart",
			touchend: "onTouchEnd",
			dragstart: "onDragStart",
			drag: "onDrag",
			dragend: "onDragEnd"
		};
		this.minPosition = {
			x: 0,
			y: 0
		};
		this.startPosition = {
			x: 0,
			y: 0
		};
		this.position = {
			x: 0,
			y: 0
		};
		this.velocity = {
			x: 0,
			y: 0
		};
		this.isAxisEnabledFlags = {
			x: false,
			y: false
		};
		this.flickStartPosition = {
			x: 0,
			y: 0
		};
		this.flickStartTime = {
			x: 0,
			y: 0
		};
		this.lastDragPosition = {
			x: 0,
			y: 0
		};
		this.dragDirection = {
			x: 0,
			y: 0
		};
		this.initialConfig = a;
		if (b) {
			this.setElement(b)
		}
		return this
	},
	applyElement: function (a) {
		if (!a) {
			return
		}
		return Ext.get(a)
	},
	updateElement: function (a) {
		this.initialize();
		if (!this.FixedHBoxStretching) {
			a.addCls(this.cls)
		}
		if (!this.getDisabled()) {
			this.attachListeneners()
		}
		this.onConfigUpdate(["containerSize", "size"], "refreshMaxPosition");
		this.on("maxpositionchange", "snapToBoundary");
		this.on("minpositionchange", "snapToBoundary");
		return this
	},
	applyTranslatable: function (b, a) {
		return Ext.factory(b, Ext.util.Translatable, a)
	},
	updateTranslatable: function (a) {
		a.setConfig({
			element: this.getElement(),
			listeners: {
				animationframe: "onAnimationFrame",
				animationend: "onAnimationEnd",
				scope: this
			}
		})
	},
	updateFps: function (a) {
		if (a !== "auto") {
			this.getTranslatable().setFps(a)
		}
	},
	attachListeneners: function () {
		this.getContainer().on(this.listeners)
	},
	detachListeners: function () {
		this.getContainer().un(this.listeners)
	},
	updateDisabled: function (a) {
		if (a) {
			this.detachListeners()
		} else {
			this.attachListeneners()
		}
	},
	updateInitialOffset: function (c) {
		if (typeof c == "number") {
			c = {
				x: c,
				y: c
			}
		}
		var b = this.position,
			a, d;
		b.x = a = c.x;
		b.y = d = c.y;
		this.getTranslatable().translate(-a, -d)
	},
	applyDirection: function (a) {
		var e = this.getMinPosition(),
			d = this.getMaxPosition(),
			c, b;
		this.givenDirection = a;
		if (a === "auto") {
			c = d.x > e.x;
			b = d.y > e.y;
			if (c && b) {
				a = "both"
			} else {
				if (c) {
					a = "horizontal"
				} else {
					a = "vertical"
				}
			}
		}
		return a
	},
	updateDirection: function (b) {
		var a = this.isAxisEnabledFlags;
		a.x = (b === "both" || b === "horizontal");
		a.y = (b === "both" || b === "vertical")
	},
	isAxisEnabled: function (a) {
		this.getDirection();
		return this.isAxisEnabledFlags[a]
	},
	applyMomentumEasing: function (b) {
		var a = Ext.fx.easing.BoundMomentum;
		return {
			x: Ext.factory(b, a),
			y: Ext.factory(b, a)
		}
	},
	applyBounceEasing: function (b) {
		var a = Ext.fx.easing.EaseOut;
		return {
			x: Ext.factory(b, a),
			y: Ext.factory(b, a)
		}
	},
	updateBounceEasing: function (a) {
		this.getTranslatable().setEasingX(a.x).setEasingY(a.y)
	},
	applySlotSnapEasing: function (b) {
		var a = Ext.fx.easing.EaseOut;
		return {
			x: Ext.factory(b, a),
			y: Ext.factory(b, a)
		}
	},
	getMinPosition: function () {
		var a = this.minPosition;
		if (!a) {
			this.minPosition = a = {
				x: 0,
				y: 0
			};
			this.fireEvent("minpositionchange", this, a)
		}
		return a
	},
	getMaxPosition: function () {
		var c = this.maxPosition,
			a, b;
		if (!c) {
			a = this.getSize();
			b = this.getContainerSize();
			this.maxPosition = c = {
				x: Math.max(0, a.x - b.x),
				y: Math.max(0, a.y - b.y)
			};
			this.fireEvent("maxpositionchange", this, c)
		}
		return c
	},
	refreshMaxPosition: function () {
		this.maxPosition = null;
		this.getMaxPosition()
	},
	applyContainerSize: function (b) {
		var c = this.getContainer().dom,
			a, d;
		if (!c) {
			return
		}
		this.givenContainerSize = b;
		if (b === "auto") {
			a = c.offsetWidth;
			d = c.offsetHeight
		} else {
			a = b.x;
			d = b.y
		}
		return {
			x: a,
			y: d
		}
	},
	applySize: function (b) {
		var c = this.getElement().dom,
			a, d;
		if (!c) {
			return
		}
		this.givenSize = b;
		if (b === "auto") {
			a = c.offsetWidth;
			d = c.offsetHeight
		} else {
			if (typeof b == "number") {
				a = b;
				d = b
			} else {
				a = b.x;
				d = b.y
			}
		}
		return {
			x: a,
			y: d
		}
	},
	updateAutoRefresh: function (a) {
		this.getElement().toggleListener(a, "resize", "onElementResize", this);
		this.getContainer().toggleListener(a, "resize", "onContainerResize", this)
	},
	applySlotSnapSize: function (a) {
		if (typeof a == "number") {
			return {
				x: a,
				y: a
			}
		}
		return a
	},
	applySlotSnapOffset: function (a) {
		if (typeof a == "number") {
			return {
				x: a,
				y: a
			}
		}
		return a
	},
	getContainer: function () {
		var a = this.container,
			b;
		if (!a) {
			b = this.getElement().getParent();
			this.container = a = this.FixedHBoxStretching ? b.getParent() : b;
			a.addCls(this.containerCls)
		}
		return a
	},
	refresh: function () {
		this.stopAnimation();
		this.getTranslatable().refresh();
		this.setSize(this.givenSize);
		this.setContainerSize(this.givenContainerSize);
		this.setDirection(this.givenDirection);
		this.fireEvent("refresh", this);
		return this
	},
	onElementResize: function (a, b) {
		this.setSize({
			x: b.width,
			y: b.height
		});
		this.refresh()
	},
	onContainerResize: function (a, b) {
		this.setContainerSize({
			x: b.width,
			y: b.height
		});
		this.refresh()
	},
	scrollTo: function (c, h, g) {
		if (this.isDestroyed) {
			return this
		}
		var b = this.getTranslatable(),
			a = this.position,
			d = false,
			f, e;
		if (this.isAxisEnabled("x")) {
			if (isNaN(c) || typeof c != "number") {
				c = a.x
			} else {
				if (a.x !== c) {
					a.x = c;
					d = true
				}
			}
			f = -c
		}
		if (this.isAxisEnabled("y")) {
			if (isNaN(h) || typeof h != "number") {
				h = a.y
			} else {
				if (a.y !== h) {
					a.y = h;
					d = true
				}
			}
			e = -h
		}
		if (d) {
			if (g !== undefined && g !== false) {
				b.translateAnimated(f, e, g)
			} else {
				this.fireEvent("scroll", this, a.x, a.y);
				b.translate(f, e)
			}
		}
		return this
	},
	scrollToTop: function (b) {
		var a = this.getInitialOffset();
		return this.scrollTo(a.x, a.y, b)
	},
	scrollToEnd: function (c) {
		var b = this.getSize(),
			a = this.getContainerSize();
		return this.scrollTo(b.x - a.x, b.y - a.y, c)
	},
	scrollBy: function (b, d, c) {
		var a = this.position;
		b = (typeof b == "number") ? b + a.x : null;
		d = (typeof d == "number") ? d + a.y : null;
		return this.scrollTo(b, d, c)
	},
	onTouchStart: function () {
		this.isTouching = true;
		this.stopAnimation()
	},
	onTouchEnd: function () {
		var a = this.position;
		this.isTouching = false;
		if (!this.isDragging && this.snapToSlot()) {
			this.fireEvent("scrollstart", this, a.x, a.y)
		}
	},
	onDragStart: function (m) {
		var p = this.getDirection(),
			g = m.absDeltaX,
			f = m.absDeltaY,
			k = this.getDirectionLock(),
			j = this.startPosition,
			d = this.flickStartPosition,
			l = this.flickStartTime,
			h = this.lastDragPosition,
			c = this.position,
			b = this.dragDirection,
			o = c.x,
			n = c.y,
			a = Ext.Date.now();
		this.isDragging = true;
		if (k && p !== "both") {
			if ((p === "horizontal" && g > f) || (p === "vertical" && f > g)) {
				m.stopPropagation()
			} else {
				this.isDragging = false;
				return
			}
		}
		h.x = o;
		h.y = n;
		d.x = o;
		d.y = n;
		j.x = o;
		j.y = n;
		l.x = a;
		l.y = a;
		b.x = 0;
		b.y = 0;
		this.dragStartTime = a;
		this.isDragging = true;
		this.fireEvent("scrollstart", this, o, n)
	},
	onAxisDrag: function (j, r) {
		if (!this.isAxisEnabled(j)) {
			return
		}
		var h = this.flickStartPosition,
			m = this.flickStartTime,
			k = this.lastDragPosition,
			e = this.dragDirection,
			g = this.position[j],
			l = this.getMinPosition()[j],
			p = this.getMaxPosition()[j],
			d = this.startPosition[j],
			q = k[j],
			o = d - r,
			c = e[j],
			n = this.getOutOfBoundRestrictFactor(),
			f = this.getStartMomentumResetTime(),
			b = Ext.Date.now(),
			a;
		if (o < l) {
			o *= n
		} else {
			if (o > p) {
				a = o - p;
				o = p + a * n
			}
		}
		if (o > q) {
			e[j] = 1
		} else {
			if (o < q) {
				e[j] = -1
			}
		}
		if ((c !== 0 && (e[j] !== c)) || (b - m[j]) > f) {
			h[j] = g;
			m[j] = b
		}
		k[j] = o
	},
	onDrag: function (b) {
		if (!this.isDragging) {
			return
		}
		var a = this.lastDragPosition;
		this.onAxisDrag("x", b.deltaX);
		this.onAxisDrag("y", b.deltaY);
		this.scrollTo(a.x, a.y)
	},
	onDragEnd: function (c) {
		var b, a;
		if (!this.isDragging) {
			return
		}
		this.dragEndTime = Ext.Date.now();
		this.onDrag(c);
		this.isDragging = false;
		b = this.getAnimationEasing("x", c);
		a = this.getAnimationEasing("y", c);
		if (b || a) {
			this.getTranslatable().animate(b, a)
		} else {
			this.onScrollEnd()
		}
	},
	getAnimationEasing: function (g, k) {
		if (!this.isAxisEnabled(g)) {
			return null
		}
		var f = this.position[g],
			c = this.getMinPosition()[g],
			j = this.getMaxPosition()[g],
			a = this.getMaxAbsoluteVelocity(),
			d = null,
			b = this.dragEndTime,
			h = k.flick.velocity[g],
			l;
		if (f < c) {
			d = c
		} else {
			if (f > j) {
				d = j
			}
		}
		if (d !== null) {
			l = this.getBounceEasing()[g];
			l.setConfig({
				startTime: b,
				startValue: -f,
				endValue: -d
			});
			return l
		}
		if (h === 0) {
			return null
		}
		if (h < -a) {
			h = -a
		} else {
			if (h > a) {
				h = a
			}
		}
		if (Ext.browser.is.IE) {
			h *= 2
		}
		l = this.getMomentumEasing()[g];
		l.setConfig({
			startTime: b,
			startValue: -f,
			startVelocity: h * 1.5,
			minMomentumValue: -j,
			maxMomentumValue: 0
		});
		return l
	},
	onAnimationFrame: function (c, b, d) {
		var a = this.position;
		a.x = -b;
		a.y = -d;
		this.fireEvent("scroll", this, a.x, a.y)
	},
	onAnimationEnd: function () {
		this.snapToBoundary();
		this.onScrollEnd()
	},
	stopAnimation: function () {
		this.getTranslatable().stopAnimation()
	},
	onScrollEnd: function () {
		var a = this.position;
		if (this.isTouching || !this.snapToSlot()) {
			this.fireEvent("scrollend", this, a.x, a.y)
		}
	},
	snapToSlot: function () {
		var b = this.getSnapPosition("x"),
			a = this.getSnapPosition("y"),
			c = this.getSlotSnapEasing();
		if (b !== null || a !== null) {
			this.scrollTo(b, a, {
				easingX: c.x,
				easingY: c.y
			});
			return true
		}
		return false
	},
	getSnapPosition: function (c) {
		var g = this.getSlotSnapSize()[c],
			d = null,
			a, f, e, b;
		if (g !== 0 && this.isAxisEnabled(c)) {
			a = this.position[c];
			f = this.getSlotSnapOffset()[c];
			e = this.getMaxPosition()[c];
			b = Math.floor((a - f) % g);
			if (b !== 0) {
				if (a !== e) {
					if (Math.abs(b) > g / 2) {
						d = Math.min(e, a + ((b > 0) ? g - b : b - g))
					} else {
						d = a - b
					}
				} else {
					d = a - b
				}
			}
		}
		return d
	},
	snapToBoundary: function () {
		var g = this.position,
			c = this.getMinPosition(),
			f = this.getMaxPosition(),
			e = c.x,
			d = c.y,
			b = f.x,
			a = f.y,
			j = Math.round(g.x),
			h = Math.round(g.y);
		if (j < e) {
			j = e
		} else {
			if (j > b) {
				j = b
			}
		}
		if (h < d) {
			h = d
		} else {
			if (h > a) {
				h = a
			}
		}
		this.scrollTo(j, h)
	},
	destroy: function () {
		var c = this.getElement(),
			b = this.sizeMonitors,
			a;
		if (b) {
			b.element.destroy();
			b.container.destroy()
		}
		if (c && !c.isDestroyed) {
			c.removeCls(this.cls);
			a = this.getContainer();
			if (a && !a.isDestroyed) {
				a.removeCls(this.containerCls)
			}
		}
		Ext.destroy(this.getTranslatable());
		this.callParent(arguments)
	}
}, function () {});
(function () {
	var c = 0,
		f = ["ms", "moz", "webkit", "o"],
		b = f.length,
		a, e, d;
	for (a = 0; a < b && !window.requestAnimationFrame; ++a) {
		e = f[a];
		window.requestAnimationFrame = window[e + "RequestAnimationFrame"];
		window.cancelAnimationFrame = window[e + "CancelAnimationFrame"] || window[e + "CancelRequestAnimationFrame"]
	}
	if (!window.Ext) {
		window.Ext = {}
	}
	Ext.performance = {};
	if (window.performance && window.performance.now) {
		Ext.performance.now = function () {
			return window.performance.now()
		}
	} else {
		Ext.performance.now = function () {
			return Date.now()
		}
	}
	if (!window.requestAnimationFrame) {
		window.requestAnimationFrame = function (l, h) {
			var g = Ext.performance.now(),
				j = Math.max(0, 16 - (g - c)),
				k = window.setTimeout(function () {
					l(g + j)
				}, j);
			c = g + j;
			return k
		}
	} else {
		Ext.trueRequestAnimationFrames = true
	}
	if (!window.cancelAnimationFrame) {
		window.cancelAnimationFrame = function (g) {
			clearTimeout(g)
		}
	}
}());
(function (a) {
	Ext.define("Ext.AnimationQueue", {
		singleton: true,
		constructor: function () {
			var b = Ext.Function.bind;
			this.queue = [];
			this.taskQueue = [];
			this.runningQueue = [];
			this.idleQueue = [];
			this.isRunning = false;
			this.isIdle = true;
			this.run = b(this.run, this);
			this.whenIdle = b(this.whenIdle, this);
			this.processIdleQueueItem = b(this.processIdleQueueItem, this);
			this.processTaskQueueItem = b(this.processTaskQueueItem, this)
		},
		start: function (d, c, b) {
			this.queue.push(arguments);
			if (!this.isRunning) {
				if (this.hasOwnProperty("idleTimer")) {
					clearTimeout(this.idleTimer);
					delete this.idleTimer
				}
				if (this.hasOwnProperty("idleQueueTimer")) {
					clearTimeout(this.idleQueueTimer);
					delete this.idleQueueTimer
				}
				this.isIdle = false;
				this.isRunning = true;
				this.doStart()
			}
		},
		run: function () {
			if (!this.isRunning) {
				return
			}
			var b = this.runningQueue,
				c, d;
			this.frameStartTime = Ext.performance.now();
			b.push.apply(b, this.queue);
			for (c = 0, d = b.length; c < d; c++) {
				this.invoke(b[c])
			}
			b.length = 0;
			this.doIterate()
		},
		doStart: function () {
			this.animationFrameId = requestAnimationFrame(this.run)
		},
		doIterate: function () {
			this.animationFrameId = requestAnimationFrame(this.run)
		},
		doStop: function () {
			cancelAnimationFrame(this.animationFrameId)
		},
		stop: function (f, e, c) {
			if (!this.isRunning) {
				return
			}
			var b = this.queue,
				h = b.length,
				d, g;
			for (d = 0; d < h; d++) {
				g = b[d];
				if (g[0] === f && g[1] === e && g[2] === c) {
					b.splice(d, 1);
					d--;
					h--
				}
			}
			if (h === 0) {
				this.doStop();
				this.isRunning = false;
				this.idleTimer = setTimeout(this.whenIdle, 100)
			}
		},
		onIdle: function (f, e, b) {
			var d = this.idleQueue,
				c, g, h;
			for (c = 0, g = d.length; c < g; c++) {
				h = d[c];
				if (f === h[0] && e === h[1] && b === h[2]) {
					return
				}
			}
			d.push(arguments);
			if (this.isIdle) {
				this.processIdleQueue()
			}
		},
		unIdle: function (f, e, b) {
			var d = this.idleQueue,
				c, g, h;
			for (c = 0, g = d.length; c < g; c++) {
				h = d[c];
				if (f === h[0] && e === h[1] && b === h[2]) {
					d.splice(c, 1);
					return true
				}
			}
			return false
		},
		queueTask: function (d, c, b) {
			this.taskQueue.push(arguments);
			this.processTaskQueue()
		},
		dequeueTask: function (f, e, b) {
			var d = this.taskQueue,
				c, g, h;
			for (c = 0, g = d.length; c < g; c++) {
				h = d[c];
				if (f === h[0] && e === h[1] && b === h[2]) {
					d.splice(c, 1);
					c--;
					g--
				}
			}
		},
		invoke: function (e) {
			var d = e[0],
				c = e[1],
				b = e[2];
			d = (typeof d == "string" ? c[d] : d);
			if (Ext.isArray(b)) {
				d.apply(c, b)
			} else {
				d.call(c, b)
			}
		},
		whenIdle: function () {
			this.isIdle = true;
			this.processIdleQueue()
		},
		processIdleQueue: function () {
			if (!this.hasOwnProperty("idleQueueTimer")) {
				this.idleQueueTimer = setTimeout(this.processIdleQueueItem, 1)
			}
		},
		processIdleQueueItem: function () {
			delete this.idleQueueTimer;
			if (!this.isIdle) {
				return
			}
			var b = this.idleQueue,
				c;
			if (b.length > 0) {
				c = b.shift();
				this.invoke(c);
				this.processIdleQueue()
			}
		},
		processTaskQueue: function () {
			if (!this.hasOwnProperty("taskQueueTimer")) {
				this.taskQueueTimer = setTimeout(this.processTaskQueueItem, 15)
			}
		},
		processTaskQueueItem: function () {
			delete this.taskQueueTimer;
			var b = this.taskQueue,
				c;
			if (b.length > 0) {
				c = b.shift();
				this.invoke(c);
				this.processTaskQueue()
			}
		},
		showFps: function () {
			if (!Ext.trueRequestAnimationFrames) {
				alert("This browser does not support requestAnimationFrame. The FPS listed will not be accurate")
			}
			Ext.onReady(function () {
				Ext.Viewport.add([{
					xtype: "component",
					bottom: 50,
					left: 0,
					width: 50,
					height: 20,
					html: "Average",
					style: "background-color: black; color: white; text-align: center; line-height: 20px; font-size: 8px;"
				}, {
					id: "__averageFps",
					xtype: "component",
					bottom: 0,
					left: 0,
					width: 50,
					height: 50,
					html: "0",
					style: "background-color: red; color: white; text-align: center; line-height: 50px;"
				}, {
					xtype: "component",
					bottom: 50,
					left: 50,
					width: 50,
					height: 20,
					html: "Min (Last 1k)",
					style: "background-color: black; color: white; text-align: center; line-height: 20px; font-size: 8px;"
				}, {
					id: "__minFps",
					xtype: "component",
					bottom: 0,
					left: 50,
					width: 50,
					height: 50,
					html: "0",
					style: "background-color: orange; color: white; text-align: center; line-height: 50px;"
				}, {
					xtype: "component",
					bottom: 50,
					left: 100,
					width: 50,
					height: 20,
					html: "Max (Last 1k)",
					style: "background-color: black; color: white; text-align: center; line-height: 20px; font-size: 8px;"
				}, {
					id: "__maxFps",
					xtype: "component",
					bottom: 0,
					left: 100,
					width: 50,
					height: 50,
					html: "0",
					style: "background-color: yellow; color: black; text-align: center; line-height: 50px;"
				}, {
					xtype: "component",
					bottom: 50,
					left: 150,
					width: 50,
					height: 20,
					html: "Current",
					style: "background-color: black; color: white; text-align: center; line-height: 20px; font-size: 8px;"
				}, {
					id: "__currentFps",
					xtype: "component",
					bottom: 0,
					left: 150,
					width: 50,
					height: 50,
					html: "0",
					style: "background-color: green; color: white; text-align: center; line-height: 50px;"
				}]);
				Ext.AnimationQueue.resetFps()
			})
		},
		resetFps: function () {
			var d = Ext.getCmp("__currentFps"),
				c = Ext.getCmp("__averageFps"),
				j = Ext.getCmp("__minFps"),
				h = Ext.getCmp("__maxFps"),
				e = 1000,
				b = 0,
				g = 0,
				f = 0;
			Ext.AnimationQueue.onFpsChanged = function (k) {
				g++;
				if (!(g % 10)) {
					e = 1000;
					b = 0
				}
				f += k;
				e = Math.min(e, k);
				b = Math.max(b, k);
				d.setHtml(Math.round(k));
				c.setHtml(Math.round(f / g));
				j.setHtml(Math.round(e));
				h.setHtml(Math.round(b))
			}
		}
	}, function () {})
})(this);
Ext.define("Ext.TaskQueue", {
	singleton: true,
	pending: false,
	mode: true,
	constructor: function () {
		this.readQueue = [];
		this.writeQueue = [];
		this.run = Ext.Function.bind(this.run, this)
	},
	requestRead: function (c, b, a) {
		this.request(true);
		this.readQueue.push(arguments)
	},
	requestWrite: function (c, b, a) {
		this.request(false);
		this.writeQueue.push(arguments)
	},
	request: function (a) {
		if (!this.pending) {
			this.pending = true;
			this.mode = a;
			if (a) {
				setTimeout(this.run, 1)
			} else {
				requestAnimationFrame(this.run)
			}
		}
	},
	run: function () {
		this.pending = false;
		var j = this.readQueue,
			e = this.writeQueue,
			c = null,
			f;
		if (this.mode) {
			f = j;
			if (e.length > 0) {
				c = false
			}
		} else {
			f = e;
			if (j.length > 0) {
				c = true
			}
		}
		var b = f.slice(),
			d, g, a, h, k;
		f.length = 0;
		for (d = 0, g = b.length; d < g; d++) {
			a = b[d];
			h = a[0];
			k = a[1];
			if (typeof h == "string") {
				h = k[h]
			}
			if (a.length > 2) {
				h.apply(k, a[2])
			} else {
				h.call(k)
			}
		}
		b.length = 0;
		if (c !== null) {
			this.request(c)
		}
	}
});
Ext.define("Ext.scroll.indicator.Abstract", {
	extend: Ext.Component,
	config: {
		baseCls: "x-scroll-indicator",
		axis: "x",
		value: null,
		length: null,
		minLength: 6,
		hidden: true,
		ui: "dark"
	},
	cachedConfig: {
		ratio: 1,
		barCls: "x-scroll-bar",
		active: true
	},
	barElement: null,
	barLength: 0,
	gapLength: 0,
	getElementConfig: function () {
		return {
			reference: "barElement",
			children: [this.callParent()]
		}
	},
	applyRatio: function (a) {
		if (isNaN(a) || a > 1) {
			a = 1
		}
		return a
	},
	refresh: function () {
		var f = this.barElement,
			e = f.dom,
			c = this.getRatio(),
			b = this.getAxis(),
			a = (b === "x") ? e.offsetWidth : e.offsetHeight,
			d = a * c;
		this.barLength = a;
		this.gapLength = a - d;
		this.setLength(d);
		this.updateValue(this.getValue())
	},
	updateBarCls: function (a) {
		this.barElement.addCls(a)
	},
	updateAxis: function (a) {
		this.element.addCls(this.getBaseCls(), null, a);
		this.barElement.addCls(this.getBarCls(), null, a)
	},
	updateValue: function (f) {
		var b = this.barLength,
			c = this.gapLength,
			d = this.getLength(),
			e, g, a;
		if (f <= 0) {
			g = 0;
			this.updateLength(this.applyLength(d + f * b))
		} else {
			if (f >= 1) {
				a = Math.round((f - 1) * b);
				e = this.applyLength(d - a);
				a = d - e;
				this.updateLength(e);
				g = c + a
			} else {
				g = c * f
			}
		}
		this.setOffset(g)
	},
	updateActive: function (a) {
		this.barElement[a ? "addCls" : "removeCls"]("active")
	},
	doSetHidden: function (a) {
		if (a) {
			this.setOffset(-10000)
		} else {
			delete this.lastLength;
			delete this.lastOffset;
			this.updateValue(this.getValue())
		}
	},
	applyLength: function (a) {
		return Math.max(this.getMinLength(), a)
	},
	updateLength: function (a) {
		a = Math.round(a);
		if (this.lastLength === a) {
			return
		}
		this.lastLength = a;
		Ext.TaskQueue.requestWrite("doUpdateLength", this, [a])
	},
	doUpdateLength: function (c) {
		if (!this.isDestroyed) {
			var b = this.getAxis(),
				a = this.element;
			if (b === "x") {
				a.setWidth(c)
			} else {
				a.setHeight(c)
			}
		}
	},
	setOffset: function (a) {
		a = Math.round(a);
		if (this.lastOffset === a || this.lastOffset === -10000) {
			return
		}
		this.lastOffset = a;
		Ext.TaskQueue.requestWrite("doSetOffset", this, [a])
	},
	doSetOffset: function (c) {
		if (!this.isDestroyed) {
			var b = this.getAxis(),
				a = this.element;
			if (b === "x") {
				a.translate(c, 0)
			} else {
				a.translate(0, c)
			}
		}
	}
});
Ext.define("Ext.scroll.indicator.CssTransform", {
	extend: Ext.scroll.indicator.Abstract,
	config: {
		cls: "csstransform"
	}
});
Ext.define("Ext.scroll.indicator.ScrollPosition", {
	extend: Ext.scroll.indicator.Abstract,
	config: {
		cls: "scrollposition"
	},
	getElementConfig: function () {
		var a = this.callParent(arguments);
		a.children.unshift({
			className: "x-scroll-bar-stretcher"
		});
		return a
	},
	updateValue: function (a) {
		if (this.gapLength === 0) {
			if (a >= 1) {
				a--
			}
			this.setOffset(this.barLength * a)
		} else {
			this.setOffset(this.gapLength * a)
		}
	},
	doUpdateLength: function () {
		if (!this.isDestroyed) {
			var a = this.barLength,
				b = this.element;
			this.callParent(arguments);
			if (this.getAxis() === "x") {
				b.setLeft(a)
			} else {
				b.setTop(a)
			}
		}
	},
	doSetOffset: function (d) {
		if (!this.isDestroyed) {
			var b = this.barLength,
				a = this.getMinLength(),
				c = this.barElement.dom;
			if (d !== -10000) {
				d = Math.min(b - a, Math.max(d, a - this.getLength()));
				d = b - d
			}
			if (this.getAxis() === "x") {
				c.scrollLeft = d
			} else {
				c.scrollTop = d
			}
		}
	}
});
Ext.define("Ext.scroll.indicator.Rounded", {
	extend: Ext.scroll.indicator.Abstract,
	config: {
		cls: "rounded"
	},
	constructor: function () {
		this.callParent(arguments);
		this.transformPropertyName = Ext.browser.getVendorProperyName("transform")
	},
	getElementConfig: function () {
		var a = this.callParent();
		a.children[0].children = [{
			reference: "startElement"
		}, {
			reference: "middleElement"
		}, {
			reference: "endElement"
		}];
		return a
	},
	refresh: function () {
		var d = this.getAxis(),
			c = this.startElement.dom,
			a = this.endElement.dom,
			e = this.middleElement,
			b, f;
		if (d === "x") {
			b = c.offsetWidth;
			f = a.offsetWidth;
			e.setLeft(b)
		} else {
			b = c.offsetHeight;
			f = a.offsetHeight;
			e.setTop(b)
		}
		this.startElementLength = b;
		this.endElementLength = f;
		this.callParent()
	},
	doUpdateLength: function (c) {
		if (!this.isDestroyed) {
			var b = this.getAxis(),
				a = this.endElement,
				e = this.middleElement.dom.style,
				d = this.endElementLength,
				h = c - d,
				g = h - this.startElementLength,
				f = this.transformPropertyName;
			if (b === "x") {
				a.translate(h, 0);
				e[f] = "translate3d(0, 0, 0) scaleX(" + g + ")"
			} else {
				a.translate(0, h);
				e[f] = "translate3d(0, 0, 0) scaleY(" + g + ")"
			}
		}
	}
});
Ext.define("Ext.scroll.Indicator", {
	alternateClassName: "Ext.util.Indicator",
	constructor: function (a) {
		var b = Ext.scroll.indicator;
		switch (Ext.browser.getPreferredTranslationMethod(a)) {
		case "scrollposition":
			return new b.ScrollPosition(a);
		case "csstransform":
			if (Ext.browser.is.AndroidStock4) {
				return new b.CssTransform(a)
			} else {
				return new b.Rounded(a)
			}
		}
	}
});
Ext.define("Ext.scroll.View", {
	extend: Ext.Evented,
	alternateClassName: "Ext.util.ScrollView",
	config: {
		indicatorsUi: "dark",
		element: null,
		scroller: {},
		indicators: {
			x: {
				axis: "x"
			},
			y: {
				axis: "y"
			}
		},
		indicatorsHidingDelay: 100,
		cls: Ext.baseCSSPrefix + "scroll-view"
	},
	processConfig: function (c) {
		if (!c) {
			return null
		}
		if (typeof c == "string") {
			c = {
				direction: c
			}
		}
		c = Ext.merge({}, c);
		var a = c.scroller,
			b;
		if (!a) {
			c.scroller = a = {}
		}
		for (b in c) {
			if (c.hasOwnProperty(b)) {
				if (!this.hasConfig(b)) {
					a[b] = c[b];
					delete c[b]
				}
			}
		}
		return c
	},
	constructor: function (a) {
		a = this.processConfig(a);
		this.useIndicators = {
			x: true,
			y: true
		};
		this.doHideIndicators = Ext.Function.bind(this.doHideIndicators, this);
		this.initConfig(a)
	},
	setConfig: function (a) {
		return this.callParent([this.processConfig(a)])
	},
	updateIndicatorsUi: function (a) {
		var b = this.getIndicators();
		b.x.setUi(a);
		b.y.setUi(a)
	},
	applyScroller: function (a, b) {
		return Ext.factory(a, Ext.scroll.Scroller, b)
	},
	applyIndicators: function (b, d) {
		var a = Ext.scroll.Indicator,
			c = this.useIndicators;
		if (!b) {
			b = {}
		}
		if (!b.x) {
			c.x = false;
			b.x = {}
		}
		if (!b.y) {
			c.y = false;
			b.y = {}
		}
		return {
			x: Ext.factory(b.x, a, d && d.x),
			y: Ext.factory(b.y, a, d && d.y)
		}
	},
	updateIndicators: function (a) {
		this.indicatorsGrid = Ext.Element.create({
			className: "x-scroll-bar-grid-wrapper",
			children: [{
				className: "x-scroll-bar-grid",
				children: [{
					children: [{}, {
						children: [a.y.barElement]
					}]
				}, {
					children: [{
						children: [a.x.barElement]
					}, {}]
				}]
			}]
		})
	},
	updateScroller: function (a) {
		a.on({
			scope: this,
			scrollstart: "onScrollStart",
			scroll: "onScroll",
			scrollend: "onScrollEnd",
			refresh: "refreshIndicators"
		})
	},
	isAxisEnabled: function (a) {
		return this.getScroller().isAxisEnabled(a) && this.useIndicators[a]
	},
	applyElement: function (a) {
		if (a) {
			return Ext.get(a)
		}
	},
	updateElement: function (c) {
		var b = this.getScroller(),
			a;
		a = c.getFirstChild().getFirstChild();
		if (this.FixedHBoxStretching) {
			a = a.getFirstChild()
		}
		c.addCls(this.getCls());
		c.insertFirst(this.indicatorsGrid);
		b.setElement(a);
		this.refreshIndicators();
		return this
	},
	showIndicators: function () {
		var a = this.getIndicators();
		if (this.hasOwnProperty("indicatorsHidingTimer")) {
			clearTimeout(this.indicatorsHidingTimer);
			delete this.indicatorsHidingTimer
		}
		if (this.isAxisEnabled("x")) {
			a.x.show()
		}
		if (this.isAxisEnabled("y")) {
			a.y.show()
		}
	},
	hideIndicators: function () {
		var a = this.getIndicatorsHidingDelay();
		if (a > 0) {
			this.indicatorsHidingTimer = setTimeout(this.doHideIndicators, a)
		} else {
			this.doHideIndicators()
		}
	},
	doHideIndicators: function () {
		var a = this.getIndicators();
		if (this.isAxisEnabled("x")) {
			a.x.hide()
		}
		if (this.isAxisEnabled("y")) {
			a.y.hide()
		}
	},
	onScrollStart: function () {
		this.onScroll.apply(this, arguments);
		this.showIndicators()
	},
	onScrollEnd: function () {
		this.hideIndicators()
	},
	onScroll: function (b, a, c) {
		this.setIndicatorValue("x", a);
		this.setIndicatorValue("y", c)
	},
	setIndicatorValue: function (b, f) {
		if (!this.isAxisEnabled(b)) {
			return this
		}
		var a = this.getScroller(),
			c = a.getMaxPosition()[b],
			e = a.getContainerSize()[b],
			d;
		if (c === 0) {
			d = f / e;
			if (f >= 0) {
				d += 1
			}
		} else {
			if (f > c) {
				d = 1 + ((f - c) / e)
			} else {
				if (f < 0) {
					d = f / e
				} else {
					d = f / c
				}
			}
		}
		this.getIndicators()[b].setValue(d)
	},
	refreshIndicator: function (d) {
		if (!this.isAxisEnabled(d)) {
			return this
		}
		var a = this.getScroller(),
			b = this.getIndicators()[d],
			e = a.getContainerSize()[d],
			f = a.getSize()[d],
			c = e / f;
		b.setRatio(c);
		b.refresh()
	},
	refresh: function () {
		return this.getScroller().refresh()
	},
	refreshIndicators: function () {
		var a = this.getIndicators();
		a.x.setActive(this.isAxisEnabled("x"));
		a.y.setActive(this.isAxisEnabled("y"));
		this.refreshIndicator("x");
		this.refreshIndicator("y")
	},
	destroy: function () {
		var a = this.getElement(),
			b = this.getIndicators();
		Ext.destroy(this.getScroller(), this.indicatorsGrid);
		if (this.hasOwnProperty("indicatorsHidingTimer")) {
			clearTimeout(this.indicatorsHidingTimer);
			delete this.indicatorsHidingTimer
		}
		if (a && !a.isDestroyed) {
			a.removeCls(this.getCls())
		}
		b.x.destroy();
		b.y.destroy();
		delete this.indicatorsGrid;
		this.callParent(arguments)
	}
});
Ext.define("Ext.behavior.Scrollable", {
	extend: Ext.behavior.Behavior,
	constructor: function () {
		this.listeners = {
			painted: "onComponentPainted",
			scope: this
		};
		this.callParent(arguments)
	},
	onComponentPainted: function () {
		this.scrollView.refresh()
	},
	setConfig: function (f) {
		var c = this.scrollView,
			e = this.component,
			b, d, a, g;
		if (f) {
			if (!c) {
				this.scrollView = c = new Ext.scroll.View(f);
				c.on("destroy", "onScrollViewDestroy", this);
				e.setUseBodyElement(true);
				this.scrollerElement = b = e.innerElement;
				if (!Ext.feature.has.ProperHBoxStretching) {
					a = c.getScroller();
					g = f.direction || "auto";
					if (g !== "vertical") {
						d = b.wrap();
						d.addCls(Ext.baseCSSPrefix + "translatable-hboxfix");
						if (g == "horizontal") {
							d.setStyle({
								height: "100%"
							})
						}
						this.scrollContainer = d.wrap();
						c.FixedHBoxStretching = a.FixedHBoxStretching = true
					} else {
						this.scrollContainer = b.wrap()
					}
				} else {
					this.scrollContainer = b.wrap()
				}
				c.setElement(e.bodyElement);
				if (e.isPainted()) {
					this.onComponentPainted()
				}
				e.on(this.listeners)
			} else {
				if (Ext.isString(f) || Ext.isObject(f)) {
					c.setConfig(f)
				}
			}
		} else {
			if (c) {
				c.destroy()
			}
		}
		return this
	},
	getScrollView: function () {
		return this.scrollView
	},
	onScrollViewDestroy: function () {
		var b = this.component,
			a = this.scrollerElement;
		if (!a.isDestroyed) {
			this.scrollerElement.unwrap()
		}
		this.scrollContainer.destroy();
		if (!b.isDestroyed) {
			b.un(this.listeners)
		}
		delete this.scrollerElement;
		delete this.scrollView;
		delete this.scrollContainer
	},
	onComponentDestroy: function () {
		var a = this.scrollView;
		if (a) {
			a.destroy()
		}
	}
});
Ext.define("Ext.Mask", {
	extend: Ext.Component,
	xtype: "mask",
	config: {
		baseCls: Ext.baseCSSPrefix + "mask",
		transparent: false,
		top: 0,
		left: 0,
		right: 0,
		bottom: 0
	},
	initialize: function () {
		this.callSuper();
		this.element.on("*", "onEvent", this);
		this.on({
			hide: "onHide"
		});
		this.inputBlocker = new Ext.util.InputBlocker()
	},
	onHide: function () {
		this.inputBlocker.unblockInputs();
		if (Ext.browser.is.AndroidStock4 && Ext.os.version.getMinor() === 0) {
			var a = this.element.getFirstChild();
			if (a) {
				a.redraw()
			}
		}
	},
	onEvent: function (b) {
		var a = arguments[arguments.length - 1];
		if (a.info.eventName === "tap") {
			this.fireEvent("tap", this, b);
			return false
		}
		if (b && b.stopEvent) {
			b.stopEvent()
		}
		return false
	},
	updateTransparent: function (a) {
		this[a ? "addCls" : "removeCls"](this.getBaseCls() + "-transparent")
	}
});
Ext.define("Ext.Container", {
	extend: Ext.Component,
	alternateClassName: "Ext.lib.Container",
	xtype: "container",
	eventedConfig: {
		activeItem: 0,
		scrollable: null
	},
	config: {
		layout: null,
		control: {},
		defaults: null,
		items: null,
		autoDestroy: true,
		defaultType: null,
		useBodyElement: null,
		masked: null,
		modal: null,
		hideOnMaskTap: null
	},
	isContainer: true,
	constructor: function (a) {
		var b = this;
		b._items = b.items = new Ext.ItemCollection();
		b.innerItems = [];
		b.onItemAdd = b.onFirstItemAdd;
		b.callParent(arguments)
	},
	getElementConfig: function () {
		return {
			reference: "element",
			classList: ["x-container", "x-unsized"],
			children: [{
				reference: "innerElement",
				className: "x-inner"
			}]
		}
	},
	applyMasked: function (b) {
		var a = true,
			c;
		if (b === false) {
			b = true;
			a = false
		}
		c = Ext.factory(b, Ext.Mask, this.getMasked());
		if (c) {
			this.add(c);
			c.setHidden(!a)
		}
		return c
	},
	mask: function (a) {
		this.setMasked(a || true)
	},
	unmask: function () {
		this.setMasked(false)
	},
	setParent: function (a) {
		this.callSuper(arguments);
		if (a) {
			var b = this.getModal();
			if (b) {
				a.insertBefore(b, this);
				b.setZIndex(this.getZIndex() - 1)
			}
		}
	},
	applyModal: function (c, b) {
		var a = true;
		if (c === false) {
			c = true;
			a = false
		}
		b = Ext.factory(c, Ext.Mask, b);
		if (b) {
			b.setVisibility(a)
		}
		return b
	},
	updateModal: function (b) {
		var a = this.getParent();
		if (a) {
			if (b) {
				a.insertBefore(b, this);
				b.setZIndex(this.getZIndex() - 1)
			} else {
				a.remove(b)
			}
		}
	},
	updateHideOnMaskTap: function (b) {
		var a = this.getModal();
		if (a) {
			a[b ? "on" : "un"].call(a, "tap", "hide", this)
		}
	},
	updateZIndex: function (b) {
		var a = this.getModal();
		this.callParent(arguments);
		if (a) {
			a.setZIndex(b - 1)
		}
	},
	updateBaseCls: function (a, b) {
		var c = this,
			d = c.getUi();
		if (a) {
			this.element.addCls(a);
			this.innerElement.addCls(a, null, "inner");
			if (d) {
				this.element.addCls(a, null, d)
			}
		}
		if (b) {
			this.element.removeCls(b);
			this.innerElement.removeCls(a, null, "inner");
			if (d) {
				this.element.removeCls(b, null, d)
			}
		}
	},
	updateUseBodyElement: function (a) {
		if (a) {
			this.link("bodyElement", this.innerElement.wrap({
				cls: "x-body"
			}))
		}
	},
	applyItems: function (a, d) {
		if (a) {
			var b = this;
			b.getDefaultType();
			b.getDefaults();
			if (b.initialized && d.length > 0) {
				b.removeAll()
			}
			b.add(a);
			if (b.initialized) {
				var c = b.initialConfig.activeItem || b.config.activeItem || 0;
				b.setActiveItem(c)
			}
		}
	},
	applyControl: function (c) {
		var a, b, e, d;
		for (a in c) {
			d = c[a];
			for (b in d) {
				e = d[b];
				if (Ext.isObject(e)) {
					e.delegate = a
				}
			}
			d.delegate = a;
			this.addListener(d)
		}
		return c
	},
	onFirstItemAdd: function () {
		delete this.onItemAdd;
		if (this.innerHtmlElement && !this.getHtml()) {
			this.innerHtmlElement.destroy();
			delete this.innerHtmlElement
		}
		this.on("innerstatechange", "onItemInnerStateChange", this, {
			delegate: "> component"
		});
		return this.onItemAdd.apply(this, arguments)
	},
	getLayout: function () {
		var a = this.layout;
		if (!a) {
			a = this.link("_layout", this.link("layout", Ext.factory(this._layout || "default", Ext.layout.Default, null, "layout")));
			a.setContainer(this)
		}
		return a
	},
	updateDefaultType: function (a) {
		this.defaultItemClass = Ext.ClassManager.getByAlias("widget." + a)
	},
	applyDefaults: function (a) {
		if (a) {
			this.factoryItem = this.factoryItemWithDefaults;
			return a
		}
	},
	factoryItem: function (a) {
		return Ext.factory(a, this.defaultItemClass)
	},
	factoryItemWithDefaults: function (c) {
		var b = this,
			d = b.getDefaults(),
			a;
		if (!d) {
			return Ext.factory(c, b.defaultItemClass)
		}
		if (c.isComponent) {
			a = c;
			if (d && c.isInnerItem() && !b.has(a)) {
				a.setConfig(d, true)
			}
		} else {
			if (d && !c.ignoreDefaults) {
				if (!(c.hasOwnProperty("left") && c.hasOwnProperty("right") && c.hasOwnProperty("top") && c.hasOwnProperty("bottom") && c.hasOwnProperty("docked") && c.hasOwnProperty("centered"))) {
					c = Ext.mergeIf({}, c, d)
				}
			}
			a = Ext.factory(c, b.defaultItemClass)
		}
		return a
	},
	add: function (a) {
		var e = this,
			b, d, c, f;
		if (Ext.isArray(a)) {
			for (b = 0, d = a.length; b < d; b++) {
				c = e.factoryItem(a[b]);
				this.doAdd(c);
				if (!f && !this.getActiveItem() && this.innerItems.length > 0 && c.isInnerItem()) {
					f = c
				}
			}
		} else {
			c = e.factoryItem(a);
			this.doAdd(c);
			if (!f && !this.getActiveItem() && this.innerItems.length > 0 && c.isInnerItem()) {
				f = c
			}
		}
		if (f) {
			this.setActiveItem(f)
		}
		return c
	},
	doAdd: function (d) {
		var c = this,
			a = c.getItems(),
			b;
		if (!a.has(d)) {
			b = a.length;
			a.add(d);
			if (d.isInnerItem()) {
				c.insertInner(d)
			}
			d.setParent(c);
			c.onItemAdd(d, b)
		}
	},
	remove: function (d, b) {
		var c = this,
			a = c.indexOf(d),
			e = c.getInnerItems();
		if (b === undefined) {
			b = c.getAutoDestroy()
		}
		if (a !== -1) {
			if (!c.removingAll && e.length > 1 && d === c.getActiveItem()) {
				c.on({
					activeitemchange: "doRemove",
					scope: c,
					single: true,
					order: "after",
					args: [d, a, b]
				});
				c.doResetActiveItem(e.indexOf(d))
			} else {
				c.doRemove(d, a, b);
				if (e.length === 0) {
					c.setActiveItem(null)
				}
			}
		}
		return c
	},
	doResetActiveItem: function (a) {
		if (a === 0) {
			this.setActiveItem(1)
		} else {
			this.setActiveItem(0)
		}
	},
	doRemove: function (d, a, b) {
		var c = this;
		c.items.remove(d);
		if (d.isInnerItem()) {
			c.removeInner(d)
		}
		c.onItemRemove(d, a, b);
		d.setParent(null);
		if (b) {
			d.destroy()
		}
	},
	removeAll: function (c, f) {
		var a = this.items,
			e = a.length,
			b = 0,
			d;
		if (typeof c != "boolean") {
			c = this.getAutoDestroy()
		}
		f = Boolean(f);
		this.removingAll = true;
		for (; b < e; b++) {
			d = a.getAt(b);
			if (d && (f || d.isInnerItem())) {
				this.doRemove(d, b, c);
				b--;
				e--
			}
		}
		this.setActiveItem(null);
		this.removingAll = false;
		return this
	},
	getAt: function (a) {
		return this.items.getAt(a)
	},
	getInnerAt: function (a) {
		return this.innerItems[a]
	},
	removeAt: function (a) {
		var b = this.getAt(a);
		if (b) {
			this.remove(b)
		}
		return this
	},
	removeInnerAt: function (a) {
		var b = this.getInnerItems()[a];
		if (b) {
			this.remove(b)
		}
		return this
	},
	has: function (a) {
		return this.getItems().indexOf(a) != -1
	},
	hasInnerItem: function (a) {
		return this.innerItems.indexOf(a) != -1
	},
	indexOf: function (a) {
		return this.getItems().indexOf(a)
	},
	innerIndexOf: function (a) {
		return this.innerItems.indexOf(a)
	},
	insertInner: function (d, b) {
		var a = this.getItems().items,
			f = this.innerItems,
			g = f.indexOf(d),
			c = -1,
			e;
		if (g !== -1) {
			f.splice(g, 1)
		}
		if (typeof b == "number") {
			do {
				e = a[++b]
			} while (e && !e.isInnerItem());
			if (e) {
				c = f.indexOf(e);
				f.splice(c, 0, d)
			}
		}
		if (c === -1) {
			f.push(d);
			c = f.length - 1
		}
		if (g !== -1) {
			this.onInnerItemMove(d, c, g)
		}
		return this
	},
	onInnerItemMove: Ext.emptyFn,
	removeInner: function (a) {
		Ext.Array.remove(this.innerItems, a);
		return this
	},
	insert: function (a, d) {
		var c = this,
			b;
		if (Ext.isArray(d)) {
			for (b = d.length - 1; b >= 0; b--) {
				c.insert(a, d[b])
			}
			return c
		}
		d = this.factoryItem(d);
		this.doInsert(a, d);
		return d
	},
	doInsert: function (d, f) {
		var e = this,
			b = e.items,
			c = b.length,
			a, g;
		g = f.isInnerItem();
		if (d > c) {
			d = c
		}
		if (b[d - 1] === f) {
			return e
		}
		a = e.indexOf(f);
		if (a !== -1) {
			if (a < d) {
				d -= 1
			}
			b.removeAt(a)
		}
		b.insert(d, f);
		if (a === -1) {
			f.setParent(e)
		}
		if (g) {
			e.insertInner(f, d)
		}
		if (a !== -1) {
			e.onItemMove(f, d, a)
		} else {
			e.onItemAdd(f, d)
		}
	},
	insertFirst: function (a) {
		return this.insert(0, a)
	},
	insertLast: function (a) {
		return this.insert(this.getItems().length, a)
	},
	insertBefore: function (c, a) {
		var b = this.indexOf(a);
		if (b !== -1) {
			this.insert(b, c)
		}
		return this
	},
	insertAfter: function (c, a) {
		var b = this.indexOf(a);
		if (b !== -1) {
			this.insert(b + 1, c)
		}
		return this
	},
	onItemAdd: function (b, a) {
		this.doItemLayoutAdd(b, a);
		if (this.initialized) {
			this.fireEvent("add", this, b, a)
		}
	},
	doItemLayoutAdd: function (c, a) {
		var b = this.getLayout();
		if (this.isRendered() && c.setRendered(true)) {
			c.fireAction("renderedchange", [this, c, true], "onItemAdd", b, {
				args: [c, a]
			})
		} else {
			b.onItemAdd(c, a)
		}
	},
	onItemRemove: function (b, a) {
		this.doItemLayoutRemove(b, a);
		this.fireEvent("remove", this, b, a)
	},
	doItemLayoutRemove: function (c, a) {
		var b = this.getLayout();
		if (this.isRendered() && c.setRendered(false)) {
			c.fireAction("renderedchange", [this, c, false], "onItemRemove", b, {
				args: [c, a, undefined]
			})
		} else {
			b.onItemRemove(c, a)
		}
	},
	onItemMove: function (b, c, a) {
		if (b.isDocked()) {
			b.setDocked(null)
		}
		this.doItemLayoutMove(b, c, a);
		this.fireEvent("move", this, b, c, a)
	},
	doItemLayoutMove: function (b, c, a) {
		this.getLayout().onItemMove(b, c, a)
	},
	onItemInnerStateChange: function (c, a) {
		var b = this.getLayout();
		if (a) {
			this.insertInner(c, this.items.indexOf(c))
		} else {
			this.removeInner(c)
		}
		b.onItemInnerStateChange.apply(b, arguments)
	},
	getInnerItems: function () {
		return this.innerItems
	},
	getDockedItems: function () {
		var a = this.getItems().items,
			c = [],
			e = a.length,
			d, b;
		for (b = 0; b < e; b++) {
			d = a[b];
			if (d.isDocked()) {
				c.push(d)
			}
		}
		return c
	},
	applyActiveItem: function (d, a) {
		var c = this.getInnerItems();
		this.getItems();
		if (!d && c.length === 0) {
			return 0
		} else {
			if (typeof d == "number") {
				d = Math.max(0, Math.min(d, c.length - 1));
				d = c[d];
				if (d) {
					return d
				} else {
					if (a) {
						return null
					}
				}
			} else {
				if (d) {
					var b;
					if (typeof d == "string") {
						b = this.child(d);
						d = {
							xtype: d
						}
					}
					if (!b || !b.isComponent) {
						b = this.factoryItem(d)
					}
					this.pendingActiveItem = b;
					if (!this.has(b)) {
						this.add(b)
					}
					return b
				}
			}
		}
	},
	animateActiveItem: function (d, c) {
		var b = this.getLayout(),
			a;
		if (this.activeItemAnimation) {
			this.activeItemAnimation.destroy()
		}
		this.activeItemAnimation = c = new Ext.fx.layout.Card(c);
		if (c && b.isCard) {
			c.setLayout(b);
			a = b.getAnimation();
			if (a) {
				a.disable()
			}
			c.on("animationend", function () {
				if (a) {
					a.enable()
				}
				c.destroy()
			}, this)
		}
		return this.setActiveItem(d)
	},
	doSetActiveItem: function (b, a) {
		delete this.pendingActiveItem;
		if (a) {
			a.fireEvent("deactivate", a, this, b)
		}
		if (b) {
			b.fireEvent("activate", b, this, a)
		}
	},
	doSetHidden: function (b) {
		var a = this.getModal();
		if (a) {
			a.setHidden(b)
		}
		this.callSuper(arguments)
	},
	setRendered: function (d) {
		if (this.callParent(arguments)) {
			var a = this.items.items,
				b, c;
			for (b = 0, c = a.length; b < c; b++) {
				a[b].setRendered(d)
			}
			return true
		}
		return false
	},
	getScrollableBehavior: function () {
		var a = this.scrollableBehavior;
		if (!a) {
			a = this.scrollableBehavior = new Ext.behavior.Scrollable(this)
		}
		return a
	},
	applyScrollable: function (a) {
		if (typeof a === "boolean") {
			this.getScrollableBehavior().setConfig({
				disabled: !a
			})
		} else {
			if (a && !a.isObservable) {
				this.getScrollableBehavior().setConfig(a)
			}
		}
		return a
	},
	doSetScrollable: function () {},
	getScrollable: function () {
		return this.getScrollableBehavior().getScrollView()
	},
	getRefItems: function (a) {
		var b = this.getItems().items.slice(),
			e = b.length,
			c, d;
		if (a) {
			for (c = 0; c < e; c++) {
				d = b[c];
				if (d.getRefItems) {
					b = b.concat(d.getRefItems(true))
				}
			}
		}
		return b
	},
	getComponent: function (a) {
		if (Ext.isObject(a)) {
			a = a.getItemId()
		}
		return this.getItems().get(a)
	},
	getDockedComponent: function (a) {
		if (Ext.isObject(a)) {
			a = a.getItemId()
		}
		var c = this.getDockedItems(),
			e = c.length,
			d, b;
		if (Ext.isNumber(a)) {
			return c[a]
		}
		for (b = 0; b < e; b++) {
			d = c[b];
			if (d.id == a) {
				return d
			}
		}
		return false
	},
	query: function (a) {
		return Ext.ComponentQuery.query(a, this)
	},
	child: function (a) {
		return this.query("> " + a)[0] || null
	},
	down: function (a) {
		return this.query(a)[0] || null
	},
	destroy: function () {
		var b = this,
			a = b.getModal();
		if (a) {
			a.destroy()
		}
		b.removeAll(true, true);
		b.unlink("_scrollable");
		Ext.destroy(b.items);
		b.callSuper()
	}
}, function () {
	this.addMember("defaultItemClass", this)
});
Ext.define("Ext.util.Point", {
	radianToDegreeConstant: 180 / Math.PI,
	statics: {
		fromEvent: function (b) {
			var a = b.changedTouches,
				c = (a && a.length > 0) ? a[0] : b;
			return this.fromTouch(c)
		},
		fromTouch: function (a) {
			return new this(a.pageX, a.pageY)
		},
		from: function (a) {
			if (!a) {
				return new this(0, 0)
			}
			if (!(a instanceof this)) {
				return new this(a.x, a.y)
			}
			return a
		}
	},
	constructor: function (a, b) {
		if (typeof a == "undefined") {
			a = 0
		}
		if (typeof b == "undefined") {
			b = 0
		}
		this.x = a;
		this.y = b;
		return this
	},
	clone: function () {
		return new this.self(this.x, this.y)
	},
	copy: function () {
		return this.clone.apply(this, arguments)
	},
	copyFrom: function (a) {
		this.x = a.x;
		this.y = a.y;
		return this
	},
	toString: function () {
		return "Point[" + this.x + "," + this.y + "]"
	},
	equals: function (a) {
		return (this.x === a.x && this.y === a.y)
	},
	isCloseTo: function (c, b) {
		if (typeof b == "number") {
			b = {
				x: b
			};
			b.y = b.x
		}
		var a = c.x,
			f = c.y,
			e = b.x,
			d = b.y;
		return (this.x <= a + e && this.x >= a - e && this.y <= f + d && this.y >= f - d)
	},
	isWithin: function () {
		return this.isCloseTo.apply(this, arguments)
	},
	translate: function (a, b) {
		this.x += a;
		this.y += b;
		return this
	},
	roundedEquals: function (a) {
		if (typeof a != "object") {
			a = {
				x: 0,
				y: 0
			}
		}
		return (Math.round(this.x) === Math.round(a.x) && Math.round(this.y) === Math.round(a.y))
	},
	getDistanceTo: function (b) {
		if (typeof b != "object") {
			b = {
				x: 0,
				y: 0
			}
		}
		var c = this.x - b.x,
			a = this.y - b.y;
		return Math.sqrt(c * c + a * a)
	},
	getAngleTo: function (b) {
		if (typeof b != "object") {
			b = {
				x: 0,
				y: 0
			}
		}
		var c = this.x - b.x,
			a = this.y - b.y;
		return Math.atan2(a, c) * this.radianToDegreeConstant
	}
});
Ext.define("Ext.util.LineSegment", {
	constructor: function (b, a) {
		var c = Ext.util.Point;
		this.point1 = c.from(b);
		this.point2 = c.from(a)
	},
	intersects: function (m) {
		var p = this.point1,
			n = this.point2,
			j = m.point1,
			f = m.point2,
			c = p.x,
			b = n.x,
			a = j.x,
			r = f.x,
			q = p.y,
			o = n.y,
			l = j.y,
			h = f.y,
			g = (c - b) * (l - h) - (q - o) * (a - r),
			k, e;
		if (g == 0) {
			return null
		}
		k = ((a - r) * (c * o - q * b) - (c - b) * (a * h - l * r)) / g;
		e = ((l - h) * (c * o - q * b) - (q - o) * (a * h - l * r)) / g;
		if (k < Math.min(c, b) || k > Math.max(c, b) || k < Math.min(a, r) || k > Math.max(a, r) || e < Math.min(q, o) || e > Math.max(q, o) || e < Math.min(l, h) || e > Math.max(l, h)) {
			return null
		}
		return new Ext.util.Point(k, e)
	},
	getLength: function () {
		return Math.abs(this.point1.getDistanceTo(this.point2))
	},
	getAngleToX: function () {
		var d = this.point1,
			c = this.point2,
			a = c.y - d.y,
			b = c.x - d.x;
		return Math.atan2(a, b)
	},
	getInBetweenPoint: function (e) {
		var b = this.point1,
			c = this.getAngleToX(),
			a = b.x + Math.cos(c) * e,
			d = b.y + Math.sin(c) * e;
		return new Ext.util.Point(a, d)
	},
	toString: function () {
		return this.point1.toString() + " " + this.point2.toString()
	}
});
Ext.define("Ext.Panel", {
	extend: Ext.Container,
	alternateClassName: "Ext.lib.Panel",
	xtype: "panel",
	isPanel: true,
	config: {
		baseCls: Ext.baseCSSPrefix + "panel",
		bodyPadding: null,
		bodyMargin: null,
		bodyBorder: null
	},
	getElementConfig: function () {
		var a = this.callParent();
		a.children.push({
			reference: "tipElement",
			className: "x-anchor",
			hidden: true
		});
		return a
	},
	applyBodyPadding: function (a) {
		if (a === true) {
			a = 5
		}
		if (a) {
			a = Ext.dom.Element.unitizeBox(a)
		}
		return a
	},
	updateBodyPadding: function (a) {
		this.element.setStyle("padding", a)
	},
	applyBodyMargin: function (a) {
		if (a === true) {
			a = 5
		}
		if (a) {
			a = Ext.dom.Element.unitizeBox(a)
		}
		return a
	},
	updateBodyMargin: function (a) {
		this.element.setStyle("margin", a)
	},
	applyBodyBorder: function (a) {
		if (a === true) {
			a = 1
		}
		if (a) {
			a = Ext.dom.Element.unitizeBox(a)
		}
		return a
	},
	updateBodyBorder: function (a) {
		this.element.setStyle("border-width", a)
	},
	alignTo: function (n) {
		var x = this.tipElement;
		x.hide();
		if (this.currentTipPosition) {
			x.removeCls("x-anchor-" + this.currentTipPosition)
		}
		this.callParent(arguments);
		var f = Ext.util.LineSegment,
			d = n.isComponent ? n.renderElement : n,
			a = this.renderElement,
			o = d.getPageBox(),
			l = a.getPageBox(),
			b = l.left,
			u = l.top,
			D = l.right,
			h = l.bottom,
			k = b + (l.width / 2),
			j = u + (l.height / 2),
			p = {
				x: b,
				y: u
			},
			m = {
				x: D,
				y: u
			},
			C = {
				x: b,
				y: h
			},
			E = {
				x: D,
				y: h
			},
			z = {
				x: k,
				y: j
			},
			t = o.left + (o.width / 2),
			r = o.top + (o.height / 2),
			w = {
				x: t,
				y: r
			},
			c = new f(z, w),
			g = 0,
			B = 0,
			e, A, s, q, y, v;
		x.setVisibility(false);
		x.show();
		e = x.getSize();
		A = e.width;
		s = e.height;
		if (c.intersects(new f(p, m))) {
			y = Math.min(Math.max(t, b + A), D - (A));
			v = u;
			B = s + 10;
			q = "top"
		} else {
			if (c.intersects(new f(p, C))) {
				y = b;
				v = Math.min(Math.max(r + (A / 2), A * 1.6), h - (A / 2.2));
				g = s + 10;
				q = "left"
			} else {
				if (c.intersects(new f(C, E))) {
					y = Math.min(Math.max(t, b + A), D - A);
					v = h;
					B = -s - 10;
					q = "bottom"
				} else {
					if (c.intersects(new f(m, E))) {
						y = D;
						v = Math.max(Math.min(r - s, h - A * 1.3), A / 2);
						g = -s - 10;
						q = "right"
					}
				}
			}
		}
		if (y || v) {
			this.currentTipPosition = q;
			x.addCls("x-anchor-" + q);
			x.setLeft(y - b);
			x.setTop(v - u);
			x.setVisibility(true);
			this.setLeft(this.getLeft() + g);
			this.setTop(this.getTop() + B)
		}
	}
});
Ext.define("Ext.Button", {
	extend: Ext.Component,
	xtype: "button",
	cachedConfig: {
		pressedCls: Ext.baseCSSPrefix + "button-pressing",
		badgeCls: Ext.baseCSSPrefix + "badge",
		hasBadgeCls: Ext.baseCSSPrefix + "hasbadge",
		labelCls: Ext.baseCSSPrefix + "button-label",
		iconCls: null
	},
	config: {
		badgeText: null,
		text: null,
		icon: false,
		iconAlign: "left",
		pressedDelay: 0,
		handler: null,
		scope: null,
		autoEvent: null,
		ui: "normal",
		baseCls: Ext.baseCSSPrefix + "button"
	},
	template: [{
		tag: "span",
		reference: "badgeElement",
		hidden: true
	}, {
		tag: "span",
		className: Ext.baseCSSPrefix + "button-icon",
		reference: "iconElement"
	}, {
		tag: "span",
		reference: "textElement",
		hidden: true
	}],
	initialize: function () {
		this.callParent();
		this.element.on({
			scope: this,
			tap: "onTap",
			touchstart: "onPress",
			touchend: "onRelease"
		})
	},
	updateBadgeText: function (c) {
		var a = this.element,
			b = this.badgeElement;
		if (c) {
			b.show();
			b.setText(c)
		} else {
			b.hide()
		}
		a[(c) ? "addCls" : "removeCls"](this.getHasBadgeCls())
	},
	updateText: function (b) {
		var a = this.textElement;
		if (a) {
			if (b) {
				a.show();
				a.setHtml(b)
			} else {
				a.hide()
			}
		}
	},
	updateHtml: function (b) {
		var a = this.textElement;
		if (b) {
			a.show();
			a.setHtml(b)
		} else {
			a.hide()
		}
	},
	updateBadgeCls: function (b, a) {
		this.badgeElement.replaceCls(a, b)
	},
	updateHasBadgeCls: function (b, c) {
		var a = this.element;
		if (a.hasCls(c)) {
			a.replaceCls(c, b)
		}
	},
	updateLabelCls: function (b, a) {
		this.textElement.replaceCls(a, b)
	},
	updatePressedCls: function (b, c) {
		var a = this.element;
		if (a.hasCls(c)) {
			a.replaceCls(c, b)
		}
	},
	updateIcon: function (b) {
		var c = this,
			a = c.iconElement;
		if (b) {
			c.showIconElement();
			a.setStyle("background-image", "url(" + b + ")");
			c.refreshIconAlign()
		} else {
			a.setStyle("background-image", "");
			c.hideIconElement()
		}
	},
	updateIconCls: function (c, a) {
		var d = this,
			b = d.iconElement;
		if (c) {
			d.showIconElement();
			b.replaceCls(a, c);
			d.refreshIconAlign()
		} else {
			b.removeCls(a);
			d.hideIconElement()
		}
	},
	updateIconAlign: function (d, c) {
		var b = this.element,
			a = Ext.baseCSSPrefix + "iconalign-";
		if (!this.getText()) {
			d = "center"
		}
		b.removeCls(a + "center");
		b.removeCls(a + c);
		if (this.getIcon() || this.getIconCls()) {
			b.addCls(a + d)
		}
	},
	refreshIconAlign: function () {
		this.updateIconAlign(this.getIconAlign())
	},
	applyAutoEvent: function (b) {
		var a = this;
		if (typeof b == "string") {
			b = {
				name: b,
				scope: a.scope || a
			}
		}
		return b
	},
	updateAutoEvent: function (c) {
		var a = c.name,
			b = c.scope;
		this.setHandler(function () {
			b.fireEvent(a, b, this)
		});
		this.setScope(b)
	},
	hideIconElement: function () {
		this.iconElement.removeCls(Ext.baseCSSPrefix + "shown");
		this.iconElement.addCls(Ext.baseCSSPrefix + "hidden")
	},
	showIconElement: function () {
		this.iconElement.removeCls(Ext.baseCSSPrefix + "hidden");
		this.iconElement.addCls(Ext.baseCSSPrefix + "shown")
	},
	applyUi: function (a) {
		if (a && Ext.isString(a)) {
			var b = a.split("-");
			if (b && (b[1] == "back" || b[1] == "forward")) {
				return b
			}
		}
		return a
	},
	getUi: function () {
		var a = this._ui;
		if (Ext.isArray(a)) {
			return a.join("-")
		}
		return a
	},
	applyPressedDelay: function (a) {
		if (Ext.isNumber(a)) {
			return a
		}
		return (a) ? 100 : 0
	},
	onPress: function () {
		var c = this,
			a = c.element,
			d = c.getPressedDelay(),
			b = c.getPressedCls();
		if (!c.getDisabled()) {
			if (d > 0) {
				c.pressedTimeout = setTimeout(function () {
					delete c.pressedTimeout;
					if (a) {
						a.addCls(b)
					}
				}, d)
			} else {
				a.addCls(b)
			}
		}
	},
	onRelease: function (a) {
		this.fireAction("release", [this, a], "doRelease")
	},
	doRelease: function (a, b) {
		if (!a.getDisabled()) {
			if (a.hasOwnProperty("pressedTimeout")) {
				clearTimeout(a.pressedTimeout);
				delete a.pressedTimeout
			} else {
				a.element.removeCls(a.getPressedCls())
			}
		}
	},
	onTap: function (a) {
		if (this.getDisabled()) {
			return false
		}
		this.fireAction("tap", [this, a], "doTap")
	},
	doTap: function (c, d) {
		var b = c.getHandler(),
			a = c.getScope() || c;
		if (!b) {
			return
		}
		if (typeof b == "string") {
			b = a[b]
		}
		if (d && d.preventDefault) {
			d.preventDefault()
		}
		b.apply(a, arguments)
	}
}, function () {});
Ext.define("Ext.Sheet", {
	extend: Ext.Panel,
	xtype: "sheet",
	config: {
		baseCls: Ext.baseCSSPrefix + "sheet",
		modal: true,
		centered: true,
		stretchX: null,
		stretchY: null,
		enter: "bottom",
		exit: "bottom",
		showAnimation: !Ext.browser.is.AndroidStock2 ? {
			type: "slideIn",
			duration: 250,
			easing: "ease-out"
		} : null,
		hideAnimation: !Ext.browser.is.AndroidStock2 ? {
			type: "slideOut",
			duration: 250,
			easing: "ease-in"
		} : null
	},
	platformConfig: [{
		theme: ["Windows"],
		enter: "top",
		exit: "top"
	}],
	applyHideAnimation: function (b) {
		var a = this.getExit(),
			d = a;
		if (a === null) {
			return null
		}
		if (b === true) {
			b = {
				type: "slideOut"
			}
		}
		if (Ext.isString(b)) {
			b = {
				type: b
			}
		}
		var c = Ext.factory(b, Ext.fx.Animation);
		if (c) {
			if (a == "bottom") {
				d = "down"
			}
			if (a == "top") {
				d = "up"
			}
			c.setDirection(d)
		}
		return c
	},
	applyShowAnimation: function (a) {
		var d = this.getEnter(),
			c = d;
		if (d === null) {
			return null
		}
		if (a === true) {
			a = {
				type: "slideIn"
			}
		}
		if (Ext.isString(a)) {
			a = {
				type: a
			}
		}
		var b = Ext.factory(a, Ext.fx.Animation);
		if (b) {
			if (d == "bottom") {
				c = "down"
			}
			if (d == "top") {
				c = "up"
			}
			b.setBefore({
				display: null
			});
			b.setReverse(true);
			b.setDirection(c)
		}
		return b
	},
	updateStretchX: function (a) {
		this.getLeft();
		this.getRight();
		if (a) {
			this.setLeft(0);
			this.setRight(0)
		}
	},
	updateStretchY: function (a) {
		this.getTop();
		this.getBottom();
		if (a) {
			this.setTop(0);
			this.setBottom(0)
		}
	}
});
Ext.define("AppMici.view.override.btn_Aggiungi", {
	override: "Ext.Button",
	lastTapped: 0,
	onTap: function (b) {
		idc = this.getId();
		if (this.getId() == "btn_inviamedico") {
			this.fireAction("tap", [this, b], "doTap")
		} else {
			if (this.parent.parent) {
				if (this.parent.parent.getId() == "templatedeader") {
					this.fireAction("tap", [this, b], "doTap")
				} else {
					var a = Date.now();
					if (this.getDisabled()) {
						return false
					}
					if ((a - this.lastTapped) > 1000) {
						this.lastTapped = a;
						this.fireAction("tap", [this, b], "doTap")
					}
				}
			} else {
				var a = Date.now();
				if (this.getDisabled()) {
					return false
				}
				if ((a - this.lastTapped) > 1000) {
					this.lastTapped = a;
					this.fireAction("tap", [this, b], "doTap")
				}
			}
		}
	}
});
Ext.define("Ext.data.Connection", {
	mixins: {
		observable: Ext.mixin.Observable
	},
	statics: {
		requestId: 0
	},
	config: {
		url: null,
		async: true,
		method: null,
		username: "",
		password: "",
		disableCaching: true,
		disableCachingParam: "_dc",
		timeout: 30000,
		extraParams: null,
		defaultHeaders: null,
		useDefaultHeader: true,
		defaultPostHeader: "application/x-www-form-urlencoded; charset=UTF-8",
		useDefaultXhrHeader: true,
		defaultXhrHeader: "XMLHttpRequest",
		autoAbort: false
	},
	textAreaRe: /textarea/i,
	multiPartRe: /multipart\/form-data/i,
	lineBreakRe: /\r\n/g,
	constructor: function (a) {
		this.initConfig(a);
		this.requests = {}
	},
	request: function (k) {
		k = k || {};
		var f = this,
			j = k.scope || window,
			e = k.username || f.getUsername(),
			g = k.password || f.getPassword() || "",
			b, c, d, a, h;
		if (f.fireEvent("beforerequest", f, k) !== false) {
			c = f.setOptions(k, j);
			if (this.isFormUpload(k) === true) {
				this.upload(k.form, c.url, c.data, k);
				return null
			}
			if (k.autoAbort === true || f.getAutoAbort()) {
				f.abort()
			}
			h = this.getXhrInstance();
			b = k.async !== false ? (k.async || f.getAsync()) : false;
			if (e) {
				h.open(c.method, c.url, b, e, g)
			} else {
				h.open(c.method, c.url, b)
			}
			a = f.setupHeaders(h, k, c.data, c.params);
			d = {
				id: ++Ext.data.Connection.requestId,
				xhr: h,
				headers: a,
				options: k,
				async: b,
				timeout: setTimeout(function () {
					d.timedout = true;
					f.abort(d)
				}, k.timeout || f.getTimeout())
			};
			f.requests[d.id] = d;
			if (b) {
				h.onreadystatechange = Ext.Function.bind(f.onStateChange, f, [d])
			}
			h.send(c.data);
			if (!b) {
				return this.onComplete(d)
			}
			return d
		} else {
			Ext.callback(k.callback, k.scope, [k, undefined, undefined]);
			return null
		}
	},
	upload: function (e, c, j, l) {
		e = Ext.getDom(e);
		l = l || {};
		var d = Ext.id(),
			g = document.createElement("iframe"),
			k = [],
			h = "multipart/form-data",
			f = {
				target: e.target,
				method: e.method,
				encoding: e.encoding,
				enctype: e.enctype,
				action: e.action
			},
			b = function (m, n) {
				a = document.createElement("input");
				Ext.fly(a).set({
					type: "hidden",
					value: n,
					name: m
				});
				e.appendChild(a);
				k.push(a)
			},
			a;
		Ext.fly(g).set({
			id: d,
			name: d,
			cls: Ext.baseCSSPrefix + "hide-display",
			src: Ext.SSL_SECURE_URL
		});
		document.body.appendChild(g);
		if (document.frames) {
			document.frames[d].name = d
		}
		Ext.fly(e).set({
			target: d,
			method: "POST",
			enctype: h,
			encoding: h,
			action: c || f.action
		});
		if (j) {
			Ext.iterate(Ext.Object.fromQueryString(j), function (m, n) {
				if (Ext.isArray(n)) {
					Ext.each(n, function (o) {
						b(m, o)
					})
				} else {
					b(m, n)
				}
			})
		}
		Ext.fly(g).on("load", Ext.Function.bind(this.onUploadComplete, this, [g, l]), null, {
			single: true
		});
		e.submit();
		Ext.fly(e).set(f);
		Ext.each(k, function (m) {
			Ext.removeNode(m)
		})
	},
	onUploadComplete: function (h, b) {
		var c = this,
			a = {
				responseText: "",
				responseXML: null
			},
			g, f;
		try {
			g = h.contentWindow.document || h.contentDocument || window.frames[id].document;
			if (g) {
				if (g.body) {
					if (this.textAreaRe.test((f = g.body.firstChild || {}).tagName)) {
						a.responseText = f.value
					} else {
						a.responseText = g.body.innerHTML
					}
				}
				a.responseXML = g.XMLDocument || g
			}
		} catch (d) {}
		c.fireEvent("requestcomplete", c, a, b);
		Ext.callback(b.success, b.scope, [a, b]);
		Ext.callback(b.callback, b.scope, [b, true, a]);
		setTimeout(function () {
			Ext.removeNode(h)
		}, 100)
	},
	isFormUpload: function (a) {
		var b = this.getForm(a);
		if (b) {
			return (a.isUpload || (this.multiPartRe).test(b.getAttribute("enctype")))
		}
		return false
	},
	getForm: function (a) {
		return Ext.getDom(a.form) || null
	},
	setOptions: function (l, k) {
		var h = this,
			e = l.params || {},
			g = h.getExtraParams(),
			d = l.urlParams,
			c = l.url || h.getUrl(),
			j = l.jsonData,
			b, a, f;
		if (Ext.isFunction(e)) {
			e = e.call(k, l)
		}
		if (Ext.isFunction(c)) {
			c = c.call(k, l)
		}
		c = this.setupUrl(l, c);
		f = l.rawData || l.xmlData || j || null;
		if (j && !Ext.isPrimitive(j)) {
			f = Ext.encode(f)
		}
		if (Ext.isObject(e)) {
			e = Ext.Object.toQueryString(e)
		}
		if (Ext.isObject(g)) {
			g = Ext.Object.toQueryString(g)
		}
		e = e + ((g) ? ((e) ? "&" : "") + g : "");
		d = Ext.isObject(d) ? Ext.Object.toQueryString(d) : d;
		e = this.setupParams(l, e);
		b = (l.method || h.getMethod() || ((e || f) ? "POST" : "GET")).toUpperCase();
		this.setupMethod(l, b);
		a = l.disableCaching !== false ? (l.disableCaching || h.getDisableCaching()) : false;
		if (a) {
			c = Ext.urlAppend(c, (l.disableCachingParam || h.getDisableCachingParam()) + "=" + (new Date().getTime()))
		}
		if ((b == "GET" || f) && e) {
			c = Ext.urlAppend(c, e);
			e = null
		}
		if (d) {
			c = Ext.urlAppend(c, d)
		}
		return {
			url: c,
			method: b,
			data: f || e || null
		}
	},
	setupUrl: function (b, a) {
		var c = this.getForm(b);
		if (c) {
			a = a || c.action
		}
		return a
	},
	setupParams: function (a, d) {
		var c = this.getForm(a),
			b;
		if (c && !this.isFormUpload(a)) {
			b = Ext.Element.serializeForm(c);
			d = d ? (d + "&" + b) : b
		}
		return d
	},
	setupMethod: function (a, b) {
		if (this.isFormUpload(a)) {
			return "POST"
		}
		return b
	},
	setupHeaders: function (m, n, d, c) {
		var h = this,
			b = Ext.apply({}, n.headers || {}, h.getDefaultHeaders() || {}),
			l = h.getDefaultPostHeader(),
			j = n.jsonData,
			a = n.xmlData,
			k, f;
		if (!b["Content-Type"] && (d || c)) {
			if (d) {
				if (n.rawData) {
					l = "text/plain"
				} else {
					if (a && Ext.isDefined(a)) {
						l = "text/xml"
					} else {
						if (j && Ext.isDefined(j)) {
							l = "application/json"
						}
					}
				}
			}
			b["Content-Type"] = l
		}
		if (((h.getUseDefaultXhrHeader() && n.useDefaultXhrHeader !== false) || n.useDefaultXhrHeader) && !b["X-Requested-With"]) {
			b["X-Requested-With"] = h.getDefaultXhrHeader()
		}
		try {
			for (k in b) {
				if (b.hasOwnProperty(k)) {
					f = b[k];
					m.setRequestHeader(k, f)
				}
			}
		} catch (g) {
			h.fireEvent("exception", k, f)
		}
		if (n.withCredentials) {
			m.withCredentials = n.withCredentials
		}
		return b
	},
	getXhrInstance: (function () {
		var b = [function () {
			return new XMLHttpRequest()
		}, function () {
			return new ActiveXObject("MSXML2.XMLHTTP.3.0")
		}, function () {
			return new ActiveXObject("MSXML2.XMLHTTP")
		}, function () {
			return new ActiveXObject("Microsoft.XMLHTTP")
		}],
			c = 0,
			a = b.length,
			f;
		for (; c < a; ++c) {
			try {
				f = b[c];
				f();
				break
			} catch (d) {}
		}
		return f
	})(),
	isLoading: function (a) {
		if (!(a && a.xhr)) {
			return false
		}
		var b = a.xhr.readyState;
		return !(b === 0 || b == 4)
	},
	abort: function (b) {
		var a = this,
			d = a.requests,
			c;
		if (b && a.isLoading(b)) {
			b.xhr.onreadystatechange = null;
			b.xhr.abort();
			a.clearTimeout(b);
			if (!b.timedout) {
				b.aborted = true
			}
			a.onComplete(b);
			a.cleanup(b)
		} else {
			if (!b) {
				for (c in d) {
					if (d.hasOwnProperty(c)) {
						a.abort(d[c])
					}
				}
			}
		}
	},
	abortAll: function () {
		this.abort()
	},
	onStateChange: function (a) {
		if (a.xhr.readyState == 4) {
			this.clearTimeout(a);
			this.onComplete(a);
			this.cleanup(a)
		}
	},
	clearTimeout: function (a) {
		clearTimeout(a.timeout);
		delete a.timeout
	},
	cleanup: function (a) {
		a.xhr = null;
		delete a.xhr
	},
	onComplete: function (f) {
		var d = this,
			c = f.options,
			a, h, b;
		try {
			a = d.parseStatus(f.xhr.status, f.xhr);
			if (f.timedout) {
				a.success = false
			}
		} catch (g) {
			a = {
				success: false,
				isException: false
			}
		}
		h = a.success;
		if (h) {
			b = d.createResponse(f);
			d.fireEvent("requestcomplete", d, b, c);
			Ext.callback(c.success, c.scope, [b, c])
		} else {
			if (a.isException || f.aborted || f.timedout) {
				b = d.createException(f)
			} else {
				b = d.createResponse(f)
			}
			d.fireEvent("requestexception", d, b, c);
			Ext.callback(c.failure, c.scope, [b, c])
		}
		Ext.callback(c.callback, c.scope, [c, h, b]);
		delete d.requests[f.id];
		return b
	},
	parseStatus: function (a, d) {
		a = a == 1223 ? 204 : a;
		var c = (a >= 200 && a < 300) || a == 304 || (a == 0 && d.responseText.length > 0),
			b = false;
		if (!c) {
			switch (a) {
			case 12002:
			case 12029:
			case 12030:
			case 12031:
			case 12152:
			case 13030:
				b = true;
				break
			}
		}
		return {
			success: c,
			isException: b
		}
	},
	createResponse: function (c) {
		var g = c.xhr,
			a = {},
			h, d, j, e, f, b;
		if (c.timedout || c.aborted) {
			c.success = false;
			h = []
		} else {
			h = g.getAllResponseHeaders().replace(this.lineBreakRe, "\n").split("\n")
		}
		d = h.length;
		while (d--) {
			j = h[d];
			e = j.indexOf(":");
			if (e >= 0) {
				f = j.substr(0, e).toLowerCase();
				if (j.charAt(e + 1) == " ") {
					++e
				}
				a[f] = j.substr(e + 1)
			}
		}
		c.xhr = null;
		delete c.xhr;
		b = {
			request: c,
			requestId: c.id,
			status: g.status,
			statusText: g.statusText,
			getResponseHeader: function (k) {
				return a[k.toLowerCase()]
			},
			getAllResponseHeaders: function () {
				return a
			},
			responseText: g.responseText,
			responseXML: g.responseXML
		};
		g = null;
		return b
	},
	createException: function (a) {
		return {
			request: a,
			requestId: a.id,
			status: a.aborted ? -1 : 0,
			statusText: a.aborted ? "transaction aborted" : "communication failure",
			aborted: a.aborted,
			timedout: a.timedout
		}
	}
});
Ext.define("Ext.Ajax", {
	extend: Ext.data.Connection,
	singleton: true,
	autoAbort: false
});
Ext.define("Ext.ComponentQuery", {
	singleton: true
}, function () {
	var g = this,
		k = ["var r = [],", "i = 0,", "it = items,", "l = it.length,", "c;", "for (; i < l; i++) {", "c = it[i];", "if (c.{0}) {", "r.push(c);", "}", "}", "return r;"].join(""),
		e = function (p, o) {
			return o.method.apply(this, [p].concat(o.args))
		},
		a = function (q, u) {
			var o = [],
				r = 0,
				t = q.length,
				s, p = u !== ">";
			for (; r < t; r++) {
				s = q[r];
				if (s.getRefItems) {
					o = o.concat(s.getRefItems(p))
				}
			}
			return o
		},
		f = function (p) {
			var o = [],
				q = 0,
				s = p.length,
				r;
			for (; q < s; q++) {
				r = p[q];
				while ( !! (r = (r.ownerCt || r.floatParent))) {
					o.push(r)
				}
			}
			return o
		},
		m = function (p, u, t) {
			if (u === "*") {
				return p.slice()
			} else {
				var o = [],
					q = 0,
					s = p.length,
					r;
				for (; q < s; q++) {
					r = p[q];
					if (r.isXType(u, t)) {
						o.push(r)
					}
				}
				return o
			}
		},
		j = function (p, s) {
			var u = Ext.Array,
				o = [],
				q = 0,
				t = p.length,
				r;
			for (; q < t; q++) {
				r = p[q];
				if (r.el ? r.el.hasCls(s) : u.contains(r.initCls(), s)) {
					o.push(r)
				}
			}
			return o
		},
		n = function (s, v, p, u) {
			var x = [],
				r = 0,
				o = s.length,
				w, t, q;
			for (; r < o; r++) {
				w = s[r];
				t = Ext.Class.getConfigNameMap(v).get;
				if (w[t]) {
					q = w[t]();
					if (!u ? !! q : (String(q) === u)) {
						x.push(w)
					}
				} else {
					if (w.config && w.config[v]) {
						if (!u ? !! w.config[v] : (String(w.config[v]) === u)) {
							x.push(w)
						}
					} else {
						if (!u ? !! w[v] : (String(w[v]) === u)) {
							x.push(w)
						}
					}
				}
			}
			return x
		},
		d = function (p, t) {
			var o = [],
				q = 0,
				s = p.length,
				r;
			for (; q < s; q++) {
				r = p[q];
				if (r.getId() === t || r.getItemId() === t) {
					o.push(r)
				}
			}
			return o
		},
		l = function (o, p, q) {
			return g.pseudos[p](o, q)
		},
		h = /^(\s?([>\^])\s?|\s|$)/,
		c = /^(#)?([\w\-]+|\*)(?:\((true|false)\))?/,
		b = [{
			re: /^\.([\w\-]+)(?:\((true|false)\))?/,
			method: m
		}, {
			re: /^(?:[\[](?:@)?([\w\-]+)\s?(?:(=|.=)\s?['"]?(.*?)["']?)?[\]])/,
			method: n
		}, {
			re: /^#([\w\-]+)/,
			method: d
		}, {
			re: /^\:([\w\-]+)(?:\(((?:\{[^\}]+\})|(?:(?!\{)[^\s>\/]*?(?!\})))\))?/,
			method: l
		}, {
			re: /^(?:\{([^\}]+)\})/,
			method: k
		}];
	g.Query = Ext.extend(Object, {
		constructor: function (o) {
			o = o || {};
			Ext.apply(this, o)
		},
		execute: function (p) {
			var r = this.operations,
				s = 0,
				t = r.length,
				q, o;
			if (!p) {
				o = Ext.ComponentManager.all.getArray()
			} else {
				if (Ext.isArray(p)) {
					o = p
				}
			}
			for (; s < t; s++) {
				q = r[s];
				if (q.mode === "^") {
					o = f(o || [p])
				} else {
					if (q.mode) {
						o = a(o || [p], q.mode)
					} else {
						o = e(o || a([p]), q)
					}
				}
				if (s === t - 1) {
					return o
				}
			}
			return []
		},
		is: function (q) {
			var p = this.operations,
				t = Ext.isArray(q) ? q : [q],
				o = t.length,
				u = p[p.length - 1],
				s, r;
			t = e(t, u);
			if (t.length === o) {
				if (p.length > 1) {
					for (r = 0, s = t.length; r < s; r++) {
						if (Ext.Array.indexOf(this.execute(), t[r]) === -1) {
							return false
						}
					}
				}
				return true
			}
			return false
		}
	});
	Ext.apply(this, {
		cache: {},
		pseudos: {
			not: function (u, o) {
				var v = Ext.ComponentQuery,
					s = 0,
					t = u.length,
					r = [],
					q = -1,
					p;
				for (; s < t; ++s) {
					p = u[s];
					if (!v.is(p, o)) {
						r[++q] = p
					}
				}
				return r
			}
		},
		query: function (p, w) {
			var x = p.split(","),
				o = x.length,
				q = 0,
				r = [],
				y = [],
				v = {},
				t, s, u;
			for (; q < o; q++) {
				p = Ext.String.trim(x[q]);
				t = this.parse(p);
				r = r.concat(t.execute(w))
			}
			if (o > 1) {
				s = r.length;
				for (q = 0; q < s; q++) {
					u = r[q];
					if (!v[u.id]) {
						y.push(u);
						v[u.id] = true
					}
				}
				r = y
			}
			return r
		},
		is: function (p, o) {
			if (!o) {
				return true
			}
			var q = this.cache[o];
			if (!q) {
				this.cache[o] = q = this.parse(o)
			}
			return q.is(p)
		},
		parse: function (r) {
			var p = [],
				q = b.length,
				v, s, w, x, y, t, u, o;
			while (r && v !== r) {
				v = r;
				s = r.match(c);
				if (s) {
					w = s[1];
					if (w === "#") {
						p.push({
							method: d,
							args: [Ext.String.trim(s[2])]
						})
					} else {
						if (w === ".") {
							p.push({
								method: j,
								args: [Ext.String.trim(s[2])]
							})
						} else {
							p.push({
								method: m,
								args: [Ext.String.trim(s[2]), Boolean(s[3])]
							})
						}
					}
					r = r.replace(s[0], "")
				}
				while (!(x = r.match(h))) {
					for (t = 0; r && t < q; t++) {
						u = b[t];
						y = r.match(u.re);
						o = u.method;
						if (y) {
							p.push({
								method: Ext.isString(u.method) ? Ext.functionFactory("items", Ext.String.format.apply(Ext.String, [o].concat(y.slice(1)))) : u.method,
								args: y.slice(1)
							});
							r = r.replace(y[0], "");
							break
						}
					}
				}
				if (x[1]) {
					p.push({
						mode: x[2] || x[1]
					});
					r = r.replace(x[0], "")
				}
			}
			return new g.Query({
				operations: p
			})
		}
	})
});
Ext.define("Ext.Decorator", {
	extend: Ext.Component,
	isDecorator: true,
	config: {
		component: {}
	},
	statics: {
		generateProxySetter: function (a) {
			return function (c) {
				var b = this.getComponent();
				b[a].call(b, c);
				return this
			}
		},
		generateProxyGetter: function (a) {
			return function () {
				var b = this.getComponent();
				return b[a].call(b)
			}
		}
	},
	onClassExtended: function (c, e) {
		if (!e.hasOwnProperty("proxyConfig")) {
			return
		}
		var f = Ext.Class,
			j = e.proxyConfig,
			d = e.config;
		e.config = (d) ? Ext.applyIf(d, j) : j;
		var b, h, g, a;
		for (b in j) {
			if (j.hasOwnProperty(b)) {
				h = f.getConfigNameMap(b);
				g = h.set;
				a = h.get;
				e[g] = this.generateProxySetter(g);
				e[a] = this.generateProxyGetter(a)
			}
		}
	},
	applyComponent: function (a) {
		return Ext.factory(a, Ext.Component)
	},
	updateComponent: function (a, b) {
		if (b) {
			if (this.isRendered() && b.setRendered(false)) {
				b.fireAction("renderedchange", [this, b, false], "doUnsetComponent", this, {
					args: [b]
				})
			} else {
				this.doUnsetComponent(b)
			}
		}
		if (a) {
			if (this.isRendered() && a.setRendered(true)) {
				a.fireAction("renderedchange", [this, a, true], "doSetComponent", this, {
					args: [a]
				})
			} else {
				this.doSetComponent(a)
			}
		}
	},
	doUnsetComponent: function (a) {
		if (a.renderElement.dom) {
			a.setLayoutSizeFlags(0);
			this.innerElement.dom.removeChild(a.renderElement.dom)
		}
	},
	doSetComponent: function (a) {
		if (a.renderElement.dom) {
			a.setLayoutSizeFlags(this.getSizeFlags());
			this.innerElement.dom.appendChild(a.renderElement.dom)
		}
	},
	setRendered: function (b) {
		var a;
		if (this.callParent(arguments)) {
			a = this.getComponent();
			if (a) {
				a.setRendered(b)
			}
			return true
		}
		return false
	},
	setDisabled: function (a) {
		this.callParent(arguments);
		this.getComponent().setDisabled(a)
	},
	destroy: function () {
		Ext.destroy(this.getComponent());
		this.callParent()
	}
});
Ext.define("Ext.Img", {
	extend: Ext.Component,
	xtype: ["image", "img"],
	config: {
		src: null,
		baseCls: Ext.baseCSSPrefix + "img",
		imageCls: Ext.baseCSSPrefix + "img-image",
		backgroundCls: Ext.baseCSSPrefix + "img-background",
		mode: "background"
	},
	beforeInitialize: function () {
		var a = this;
		a.onLoad = Ext.Function.bind(a.onLoad, a);
		a.onError = Ext.Function.bind(a.onError, a)
	},
	initialize: function () {
		var a = this;
		a.callParent();
		a.relayEvents(a.renderElement, "*");
		a.element.on({
			tap: "onTap",
			scope: a
		})
	},
	hide: function () {
		this.callParent();
		this.hiddenSrc = this.hiddenSrc || this.getSrc();
		this.setSrc(null)
	},
	show: function () {
		this.callParent();
		if (this.hiddenSrc) {
			this.setSrc(this.hiddenSrc);
			delete this.hiddenSrc
		}
	},
	updateMode: function (d) {
		var c = this,
			a = c.getImageCls(),
			b = c.getBackgroundCls();
		if (d === "background") {
			if (c.imageElement) {
				c.imageElement.destroy();
				delete c.imageElement;
				c.updateSrc(c.getSrc())
			}
			c.replaceCls(a, b)
		} else {
			c.imageElement = c.element.createChild({
				tag: "img"
			});
			c.replaceCls(b, a)
		}
	},
	updateImageCls: function (b, a) {
		this.replaceCls(a, b)
	},
	updateBackgroundCls: function (b, a) {
		this.replaceCls(a, b)
	},
	onTap: function (a) {
		this.fireEvent("tap", this, a)
	},
	onAfterRender: function () {
		this.updateSrc(this.getSrc())
	},
	updateSrc: function (a) {
		var b = this,
			c;
		if (b.getMode() === "background") {
			c = this.imageObject || new Image()
		} else {
			c = b.imageElement.dom
		}
		this.imageObject = c;
		c.setAttribute("src", Ext.isString(a) ? a : "");
		c.addEventListener("load", b.onLoad, false);
		c.addEventListener("error", b.onError, false)
	},
	detachListeners: function () {
		var a = this.imageObject;
		if (a) {
			a.removeEventListener("load", this.onLoad, false);
			a.removeEventListener("error", this.onError, false)
		}
	},
	onLoad: function (a) {
		this.detachListeners();
		if (this.getMode() === "background") {
			this.element.dom.style.backgroundImage = 'url("' + this.imageObject.src + '")'
		}
		this.fireEvent("load", this, a)
	},
	onError: function (a) {
		this.detachListeners();
		if (this.getMode() === "background") {
			this.element.dom.style.backgroundImage = 'url("' + this.imageObject.src + '")'
		}
		this.fireEvent("error", this, a)
	},
	doSetWidth: function (b) {
		var a = (this.getMode() === "background") ? this.element : this.imageElement;
		a.setWidth(b);
		this.callParent(arguments)
	},
	doSetHeight: function (b) {
		var a = (this.getMode() === "background") ? this.element : this.imageElement;
		a.setHeight(b);
		this.callParent(arguments)
	},
	destroy: function () {
		this.detachListeners();
		Ext.destroy(this.imageObject, this.imageElement);
		delete this.imageObject;
		delete this.imageElement;
		this.callParent()
	}
});
Ext.define("Ext.Label", {
	extend: Ext.Component,
	xtype: "label",
	config: {
		baseCls: Ext.baseCSSPrefix + "label"
	}
});
Ext.define("Ext.LoadMask", {
	extend: Ext.Mask,
	xtype: "loadmask",
	config: {
		message: "Loading...",
		messageCls: Ext.baseCSSPrefix + "mask-message",
		indicator: true
	},
	getTemplate: function () {
		var a = Ext.baseCSSPrefix;
		return [{
			reference: "innerElement",
			cls: a + "mask-inner",
			children: [{
				reference: "indicatorElement",
				cls: a + "loading-spinner-outer",
				children: [{
					cls: a + "loading-spinner",
					children: [{
						tag: "span",
						cls: a + "loading-top"
					}, {
						tag: "span",
						cls: a + "loading-right"
					}, {
						tag: "span",
						cls: a + "loading-bottom"
					}, {
						tag: "span",
						cls: a + "loading-left"
					}]
				}]
			}, {
				reference: "messageElement"
			}]
		}]
	},
	updateMessage: function (b) {
		var a = Ext.baseCSSPrefix + "has-message";
		if (b) {
			this.addCls(a)
		} else {
			this.removeCls(a)
		}
		this.messageElement.setHtml(b)
	},
	updateMessageCls: function (b, a) {
		this.messageElement.replaceCls(a, b)
	},
	updateIndicator: function (a) {
		this[a ? "removeCls" : "addCls"](Ext.baseCSSPrefix + "indicator-hidden")
	}
}, function () {});
Ext.define("Ext.Title", {
	extend: Ext.Component,
	xtype: "title",
	config: {
		baseCls: "x-title",
		title: ""
	},
	updateTitle: function (a) {
		this.setHtml(a)
	}
});
Ext.define("Ext.Spacer", {
	extend: Ext.Component,
	alias: "widget.spacer",
	config: {},
	constructor: function (a) {
		a = a || {};
		if (!a.width) {
			a.flex = 1
		}
		this.callParent([a])
	}
});
Ext.define("Ext.Toolbar", {
	extend: Ext.Container,
	xtype: "toolbar",
	isToolbar: true,
	config: {
		baseCls: Ext.baseCSSPrefix + "toolbar",
		ui: "dark",
		title: null,
		defaultType: "button",
		minHeight: null,
		layout: {
			type: "hbox",
			align: "center"
		}
	},
	hasCSSMinHeight: true,
	constructor: function (a) {
		a = a || {};
		if (a.docked == "left" || a.docked == "right") {
			a.layout = {
				type: "vbox",
				align: "stretch"
			}
		}
		this.callParent([a])
	},
	applyTitle: function (a) {
		if (typeof a == "string") {
			a = {
				title: a,
				centered: true
			}
		}
		return Ext.factory(a, Ext.Title, this.getTitle())
	},
	updateTitle: function (b, a) {
		if (b) {
			this.add(b)
		}
		if (a) {
			a.destroy()
		}
	},
	showTitle: function () {
		var a = this.getTitle();
		if (a) {
			a.show()
		}
	},
	hideTitle: function () {
		var a = this.getTitle();
		if (a) {
			a.hide()
		}
	}
}, function () {});
Ext.define("Ext.field.Input", {
	extend: Ext.Component,
	xtype: "input",
	tag: "input",
	cachedConfig: {
		cls: Ext.baseCSSPrefix + "form-field",
		focusCls: Ext.baseCSSPrefix + "field-focus",
		maskCls: Ext.baseCSSPrefix + "field-mask",
		useMask: "auto",
		type: "text",
		checked: false
	},
	config: {
		baseCls: Ext.baseCSSPrefix + "field-input",
		name: null,
		value: null,
		isFocused: false,
		tabIndex: null,
		placeHolder: null,
		minValue: null,
		maxValue: null,
		stepValue: null,
		maxLength: null,
		autoComplete: null,
		autoCapitalize: null,
		autoCorrect: null,
		readOnly: null,
		maxRows: null,
		pattern: null,
		startValue: false
	},
	getTemplate: function () {
		var a = [{
			reference: "input",
			tag: this.tag
		}, {
			reference: "mask",
			classList: [this.config.maskCls]
		}, {
			reference: "clearIcon",
			cls: "x-clear-icon"
		}];
		return a
	},
	initElement: function () {
		var a = this;
		a.callParent();
		a.input.on({
			scope: a,
			keyup: "onKeyUp",
			keydown: "onKeyDown",
			focus: "onFocus",
			blur: "onBlur",
			input: "onInput",
			paste: "onPaste",
			tap: "onInputTap"
		});
		a.mask.on({
			scope: a,
			tap: "onMaskTap"
		});
		if (a.clearIcon) {
			a.clearIcon.on({
				tap: "onClearIconTap",
				touchstart: "onClearIconPress",
				touchend: "onClearIconRelease",
				scope: a
			})
		}
		if (Ext.browser.is.ie && Ext.browser.version.major >= 10) {
			a.input.on({
				scope: a,
				keypress: "onKeyPress"
			})
		}
	},
	useManualMaxLength: function () {
		return Boolean((Ext.os.is.Android && !Ext.browser.is.Chrome))
	},
	applyUseMask: function (a) {
		if (a === "auto") {
			a = Ext.os.is.iOS && Ext.os.version.lt("5")
		}
		return Boolean(a)
	},
	updateUseMask: function (a) {
		this.mask[a ? "show" : "hide"]()
	},
	updatePattern: function (a) {
		this.updateFieldAttribute("pattern", a)
	},
	updateFieldAttribute: function (b, c) {
		var a = this.input;
		if (c) {
			a.dom.setAttribute(b, c)
		} else {
			a.dom.removeAttribute(b)
		}
	},
	updateCls: function (b, a) {
		this.input.addCls(Ext.baseCSSPrefix + "input-el");
		this.input.replaceCls(a, b)
	},
	updateType: function (a, c) {
		var b = Ext.baseCSSPrefix + "input-";
		this.input.replaceCls(b + c, b + a);
		this.updateFieldAttribute("type", a)
	},
	updateName: function (a) {
		this.updateFieldAttribute("name", a)
	},
	getValue: function () {
		var a = this.input;
		if (a) {
			this._value = a.dom.value
		}
		return this._value
	},
	applyValue: function (a) {
		return (Ext.isEmpty(a)) ? "" : a
	},
	updateValue: function (b) {
		var a = this.input;
		if (a) {
			a.dom.value = b
		}
	},
	setValue: function (b) {
		var a = this._value;
		this.updateValue(this.applyValue(b));
		b = this.getValue();
		if (String(b) != String(a) && this.initialized) {
			this.onChange(this, b, a)
		}
		return this
	},
	updateTabIndex: function (a) {
		this.updateFieldAttribute("tabIndex", a)
	},
	testAutoFn: function (a) {
		return [true, "on"].indexOf(a) !== -1
	},
	updateMaxLength: function (a) {
		if (!this.useManualMaxLength()) {
			this.updateFieldAttribute("maxlength", a)
		}
	},
	updatePlaceHolder: function (a) {
		this.updateFieldAttribute("placeholder", a)
	},
	applyAutoComplete: function (a) {
		return this.testAutoFn(a)
	},
	updateAutoComplete: function (a) {
		var b = a ? "on" : "off";
		this.updateFieldAttribute("autocomplete", b)
	},
	applyAutoCapitalize: function (a) {
		return this.testAutoFn(a)
	},
	updateAutoCapitalize: function (b) {
		var a = b ? "on" : "off";
		this.updateFieldAttribute("autocapitalize", a)
	},
	applyAutoCorrect: function (a) {
		return this.testAutoFn(a)
	},
	updateAutoCorrect: function (a) {
		var b = a ? "on" : "off";
		this.updateFieldAttribute("autocorrect", b)
	},
	updateMinValue: function (a) {
		this.updateFieldAttribute("min", a)
	},
	updateMaxValue: function (a) {
		this.updateFieldAttribute("max", a)
	},
	updateStepValue: function (a) {
		this.updateFieldAttribute("step", a)
	},
	checkedRe: /^(true|1|on)/i,
	getChecked: function () {
		var a = this.input,
			b;
		if (a) {
			b = a.dom.checked;
			this._checked = b
		}
		return b
	},
	applyChecked: function (a) {
		return !!this.checkedRe.test(String(a))
	},
	setChecked: function (a) {
		this.updateChecked(this.applyChecked(a));
		this._checked = a
	},
	updateChecked: function (a) {
		this.input.dom.checked = a
	},
	updateReadOnly: function (a) {
		this.updateFieldAttribute("readonly", a)
	},
	updateMaxRows: function (a) {
		this.updateFieldAttribute("rows", a)
	},
	doSetDisabled: function (a) {
		this.callParent(arguments);
		this.input.dom.disabled = a;
		if (!a) {
			this.blur()
		}
	},
	isDirty: function () {
		if (this.getDisabled()) {
			return false
		}
		return String(this.getValue()) !== String(this.originalValue)
	},
	reset: function () {
		this.setValue(this.originalValue)
	},
	onInputTap: function (a) {
		this.fireAction("inputtap", [this, a], "doInputTap")
	},
	doInputTap: function (a, b) {
		if (a.getDisabled()) {
			return false
		}
		a.focus()
	},
	onMaskTap: function (a) {
		this.fireAction("masktap", [this, a], "doMaskTap")
	},
	doMaskTap: function (a, b) {
		if (a.getDisabled()) {
			return false
		}
		a.focus()
	},
	showMask: function () {
		if (this.getUseMask()) {
			this.mask.setStyle("display", "block")
		}
	},
	hideMask: function () {
		if (this.getUseMask()) {
			this.mask.setStyle("display", "none")
		}
	},
	focus: function () {
		var b = this,
			a = b.input;
		if (a && a.dom.focus) {
			a.dom.focus()
		}
		return b
	},
	blur: function () {
		var b = this,
			a = this.input;
		if (a && a.dom.blur) {
			a.dom.blur()
		}
		return b
	},
	select: function () {
		var b = this,
			a = b.input;
		if (a && a.dom.setSelectionRange) {
			a.dom.setSelectionRange(0, 9999)
		}
		return b
	},
	onFocus: function (a) {
		this.fireAction("focus", [a], "doFocus")
	},
	doFocus: function (b) {
		var a = this;
		a.hideMask();
		if (!a.getIsFocused()) {
			a.setStartValue(a.getValue())
		}
		a.setIsFocused(true)
	},
	onBlur: function (a) {
		this.fireAction("blur", [a], "doBlur")
	},
	doBlur: function (d) {
		var b = this,
			c = b.getValue(),
			a = b.getStartValue();
		b.showMask();
		b.setIsFocused(false);
		if (String(c) != String(a)) {
			b.onChange(b, c, a)
		}
	},
	onClearIconTap: function (a) {
		this.fireEvent("clearicontap", this, a);
		if (Ext.os.is.Android) {
			this.focus()
		}
	},
	onClearIconPress: function () {
		this.clearIcon.addCls(Ext.baseCSSPrefix + "pressing")
	},
	onClearIconRelease: function () {
		this.clearIcon.removeCls(Ext.baseCSSPrefix + "pressing")
	},
	onClick: function (a) {
		this.fireEvent("click", a)
	},
	onChange: function (b, c, a) {
		if (this.useManualMaxLength()) {
			this.trimValueToMaxLength()
		}
		this.fireEvent("change", b, c, a)
	},
	onPaste: function (a) {
		if (this.useManualMaxLength()) {
			this.trimValueToMaxLength()
		}
		this.fireEvent("paste", a)
	},
	onKeyUp: function (a) {
		if (this.useManualMaxLength()) {
			this.trimValueToMaxLength()
		}
		this.fireEvent("keyup", a)
	},
	onKeyDown: function () {
		this.ignoreInput = true
	},
	onInput: function (b) {
		var a = this;
		if (a.ignoreInput) {
			a.ignoreInput = false;
			return
		}
		setTimeout(function () {
			if (!a.ignoreInput) {
				a.fireEvent("keyup", b);
				a.ignoreInput = false
			}
		}, 10)
	},
	onKeyPress: function (a) {
		if (a.browserEvent.keyCode == 13) {
			this.fireEvent("keyup", a)
		}
	},
	onMouseDown: function (a) {
		this.fireEvent("mousedown", a)
	},
	trimValueToMaxLength: function () {
		var a = this.getMaxLength();
		if (a) {
			var b = this.getValue();
			if (b.length > this.getMaxLength()) {
				this.setValue(b.slice(0, a))
			}
		}
	}
});
Ext.define("Ext.field.Field", {
	extend: Ext.Decorator,
	alternateClassName: "Ext.form.Field",
	xtype: "field",
	isField: true,
	isFormField: true,
	config: {
		baseCls: Ext.baseCSSPrefix + "field",
		label: null,
		labelAlign: "left",
		labelWidth: "30%",
		labelWrap: false,
		clearIcon: null,
		required: false,
		inputType: null,
		name: null,
		value: null,
		tabIndex: null
	},
	platformConfig: [{
		theme: ["Windows"],
		labelAlign: "top"
	}],
	cachedConfig: {
		labelCls: null,
		requiredCls: Ext.baseCSSPrefix + "field-required",
		inputCls: null
	},
	getElementConfig: function () {
		var a = Ext.baseCSSPrefix;
		return {
			reference: "element",
			className: "x-container",
			children: [{
				reference: "label",
				cls: a + "form-label",
				children: [{
					reference: "labelspan",
					tag: "span"
				}]
			}, {
				reference: "innerElement",
				cls: a + "component-outer"
			}]
		}
	},
	updateLabel: function (b, d) {
		var a = this.renderElement,
			c = Ext.baseCSSPrefix;
		if (b) {
			this.labelspan.setHtml(b);
			a.addCls(c + "field-labeled")
		} else {
			a.removeCls(c + "field-labeled")
		}
	},
	updateLabelAlign: function (b, c) {
		var a = this.renderElement,
			d = Ext.baseCSSPrefix;
		if (b) {
			a.addCls(d + "label-align-" + b);
			if (b == "top" || b == "bottom") {
				this.label.setWidth("100%")
			} else {
				this.updateLabelWidth(this.getLabelWidth())
			}
		}
		if (c) {
			a.removeCls(d + "label-align-" + c)
		}
	},
	updateLabelCls: function (a, b) {
		if (a) {
			this.label.addCls(a)
		}
		if (b) {
			this.label.removeCls(b)
		}
	},
	updateLabelWidth: function (b) {
		var a = this.getLabelAlign();
		if (b) {
			if (a == "top" || a == "bottom") {
				this.label.setWidth("100%")
			} else {
				this.label.setWidth(b)
			}
		}
	},
	updateLabelWrap: function (b, c) {
		var a = Ext.baseCSSPrefix + "form-label-nowrap";
		if (!b) {
			this.addCls(a)
		} else {
			this.removeCls(a)
		}
	},
	updateRequired: function (a) {
		this.renderElement[a ? "addCls" : "removeCls"](this.getRequiredCls())
	},
	updateRequiredCls: function (a, b) {
		if (this.getRequired()) {
			this.renderElement.replaceCls(b, a)
		}
	},
	initialize: function () {
		var a = this;
		a.callParent();
		a.doInitValue()
	},
	doInitValue: function () {
		this.originalValue = this.getInitialConfig().value
	},
	reset: function () {
		this.setValue(this.originalValue);
		return this
	},
	resetOriginalValue: function () {
		this.originalValue = this.getValue()
	},
	isDirty: function () {
		return false
	}
}, function () {});
Ext.define("Ext.field.Text", {
	extend: Ext.field.Field,
	xtype: "textfield",
	alternateClassName: "Ext.form.Text",
	config: {
		ui: "text",
		clearIcon: true,
		placeHolder: null,
		maxLength: null,
		autoComplete: null,
		autoCapitalize: null,
		autoCorrect: null,
		readOnly: null,
		component: {
			xtype: "input",
			type: "text"
		},
		bubbleEvents: ["action"]
	},
	initialize: function () {
		var a = this;
		a.callParent();
		a.getComponent().on({
			scope: this,
			keyup: "onKeyUp",
			change: "onChange",
			focus: "onFocus",
			blur: "onBlur",
			paste: "onPaste",
			mousedown: "onMouseDown",
			clearicontap: "onClearIconTap"
		});
		a.originalValue = a.originalValue || "";
		a.getComponent().originalValue = a.originalValue;
		a.syncEmptyCls()
	},
	syncEmptyCls: function () {
		var b = (this._value) ? this._value.length : false,
			a = Ext.baseCSSPrefix + "empty";
		if (b) {
			this.removeCls(a)
		} else {
			this.addCls(a)
		}
	},
	updateValue: function (c) {
		var b = this.getComponent(),
			a = c !== undefined && c !== null;
		if (b) {
			b.setValue(c)
		}
		this[a && this.isDirty() ? "showClearIcon" : "hideClearIcon"]();
		this.syncEmptyCls()
	},
	getValue: function () {
		var a = this;
		a._value = a.getComponent().getValue();
		a.syncEmptyCls();
		return a._value
	},
	updatePlaceHolder: function (a) {
		this.getComponent().setPlaceHolder(a)
	},
	updateMaxLength: function (a) {
		this.getComponent().setMaxLength(a)
	},
	updateAutoComplete: function (a) {
		this.getComponent().setAutoComplete(a)
	},
	updateAutoCapitalize: function (a) {
		this.getComponent().setAutoCapitalize(a)
	},
	updateAutoCorrect: function (a) {
		this.getComponent().setAutoCorrect(a)
	},
	updateReadOnly: function (a) {
		if (a) {
			this.hideClearIcon()
		} else {
			this.showClearIcon()
		}
		this.getComponent().setReadOnly(a)
	},
	updateInputType: function (a) {
		var b = this.getComponent();
		if (b) {
			b.setType(a)
		}
	},
	updateName: function (a) {
		var b = this.getComponent();
		if (b) {
			b.setName(a)
		}
	},
	updateTabIndex: function (b) {
		var a = this.getComponent();
		if (a) {
			a.setTabIndex(b)
		}
	},
	updateInputCls: function (a, b) {
		var c = this.getComponent();
		if (c) {
			c.replaceCls(b, a)
		}
	},
	doSetDisabled: function (b) {
		var c = this;
		c.callParent(arguments);
		var a = c.getComponent();
		if (a) {
			a.setDisabled(b)
		}
		if (b) {
			c.hideClearIcon()
		} else {
			c.showClearIcon()
		}
	},
	showClearIcon: function () {
		var b = this,
			c = b.getValue(),
			a = c !== undefined && c !== null;
		if (b.getClearIcon() && !b.getDisabled() && !b.getReadOnly() && a) {
			b.element.addCls(Ext.baseCSSPrefix + "field-clearable")
		}
		return b
	},
	hideClearIcon: function () {
		if (this.getClearIcon()) {
			this.element.removeCls(Ext.baseCSSPrefix + "field-clearable")
		}
	},
	onKeyUp: function (a) {
		this.fireAction("keyup", [this, a], "doKeyUp")
	},
	doKeyUp: function (b, d) {
		var c = b.getValue(),
			a = c !== undefined && c !== null;
		this[a && c !== this.originalValue ? "showClearIcon" : "hideClearIcon"]();
		if (d.browserEvent.keyCode === 13) {
			b.fireAction("action", [b, d], "doAction")
		}
	},
	doAction: function () {
		this.blur()
	},
	onClearIconTap: function (a) {
		this.fireAction("clearicontap", [this, a], "doClearIconTap")
	},
	doClearIconTap: function (a, b) {
		a.setValue("");
		a.getValue()
	},
	onChange: function (b, c, a) {
		b.fireEvent("change", this, c, a)
	},
	onFocus: function (a) {
		this.addCls(Ext.baseCSSPrefix + "field-focused");
		this.isFocused = true;
		this.fireEvent("focus", this, a)
	},
	onBlur: function (b) {
		var a = this;
		this.removeCls(Ext.baseCSSPrefix + "field-focused");
		this.isFocused = false;
		a.fireEvent("blur", a, b);
		setTimeout(function () {
			a.isFocused = false
		}, 50)
	},
	onPaste: function (a) {
		this.fireEvent("paste", this, a)
	},
	onMouseDown: function (a) {
		this.fireEvent("mousedown", this, a)
	},
	focus: function () {
		this.getComponent().focus();
		return this
	},
	blur: function () {
		this.getComponent().blur();
		return this
	},
	select: function () {
		this.getComponent().select();
		return this
	},
	resetOriginalValue: function () {
		this.callParent();
		var a = this.getComponent();
		if (a && a.hasOwnProperty("originalValue")) {
			this.getComponent().originalValue = this.originalValue
		}
		this.reset()
	},
	reset: function () {
		this.getComponent().reset();
		this.getValue();
		this[this.isDirty() ? "showClearIcon" : "hideClearIcon"]()
	},
	isDirty: function () {
		var a = this.getComponent();
		if (a) {
			return a.isDirty()
		}
		return false
	}
});
Ext.define("Ext.field.TextAreaInput", {
	extend: Ext.field.Input,
	xtype: "textareainput",
	tag: "textarea"
});
Ext.define("Ext.field.TextArea", {
	extend: Ext.field.Text,
	xtype: "textareafield",
	alternateClassName: "Ext.form.TextArea",
	config: {
		ui: "textarea",
		autoCapitalize: false,
		component: {
			xtype: "textareainput"
		},
		maxRows: null
	},
	updateMaxRows: function (a) {
		this.getComponent().setMaxRows(a)
	},
	doSetHeight: function (a) {
		this.callParent(arguments);
		var b = this.getComponent();
		b.input.setHeight(a)
	},
	doSetWidth: function (b) {
		this.callParent(arguments);
		var a = this.getComponent();
		a.input.setWidth(b)
	},
	doKeyUp: function (a) {
		var b = a.getValue();
		a[b ? "showClearIcon" : "hideClearIcon"]()
	}
});
Ext.define("Ext.MessageBox", {
	extend: Ext.Sheet,
	config: {
		ui: "dark",
		baseCls: Ext.baseCSSPrefix + "msgbox",
		iconCls: null,
		showAnimation: {
			type: "popIn",
			duration: 250,
			easing: "ease-out"
		},
		hideAnimation: {
			type: "popOut",
			duration: 250,
			easing: "ease-out"
		},
		zIndex: 999,
		defaultTextHeight: 75,
		title: null,
		buttons: null,
		message: null,
		prompt: null,
		modal: true,
		layout: {
			type: "vbox",
			pack: "center"
		}
	},
	platformConfig: [{
		theme: ["Windows"],
		ui: "light",
		showAnimation: {
			type: "fadeIn"
		},
		hideAnimation: {
			type: "fadeOut"
		}
	}, {
		theme: ["Blackberry"],
		ui: "plain"
	}],
	statics: {
		OK: {
			text: "OK",
			itemId: "ok",
			ui: "action"
		},
		YES: {
			text: "Yes",
			itemId: "yes",
			ui: "action"
		},
		NO: {
			text: "No",
			itemId: "no"
		},
		CANCEL: {
			text: "Cancel",
			itemId: "cancel"
		},
		INFO: Ext.baseCSSPrefix + "msgbox-info",
		WARNING: Ext.baseCSSPrefix + "msgbox-warning",
		QUESTION: Ext.baseCSSPrefix + "msgbox-question",
		ERROR: Ext.baseCSSPrefix + "msgbox-error",
		OKCANCEL: [{
			text: "Cancel",
			itemId: "cancel"
		}, {
			text: "OK",
			itemId: "ok",
			ui: "action"
		}],
		YESNOCANCEL: [{
			text: "Cancel",
			itemId: "cancel"
		}, {
			text: "No",
			itemId: "no"
		}, {
			text: "Yes",
			itemId: "yes",
			ui: "action"
		}],
		YESNO: [{
			text: "No",
			itemId: "no"
		}, {
			text: "Yes",
			itemId: "yes",
			ui: "action"
		}]
	},
	constructor: function (a) {
		a = a || {};
		if (a.hasOwnProperty("promptConfig")) {
			Ext.applyIf(a, {
				prompt: a.promptConfig
			});
			delete a.promptConfig
		}
		if (a.hasOwnProperty("multiline") || a.hasOwnProperty("multiLine")) {
			a.prompt = a.prompt || {};
			Ext.applyIf(a.prompt, {
				multiLine: a.multiline || a.multiLine
			});
			delete a.multiline;
			delete a.multiLine
		}
		this.defaultAllowedConfig = {};
		var e = ["ui", "showAnimation", "hideAnimation", "title", "message", "prompt", "iconCls", "buttons", "defaultTextHeight"],
			d = e.length,
			b, c;
		for (b = 0; b < d; b++) {
			c = e[b];
			this.defaultAllowedConfig[c] = this.defaultConfig[c]
		}
		this.callParent([a]);
		this.inputBlocker = new Ext.util.InputBlocker()
	},
	applyTitle: function (a) {
		if (typeof a == "string") {
			a = {
				title: a
			}
		}
		Ext.applyIf(a, {
			docked: "top",
			minHeight: (Ext.filterPlatform("blackberry") || Ext.filterPlatform("ie10")) ? "2.6em" : "1.3em",
			ui: Ext.filterPlatform("blackberry") ? "light" : "dark",
			cls: this.getBaseCls() + "-title"
		});
		return Ext.factory(a, Ext.Toolbar, this.getTitle())
	},
	updateTitle: function (a) {
		if (a) {
			this.add(a)
		}
	},
	updateButtons: function (a) {
		var b = this;
		a = (!a || a.length === 0) ? false : a;
		if (a) {
			if (b.buttonsToolbar) {
				b.buttonsToolbar.show();
				b.buttonsToolbar.removeAll();
				b.buttonsToolbar.setItems(a)
			} else {
				b.buttonsToolbar = Ext.create("Ext.Toolbar", {
					docked: "bottom",
					defaultType: "button",
					layout: {
						type: "hbox",
						pack: "center"
					},
					ui: b.getUi(),
					cls: b.getBaseCls() + "-buttons",
					items: a
				});
				b.add(b.buttonsToolbar)
			}
		} else {
			if (b.buttonsToolbar) {
				b.buttonsToolbar.hide()
			}
		}
	},
	applyMessage: function (a) {
		a = {
			html: a,
			cls: this.getBaseCls() + "-text"
		};
		return Ext.factory(a, Ext.Component, this._message)
	},
	updateMessage: function (a) {
		if (a) {
			this.add(a)
		}
	},
	getMessage: function () {
		if (this._message) {
			return this._message.getHtml()
		}
		return null
	},
	applyIconCls: function (a) {
		a = {
			xtype: "component",
			docked: "left",
			width: 40,
			height: 40,
			baseCls: Ext.baseCSSPrefix + "icon",
			hidden: (a) ? false : true,
			cls: a
		};
		return Ext.factory(a, Ext.Component, this._iconCls)
	},
	updateIconCls: function (a, b) {
		var c = this;
		this.getTitle();
		this.getButtons();
		if (a) {
			this.add(a)
		} else {
			this.remove(b)
		}
	},
	getIconCls: function () {
		var b = this._iconCls,
			a;
		if (b) {
			a = b.getCls();
			return (a) ? a[0] : null
		}
		return null
	},
	applyPrompt: function (a) {
		if (a) {
			var b = {
				label: false
			};
			if (Ext.isObject(a)) {
				Ext.apply(b, a)
			}
			if (b.multiLine) {
				b.height = Ext.isNumber(b.multiLine) ? parseFloat(b.multiLine) : this.getDefaultTextHeight();
				return Ext.factory(b, Ext.field.TextArea, this.getPrompt())
			} else {
				return Ext.factory(b, Ext.field.Text, this.getPrompt())
			}
		}
		return a
	},
	updatePrompt: function (a, b) {
		if (a) {
			this.add(a)
		}
		if (b) {
			this.remove(b)
		}
	},
	onClick: function (c) {
		if (c) {
			var b = c.config.userConfig || {},
				d = c.getInitialConfig(),
				a = this.getPrompt();
			if (typeof b.fn == "function") {
				this.on({
					hiddenchange: function () {
						b.fn.call(b.scope || null, d.itemId || d.text, a ? a.getValue() : null, b)
					},
					single: true,
					scope: this
				})
			}
			if (b.input) {
				b.input.dom.blur()
			}
		}
		this.hide()
	},
	show: function (f) {
		this.inputBlocker.blockInputs();
		if (!this.getParent() && Ext.Viewport) {
			Ext.Viewport.add(this)
		}
		if (!f) {
			return this.callParent()
		}
		var b = Ext.Object.merge({}, {
			value: ""
		}, f);
		var e = f.buttons || Ext.MessageBox.OK || [],
			d = [],
			c = f;
		Ext.each(e, function (g) {
			if (!g) {
				return
			}
			d.push(Ext.apply({
				userConfig: c,
				scope: this,
				handler: "onClick"
			}, g))
		}, this);
		b.buttons = d;
		if (b.promptConfig) {}
		b.prompt = (b.promptConfig || b.prompt) || null;
		if (b.multiLine) {
			b.prompt = b.prompt || {};
			b.prompt.multiLine = b.multiLine;
			delete b.multiLine
		}
		b = Ext.merge({}, this.defaultAllowedConfig, b);
		this.setConfig(b);
		var a = this.getPrompt();
		if (a) {
			a.setValue(f.value || "")
		}
		this.callParent();
		return this
	},
	alert: function (d, c, b, a) {
		return this.show({
			title: d || null,
			message: c || null,
			buttons: Ext.MessageBox.OK,
			promptConfig: false,
			fn: function () {
				if (b) {
					b.apply(a, arguments)
				}
			},
			scope: a
		})
	},
	confirm: function (d, c, b, a) {
		return this.show({
			title: d || null,
			message: c || null,
			buttons: Ext.MessageBox.YESNO,
			promptConfig: false,
			scope: a,
			fn: function () {
				if (b) {
					b.apply(a, arguments)
				}
			}
		})
	},
	prompt: function (g, d, c, b, f, e, a) {
		return this.show({
			title: g || null,
			message: d || null,
			buttons: Ext.MessageBox.OKCANCEL,
			scope: b,
			prompt: a || true,
			multiLine: f,
			value: e,
			fn: function () {
				if (c) {
					c.apply(b, arguments)
				}
			}
		})
	}
}, function (a) {
	Ext.onSetup(function () {
		Ext.Msg = new a
	})
});
Ext.define("Ext.TitleBar", {
	extend: Ext.Container,
	xtype: "titlebar",
	isToolbar: true,
	config: {
		baseCls: Ext.baseCSSPrefix + "toolbar",
		cls: Ext.baseCSSPrefix + "navigation-bar",
		ui: "dark",
		title: null,
		defaultType: "button",
		minHeight: null,
		layout: {
			type: "hbox"
		},
		items: []
	},
	hasCSSMinHeight: true,
	maxButtonWidth: "40%",
	beforeInitialize: function () {
		this.applyItems = this.applyInitialItems
	},
	initialize: function () {
		delete this.applyItems;
		this.add(this.initialItems);
		delete this.initialItems;
		this.on({
			painted: "refreshTitlePosition",
			single: true
		})
	},
	applyInitialItems: function (a) {
		var b = this,
			c = b.getDefaults() || {};
		b.initialItems = a;
		b.leftBox = b.add({
			xtype: "container",
			style: "position: relative",
			layout: {
				type: "hbox",
				align: "center"
			},
			listeners: {
				resize: "refreshTitlePosition",
				scope: b
			}
		});
		b.spacer = b.add({
			xtype: "component",
			style: "position: relative",
			flex: 1,
			listeners: {
				resize: "refreshTitlePosition",
				scope: b
			}
		});
		b.rightBox = b.add({
			xtype: "container",
			style: "position: relative",
			layout: {
				type: "hbox",
				align: "center"
			},
			listeners: {
				resize: "refreshTitlePosition",
				scope: b
			}
		});
		b.titleComponent = b.add({
			xtype: "title",
			hidden: c.hidden,
			centered: true
		});
		b.doAdd = b.doBoxAdd;
		b.remove = b.doBoxRemove;
		b.doInsert = b.doBoxInsert
	},
	doBoxAdd: function (a) {
		if (a.config.align == "right") {
			this.rightBox.add(a)
		} else {
			this.leftBox.add(a)
		}
	},
	doBoxRemove: function (b, a) {
		if (b.config.align == "right") {
			this.rightBox.remove(b, a)
		} else {
			this.leftBox.remove(b, a)
		}
	},
	doBoxInsert: function (a, b) {
		if (b.config.align == "right") {
			this.rightBox.insert(a, b)
		} else {
			this.leftBox.insert(a, b)
		}
	},
	getMaxButtonWidth: function () {
		var a = this.maxButtonWidth;
		if (Ext.isString(this.maxButtonWidth)) {
			a = parseInt(a.replace("%", ""), 10);
			a = Math.round((this.element.getWidth() / 100) * a)
		}
		return a
	},
	refreshTitlePosition: function () {
		if (this.isDestroyed) {
			return
		}
		var g = this.titleComponent.renderElement;
		g.setWidth(null);
		g.setLeft(null);
		var b = this.leftBox,
			d = b.down("button"),
			a = b.getItems().getCount() == 1,
			j, o;
		if (d && a) {
			if (d.getWidth() == null) {
				d.renderElement.setWidth("auto")
			}
			j = b.renderElement.getWidth();
			o = this.getMaxButtonWidth();
			if (j > o) {
				d.renderElement.setWidth(o)
			}
		}
		var l = this.spacer.renderElement.getPageBox(),
			m = g.getPageBox(),
			h = m.width - l.width,
			e = m.left,
			k = m.right,
			c, n, f;
		if (h > 0) {
			g.setWidth(l.width);
			c = h / 2;
			e += c;
			k -= c
		}
		n = l.left - e;
		f = k - l.right;
		if (n > 0) {
			g.setLeft(n)
		} else {
			if (f > 0) {
				g.setLeft(-f)
			}
		}
		g.repaint()
	},
	updateTitle: function (a) {
		this.titleComponent.setTitle(a);
		if (this.isPainted()) {
			this.refreshTitlePosition()
		}
	}
});
Ext.define("Ext.app.Action", {
	config: {
		scope: null,
		application: null,
		controller: null,
		action: null,
		args: [],
		url: undefined,
		data: {},
		title: null,
		beforeFilters: [],
		currentFilterIndex: -1
	},
	constructor: function (a) {
		this.initConfig(a);
		this.getUrl()
	},
	applyBeforeFilters: function (a) {
		return a || []
	},
	execute: function () {
		this.resume()
	},
	resume: function () {
		var b = this.getCurrentFilterIndex() + 1,
			c = this.getBeforeFilters(),
			a = this.getController(),
			d = c[b];
		if (d) {
			this.setCurrentFilterIndex(b);
			d.call(a, this)
		} else {
			a[this.getAction()].apply(a, this.getArgs())
		}
	},
	applyUrl: function (a) {
		if (a === null || a === undefined) {
			a = this.urlEncode()
		}
		return a
	},
	applyController: function (a) {
		var c = this.getApplication(),
			b = c.getCurrentProfile();
		if (Ext.isString(a)) {
			a = c.getController(a, b ? b.getNamespace() : null)
		}
		return a
	},
	urlEncode: function () {
		var a = this.getController(),
			b;
		if (a instanceof Ext.app.Controller) {
			b = a.$className.split(".");
			a = b[b.length - 1]
		}
		return a + "/" + this.getAction()
	}
});
Ext.define("Ext.app.Controller", {
	mixins: {
		observable: Ext.mixin.Observable
	},
	config: {
		refs: {},
		routes: {},
		control: {},
		before: {},
		application: {},
		stores: [],
		models: [],
		views: []
	},
	constructor: function (a) {
		this.initConfig(a);
		this.mixins.observable.constructor.call(this, a)
	},
	init: Ext.emptyFn,
	launch: Ext.emptyFn,
	redirectTo: function (a) {
		return this.getApplication().redirectTo(a)
	},
	execute: function (b, a) {
		b.setBeforeFilters(this.getBefore()[b.getAction()]);
		b.execute()
	},
	applyBefore: function (e) {
		var d, a, c, b;
		for (a in e) {
			d = Ext.Array.from(e[a]);
			c = d.length;
			for (b = 0; b < c; b++) {
				d[b] = this[d[b]]
			}
			e[a] = d
		}
		return e
	},
	applyControl: function (a) {
		this.control(a, this);
		return a
	},
	applyRefs: function (a) {
		this.ref(a);
		return a
	},
	applyRoutes: function (a) {
		var f = this instanceof Ext.app.Application ? this : this.getApplication(),
			c = f.getRouter(),
			b, e, d;
		for (e in a) {
			b = a[e];
			d = {
				controller: this.$className
			};
			if (Ext.isString(b)) {
				d.action = b
			} else {
				Ext.apply(d, b)
			}
			c.connect(e, d)
		}
		return a
	},
	applyStores: function (a) {
		return this.getFullyQualified(a, "store")
	},
	applyModels: function (a) {
		return this.getFullyQualified(a, "model")
	},
	applyViews: function (a) {
		return this.getFullyQualified(a, "view")
	},
	getFullyQualified: function (b, e) {
		var f = b.length,
			a = this.getApplication().getName(),
			c, d;
		for (d = 0; d < f; d++) {
			c = b[d];
			if (Ext.isString(c) && (Ext.Loader.getPrefix(c) === "" || c === a)) {
				b[d] = a + "." + e + "." + c
			}
		}
		return b
	},
	control: function (a) {
		this.getApplication().control(a, this)
	},
	ref: function (b) {
		var d = this,
			f, c, a, e;
		for (f in b) {
			a = b[f];
			c = "get" + Ext.String.capitalize(f);
			if (!this[c]) {
				if (Ext.isString(b[f])) {
					e = {
						ref: f,
						selector: a
					}
				} else {
					e = b[f]
				}
				this[c] = function (j, h) {
					var g = [j, h];
					return function () {
						return d.getRef.apply(d, g.concat.apply(g, arguments))
					}
				}(f, e)
			}
			this.references = this.references || [];
			this.references.push(f.toLowerCase())
		}
	},
	getRef: function (d, e, a) {
		this.refCache = this.refCache || {};
		e = e || {};
		a = a || {};
		Ext.apply(e, a);
		if (e.forceCreate) {
			return Ext.ComponentManager.create(e, "component")
		}
		var c = this,
			b = c.refCache[d];
		if (!b) {
			c.refCache[d] = b = Ext.ComponentQuery.query(e.selector)[0];
			if (!b && e.autoCreate) {
				c.refCache[d] = b = Ext.ComponentManager.create(e, "component")
			}
			if (b) {
				b.on("destroy", function () {
					c.refCache[d] = null
				})
			}
		}
		return b
	},
	hasRef: function (a) {
		return this.references && this.references.indexOf(a.toLowerCase()) !== -1
	}
}, function () {});
Ext.define("Ext.app.History", {
	mixins: [Ext.mixin.Observable],
	config: {
		actions: [],
		updateUrl: true,
		token: ""
	},
	constructor: function (a) {
		if (Ext.feature.has.History) {
			window.addEventListener("hashchange", Ext.bind(this.detectStateChange, this))
		} else {
			setInterval(Ext.bind(this.detectStateChange, this), 100)
		}
		this.initConfig(a);
		if (a && Ext.isEmpty(a.token)) {
			this.setToken(window.location.hash.substr(1))
		}
	},
	add: function (c, a) {
		c = Ext.factory(c, Ext.app.Action);
		this.getActions().push(c);
		var b = c.getUrl();
		if (this.getUpdateUrl()) {
			this.setToken(b);
			window.location.hash = b
		}
		if (a !== true) {
			this.fireEvent("change", b)
		}
		this.setToken(b)
	},
	back: function () {
		var b = this.getActions(),
			a = b[b.length - 2];
		if (a) {
			b.pop();
			a.getController().getApplication().redirectTo(a.getUrl())
		} else {
			b[b.length - 1].getController().getApplication().redirectTo("")
		}
	},
	applyToken: function (a) {
		return a[0] == "#" ? a.substr(1) : a
	},
	detectStateChange: function () {
		var b = this.applyToken(window.location.hash),
			a = this.getToken();
		if (b != a) {
			this.onStateChange();
			this.setToken(b)
		}
	},
	onStateChange: function () {
		this.fireEvent("change", window.location.hash.substr(1))
	}
});
Ext.define("Ext.app.Profile", {
	mixins: {
		observable: Ext.mixin.Observable
	},
	config: {
		namespace: "auto",
		name: "auto",
		controllers: [],
		models: [],
		views: [],
		stores: [],
		application: null
	},
	constructor: function (a) {
		this.initConfig(a);
		this.mixins.observable.constructor.apply(this, arguments)
	},
	isActive: function () {
		return false
	},
	launch: Ext.emptyFn,
	applyNamespace: function (a) {
		if (a == "auto") {
			a = this.getName()
		}
		return a.toLowerCase()
	},
	applyName: function (a) {
		if (a == "auto") {
			var b = this.$className.split(".");
			a = b[b.length - 1]
		}
		return a
	},
	getDependencies: function () {
		var c = [],
			g = Ext.String.format,
			b = this.getApplication().getName(),
			d = this.getNamespace(),
			f = {
				model: this.getModels(),
				view: this.getViews(),
				controller: this.getControllers(),
				store: this.getStores()
			},
			e, h, a;
		for (e in f) {
			h = [];
			Ext.each(f[e], function (j) {
				if (Ext.isString(j)) {
					if (Ext.isString(j) && (Ext.Loader.getPrefix(j) === "" || j === b)) {
						j = b + "." + e + "." + d + "." + j
					}
					h.push(j);
					c.push(j)
				}
			}, this);
			f[e] = h
		}
		f.all = c;
		return f
	}
});
Ext.define("Ext.app.Route", {
	config: {
		conditions: {},
		url: null,
		controller: null,
		action: null,
		initialized: false
	},
	constructor: function (a) {
		this.initConfig(a)
	},
	recognize: function (b) {
		if (!this.getInitialized()) {
			this.initialize()
		}
		if (this.recognizes(b)) {
			var c = this.matchesFor(b),
				a = b.match(this.matcherRegex);
			a.shift();
			return Ext.applyIf(c, {
				controller: this.getController(),
				action: this.getAction(),
				url: b,
				args: a,
				historyUrl: b
			})
		}
	},
	initialize: function () {
		this.paramMatchingRegex = new RegExp(/:([0-9A-Za-z\_]*)/g);
		this.paramsInMatchString = this.getUrl().match(this.paramMatchingRegex) || [];
		this.matcherRegex = this.createMatcherRegex(this.getUrl());
		this.setInitialized(true)
	},
	recognizes: function (a) {
		return this.matcherRegex.test(a)
	},
	matchesFor: function (b) {
		var f = {},
			e = this.paramsInMatchString,
			a = b.match(this.matcherRegex),
			d = e.length,
			c;
		a.shift();
		for (c = 0; c < d; c++) {
			f[e[c].replace(":", "")] = a[c]
		}
		return f
	},
	argsFor: function (c) {
		var b = [],
			f = this.paramsInMatchString,
			a = c.match(this.matcherRegex),
			e = f.length,
			d;
		a.shift();
		for (d = 0; d < e; d++) {
			b.push(f[d].replace(":", ""));
			params[f[d].replace(":", "")] = a[d]
		}
		return params
	},
	urlFor: function (b) {
		var a = this.getUrl();
		for (var c in b) {
			a = a.replace(":" + c, b[c])
		}
		return a
	},
	createMatcherRegex: function (a) {
		var e = this.paramsInMatchString,
			d = e.length,
			b, c, f;
		for (b = 0; b < d; b++) {
			c = this.getConditions()[e[b]];
			f = Ext.util.Format.format("({0})", c || "[%a-zA-Z0-9-\\_\\s,]+");
			a = a.replace(new RegExp(e[b]), f)
		}
		return new RegExp("^" + a + "$")
	}
});
Ext.define("Ext.app.Router", {
	config: {
		routes: [],
		defaults: {
			action: "index"
		}
	},
	constructor: function (a) {
		this.initConfig(a)
	},
	connect: function (b, c) {
		c = Ext.apply({
			url: b
		}, c || {}, this.getDefaults());
		var a = Ext.create("Ext.app.Route", c);
		this.getRoutes().push(a);
		return a
	},
	recognize: function (c) {
		var b = this.getRoutes(),
			e = b.length,
			d, a;
		for (d = 0; d < e; d++) {
			a = b[d].recognize(c);
			if (a !== undefined) {
				return a
			}
		}
		return undefined
	},
	draw: function (a) {
		a.call(this, this)
	},
	clear: function () {
		this.setRoutes([])
	}
}, function () {});
Ext.define("Ext.app.Application", {
	extend: Ext.app.Controller,
	config: {
		profiles: [],
		controllers: [],
		history: {},
		name: null,
		appFolder: "app",
		router: {},
		controllerInstances: [],
		profileInstances: [],
		currentProfile: null,
		launch: Ext.emptyFn,
		enableLoader: true,
		requires: []
	},
	constructor: function (a) {
		a = a || {};
		Ext.applyIf(a, {
			application: this
		});
		this.initConfig(a);
		for (var b in a) {
			this[b] = a[b]
		}
		Ext.require(this.getRequires(), function () {
			if (this.getEnableLoader() !== false) {
				Ext.require(this.getProfiles(), this.onProfilesLoaded, this)
			}
		}, this)
	},
	dispatch: function (e, d) {
		e = e || {};
		Ext.applyIf(e, {
			application: this
		});
		e = Ext.factory(e, Ext.app.Action);
		if (e) {
			var c = this.getCurrentProfile(),
				b = c ? c.getNamespace() : undefined,
				a = this.getController(e.getController(), b);
			if (a) {
				if (d !== false) {
					this.getHistory().add(e, true)
				}
				a.execute(e)
			}
		}
	},
	redirectTo: function (c) {
		if (Ext.data && Ext.data.Model && c instanceof Ext.data.Model) {
			var a = c;
			c = a.toUrl()
		}
		var b = this.getRouter().recognize(c);
		if (b) {
			b.url = c;
			if (a) {
				b.data = {};
				b.data.record = a
			}
			return this.dispatch(b)
		}
	},
	control: function (h, d) {
		d = d || this;
		var j = this.getEventDispatcher(),
			g = (d) ? d.getRefs() : {},
			c, e, b, f, a;
		for (c in h) {
			if (h.hasOwnProperty(c)) {
				f = h[c];
				a = g[c];
				if (a) {
					c = a.selector || a
				}
				for (e in f) {
					b = f[e];
					if (Ext.isString(b)) {
						b = d[b]
					}
					j.addListener("component", c, e, b, d)
				}
			}
		}
	},
	getController: function (b, d) {
		var f = this.getControllerInstances(),
			a = this.getName(),
			e = Ext.String.format,
			c;
		if (b instanceof Ext.app.Controller) {
			return b
		}
		if (f[b]) {
			return f[b]
		} else {
			c = e("{0}.controller.{1}", a, b);
			d = e("{0}.controller.{1}.{2}", a, d, b);
			return f[d] || f[c]
		}
	},
	onProfilesLoaded: function () {
		var b = this.getProfiles(),
			e = b.length,
			g = [],
			d = this.gatherDependencies(),
			f, c, a;
		for (c = 0; c < e; c++) {
			g[c] = Ext.create(b[c], {
				application: this
			});
			a = g[c].getDependencies();
			d = d.concat(a.all);
			if (g[c].isActive() && !f) {
				f = g[c];
				this.setCurrentProfile(f);
				this.setControllers(this.getControllers().concat(a.controller));
				this.setModels(this.getModels().concat(a.model));
				this.setViews(this.getViews().concat(a.view));
				this.setStores(this.getStores().concat(a.store))
			}
		}
		this.setProfileInstances(g);
		Ext.require(d, this.loadControllerDependencies, this)
	},
	loadControllerDependencies: function () {
		this.instantiateControllers();
		var g = this.getControllerInstances(),
			f = [],
			c = [],
			e, b, a, d;
		for (d in g) {
			b = g[d];
			a = b.getStores();
			c = c.concat(a);
			f = f.concat(b.getModels().concat(b.getViews()).concat(a))
		}
		this.setStores(this.getStores().concat(c));
		Ext.require(f, this.onDependenciesLoaded, this)
	},
	onDependenciesLoaded: function () {
		var c = this,
			b = this.getCurrentProfile(),
			e = this.getLaunch(),
			d, a;
		this.instantiateStores();
		d = this.getControllerInstances();
		for (a in d) {
			d[a].init(this)
		}
		if (b) {
			b.launch()
		}
		e.call(c);
		for (a in d) {
			d[a].launch(this)
		}
		c.redirectTo(window.location.hash.substr(1))
	},
	gatherDependencies: function () {
		var a = this.getModels().concat(this.getViews()).concat(this.getControllers());
		Ext.each(this.getStores(), function (b) {
			if (Ext.isString(b)) {
				a.push(b)
			}
		}, this);
		return a
	},
	instantiateStores: function () {
		var b = this.getStores(),
			f = b.length,
			c, a, d, g, e;
		for (e = 0; e < f; e++) {
			c = b[e];
			if (Ext.data && Ext.data.Store && !(c instanceof Ext.data.Store)) {
				if (Ext.isString(c)) {
					d = c;
					a = Ext.ClassManager.classes[c];
					c = {
						xclass: c
					};
					if (a.prototype.defaultConfig.storeId === undefined) {
						g = d.split(".");
						c.id = g[g.length - 1]
					}
				}
				b[e] = Ext.factory(c, Ext.data.Store)
			}
		}
		this.setStores(b)
	},
	instantiateControllers: function () {
		var e = this.getControllers(),
			d = {},
			c = e.length,
			a, b;
		for (b = 0; b < c; b++) {
			a = e[b];
			d[a] = Ext.create(a, {
				application: this
			})
		}
		return this.setControllerInstances(d)
	},
	applyControllers: function (a) {
		return this.getFullyQualified(a, "controller")
	},
	applyProfiles: function (a) {
		return this.getFullyQualified(a, "profile")
	},
	applyName: function (a) {
		var b;
		if (a && a.match(/ /g)) {
			b = a;
			a = a.replace(/ /g, "")
		}
		return a
	},
	updateName: function (a) {
		Ext.ClassManager.setNamespace(a + ".app", this);
		if (!Ext.Loader.config.paths[a]) {
			Ext.Loader.setPath(a, this.getAppFolder())
		}
	},
	applyRouter: function (a) {
		return Ext.factory(a, Ext.app.Router, this.getRouter())
	},
	applyHistory: function (a) {
		var b = Ext.factory(a, Ext.app.History, this.getHistory());
		b.on("change", this.onHistoryChange, this);
		return b
	},
	onHistoryChange: function (a) {
		this.dispatch(this.getRouter().recognize(a), false)
	}
}, function () {});
Ext.define("Ext.mixin.Sortable", {
	extend: Ext.mixin.Mixin,
	mixinConfig: {
		id: "sortable"
	},
	config: {
		sorters: null,
		defaultSortDirection: "ASC",
		sortRoot: null
	},
	dirtySortFn: false,
	sortFn: null,
	sorted: false,
	applySorters: function (a, b) {
		if (!b) {
			b = this.createSortersCollection()
		}
		b.clear();
		this.sorted = false;
		if (a) {
			this.addSorters(a)
		}
		return b
	},
	createSortersCollection: function () {
		this._sorters = Ext.create("Ext.util.Collection", function (a) {
			return a.getId()
		});
		return this._sorters
	},
	addSorter: function (b, a) {
		this.addSorters([b], a)
	},
	addSorters: function (c, a) {
		var b = this.getSorters();
		return this.insertSorters(b ? b.length : 0, c, a)
	},
	insertSorter: function (a, c, b) {
		return this.insertSorters(a, [c], b)
	},
	insertSorters: function (e, h, a) {
		if (!Ext.isArray(h)) {
			h = [h]
		}
		var f = h.length,
			j = a || this.getDefaultSortDirection(),
			c = this.getSortRoot(),
			k = this.getSorters(),
			l = [],
			g, b, m, d;
		if (!k) {
			k = this.createSortersCollection()
		}
		for (b = 0; b < f; b++) {
			m = h[b];
			g = {
				direction: j,
				root: c
			};
			if (typeof m === "string") {
				d = k.get(m);
				if (!d) {
					g.property = m
				} else {
					if (a) {
						d.setDirection(a)
					} else {
						d.toggle()
					}
					continue
				}
			} else {
				if (Ext.isFunction(m)) {
					g.sorterFn = m
				} else {
					if (Ext.isObject(m)) {
						if (!m.isSorter) {
							if (m.fn) {
								m.sorterFn = m.fn;
								delete m.fn
							}
							g = Ext.apply(g, m)
						} else {
							l.push(m);
							if (!m.getRoot()) {
								m.setRoot(c)
							}
							continue
						}
					}
				}
			}
			m = Ext.create("Ext.util.Sorter", g);
			l.push(m)
		}
		for (b = 0, f = l.length; b < f; b++) {
			k.insert(e + b, l[b])
		}
		this.dirtySortFn = true;
		if (k.length) {
			this.sorted = true
		}
		return k
	},
	removeSorter: function (a) {
		return this.removeSorters([a])
	},
	removeSorters: function (d) {
		if (!Ext.isArray(d)) {
			d = [d]
		}
		var b = d.length,
			c = this.getSorters(),
			a, e;
		for (a = 0; a < b; a++) {
			e = d[a];
			if (typeof e === "string") {
				c.removeAtKey(e)
			} else {
				if (typeof e === "function") {
					c.each(function (f) {
						if (f.getSorterFn() === e) {
							c.remove(f)
						}
					})
				} else {
					if (e.isSorter) {
						c.remove(e)
					}
				}
			}
		}
		if (!c.length) {
			this.sorted = false
		}
	},
	updateSortFn: function () {
		var a = this.getSorters().items;
		this.sortFn = function (d, c) {
			var f = a.length,
				b, e;
			for (e = 0; e < f; e++) {
				b = a[e].sort.call(this, d, c);
				if (b !== 0) {
					break
				}
			}
			return b
		};
		this.dirtySortFn = false;
		return this.sortFn
	},
	getSortFn: function () {
		if (this.dirtySortFn) {
			return this.updateSortFn()
		}
		return this.sortFn
	},
	sort: function (a) {
		Ext.Array.sort(a, this.getSortFn());
		return a
	},
	findInsertionIndex: function (b, e, g) {
		var h = 0,
			a = b.length - 1,
			d = g || this.getSortFn(),
			c, f;
		while (h <= a) {
			c = (h + a) >> 1;
			f = d(e, b[c]);
			if (f >= 0) {
				h = c + 1
			} else {
				if (f < 0) {
					a = c - 1
				}
			}
		}
		return h
	}
});
Ext.define("Ext.mixin.Filterable", {
	extend: Ext.mixin.Mixin,
	mixinConfig: {
		id: "filterable"
	},
	config: {
		filters: null,
		filterRoot: null
	},
	dirtyFilterFn: false,
	filterFn: null,
	filtered: false,
	applyFilters: function (a, b) {
		if (!b) {
			b = this.createFiltersCollection()
		}
		b.clear();
		this.filtered = false;
		this.dirtyFilterFn = true;
		if (a) {
			this.addFilters(a)
		}
		return b
	},
	createFiltersCollection: function () {
		this._filters = Ext.create("Ext.util.Collection", function (a) {
			return a.getId()
		});
		return this._filters
	},
	addFilter: function (a) {
		this.addFilters([a])
	},
	addFilters: function (b) {
		var a = this.getFilters();
		return this.insertFilters(a ? a.length : 0, b)
	},
	insertFilter: function (a, b) {
		return this.insertFilters(a, [b])
	},
	insertFilters: function (h, c) {
		if (!Ext.isArray(c)) {
			c = [c]
		}
		var j = c.length,
			a = this.getFilterRoot(),
			d = this.getFilters(),
			e = [],
			f, g, b;
		if (!d) {
			d = this.createFiltersCollection()
		}
		for (g = 0; g < j; g++) {
			b = c[g];
			f = {
				root: a
			};
			if (Ext.isFunction(b)) {
				f.filterFn = b
			} else {
				if (Ext.isObject(b)) {
					if (!b.isFilter) {
						if (b.fn) {
							b.filterFn = b.fn;
							delete b.fn
						}
						f = Ext.apply(f, b)
					} else {
						e.push(b);
						if (!b.getRoot()) {
							b.setRoot(a)
						}
						continue
					}
				}
			}
			b = Ext.create("Ext.util.Filter", f);
			e.push(b)
		}
		for (g = 0, j = e.length; g < j; g++) {
			d.insert(h + g, e[g])
		}
		this.dirtyFilterFn = true;
		if (d.length) {
			this.filtered = true
		}
		return d
	},
	removeFilters: function (e) {
		if (!Ext.isArray(e)) {
			e = [e]
		}
		var d = e.length,
			c = this.getFilters(),
			a, b;
		for (a = 0; a < d; a++) {
			b = e[a];
			if (typeof b === "string") {
				c.each(function (f) {
					if (f.getProperty() === b) {
						c.remove(f)
					}
				})
			} else {
				if (typeof b === "function") {
					c.each(function (f) {
						if (f.getFilterFn() === b) {
							c.remove(f)
						}
					})
				} else {
					if (b.isFilter) {
						c.remove(b)
					} else {
						if (b.property !== undefined && b.value !== undefined) {
							c.each(function (f) {
								if (f.getProperty() === b.property && f.getValue() === b.value) {
									c.remove(f)
								}
							})
						}
					}
				}
			}
		}
		if (!c.length) {
			this.filtered = false
		}
	},
	updateFilterFn: function () {
		var a = this.getFilters().items;
		this.filterFn = function (h) {
			var f = true,
				g = a.length,
				b;
			for (b = 0; b < g; b++) {
				var e = a[b],
					d = e.getFilterFn(),
					c = e.getScope() || this;
				f = f && d.call(c, h)
			}
			return f
		};
		this.dirtyFilterFn = false;
		return this.filterFn
	},
	filter: function (a) {
		return this.getFilters().length ? Ext.Array.filter(a, this.getFilterFn()) : a
	},
	isFiltered: function (a) {
		return this.getFilters().length ? !this.getFilterFn()(a) : false
	},
	getFilterFn: function () {
		if (this.dirtyFilterFn) {
			return this.updateFilterFn()
		}
		return this.filterFn
	}
});
Ext.define("Ext.util.Collection", {
	config: {
		autoFilter: true,
		autoSort: true
	},
	mixins: {
		sortable: Ext.mixin.Sortable,
		filterable: Ext.mixin.Filterable
	},
	constructor: function (b, a) {
		var c = this;
		c.all = [];
		c.items = [];
		c.keys = [];
		c.indices = {};
		c.map = {};
		c.length = 0;
		if (b) {
			c.getKey = b
		}
		this.initConfig(a)
	},
	updateAutoSort: function (a, b) {
		if (b === false && a && this.items.length) {
			this.sort()
		}
	},
	updateAutoFilter: function (b, a) {
		if (a === false && b && this.all.length) {
			this.filter()
		}
	},
	insertSorters: function () {
		this.mixins.sortable.insertSorters.apply(this, arguments);
		if (this.getAutoSort() && this.items.length) {
			this.sort()
		}
		return this
	},
	removeSorters: function (a) {
		this.mixins.sortable.removeSorters.call(this, a);
		if (this.sorted && this.getAutoSort() && this.items.length) {
			this.sort()
		}
		return this
	},
	applyFilters: function (a) {
		var b = this.mixins.filterable.applyFilters.call(this, a);
		if (!a && this.all.length && this.getAutoFilter()) {
			this.filter()
		}
		return b
	},
	addFilters: function (a) {
		this.mixins.filterable.addFilters.call(this, a);
		if (this.items.length && this.getAutoFilter()) {
			this.filter()
		}
		return this
	},
	removeFilters: function (a) {
		this.mixins.filterable.removeFilters.call(this, a);
		if (this.filtered && this.all.length && this.getAutoFilter()) {
			this.filter()
		}
		return this
	},
	filter: function (c, b, d, a) {
		if (c) {
			if (Ext.isString(c)) {
				this.addFilters({
					property: c,
					value: b,
					anyMatch: d,
					caseSensitive: a
				});
				return this.items
			} else {
				this.addFilters(c);
				return this.items
			}
		}
		this.items = this.mixins.filterable.filter.call(this, this.all.slice());
		this.updateAfterFilter();
		if (this.sorted && this.getAutoSort()) {
			this.sort()
		}
	},
	updateAfterFilter: function () {
		var a = this.items,
			f = this.keys,
			g = this.indices = {},
			e = a.length,
			c, d, b;
		f.length = 0;
		for (c = 0; c < e; c++) {
			d = a[c];
			b = this.getKey(d);
			g[b] = c;
			f[c] = b
		}
		this.length = a.length;
		this.dirtyIndices = false
	},
	sort: function (e, a) {
		var d = this.items,
			h = this.keys,
			g = this.indices,
			c = d.length,
			b, j, f;
		if (e) {
			this.addSorters(e, a);
			return this.items
		}
		for (b = 0; b < c; b++) {
			d[b]._current_key = h[b]
		}
		this.handleSort(d);
		for (b = 0; b < c; b++) {
			j = d[b];
			f = j._current_key;
			h[b] = f;
			g[f] = b;
			delete j._current_key
		}
		this.dirtyIndices = true
	},
	handleSort: function (a) {
		this.mixins.sortable.sort.call(this, a)
	},
	add: function (j, l) {
		var g = this,
			d = this.filtered,
			e = this.sorted,
			h = this.all,
			f = this.items,
			m = this.keys,
			k = this.indices,
			a = this.mixins.filterable,
			b = f.length,
			c = b;
		if (arguments.length == 1) {
			l = j;
			j = g.getKey(l)
		}
		if (typeof j != "undefined" && j !== null) {
			if (typeof g.map[j] != "undefined") {
				return g.replace(j, l)
			}
			g.map[j] = l
		}
		h.push(l);
		if (d && this.getAutoFilter() && a.isFiltered.call(g, l)) {
			return null
		}
		g.length++;
		if (e && this.getAutoSort()) {
			c = this.findInsertionIndex(f, l)
		}
		if (c !== b) {
			this.dirtyIndices = true;
			Ext.Array.splice(m, c, 0, j);
			Ext.Array.splice(f, c, 0, l)
		} else {
			k[j] = b;
			m.push(j);
			f.push(l)
		}
		return l
	},
	getKey: function (a) {
		return a.id
	},
	replace: function (d, n) {
		var j = this,
			g = j.sorted,
			f = j.filtered,
			b = j.mixins.filterable,
			h = j.items,
			o = j.keys,
			l = j.all,
			c = j.map,
			m = null,
			a = h.length,
			p, e, k;
		if (arguments.length == 1) {
			n = d;
			d = k = j.getKey(n)
		} else {
			k = j.getKey(n)
		}
		p = c[d];
		if (typeof d == "undefined" || d === null || typeof p == "undefined") {
			return j.add(k, n)
		}
		j.map[k] = n;
		if (k !== d) {
			delete j.map[d]
		}
		if (g && j.getAutoSort()) {
			Ext.Array.remove(h, p);
			Ext.Array.remove(o, d);
			Ext.Array.remove(l, p);
			l.push(n);
			j.dirtyIndices = true;
			if (f && j.getAutoFilter()) {
				if (b.isFiltered.call(j, n)) {
					if (a !== h.length) {
						j.length--
					}
					return null
				} else {
					if (a === h.length) {
						j.length++;
						m = n
					}
				}
			}
			e = this.findInsertionIndex(h, n);
			Ext.Array.splice(o, e, 0, k);
			Ext.Array.splice(h, e, 0, n)
		} else {
			if (f) {
				if (j.getAutoFilter() && b.isFiltered.call(j, n)) {
					if (j.indexOf(p) !== -1) {
						Ext.Array.remove(h, p);
						Ext.Array.remove(o, d);
						j.length--;
						j.dirtyIndices = true
					}
					return null
				} else {
					if (j.indexOf(p) === -1) {
						h.push(n);
						o.push(k);
						j.indices[k] = j.length;
						j.length++;
						return n
					}
				}
			}
			e = j.indexOf(p);
			o[e] = k;
			h[e] = n;
			if (k !== d) {
				this.dirtyIndices = true
			}
		}
		return m
	},
	addAll: function (h) {
		var q = this,
			e = q.filtered,
			a = q.sorted,
			b = q.all,
			k = q.items,
			j = q.keys,
			p = q.map,
			l = q.getAutoFilter(),
			m = q.getAutoSort(),
			r = [],
			f = [],
			c = q.mixins.filterable,
			d = [],
			g, s, n, o;
		if (Ext.isObject(h)) {
			for (s in h) {
				if (h.hasOwnProperty(s)) {
					f.push(k[s]);
					r.push(s)
				}
			}
		} else {
			f = h;
			g = h.length;
			for (n = 0; n < g; n++) {
				r.push(q.getKey(h[n]))
			}
		}
		for (n = 0; n < g; n++) {
			s = r[n];
			o = f[n];
			if (typeof s != "undefined" && s !== null) {
				if (typeof p[s] != "undefined") {
					q.replace(s, o);
					continue
				}
				p[s] = o
			}
			b.push(o);
			if (e && l && c.isFiltered.call(q, o)) {
				continue
			}
			q.length++;
			j.push(s);
			k.push(o);
			d.push(o)
		}
		if (d.length) {
			q.dirtyIndices = true;
			if (a && m) {
				q.sort()
			}
			return d
		}
		return null
	},
	each: function (e, d) {
		var b = this.items.slice(),
			c = 0,
			a = b.length,
			f;
		for (; c < a; c++) {
			f = b[c];
			if (e.call(d || f, f, c, a) === false) {
				break
			}
		}
	},
	eachKey: function (d, c) {
		var f = this.keys,
			a = this.items,
			e = f.length,
			b;
		for (b = 0; b < e; b++) {
			d.call(c || window, f[b], a[b], b, e)
		}
	},
	findBy: function (e, d) {
		var f = this.keys,
			b = this.items,
			c = 0,
			a = b.length;
		for (; c < a; c++) {
			if (e.call(d || window, b[c], f[c])) {
				return b[c]
			}
		}
		return null
	},
	filterBy: function (e, d) {
		var h = this,
			c = new this.self(),
			g = h.keys,
			a = h.all,
			f = a.length,
			b;
		c.getKey = h.getKey;
		for (b = 0; b < f; b++) {
			if (e.call(d || h, a[b], h.getKey(a[b]))) {
				c.add(g[b], a[b])
			}
		}
		return c
	},
	insert: function (c, d, f) {
		var e = this,
			a = this.sorted,
			g = this.map,
			b = this.filtered;
		if (arguments.length == 2) {
			f = d;
			d = e.getKey(f)
		}
		if (c >= e.length || (a && e.getAutoSort())) {
			return e.add(d, f)
		}
		if (typeof d != "undefined" && d !== null) {
			if (typeof g[d] != "undefined") {
				e.replace(d, f);
				return false
			}
			g[d] = f
		}
		this.all.push(f);
		if (b && this.getAutoFilter() && this.mixins.filterable.isFiltered.call(e, f)) {
			return null
		}
		e.length++;
		Ext.Array.splice(e.items, c, 0, f);
		Ext.Array.splice(e.keys, c, 0, d);
		e.dirtyIndices = true;
		return f
	},
	insertAll: function (g, d) {
		if (g >= this.items.length || (this.sorted && this.getAutoSort())) {
			return this.addAll(d)
		}
		var s = this,
			h = this.filtered,
			a = this.sorted,
			b = this.all,
			m = this.items,
			l = this.keys,
			r = this.map,
			n = this.getAutoFilter(),
			o = this.getAutoSort(),
			t = [],
			j = [],
			f = [],
			c = this.mixins.filterable,
			e = false,
			k, u, p, q;
		if (a && this.getAutoSort()) {}
		if (Ext.isObject(d)) {
			for (u in d) {
				if (d.hasOwnProperty(u)) {
					j.push(m[u]);
					t.push(u)
				}
			}
		} else {
			j = d;
			k = d.length;
			for (p = 0; p < k; p++) {
				t.push(s.getKey(d[p]))
			}
		}
		for (p = 0; p < k; p++) {
			u = t[p];
			q = j[p];
			if (typeof u != "undefined" && u !== null) {
				if (typeof r[u] != "undefined") {
					s.replace(u, q);
					continue
				}
				r[u] = q
			}
			b.push(q);
			if (h && n && c.isFiltered.call(s, q)) {
				continue
			}
			s.length++;
			Ext.Array.splice(m, g + p, 0, q);
			Ext.Array.splice(l, g + p, 0, u);
			e = true;
			f.push(q)
		}
		if (e) {
			this.dirtyIndices = true;
			if (a && o) {
				this.sort()
			}
			return f
		}
		return null
	},
	remove: function (c) {
		var a = this.items.indexOf(c);
		if (a === -1) {
			Ext.Array.remove(this.all, c);
			if (typeof this.getKey == "function") {
				var b = this.getKey(c);
				if (b !== undefined) {
					delete this.map[b]
				}
			}
			return c
		}
		return this.removeAt(this.items.indexOf(c))
	},
	removeAll: function (a) {
		if (a) {
			var c = a.length,
				b;
			for (b = 0; b < c; b++) {
				this.remove(a[b])
			}
		}
		return this
	},
	removeAt: function (b) {
		var g = this,
			a = g.items,
			f = g.keys,
			d = g.all,
			e, c;
		if (b < g.length && b >= 0) {
			e = a[b];
			c = f[b];
			if (typeof c != "undefined") {
				delete g.map[c]
			}
			Ext.Array.erase(a, b, 1);
			Ext.Array.erase(f, b, 1);
			Ext.Array.remove(d, e);
			delete g.indices[c];
			g.length--;
			this.dirtyIndices = true;
			return e
		}
		return false
	},
	removeAtKey: function (a) {
		return this.removeAt(this.indexOfKey(a))
	},
	getCount: function () {
		return this.length
	},
	indexOf: function (b) {
		if (this.dirtyIndices) {
			this.updateIndices()
		}
		var a = this.indices[this.getKey(b)];
		return (a === undefined) ? -1 : a
	},
	indexOfKey: function (b) {
		if (this.dirtyIndices) {
			this.updateIndices()
		}
		var a = this.indices[b];
		return (a === undefined) ? -1 : a
	},
	updateIndices: function () {
		var a = this.items,
			e = a.length,
			f = this.indices = {},
			c, d, b;
		for (c = 0; c < e; c++) {
			d = a[c];
			b = this.getKey(d);
			f[b] = c
		}
		this.dirtyIndices = false
	},
	get: function (b) {
		var d = this,
			a = d.map[b],
			c;
		if (a !== undefined) {
			c = a
		} else {
			if (typeof b == "number") {
				c = d.items[b]
			}
		}
		return typeof c != "function" || d.getAllowFunctions() ? c : null
	},
	getAt: function (a) {
		return this.items[a]
	},
	getByKey: function (a) {
		return this.map[a]
	},
	contains: function (b) {
		var a = this.getKey(b);
		if (a) {
			return this.containsKey(a)
		} else {
			return Ext.Array.contains(this.items, b)
		}
	},
	containsKey: function (a) {
		return typeof this.map[a] != "undefined"
	},
	clear: function () {
		var a = this;
		a.length = 0;
		a.items.length = 0;
		a.keys.length = 0;
		a.all.length = 0;
		a.dirtyIndices = true;
		a.indices = {};
		a.map = {}
	},
	first: function () {
		return this.items[0]
	},
	last: function () {
		return this.items[this.length - 1]
	},
	getRange: function (f, a) {
		var e = this,
			c = e.items,
			b = [],
			d;
		if (c.length < 1) {
			return b
		}
		f = f || 0;
		a = Math.min(typeof a == "undefined" ? e.length - 1 : a, e.length - 1);
		if (f <= a) {
			for (d = f; d <= a; d++) {
				b[b.length] = c[d]
			}
		} else {
			for (d = f; d >= a; d--) {
				b[b.length] = c[d]
			}
		}
		return b
	},
	findIndexBy: function (d, c, h) {
		var g = this,
			f = g.keys,
			a = g.items,
			b = h || 0,
			e = a.length;
		for (; b < e; b++) {
			if (d.call(c || g, a[b], f[b])) {
				return b
			}
		}
		return -1
	},
	clone: function () {
		var e = this,
			f = new this.self(),
			d = e.keys,
			a = e.items,
			b = 0,
			c = a.length;
		for (; b < c; b++) {
			f.add(d[b], a[b])
		}
		f.getKey = e.getKey;
		return f
	},
	destroy: function () {
		this.callSuper();
		this.clear()
	}
});
Ext.define("Ext.data.Operation", {
	config: {
		synchronous: true,
		action: null,
		filters: null,
		sorters: null,
		grouper: null,
		start: null,
		limit: null,
		batch: null,
		callback: null,
		scope: null,
		resultSet: null,
		records: null,
		request: null,
		response: null,
		withCredentials: null,
		params: null,
		url: null,
		page: null,
		node: null,
		model: undefined,
		addRecords: false
	},
	started: false,
	running: false,
	complete: false,
	success: undefined,
	exception: false,
	error: undefined,
	constructor: function (a) {
		this.initConfig(a)
	},
	applyModel: function (a) {
		if (typeof a == "string") {
			a = Ext.data.ModelManager.getModel(a);
			if (!a) {
				Ext.Logger.error("Model with name " + arguments[0] + " doesnt exist.")
			}
		}
		if (a && !a.prototype.isModel && Ext.isObject(a)) {
			a = Ext.data.ModelManager.registerType(a.storeId || a.id || Ext.id(), a)
		}
		return a
	},
	getRecords: function () {
		var a = this.getResultSet();
		return this._records || (a ? a.getRecords() : [])
	},
	setStarted: function () {
		this.started = true;
		this.running = true
	},
	setCompleted: function () {
		this.complete = true;
		this.running = false
	},
	setSuccessful: function () {
		this.success = true
	},
	setException: function (a) {
		this.exception = true;
		this.success = false;
		this.running = false;
		this.error = a
	},
	hasException: function () {
		return this.exception === true
	},
	getError: function () {
		return this.error
	},
	isStarted: function () {
		return this.started === true
	},
	isRunning: function () {
		return this.running === true
	},
	isComplete: function () {
		return this.complete === true
	},
	wasSuccessful: function () {
		return this.isComplete() && this.success === true
	},
	allowWrite: function () {
		return this.getAction() != "read"
	},
	process: function (d, b, c, a) {
		if (b.getSuccess() !== false) {
			this.setResponse(a);
			this.setResultSet(b);
			this.setCompleted();
			this.setSuccessful()
		} else {
			return false
		}
		return this["process" + Ext.String.capitalize(d)].call(this, b, c, a)
	},
	processRead: function (d) {
		var b = d.getRecords(),
			g = [],
			f = this.getModel(),
			e = b.length,
			c, a;
		for (c = 0; c < e; c++) {
			a = b[c];
			g.push(new f(a.data, a.id, a.node))
		}
		this.setRecords(g);
		d.setRecords(g);
		return true
	},
	processCreate: function (e) {
		var c = e.getRecords(),
			b = this.getRecords(),
			f = c.length,
			d, a, g;
		for (d = 0; d < f; d++) {
			g = c[d];
			if (g.clientId === null && b.length == 1 && c.length == 1) {
				a = b[d]
			} else {
				a = this.findCurrentRecord(g.clientId)
			}
			if (a) {
				this.updateRecord(a, g)
			}
		}
		return true
	},
	processUpdate: function (e) {
		var c = e.getRecords(),
			b = this.getRecords(),
			f = c.length,
			d, a, g;
		for (d = 0; d < f; d++) {
			g = c[d];
			a = b[d];
			if (a) {
				this.updateRecord(a, g)
			}
		}
		return true
	},
	processDestroy: function (d) {
		var b = d.getRecords(),
			e = b.length,
			c, a, f;
		for (c = 0; c < e; c++) {
			f = b[c];
			a = this.findCurrentRecord(f.id);
			if (a) {
				a.setIsErased(true);
				a.notifyStores("afterErase", a)
			}
		}
	},
	findCurrentRecord: function (a) {
		var c = this.getRecords(),
			e = c.length,
			d, b;
		for (d = 0; d < e; d++) {
			b = c[d];
			if (b.getId() === a) {
				return b
			}
		}
	},
	updateRecord: function (b, d) {
		var a = d.data,
			c = d.id;
		b.beginEdit();
		b.set(a);
		if (c !== null) {
			b.setId(c)
		}
		b.endEdit(true);
		b.commit()
	}
});
Ext.define("Ext.data.ResultSet", {
	config: {
		loaded: true,
		count: null,
		total: null,
		success: false,
		records: null,
		message: null
	},
	constructor: function (a) {
		this.initConfig(a)
	},
	applyCount: function (a) {
		if (!a && a !== 0) {
			return this.getRecords().length
		}
		return a
	},
	updateRecords: function (a) {
		this.setCount(a.length)
	}
});
Ext.define("Ext.data.reader.Reader", {
	alternateClassName: ["Ext.data.Reader", "Ext.data.DataReader"],
	mixins: [Ext.mixin.Observable],
	isReader: true,
	config: {
		idProperty: undefined,
		clientIdProperty: "clientId",
		totalProperty: "total",
		successProperty: "success",
		messageProperty: null,
		rootProperty: "",
		implicitIncludes: true,
		model: undefined
	},
	constructor: function (a) {
		this.initConfig(a)
	},
	fieldCount: 0,
	applyModel: function (a) {
		if (typeof a == "string") {
			a = Ext.data.ModelManager.getModel(a);
			if (!a) {
				Ext.Logger.error("Model with name " + arguments[0] + " doesnt exist.")
			}
		}
		if (a && !a.prototype.isModel && Ext.isObject(a)) {
			a = Ext.data.ModelManager.registerType(a.storeId || a.id || Ext.id(), a)
		}
		return a
	},
	applyIdProperty: function (a) {
		if (!a && this.getModel()) {
			a = this.getModel().getIdProperty()
		}
		return a
	},
	updateModel: function (a) {
		if (a) {
			if (!this.getIdProperty()) {
				this.setIdProperty(a.getIdProperty())
			}
			this.buildExtractors()
		}
	},
	createAccessor: Ext.emptyFn,
	createFieldAccessExpression: function () {
		return "undefined"
	},
	buildExtractors: function () {
		if (!this.getModel()) {
			return
		}
		var b = this,
			c = b.getTotalProperty(),
			a = b.getSuccessProperty(),
			d = b.getMessageProperty();
		if (c) {
			b.getTotal = b.createAccessor(c)
		}
		if (a) {
			b.getSuccess = b.createAccessor(a)
		}
		if (d) {
			b.getMessage = b.createAccessor(d)
		}
		b.extractRecordData = b.buildRecordDataExtractor()
	},
	buildRecordDataExtractor: function () {
		var k = this,
			e = k.getModel(),
			g = e.getFields(),
			j = g.length,
			a = [],
			h = k.getModel().getClientIdProperty(),
			f = "__field",
			b = ["var me = this,\n", "    fields = me.getModel().getFields(),\n", "    idProperty = me.getIdProperty(),\n", '    idPropertyIsFn = (typeof idProperty == "function"),', "    value,\n", "    internalId"],
			d, l, c, m;
		g = g.items;
		for (d = 0; d < j; d++) {
			l = g[d];
			m = l.getName();
			if (m === e.getIdProperty()) {
				a[d] = "idField"
			} else {
				a[d] = f + d
			}
			b.push(",\n    ", a[d], ' = fields.get("', l.getName(), '")')
		}
		b.push(";\n\n    return function(source) {\n        var dest = {};\n");
		b.push("        if (idPropertyIsFn) {\n");
		b.push("            idField.setMapping(idProperty);\n");
		b.push("        }\n");
		for (d = 0; d < j; d++) {
			l = g[d];
			c = a[d];
			m = l.getName();
			if (m === e.getIdProperty() && l.getMapping() === null && e.getIdProperty() !== this.getIdProperty()) {
				l.setMapping(this.getIdProperty())
			}
			b.push("        try {\n");
			b.push("            value = ", k.createFieldAccessExpression(l, c, "source"), ";\n");
			b.push("            if (value !== undefined) {\n");
			b.push('                dest["' + l.getName() + '"] = value;\n');
			b.push("            }\n");
			b.push("        } catch(e){}\n")
		}
		if (h) {
			b.push("        internalId = " + k.createFieldAccessExpression(Ext.create("Ext.data.Field", {
				name: h
			}), null, "source") + ";\n");
			b.push("        if (internalId !== undefined) {\n");
			b.push('            dest["_clientId"] = internalId;\n        }\n')
		}
		b.push("        return dest;\n");
		b.push("    };");
		return Ext.functionFactory(b.join("")).call(k)
	},
	getFields: function () {
		return this.getModel().getFields().items
	},
	getData: function (a) {
		return a
	},
	getResponseData: function (a) {
		return a
	},
	getRoot: function (a) {
		return a
	},
	read: function (c) {
		var g = c,
			h = this.getModel(),
			e, b, d, f, a;
		if (c) {
			g = this.getResponseData(c)
		}
		if (g) {
			e = this.readRecords(g);
			b = e.getRecords();
			for (d = 0, f = b.length; d < f; d++) {
				a = b[d];
				b[d] = new h(a.data, a.id, a.node)
			}
			return e
		} else {
			return this.nullResultSet
		}
	},
	process: function (a) {
		var b = a;
		if (a) {
			b = this.getResponseData(a)
		}
		if (b) {
			return this.readRecords(b)
		} else {
			return this.nullResultSet
		}
	},
	readRecords: function (c) {
		var e = this;
		e.rawData = c;
		c = e.getData(c);
		if (c.metaData) {
			e.onMetaChange(c.metaData)
		}
		var d = Ext.isArray(c),
			g = d ? c : e.getRoot(c),
			j = true,
			b = 0,
			f, h, a, k;
		if (d && !c.length) {
			return e.nullResultSet
		}
		if (e.getTotal) {
			h = parseInt(e.getTotal(c), 10);
			if (!isNaN(h)) {
				f = h
			}
		}
		if (e.getSuccess) {
			h = e.getSuccess(c);
			if (h === false || h === "false") {
				j = false
			}
		}
		if (e.getMessage) {
			k = e.getMessage(c)
		}
		if (g) {
			a = e.extractData(g);
			b = a.length
		} else {
			b = 0;
			a = []
		}
		return new Ext.data.ResultSet({
			total: f,
			count: b,
			records: a,
			success: j,
			message: k
		})
	},
	extractData: function (l) {
		var j = this,
			e = [],
			c = l.length,
			h = j.getModel(),
			m = h.getIdProperty(),
			k = h.getFields(),
			d, g, f, b, a;
		if (k.isDirty) {
			j.buildExtractors(true);
			delete k.isDirty
		}
		if (!l.length && Ext.isObject(l)) {
			l = [l];
			c = 1
		}
		for (g = 0; g < c; g++) {
			a = null;
			b = null;
			d = l[g];
			if (d.isModel) {
				f = d.data
			} else {
				f = j.extractRecordData(d)
			}
			if (f._clientId !== undefined) {
				a = f._clientId;
				delete f._clientId
			}
			if (f[m] !== undefined) {
				b = f[m]
			}
			if (j.getImplicitIncludes()) {
				j.readAssociated(f, d)
			}
			e.push({
				clientId: a,
				id: b,
				data: f,
				node: d
			})
		}
		return e
	},
	readAssociated: function (b, h) {
		var f = this.getModel().associations.items,
			g = f.length,
			e = 0,
			a, d, c;
		for (; e < g; e++) {
			a = f[e];
			c = a.getAssociationKey();
			d = this.getAssociatedDataRoot(h, c);
			if (d) {
				b[c] = d
			}
		}
	},
	getAssociatedDataRoot: function (d, a) {
		var c = /[\[\.]/,
			b = String(a).search(c);
		if (b >= 0) {
			return Ext.functionFactory("obj", "return obj" + (b > 0 ? "." : "") + a)(d)
		}
		return d[a]
	},
	onMetaChange: function (f) {
		var a = f.fields,
			e = this,
			d, c, b;
		e.metaData = f;
		if (f.rootProperty !== undefined) {
			e.setRootProperty(f.rootProperty)
		} else {
			if (f.root !== undefined) {
				e.setRootProperty(f.root)
			}
		}
		if (f.idProperty !== undefined) {
			e.setIdProperty(f.idProperty)
		}
		if (f.totalProperty !== undefined) {
			e.setTotalProperty(f.totalProperty)
		}
		if (f.successProperty !== undefined) {
			e.setSuccessProperty(f.successProperty)
		}
		if (f.messageProperty !== undefined) {
			e.setMessageProperty(f.messageProperty)
		}
		if (a) {
			if (e.getModel()) {
				e.getModel().setFields(a);
				e.buildExtractors()
			} else {
				b = e.getIdProperty();
				c = {
					fields: a
				};
				if (b) {
					c.idProperty = b
				}
				d = Ext.define("Ext.data.reader.MetaModel" + Ext.id(), {
					extend: "Ext.data.Model",
					config: c
				});
				e.setModel(d)
			}
		} else {
			e.buildExtractors()
		}
	}
}, function () {
	Ext.apply(this.prototype, {
		nullResultSet: new Ext.data.ResultSet({
			total: 0,
			count: 0,
			records: [],
			success: false
		})
	})
});
Ext.define("Ext.data.reader.Json", {
	extend: Ext.data.reader.Reader,
	alternateClassName: "Ext.data.JsonReader",
	alias: "reader.json",
	config: {
		record: null,
		useSimpleAccessors: false
	},
	objectRe: /[\[\.]/,
	getResponseData: function (a) {
		var d = a;
		if (a && a.responseText) {
			d = a.responseText
		}
		if (typeof d !== "string") {
			return d
		}
		var c;
		try {
			c = Ext.decode(d)
		} catch (b) {
			this.fireEvent("exception", this, a, "Unable to parse the JSON returned by the server: " + b.toString());
			Ext.Logger.warn("Unable to parse the JSON returned by the server: " + b.toString())
		}
		return c
	},
	buildExtractors: function () {
		var b = this,
			a = b.getRootProperty();
		b.callParent(arguments);
		if (a) {
			b.rootAccessor = b.createAccessor(a)
		} else {
			delete b.rootAccessor
		}
	},
	getRoot: function (b) {
		var a = this.getModel().getFields();
		if (a.isDirty) {
			this.buildExtractors(true);
			delete a.isDirty
		}
		if (this.rootAccessor) {
			return this.rootAccessor.call(this, b)
		} else {
			return b
		}
	},
	extractData: function (a) {
		var e = this.getRecord(),
			d = [],
			c, b;
		if (e) {
			c = a.length;
			if (!c && Ext.isObject(a)) {
				c = 1;
				a = [a]
			}
			for (b = 0; b < c; b++) {
				d[b] = a[b][e]
			}
		} else {
			d = a
		}
		return this.callParent([d])
	},
	createAccessor: function () {
		var a = /[\[\.]/;
		return function (c) {
			if (Ext.isEmpty(c)) {
				return Ext.emptyFn
			}
			if (Ext.isFunction(c)) {
				return c
			}
			if (this.getUseSimpleAccessors() !== true) {
				var b = String(c).search(a);
				if (b >= 0) {
					return Ext.functionFactory("obj", "var value; try {value = obj" + (b > 0 ? "." : "") + c + "} catch(e) {}; return value;")
				}
			}
			return function (d) {
				return d[c]
			}
		}
	}(),
	createFieldAccessExpression: function (g, b, c) {
		var f = this,
			h = f.objectRe,
			e = (g.getMapping() !== null),
			a = e ? g.getMapping() : g.getName(),
			j, d;
		if (typeof a === "function") {
			j = b + ".getMapping()(" + c + ", this)"
		} else {
			if (f.getUseSimpleAccessors() === true || ((d = String(a).search(h)) < 0)) {
				if (!e || isNaN(a)) {
					a = '"' + a + '"'
				}
				j = c + "[" + a + "]"
			} else {
				j = c + (d > 0 ? "." : "") + a
			}
		}
		return j
	}
});
Ext.define("Ext.data.writer.Writer", {
	alias: "writer.base",
	alternateClassName: ["Ext.data.DataWriter", "Ext.data.Writer"],
	config: {
		writeAllFields: true,
		nameProperty: "name"
	},
	constructor: function (a) {
		this.initConfig(a)
	},
	write: function (e) {
		var c = e.getOperation(),
			b = c.getRecords() || [],
			a = b.length,
			d = 0,
			f = [];
		for (; d < a; d++) {
			f.push(this.getRecordData(b[d]))
		}
		return this.writeRecords(e, f)
	},
	writeDate: function (c, b) {
		if (!b) {
			return null
		}
		var a = c.getDateFormat() || "timestamp";
		switch (a) {
		case "timestamp":
			return b.getTime() / 1000;
		case "time":
			return b.getTime();
		default:
			return Ext.Date.format(b, a)
		}
	},
	getRecordData: function (e) {
		var k = e.phantom === true,
			b = this.getWriteAllFields() || k,
			c = this.getNameProperty(),
			f = e.getFields(),
			d = {},
			h, a, g, l, j;
		if (b) {
			f.each(function (m) {
				if (m.getPersist()) {
					a = m.config[c] || m.getName();
					j = e.get(m.getName());
					if (m.getType().type == "date") {
						j = this.writeDate(m, j)
					}
					d[a] = j
				}
			}, this)
		} else {
			h = e.getChanges();
			for (l in h) {
				if (h.hasOwnProperty(l)) {
					g = f.get(l);
					if (g.getPersist()) {
						a = g.config[c] || g.getName();
						j = h[l];
						if (g.getType().type == "date") {
							j = this.writeDate(g, j)
						}
						d[a] = j
					}
				}
			}
			if (!k) {
				d[e.getIdProperty()] = e.getId()
			}
		}
		return d
	}
});
Ext.define("Ext.data.writer.Json", {
	extend: Ext.data.writer.Writer,
	alternateClassName: "Ext.data.JsonWriter",
	alias: "writer.json",
	config: {
		rootProperty: undefined,
		encode: false,
		allowSingle: true,
		encodeRequest: false
	},
	applyRootProperty: function (a) {
		if (!a && (this.getEncode() || this.getEncodeRequest())) {
			a = "data"
		}
		return a
	},
	writeRecords: function (d, e) {
		var a = this.getRootProperty(),
			f = d.getParams(),
			b = this.getAllowSingle(),
			c;
		if (this.getAllowSingle() && e && e.length == 1) {
			e = e[0]
		}
		if (this.getEncodeRequest()) {
			c = d.getJsonData() || {};
			if (e && (e.length || (b && Ext.isObject(e)))) {
				c[a] = e
			}
			d.setJsonData(Ext.apply(c, f || {}));
			d.setParams(null);
			d.setMethod("POST");
			return d
		}
		if (!e || !(e.length || (b && Ext.isObject(e)))) {
			return d
		}
		if (this.getEncode()) {
			if (a) {
				f[a] = Ext.encode(e)
			} else {}
		} else {
			c = d.getJsonData() || {};
			if (a) {
				c[a] = e
			} else {
				c = e
			}
			d.setJsonData(c)
		}
		return d
	}
});
Ext.define("Ext.data.Batch", {
	mixins: {
		observable: Ext.mixin.Observable
	},
	config: {
		autoStart: false,
		pauseOnException: true,
		proxy: null
	},
	current: -1,
	total: 0,
	isRunning: false,
	isComplete: false,
	hasException: false,
	constructor: function (a) {
		var b = this;
		b.initConfig(a);
		b.operations = []
	},
	add: function (a) {
		this.total++;
		a.setBatch(this);
		this.operations.push(a)
	},
	start: function () {
		this.hasException = false;
		this.isRunning = true;
		this.runNextOperation()
	},
	runNextOperation: function () {
		this.runOperation(this.current + 1)
	},
	pause: function () {
		this.isRunning = false
	},
	runOperation: function (d) {
		var e = this,
			c = e.operations,
			b = c[d],
			a;
		if (b === undefined) {
			e.isRunning = false;
			e.isComplete = true;
			e.fireEvent("complete", e, c[c.length - 1])
		} else {
			e.current = d;
			a = function (f) {
				var g = f.hasException();
				if (g) {
					e.hasException = true;
					e.fireEvent("exception", e, f)
				} else {
					e.fireEvent("operationcomplete", e, f)
				}
				if (g && e.getPauseOnException()) {
					e.pause()
				} else {
					f.setCompleted();
					e.runNextOperation()
				}
			};
			b.setStarted();
			e.getProxy()[b.getAction()](b, a, e)
		}
	}
});
Ext.define("Ext.data.proxy.Proxy", {
	extend: Ext.Evented,
	alias: "proxy.proxy",
	alternateClassName: ["Ext.data.DataProxy", "Ext.data.Proxy"],
	config: {
		batchOrder: "create,update,destroy",
		batchActions: true,
		model: null,
		reader: {
			type: "json"
		},
		writer: {
			type: "json"
		}
	},
	isProxy: true,
	applyModel: function (a) {
		if (typeof a == "string") {
			a = Ext.data.ModelManager.getModel(a);
			if (!a) {
				Ext.Logger.error("Model with name " + arguments[0] + " doesnt exist.")
			}
		}
		if (a && !a.prototype.isModel && Ext.isObject(a)) {
			a = Ext.data.ModelManager.registerType(a.storeId || a.id || Ext.id(), a)
		}
		return a
	},
	updateModel: function (b) {
		if (b) {
			var a = this.getReader();
			if (a && !a.getModel()) {
				a.setModel(b)
			}
		}
	},
	applyReader: function (b, a) {
		return Ext.factory(b, Ext.data.Reader, a, "reader")
	},
	updateReader: function (a) {
		if (a) {
			var b = this.getModel();
			if (!b) {
				b = a.getModel();
				if (b) {
					this.setModel(b)
				}
			} else {
				a.setModel(b)
			}
			if (a.onMetaChange) {
				a.onMetaChange = Ext.Function.createSequence(a.onMetaChange, this.onMetaChange, this)
			}
		}
	},
	onMetaChange: function (b) {
		var a = this.getReader().getModel();
		if (!this.getModel() && a) {
			this.setModel(a)
		}
		this.fireEvent("metachange", this, b)
	},
	applyWriter: function (b, a) {
		return Ext.factory(b, Ext.data.Writer, a, "writer")
	},
	create: Ext.emptyFn,
	read: Ext.emptyFn,
	update: Ext.emptyFn,
	destroy: Ext.emptyFn,
	onDestroy: function () {
		Ext.destroy(this.getReader(), this.getWriter());
		Ext.Evented.prototype.destroy.apply(this, arguments)
	},
	batch: function (e, f) {
		var g = this,
			d = g.getBatchActions(),
			c = g.getModel(),
			b, a;
		if (e.operations === undefined) {
			e = {
				operations: e,
				listeners: f
			}
		}
		if (e.batch && e.batch.isBatch) {
			b = e.batch
		} else {
			b = new Ext.data.Batch(e.batch || {})
		}
		b.setProxy(g);
		b.on("complete", Ext.bind(g.onBatchComplete, g, [e], 0));
		if (e.listeners) {
			b.on(e.listeners)
		}
		Ext.each(g.getBatchOrder().split(","), function (h) {
			a = e.operations[h];
			if (a) {
				if (d) {
					b.add(new Ext.data.Operation({
						action: h,
						records: a,
						model: c
					}))
				} else {
					Ext.each(a, function (j) {
						b.add(new Ext.data.Operation({
							action: h,
							records: [j],
							model: c
						}))
					})
				}
			}
		}, g);
		b.start();
		return b
	},
	onBatchComplete: function (a, b) {
		var c = a.scope || this;
		if (b.hasException) {
			if (Ext.isFunction(a.failure)) {
				Ext.callback(a.failure, c, [b, a])
			}
		} else {
			if (Ext.isFunction(a.success)) {
				Ext.callback(a.success, c, [b, a])
			}
		}
		if (Ext.isFunction(a.callback)) {
			Ext.callback(a.callback, c, [b, a])
		}
		Ext.destroy(b)
	}
}, function () {});
Ext.define("Ext.data.proxy.Client", {
	extend: Ext.data.proxy.Proxy,
	alternateClassName: "Ext.proxy.ClientProxy",
	clear: function () {}
});
Ext.define("Ext.data.proxy.Memory", {
	extend: Ext.data.proxy.Client,
	alias: "proxy.memory",
	alternateClassName: "Ext.data.MemoryProxy",
	isMemoryProxy: true,
	config: {
		data: []
	},
	finishOperation: function (b, f, d) {
		if (b) {
			var c = 0,
				e = b.getRecords(),
				a = e.length;
			for (c; c < a; c++) {
				e[c].commit()
			}
			b.setCompleted();
			b.setSuccessful();
			Ext.callback(f, d || this, [b])
		}
	},
	create: function () {
		this.finishOperation.apply(this, arguments)
	},
	update: function () {
		this.finishOperation.apply(this, arguments)
	},
	destroy: function () {
		this.finishOperation.apply(this, arguments)
	},
	read: function (b, e, c) {
		var d = this,
			a = d.getReader();
		if (b.process("read", a.process(d.getData())) === false) {
			this.fireEvent("exception", this, null, b)
		}
		Ext.callback(e, c || d, [b])
	},
	clear: Ext.emptyFn
});
Ext.define("Ext.data.SortTypes", {
	singleton: true,
	stripTagsRE: /<\/?[^>]+>/gi,
	none: function (a) {
		return a
	},
	asText: function (a) {
		return String(a).replace(this.stripTagsRE, "")
	},
	asUCText: function (a) {
		return String(a).toUpperCase().replace(this.stripTagsRE, "")
	},
	asUCString: function (a) {
		return String(a).toUpperCase()
	},
	asDate: function (a) {
		if (!a) {
			return 0
		}
		if (Ext.isDate(a)) {
			return a.getTime()
		}
		return Date.parse(String(a))
	},
	asFloat: function (a) {
		a = parseFloat(String(a).replace(/,/g, ""));
		return isNaN(a) ? 0 : a
	},
	asInt: function (a) {
		a = parseInt(String(a).replace(/,/g, ""), 10);
		return isNaN(a) ? 0 : a
	}
});
Ext.define("Ext.data.Types", {
	singleton: true,
	stripRe: /[\$,%]/g,
	dashesRe: /-/g,
	iso8601TestRe: /\d\dT\d\d/,
	iso8601SplitRe: /[- :T\.Z\+]/
}, function () {
	var b = this,
		a = Ext.data.SortTypes;
	Ext.apply(b, {
		AUTO: {
			convert: function (c) {
				return c
			},
			sortType: a.none,
			type: "auto"
		},
		STRING: {
			convert: function (c) {
				return (c === undefined || c === null) ? (this.getAllowNull() ? null : "") : String(c)
			},
			sortType: a.asUCString,
			type: "string"
		},
		INT: {
			convert: function (c) {
				return (c !== undefined && c !== null && c !== "") ? ((typeof c === "number") ? parseInt(c, 10) : parseInt(String(c).replace(b.stripRe, ""), 10)) : (this.getAllowNull() ? null : 0)
			},
			sortType: a.none,
			type: "int"
		},
		FLOAT: {
			convert: function (c) {
				return (c !== undefined && c !== null && c !== "") ? ((typeof c === "number") ? c : parseFloat(String(c).replace(b.stripRe, ""), 10)) : (this.getAllowNull() ? null : 0)
			},
			sortType: a.none,
			type: "float"
		},
		BOOL: {
			convert: function (c) {
				if ((c === undefined || c === null || c === "") && this.getAllowNull()) {
					return null
				}
				return c !== "false" && c !== "0" && !! c
			},
			sortType: a.none,
			type: "bool"
		},
		DATE: {
			convert: function (e) {
				var c = this.getDateFormat(),
					d;
				if (!e) {
					return null
				}
				if (Ext.isDate(e)) {
					return e
				}
				if (c) {
					if (c == "timestamp") {
						return new Date(e * 1000)
					}
					if (c == "time") {
						return new Date(parseInt(e, 10))
					}
					return Ext.Date.parse(e, c)
				}
				d = new Date(Date.parse(e));
				if (isNaN(d)) {
					if (b.iso8601TestRe.test(e)) {
						d = e.split(b.iso8601SplitRe);
						d = new Date(d[0], d[1] - 1, d[2], d[3], d[4], d[5])
					}
					if (isNaN(d)) {
						d = new Date(Date.parse(e.replace(b.dashesRe, "/")))
					}
				}
				return isNaN(d) ? null : d
			},
			sortType: a.asDate,
			type: "date"
		}
	});
	Ext.apply(b, {
		BOOLEAN: this.BOOL,
		INTEGER: this.INT,
		NUMBER: this.FLOAT
	})
});
Ext.define("Ext.data.Field", {
	alias: "data.field",
	isField: true,
	config: {
		name: null,
		type: "auto",
		convert: undefined,
		dateFormat: null,
		allowNull: true,
		defaultValue: undefined,
		mapping: null,
		sortType: undefined,
		sortDir: "ASC",
		allowBlank: true,
		persist: true,
		encode: null,
		decode: null,
		bubbleEvents: "action"
	},
	constructor: function (a) {
		if (Ext.isString(a)) {
			a = {
				name: a
			}
		}
		this.initConfig(a)
	},
	applyType: function (c) {
		var b = Ext.data.Types,
			a = b.AUTO;
		if (c) {
			if (Ext.isString(c)) {
				return b[c.toUpperCase()] || a
			} else {
				return c
			}
		}
		return a
	},
	updateType: function (a, b) {
		var c = this.getConvert();
		if (b && c === b.convert) {
			this.setConvert(a.convert)
		}
	},
	applySortType: function (d) {
		var c = Ext.data.SortTypes,
			a = this.getType(),
			b = a.sortType;
		if (d) {
			if (Ext.isString(d)) {
				return c[d] || b
			} else {
				return d
			}
		}
		return b
	},
	applyConvert: function (b) {
		var a = this.getType().convert;
		if (b && b !== a) {
			this._hasCustomConvert = true;
			return b
		} else {
			this._hasCustomConvert = false;
			return a
		}
	},
	hasCustomConvert: function () {
		return this._hasCustomConvert
	}
});
Ext.define("Ext.data.identifier.Simple", {
	alias: "data.identifier.simple",
	statics: {
		AUTO_ID: 1
	},
	config: {
		prefix: "ext-record-"
	},
	constructor: function (a) {
		this.initConfig(a)
	},
	generate: function (a) {
		return this._prefix + this.self.AUTO_ID++
	}
});
Ext.define("Ext.data.ModelManager", {
	extend: Ext.AbstractManager,
	alternateClassName: ["Ext.ModelMgr", "Ext.ModelManager"],
	singleton: true,
	modelNamespace: null,
	registerType: function (c, b) {
		var d = b.prototype,
			a;
		if (d && d.isModel) {
			a = b
		} else {
			b = {
				extend: b.extend || "Ext.data.Model",
				config: b
			};
			a = Ext.define(c, b)
		}
		this.types[c] = a;
		return a
	},
	onModelDefined: Ext.emptyFn,
	getModel: function (b) {
		var a = b;
		if (typeof a == "string") {
			a = this.types[a];
			if (!a && this.modelNamespace) {
				a = this.types[this.modelNamespace + "." + a]
			}
		}
		return a
	},
	create: function (c, b, d) {
		var a = typeof b == "function" ? b : this.types[b || c.name];
		return new a(c, d)
	}
}, function () {
	Ext.regModel = function () {
		return this.ModelManager.registerType.apply(this.ModelManager, arguments)
	}
});
Ext.define("Ext.data.Request", {
	config: {
		action: null,
		params: null,
		method: "GET",
		url: null,
		operation: null,
		proxy: null,
		disableCaching: false,
		headers: {},
		callbackKey: null,
		jsonP: null,
		jsonData: null,
		xmlData: null,
		withCredentials: null,
		username: null,
		password: null,
		callback: null,
		scope: null,
		timeout: 30000,
		records: null,
		directFn: null,
		args: null
	},
	constructor: function (a) {
		this.initConfig(a)
	}
});
Ext.define("Ext.data.proxy.Server", {
	extend: Ext.data.proxy.Proxy,
	alias: "proxy.server",
	alternateClassName: "Ext.data.ServerProxy",
	config: {
		url: null,
		pageParam: "page",
		startParam: "start",
		limitParam: "limit",
		groupParam: "group",
		sortParam: "sort",
		filterParam: "filter",
		directionParam: "dir",
		enablePagingParams: true,
		simpleSortMode: false,
		noCache: true,
		cacheString: "_dc",
		timeout: 30000,
		api: {
			create: undefined,
			read: undefined,
			update: undefined,
			destroy: undefined
		},
		extraParams: {}
	},
	constructor: function (a) {
		a = a || {};
		if (a.nocache !== undefined) {
			a.noCache = a.nocache
		}
		this.callParent([a])
	},
	create: function () {
		return this.doRequest.apply(this, arguments)
	},
	read: function () {
		return this.doRequest.apply(this, arguments)
	},
	update: function () {
		return this.doRequest.apply(this, arguments)
	},
	destroy: function () {
		return this.doRequest.apply(this, arguments)
	},
	setExtraParam: function (a, b) {
		this.getExtraParams()[a] = b
	},
	buildRequest: function (a) {
		var c = this,
			d = Ext.applyIf(a.getParams() || {}, c.getExtraParams() || {}),
			b;
		d = Ext.applyIf(d, c.getParams(a));
		b = Ext.create("Ext.data.Request", {
			params: d,
			action: a.getAction(),
			records: a.getRecords(),
			url: a.getUrl(),
			operation: a,
			proxy: c
		});
		b.setUrl(c.buildUrl(b));
		a.setRequest(b);
		return b
	},
	processResponse: function (l, b, d, c, k, m) {
		var h = this,
			a = b.getAction(),
			f, j;
		if (l === true) {
			f = h.getReader();
			try {
				j = f.process(h.getResponseResult(c))
			} catch (g) {
				b.setException(g.message);
				h.fireEvent("exception", h, c, b);
				return
			}
			if (!b.getModel()) {
				b.setModel(this.getModel())
			}
			if (b.process(a, j, d, c) === false) {
				h.fireEvent("exception", h, c, b)
			}
		} else {
			h.setException(b, c);
			h.fireEvent("exception", this, c, b)
		}
		if (typeof k == "function") {
			k.call(m || h, b)
		}
		h.afterRequest(d, l)
	},
	getResponseResult: function (a) {
		return a
	},
	setException: function (b, a) {
		if (Ext.isObject(a)) {
			b.setException({
				status: a.status,
				statusText: a.statusText
			})
		}
	},
	applyEncoding: function (a) {
		return Ext.encode(a)
	},
	encodeSorters: function (d) {
		var b = [],
			c = d.length,
			a = 0;
		for (; a < c; a++) {
			b[a] = {
				property: d[a].getProperty(),
				direction: d[a].getDirection()
			}
		}
		return this.applyEncoding(b)
	},
	encodeFilters: function (d) {
		var b = [],
			c = d.length,
			a = 0;
		for (; a < c; a++) {
			b[a] = {
				property: d[a].getProperty(),
				value: d[a].getValue()
			}
		}
		return this.applyEncoding(b)
	},
	getParams: function (j) {
		var o = this,
			h = {},
			a = j.getGrouper(),
			n = j.getSorters(),
			f = j.getFilters(),
			m = j.getPage(),
			d = j.getStart(),
			g = j.getLimit(),
			p = o.getSimpleSortMode(),
			r = o.getPageParam(),
			l = o.getStartParam(),
			q = o.getLimitParam(),
			k = o.getGroupParam(),
			e = o.getSortParam(),
			c = o.getFilterParam(),
			b = o.getDirectionParam();
		if (o.getEnablePagingParams()) {
			if (r && m !== null) {
				h[r] = m
			}
			if (l && d !== null) {
				h[l] = d
			}
			if (q && g !== null) {
				h[q] = g
			}
		}
		if (k && a) {
			h[k] = o.encodeSorters([a])
		}
		if (e && n && n.length > 0) {
			if (p) {
				h[e] = n[0].getProperty();
				h[b] = n[0].getDirection()
			} else {
				h[e] = o.encodeSorters(n)
			}
		}
		if (c && f && f.length > 0) {
			h[c] = o.encodeFilters(f)
		}
		return h
	},
	buildUrl: function (c) {
		var b = this,
			a = b.getUrl(c);
		if (b.getNoCache()) {
			a = Ext.urlAppend(a, Ext.String.format("{0}={1}", b.getCacheString(), Ext.Date.now()))
		}
		return a
	},
	getUrl: function (a) {
		return a ? a.getUrl() || this.getApi()[a.getAction()] || this._url : this._url
	},
	doRequest: function () {},
	afterRequest: Ext.emptyFn
});
Ext.define("Ext.data.proxy.Ajax", {
	extend: Ext.data.proxy.Server,
	alias: "proxy.ajax",
	alternateClassName: ["Ext.data.HttpProxy", "Ext.data.AjaxProxy"],
	config: {
		withCredentials: false,
		useDefaultXhrHeader: true,
		username: null,
		password: null,
		actionMethods: {
			create: "POST",
			read: "GET",
			update: "POST",
			destroy: "POST"
		},
		headers: {}
	},
	doRequest: function (a, f, b) {
		var d = this,
			e = d.getWriter(),
			c = d.buildRequest(a);
		c.setConfig({
			headers: d.getHeaders(),
			timeout: d.getTimeout(),
			method: d.getMethod(c),
			callback: d.createRequestCallback(c, a, f, b),
			scope: d,
			proxy: d,
			useDefaultXhrHeader: d.getUseDefaultXhrHeader()
		});
		if (a.getWithCredentials() || d.getWithCredentials()) {
			c.setWithCredentials(true);
			c.setUsername(d.getUsername());
			c.setPassword(d.getPassword())
		}
		c = e.write(c);
		Ext.Ajax.request(c.getCurrentConfig());
		return c
	},
	getMethod: function (a) {
		return this.getActionMethods()[a.getAction()]
	},
	createRequestCallback: function (d, a, e, b) {
		var c = this;
		return function (g, h, f) {
			c.processResponse(h, a, d, f, e, b)
		}
	}
});
Ext.define("Ext.data.association.Association", {
	alternateClassName: "Ext.data.Association",
	config: {
		ownerModel: null,
		ownerName: undefined,
		associatedModel: null,
		associatedName: undefined,
		associationKey: undefined,
		primaryKey: "id",
		reader: null,
		type: null,
		name: undefined
	},
	statics: {
		create: function (a) {
			if (!a.isAssociation) {
				if (Ext.isString(a)) {
					a = {
						type: a
					}
				}
				a.type = a.type.toLowerCase();
				return Ext.factory(a, Ext.data.association.Association, null, "association")
			}
			return a
		}
	},
	constructor: function (a) {
		this.initConfig(a)
	},
	applyName: function (a) {
		if (!a) {
			a = this.getAssociatedName()
		}
		return a
	},
	applyOwnerModel: function (a) {
		var b = Ext.data.ModelManager.getModel(a);
		if (b === undefined) {
			Ext.Logger.error("The configured ownerModel was not valid (you tried " + a + ")")
		}
		return b
	},
	applyOwnerName: function (a) {
		if (!a) {
			a = this.getOwnerModel().modelName
		}
		a = a.slice(a.lastIndexOf(".") + 1);
		return a
	},
	updateOwnerModel: function (a, b) {
		if (b) {
			this.setOwnerName(a.modelName)
		}
	},
	applyAssociatedModel: function (a) {
		var b = Ext.data.ModelManager.types[a];
		if (b === undefined) {
			Ext.Logger.error("The configured associatedModel was not valid (you tried " + a + ")")
		}
		return b
	},
	applyAssociatedName: function (a) {
		if (!a) {
			a = this.getAssociatedModel().modelName
		}
		a = a.slice(a.lastIndexOf(".") + 1);
		return a
	},
	updateAssociatedModel: function (b, a) {
		if (a) {
			this.setAssociatedName(b.modelName)
		}
	},
	applyReader: function (a) {
		if (a) {
			if (Ext.isString(a)) {
				a = {
					type: a
				}
			}
			if (!a.isReader) {
				Ext.applyIf(a, {
					type: "json"
				})
			}
		}
		return Ext.factory(a, Ext.data.Reader, this.getReader(), "reader")
	},
	updateReader: function (a) {
		a.setModel(this.getAssociatedModel())
	}
});
Ext.define("Ext.util.Inflector", {
	singleton: true,
	plurals: [
		[(/(quiz)$/i), "$1zes"],
		[(/^(ox)$/i), "$1en"],
		[(/([m|l])ouse$/i), "$1ice"],
		[(/(matr|vert|ind)ix|ex$/i), "$1ices"],
		[(/(x|ch|ss|sh)$/i), "$1es"],
		[(/([^aeiouy]|qu)y$/i), "$1ies"],
		[(/(hive)$/i), "$1s"],
		[(/(?:([^f])fe|([lr])f)$/i), "$1$2ves"],
		[(/sis$/i), "ses"],
		[(/([ti])um$/i), "$1a"],
		[(/(buffal|tomat|potat)o$/i), "$1oes"],
		[(/(bu)s$/i), "$1ses"],
		[(/(alias|status|sex)$/i), "$1es"],
		[(/(octop|vir)us$/i), "$1i"],
		[(/(ax|test)is$/i), "$1es"],
		[(/^person$/), "people"],
		[(/^man$/), "men"],
		[(/^(child)$/), "$1ren"],
		[(/s$/i), "s"],
		[(/$/), "s"]
	],
	singulars: [
		[(/(quiz)zes$/i), "$1"],
		[(/(matr)ices$/i), "$1ix"],
		[(/(vert|ind)ices$/i), "$1ex"],
		[(/^(ox)en/i), "$1"],
		[(/(alias|status)es$/i), "$1"],
		[(/(octop|vir)i$/i), "$1us"],
		[(/(cris|ax|test)es$/i), "$1is"],
		[(/(shoe)s$/i), "$1"],
		[(/(o)es$/i), "$1"],
		[(/(bus)es$/i), "$1"],
		[(/([m|l])ice$/i), "$1ouse"],
		[(/(x|ch|ss|sh)es$/i), "$1"],
		[(/(m)ovies$/i), "$1ovie"],
		[(/(s)eries$/i), "$1eries"],
		[(/([^aeiouy]|qu)ies$/i), "$1y"],
		[(/([lr])ves$/i), "$1f"],
		[(/(tive)s$/i), "$1"],
		[(/(hive)s$/i), "$1"],
		[(/([^f])ves$/i), "$1fe"],
		[(/(^analy)ses$/i), "$1sis"],
		[(/((a)naly|(b)a|(d)iagno|(p)arenthe|(p)rogno|(s)ynop|(t)he)ses$/i), "$1$2sis"],
		[(/([ti])a$/i), "$1um"],
		[(/(n)ews$/i), "$1ews"],
		[(/people$/i), "person"],
		[(/s$/i), ""]
	],
	uncountable: ["sheep", "fish", "series", "species", "money", "rice", "information", "equipment", "grass", "mud", "offspring", "deer", "means"],
	singular: function (b, a) {
		this.singulars.unshift([b, a])
	},
	plural: function (b, a) {
		this.plurals.unshift([b, a])
	},
	clearSingulars: function () {
		this.singulars = []
	},
	clearPlurals: function () {
		this.plurals = []
	},
	isTransnumeral: function (a) {
		return Ext.Array.indexOf(this.uncountable, a) != -1
	},
	pluralize: function (f) {
		if (this.isTransnumeral(f)) {
			return f
		}
		var e = this.plurals,
			d = e.length,
			a, c, b;
		for (b = 0; b < d; b++) {
			a = e[b];
			c = a[0];
			if (c == f || (c.test && c.test(f))) {
				return f.replace(c, a[1])
			}
		}
		return f
	},
	singularize: function (f) {
		if (this.isTransnumeral(f)) {
			return f
		}
		var e = this.singulars,
			d = e.length,
			a, c, b;
		for (b = 0; b < d; b++) {
			a = e[b];
			c = a[0];
			if (c == f || (c.test && c.test(f))) {
				return f.replace(c, a[1])
			}
		}
		return f
	},
	classify: function (a) {
		return Ext.String.capitalize(this.singularize(a))
	},
	ordinalize: function (d) {
		var b = parseInt(d, 10),
			c = b % 10,
			a = b % 100;
		if (11 <= a && a <= 13) {
			return d + "th"
		} else {
			switch (c) {
			case 1:
				return d + "st";
			case 2:
				return d + "nd";
			case 3:
				return d + "rd";
			default:
				return d + "th"
			}
		}
	}
}, function () {
	var b = {
		alumnus: "alumni",
		cactus: "cacti",
		focus: "foci",
		nucleus: "nuclei",
		radius: "radii",
		stimulus: "stimuli",
		ellipsis: "ellipses",
		paralysis: "paralyses",
		oasis: "oases",
		appendix: "appendices",
		index: "indexes",
		beau: "beaux",
		bureau: "bureaux",
		tableau: "tableaux",
		woman: "women",
		child: "children",
		man: "men",
		corpus: "corpora",
		criterion: "criteria",
		curriculum: "curricula",
		genus: "genera",
		memorandum: "memoranda",
		phenomenon: "phenomena",
		foot: "feet",
		goose: "geese",
		tooth: "teeth",
		antenna: "antennae",
		formula: "formulae",
		nebula: "nebulae",
		vertebra: "vertebrae",
		vita: "vitae"
	},
		a;
	for (a in b) {
		this.plural(a, b[a]);
		this.singular(b[a], a)
	}
});
Ext.define("Ext.data.association.HasMany", {
	extend: Ext.data.association.Association,
	alternateClassName: "Ext.data.HasManyAssociation",
	alias: "association.hasmany",
	config: {
		foreignKey: undefined,
		store: undefined,
		storeName: undefined,
		filterProperty: null,
		autoLoad: false,
		autoSync: false
	},
	constructor: function (a) {
		a = a || {};
		if (a.storeConfig) {
			a.store = a.storeConfig;
			delete a.storeConfig
		}
		this.callParent([a])
	},
	applyName: function (a) {
		if (!a) {
			a = Ext.util.Inflector.pluralize(this.getAssociatedName().toLowerCase())
		}
		return a
	},
	applyStoreName: function (a) {
		if (!a) {
			a = this.getName() + "Store"
		}
		return a
	},
	applyForeignKey: function (b) {
		if (!b) {
			var a = this.getInverseAssociation();
			if (a) {
				b = a.getForeignKey()
			} else {
				b = this.getOwnerName().toLowerCase() + "_id"
			}
		}
		return b
	},
	applyAssociationKey: function (a) {
		if (!a) {
			var b = this.getAssociatedName();
			a = Ext.util.Inflector.pluralize(b[0].toLowerCase() + b.slice(1))
		}
		return a
	},
	updateForeignKey: function (b, d) {
		var a = this.getAssociatedModel().getFields(),
			c = a.get(b);
		if (!c) {
			c = new Ext.data.Field({
				name: b
			});
			a.add(c);
			a.isDirty = true
		}
		if (d) {
			c = a.get(d);
			if (c) {
				a.remove(c);
				a.isDirty = true
			}
		}
	},
	applyStore: function (b) {
		var e = this,
			j = e.getAssociatedModel(),
			f = e.getStoreName(),
			d = e.getForeignKey(),
			h = e.getPrimaryKey(),
			g = e.getFilterProperty(),
			c = e.getAutoLoad(),
			a = e.getAutoSync();
		return function () {
			var l = this,
				n, p, m, k = {},
				o = {
					addrecords: e.onAddRecords,
					removerecords: e.onRemoveRecords,
					scope: e
				};
			if (l[f] === undefined) {
				if (g) {
					p = {
						property: g,
						value: l.get(g),
						exactMatch: true
					}
				} else {
					p = {
						property: d,
						value: l.get(h),
						exactMatch: true
					}
				}
				k[d] = l.get(h);
				n = Ext.apply({}, b, {
					model: j,
					filters: [p],
					remoteFilter: true,
					autoSync: a,
					modelDefaults: k,
					listeners: o
				});
				m = l[f] = Ext.create("Ext.data.Store", n);
				m.boundTo = l;
				if (c) {
					l[f].load()
				}
			}
			return l[f]
		}
	},
	onAddRecords: function (c, b) {
		var e = b.length,
			f = c.boundTo.getId(),
			d, a;
		for (d = 0; d < e; d++) {
			a = b[d];
			a.set(this.getForeignKey(), f)
		}
		this.updateInverseInstances(c.boundTo)
	},
	onRemoveRecords: function (c, b) {
		var e = b.length,
			d, a;
		for (d = 0; d < e; d++) {
			a = b[d];
			a.set(this.getForeignKey(), null)
		}
	},
	updateStore: function (a) {
		this.getOwnerModel().prototype[this.getName()] = a
	},
	read: function (b, a, e) {
		var d = b[this.getName()](),
			c = a.read(e).getRecords();
		d.add(c)
	},
	updateInverseInstances: function (b) {
		var c = b[this.getName()](),
			a = this.getInverseAssociation();
		if (a) {
			c.each(function (d) {
				d[a.getInstanceName()] = b
			})
		}
	},
	getInverseAssociation: function () {
		var a = this.getOwnerModel().modelName;
		return this.getAssociatedModel().associations.findBy(function (b) {
			return b.getType().toLowerCase() === "belongsto" && b.getAssociatedModel().modelName === a
		})
	}
});
Ext.define("Ext.data.association.BelongsTo", {
	extend: Ext.data.association.Association,
	alternateClassName: "Ext.data.BelongsToAssociation",
	alias: "association.belongsto",
	config: {
		foreignKey: undefined,
		getterName: undefined,
		setterName: undefined,
		instanceName: undefined
	},
	applyForeignKey: function (a) {
		if (!a) {
			a = this.getAssociatedName().toLowerCase() + "_id"
		}
		return a
	},
	updateForeignKey: function (b, d) {
		var a = this.getOwnerModel().getFields(),
			c = a.get(b);
		if (!c) {
			c = new Ext.data.Field({
				name: b
			});
			a.add(c);
			a.isDirty = true
		}
		if (d) {
			c = a.get(d);
			if (c) {
				a.isDirty = true;
				a.remove(c)
			}
		}
	},
	applyInstanceName: function (a) {
		if (!a) {
			a = this.getAssociatedName() + "BelongsToInstance"
		}
		return a
	},
	applyAssociationKey: function (a) {
		if (!a) {
			var b = this.getAssociatedName();
			a = b[0].toLowerCase() + b.slice(1)
		}
		return a
	},
	applyGetterName: function (a) {
		if (!a) {
			var b = this.getAssociatedName();
			a = "get" + b[0].toUpperCase() + b.slice(1)
		}
		return a
	},
	applySetterName: function (a) {
		if (!a) {
			var b = this.getAssociatedName();
			a = "set" + b[0].toUpperCase() + b.slice(1)
		}
		return a
	},
	updateGetterName: function (b, c) {
		var a = this.getOwnerModel().prototype;
		if (c) {
			delete a[c]
		}
		if (b) {
			a[b] = this.createGetter()
		}
	},
	updateSetterName: function (b, c) {
		var a = this.getOwnerModel().prototype;
		if (c) {
			delete a[c]
		}
		if (b) {
			a[b] = this.createSetter()
		}
	},
	createSetter: function () {
		var d = this,
			c = d.getForeignKey(),
			f = d.getAssociatedModel(),
			e, a, b;
		return function (l, j, k) {
			var h = d.getInverseAssociation(),
				g = this;
			if (l && l.isModel) {
				l = l.getId()
			}
			if (Ext.isFunction(j)) {
				j = {
					callback: j,
					scope: k || g
				}
			}
			delete g[d.getInstanceName()];
			e = Ext.data.Model.cache[Ext.data.Model.generateCacheId(f.modelName, this.get(c))];
			a = Ext.data.Model.cache[Ext.data.Model.generateCacheId(f.modelName, l)];
			g.set(c, l);
			if (h) {
				if (a) {
					if (h.getType().toLowerCase() === "hasmany") {
						b = a[h.getName()]();
						b.add(g)
					} else {
						a[h.getInstanceName()] = g
					}
				}
				if (e) {
					if (h.getType().toLowerCase() === "hasmany") {
						b = e[h.getName()]();
						b.remove(g)
					} else {
						delete l[h.getInstanceName()]
					}
				}
			}
			if (a) {
				g[d.getInstanceName()] = a
			}
			if (Ext.isObject(j)) {
				return g.save(j)
			}
			return g
		}
	},
	createGetter: function () {
		var c = this,
			d = c.getAssociatedModel(),
			b = c.getForeignKey(),
			a = c.getInstanceName();
		return function (h, j) {
			h = h || {};
			var g = this,
				k = g.get(b),
				l, e, f;
			e = g[a];
			if (!e) {
				e = Ext.data.Model.cache[Ext.data.Model.generateCacheId(d.modelName, k)];
				if (e) {
					g[a] = e
				}
			}
			if (h.reload === true || e === undefined) {
				if (typeof h == "function") {
					h = {
						callback: h,
						scope: j || g
					}
				}
				l = h.success;
				h.success = function (m) {
					g[a] = m;
					if (l) {
						l.apply(this, arguments)
					}
				};
				d.load(k, h)
			} else {
				f = [e];
				j = j || g;
				Ext.callback(h, j, f);
				Ext.callback(h.success, j, f);
				Ext.callback(h.failure, j, f);
				Ext.callback(h.callback, j, f);
				return e
			}
		}
	},
	read: function (b, a, c) {
		b[this.getInstanceName()] = a.read([c]).getRecords()[0]
	},
	getInverseAssociation: function () {
		var b = this.getOwnerModel().modelName,
			a = this.getForeignKey();
		return this.getAssociatedModel().associations.findBy(function (d) {
			var c = d.getType().toLowerCase();
			return (c === "hasmany" || c === "hasone") && d.getAssociatedModel().modelName === b && d.getForeignKey() === a
		})
	}
});
Ext.define("Ext.data.association.HasOne", {
	extend: Ext.data.association.Association,
	alternateClassName: "Ext.data.HasOneAssociation",
	alias: "association.hasone",
	config: {
		foreignKey: undefined,
		getterName: undefined,
		setterName: undefined,
		instanceName: undefined
	},
	applyForeignKey: function (b) {
		if (!b) {
			var a = this.getInverseAssociation();
			if (a) {
				b = a.getForeignKey()
			} else {
				b = this.getAssociatedName().toLowerCase() + "_id"
			}
		}
		return b
	},
	updateForeignKey: function (b, d) {
		var a = this.getOwnerModel().getFields(),
			c = a.get(b);
		if (!c) {
			c = new Ext.data.Field({
				name: b
			});
			a.add(c);
			a.isDirty = true
		}
		if (d) {
			c = a.get(d);
			if (c) {
				a.remove(c);
				a.isDirty = true
			}
		}
	},
	applyInstanceName: function (a) {
		if (!a) {
			a = this.getAssociatedName() + "HasOneInstance"
		}
		return a
	},
	applyAssociationKey: function (a) {
		if (!a) {
			var b = this.getAssociatedName();
			a = b[0].toLowerCase() + b.slice(1)
		}
		return a
	},
	applyGetterName: function (a) {
		if (!a) {
			var b = this.getAssociatedName();
			a = "get" + b[0].toUpperCase() + b.slice(1)
		}
		return a
	},
	applySetterName: function (a) {
		if (!a) {
			var b = this.getAssociatedName();
			a = "set" + b[0].toUpperCase() + b.slice(1)
		}
		return a
	},
	updateGetterName: function (b, c) {
		var a = this.getOwnerModel().prototype;
		if (c) {
			delete a[c]
		}
		if (b) {
			a[b] = this.createGetter()
		}
	},
	updateSetterName: function (b, c) {
		var a = this.getOwnerModel().prototype;
		if (c) {
			delete a[c]
		}
		if (b) {
			a[b] = this.createSetter()
		}
	},
	createSetter: function () {
		var c = this,
			b = c.getForeignKey(),
			a = c.getInstanceName(),
			d = c.getAssociatedModel();
		return function (h, f, g) {
			var j = Ext.data.Model,
				e;
			if (h && h.isModel) {
				h = h.getId()
			}
			this.set(b, h);
			if (h || h === 0) {
				e = j.cache[j.generateCacheId(d.modelName, h)];
				if (e) {
					this[a] = e
				}
			} else {
				delete this[a]
			}
			if (Ext.isFunction(f)) {
				f = {
					callback: f,
					scope: g || this
				}
			}
			if (Ext.isObject(f)) {
				return this.save(f)
			}
			return this
		}
	},
	createGetter: function () {
		var c = this,
			d = c.getAssociatedModel(),
			b = c.getForeignKey(),
			a = c.getInstanceName();
		return function (h, j) {
			h = h || {};
			var g = this,
				k = g.get(b),
				l, e, f;
			if (h.reload === true || g[a] === undefined) {
				if (typeof h == "function") {
					h = {
						callback: h,
						scope: j || g
					}
				}
				l = h.success;
				h.success = function (m) {
					g[a] = m;
					if (l) {
						l.call(this, arguments)
					}
				};
				d.load(k, h)
			} else {
				e = g[a];
				f = [e];
				j = j || g;
				Ext.callback(h, j, f);
				Ext.callback(h.success, j, f);
				Ext.callback(h.failure, j, f);
				Ext.callback(h.callback, j, f);
				return e
			}
		}
	},
	read: function (c, a, e) {
		var b = this.getInverseAssociation(),
			d = a.read([e]).getRecords()[0];
		c[this.getSetterName()].call(c, d);
		if (b) {
			d[b.getInstanceName()] = c
		}
	},
	getInverseAssociation: function () {
		var a = this.getOwnerModel().modelName;
		return this.getAssociatedModel().associations.findBy(function (b) {
			return b.getType().toLowerCase() === "belongsto" && b.getAssociatedModel().modelName === a
		})
	}
});
Ext.define("Ext.data.Error", {
	config: {
		field: null,
		message: ""
	},
	constructor: function (a) {
		this.initConfig(a)
	}
});
Ext.define("Ext.data.Errors", {
	extend: Ext.util.Collection,
	isValid: function () {
		return this.length === 0
	},
	getByField: function (d) {
		var c = [],
			a, b;
		for (b = 0; b < this.length; b++) {
			a = this.items[b];
			if (a.getField() == d) {
				c.push(a)
			}
		}
		return c
	},
	add: function () {
		var a = arguments.length == 1 ? arguments[0] : arguments[1];
		if (!(a instanceof Ext.data.Error)) {
			a = Ext.create("Ext.data.Error", {
				field: a.field || a.name,
				message: a.error || a.message
			})
		}
		return this.callParent([a])
	}
});
Ext.define("Ext.data.Model", {
	alternateClassName: "Ext.data.Record",
	mixins: {
		observable: Ext.mixin.Observable
	},
	isModel: true,
	config: {
		idProperty: "id",
		data: null,
		fields: undefined,
		validations: null,
		associations: null,
		hasMany: null,
		hasOne: null,
		belongsTo: null,
		proxy: null,
		identifier: {
			type: "simple"
		},
		clientIdProperty: "clientId",
		isErased: false,
		useCache: true
	},
	staticConfigs: ["idProperty", "fields", "validations", "associations", "hasMany", "hasOne", "belongsTo", "clientIdProperty", "identifier", "useCache", "proxy"],
	statics: {
		EDIT: "edit",
		REJECT: "reject",
		COMMIT: "commit",
		cache: {},
		generateProxyMethod: function (a) {
			return function () {
				var b = this.prototype;
				return b[a].apply(b, arguments)
			}
		},
		generateCacheId: function (b, c) {
			var a;
			if (b && b.isModel) {
				a = b.modelName;
				if (c === undefined) {
					c = b.getId()
				}
			} else {
				a = b
			}
			return a.replace(/\./g, "-").toLowerCase() + "-" + c
		}
	},
	inheritableStatics: {
		load: function (a, b, h) {
			var f = this.getProxy(),
				j = this.getIdProperty(),
				e = null,
				d = {},
				g, c;
			h = h || (b && b.scope) || this;
			if (Ext.isFunction(b)) {
				b = {
					callback: b,
					scope: h
				}
			}
			d[j] = a;
			b = Ext.apply({}, b);
			b = Ext.applyIf(b, {
				action: "read",
				params: d,
				model: this
			});
			c = Ext.create("Ext.data.Operation", b);
			if (!f) {
				Ext.Logger.error("You are trying to load a model that doesn't have a Proxy specified")
			}
			g = function (k) {
				if (k.wasSuccessful()) {
					e = k.getRecords()[0] || null;
					Ext.callback(b.success, h, [e, k])
				} else {
					Ext.callback(b.failure, h, [e, k])
				}
				Ext.callback(b.callback, h, [e, k])
			};
			f.read(c, g, this)
		}
	},
	editing: false,
	dirty: false,
	phantom: false,
	constructor: function (f, h, c, g) {
		var e = this,
			d = null,
			a = e.getUseCache(),
			b = e.getIdProperty();
		f = f || g || {};
		if (h || h === 0) {
			f[b] = e.internalId = h
		}
		h = f[b];
		if (a && (h || h === 0)) {
			d = Ext.data.Model.cache[Ext.data.Model.generateCacheId(this, h)];
			if (d) {
				d.raw = c || d.raw;
				return d.mergeData(g || f || {})
			}
		}
		e.modified = {};
		e.raw = c || f || {};
		e.stores = [];
		if (g) {
			e.setConvertedData(f)
		} else {
			e.setData(f)
		}
		e.id = e.getIdentifier().generate(e);
		h = e.data[b];
		if (!h && h !== 0) {
			e.data[b] = e.internalId = e.id;
			e.phantom = true;
			if (this.associations.length) {
				this.handleInlineAssociationData(f)
			}
		} else {
			this.internalId = h
		}
		if (a) {
			Ext.data.Model.cache[Ext.data.Model.generateCacheId(e)] = e
		}
		if (this.init && typeof this.init == "function") {
			this.init()
		}
	},
	mergeData: function (a) {
		var g = this,
			e = g.getFields().items,
			f = e.length,
			k = g.modified,
			c = g.data,
			d, h, l, j, b;
		for (d = 0; d < f; d++) {
			h = e[d];
			l = h._name;
			j = a[l];
			if (j !== undefined && !k.hasOwnProperty(l)) {
				if (h._convert) {
					j = h._convert(j, g)
				}
				c[l] = j
			} else {
				if (Ext.isFunction(h._convert)) {
					j = h._convert(j, g);
					c[l] = j
				}
			}
		}
		if (g.associations.length) {
			g.handleInlineAssociationData(a)
		}
		return this
	},
	setData: function (a) {
		var k = this,
			g = k.fields.items,
			h = g.length,
			f = Ext.isArray(a),
			d = k._data = k.data = {},
			e, l, b, m, j, c;
		if (!a) {
			return k
		}
		for (e = 0; e < h; e++) {
			l = g[e];
			b = l._name;
			j = l._convert;
			if (f) {
				m = a[e]
			} else {
				m = a[b];
				if (typeof m == "undefined") {
					m = l._defaultValue
				}
			}
			if (j) {
				m = l._convert(m, k)
			}
			d[b] = m
		}
		c = k.getId();
		if (k.associations.length && (c || c === 0)) {
			k.handleInlineAssociationData(a)
		}
		return k
	},
	handleInlineAssociationData: function (e) {
		var d = this.associations.items,
			h = d.length,
			f, c, b, g, j, a;
		e = Ext.apply({}, e, this.raw);
		for (f = 0; f < h; f++) {
			c = d[f];
			a = c.getAssociationKey();
			b = e[a];
			if (b) {
				g = c.getReader();
				if (!g) {
					j = c.getAssociatedModel().getProxy();
					if (j) {
						g = j.getReader()
					} else {
						g = new Ext.data.JsonReader({
							model: c.getAssociatedModel()
						})
					}
				}
				c.read(this, g, b)
			}
		}
	},
	setId: function (b) {
		var a = this.getId();
		this.set(this.getIdProperty(), b);
		this.internalId = b;
		if (this.getUseCache()) {
			delete Ext.data.Model.cache[Ext.data.Model.generateCacheId(this, a)];
			Ext.data.Model.cache[Ext.data.Model.generateCacheId(this)] = this
		}
	},
	getId: function () {
		return this.get(this.getIdProperty())
	},
	setConvertedData: function (a) {
		this._data = this.data = a;
		return this
	},
	get: function (a) {
		return this.data[a]
	},
	set: function (o, k) {
		var h = this,
			b = h.fields.map,
			n = h.modified,
			a = !h.editing,
			e = 0,
			c = [],
			j, m, d, l, f, g;
		if (arguments.length == 1) {
			for (m in o) {
				if (o.hasOwnProperty(m)) {
					j = b[m];
					if (j && j.hasCustomConvert()) {
						c.push(m);
						continue
					}
					if (!e && a) {
						h.beginEdit()
					}++e;
					h.set(m, o[m])
				}
			}
			f = c.length;
			if (f) {
				if (!e && a) {
					h.beginEdit()
				}
				e += f;
				for (d = 0; d < f; d++) {
					j = c[d];
					h.set(j, o[j])
				}
			}
			if (a && e) {
				h.endEdit(false, c)
			}
		} else {
			if (n) {
				j = b[o];
				g = j && j.getConvert();
				if (g) {
					k = g.call(j, k, h)
				}
				l = h.data[o];
				h.data[o] = k;
				if (j && !h.isEqual(l, k)) {
					if (n.hasOwnProperty(o)) {
						if (h.isEqual(n[o], k)) {
							delete n[o];
							h.dirty = false;
							for (m in n) {
								if (n.hasOwnProperty(m)) {
									h.dirty = true;
									break
								}
							}
						}
					} else {
						h.dirty = true;
						n[o] = l
					}
				}
				if (a) {
					h.afterEdit([o], n)
				}
			}
		}
	},
	isEqual: function (d, c) {
		if (Ext.isDate(d) && Ext.isDate(c)) {
			return d.getTime() === c.getTime()
		}
		return d === c
	},
	beginEdit: function () {
		var a = this;
		if (!a.editing) {
			a.editing = true;
			a.dirtySave = a.dirty;
			a.dataSave = Ext.apply({}, a.data);
			a.modifiedSave = Ext.apply({}, a.modified)
		}
	},
	cancelEdit: function () {
		var a = this;
		if (a.editing) {
			a.editing = false;
			a.modified = a.modifiedSave;
			a.data = a.dataSave;
			a.dirty = a.dirtySave;
			delete a.modifiedSave;
			delete a.dataSave;
			delete a.dirtySave
		}
	},
	endEdit: function (a, c) {
		var b = this;
		if (b.editing) {
			b.editing = false;
			if (a !== true && (b.changedWhileEditing())) {
				b.afterEdit(c || Ext.Object.getKeys(this.modified), this.modified)
			}
			delete b.modifiedSave;
			delete b.dataSave;
			delete b.dirtySave
		}
	},
	changedWhileEditing: function () {
		var c = this,
			b = c.dataSave,
			d = c.data,
			a;
		for (a in d) {
			if (d.hasOwnProperty(a)) {
				if (!c.isEqual(d[a], b[a])) {
					return true
				}
			}
		}
		return false
	},
	getChanges: function () {
		var a = this.modified,
			b = {},
			c;
		for (c in a) {
			if (a.hasOwnProperty(c)) {
				b[c] = this.get(c)
			}
		}
		return b
	},
	isModified: function (a) {
		return this.modified.hasOwnProperty(a)
	},
	save: function (b, d) {
		var e = this,
			f = e.phantom ? "create" : "update",
			c = e.getProxy(),
			a, g;
		if (!c) {
			Ext.Logger.error("You are trying to save a model instance that doesn't have a Proxy specified")
		}
		b = b || {};
		d = d || e;
		if (Ext.isFunction(b)) {
			b = {
				callback: b,
				scope: d
			}
		}
		Ext.applyIf(b, {
			records: [e],
			action: f,
			model: e.self
		});
		a = Ext.create("Ext.data.Operation", b);
		g = function (h) {
			if (h.wasSuccessful()) {
				Ext.callback(b.success, d, [e, h])
			} else {
				Ext.callback(b.failure, d, [e, h])
			}
			Ext.callback(b.callback, d, [e, h])
		};
		c[f](a, g, e);
		return e
	},
	erase: function (b, d) {
		var e = this,
			c = this.getProxy(),
			a, f;
		if (!c) {
			Ext.Logger.error("You are trying to erase a model instance that doesn't have a Proxy specified")
		}
		b = b || {};
		d = d || e;
		if (Ext.isFunction(b)) {
			b = {
				callback: b,
				scope: d
			}
		}
		Ext.applyIf(b, {
			records: [e],
			action: "destroy",
			model: this.self
		});
		a = Ext.create("Ext.data.Operation", b);
		f = function (g) {
			if (g.wasSuccessful()) {
				Ext.callback(b.success, d, [e, g])
			} else {
				Ext.callback(b.failure, d, [e, g])
			}
			Ext.callback(b.callback, d, [e, g])
		};
		c.destroy(a, f, e);
		return e
	},
	reject: function (a) {
		var c = this,
			b = c.modified,
			d;
		for (d in b) {
			if (b.hasOwnProperty(d)) {
				if (typeof b[d] != "function") {
					c.data[d] = b[d]
				}
			}
		}
		c.dirty = false;
		c.editing = false;
		c.modified = {};
		if (a !== true) {
			c.afterReject()
		}
	},
	commit: function (a) {
		var c = this,
			b = this.modified;
		c.phantom = c.dirty = c.editing = false;
		c.modified = {};
		if (a !== true) {
			c.afterCommit(b)
		}
	},
	afterEdit: function (b, a) {
		this.notifyStores("afterEdit", b, a)
	},
	afterReject: function () {
		this.notifyStores("afterReject")
	},
	afterCommit: function (a) {
		this.notifyStores("afterCommit", Ext.Object.getKeys(a || {}), a)
	},
	notifyStores: function (e) {
		var c = Ext.Array.clone(arguments),
			a = this.stores;
		if (Ext.isArray(a)) {
			var f = a.length,
				d, b;
			c[0] = this;
			for (d = 0; d < f; ++d) {
				b = a[d];
				if (b !== undefined && typeof b[e] == "function") {
					b[e].apply(b, c)
				}
			}
		}
	},
	copy: function (c) {
		var d = this,
			b = d.getIdProperty(),
			a = Ext.apply({}, d.raw),
			e = Ext.apply({}, d.data);
		delete a[b];
		delete e[b];
		return new d.self(null, c, a, e)
	},
	getData: function (a) {
		var b = this.data;
		if (a === true) {
			Ext.apply(b, this.getAssociatedData())
		}
		return b
	},
	getAssociatedData: function () {
		return this.prepareAssociatedData(this, [], null)
	},
	prepareAssociatedData: function (d, m, c) {
		var r = d.associations.items,
			g = r.length,
			s = {},
			o = [],
			n, u, b, a, k, e, l, q, p, f, t, h;
		for (q = 0; q < g; q++) {
			e = r[q];
			u = e.getName();
			f = e.getType();
			t = true;
			if (c) {
				t = f == c
			}
			if (t && f.toLowerCase() == "hasmany") {
				n = d[e.getStoreName()];
				s[u] = [];
				if (n && n.getCount() > 0) {
					b = n.data.items;
					k = b.length;
					o.length = 0;
					for (p = 0; p < k; p++) {
						a = b[p];
						l = a.id;
						if (Ext.Array.indexOf(m, l) == -1) {
							m.push(l);
							s[u][p] = a.getData();
							o.push({
								associationName: u,
								j: p,
								associatedRecord: a,
								ids: m,
								associationType: c
							})
						}
					}
					while (o.length > 0) {
						h = o.shift();
						Ext.apply(s[h.associationName][h.j], this.prepareAssociatedData(h.associatedRecord, h.ids, h.associationType))
					}
				}
			} else {
				if (t && (f.toLowerCase() == "belongsto" || f.toLowerCase() == "hasone")) {
					a = d[e.getInstanceName()];
					if (a !== undefined) {
						l = a.id;
						if (Ext.Array.indexOf(m, l) === -1) {
							m.push(l);
							s[u] = a.getData();
							Ext.apply(s[u], this.prepareAssociatedData(a, m, c))
						}
					}
				}
			}
		}
		return s
	},
	join: function (a) {
		Ext.Array.include(this.stores, a)
	},
	unjoin: function (a) {
		Ext.Array.remove(this.stores, a)
	},
	setDirty: function () {
		var b = this,
			a;
		b.dirty = true;
		b.fields.each(function (c) {
			if (c.getPersist()) {
				a = c.getName();
				b.modified[a] = b.get(a)
			}
		})
	},
	validate: function () {
		var j = Ext.create("Ext.data.Errors"),
			c = this.getValidations().items,
			e = Ext.data.Validations,
			b, d, h, a, g, f;
		if (c) {
			b = c.length;
			for (f = 0; f < b; f++) {
				d = c[f];
				h = d.field || d.name;
				g = d.type;
				a = e[g](d, this.get(h));
				if (!a) {
					j.add(Ext.create("Ext.data.Error", {
						field: h,
						message: d.message || e.getMessage(g)
					}))
				}
			}
		}
		return j
	},
	isValid: function () {
		return this.validate().isValid()
	},
	toUrl: function () {
		var b = this.$className.split("."),
			a = b[b.length - 1].toLowerCase();
		return a + "/" + this.getId()
	},
	destroy: function () {
		var a = this;
		a.notifyStores("afterErase", a);
		if (a.getUseCache()) {
			delete Ext.data.Model.cache[Ext.data.Model.generateCacheId(a)]
		}
		a.raw = a.stores = a.modified = null;
		a.callParent(arguments)
	},
	applyProxy: function (b, a) {
		return Ext.factory(b, Ext.data.Proxy, a, "proxy")
	},
	updateProxy: function (a) {
		if (a) {
			a.setModel(this.self)
		}
	},
	applyAssociations: function (a) {
		if (a) {
			this.addAssociations(a, "hasMany")
		}
	},
	applyBelongsTo: function (a) {
		if (a) {
			this.addAssociations(a, "belongsTo")
		}
	},
	applyHasMany: function (a) {
		if (a) {
			this.addAssociations(a, "hasMany")
		}
	},
	applyHasOne: function (a) {
		if (a) {
			this.addAssociations(a, "hasOne")
		}
	},
	addAssociations: function (e, h) {
		var f, d, b, c = this.self.modelName,
			g = this.self.associations,
			a;
		e = Ext.Array.from(e);
		for (d = 0, f = e.length; d < f; d++) {
			b = e[d];
			if (!Ext.isObject(b)) {
				b = {
					model: b
				}
			}
			Ext.applyIf(b, {
				type: h,
				ownerModel: c,
				associatedModel: b.model
			});
			delete b.model;
			a = Ext.Function.bind(function (j) {
				g.add(Ext.data.association.Association.create(this))
			}, b);
			Ext.ClassManager.onCreated(a, this, (typeof b.associatedModel === "string") ? b.associatedModel : Ext.getClassName(b.associatedModel))
		}
	},
	applyValidations: function (a) {
		if (a) {
			if (!Ext.isArray(a)) {
				a = [a]
			}
			this.addValidations(a)
		}
	},
	addValidations: function (a) {
		this.self.validations.addAll(a)
	},
	applyFields: function (a) {
		var b = this.superclass.fields;
		if (b) {
			a = b.items.concat(a || [])
		}
		return a || []
	},
	updateFields: function (c) {
		var d = c.length,
			e = this,
			h = e.self.prototype,
			j = this.getIdProperty(),
			a, f, g, b;
		f = e._fields = e.fields = new Ext.util.Collection(h.getFieldName);
		for (b = 0; b < d; b++) {
			g = c[b];
			if (!g.isField) {
				g = new Ext.data.Field(c[b])
			}
			f.add(g)
		}
		a = f.get(j);
		if (!a) {
			f.add(new Ext.data.Field(j))
		} else {
			a.setType("auto")
		}
		f.addSorter(h.sortConvertFields)
	},
	applyIdentifier: function (a) {
		if (typeof a === "string") {
			a = {
				type: a
			}
		}
		return Ext.factory(a, Ext.data.identifier.Simple, this.getIdentifier(), "data.identifier")
	},
	getFieldName: function (a) {
		return a.getName()
	},
	sortConvertFields: function (a, d) {
		var c = a.hasCustomConvert(),
			b = d.hasCustomConvert();
		if (c && !b) {
			return 1
		}
		if (!c && b) {
			return -1
		}
		return 0
	},
	onClassExtended: function (l, d, k) {
		var f = k.onBeforeCreated,
			b = this,
			h = b.prototype,
			e = Ext.Class.configNameCache,
			g = h.staticConfigs.concat(d.staticConfigs || []),
			c = h.config,
			a = d.config || {},
			j;
		d.config = a;
		k.onBeforeCreated = function (B, u) {
			var w = [],
				y = B.prototype,
				x = {},
				n = y.config,
				o = g.length,
				r = ["set", "get"],
				t = r.length,
				p = n.associations || [],
				m = Ext.getClassName(B),
				A, z, s, q, v;
			for (s = 0; s < o; s++) {
				A = g[s];
				for (q = 0; q < t; q++) {
					z = e[A][r[q]];
					if (z in y) {
						x[z] = b.generateProxyMethod(z)
					}
				}
			}
			B.addStatics(x);
			B.modelName = m;
			y.modelName = m;
			if (n.belongsTo) {
				w.push("association.belongsto")
			}
			if (n.hasMany) {
				w.push("association.hasmany")
			}
			if (n.hasOne) {
				w.push("association.hasone")
			}
			for (s = 0, v = p.length; s < v; ++s) {
				w.push("association." + p[s].type.toLowerCase())
			}
			if (n.identifier) {
				if (typeof n.identifier === "string") {
					w.push("data.identifier." + n.identifier)
				} else {
					if (typeof n.identifier.type === "string") {
						w.push("data.identifier." + n.identifier.type)
					}
				}
			}
			if (n.proxy) {
				if (typeof n.proxy === "string") {
					w.push("proxy." + n.proxy)
				} else {
					if (typeof n.proxy.type === "string") {
						w.push("proxy." + n.proxy.type)
					}
				}
			}
			if (n.validations) {
				w.push("Ext.data.Validations")
			}
			Ext.require(w, function () {
				Ext.Function.interceptBefore(k, "onCreated", function () {
					Ext.data.ModelManager.registerType(m, B);
					var C = B.prototype.superclass;
					B.prototype.associations = B.associations = B.prototype._associations = (C && C.associations) ? C.associations.clone() : new Ext.util.Collection(function (D) {
						return D.getName()
					});
					B.prototype.validations = B.validations = B.prototype._validations = (C && C.validations) ? C.validations.clone() : new Ext.util.Collection(function (D) {
						return D.field ? (D.field + "-" + D.type) : (D.name + "-" + D.type)
					});
					B.prototype = Ext.Object.chain(B.prototype);
					B.prototype.initConfig.call(B.prototype, n);
					delete B.prototype.initConfig
				});
				f.call(b, B, u, k)
			})
		}
	}
});
Ext.define("Ext.data.StoreManager", {
	extend: Ext.util.Collection,
	alternateClassName: ["Ext.StoreMgr", "Ext.data.StoreMgr", "Ext.StoreManager"],
	singleton: true,
	register: function () {
		for (var a = 0, b;
		(b = arguments[a]); a++) {
			this.add(b)
		}
	},
	unregister: function () {
		for (var a = 0, b;
		(b = arguments[a]); a++) {
			this.remove(this.lookup(b))
		}
	},
	lookup: function (c) {
		if (Ext.isArray(c)) {
			var b = ["field1"],
				e = !Ext.isArray(c[0]),
				f = c,
				d, a;
			if (e) {
				f = [];
				for (d = 0, a = c.length; d < a; ++d) {
					f.push([c[d]])
				}
			} else {
				for (d = 2, a = c[0].length; d <= a; ++d) {
					b.push("field" + d)
				}
			}
			return Ext.create("Ext.data.ArrayStore", {
				data: f,
				fields: b,
				autoDestroy: true,
				autoCreated: true,
				expanded: e
			})
		}
		if (Ext.isString(c)) {
			return this.get(c)
		} else {
			if (c instanceof Ext.data.Store) {
				return c
			} else {
				return Ext.factory(c, Ext.data.Store, null, "store")
			}
		}
	},
	getKey: function (a) {
		return a.getStoreId()
	}
}, function () {
	Ext.regStore = function (c, b) {
		var a;
		if (Ext.isObject(c)) {
			b = c
		} else {
			if (b instanceof Ext.data.Store) {
				b.setStoreId(c)
			} else {
				b.storeId = c
			}
		}
		if (b instanceof Ext.data.Store) {
			a = b
		} else {
			a = Ext.create("Ext.data.Store", b)
		}
		return Ext.data.StoreManager.register(a)
	};
	Ext.getStore = function (a) {
		return Ext.data.StoreManager.lookup(a)
	}
});
Ext.define("Ext.util.Grouper", {
	extend: Ext.util.Sorter,
	isGrouper: true,
	config: {
		groupFn: null,
		sortProperty: null,
		sorterFn: function (d, c) {
			var e = this.getSortProperty(),
				g, b, f, a;
			g = this.getGroupFn();
			b = g.call(this, d);
			f = g.call(this, c);
			if (e) {
				if (b !== f) {
					return this.defaultSortFn.call(this, d, c)
				} else {
					return 0
				}
			}
			return (b > f) ? 1 : ((b < f) ? -1 : 0)
		}
	},
	defaultSortFn: function (e, c) {
		var g = this,
			f = g._transform,
			b = g._root,
			d, a, h = g._sortProperty;
		if (b !== null) {
			e = e[b];
			c = c[b]
		}
		d = e[h];
		a = c[h];
		if (f) {
			d = f(d);
			a = f(a)
		}
		return d > a ? 1 : (d < a ? -1 : 0)
	},
	updateProperty: function (a) {
		this.setGroupFn(this.standardGroupFn)
	},
	standardGroupFn: function (b) {
		var a = this.getRoot(),
			d = this.getProperty(),
			c = b;
		if (a) {
			c = b[a]
		}
		return c[d]
	},
	getGroupString: function (a) {
		var b = this.getGroupFn().call(this, a);
		return (b !== null && typeof b != "undefined") ? b.toString() : ""
	}
});
Ext.define("Ext.data.Store", {
	alias: "store.store",
	extend: Ext.Evented,
	statics: {
		create: function (a) {
			if (!a.isStore) {
				if (!a.type) {
					a.type = "store"
				}
				a = Ext.createByAlias("store." + a.type, a)
			}
			return a
		}
	},
	isStore: true,
	config: {
		storeId: undefined,
		data: null,
		autoLoad: null,
		autoSync: false,
		model: undefined,
		proxy: undefined,
		fields: null,
		remoteSort: false,
		remoteFilter: false,
		remoteGroup: false,
		filters: null,
		sorters: null,
		grouper: null,
		groupField: null,
		groupDir: null,
		getGroupString: null,
		pageSize: 25,
		totalCount: null,
		clearOnPageLoad: true,
		modelDefaults: {},
		autoDestroy: false,
		syncRemovedRecords: true,
		destroyRemovedRecords: true
	},
	currentPage: 1,
	constructor: function (a) {
		a = a || {};
		this.data = this._data = this.createDataCollection();
		this.data.setSortRoot("data");
		this.data.setFilterRoot("data");
		this.removed = [];
		if (a.id && !a.storeId) {
			a.storeId = a.id;
			delete a.id
		}
		this.initConfig(a);
		this.callParent(arguments)
	},
	createDataCollection: function () {
		return new Ext.util.Collection(function (a) {
			return a.getId()
		})
	},
	applyStoreId: function (a) {
		if (a === undefined || a === null) {
			a = this.getUniqueId()
		}
		return a
	},
	updateStoreId: function (a, b) {
		if (b) {
			Ext.data.StoreManager.unregister(this)
		}
		if (a) {
			Ext.data.StoreManager.register(this)
		}
	},
	applyModel: function (b) {
		if (typeof b == "string") {
			var d = Ext.data.ModelManager.getModel(b);
			if (!d) {
				Ext.Logger.error('Model with name "' + b + '" does not exist.')
			}
			b = d
		}
		if (b && !b.prototype.isModel && Ext.isObject(b)) {
			b = Ext.data.ModelManager.registerType(b.storeId || b.id || Ext.id(), b)
		}
		if (!b) {
			var a = this.getFields(),
				c = this.config.data;
			if (!a && c && c.length) {
				a = Ext.Object.getKeys(c[0])
			}
			if (a) {
				b = Ext.define("Ext.data.Store.ImplicitModel-" + (this.getStoreId() || Ext.id()), {
					extend: "Ext.data.Model",
					config: {
						fields: a,
						useCache: false,
						proxy: this.getProxy()
					}
				});
				this.implicitModel = true
			}
		}
		if (!b && this.getProxy()) {
			b = this.getProxy().getModel()
		}
		return b
	},
	updateModel: function (a) {
		var b = this.getProxy();
		if (b && !b.getModel()) {
			b.setModel(a)
		}
	},
	applyProxy: function (b, a) {
		b = Ext.factory(b, Ext.data.Proxy, a, "proxy");
		if (!b && this.getModel()) {
			b = this.getModel().getProxy()
		}
		if (!b) {
			b = new Ext.data.proxy.Memory({
				model: this.getModel()
			})
		}
		if (b.isMemoryProxy) {
			this.setSyncRemovedRecords(false)
		}
		return b
	},
	updateProxy: function (b, a) {
		if (b) {
			if (!b.getModel()) {
				b.setModel(this.getModel())
			}
			b.on("metachange", "onMetaChange", this)
		}
		if (a) {
			b.un("metachange", "onMetaChange", this)
		}
	},
	applyData: function (c) {
		var b = this,
			a;
		if (c) {
			a = b.getProxy();
			if (a instanceof Ext.data.proxy.Memory) {
				a.setData(c);
				b.load();
				return
			} else {
				b.removeAll(true);
				b.fireEvent("clear", b);
				b.suspendEvents();
				b.add(c);
				b.resumeEvents();
				b.dataLoaded = true
			}
		} else {
			b.removeAll(true);
			b.fireEvent("clear", b)
		}
		b.fireEvent("refresh", b, b.data)
	},
	clearData: function () {
		this.setData(null)
	},
	addData: function (d) {
		var a = this.getProxy().getReader(),
			c = a.read(d),
			b = c.getRecords();
		this.add(b)
	},
	updateAutoLoad: function (a) {
		var b = this.getProxy();
		if (a && (b && !b.isMemoryProxy)) {
			this.load(Ext.isObject(a) ? a : null)
		}
	},
	isAutoLoading: function () {
		var a = this.getProxy();
		return (this.getAutoLoad() || (a && a.isMemoryProxy) || this.dataLoaded)
	},
	updateGroupField: function (a) {
		var b = this.getGrouper();
		if (a) {
			if (!b) {
				this.setGrouper({
					property: a,
					direction: this.getGroupDir() || "ASC"
				})
			} else {
				b.setProperty(a)
			}
		} else {
			if (b) {
				this.setGrouper(null)
			}
		}
	},
	updateGroupDir: function (a) {
		var b = this.getGrouper();
		if (b) {
			b.setDirection(a)
		}
	},
	applyGetGroupString: function (b) {
		var a = this.getGrouper();
		if (b) {
			if (a) {
				a.setGroupFn(b)
			} else {
				this.setGrouper({
					groupFn: b
				})
			}
		} else {
			if (a) {
				this.setGrouper(null)
			}
		}
	},
	applyGrouper: function (a) {
		if (typeof a == "string") {
			a = {
				property: a
			}
		} else {
			if (typeof a == "function") {
				a = {
					groupFn: a
				}
			}
		}
		a = Ext.factory(a, Ext.util.Grouper);
		return a
	},
	updateGrouper: function (b, a) {
		var c = this.data;
		if (a) {
			c.removeSorter(a);
			if (!b) {
				c.getSorters().removeSorter("isGrouper")
			}
		}
		if (b) {
			c.insertSorter(0, b);
			if (!a) {
				c.getSorters().addSorter({
					direction: "DESC",
					property: "isGrouper",
					transform: function (d) {
						return (d === true) ? 1 : -1
					}
				})
			}
		}
		if (a) {
			this.fireEvent("refresh", this, c)
		}
	},
	isGrouped: function () {
		return !!this.getGrouper()
	},
	updateSorters: function (d) {
		var b = this.getGrouper(),
			c = this.data,
			a = c.getAutoSort();
		c.setAutoSort(false);
		c.setSorters(d);
		if (b) {
			c.insertSorter(0, b)
		}
		this.updateSortTypes();
		c.setAutoSort(a)
	},
	updateSortTypes: function () {
		var b = this.getModel(),
			a = b && b.getFields(),
			c = this.data;
		if (a) {
			c.getSorters().each(function (f) {
				var d = f.getProperty(),
					e;
				if (!f.isGrouper && d && !f.getTransform()) {
					e = a.get(d);
					if (e) {
						f.setTransform(e.getSortType())
					}
				}
			})
		}
	},
	updateFilters: function (a) {
		this.data.setFilters(a)
	},
	add: function (a) {
		if (!Ext.isArray(a)) {
			a = Array.prototype.slice.call(arguments)
		}
		return this.insert(this.data.length, a)
	},
	insert: function (f, b) {
		if (!Ext.isArray(b)) {
			b = Array.prototype.slice.call(arguments, 1)
		}
		var j = this,
			l = false,
			d = this.data,
			g = b.length,
			a = this.getModel(),
			h = j.getModelDefaults(),
			k = false,
			c, e;
		b = b.slice();
		for (c = 0; c < g; c++) {
			e = b[c];
			if (!e.isModel) {
				e = new a(e)
			} else {
				if (this.removed.indexOf(e) != -1) {
					Ext.Array.remove(this.removed, e)
				}
			}
			e.set(h);
			e.join(j);
			b[c] = e;
			l = l || (e.phantom === true)
		}
		if (b.length === 1) {
			k = d.insert(f, b[0]);
			if (k) {
				k = [k]
			}
		} else {
			k = d.insertAll(f, b)
		}
		if (k) {
			j.fireEvent("addrecords", j, k)
		}
		if (j.getAutoSync() && l) {
			j.sync()
		}
		return b
	},
	remove: function (b) {
		if (b.isModel) {
			b = [b]
		}
		var k = this,
			l = false,
			d = 0,
			a = this.getAutoSync(),
			o = k.getSyncRemovedRecords(),
			c = this.getDestroyRemovedRecords(),
			j = b.length,
			n = [],
			g = [],
			m, h = k.data.items,
			e, f;
		for (; d < j; d++) {
			e = b[d];
			if (k.data.contains(e)) {
				m = (e.phantom === true);
				f = h.indexOf(e);
				if (f !== -1) {
					g.push(e);
					n.push(f)
				}
				e.unjoin(k);
				k.data.remove(e);
				if (c && !o && !e.stores.length) {
					e.destroy()
				} else {
					if (!m && o) {
						k.removed.push(e)
					}
				}
				l = l || !m
			}
		}
		k.fireEvent("removerecords", k, g, n);
		if (a && l) {
			k.sync()
		}
	},
	removeAt: function (b) {
		var a = this.getAt(b);
		if (a) {
			this.remove(a)
		}
	},
	removeAll: function (a) {
		if (a !== true && this.eventFiringSuspended !== true) {
			this.fireAction("clear", [this], "doRemoveAll")
		} else {
			this.doRemoveAll.call(this, true)
		}
	},
	doRemoveAll: function (d) {
		var g = this,
			a = this.getDestroyRemovedRecords(),
			h = this.getSyncRemovedRecords(),
			c = g.data.all.slice(),
			f = c.length,
			e, b;
		for (e = 0; e < f; e++) {
			b = c[e];
			b.unjoin(g);
			if (a && !h && !b.stores.length) {
				b.destroy()
			} else {
				if (b.phantom !== true && h) {
					g.removed.push(b)
				}
			}
		}
		g.data.clear();
		if (d !== true) {
			g.fireEvent("refresh", g, g.data)
		}
		if (g.getAutoSync()) {
			this.sync()
		}
	},
	each: function (b, a) {
		this.data.each(b, a)
	},
	getCount: function () {
		return this.data.items.length || 0
	},
	getAllCount: function () {
		return this.data.all.length || 0
	},
	getAt: function (a) {
		return this.data.getAt(a)
	},
	getRange: function (b, a) {
		return this.data.getRange(b, a)
	},
	getById: function (a) {
		return this.data.findBy(function (b) {
			return b.getId() == a
		})
	},
	indexOf: function (a) {
		return this.data.indexOf(a)
	},
	indexOfId: function (a) {
		return this.data.indexOfKey(a)
	},
	afterEdit: function (c, g, d) {
		var f = this,
			h = f.data,
			a = d[c.getIdProperty()] || c.getId(),
			b = h.keys.indexOf(a),
			e;
		if (b === -1 && h.map[a] === undefined) {
			return
		}
		if (f.getAutoSync()) {
			f.sync()
		}
		if (a !== c.getId()) {
			h.replace(a, c)
		} else {
			h.replace(c)
		}
		e = h.indexOf(c);
		if (b === -1 && e !== -1) {
			f.fireEvent("addrecords", f, [c])
		} else {
			if (b !== -1 && e === -1) {
				f.fireEvent("removerecords", f, [c], [b])
			} else {
				if (e !== -1) {
					f.fireEvent("updaterecord", f, c, e, b, g, d)
				}
			}
		}
	},
	afterReject: function (a) {
		var b = this.data.indexOf(a);
		this.fireEvent("updaterecord", this, a, b, b, [], {})
	},
	afterCommit: function (c, g, d) {
		var f = this,
			h = f.data,
			a = d[c.getIdProperty()] || c.getId(),
			b = h.keys.indexOf(a),
			e;
		if (b === -1 && h.map[a] === undefined) {
			return
		}
		if (a !== c.getId()) {
			h.replace(a, c)
		} else {
			h.replace(c)
		}
		e = h.indexOf(c);
		if (b === -1 && e !== -1) {
			f.fireEvent("addrecords", f, [c])
		} else {
			if (b !== -1 && e === -1) {
				f.fireEvent("removerecords", f, [c], [b])
			} else {
				if (e !== -1) {
					f.fireEvent("updaterecord", f, c, e, b, g, d)
				}
			}
		}
	},
	afterErase: function (a) {
		var c = this,
			d = c.data,
			b = d.indexOf(a);
		if (b !== -1) {
			d.remove(a);
			c.fireEvent("removerecords", c, [a], [b])
		}
	},
	applyRemoteFilter: function (b) {
		var a = this.getProxy();
		return b || (a && a.isSQLProxy === true)
	},
	applyRemoteSort: function (b) {
		var a = this.getProxy();
		return b || (a && a.isSQLProxy === true)
	},
	applyRemoteGroup: function (b) {
		var a = this.getProxy();
		return b || (a && a.isSQLProxy === true)
	},
	updateRemoteFilter: function (a) {
		this.data.setAutoFilter(!a)
	},
	updateRemoteSort: function (a) {
		this.data.setAutoSort(!a)
	},
	sort: function (f, d, c) {
		var e = this.data,
			b = this.getGrouper(),
			a = e.getAutoSort();
		if (f) {
			e.setAutoSort(false);
			if (typeof c === "string") {
				if (c == "prepend") {
					e.insertSorters(b ? 1 : 0, f, d)
				} else {
					e.addSorters(f, d)
				}
			} else {
				e.setSorters(null);
				if (b) {
					e.addSorters(b)
				}
				e.addSorters(f, d)
			}
			this.updateSortTypes();
			e.setAutoSort(a)
		}
		if (!this.getRemoteSort()) {
			if (!f) {
				this.data.sort()
			}
			this.fireEvent("sort", this, this.data, this.data.getSorters());
			if (e.length) {
				this.fireEvent("refresh", this, this.data)
			}
		}
	},
	filter: function (e, d, f, a) {
		var c = this.data,
			b = null;
		if (e) {
			if (Ext.isFunction(e)) {
				b = {
					filterFn: e
				}
			} else {
				if (Ext.isArray(e) || e.isFilter) {
					b = e
				} else {
					b = {
						property: e,
						value: d,
						anyMatch: f,
						caseSensitive: a,
						id: e
					}
				}
			}
		}
		if (this.getRemoteFilter()) {
			c.addFilters(b)
		} else {
			c.filter(b);
			this.fireEvent("filter", this, c, c.getFilters());
			this.fireEvent("refresh", this, c)
		}
	},
	filterBy: function (b, a) {
		var d = this,
			e = d.data,
			c = e.length;
		e.filter({
			filterFn: function (f) {
				return b.call(a || d, f, f.getId())
			}
		});
		this.fireEvent("filter", this, e, e.getFilters());
		if (e.length !== c) {
			this.fireEvent("refresh", this, e)
		}
	},
	queryBy: function (b, a) {
		return this.data.filterBy(b, a || this)
	},
	clearFilter: function (a) {
		var b = this.data.length;
		if (a) {
			this.suspendEvents()
		}
		this.data.setFilters(null);
		if (a) {
			this.resumeEvents(true)
		} else {
			if (b !== this.data.length) {
				this.fireEvent("refresh", this, this.data)
			}
		}
	},
	isFiltered: function () {
		return this.data.filtered
	},
	isSorted: function () {
		return this.data.sorted
	},
	getSorters: function () {
		var a = this.data.getSorters();
		return (a) ? a.items : []
	},
	getFilters: function () {
		var a = this.data.getFilters();
		return (a) ? a.items : []
	},
	getGroups: function (c) {
		var e = this.data.items,
			b = e.length,
			a = this.getGrouper(),
			d = [],
			k = {},
			g, h, j, f;
		for (f = 0; f < b; f++) {
			g = e[f];
			h = a.getGroupString(g);
			j = k[h];
			if (j === undefined) {
				j = {
					name: h,
					children: []
				};
				d.push(j);
				k[h] = j
			}
			j.children.push(g)
		}
		return c ? k[c] : d
	},
	getGroupString: function (a) {
		var b = this.getGrouper();
		if (b) {
			return b.getGroupString(a)
		}
		return null
	},
	find: function (g, d, e, f, a, c) {
		var b = Ext.create("Ext.util.Filter", {
			property: g,
			value: d,
			anyMatch: f,
			caseSensitive: a,
			exactMatch: c,
			root: "data"
		});
		return this.data.findIndexBy(b.getFilterFn(), null, e)
	},
	findRecord: function () {
		var b = this,
			a = b.find.apply(b, arguments);
		return a !== -1 ? b.getAt(a) : null
	},
	findExact: function (c, a, b) {
		return this.data.findIndexBy(function (d) {
			return d.get(c) === a
		}, this, b)
	},
	findBy: function (b, a, c) {
		return this.data.findIndexBy(b, a, c)
	},
	load: function (c, e) {
		var f = this,
			b, d = f.currentPage,
			a = f.getPageSize();
		c = c || {};
		if (Ext.isFunction(c)) {
			c = {
				callback: c,
				scope: e || this
			}
		}
		if (f.getRemoteSort()) {
			c.sorters = c.sorters || this.getSorters()
		}
		if (f.getRemoteFilter()) {
			c.filters = c.filters || this.getFilters()
		}
		if (f.getRemoteGroup()) {
			c.grouper = c.grouper || this.getGrouper()
		}
		Ext.applyIf(c, {
			page: d,
			start: (d - 1) * a,
			limit: a,
			addRecords: false,
			action: "read",
			model: this.getModel()
		});
		b = Ext.create("Ext.data.Operation", c);
		if (f.fireEvent("beforeload", f, b) !== false) {
			f.loading = true;
			f.getProxy().read(b, f.onProxyLoad, f)
		}
		return f
	},
	isLoading: function () {
		return Boolean(this.loading)
	},
	isLoaded: function () {
		return Boolean(this.loaded)
	},
	sync: function () {
		var d = this,
			b = {},
			e = d.getNewRecords(),
			c = d.getUpdatedRecords(),
			a = d.getRemovedRecords(),
			f = false;
		if (e.length > 0) {
			b.create = e;
			f = true
		}
		if (c.length > 0) {
			b.update = c;
			f = true
		}
		if (a.length > 0) {
			b.destroy = a;
			f = true
		}
		if (f && d.fireEvent("beforesync", this, b) !== false) {
			d.getProxy().batch({
				operations: b,
				listeners: d.getBatchListeners()
			})
		}
		return {
			added: e,
			updated: c,
			removed: a
		}
	},
	first: function () {
		return this.data.first()
	},
	last: function () {
		return this.data.last()
	},
	sum: function (e) {
		var d = 0,
			c = 0,
			b = this.data.items,
			a = b.length;
		for (; c < a; ++c) {
			d += b[c].get(e)
		}
		return d
	},
	min: function (f) {
		var d = 1,
			b = this.data.items,
			a = b.length,
			e, c;
		if (a > 0) {
			c = b[0].get(f)
		}
		for (; d < a; ++d) {
			e = b[d].get(f);
			if (e < c) {
				c = e
			}
		}
		return c
	},
	max: function (f) {
		var d = 1,
			c = this.data.items,
			b = c.length,
			e, a;
		if (b > 0) {
			a = c[0].get(f)
		}
		for (; d < b; ++d) {
			e = c[d].get(f);
			if (e > a) {
				a = e
			}
		}
		return a
	},
	average: function (e) {
		var c = 0,
			b = this.data.items,
			a = b.length,
			d = 0;
		if (b.length > 0) {
			for (; c < a; ++c) {
				d += b[c].get(e)
			}
			return d / a
		}
		return 0
	},
	getBatchListeners: function () {
		return {
			scope: this,
			exception: this.onBatchException,
			complete: this.onBatchComplete
		}
	},
	onBatchComplete: function (b) {
		var e = this,
			a = b.operations,
			d = a.length,
			c;
		for (c = 0; c < d; c++) {
			e.onProxyWrite(a[c])
		}
	},
	onBatchException: function (b, a) {},
	onProxyLoad: function (b) {
		var d = this,
			a = b.getRecords(),
			c = b.getResultSet(),
			e = b.wasSuccessful();
		if (c) {
			d.setTotalCount(c.getTotal())
		}
		if (e) {
			this.fireAction("datarefresh", [this, this.data, b], "doDataRefresh")
		}
		d.loaded = true;
		d.loading = false;
		d.fireEvent("load", this, a, e, b);
		Ext.callback(b.getCallback(), b.getScope() || d, [a, b, e])
	},
	doDataRefresh: function (m, h, d) {
		var c = d.getRecords(),
			l = this,
			f = l.getDestroyRemovedRecords(),
			e = h.all.slice(),
			k = e.length,
			b = c.length,
			a = {},
			g, j;
		if (d.getAddRecords() !== true) {
			for (g = 0; g < b; g++) {
				a[c[g].id] = true
			}
			for (g = 0; g < k; g++) {
				j = e[g];
				j.unjoin(l);
				if (a[j.id] !== true && f && !j.stores.length) {
					j.destroy()
				}
			}
			h.clear();
			l.fireEvent("clear", l)
		}
		if (c && c.length) {
			l.suspendEvents();
			l.add(c);
			l.resumeEvents(true)
		}
		l.fireEvent("refresh", l, h)
	},
	onProxyWrite: function (b) {
		var c = this,
			d = b.wasSuccessful(),
			a = b.getRecords();
		switch (b.getAction()) {
		case "create":
			c.onCreateRecords(a, b, d);
			break;
		case "update":
			c.onUpdateRecords(a, b, d);
			break;
		case "destroy":
			c.onDestroyRecords(a, b, d);
			break
		}
		if (d) {
			c.fireEvent("write", c, b)
		}
		Ext.callback(b.getCallback(), b.getScope() || c, [a, b, d])
	},
	onCreateRecords: function (b, a, c) {},
	onUpdateRecords: function (b, a, c) {},
	onDestroyRecords: function (b, a, c) {
		this.removed = []
	},
	onMetaChange: function (b) {
		var a = this.getProxy().getModel();
		if (!this.getModel() && a) {
			this.setModel(a)
		}
		this.fireEvent("metachange", this, b)
	},
	getNewRecords: function () {
		return this.data.filterBy(function (a) {
			return a.phantom === true && a.isValid()
		}).items
	},
	getUpdatedRecords: function () {
		return this.data.filterBy(function (a) {
			return a.dirty === true && a.phantom !== true && a.isValid()
		}).items
	},
	getRemovedRecords: function () {
		return this.removed
	},
	loadPage: function (f, c, d) {
		if (typeof c === "function") {
			c = {
				callback: c,
				scope: d || this
			}
		}
		var e = this,
			b = e.getPageSize(),
			a = e.getClearOnPageLoad();
		c = Ext.apply({}, c);
		e.currentPage = f;
		e.load(Ext.applyIf(c, {
			page: f,
			start: (f - 1) * b,
			limit: b,
			addRecords: !a
		}))
	},
	nextPage: function (a) {
		this.loadPage(this.currentPage + 1, a)
	},
	previousPage: function (a) {
		this.loadPage(this.currentPage - 1, a)
	},
	destroy: function () {
		this.clearData();
		var a = this.getProxy();
		if (a) {
			a.onDestroy()
		}
		Ext.data.StoreManager.unregister(this);
		if (this.implicitModel && this.getModel()) {
			delete Ext.data.ModelManager.types[this.getModel().getName()]
		}
		Ext.destroy(this.data);
		this.callParent(arguments)
	}
});
Ext.define("Ext.data.ArrayStore", {
	extend: Ext.data.Store,
	alias: "store.array",
	config: {
		proxy: {
			type: "memory",
			reader: "array"
		}
	},
	loadData: function (b, a) {
		this.callParent([b, a])
	}
}, function () {
	Ext.data.SimpleStore = Ext.data.ArrayStore
});
Ext.define("Ext.data.JsonP", {
	alternateClassName: "Ext.util.JSONP",
	singleton: true,
	requestCount: 0,
	requests: {},
	timeout: 30000,
	disableCaching: true,
	disableCachingParam: "_dc",
	callbackKey: "callback",
	request: function (n) {
		n = Ext.apply({}, n);
		var j = this,
			d = Ext.isDefined(n.disableCaching) ? n.disableCaching : j.disableCaching,
			g = n.disableCachingParam || j.disableCachingParam,
			c = ++j.requestCount,
			l = n.callbackName || "callback" + c,
			h = n.callbackKey || j.callbackKey,
			m = Ext.isDefined(n.timeout) ? n.timeout : j.timeout,
			e = Ext.apply({}, n.params),
			b = n.url,
			a = Ext.isSandboxed ? Ext.getUniqueGlobalNamespace() : "Ext",
			f, k;
		e[h] = a + ".data.JsonP." + l;
		if (d) {
			e[g] = new Date().getTime()
		}
		k = j.createScript(b, e, n);
		j.requests[c] = f = {
			url: b,
			params: e,
			script: k,
			id: c,
			scope: n.scope,
			success: n.success,
			failure: n.failure,
			callback: n.callback,
			callbackKey: h,
			callbackName: l
		};
		if (m > 0) {
			f.timeout = setTimeout(Ext.bind(j.handleTimeout, j, [f]), m)
		}
		j.setupErrorHandling(f);
		j[l] = Ext.bind(j.handleResponse, j, [f], true);
		j.loadScript(f);
		return f
	},
	abort: function (b) {
		var c = this.requests,
			a;
		if (b) {
			if (!b.id) {
				b = c[b]
			}
			this.handleAbort(b)
		} else {
			for (a in c) {
				if (c.hasOwnProperty(a)) {
					this.abort(c[a])
				}
			}
		}
	},
	setupErrorHandling: function (a) {
		a.script.onerror = Ext.bind(this.handleError, this, [a])
	},
	handleAbort: function (a) {
		a.errorType = "abort";
		this.handleResponse(null, a)
	},
	handleError: function (a) {
		a.errorType = "error";
		this.handleResponse(null, a)
	},
	cleanupErrorHandling: function (a) {
		a.script.onerror = null
	},
	handleTimeout: function (a) {
		a.errorType = "timeout";
		this.handleResponse(null, a)
	},
	handleResponse: function (a, b) {
		var c = true;
		if (b.timeout) {
			clearTimeout(b.timeout)
		}
		delete this[b.callbackName];
		delete this.requests[b.id];
		this.cleanupErrorHandling(b);
		Ext.fly(b.script).destroy();
		if (b.errorType) {
			c = false;
			Ext.callback(b.failure, b.scope, [b.errorType, b])
		} else {
			Ext.callback(b.success, b.scope, [a, b])
		}
		Ext.callback(b.callback, b.scope, [c, a, b.errorType, b])
	},
	createScript: function (c, d, b) {
		var a = document.createElement("script");
		a.setAttribute("src", Ext.urlAppend(c, Ext.Object.toQueryString(d)));
		a.setAttribute("async", true);
		a.setAttribute("type", "text/javascript");
		return a
	},
	loadScript: function (a) {
		Ext.getHead().appendChild(a.script)
	}
});
Ext.define("Ext.data.Validations", {
	alternateClassName: "Ext.data.validations",
	singleton: true,
	config: {
		presenceMessage: "must be present",
		lengthMessage: "is the wrong length",
		formatMessage: "is the wrong format",
		inclusionMessage: "is not included in the list of acceptable values",
		exclusionMessage: "is not an acceptable value",
		emailMessage: "is not a valid email address"
	},
	constructor: function (a) {
		this.initConfig(a)
	},
	getMessage: function (a) {
		var b = this["get" + a[0].toUpperCase() + a.slice(1) + "Message"];
		if (b) {
			return b.call(this)
		}
		return ""
	},
	emailRe: /^\s*[\w\-\+_]+(\.[\w\-\+_]+)*\@[\w\-\+_]+\.[\w\-\+_]+(\.[\w\-\+_]+)*\s*$/,
	presence: function (a, b) {
		if (arguments.length === 1) {
			b = a
		}
		return !!b || b === 0
	},
	length: function (b, e) {
		if (e === undefined || e === null) {
			return false
		}
		var d = e.length,
			c = b.min,
			a = b.max;
		if ((c && d < c) || (a && d > a)) {
			return false
		} else {
			return true
		}
	},
	email: function (b, a) {
		return Ext.data.validations.emailRe.test(a)
	},
	format: function (a, b) {
		if (b === undefined || b === null) {
			b = ""
		}
		return !!(a.matcher && a.matcher.test(b))
	},
	inclusion: function (a, b) {
		return a.list && Ext.Array.indexOf(a.list, b) != -1
	},
	exclusion: function (a, b) {
		return a.list && Ext.Array.indexOf(a.list, b) == -1
	}
});
Ext.define("Ext.data.identifier.Uuid", {
	extend: Ext.data.identifier.Simple,
	alias: "data.identifier.uuid",
	isUnique: true,
	config: {
		id: undefined,
		salt: null,
		timestamp: null,
		version: 4
	},
	applyId: function (a) {
		if (a === undefined) {
			return Ext.data.identifier.Uuid.Global
		}
		return a
	},
	constructor: function () {
		var a = this;
		a.callParent(arguments);
		a.parts = [];
		a.init()
	},
	reconfigure: function (a) {
		this.setConfig(a);
		this.init()
	},
	generate: function () {
		var c = this,
			e = c.parts,
			a = c.getVersion(),
			b = c.getSalt(),
			d = c.getTimestamp();
		e[0] = c.toHex(d.lo, 8);
		e[1] = c.toHex(d.hi & 65535, 4);
		e[2] = c.toHex(((d.hi >>> 16) & 4095) | (a << 12), 4);
		e[3] = c.toHex(128 | ((c.clockSeq >>> 8) & 63), 2) + c.toHex(c.clockSeq & 255, 2);
		e[4] = c.toHex(b.hi, 4) + c.toHex(b.lo, 8);
		if (a == 4) {
			c.init()
		} else {
			++d.lo;
			if (d.lo >= c.twoPow32) {
				d.lo = 0;
				++d.hi
			}
		}
		return e.join("-").toLowerCase()
	},
	init: function () {
		var b = this,
			a = b.getSalt(),
			c = b.getTimestamp();
		if (b.getVersion() == 4) {
			b.clockSeq = b.rand(0, b.twoPow14 - 1);
			if (!a) {
				a = {};
				b.setSalt(a)
			}
			if (!c) {
				c = {};
				b.setTimestamp(c)
			}
			a.lo = b.rand(0, b.twoPow32 - 1);
			a.hi = b.rand(0, b.twoPow16 - 1);
			c.lo = b.rand(0, b.twoPow32 - 1);
			c.hi = b.rand(0, b.twoPow28 - 1)
		} else {
			b.setSalt(b.split(b.getSalt()));
			b.setTimestamp(b.split(b.getTimestamp()));
			b.getSalt().hi |= 256
		}
	},
	twoPow14: Math.pow(2, 14),
	twoPow16: Math.pow(2, 16),
	twoPow28: Math.pow(2, 28),
	twoPow32: Math.pow(2, 32),
	toHex: function (c, b) {
		var a = c.toString(16);
		if (a.length > b) {
			a = a.substring(a.length - b)
		} else {
			if (a.length < b) {
				a = Ext.String.leftPad(a, b, "0")
			}
		}
		return a
	},
	rand: function (c, b) {
		var a = Math.random() * (b - c + 1);
		return Math.floor(a) + c
	},
	split: function (b) {
		if (typeof (b) == "number") {
			var a = Math.floor(b / this.twoPow32);
			return {
				lo: Math.floor(b - a * this.twoPow32),
				hi: a
			}
		}
		return b
	}
}, function () {
	this.Global = new this({
		id: "uuid"
	})
});
Ext.define("Ext.data.proxy.JsonP", {
	extend: Ext.data.proxy.Server,
	alternateClassName: "Ext.data.ScriptTagProxy",
	alias: ["proxy.jsonp", "proxy.scripttag"],
	config: {
		defaultWriterType: "base",
		callbackKey: "callback",
		recordParam: "records",
		autoAppendParams: true
	},
	doRequest: function (a, f, b) {
		var d = this,
			c = d.buildRequest(a),
			e = c.getParams();
		c.setConfig({
			callbackKey: d.getCallbackKey(),
			timeout: d.getTimeout(),
			scope: d,
			callback: d.createRequestCallback(c, a, f, b)
		});
		if (d.getAutoAppendParams()) {
			c.setParams({})
		}
		c.setJsonP(Ext.data.JsonP.request(c.getCurrentConfig()));
		c.setParams(e);
		a.setStarted();
		d.lastRequest = c;
		return c
	},
	createRequestCallback: function (d, a, e, b) {
		var c = this;
		return function (h, f, g) {
			delete c.lastRequest;
			c.processResponse(h, a, d, f, e, b)
		}
	},
	setException: function (b, a) {
		b.setException(b.getRequest().getJsonP().errorType)
	},
	buildUrl: function (f) {
		var e = this,
			a = e.callParent(arguments),
			h = Ext.apply({}, f.getParams()),
			d = h.filters,
			c, b, g;
		delete h.filters;
		if (e.getAutoAppendParams()) {
			a = Ext.urlAppend(a, Ext.Object.toQueryString(h))
		}
		if (d && d.length) {
			for (b = 0; b < d.length; b++) {
				c = d[b];
				g = c.getValue();
				if (g) {
					a = Ext.urlAppend(a, c.getProperty() + "=" + g)
				}
			}
		}
		return a
	},
	destroy: function () {
		this.abort();
		this.callParent(arguments)
	},
	abort: function () {
		var a = this.lastRequest;
		if (a) {
			Ext.data.JsonP.abort(a.getJsonP())
		}
	}
});
Ext.define("Ext.data.proxy.WebStorage", {
	extend: Ext.data.proxy.Client,
	alternateClassName: "Ext.data.WebStorageProxy",
	config: {
		id: undefined,
		reader: null,
		writer: null,
		enablePagingParams: false,
		defaultDateFormat: "Y-m-d H:i:s.u"
	},
	constructor: function (a) {
		this.callParent(arguments);
		this.cache = {}
	},
	updateModel: function (a) {
		if (!this.getId()) {
			this.setId(a.modelName)
		}
	},
	create: function (e, h, j) {
		var d = e.getRecords(),
			c = d.length,
			a = this.getIds(),
			b, g, f;
		e.setStarted();
		for (f = 0; f < c; f++) {
			g = d[f];
			b = g.getId();
			this.setRecord(g);
			a.push(b)
		}
		this.setIds(a);
		e.setCompleted();
		e.setSuccessful();
		if (typeof h == "function") {
			h.call(j || this, e)
		}
	},
	read: function (h, o, p) {
		var e = [],
			a = this.getIds(),
			l = this.getModel(),
			q = l.getIdProperty(),
			g = h.getParams() || {},
			n = h.getSorters(),
			d = h.getFilters(),
			b = h.getStart(),
			f = h.getLimit(),
			c = a.length,
			j, k, m;
		if (g[q] !== undefined) {
			k = this.getRecord(g[q]);
			if (k) {
				e.push(k);
				h.setSuccessful()
			}
		} else {
			for (j = 0; j < c; j++) {
				k = this.getRecord(a[j]);
				if (k) {
					e.push(k)
				}
			}
			m = Ext.create("Ext.util.Collection");
			if (d && d.length) {
				m.setFilters(d)
			}
			if (n && n.length) {
				m.setSorters(n)
			}
			m.addAll(e);
			if (this.getEnablePagingParams() && b !== undefined && f !== undefined) {
				e = m.items.slice(b, b + f)
			} else {
				e = m.items.slice()
			}
			h.setSuccessful()
		}
		h.setCompleted();
		h.setResultSet(Ext.create("Ext.data.ResultSet", {
			records: e,
			total: e.length,
			loaded: true
		}));
		h.setRecords(e);
		if (typeof o == "function") {
			o.call(p || this, h)
		}
	},
	update: function (e, h, j) {
		var d = e.getRecords(),
			c = d.length,
			a = this.getIds(),
			g, b, f;
		e.setStarted();
		for (f = 0; f < c; f++) {
			g = d[f];
			this.setRecord(g);
			b = g.getId();
			if (b !== undefined && Ext.Array.indexOf(a, b) == -1) {
				a.push(b)
			}
		}
		this.setIds(a);
		e.setCompleted();
		e.setSuccessful();
		if (typeof h == "function") {
			h.call(j || this, e)
		}
	},
	destroy: function (b, h, e) {
		var a = b.getRecords(),
			f = a.length,
			d = this.getIds(),
			g = [].concat(d),
			c;
		b.setStarted();
		for (c = 0; c < f; c++) {
			Ext.Array.remove(g, a[c].getId());
			this.removeRecord(a[c], false)
		}
		this.setIds(g);
		b.setCompleted();
		b.setSuccessful();
		if (typeof h == "function") {
			h.call(e || this, b)
		}
	},
	getRecord: function (c) {
		if (this.cache[c] === undefined) {
			var m = this.getRecordKey(c),
				n = this.getStorageObject().getItem(m),
				g = {},
				e = this.getModel(),
				k = e.getFields().items,
				d = k.length,
				h, l, b, j, a, f;
			if (!n) {
				return undefined
			}
			a = Ext.decode(n);
			for (h = 0; h < d; h++) {
				l = k[h];
				b = l.getName();
				f = a[b];
				if (typeof l.getDecode() == "function") {
					g[b] = l.getDecode()(f)
				} else {
					if (l.getType().type == "date") {
						g[b] = this.readDate(l, f)
					} else {
						g[b] = f
					}
				}
			}
			j = new e(g, c);
			this.cache[c] = j
		}
		return this.cache[c]
	},
	setRecord: function (l, c) {
		if (c) {
			l.setId(c)
		} else {
			c = l.getId()
		}
		var o = this,
			a = l.getData(),
			k = {},
			f = o.getModel(),
			m = f.getFields().items,
			d = m.length,
			j = 0,
			g, p, b, h, q;
		for (; j < d; j++) {
			p = m[j];
			b = p.getName();
			g = a[b];
			if (p.getPersist() === false) {
				continue
			}
			if (typeof p.getEncode() == "function") {
				k[b] = p.getEncode()(g, l)
			} else {
				if (p.getType().type == "date" && Ext.isDate(g)) {
					k[b] = this.writeDate(p, g)
				} else {
					k[b] = g
				}
			}
		}
		h = o.getStorageObject();
		q = o.getRecordKey(c);
		o.cache[c] = l;
		h.removeItem(q);
		try {
			h.setItem(q, Ext.encode(k))
		} catch (n) {
			this.fireEvent("exception", this, n)
		}
		l.commit()
	},
	removeRecord: function (d, c) {
		var b = this,
			a;
		if (d.isModel) {
			d = d.getId()
		}
		if (c !== false) {
			a = b.getIds();
			Ext.Array.remove(a, d);
			b.setIds(a)
		}
		b.getStorageObject().removeItem(b.getRecordKey(d))
	},
	getRecordKey: function (a) {
		if (a.isModel) {
			a = a.getId()
		}
		return Ext.String.format("{0}-{1}", this.getId(), a)
	},
	getIds: function () {
		var b = (this.getStorageObject().getItem(this.getId()) || "").split(","),
			c = b.length,
			a;
		if (c == 1 && b[0] === "") {
			b = []
		}
		return b
	},
	setIds: function (a) {
		var c = this.getStorageObject(),
			d = a.join(","),
			f = this.getId();
		c.removeItem(f);
		if (!Ext.isEmpty(d)) {
			try {
				c.setItem(f, d)
			} catch (b) {
				this.fireEvent("exception", this, b)
			}
		}
	},
	writeDate: function (c, b) {
		if (Ext.isEmpty(b)) {
			return null
		}
		var a = c.getDateFormat() || this.getDefaultDateFormat();
		switch (a) {
		case "timestamp":
			return b.getTime() / 1000;
		case "time":
			return b.getTime();
		default:
			return Ext.Date.format(b, a)
		}
	},
	readDate: function (c, b) {
		if (Ext.isEmpty(b)) {
			return null
		}
		var a = c.getDateFormat() || this.getDefaultDateFormat();
		switch (a) {
		case "timestamp":
			return new Date(b * 1000);
		case "time":
			return new Date(b);
		default:
			return Ext.Date.format(Ext.isDate(b) ? b : new Date(b), a)
		}
	},
	initialize: function () {
		this.callParent(arguments);
		var a = this.getStorageObject();
		try {
			a.setItem(this.getId(), a.getItem(this.getId()) || "")
		} catch (b) {
			this.fireEvent("exception", this, b)
		}
	},
	clear: function () {
		var d = this.getStorageObject(),
			c = this.getIds(),
			a = c.length,
			b;
		for (b = 0; b < a; b++) {
			this.removeRecord(c[b], false)
		}
		d.removeItem(this.getId())
	},
	getStorageObject: function () {}
});
Ext.define("Ext.data.proxy.LocalStorage", {
	extend: Ext.data.proxy.WebStorage,
	alias: "proxy.localstorage",
	alternateClassName: "Ext.data.LocalStorageProxy",
	getStorageObject: function () {
		return window.localStorage
	}
});
Ext.define("Ext.data.reader.Array", {
	extend: Ext.data.reader.Json,
	alternateClassName: "Ext.data.ArrayReader",
	alias: "reader.array",
	config: {
		totalProperty: undefined,
		successProperty: undefined
	},
	createFieldAccessExpression: function (g, c, b) {
		var f = this,
			e = g.getMapping(),
			d = (e == null) ? f.getModel().getFields().indexOf(g) : e,
			a;
		if (typeof d === "function") {
			a = c + ".getMapping()(" + b + ", this)"
		} else {
			if (isNaN(d)) {
				d = '"' + d + '"'
			}
			a = b + "[" + d + "]"
		}
		return a
	}
});
Ext.define("Ext.mixin.Selectable", {
	extend: Ext.mixin.Mixin,
	mixinConfig: {
		id: "selectable",
		hooks: {
			updateStore: "updateStore"
		}
	},
	config: {
		disableSelection: null,
		mode: "SINGLE",
		allowDeselect: false,
		lastSelected: null,
		lastFocused: null,
		deselectOnContainerClick: true
	},
	modes: {
		SINGLE: true,
		SIMPLE: true,
		MULTI: true
	},
	selectableEventHooks: {
		addrecords: "onSelectionStoreAdd",
		removerecords: "onSelectionStoreRemove",
		updaterecord: "onSelectionStoreUpdate",
		load: "refreshSelection",
		refresh: "refreshSelection"
	},
	constructor: function () {
		this.selected = new Ext.util.MixedCollection();
		this.callParent(arguments)
	},
	applyMode: function (a) {
		a = a ? a.toUpperCase() : "SINGLE";
		return this.modes[a] ? a : "SINGLE"
	},
	updateStore: function (a, c) {
		var b = this,
			d = Ext.apply({}, b.selectableEventHooks, {
				scope: b
			});
		if (c && Ext.isObject(c) && c.isStore) {
			if (c.autoDestroy) {
				c.destroy()
			} else {
				c.un(d);
				if (a) {
					a.un("clear", "onSelectionStoreClear", this)
				}
			}
		}
		if (a) {
			a.on(d);
			a.onBefore("clear", "onSelectionStoreClear", this);
			b.refreshSelection()
		}
	},
	selectAll: function (a) {
		var e = this,
			c = e.getStore().getRange(),
			d = c.length,
			b = 0;
		for (; b < d; b++) {
			e.select(c[b], true, a)
		}
	},
	deselectAll: function (c) {
		var b = this,
			a = b.getStore().getRange();
		b.deselect(a, c);
		b.selected.clear();
		b.setLastSelected(null);
		b.setLastFocused(null)
	},
	selectWithEvent: function (a) {
		var c = this,
			b = c.isSelected(a);
		switch (c.getMode()) {
		case "MULTI":
		case "SIMPLE":
			if (b) {
				c.deselect(a)
			} else {
				c.select(a, true)
			}
			break;
		case "SINGLE":
			if (c.getAllowDeselect() && b) {
				c.deselect(a)
			} else {
				c.select(a, false)
			}
			break
		}
	},
	selectRange: function (c, g, h) {
		var f = this,
			b = f.getStore(),
			a = [],
			e, d;
		if (f.getDisableSelection()) {
			return
		}
		if (c > g) {
			e = g;
			g = c;
			c = e
		}
		for (d = c; d <= g; d++) {
			a.push(b.getAt(d))
		}
		this.doMultiSelect(a, h)
	},
	select: function (c, e, b) {
		var d = this,
			a;
		if (d.getDisableSelection()) {
			return
		}
		if (typeof c === "number") {
			c = [d.getStore().getAt(c)]
		}
		if (!c) {
			return
		}
		if (d.getMode() == "SINGLE" && c) {
			a = c.length ? c[0] : c;
			d.doSingleSelect(a, b)
		} else {
			d.doMultiSelect(c, e, b)
		}
	},
	doSingleSelect: function (a, b) {
		var d = this,
			c = d.selected;
		if (d.getDisableSelection()) {
			return
		}
		if (d.isSelected(a)) {
			return
		}
		if (c.getCount() > 0) {
			d.deselect(d.getLastSelected(), b)
		}
		c.add(a);
		d.setLastSelected(a);
		d.onItemSelect(a, b);
		d.setLastFocused(a);
		if (!b) {
			d.fireSelectionChange([a])
		}
	},
	doMultiSelect: function (a, j, h) {
		if (a === null || this.getDisableSelection()) {
			return
		}
		a = !Ext.isArray(a) ? [a] : a;
		var f = this,
			b = f.selected,
			e = a.length,
			g = false,
			c = 0,
			d;
		if (!j && b.getCount() > 0) {
			g = true;
			f.deselect(f.getSelection(), true)
		}
		for (; c < e; c++) {
			d = a[c];
			if (j && f.isSelected(d)) {
				continue
			}
			g = true;
			f.setLastSelected(d);
			b.add(d);
			if (!h) {
				f.setLastFocused(d)
			}
			f.onItemSelect(d, h)
		}
		if (g && !h) {
			this.fireSelectionChange(a)
		}
	},
	deselect: function (a, j) {
		var f = this;
		if (f.getDisableSelection()) {
			return
		}
		a = Ext.isArray(a) ? a : [a];
		var b = f.selected,
			g = false,
			c = 0,
			h = f.getStore(),
			e = a.length,
			d;
		for (; c < e; c++) {
			d = a[c];
			if (typeof d === "number") {
				d = h.getAt(d)
			}
			if (b.remove(d)) {
				if (f.getLastSelected() == d) {
					f.setLastSelected(b.last())
				}
				g = true
			}
			if (d) {
				f.onItemDeselect(d, j)
			}
		}
		if (g && !j) {
			f.fireSelectionChange(a)
		}
	},
	updateLastFocused: function (b, a) {
		this.onLastFocusChanged(a, b)
	},
	fireSelectionChange: function (a) {
		var b = this;
		b.fireAction("selectionchange", [b, a], "getSelection")
	},
	getSelection: function () {
		return this.selected.getRange()
	},
	isSelected: function (a) {
		a = Ext.isNumber(a) ? this.getStore().getAt(a) : a;
		return this.selected.indexOf(a) !== -1
	},
	hasSelection: function () {
		return this.selected.getCount() > 0
	},
	refreshSelection: function () {
		var b = this,
			a = b.getSelection();
		b.deselectAll(true);
		if (a.length) {
			b.select(a, false, true)
		}
	},
	onSelectionStoreRemove: function (c, b) {
		var g = this,
			e = g.selected,
			f = b.length,
			a, d;
		if (g.getDisableSelection()) {
			return
		}
		for (d = 0; d < f; d++) {
			a = b[d];
			if (e.remove(a)) {
				if (g.getLastSelected() == a) {
					g.setLastSelected(null)
				}
				if (g.getLastFocused() == a) {
					g.setLastFocused(null)
				}
				g.fireSelectionChange([a])
			}
		}
	},
	onSelectionStoreClear: function (b) {
		var a = b.getData().items;
		this.onSelectionStoreRemove(b, a)
	},
	getSelectionCount: function () {
		return this.selected.getCount()
	},
	onSelectionStoreAdd: Ext.emptyFn,
	onSelectionStoreUpdate: Ext.emptyFn,
	onItemSelect: Ext.emptyFn,
	onItemDeselect: Ext.emptyFn,
	onLastFocusChanged: Ext.emptyFn,
	onEditorKey: Ext.emptyFn
}, function () {});
Ext.define("Ext.dataview.component.DataItem", {
	extend: Ext.Container,
	xtype: "dataitem",
	config: {
		baseCls: Ext.baseCSSPrefix + "data-item",
		defaultType: "component",
		record: null,
		itemCls: null,
		dataMap: {},
		dataview: null,
		width: "100%",
		items: [{
			xtype: "component"
		}]
	},
	updateBaseCls: function (a, b) {
		var c = this;
		c.callParent(arguments)
	},
	updateItemCls: function (b, a) {
		if (a) {
			this.removeCls(a)
		}
		if (b) {
			this.addCls(b)
		}
	},
	doMapData: function (d, g, f) {
		var a, e, c, b;
		for (a in d) {
			c = d[a];
			e = this[a]();
			if (e) {
				for (b in c) {
					if (g && e[b] && g[c[b]] !== undefined && g[c[b]] !== null) {
						e[b](g[c[b]])
					}
				}
			}
		}
		if (f) {
			f.updateData(g)
		}
	},
	updateRecord: function (d) {
		if (!d) {
			return
		}
		this._record = d;
		var f = this,
			a = f.dataview || this.getDataview(),
			g = a.prepareData(d.getData(true), a.getStore().indexOf(d), d),
			c = f.getItems(),
			e = c.first(),
			b = f.getDataMap();
		if (!e) {
			return
		}
		if (b) {
			this.doMapData(b, g, e)
		}
		f.fireEvent("updatedata", f, g)
	}
});
Ext.define("Ext.dataview.component.Container", {
	extend: Ext.Container,
	constructor: function () {
		this.itemCache = [];
		this.callParent(arguments)
	},
	doInitialize: function () {
		this.innerElement.on({
			touchstart: "onItemTouchStart",
			touchend: "onItemTouchEnd",
			tap: "onItemTap",
			taphold: "onItemTapHold",
			touchmove: "onItemTouchMove",
			singletap: "onItemSingleTap",
			doubletap: "onItemDoubleTap",
			swipe: "onItemSwipe",
			delegate: "> ." + Ext.baseCSSPrefix + "data-item",
			scope: this
		})
	},
	initialize: function () {
		this.callParent();
		this.doInitialize()
	},
	onItemTouchStart: function (d) {
		var b = this,
			c = d.getTarget(),
			a = Ext.getCmp(c.id);
		a.on({
			touchmove: "onItemTouchMove",
			scope: b,
			single: true
		});
		b.fireEvent("itemtouchstart", b, a, b.indexOf(a), d)
	},
	onItemTouchMove: function (d) {
		var b = this,
			c = d.getTarget(),
			a = Ext.getCmp(c.id);
		b.fireEvent("itemtouchmove", b, a, b.indexOf(a), d)
	},
	onItemTouchEnd: function (d) {
		var b = this,
			c = d.getTarget(),
			a = Ext.getCmp(c.id);
		a.un({
			touchmove: "onItemTouchMove",
			scope: b
		});
		b.fireEvent("itemtouchend", b, a, b.indexOf(a), d)
	},
	onItemTap: function (d) {
		var b = this,
			c = d.getTarget(),
			a = Ext.getCmp(c.id);
		b.fireEvent("itemtap", b, a, b.indexOf(a), d)
	},
	onItemTapHold: function (d) {
		var b = this,
			c = d.getTarget(),
			a = Ext.getCmp(c.id);
		b.fireEvent("itemtaphold", b, a, b.indexOf(a), d)
	},
	onItemSingleTap: function (d) {
		var b = this,
			c = d.getTarget(),
			a = Ext.getCmp(c.id);
		b.fireEvent("itemsingletap", b, a, b.indexOf(a), d)
	},
	onItemDoubleTap: function (d) {
		var b = this,
			c = d.getTarget(),
			a = Ext.getCmp(c.id);
		b.fireEvent("itemdoubletap", b, a, b.indexOf(a), d)
	},
	onItemSwipe: function (d) {
		var b = this,
			c = d.getTarget(),
			a = Ext.getCmp(c.id);
		b.fireEvent("itemswipe", b, a, b.indexOf(a), d)
	},
	moveItemsToCache: function (j, k) {
		var h = this,
			c = h.dataview,
			a = c.getMaxItemCache(),
			g = h.getViewItems(),
			f = h.itemCache,
			e = f.length,
			l = c.getPressedCls(),
			d = c.getSelectedCls(),
			b = k - j,
			m;
		for (; b >= 0; b--) {
			m = g[j + b];
			if (e !== a) {
				h.remove(m, false);
				m.removeCls([l, d]);
				f.push(m);
				e++
			} else {
				m.destroy()
			}
		}
		if (h.getViewItems().length == 0) {
			this.dataview.showEmptyText()
		}
	},
	moveItemsFromCache: function (b) {
		var l = this,
			e = l.dataview,
			m = e.getStore(),
			k = b.length,
			a = e.getDefaultType(),
			h = e.getItemConfig(),
			g = l.itemCache,
			f = g.length,
			j = [],
			c, n, d;
		if (k) {
			e.hideEmptyText()
		}
		for (c = 0; c < k; c++) {
			b[c]._tmpIndex = m.indexOf(b[c])
		}
		Ext.Array.sort(b, function (p, o) {
			return p._tmpIndex > o._tmpIndex ? 1 : -1
		});
		for (c = 0; c < k; c++) {
			d = b[c];
			if (f) {
				f--;
				n = g.pop();
				this.updateListItem(d, n)
			} else {
				n = l.getDataItemConfig(a, d, h)
			}
			n = this.insert(d._tmpIndex, n);
			delete d._tmpIndex
		}
		return j
	},
	getViewItems: function () {
		return this.getInnerItems()
	},
	updateListItem: function (a, b) {
		if (b.updateRecord) {
			if (b.getRecord() === a) {
				b.updateRecord(a)
			} else {
				b.setRecord(a)
			}
		}
	},
	getDataItemConfig: function (e, b, c) {
		var a = this.dataview,
			d = {
				xtype: e,
				record: b,
				itemCls: a.getItemCls(),
				defaults: c,
				dataview: a
			};
		return Ext.merge(d, c)
	},
	doRemoveItemCls: function (a) {
		var b = this.getViewItems(),
			d = b.length,
			c = 0;
		for (; c < d; c++) {
			b[c].removeCls(a)
		}
	},
	doAddItemCls: function (a) {
		var b = this.getViewItems(),
			d = b.length,
			c = 0;
		for (; c < d; c++) {
			b[c].addCls(a)
		}
	},
	updateAtNewIndex: function (c, b, a) {
		this.moveItemsToCache(c, c);
		this.moveItemsFromCache([a])
	},
	destroy: function () {
		var d = this,
			b = d.itemCache,
			c = b.length,
			a = 0;
		for (; a < c; a++) {
			b[a].destroy()
		}
		this.callParent()
	}
});
Ext.define("Ext.dataview.element.Container", {
	extend: Ext.Component,
	doInitialize: function () {
		this.element.on({
			touchstart: "onItemTouchStart",
			touchend: "onItemTouchEnd",
			tap: "onItemTap",
			taphold: "onItemTapHold",
			touchmove: "onItemTouchMove",
			singletap: "onItemSingleTap",
			doubletap: "onItemDoubleTap",
			swipe: "onItemSwipe",
			delegate: "> div",
			scope: this
		})
	},
	initialize: function () {
		this.callParent();
		this.doInitialize()
	},
	updateBaseCls: function (a, b) {
		var c = this;
		c.callParent([a + "-container", b])
	},
	onItemTouchStart: function (d) {
		var b = this,
			c = d.getTarget(),
			a = b.getViewItems().indexOf(c);
		Ext.get(c).on({
			touchmove: "onItemTouchMove",
			scope: b,
			single: true
		});
		b.fireEvent("itemtouchstart", b, Ext.get(c), a, d)
	},
	onItemTouchEnd: function (d) {
		var b = this,
			c = d.getTarget(),
			a = b.getViewItems().indexOf(c);
		Ext.get(c).un({
			touchmove: "onItemTouchMove",
			scope: b
		});
		b.fireEvent("itemtouchend", b, Ext.get(c), a, d)
	},
	onItemTouchMove: function (d) {
		var b = this,
			c = d.getTarget(),
			a = b.getViewItems().indexOf(c);
		b.fireEvent("itemtouchmove", b, Ext.get(c), a, d)
	},
	onItemTap: function (d) {
		var b = this,
			c = d.getTarget(),
			a = b.getViewItems().indexOf(c);
		b.fireEvent("itemtap", b, Ext.get(c), a, d)
	},
	onItemTapHold: function (d) {
		var b = this,
			c = d.getTarget(),
			a = b.getViewItems().indexOf(c);
		b.fireEvent("itemtaphold", b, Ext.get(c), a, d)
	},
	onItemDoubleTap: function (d) {
		var b = this,
			c = d.getTarget(),
			a = b.getViewItems().indexOf(c);
		b.fireEvent("itemdoubletap", b, Ext.get(c), a, d)
	},
	onItemSingleTap: function (d) {
		var b = this,
			c = d.getTarget(),
			a = b.getViewItems().indexOf(c);
		b.fireEvent("itemsingletap", b, Ext.get(c), a, d)
	},
	onItemSwipe: function (d) {
		var b = this,
			c = d.getTarget(),
			a = b.getViewItems().indexOf(c);
		b.fireEvent("itemswipe", b, Ext.get(c), a, d)
	},
	updateListItem: function (b, f) {
		var e = this,
			a = e.dataview,
			c = a.getStore(),
			d = c.indexOf(b),
			g = a.prepareData(b.getData(true), d, b);
		g.xcount = c.getCount();
		g.xindex = typeof g.xindex === "number" ? g.xindex : d;
		f.innerHTML = a.getItemTpl().apply(g)
	},
	addListItem: function (e, c) {
		var h = this,
			d = h.dataview,
			j = d.getStore(),
			a = d.prepareData(c.getData(true), e, c),
			b = h.element,
			k = b.dom.childNodes,
			g = k.length,
			f;
		a.xcount = typeof a.xcount === "number" ? a.xcount : j.getCount();
		a.xindex = typeof a.xindex === "number" ? a.xindex : e;
		f = Ext.Element.create(this.getItemElementConfig(e, a));
		if (!g || e == g) {
			f.appendTo(b)
		} else {
			f.insertBefore(k[e])
		}
	},
	getItemElementConfig: function (c, e) {
		var b = this.dataview,
			d = b.getItemCls(),
			a = b.getBaseCls() + "-item";
		if (d) {
			a += " " + d
		}
		return {
			cls: a,
			html: b.getItemTpl().apply(e)
		}
	},
	doRemoveItemCls: function (a) {
		var d = this.getViewItems(),
			c = d.length,
			b = 0;
		for (; b < c; b++) {
			Ext.fly(d[b]).removeCls(a)
		}
	},
	doAddItemCls: function (a) {
		var d = this.getViewItems(),
			c = d.length,
			b = 0;
		for (; b < c; b++) {
			Ext.fly(d[b]).addCls(a)
		}
	},
	moveItemsToCache: function (f, e) {
		var d = this,
			a = d.getViewItems(),
			b = e - f,
			c;
		for (; b >= 0; b--) {
			c = a[f + b];
			Ext.get(c).destroy()
		}
		if (d.getViewItems().length == 0) {
			this.dataview.showEmptyText()
		}
	},
	moveItemsFromCache: function (d) {
		var g = this,
			b = g.dataview,
			c = b.getStore(),
			f = d.length,
			e, a;
		if (f) {
			b.hideEmptyText()
		}
		for (e = 0; e < f; e++) {
			d[e]._tmpIndex = c.indexOf(d[e])
		}
		Ext.Array.sort(d, function (j, h) {
			return j._tmpIndex > h._tmpIndex ? 1 : -1
		});
		for (e = 0; e < f; e++) {
			a = d[e];
			g.addListItem(a._tmpIndex, a);
			delete a._tmpIndex
		}
	},
	getViewItems: function () {
		return Array.prototype.slice.call(this.element.dom.childNodes)
	},
	updateAtNewIndex: function (c, b, a) {
		this.moveItemsToCache(c, c);
		this.moveItemsFromCache([a])
	},
	destroy: function () {
		var c = this.getViewItems(),
			b = c.length,
			a = 0;
		for (; a < b; a++) {
			Ext.get(c[a]).destroy()
		}
		this.callParent()
	}
});
Ext.define("Ext.dataview.DataView", {
	extend: Ext.Container,
	alternateClassName: "Ext.DataView",
	mixins: [Ext.mixin.Selectable],
	xtype: "dataview",
	config: {
		store: null,
		data: null,
		baseCls: Ext.baseCSSPrefix + "dataview",
		emptyText: null,
		deferEmptyText: true,
		itemTpl: "<div>{text}</div>",
		pressedCls: "x-item-pressed",
		itemCls: null,
		selectedCls: "x-item-selected",
		triggerEvent: "itemtap",
		triggerCtEvent: "tap",
		deselectOnContainerClick: true,
		scrollable: true,
		inline: null,
		pressedDelay: 100,
		loadingText: "Loading...",
		useComponents: null,
		itemConfig: {},
		maxItemCache: 20,
		defaultType: "dataitem",
		scrollToTopOnRefresh: true
	},
	constructor: function (a) {
		var c = this,
			b;
		c.hasLoadedStore = false;
		c.mixins.selectable.constructor.apply(c, arguments);
		c.indexOffset = 0;
		c.callParent(arguments)
	},
	updateItemCls: function (c, b) {
		var a = this.container;
		if (a) {
			if (b) {
				a.doRemoveItemCls(b)
			}
			if (c) {
				a.doAddItemCls(c)
			}
		}
	},
	storeEventHooks: {
		beforeload: "onBeforeLoad",
		load: "onLoad",
		refresh: "refresh",
		addrecords: "onStoreAdd",
		removerecords: "onStoreRemove",
		updaterecord: "onStoreUpdate"
	},
	initialize: function () {
		this.callParent();
		var b = this,
			a;
		b.on(b.getTriggerCtEvent(), b.onContainerTrigger, b);
		a = b.container = this.add(new Ext.dataview[b.getUseComponents() ? "component" : "element"].Container({
			baseCls: this.getBaseCls()
		}));
		a.dataview = b;
		b.on(b.getTriggerEvent(), b.onItemTrigger, b);
		a.on({
			itemtouchstart: "onItemTouchStart",
			itemtouchend: "onItemTouchEnd",
			itemtap: "onItemTap",
			itemtaphold: "onItemTapHold",
			itemtouchmove: "onItemTouchMove",
			itemsingletap: "onItemSingleTap",
			itemdoubletap: "onItemDoubleTap",
			itemswipe: "onItemSwipe",
			scope: b
		});
		if (b.getStore()) {
			if (b.isPainted()) {
				b.refresh()
			} else {
				b.on({
					painted: "refresh",
					single: true
				})
			}
		}
	},
	applyInline: function (a) {
		if (Ext.isObject(a)) {
			a = Ext.apply({}, a)
		}
		return a
	},
	updateInline: function (c, b) {
		var a = this.getBaseCls();
		if (b) {
			this.removeCls([a + "-inlineblock", a + "-nowrap"])
		}
		if (c) {
			this.addCls(a + "-inlineblock");
			if (Ext.isObject(c) && c.wrap === false) {
				this.addCls(a + "-nowrap")
			} else {
				this.removeCls(a + "-nowrap")
			}
		}
	},
	prepareData: function (c, b, a) {
		return c
	},
	onContainerTrigger: function (b) {
		var a = this;
		if (b.target != a.element.dom) {
			return
		}
		if (a.getDeselectOnContainerClick() && a.getStore()) {
			a.deselectAll()
		}
	},
	onItemTrigger: function (b, a) {
		this.selectWithEvent(this.getStore().getAt(a))
	},
	doAddPressedCls: function (a) {
		var c = this,
			b = c.getItemAt(c.getStore().indexOf(a));
		if (Ext.isElement(b)) {
			b = Ext.get(b)
		}
		if (b) {
			if (b.isComponent) {
				b.renderElement.addCls(c.getPressedCls())
			} else {
				b.addCls(c.getPressedCls())
			}
		}
	},
	onItemTouchStart: function (b, h, d, g) {
		var f = this,
			c = f.getStore(),
			a = c && c.getAt(d);
		f.fireAction("itemtouchstart", [f, d, h, a, g], "doItemTouchStart")
	},
	doItemTouchStart: function (c, b, e, a) {
		var d = c.getPressedDelay();
		if (a) {
			if (d > 0) {
				c.pressedTimeout = Ext.defer(c.doAddPressedCls, d, c, [a])
			} else {
				c.doAddPressedCls(a)
			}
		}
	},
	onItemTouchEnd: function (b, h, d, g) {
		var f = this,
			c = f.getStore(),
			a = c && c.getAt(d);
		if (this.hasOwnProperty("pressedTimeout")) {
			clearTimeout(this.pressedTimeout);
			delete this.pressedTimeout
		}
		if (a && h) {
			if (h.isComponent) {
				h.renderElement.removeCls(f.getPressedCls())
			} else {
				h.removeCls(f.getPressedCls())
			}
		}
		f.fireEvent("itemtouchend", f, d, h, a, g)
	},
	onItemTouchMove: function (b, h, d, g) {
		var f = this,
			c = f.getStore(),
			a = c && c.getAt(d);
		if (f.hasOwnProperty("pressedTimeout")) {
			clearTimeout(f.pressedTimeout);
			delete f.pressedTimeout
		}
		if (a && h) {
			if (h.isComponent) {
				h.renderElement.removeCls(f.getPressedCls())
			} else {
				h.removeCls(f.getPressedCls())
			}
		}
		f.fireEvent("itemtouchmove", f, d, h, a, g)
	},
	onItemTap: function (b, h, d, g) {
		var f = this,
			c = f.getStore(),
			a = c && c.getAt(d);
		f.fireEvent("itemtap", f, d, h, a, g)
	},
	onItemTapHold: function (b, h, d, g) {
		var f = this,
			c = f.getStore(),
			a = c && c.getAt(d);
		f.fireEvent("itemtaphold", f, d, h, a, g)
	},
	onItemSingleTap: function (b, h, d, g) {
		var f = this,
			c = f.getStore(),
			a = c && c.getAt(d);
		f.fireEvent("itemsingletap", f, d, h, a, g)
	},
	onItemDoubleTap: function (b, h, d, g) {
		var f = this,
			c = f.getStore(),
			a = c && c.getAt(d);
		f.fireEvent("itemdoubletap", f, d, h, a, g)
	},
	onItemSwipe: function (b, h, d, g) {
		var f = this,
			c = f.getStore(),
			a = c && c.getAt(d);
		f.fireEvent("itemswipe", f, d, h, a, g)
	},
	onItemSelect: function (a, b) {
		var c = this;
		if (b) {
			c.doItemSelect(c, a)
		} else {
			c.fireAction("select", [c, a], "doItemSelect")
		}
	},
	doItemSelect: function (c, a) {
		if (c.container && !c.isDestroyed) {
			var b = c.getItemAt(c.getStore().indexOf(a));
			if (Ext.isElement(b)) {
				b = Ext.get(b)
			}
			if (b) {
				if (b.isComponent) {
					b.renderElement.removeCls(c.getPressedCls());
					b.renderElement.addCls(c.getSelectedCls())
				} else {
					b.removeCls(c.getPressedCls());
					b.addCls(c.getSelectedCls())
				}
			}
		}
	},
	onItemDeselect: function (a, b) {
		var c = this;
		if (c.container && !c.isDestroyed) {
			if (b) {
				c.doItemDeselect(c, a)
			} else {
				c.fireAction("deselect", [c, a, b], "doItemDeselect")
			}
		}
	},
	doItemDeselect: function (c, a) {
		var b = c.getItemAt(c.getStore().indexOf(a));
		if (Ext.isElement(b)) {
			b = Ext.get(b)
		}
		if (b) {
			if (b.isComponent) {
				b.renderElement.removeCls([c.getPressedCls(), c.getSelectedCls()])
			} else {
				b.removeCls([c.getPressedCls(), c.getSelectedCls()])
			}
		}
	},
	updateData: function (b) {
		var a = this.getStore();
		if (!a) {
			this.setStore(Ext.create("Ext.data.Store", {
				data: b,
				autoDestroy: true
			}))
		} else {
			a.add(b)
		}
	},
	applyStore: function (b) {
		var d = this,
			e = Ext.apply({}, d.storeEventHooks, {
				scope: d
			}),
			c, a;
		if (b) {
			b = Ext.data.StoreManager.lookup(b);
			if (b && Ext.isObject(b) && b.isStore) {
				b.on(e);
				c = b.getProxy();
				if (c) {
					a = c.getReader();
					if (a) {
						a.on("exception", "handleException", this)
					}
				}
			}
		}
		return b
	},
	handleException: function () {
		this.setMasked(false)
	},
	updateStore: function (b, e) {
		var d = this,
			f = Ext.apply({}, d.storeEventHooks, {
				scope: d
			}),
			c, a;
		if (e && Ext.isObject(e) && e.isStore) {
			e.un(f);
			if (!d.isDestroyed) {
				d.onStoreClear()
			}
			if (e.getAutoDestroy()) {
				e.destroy()
			} else {
				c = e.getProxy();
				if (c) {
					a = c.getReader();
					if (a) {
						a.un("exception", "handleException", this)
					}
				}
			}
		}
		if (b) {
			if (b.isLoaded()) {
				this.hasLoadedStore = true
			}
			if (b.isLoading()) {
				d.onBeforeLoad()
			}
			if (d.container) {
				d.refresh()
			}
		}
	},
	onBeforeLoad: function () {
		var a = this.getLoadingText();
		if (a && this.isPainted()) {
			this.setMasked({
				xtype: "loadmask",
				message: a
			})
		}
		this.hideEmptyText()
	},
	updateEmptyText: function (c, d) {
		var b = this,
			a;
		if (d && b.emptyTextCmp) {
			b.remove(b.emptyTextCmp, true);
			delete b.emptyTextCmp
		}
		if (c) {
			b.emptyTextCmp = b.add({
				xtype: "component",
				cls: b.getBaseCls() + "-emptytext",
				html: c,
				hidden: true
			});
			a = b.getStore();
			if (a && b.hasLoadedStore && !a.getCount()) {
				this.showEmptyText()
			}
		}
	},
	onLoad: function (a) {
		this.hasLoadedStore = true;
		this.setMasked(false);
		if (!a.getCount()) {
			this.showEmptyText()
		}
	},
	refresh: function () {
		var b = this,
			a = b.container;
		if (!b.getStore()) {
			if (!b.hasLoadedStore && !b.getDeferEmptyText()) {
				b.showEmptyText()
			}
			return
		}
		if (a) {
			b.fireAction("refresh", [b], "doRefresh")
		}
	},
	applyItemTpl: function (a) {
		return (Ext.isObject(a) && a.isTemplate) ? a : new Ext.XTemplate(a)
	},
	onAfterRender: function () {
		var a = this;
		a.callParent(arguments);
		a.updateStore(a.getStore())
	},
	getItemAt: function (a) {
		return this.getViewItems()[a - this.indexOffset]
	},
	getItemIndex: function (b) {
		var a = this.getViewItems().indexOf(b);
		return (a === -1) ? a : this.indexOffset + a
	},
	getViewItems: function () {
		return this.container.getViewItems()
	},
	doRefresh: function (g) {
		var a = g.container,
			l = g.getStore(),
			b = l.getRange(),
			f = g.getViewItems(),
			j = b.length,
			o = f.length,
			c = j - o,
			h = g.getScrollable(),
			d, m;
		if (this.getScrollToTopOnRefresh() && h) {
			h.getScroller().scrollToTop()
		}
		if (j < 1) {
			g.onStoreClear();
			return
		} else {
			g.hideEmptyText()
		}
		if (c < 0) {
			a.moveItemsToCache(o + c, o - 1);
			f = g.getViewItems();
			o = f.length
		} else {
			if (c > 0) {
				a.moveItemsFromCache(l.getRange(o))
			}
		}
		for (d = 0; d < o; d++) {
			m = f[d];
			a.updateListItem(b[d], m)
		}
		if (this.hasSelection()) {
			var k = this.getSelection(),
				n = this.getSelectionCount(),
				e;
			for (d = 0; d < n; d++) {
				e = k[d];
				this.doItemSelect(this, e)
			}
		}
	},
	showEmptyText: function () {
		if (this.getEmptyText() && (this.hasLoadedStore || !this.getDeferEmptyText())) {
			this.emptyTextCmp.show()
		}
	},
	hideEmptyText: function () {
		if (this.getEmptyText()) {
			this.emptyTextCmp.hide()
		}
	},
	destroy: function () {
		var b = this.getStore(),
			c = (b && b.getProxy()),
			a = (c && c.getReader());
		if (a) {
			a.clearListeners()
		}
		this.callParent(arguments);
		this.setStore(null)
	},
	onStoreClear: function () {
		var c = this,
			a = c.container,
			b = c.getViewItems();
		a.moveItemsToCache(0, b.length - 1);
		this.showEmptyText()
	},
	onStoreAdd: function (b, a) {
		if (a) {
			this.hideEmptyText();
			this.container.moveItemsFromCache(a)
		}
	},
	onStoreRemove: function (c, b, f) {
		var a = this.container,
			e = b.length,
			d;
		for (d = 0; d < e; d++) {
			a.moveItemsToCache(f[d], f[d])
		}
	},
	onStoreUpdate: function (c, b, d, g) {
		var f = this,
			a = f.container,
			e;
		g = (typeof g === "undefined") ? d : g;
		if (g !== d) {
			a.updateAtNewIndex(g, d, b);
			if (f.isSelected(b)) {
				f.doItemSelect(f, b)
			}
		} else {
			e = f.getViewItems()[d];
			if (e) {
				a.updateListItem(b, e)
			}
		}
	}
});
Ext.define("Ext.dataview.IndexBar", {
	extend: Ext.Component,
	alternateClassName: "Ext.IndexBar",
	config: {
		baseCls: Ext.baseCSSPrefix + "indexbar",
		direction: "vertical",
		letters: ["A", "B", "C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P", "Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z"],
		ui: "alphabet",
		listPrefix: null
	},
	itemCls: Ext.baseCSSPrefix + "",
	updateDirection: function (a, c) {
		var b = this.getBaseCls();
		this.element.replaceCls(b + "-" + c, b + "-" + a)
	},
	getElementConfig: function () {
		return {
			reference: "wrapper",
			classList: ["x-centered", "x-indexbar-wrapper"],
			children: [this.callParent()]
		}
	},
	updateLetters: function (c) {
		this.innerElement.setHtml("");
		if (c) {
			var b = c.length,
				a;
			for (a = 0; a < b; a++) {
				this.innerElement.createChild({
					html: c[a]
				})
			}
		}
	},
	updateListPrefix: function (a) {
		if (a && a.length) {
			this.innerElement.createChild({
				html: a
			}, 0)
		}
	},
	initialize: function () {
		this.callParent();
		this.innerElement.on({
			dragstart: this.onDragStart,
			dragend: this.onDragEnd,
			drag: this.onDrag,
			scope: this
		})
	},
	onDragStart: function (b, a) {
		b.stopPropagation();
		this.innerElement.addCls(this.getBaseCls() + "-pressed");
		this.pageBox = this.innerElement.getPageBox();
		this.onDrag(b)
	},
	onDragEnd: function (b, a) {
		this.innerElement.removeCls(this.getBaseCls() + "-pressed")
	},
	onDrag: function (c) {
		var a = Ext.util.Point.fromEvent(c),
			b, d = this.pageBox;
		if (!d) {
			d = this.pageBox = this.el.getPageBox()
		}
		if (this.getDirection() === "vertical") {
			if (a.y > d.bottom || a.y < d.top) {
				return
			}
			b = Ext.Element.fromPoint(d.left + (d.width / 2), a.y)
		} else {
			if (a.x > d.right || a.x < d.left) {
				return
			}
			b = Ext.Element.fromPoint(a.x, d.top + (d.height / 2))
		}
		if (b) {
			this.fireEvent("index", this, b.dom.innerHTML, b)
		}
	},
	destroy: function () {
		var c = this,
			d = Array.prototype.slice.call(c.innerElement.dom.childNodes),
			b = d.length,
			a = 0;
		for (; a < b; a++) {
			Ext.removeNode(d[a])
		}
		this.callParent()
	}
}, function () {});
Ext.define("Ext.dataview.ListItemHeader", {
	extend: Ext.Component,
	xtype: "listitemheader",
	config: {
		baseCls: Ext.baseCSSPrefix + "list-header",
		docked: "top"
	}
});
Ext.define("Ext.dataview.component.ListItem", {
	extend: Ext.dataview.component.DataItem,
	xtype: "listitem",
	config: {
		baseCls: Ext.baseCSSPrefix + "list-item",
		dataMap: null,
		body: {
			xtype: "component",
			cls: "x-list-item-body"
		},
		disclosure: {
			xtype: "component",
			cls: "x-list-disclosure",
			hidden: true,
			docked: "right"
		},
		header: {
			xtype: "component",
			cls: "x-list-header",
			html: " "
		},
		tpl: null,
		items: null
	},
	applyBody: function (a) {
		if (a && !a.isComponent) {
			a = Ext.factory(a, Ext.Component, this.getBody())
		}
		return a
	},
	updateBody: function (a, b) {
		if (a) {
			this.add(a)
		} else {
			if (b) {
				b.destroy()
			}
		}
	},
	applyHeader: function (a) {
		if (a && !a.isComponent) {
			a = Ext.factory(a, Ext.Component, this.getHeader())
		}
		return a
	},
	updateHeader: function (b, a) {
		if (a) {
			a.destroy()
		}
	},
	applyDisclosure: function (a) {
		if (a && !a.isComponent) {
			a = Ext.factory(a, Ext.Component, this.getDisclosure())
		}
		return a
	},
	updateDisclosure: function (b, a) {
		if (b) {
			this.add(b)
		} else {
			if (a) {
				a.destroy()
			}
		}
	},
	updateTpl: function (a) {
		this.getBody().setTpl(a)
	},
	updateRecord: function (d) {
		var f = this,
			c = f.dataview || this.getDataview(),
			g = d && c.prepareData(d.getData(true), c.getStore().indexOf(d), d),
			e = f.getDataMap(),
			b = this.getBody(),
			h = this.getDisclosure();
		f._record = d;
		if (e) {
			f.doMapData(e, g, b)
		} else {
			if (b) {
				b.updateData(g || null)
			}
		}
		if (h && d && c.getOnItemDisclosure()) {
			var a = c.getDisclosureProperty();
			h[(g.hasOwnProperty(a) && g[a] === false) ? "hide" : "show"]()
		}
		f.fireEvent("updatedata", f, g)
	},
	destroy: function () {
		Ext.destroy(this.getHeader());
		this.callParent(arguments)
	}
});
Ext.define("Ext.dataview.component.SimpleListItem", {
	extend: Ext.Component,
	xtype: "simplelistitem",
	config: {
		baseCls: Ext.baseCSSPrefix + "list-item",
		disclosure: {
			xtype: "component",
			cls: "x-list-disclosure",
			hidden: true
		},
		header: {
			xtype: "component",
			cls: "x-list-header",
			html: " "
		},
		dataview: null,
		record: null
	},
	initialize: function () {
		this.element.addCls(this.getBaseCls() + "-tpl")
	},
	applyHeader: function (a) {
		if (a && !a.isComponent) {
			a = Ext.factory(a, Ext.Component, this.getHeader())
		}
		return a
	},
	updateHeader: function (b, a) {
		if (a) {
			a.destroy()
		}
	},
	applyDisclosure: function (a) {
		if (a && !a.isComponent) {
			a = Ext.factory(a, Ext.Component, this.getDisclosure())
		}
		return a
	},
	updateDisclosure: function (b, a) {
		if (b) {
			this.element.appendChild(b.renderElement)
		} else {
			if (a) {
				a.destroy()
			}
		}
	},
	updateRecord: function (c) {
		var d = this,
			b = d.dataview || this.getDataview(),
			e = c && b.prepareData(c.getData(true), b.getStore().indexOf(c), c),
			f = this.getDisclosure();
		d.updateData(e || null);
		if (f && c && b.getOnItemDisclosure()) {
			var a = b.getDisclosureProperty();
			f[(e.hasOwnProperty(a) && e[a] === false) ? "hide" : "show"]()
		}
		d.fireEvent("updatedata", d, e)
	},
	destroy: function () {
		Ext.destroy(this.getHeader(), this.getDisclosure());
		this.callParent(arguments)
	}
});
Ext.define("Ext.util.PositionMap", {
	config: {
		minimumHeight: 50
	},
	constructor: function (a) {
		this.map = [];
		this.adjustments = {};
		this.offset = 0;
		this.initConfig(a)
	},
	populate: function (d, g) {
		var f = this.map = this.map || [],
			a = this.getMinimumHeight(),
			b, e, c;
		d++;
		f.length = d;
		f[0] = 0;
		for (b = g + 1, c = d - 1; b <= c; b++) {
			e = b - 1;
			f[b] = f[e] + a
		}
		this.adjustments = {
			indices: [],
			heights: {}
		};
		this.offset = 0;
		for (b = 1, c = d - 1; b <= c; b++) {
			e = b - 1;
			this.offset += f[b] - f[e] - a
		}
	},
	setItemHeight: function (b, a) {
		a = Math.max(a, this.getMinimumHeight());
		if (a !== this.getItemHeight(b)) {
			var c = this.adjustments;
			c.indices.push(parseInt(b, 10));
			c.heights[b] = a
		}
	},
	update: function () {
		var d = this.adjustments,
			n = d.indices,
			l = d.heights,
			a = this.map,
			k = n.length,
			o = this.getMinimumHeight(),
			c = 0,
			f, e, m, h, g, b;
		if (!d.indices.length) {
			return false
		}
		Ext.Array.sort(n, function (p, j) {
			return p - j
		});
		for (f = 0; f < k; f++) {
			h = n[f];
			g = n[f + 1] || a.length - 1;
			b = (a[h + 1] !== undefined) ? (a[h + 1] - a[h] + c) : o;
			m = l[h];
			c += m - b;
			for (e = h + 1; e <= g; e++) {
				a[e] += c
			}
		}
		this.offset += c;
		this.adjustments = {
			indices: [],
			heights: {}
		};
		return true
	},
	getItemHeight: function (a) {
		return this.map[a + 1] - this.map[a]
	},
	getTotalHeight: function () {
		return ((this.map.length - 1) * this.getMinimumHeight()) + this.offset
	},
	findIndex: function (a) {
		return this.map.length ? this.binarySearch(this.map, a) : 0
	},
	binarySearch: function (b, d) {
		var f = 0,
			a = b.length;
		if (d < b[0]) {
			return 0
		}
		if (d > b[a - 1]) {
			return a - 1
		}
		while (f + 1 < a) {
			var c = (f + a) >> 1,
				e = b[c];
			if (e == d) {
				return c
			} else {
				if (e < d) {
					f = c
				} else {
					a = c
				}
			}
		}
		return f
	}
});
Ext.define("Ext.dataview.List", {
	alternateClassName: "Ext.List",
	extend: Ext.dataview.DataView,
	xtype: "list",
	mixins: [Ext.mixin.Bindable],
	config: {
		layout: "fit",
		indexBar: false,
		icon: null,
		preventSelectionOnDisclose: true,
		baseCls: Ext.baseCSSPrefix + "list",
		pinHeaders: true,
		grouped: false,
		onItemDisclosure: null,
		disclosureProperty: "disclosure",
		ui: "normal",
		defaultType: undefined,
		itemMap: {},
		itemHeight: 47,
		variableHeights: false,
		refreshHeightOnUpdate: true,
		infinite: false,
		useSimpleItems: true,
		scrollable: null,
		striped: false
	},
	platformConfig: [{
		theme: ["Windows"],
		itemHeight: 44
	}],
	topItemIndex: 0,
	constructor: function () {
		var b = this,
			a;
		b.callParent(arguments)
	},
	beforeInitialize: function () {
		var d = this,
			b, e, c, a;
		Ext.apply(d, {
			listItems: [],
			headerItems: [],
			updatedItems: [],
			headerMap: [],
			scrollDockItems: {
				top: [],
				bottom: []
			}
		});
		this.translationMethod = Ext.browser.is.AndroidStock2 ? "cssposition" : "csstransform";
		b = d.container = Ext.factory({
			xtype: "container",
			scrollable: {
				scroller: {
					autoRefresh: !d.getInfinite(),
					direction: "vertical"
				}
			}
		});
		d.add(b);
		e = b.getScrollable();
		c = d.scrollViewElement = e.getElement();
		d.scrollElement = e.getScroller().getElement();
		d.setScrollable(e);
		d.scrollableBehavior = b.getScrollableBehavior();
		a = d.pinnedHeader = Ext.factory({
			xtype: "listitemheader",
			html: "&nbsp;",
			translatable: {
				translationMethod: this.translationMethod
			},
			cls: ["x-list-header", "x-list-header-swap"]
		});
		a.translate(0, -10000);
		a.$position = -10000;
		c.insertFirst(a.renderElement);
		d.bind(e.getScroller().getTranslatable(), "doTranslate", "onTranslate")
	},
	initialize: function () {
		var d = this,
			a = d.container,
			c = d.scrollViewElement,
			b = d.getIndexBar();
		if (b) {
			c.appendChild(b.renderElement)
		}
		d.on(d.getTriggerCtEvent(), d.onContainerTrigger, d);
		d.on(d.getTriggerEvent(), d.onItemTrigger, d);
		a.element.on({
			delegate: "." + d.getBaseCls() + "-disclosure",
			tap: "handleItemDisclosure",
			scope: d
		});
		a.element.on({
			resize: "onContainerResize",
			scope: d
		});
		a.innerElement.on({
			touchstart: "onItemTouchStart",
			touchend: "onItemTouchEnd",
			tap: "onItemTap",
			taphold: "onItemTapHold",
			singletap: "onItemSingleTap",
			doubletap: "onItemDoubleTap",
			swipe: "onItemSwipe",
			delegate: "." + Ext.baseCSSPrefix + "list-item",
			scope: d
		});
		if (d.getStore()) {
			d.refresh()
		}
	},
	onTranslate: function (b, h) {
		var f = this,
			a = f.pinnedHeader,
			c = f.getStore(),
			g = c && c.getCount(),
			d = f.getGrouped(),
			e = f.getInfinite();
		if (!g) {
			f.showEmptyText();
			f.showEmptyScrollDock();
			a.$position = -10000;
			a.translate(0, -10000)
		} else {
			if (e && f.itemsCount) {
				f.handleItemUpdates(h);
				f.handleItemHeights();
				f.handleItemTransforms()
			}
		}
		if (d && f.groups.length && f.getPinHeaders()) {
			f.handlePinnedHeader(h)
		}
	},
	handleItemUpdates: function (g) {
		var f = this,
			c = f.listItems,
			l = c.length,
			h = f.topItemIndex,
			a = f.getListItemInfo(),
			d = f.getItemMap(),
			b, e, k, j;
		f.topItemIndex = j = Math.max(0, d.findIndex(-g) || 0);
		if (h !== j) {
			if (h > j) {
				b = Math.min(l, h - j);
				for (e = b - 1; e >= 0; e--) {
					k = c.pop();
					c.unshift(k);
					f.updateListItem(k, e + j, a)
				}
			} else {
				b = Math.min(l, j - h);
				for (e = 0; e < b; e++) {
					k = c.shift();
					c.push(k);
					f.updateListItem(k, e + j + l - b, a)
				}
			}
		}
	},
	handleItemHeights: function () {
		var t = this,
			k = t.updatedItems,
			d = k.length,
			o = t.getItemMap(),
			b = t.getUseSimpleItems(),
			q = t.container.getScrollable().getScroller(),
			c = o.getMinimumHeight(),
			p = t.headerIndices,
			g = t.headerMap,
			f = q.getTranslatable(),
			h = t.getVariableHeights(),
			s, n, m, a, r, l, e;
		for (n = 0; n < d; n++) {
			r = k[n];
			s = r.$dataIndex;
			if (s !== null) {
				if (h) {
					l = b ? r.element.getHeight() : r.element.getFirstChild().getHeight();
					l = Math.max(l, c)
				} else {
					l = c
				}
				r.$ownItemHeight = l;
				a = t.scrollDockItems.top.length;
				if (r.isFirst) {
					t.totalScrollDockTopHeight = 0;
					for (m = 0; m < a; m++) {
						e = t.scrollDockItems.top[m].$scrollDockHeight;
						l += e;
						t.totalScrollDockTopHeight += e
					}
				}
				a = t.scrollDockItems.bottom.length;
				if (r.isLast) {
					for (m = 0; m < a; m++) {
						e = t.scrollDockItems.bottom[m].$scrollDockHeight;
						l += e
					}
				}
				if (p && p[s]) {
					l += t.headerHeight
				}
				o.setItemHeight(s, l);
				r.$height = l
			}
		}
		o.update();
		l = o.getTotalHeight();
		g.length = 0;
		for (n in p) {
			if (p.hasOwnProperty(n)) {
				g.push(o.map[n])
			}
		}
		if (l != q.givenSize) {
			q.setSize(l);
			q.refreshMaxPosition();
			q.fireEvent("refresh", q);
			if (f.isAnimating && f.activeEasingY && f.activeEasingY.setMinMomentumValue) {
				f.activeEasingY.setMinMomentumValue(-q.getMaxPosition().y)
			}
		}
		t.updatedItems.length = 0
	},
	handleItemTransforms: function () {
		var h = this,
			a = h.listItems,
			m = a.length,
			b = h.getItemMap(),
			k = h.scrollDockItems,
			f = h.getGrouped(),
			l, d, e, g, c;
		for (e = 0; e < m; e++) {
			l = a[e];
			d = b.map[l.$dataIndex];
			if (!l.$hidden && l.$position !== d) {
				l.$position = d;
				g = k.top.length;
				if (l.isFirst && g) {
					for (c = 0; c < g; c++) {
						k.top[c].translate(0, d);
						d += k.top[c].$scrollDockHeight
					}
				}
				if (f && h.headerIndices && h.headerIndices[l.$dataIndex]) {
					l.getHeader().translate(0, d);
					d += h.headerHeight
				}
				l.translate(0, d);
				d += l.$ownItemHeight;
				g = k.bottom.length;
				if (l.isLast && g) {
					for (c = 0; c < g; c++) {
						k.bottom[c].translate(0, d);
						d += k.bottom[c].$scrollDockHeight
					}
				}
			}
		}
	},
	handlePinnedHeader: function (n) {
		var m = this,
			c = m.pinnedHeader,
			f = m.getItemMap(),
			e = m.groups,
			l = m.headerMap,
			h = m.headerHeight,
			o = m.getStore(),
			d = m.totalScrollDockTopHeight,
			j, b, k, g, a;
		b = f.binarySearch(l, -n);
		j = e[b].children[0];
		if (j) {
			k = n + l[b + 1] - h;
			if (n >= 0 || (b === 0 && d + n >= 0) || (b === 0 && -n <= l[b])) {
				g = -10000
			} else {
				if (k < 0) {
					g = k
				} else {
					g = Math.max(0, n)
				}
			}
			a = o.getGroupString(j);
			if (c.$currentHeader != a) {
				c.setHtml(a);
				c.$currentHeader = a
			}
			if (c.$position != g) {
				c.translate(0, g);
				c.$position = g
			}
		}
	},
	createItem: function (c) {
		var h = this,
			a = h.container,
			d = h.listItems,
			f = h.getInfinite(),
			g = h.scrollElement,
			j, e, b;
		j = Ext.factory(c);
		j.dataview = h;
		j.$height = c.minHeight;
		e = j.getHeader();
		if (!f) {
			b = h.getBaseCls() + "-item-relative";
			j.addCls(b);
			e.addCls(b)
		} else {
			e.setTranslatable({
				translationMethod: this.translationMethod
			});
			e.translate(0, -10000);
			g.insertFirst(e.renderElement)
		}
		a.doAdd(j);
		d.push(j);
		return j
	},
	setItemsCount: function (a) {
		var d = this,
			e = d.listItems,
			b = d.getListItemConfig(),
			f = a - e.length,
			c;
		for (c = 0; c < f; c++) {
			d.createItem(b)
		}
		for (c = f; c < 0; c++) {
			e.pop().destroy()
		}
		d.itemsCount = a;
		d.updateAllListItems();
		return d.listItems
	},
	updateUi: function (a, b) {
		if (a && a != b && a == "round") {
			this.setPinHeaders(false)
		}
		this.callParent(arguments)
	},
	updateListItem: function (s, d, r) {
		var u = this,
			a = r.store.getAt(d),
			o = u.headerIndices,
			b = u.footerIndices,
			m = s.getHeader(),
			p = u.scrollDockItems,
			h = u.updatedItems,
			g = s.renderElement.classList,
			k = m.renderElement.classList,
			e = u.getInfinite(),
			q = r.store.getCount(),
			t = [],
			j = [],
			n = [r.headerCls, r.footerCls, r.firstCls, r.lastCls, r.selectedCls, r.stripeCls],
			v = [r.headerCls, r.footerCls, r.firstCls, r.lastCls],
			f, l, c;
		if (e) {
			s.$position = -10000
		}
		if (!a) {
			s.setRecord(null);
			if (e) {
				s.translate(0, -10000);
				m.translate(0, -10000)
			} else {
				s.hide();
				m.hide()
			}
			s.$hidden = true;
			return
		} else {
			if (s.$hidden) {
				if (!e) {
					s.show()
				}
				s.$hidden = false
			}
		}
		if (e) {
			h.push(s)
		}
		if (s.isFirst && d !== 0 && p.top.length) {
			for (l = 0, f = p.top.length; l < f; l++) {
				c = p.top[l];
				if (e) {
					c.translate(0, -10000)
				}
			}
			s.isFirst = false
		}
		if (s.isLast && d !== q - 1 && p.bottom.length) {
			for (l = 0, f = p.bottom.length; l < f; l++) {
				c = p.bottom[l];
				if (e) {
					c.translate(0, -10000)
				}
			}
			s.isLast = false
		}
		if (s.$dataIndex !== d) {
			s.$dataIndex = d;
			u.fireEvent("itemindexchange", u, a, d, s)
		}
		if (s.getRecord() === a) {
			s.updateRecord(a)
		} else {
			s.setRecord(a)
		}
		if (u.isSelected(a)) {
			t.push(r.selectedCls)
		}
		if (r.grouped) {
			if (o[d]) {
				t.push(r.headerCls);
				j.push(r.headerCls);
				m.setHtml(r.store.getGroupString(a));
				if (!e) {
					m.renderElement.insertBefore(s.renderElement);
					m.show()
				}
			} else {
				if (e) {
					m.translate(0, -10000)
				} else {
					m.hide()
				}
			}
			if (b[d]) {
				t.push(r.footerCls);
				j.push(r.footerCls)
			}
		}
		if (d === 0) {
			s.isFirst = true;
			t.push(r.firstCls);
			j.push(r.firstCls);
			if (!r.grouped) {
				t.push(r.headerCls);
				j.push(r.headerCls)
			}
			if (!e) {
				for (l = 0, f = p.top.length; l < f; l++) {
					c = p.top[l];
					if (r.grouped) {
						c.renderElement.insertBefore(m.renderElement)
					} else {
						c.renderElement.insertBefore(s.renderElement)
					}
				}
			}
		}
		if (d === q - 1) {
			s.isLast = true;
			t.push(r.lastCls);
			j.push(r.lastCls);
			if (!r.grouped) {
				t.push(r.footerCls);
				j.push(r.footerCls)
			}
			if (!e) {
				for (l = 0, f = p.bottom.length; l < f; l++) {
					c = p.bottom[l];
					c.renderElement.insertAfter(s.renderElement)
				}
			}
		}
		if (r.striped && d % 2 == 1) {
			t.push(r.stripeCls)
		}
		if (g) {
			for (l = 0; l < n.length; l++) {
				Ext.Array.remove(g, n[l])
			}
			t = Ext.Array.merge(t, g)
		}
		if (k) {
			for (l = 0; l < v.length; l++) {
				Ext.Array.remove(k, v[l])
			}
			j = Ext.Array.merge(j, k)
		}
		s.renderElement.setCls(t);
		m.renderElement.setCls(j)
	},
	updateAllListItems: function () {
		var e = this,
			b = e.getStore(),
			a = e.listItems,
			f = e.getListItemInfo(),
			g = e.topItemIndex,
			c, d;
		if (b) {
			for (c = 0, d = a.length; c < d; c++) {
				e.updateListItem(a[c], g + c, f)
			}
		}
		if (e.isPainted()) {
			if (e.getInfinite() && b && b.getCount()) {
				e.handleItemHeights()
			}
			e.refreshScroller()
		}
	},
	doRefresh: function () {
		var c = this,
			b = c.getInfinite(),
			a = c.container.getScrollable().getScroller(),
			d = c.getStore().getCount();
		if (b) {
			c.getItemMap().populate(d, this.topItemIndex)
		}
		if (c.getGrouped()) {
			c.refreshHeaderIndices()
		}
		if (d) {
			c.hideScrollDockItems();
			c.hideEmptyText();
			if (!b) {
				c.setItemsCount(d);
				if (c.getScrollToTopOnRefresh()) {
					a.scrollTo(0, 0)
				}
			} else {
				if (c.getScrollToTopOnRefresh()) {
					c.topItemIndex = 0;
					a.position.y = 0
				}
				c.updateAllListItems()
			}
		} else {
			c.onStoreClear()
		}
	},
	onContainerResize: function (a, b) {
		var c = this;
		if (!c.headerHeight) {
			c.headerHeight = parseInt(c.pinnedHeader.renderElement.getHeight(), 10)
		}
		if (c.getInfinite()) {
			c.setItemsCount(Math.ceil(b.height / c.getItemMap().getMinimumHeight()) + 1)
		} else {
			if (c.listItems.length && c.getGrouped() && c.getPinHeaders()) {
				c.updateHeaderMap()
			}
		}
	},
	refreshScroller: function () {
		var a = this;
		if (a.isPainted()) {
			if (!a.getInfinite() && a.getGrouped() && a.getPinHeaders()) {
				a.updateHeaderMap()
			}
			a.container.getScrollable().getScroller().refresh()
		}
	},
	updateHeaderMap: function () {
		var c = this,
			b = c.headerMap,
			d = c.headerIndices,
			e, a;
		b.length = 0;
		for (a in d) {
			if (d.hasOwnProperty(a)) {
				e = c.getItemAt(a).getHeader();
				b.push(e.renderElement.dom.offsetTop)
			}
		}
	},
	applyVariableHeights: function (a) {
		if (!this.getInfinite()) {
			return true
		}
		return a
	},
	applyDefaultType: function (a) {
		if (!a) {
			a = this.getUseSimpleItems() ? "simplelistitem" : "listitem"
		}
		return a
	},
	applyItemMap: function (a) {
		return Ext.factory(a, Ext.util.PositionMap, this.getItemMap())
	},
	updateItemHeight: function (a) {
		this.getItemMap().setMinimumHeight(a)
	},
	applyIndexBar: function (a) {
		return Ext.factory(a, Ext.dataview.IndexBar, this.getIndexBar())
	},
	updatePinHeaders: function (a) {
		if (this.isPainted()) {
			this.pinnedHeader.translate(0, a ? this.pinnedHeader.$position : -10000)
		}
	},
	updateItemTpl: function (f) {
		var d = this,
			e = d.listItems,
			c = e.length || 0,
			a, b;
		for (a = 0; a < c; a++) {
			b = e[a];
			b.setTpl(f)
		}
		d.updateAllListItems()
	},
	updateItemCls: function (f, c) {
		var a = this.listItems,
			e = a.length,
			b, d;
		for (b = 0; b < e; b++) {
			d = a[b];
			d.removeCls(c);
			d.addCls(f)
		}
	},
	updateIndexBar: function (a, d) {
		var c = this,
			b = c.scrollViewElement;
		if (d) {
			d.un({
				index: "onIndex",
				scope: c
			});
			if (!a) {
				c.element.removeCls(c.getBaseCls() + "-indexed")
			}
			if (b) {
				b.removeChild(d.renderElement)
			}
		}
		if (a) {
			a.on({
				index: "onIndex",
				scope: c
			});
			if (!d) {
				c.element.addCls(c.getBaseCls() + "-indexed")
			}
			if (b) {
				b.appendChild(a.renderElement)
			}
		}
	},
	updateGrouped: function (d) {
		var f = this,
			c = this.getBaseCls(),
			a = f.pinnedHeader,
			b = c + "-grouped",
			e = c + "-ungrouped";
		if (a) {
			a.translate(0, -10000)
		}
		if (d) {
			f.addCls(b);
			f.removeCls(e)
		} else {
			f.addCls(e);
			f.removeCls(b)
		}
		f.updateAllListItems()
	},
	onStoreAdd: function () {
		this.doRefresh()
	},
	onStoreRemove: function () {
		this.doRefresh()
	},
	onStoreUpdate: function () {
		this.doRefresh()
	},
	onStoreClear: function () {
		var c = this,
			a = c.container.getScrollable().getScroller(),
			b = c.getInfinite();
		if (c.pinnedHeader) {
			c.pinnedHeader.translate(0, -10000)
		}
		if (!b) {
			c.setItemsCount(0);
			a.scrollTo(0, 0)
		} else {
			c.topItemIndex = 0;
			a.position.y = 0;
			c.updateAllListItems()
		}
	},
	showEmptyScrollDock: function () {
		var e = this,
			d = e.getInfinite(),
			f = e.scrollDockItems,
			g = 0,
			a, c, b;
		for (a = 0, c = f.top.length; a < c; a++) {
			b = f.top[a];
			if (d) {
				b.translate(0, g);
				g += b.$scrollDockHeight
			} else {
				this.scrollElement.appendChild(b.renderElement)
			}
		}
		for (a = 0, c = f.bottom.length; a < c; a++) {
			b = f.bottom[a];
			if (d) {
				b.translate(0, g);
				g += b.$scrollDockHeight
			} else {
				this.scrollElement.appendChild(b.renderElement)
			}
		}
	},
	hideScrollDockItems: function () {
		var e = this,
			d = e.getInfinite(),
			f = e.scrollDockItems,
			a, c, b;
		if (!d) {
			return
		}
		for (a = 0, c = f.top.length; a < c; a++) {
			b = f.top[a];
			b.translate(0, -10000)
		}
		for (a = 0, c = f.bottom.length; a < c; a++) {
			b = f.bottom[a];
			b.translate(0, -10000)
		}
	},
	getItemAt: function (a) {
		var e = this.listItems,
			d = e.length,
			b, c;
		for (b = 0; b < d; b++) {
			c = e[b];
			if (c.$dataIndex == a) {
				return c
			}
		}
	},
	getItemIndex: function (a) {
		return a.$dataIndex
	},
	getViewItems: function () {
		return this.listItems
	},
	getListItemInfo: function () {
		var b = this,
			a = b.getBaseCls();
		return {
			store: b.getStore(),
			grouped: b.getGrouped(),
			baseCls: a,
			selectedCls: b.getSelectedCls(),
			headerCls: a + "-header-wrap",
			footerCls: a + "-footer-wrap",
			firstCls: a + "-item-first",
			lastCls: a + "-item-last",
			stripeCls: a + "-item-odd",
			striped: b.getStriped(),
			itemMap: b.getItemMap(),
			defaultItemHeight: b.getItemHeight()
		}
	},
	getListItemConfig: function () {
		var c = this,
			a = c.getItemMap().getMinimumHeight(),
			b = {
				xtype: c.getDefaultType(),
				itemConfig: c.getItemConfig(),
				tpl: c.getItemTpl(),
				minHeight: a,
				cls: c.getItemCls()
			};
		if (c.getInfinite()) {
			b.translatable = {
				translationMethod: this.translationMethod
			}
		}
		if (!c.getVariableHeights()) {
			b.height = a
		}
		return b
	},
	refreshHeaderIndices: function () {
		var g = this,
			h = g.getStore(),
			d = h && h.getCount(),
			c = h.getGroups(),
			k = c.length,
			l = g.headerIndices = {},
			j = g.footerIndices = {},
			e, b, a, f;
		g.groups = c;
		for (e = 0; e < k; e++) {
			a = c[e].children[0];
			f = h.indexOf(a);
			l[f] = true;
			b = f - 1;
			if (b >= 0) {
				j[b] = true
			}
		}
		j[d - 1] = true;
		return l
	},
	onIndex: function (d, k) {
		var m = this,
			p = k.toLowerCase(),
			n = m.getStore(),
			e = n.getGroups(),
			l = e.length,
			j = m.container.getScrollable().getScroller(),
			o, h, c, b;
		for (h = 0; h < l; h++) {
			o = e[h];
			b = o.name.toLowerCase();
			if (b >= p) {
				c = o;
				break
			} else {
				c = o
			}
		}
		if (c) {
			k = n.indexOf(c.children[0]);
			j.stopAnimation();
			var a = j.getContainerSize().y,
				q = j.getSize().y,
				f = q - a,
				g = m.getInfinite() ? m.getItemMap().map[k] : m.listItems[k].getHeader().renderElement.dom.offsetTop;
			j.scrollTo(0, Math.min(g, f))
		}
	},
	onItemAdd: function (c) {
		var b = this,
			a = c.config;
		if (a.scrollDock) {
			if (a.scrollDock == "bottom") {
				b.scrollDockItems.bottom.push(c)
			} else {
				b.scrollDockItems.top.push(c)
			}
			if (b.getInfinite()) {
				c.on({
					resize: "onScrollDockItemResize",
					scope: this
				});
				c.addCls(b.getBaseCls() + "-scrolldockitem");
				c.setTranslatable({
					translationMethod: this.translationMethod
				});
				c.translate(0, -10000);
				c.$scrollDockHeight = 0
			}
			b.container.doAdd(c)
		} else {
			b.callParent(arguments)
		}
	},
	getScrollDockedItems: function () {
		return this.scrollDockItems.bottom.slice().concat(this.scrollDockItems.top.slice())
	},
	onScrollDockItemResize: function (g, c) {
		var f = this,
			a = f.listItems,
			e = a.length,
			b, d;
		Ext.getCmp(g.id).$scrollDockHeight = c.height;
		for (b = 0; b < e; b++) {
			d = a[b];
			if (d.isLast) {
				this.updatedItems.push(d);
				this.refreshScroller();
				break
			}
		}
	},
	onItemTouchStart: function (a) {
		this.container.innerElement.on({
			touchmove: "onItemTouchMove",
			delegate: "." + Ext.baseCSSPrefix + "list-item",
			single: true,
			scope: this
		});
		this.callParent(this.parseEvent(a))
	},
	onItemTouchMove: function (a) {
		this.callParent(this.parseEvent(a))
	},
	onItemTouchEnd: function (a) {
		this.container.innerElement.un({
			touchmove: "onItemTouchMove",
			delegate: "." + Ext.baseCSSPrefix + "list-item",
			scope: this
		});
		this.callParent(this.parseEvent(a))
	},
	onItemTap: function (a) {
		this.callParent(this.parseEvent(a))
	},
	onItemTapHold: function (a) {
		this.callParent(this.parseEvent(a))
	},
	onItemSingleTap: function (a) {
		this.callParent(this.parseEvent(a))
	},
	onItemDoubleTap: function (a) {
		this.callParent(this.parseEvent(a))
	},
	onItemSwipe: function (a) {
		this.callParent(this.parseEvent(a))
	},
	parseEvent: function (d) {
		var b = this,
			c = Ext.fly(d.getTarget()).findParent("." + Ext.baseCSSPrefix + "list-item", 8),
			a = Ext.getCmp(c.id);
		return [b, a, a.$dataIndex, d]
	},
	applyOnItemDisclosure: function (a) {
		if (Ext.isFunction(a)) {
			return {
				scope: this,
				handler: a
			}
		}
		return a
	},
	handleItemDisclosure: function (f) {
		var d = this,
			c = Ext.getCmp(Ext.get(f.getTarget()).up(".x-list-item").id),
			b = c.$dataIndex,
			a = d.getStore().getAt(b);
		d.fireAction("disclose", [d, a, c, b, f], "doDisclose")
	},
	doDisclose: function (f, a, d, c, g) {
		var b = f.getOnItemDisclosure();
		if (b && b.handler) {
			b.handler.call(b.scope || f, a, d, c, g)
		}
	},
	onItemTrigger: function (c, b, f, a, d) {
		if (!(this.getPreventSelectionOnDisclose() && Ext.fly(d.target).hasCls(this.getBaseCls() + "-disclosure"))) {
			this.callParent(arguments)
		}
	}
});
Ext.define("Ext.device.communicator.Default", {
	SERVER_URL: "http://localhost:3000",
	callbackDataMap: {},
	callbackIdMap: {},
	idSeed: 0,
	globalScopeId: "0",
	generateId: function () {
		return String(++this.idSeed)
	},
	getId: function (a) {
		var b = a.$callbackId;
		if (!b) {
			a.$callbackId = b = this.generateId()
		}
		return b
	},
	getCallbackId: function (h, d) {
		var c = this.callbackIdMap,
			b = this.callbackDataMap,
			g, a, f, e;
		if (!d) {
			a = this.globalScopeId
		} else {
			if (d.isIdentifiable) {
				a = d.getId()
			} else {
				a = this.getId(d)
			}
		}
		f = this.getId(h);
		if (!c[a]) {
			c[a] = {}
		}
		if (!c[a][f]) {
			g = this.generateId();
			e = {
				callback: h,
				scope: d
			};
			c[a][f] = g;
			b[g] = e
		}
		return c[a][f]
	},
	getCallbackData: function (a) {
		return this.callbackDataMap[a]
	},
	invoke: function (c, a) {
		var b = this.getCallbackData(c);
		b.callback.apply(b.scope, a)
	},
	send: function (c) {
		var e, d, b, f;
		if (!c) {
			c = {}
		} else {
			if (c.callbacks) {
				e = c.callbacks;
				d = c.scope;
				delete c.callbacks;
				delete c.scope;
				for (b in e) {
					if (e.hasOwnProperty(b)) {
						f = e[b];
						if (typeof f == "function") {
							c[b] = this.getCallbackId(f, d)
						}
					}
				}
			}
		}
		c.__source = document.location.href;
		var a = this.doSend(c);
		return (a && a.length > 0) ? JSON.parse(a) : null
	},
	doSend: function (a) {
		var c = new XMLHttpRequest();
		c.open("GET", this.SERVER_URL + "?" + Ext.Object.toQueryString(a) + "&_dc=" + new Date().getTime(), false);
		try {
			c.send(null);
			return c.responseText
		} catch (b) {
			if (a.failure) {
				this.invoke(a.failure)
			} else {
				if (a.callback) {
					this.invoke(a.callback)
				}
			}
		}
	}
});
Ext.define("Ext.device.communicator.Android", {
	extend: Ext.device.communicator.Default,
	doSend: function (a) {
		a.__source = document.location.href;
		return window.Sencha.action(JSON.stringify(a))
	}
});
Ext.define("Ext.device.Communicator", {
	singleton: true,
	constructor: function () {
		if (Ext.os.is.Android) {
			return new Ext.device.communicator.Android()
		}
		return new Ext.device.communicator.Default()
	}
});
Ext.define("Ext.device.notification.Abstract", {
	show: function (a) {
		if (!a.message) {
			throw ("[Ext.device.Notification#show] You passed no message")
		}
		if (!a.buttons) {
			a.buttons = "OK"
		}
		if (!Ext.isArray(a.buttons)) {
			a.buttons = [a.buttons]
		}
		if (!a.scope) {
			a.scope = this
		}
		return a
	},
	vibrate: Ext.emptyFn
});
Ext.define("Ext.device.notification.PhoneGap", {
	extend: Ext.device.notification.Abstract,
    show: function() {
        var config = this.callParent(arguments),
            buttons = config.buttons,
            onShowCallback = function (index) {
                if (config.callback) {
                    config.callback.apply(config.scope, (config.buttons) ? [config.buttons[index - 1].toLowerCase()] : []);
                }
            };

         // change Ext.MessageBox buttons into normal arrays
        var ln = buttons.length;
        if (ln && typeof buttons[0] != "string") {
            var newButtons = [],
                i;

            for (i = 0; i < ln; i++) {
                newButtons.push(buttons[i].text);
            }

            buttons = newButtons.join(',');
        }

        navigator.notification.confirm(
            config.message, // message
            onShowCallback, // callback
            config.title, // title
            buttons // array of button names
        );
    },

    vibrate: function() {
        navigator.notification.vibrate(2000);
    }
});
Ext.define("Ext.device.notification.Sencha", {
	extend: Ext.device.notification.Abstract,
	show: function () {
		var a = this.callParent(arguments);
		Ext.device.Communicator.send({
			command: "Notification#show",
			callbacks: {
				callback: a.callback
			},
			scope: a.scope,
			title: a.title,
			message: a.message,
			buttons: a.buttons.join(",")
		})
	},
	vibrate: function () {
		Ext.device.Communicator.send({
			command: "Notification#vibrate"
		})
	}
});
Ext.define("Ext.device.notification.Simulator", {
	extend: Ext.device.notification.Abstract,
	msg: null,
	show: function () {
		var a = this.callParent(arguments),
			e = [],
			d = a.buttons.length,
			c, b, g, f;
		for (b = 0; b < d; b++) {
			c = a.buttons[b];
			if (Ext.isString(c)) {
				c = {
					text: a.buttons[b],
					itemId: a.buttons[b].toLowerCase()
				}
			}
			e.push(c)
		}
		this.msg = Ext.create("Ext.MessageBox");
		f = this.msg;
		g = function (h) {
			if (a.callback) {
				a.callback.apply(a.scope, [h])
			}
		};
		this.msg.show({
			title: a.title,
			message: a.message,
			scope: this.msg,
			buttons: e,
			fn: g
		})
	},
	vibrate: function () {
		var c = ["@-webkit-keyframes vibrate{", "    from {", "        -webkit-transform: rotate(-2deg);", "    }", "    to{", "        -webkit-transform: rotate(2deg);", "    }", "}", "body {", "    -webkit-animation: vibrate 50ms linear 10 alternate;", "}"];
		var b = document.getElementsByTagName("head")[0];
		var a = document.createElement("style");
		a.innerHTML = c.join("\n");
		b.appendChild(a);
		setTimeout(function () {
			b.removeChild(a)
		}, 400)
	}
});
Ext.define("Ext.device.Notification", {
	singleton: true,
	constructor: function () {
		var a = Ext.browser.is;
		if (a.WebView) {
			if (a.PhoneGap) {
				return Ext.create("Ext.device.notification.PhoneGap")
			} else {
				return Ext.create("Ext.device.notification.Sencha")
			}
		} else {
			return Ext.create("Ext.device.notification.Simulator")
		}
	}
});
Ext.define("Ext.event.Event", {
	alternateClassName: "Ext.EventObject",
	isStopped: false,
	set: function (a, b) {
		if (arguments.length === 1 && typeof a != "string") {
			var c = a;
			for (a in c) {
				if (c.hasOwnProperty(a)) {
					this[a] = c[a]
				}
			}
		} else {
			this[a] = c[a]
		}
	},
	stopEvent: function () {
		return this.stopPropagation()
	},
	stopPropagation: function () {
		this.isStopped = true;
		return this
	}
});
Ext.define("Ext.event.Dom", {
	extend: Ext.event.Event,
	constructor: function (a) {
		var c = a.target,
			b;
		if (c && c.nodeType !== 1) {
			c = c.parentNode
		}
		b = a.changedTouches;
		if (b) {
			b = b[0];
			this.pageX = b.pageX;
			this.pageY = b.pageY
		} else {
			this.pageX = a.pageX;
			this.pageY = a.pageY
		}
		this.browserEvent = this.event = a;
		this.target = this.delegatedTarget = c;
		this.type = a.type;
		this.timeStamp = this.time = +a.timeStamp;
		return this
	},
	stopEvent: function () {
		this.preventDefault();
		return this.callParent()
	},
	preventDefault: function () {
		this.browserEvent.preventDefault()
	},
	getPageX: function () {
		return this.pageX || this.browserEvent.pageX
	},
	getPageY: function () {
		return this.pageY || this.browserEvent.pageY
	},
	getXY: function () {
		if (!this.xy) {
			this.xy = [this.getPageX(), this.getPageY()]
		}
		return this.xy
	},
	getTarget: function (b, c, a) {
		if (arguments.length === 0) {
			return this.delegatedTarget
		}
		return b ? Ext.fly(this.target).findParent(b, c, a) : (a ? Ext.get(this.target) : this.target)
	},
	getTime: function () {
		return this.time
	},
	setDelegatedTarget: function (a) {
		this.delegatedTarget = a
	},
	makeUnpreventable: function () {
		this.browserEvent.preventDefault = Ext.emptyFn
	}
});
Ext.define("Ext.event.Touch", {
	extend: Ext.event.Dom,
	constructor: function (b, c, a, h) {
		var f = [],
			d, e, j, g;
		if (c) {
			this.set(c)
		}
		this.changedTouches = this.cloneTouches(b.changedTouches, a);
		for (e = 0, j = h.length; e < j; e++) {
			g = h[e];
			f.push(a[g])
		}
		this.touches = f;
		this.targetTouches = f.slice();
		d = this.changedTouches[0];
		this.callSuper([b]);
		this.target = this.delegatedTarget = d.target;
		this.pageX = d.pageX;
		this.pageY = d.pageY
	},
	cloneTouches: function (f, e) {
		var d = [],
			b, c, g, a;
		for (b = 0, c = f.length; b < c; b++) {
			g = f[b];
			a = g.identifier;
			d[b] = e[a]
		}
		return d
	}
});
Ext.define("Ext.event.publisher.Publisher", {
	targetType: "",
	idSelectorRegex: /^#([\w\-]+)$/i,
	constructor: function () {
		var b = this.handledEvents,
			a, c, e, d;
		a = this.handledEventsMap = {};
		for (c = 0, e = b.length; c < e; c++) {
			d = b[c];
			a[d] = true
		}
		this.subscribers = {};
		return this
	},
	handles: function (a) {
		var b = this.handledEventsMap;
		return !!b[a] || !! b["*"] || a === "*"
	},
	getHandledEvents: function () {
		return this.handledEvents
	},
	setDispatcher: function (a) {
		this.dispatcher = a
	},
	subscribe: function () {
		return false
	},
	unsubscribe: function () {
		return false
	},
	unsubscribeAll: function () {
		delete this.subscribers;
		this.subscribers = {};
		return this
	},
	notify: function () {
		return false
	},
	getTargetType: function () {
		return this.targetType
	},
	dispatch: function (c, a, b) {
		this.dispatcher.doDispatchEvent(this.targetType, c, a, b)
	}
});
Ext.define("Ext.event.publisher.ComponentDelegation", {
	extend: Ext.event.publisher.Publisher,
	targetType: "component",
	optimizedSelectorRegex: /^#([\w\-]+)((?:[\s]*)>(?:[\s]*)|(?:\s*))([\w\-]+)$/i,
	handledEvents: ["*"],
	getSubscribers: function (b, a) {
		var d = this.subscribers,
			c = d[b];
		if (!c && a) {
			c = d[b] = {
				type: {
					$length: 0
				},
				selector: [],
				$length: 0
			}
		}
		return c
	},
	subscribe: function (g, f) {
		if (this.idSelectorRegex.test(g)) {
			return false
		}
		var e = g.match(this.optimizedSelectorRegex),
			a = this.getSubscribers(f, true),
			l = a.type,
			c = a.selector,
			d, j, k, b, h;
		if (e !== null) {
			d = e[1];
			j = e[2].indexOf(">") === -1;
			k = e[3];
			b = l[k];
			if (!b) {
				l[k] = b = {
					descendents: {
						$length: 0
					},
					children: {
						$length: 0
					},
					$length: 0
				}
			}
			h = j ? b.descendents : b.children;
			if (h.hasOwnProperty(d)) {
				h[d]++;
				return true
			}
			h[d] = 1;
			h.$length++;
			b.$length++;
			l.$length++
		} else {
			if (c.hasOwnProperty(g)) {
				c[g]++;
				return true
			}
			c[g] = 1;
			c.push(g)
		}
		a.$length++;
		return true
	},
	unsubscribe: function (g, f, l) {
		var a = this.getSubscribers(f);
		if (!a) {
			return false
		}
		var e = g.match(this.optimizedSelectorRegex),
			m = a.type,
			c = a.selector,
			d, j, k, b, h;
		l = Boolean(l);
		if (e !== null) {
			d = e[1];
			j = e[2].indexOf(">") === -1;
			k = e[3];
			b = m[k];
			if (!b) {
				return true
			}
			h = j ? b.descendents : b.children;
			if (!h.hasOwnProperty(d) || (!l && --h[d] > 0)) {
				return true
			}
			delete h[d];
			h.$length--;
			b.$length--;
			m.$length--
		} else {
			if (!c.hasOwnProperty(g) || (!l && --c[g] > 0)) {
				return true
			}
			delete c[g];
			Ext.Array.remove(c, g)
		}
		if (--a.$length === 0) {
			delete this.subscribers[f]
		}
		return true
	},
	notify: function (d, a) {
		var c = this.getSubscribers(a),
			e, b;
		if (!c || c.$length === 0) {
			return false
		}
		e = d.substr(1);
		b = Ext.ComponentManager.get(e);
		if (b) {
			this.dispatcher.doAddListener(this.targetType, d, a, "publish", this, {
				args: [a, b]
			}, "before")
		}
	},
	matchesSelector: function (b, a) {
		return Ext.ComponentQuery.is(b, a)
	},
	dispatch: function (d, b, c, a) {
		this.dispatcher.doDispatchEvent(this.targetType, d, b, c, null, a)
	},
	publish: function (g, k) {
		var e = this.getSubscribers(g);
		if (!e) {
			return
		}
		var p = arguments[arguments.length - 1],
			o = e.type,
			b = e.selector,
			d = Array.prototype.slice.call(arguments, 2, -2),
			l = k.xtypesChain,
			s, n, t, a, m, v, r, u, h, f, q, c;
		for (u = 0, h = l.length; u < h; u++) {
			f = l[u];
			e = o[f];
			if (e && e.$length > 0) {
				s = e.descendents;
				if (s.$length > 0) {
					if (!a) {
						a = k.getAncestorIds()
					}
					for (q = 0, c = a.length; q < c; q++) {
						m = a[q];
						if (s.hasOwnProperty(m)) {
							this.dispatch("#" + m + " " + f, g, d, p)
						}
					}
				}
				n = e.children;
				if (n.$length > 0) {
					if (!t) {
						if (a) {
							t = a[0]
						} else {
							v = k.getParent();
							if (v) {
								t = v.getId()
							}
						}
					}
					if (t) {
						if (n.hasOwnProperty(t)) {
							this.dispatch("#" + t + " > " + f, g, d, p)
						}
					}
				}
			}
		}
		h = b.length;
		if (h > 0) {
			for (u = 0; u < h; u++) {
				r = b[u];
				if (this.matchesSelector(k, r)) {
					this.dispatch(r, g, d, p)
				}
			}
		}
	}
});
Ext.define("Ext.event.publisher.ComponentPaint", {
	extend: Ext.event.publisher.Publisher,
	targetType: "component",
	handledEvents: ["erased"],
	eventNames: {
		painted: "painted",
		erased: "erased"
	},
	constructor: function () {
		this.callParent(arguments);
		this.hiddenQueue = {};
		this.renderedQueue = {}
	},
	getSubscribers: function (b, a) {
		var c = this.subscribers;
		if (!c.hasOwnProperty(b)) {
			if (!a) {
				return null
			}
			c[b] = {
				$length: 0
			}
		}
		return c[b]
	},
	setDispatcher: function (a) {
		var b = this.targetType;
		a.doAddListener(b, "*", "renderedchange", "onBeforeComponentRenderedChange", this, null, "before");
		a.doAddListener(b, "*", "hiddenchange", "onBeforeComponentHiddenChange", this, null, "before");
		a.doAddListener(b, "*", "renderedchange", "onComponentRenderedChange", this, null, "after");
		a.doAddListener(b, "*", "hiddenchange", "onComponentHiddenChange", this, null, "after");
		return this.callParent(arguments)
	},
	subscribe: function (d, a) {
		var b = d.match(this.idSelectorRegex),
			c, e;
		if (!b) {
			return false
		}
		e = b[1];
		c = this.getSubscribers(a, true);
		if (c.hasOwnProperty(e)) {
			c[e]++;
			return true
		}
		c[e] = 1;
		c.$length++;
		return true
	},
	unsubscribe: function (e, a, c) {
		var b = e.match(this.idSelectorRegex),
			d, f;
		if (!b || !(d = this.getSubscribers(a))) {
			return false
		}
		f = b[1];
		if (!d.hasOwnProperty(f) || (!c && --d[f] > 0)) {
			return true
		}
		delete d[f];
		if (--d.$length === 0) {
			delete this.subscribers[a]
		}
		return true
	},
	onBeforeComponentRenderedChange: function (b, d, g) {
		var f = this.eventNames,
			c = g ? f.painted : f.erased,
			e = this.getSubscribers(c),
			a;
		if (e && e.$length > 0) {
			this.renderedQueue[d.getId()] = a = [];
			this.publish(e, d, c, a)
		}
	},
	onBeforeComponentHiddenChange: function (c, d) {
		var f = this.eventNames,
			b = d ? f.erased : f.painted,
			e = this.getSubscribers(b),
			a;
		if (e && e.$length > 0) {
			this.hiddenQueue[c.getId()] = a = [];
			this.publish(e, c, b, a)
		}
	},
	onComponentRenderedChange: function (b, c) {
		var d = this.renderedQueue,
			e = c.getId(),
			a;
		if (!d.hasOwnProperty(e)) {
			return
		}
		a = d[e];
		delete d[e];
		if (a.length > 0) {
			this.dispatchQueue(a)
		}
	},
	onComponentHiddenChange: function (c) {
		var b = this.hiddenQueue,
			d = c.getId(),
			a;
		if (!b.hasOwnProperty(d)) {
			return
		}
		a = b[d];
		delete b[d];
		if (a.length > 0) {
			this.dispatchQueue(a)
		}
	},
	dispatchQueue: function (g) {
		var l = this.dispatcher,
			a = this.targetType,
			b = this.eventNames,
			e = g.slice(),
			f = e.length,
			c, k, h, d, j;
		g.length = 0;
		if (f > 0) {
			for (c = 0; c < f; c++) {
				k = e[c];
				h = k.component;
				d = k.eventName;
				j = h.isPainted();
				if ((d === b.painted && j) || d === b.erased && !j) {
					l.doDispatchEvent(a, "#" + k.id, d, [h])
				}
			}
			e.length = 0
		}
	},
	publish: function (a, k, f, j) {
		var c = k.getId(),
			b = false,
			d, h, e, g, l;
		if (a[c]) {
			d = this.eventNames;
			l = k.isPainted();
			if ((f === d.painted && !l) || f === d.erased && l) {
				b = true
			} else {
				return this
			}
		}
		if (k.isContainer) {
			h = k.getItems().items;
			for (e = 0, g = h.length; e < g; e++) {
				this.publish(a, h[e], f, j)
			}
		} else {
			if (k.isDecorator) {
				this.publish(a, k.getComponent(), f, j)
			}
		}
		if (b) {
			j.push({
				id: c,
				eventName: f,
				component: k
			})
		}
	}
});
Ext.define("Ext.event.publisher.Dom", {
	extend: Ext.event.publisher.Publisher,
	targetType: "element",
	idOrClassSelectorRegex: /^([#|\.])([\w\-]+)$/,
	handledEvents: ["focus", "blur", "paste", "input", "change", "keyup", "keydown", "keypress", "submit", "transitionend", "animationstart", "animationend"],
	classNameSplitRegex: /\s+/,
	SELECTOR_ALL: "*",
	constructor: function () {
		var f = this.getHandledEvents(),
			e = {},
			b, c, a, d;
		this.doBubbleEventsMap = {
			click: true,
			submit: true,
			mousedown: true,
			mousemove: true,
			mouseup: true,
			mouseover: true,
			mouseout: true,
			transitionend: true
		};
		this.onEvent = Ext.Function.bind(this.onEvent, this);
		for (b = 0, c = f.length; b < c; b++) {
			a = f[b];
			d = this.getVendorEventName(a);
			e[d] = a;
			this.attachListener(d)
		}
		this.eventNameMap = e;
		return this.callParent()
	},
	getSubscribers: function (a) {
		var c = this.subscribers,
			b = c[a];
		if (!b) {
			b = c[a] = {
				id: {
					$length: 0
				},
				className: {
					$length: 0
				},
				selector: [],
				all: 0,
				$length: 0
			}
		}
		return b
	},
	getVendorEventName: function (a) {
		if (Ext.browser.is.WebKit) {
			if (a === "transitionend") {
				a = Ext.browser.getVendorProperyName("transitionEnd")
			} else {
				if (a === "animationstart") {
					a = Ext.browser.getVendorProperyName("animationStart")
				} else {
					if (a === "animationend") {
						a = Ext.browser.getVendorProperyName("animationEnd")
					}
				}
			}
		}
		return a
	},
	bindListeners: function (d, e) {
		var a = this.getHandledEvents(),
			c = a.length,
			b;
		for (b = 0; b < c; b++) {
			this.bindListener(d, this.getVendorEventName(a[b]), e)
		}
	},
	bindListener: function (b, a, c) {
		if (c) {
			this.attachListener(a, b)
		} else {
			this.removeListener(a, b)
		}
		return this
	},
	attachListener: function (a, d) {
		if (!d) {
			d = document
		}
		var b = d.defaultView,
			c;
		if (b && b.addEventListener) {
			c = b.addEventListener
		} else {
			c = d.addEventListener
		}
		c(a, this.onEvent, !this.doesEventBubble(a));
		return this
	},
	removeListener: function (a, d) {
		if (!d) {
			d = document
		}
		var b = d.defaultView,
			c;
		if (b && b.removeEventListener) {
			c = b.removeEventListener
		} else {
			c = d.addEventListener
		}
		c(a, this.onEvent, !this.doesEventBubble(a));
		return this
	},
	doesEventBubble: function (a) {
		return !!this.doBubbleEventsMap[a]
	},
	subscribe: function (g, f) {
		if (!this.handles(f)) {
			return false
		}
		var e = g.match(this.idOrClassSelectorRegex),
			a = this.getSubscribers(f),
			c = a.id,
			d = a.className,
			b = a.selector,
			h, j;
		if (e !== null) {
			h = e[1];
			j = e[2];
			if (h === "#") {
				if (c.hasOwnProperty(j)) {
					c[j]++;
					return true
				}
				c[j] = 1;
				c.$length++
			} else {
				if (d.hasOwnProperty(j)) {
					d[j]++;
					return true
				}
				d[j] = 1;
				d.$length++
			}
		} else {
			if (g === this.SELECTOR_ALL) {
				a.all++
			} else {
				if (b.hasOwnProperty(g)) {
					b[g]++;
					return true
				}
				b[g] = 1;
				b.push(g)
			}
		}
		a.$length++;
		return true
	},
	unsubscribe: function (g, f, k) {
		if (!this.handles(f)) {
			return false
		}
		var e = g.match(this.idOrClassSelectorRegex),
			a = this.getSubscribers(f),
			c = a.id,
			d = a.className,
			b = a.selector,
			h, j;
		k = Boolean(k);
		if (e !== null) {
			h = e[1];
			j = e[2];
			if (h === "#") {
				if (!c.hasOwnProperty(j) || (!k && --c[j] > 0)) {
					return true
				}
				delete c[j];
				c.$length--
			} else {
				if (!d.hasOwnProperty(j) || (!k && --d[j] > 0)) {
					return true
				}
				delete d[j];
				d.$length--
			}
		} else {
			if (g === this.SELECTOR_ALL) {
				if (k) {
					a.all = 0
				} else {
					a.all--
				}
			} else {
				if (!b.hasOwnProperty(g) || (!k && --b[g] > 0)) {
					return true
				}
				delete b[g];
				Ext.Array.remove(b, g)
			}
		}
		a.$length--;
		return true
	},
	getElementTarget: function (a) {
		if (a.nodeType !== 1) {
			a = a.parentNode;
			if (!a || a.nodeType !== 1) {
				return null
			}
		}
		return a
	},
	getBubblingTargets: function (b) {
		var a = [];
		if (!b) {
			return a
		}
		do {
			a[a.length] = b;
			b = b.parentNode
		} while (b && b.nodeType === 1);
		return a
	},
	dispatch: function (c, a, b) {
		b.push(b[0].target);
		this.callParent(arguments)
	},
	publish: function (b, a, c) {
		var d = this.getSubscribers(b),
			e;
		if (d.$length === 0 || !this.doPublish(d, b, a, c)) {
			e = this.getSubscribers("*");
			if (e.$length > 0) {
				this.doPublish(e, b, a, c)
			}
		}
		return this
	},
	doPublish: function (f, h, x, u) {
		var r = f.id,
			g = f.className,
			b = f.selector,
			p = r.$length > 0,
			a = g.$length > 0,
			l = b.length > 0,
			o = f.all > 0,
			y = {},
			e = [u],
			q = false,
			m = this.classNameSplitRegex,
			v, k, t, d, z, n, c, w, s;
		for (v = 0, k = x.length; v < k; v++) {
			z = x[v];
			u.setDelegatedTarget(z);
			if (p) {
				n = z.id;
				if (n) {
					if (r.hasOwnProperty(n)) {
						q = true;
						this.dispatch("#" + n, h, e)
					}
				}
			}
			if (a) {
				c = z.className;
				if (c) {
					w = c.split(m);
					for (t = 0, d = w.length; t < d; t++) {
						c = w[t];
						if (!y[c]) {
							y[c] = true;
							if (g.hasOwnProperty(c)) {
								q = true;
								this.dispatch("." + c, h, e)
							}
						}
					}
				}
			}
			if (u.isStopped) {
				return q
			}
		}
		if (o && !q) {
			u.setDelegatedTarget(u.browserEvent.target);
			q = true;
			this.dispatch(this.SELECTOR_ALL, h, e);
			if (u.isStopped) {
				return q
			}
		}
		if (l) {
			for (t = 0, d = x.length; t < d; t++) {
				z = x[t];
				for (v = 0, k = b.length; v < k; v++) {
					s = b[v];
					if (this.matchesSelector(z, s)) {
						u.setDelegatedTarget(z);
						q = true;
						this.dispatch(s, h, e)
					}
					if (u.isStopped) {
						return q
					}
				}
			}
		}
		return q
	},
	matchesSelector: function () {
		var b = Element.prototype,
			a = ("webkitMatchesSelector" in b) ? "webkitMatchesSelector" : (("msMatchesSelector" in b) ? "msMatchesSelector" : ("mozMatchesSelector" in b ? "mozMatchesSelector" : null));
		if (a) {
			return function (d, c) {
				return d[a](c)
			}
		}
		return function (d, c) {
			Ext.DomQuery.is(d, c)
		}
	}(),
	onEvent: function (d) {
		var b = this.eventNameMap[d.type];
		Ext.frameStartTime = d.timeStamp;
		if (!b || this.getSubscribersCount(b) === 0) {
			return
		}
		var c = this.getElementTarget(d.target),
			a;
		if (!c) {
			return
		}
		if (this.doesEventBubble(b)) {
			a = this.getBubblingTargets(c)
		} else {
			a = [c]
		}
		this.publish(b, a, new Ext.event.Dom(d))
	},
	getSubscribersCount: function (a) {
		if (!this.handles(a)) {
			return 0
		}
		return this.getSubscribers(a).$length + this.getSubscribers("*").$length
	}
});
Ext.define("Ext.util.paintmonitor.Abstract", {
	config: {
		element: null,
		callback: Ext.emptyFn,
		scope: null,
		args: []
	},
	eventName: "",
	monitorClass: "",
	constructor: function (a) {
		this.onElementPainted = Ext.Function.bind(this.onElementPainted, this);
		this.initConfig(a)
	},
	bindListeners: function (a) {
		this.monitorElement[a ? "addEventListener" : "removeEventListener"](this.eventName, this.onElementPainted, true)
	},
	applyElement: function (a) {
		if (a) {
			return Ext.get(a)
		}
	},
	updateElement: function (a) {
		this.monitorElement = Ext.Element.create({
			classList: ["x-paint-monitor", this.monitorClass]
		}, true);
		a.appendChild(this.monitorElement);
		a.addCls("x-paint-monitored");
		this.bindListeners(true)
	},
	onElementPainted: function () {},
	destroy: function () {
		var b = this.monitorElement,
			a = b.parentNode,
			c = this.getElement();
		this.bindListeners(false);
		delete this.monitorElement;
		if (c && !c.isDestroyed) {
			c.removeCls("x-paint-monitored");
			delete this._element
		}
		if (a) {
			a.removeChild(b)
		}
		this.callSuper()
	}
});
Ext.define("Ext.util.paintmonitor.CssAnimation", {
	extend: Ext.util.paintmonitor.Abstract,
	eventName: Ext.browser.is.WebKit ? "webkitAnimationEnd" : "animationend",
	monitorClass: "cssanimation",
	onElementPainted: function (a) {
		if (a.animationName === "x-paint-monitor-helper") {
			this.getCallback().apply(this.getScope(), this.getArgs())
		}
	}
});
Ext.define("Ext.util.paintmonitor.OverflowChange", {
	extend: Ext.util.paintmonitor.Abstract,
	eventName: Ext.browser.is.Firefox ? "overflow" : "overflowchanged",
	monitorClass: "overflowchange",
	onElementPainted: function (a) {
		this.getCallback().apply(this.getScope(), this.getArgs())
	}
});
Ext.define("Ext.util.PaintMonitor", {
	constructor: function (a) {
		if (Ext.browser.is.Firefox || (Ext.browser.is.WebKit && Ext.browser.engineVersion.gtEq("536") && !Ext.os.is.Blackberry)) {
			return new Ext.util.paintmonitor.OverflowChange(a)
		} else {
			return new Ext.util.paintmonitor.CssAnimation(a)
		}
	}
});
Ext.define("Ext.event.publisher.ElementPaint", {
	extend: Ext.event.publisher.Publisher,
	targetType: "element",
	handledEvents: ["painted"],
	constructor: function () {
		this.monitors = {};
		this.callSuper(arguments)
	},
	subscribe: function (d) {
		var a = d.match(this.idSelectorRegex),
			c = this.subscribers,
			e, b;
		if (!a) {
			return false
		}
		e = a[1];
		if (c.hasOwnProperty(e)) {
			c[e]++;
			return true
		}
		c[e] = 1;
		b = Ext.get(e);
		this.monitors[e] = new Ext.util.PaintMonitor({
			element: b,
			callback: this.onElementPainted,
			scope: this,
			args: [d, b]
		});
		return true
	},
	unsubscribe: function (e, a, c) {
		var b = e.match(this.idSelectorRegex),
			d = this.subscribers,
			f;
		if (!b) {
			return false
		}
		f = b[1];
		if (!d.hasOwnProperty(f) || (!c && --d[f] > 0)) {
			return true
		}
		delete d[f];
		this.monitors[f].destroy();
		delete this.monitors[f];
		return true
	},
	onElementPainted: function (b, a) {
		Ext.TaskQueue.requestRead("dispatch", this, [b, "painted", [a]])
	}
});
Ext.define("Ext.mixin.Templatable", {
	extend: Ext.mixin.Mixin,
	mixinConfig: {
		id: "templatable"
	},
	referenceAttributeName: "reference",
	referenceSelector: "[reference]",
	getElementConfig: function () {
		return {
			reference: "element"
		}
	},
	getElementTemplate: function () {
		var a = document.createDocumentFragment();
		a.appendChild(Ext.Element.create(this.getElementConfig(), true));
		return a
	},
	initElement: function () {
		var a = this.self.prototype;
		a.elementTemplate = this.getElementTemplate();
		a.initElement = a.doInitElement;
		this.initElement.apply(this, arguments)
	},
	linkElement: function (a, b) {
		this.link(a, b)
	},
	doInitElement: function () {
		var g = this.referenceAttributeName,
			c, d, e, f, b, a;
		c = this.elementTemplate.cloneNode(true);
		d = c.querySelectorAll(this.referenceSelector);
		for (e = 0, f = d.length; e < f; e++) {
			b = d[e];
			a = b.getAttribute(g);
			b.removeAttribute(g);
			this.linkElement(a, b)
		}
	}
});
Ext.define("Ext.util.sizemonitor.Abstract", {
	mixins: [Ext.mixin.Templatable],
	config: {
		element: null,
		callback: Ext.emptyFn,
		scope: null,
		args: []
	},
	width: 0,
	height: 0,
	contentWidth: 0,
	contentHeight: 0,
	constructor: function (a) {
		this.refresh = Ext.Function.bind(this.refresh, this);
		this.info = {
			width: 0,
			height: 0,
			contentWidth: 0,
			contentHeight: 0,
			flag: 0
		};
		this.initElement();
		this.initConfig(a);
		this.bindListeners(true)
	},
	bindListeners: Ext.emptyFn,
	applyElement: function (a) {
		if (a) {
			return Ext.get(a)
		}
	},
	updateElement: function (a) {
		a.append(this.detectorsContainer);
		a.addCls("x-size-monitored")
	},
	applyArgs: function (a) {
		return a.concat([this.info])
	},
	refreshMonitors: Ext.emptyFn,
	forceRefresh: function () {
		Ext.TaskQueue.requestRead("refresh", this)
	},
	getContentBounds: function () {
		return this.detectorsContainer.getBoundingClientRect()
	},
	getContentWidth: function () {
		return this.detectorsContainer.offsetWidth
	},
	getContentHeight: function () {
		return this.detectorsContainer.offsetHeight
	},
	refreshSize: function () {
		var d = this.getElement();
		if (!d || d.isDestroyed) {
			return false
		}
		var b = d.getWidth(),
			k = d.getHeight(),
			a = this.getContentWidth(),
			j = this.getContentHeight(),
			h = this.contentWidth,
			f = this.contentHeight,
			c = this.info,
			e = false,
			g;
		this.width = b;
		this.height = k;
		this.contentWidth = a;
		this.contentHeight = j;
		g = ((h !== a ? 1 : 0) + (f !== j ? 2 : 0));
		if (g > 0) {
			c.width = b;
			c.height = k;
			c.contentWidth = a;
			c.contentHeight = j;
			c.flag = g;
			e = true;
			this.getCallback().apply(this.getScope(), this.getArgs())
		}
		return e
	},
	refresh: function (a) {
		if (this.refreshSize() || a) {
			Ext.TaskQueue.requestWrite("refreshMonitors", this)
		}
	},
	destroy: function () {
		var a = this.getElement();
		this.bindListeners(false);
		if (a && !a.isDestroyed) {
			a.removeCls("x-size-monitored")
		}
		delete this._element;
		this.callSuper()
	}
});
Ext.define("Ext.util.sizemonitor.Default", {
	extend: Ext.util.sizemonitor.Abstract,
	updateElement: function (a) {},
	bindListeners: function (b) {
		var a = this.getElement().dom;
		if (!a) {
			return
		}
		if (b) {
			a.onresize = this.refresh
		} else {
			delete a.onresize
		}
	},
	getContentBounds: function () {
		return this.getElement().dom.getBoundingClientRect()
	},
	getContentWidth: function () {
		return this.getElement().getWidth()
	},
	getContentHeight: function () {
		return this.getElement().getHeight()
	}
});
Ext.define("Ext.util.sizemonitor.Scroll", {
	extend: Ext.util.sizemonitor.Abstract,
	getElementConfig: function () {
		return {
			reference: "detectorsContainer",
			classList: ["x-size-monitors", "scroll"],
			children: [{
				reference: "expandMonitor",
				className: "expand"
			}, {
				reference: "shrinkMonitor",
				className: "shrink"
			}]
		}
	},
	constructor: function (a) {
		this.onScroll = Ext.Function.bind(this.onScroll, this);
		this.callSuper(arguments)
	},
	bindListeners: function (b) {
		var a = b ? "addEventListener" : "removeEventListener";
		this.expandMonitor[a]("scroll", this.onScroll, true);
		this.shrinkMonitor[a]("scroll", this.onScroll, true)
	},
	forceRefresh: function () {
		Ext.TaskQueue.requestRead("refresh", this, [true])
	},
	onScroll: function () {
		Ext.TaskQueue.requestRead("refresh", this)
	},
	refreshMonitors: function () {
		var b = this.expandMonitor,
			c = this.shrinkMonitor,
			a = 1000000;
		if (b && !b.isDestroyed) {
			b.scrollLeft = a;
			b.scrollTop = a
		}
		if (c && !c.isDestroyed) {
			c.scrollLeft = a;
			c.scrollTop = a
		}
	}
});
Ext.define("Ext.util.sizemonitor.OverflowChange", {
	extend: Ext.util.sizemonitor.Abstract,
	constructor: function (a) {
		this.onExpand = Ext.Function.bind(this.onExpand, this);
		this.onShrink = Ext.Function.bind(this.onShrink, this);
		this.callSuper(arguments)
	},
	getElementConfig: function () {
		return {
			reference: "detectorsContainer",
			classList: ["x-size-monitors", "overflowchanged"],
			children: [{
				reference: "expandMonitor",
				className: "expand",
				children: [{
					reference: "expandHelper"
				}]
			}, {
				reference: "shrinkMonitor",
				className: "shrink",
				children: [{
					reference: "shrinkHelper"
				}]
			}]
		}
	},
	bindListeners: function (b) {
		var a = b ? "addEventListener" : "removeEventListener";
		this.expandMonitor[a](Ext.browser.is.Firefox ? "underflow" : "overflowchanged", this.onExpand, true);
		this.shrinkMonitor[a](Ext.browser.is.Firefox ? "overflow" : "overflowchanged", this.onShrink, true)
	},
	onExpand: function (a) {
		if (Ext.browser.is.Webkit && a.horizontalOverflow && a.verticalOverflow) {
			return
		}
		Ext.TaskQueue.requestRead("refresh", this)
	},
	onShrink: function (a) {
		if (Ext.browser.is.Webkit && !a.horizontalOverflow && !a.verticalOverflow) {
			return
		}
		Ext.TaskQueue.requestRead("refresh", this)
	},
	refreshMonitors: function () {
		if (this.isDestroyed) {
			return
		}
		var f = this.expandHelper,
			e = this.shrinkHelper,
			b = this.getContentBounds(),
			d = b.width,
			a = b.height,
			c;
		if (f && !f.isDestroyed) {
			c = f.style;
			c.width = (d + 1) + "px";
			c.height = (a + 1) + "px"
		}
		if (e && !e.isDestroyed) {
			c = e.style;
			c.width = d + "px";
			c.height = a + "px"
		}
		Ext.TaskQueue.requestRead("refresh", this)
	}
});
Ext.define("Ext.util.SizeMonitor", {
	constructor: function (a) {
		var b = Ext.util.sizemonitor;
		if (Ext.browser.is.Firefox) {
			return new b.OverflowChange(a)
		} else {
			if (Ext.browser.is.WebKit) {
				if (Ext.browser.engineVersion.gtEq("535")) {
					return new b.OverflowChange(a)
				} else {
					return new b.Scroll(a)
				}
			} else {
				return new b.Default(a)
			}
		}
	}
});
Ext.define("Ext.event.publisher.ElementSize", {
	extend: Ext.event.publisher.Publisher,
	targetType: "element",
	handledEvents: ["resize"],
	constructor: function () {
		this.monitors = {};
		this.callSuper(arguments)
	},
	subscribe: function (e) {
		var b = e.match(this.idSelectorRegex),
			d = this.subscribers,
			f, c, a;
		if (!b) {
			return false
		}
		f = b[1];
		if (d.hasOwnProperty(f)) {
			d[f]++;
			return true
		}
		d[f] = 1;
		c = Ext.get(f);
		this.monitors[f] = a = new Ext.util.SizeMonitor({
			element: c,
			callback: this.onElementResize,
			scope: this,
			args: [e, c]
		});
		this.dispatcher.addListener("element", e, "painted", "forceRefresh", a);
		return true
	},
	unsubscribe: function (g, a, e) {
		var c = g.match(this.idSelectorRegex),
			f = this.subscribers,
			d = this.monitors,
			h, b;
		if (!c) {
			return false
		}
		h = c[1];
		if (!f.hasOwnProperty(h) || (!e && --f[h] > 0)) {
			return true
		}
		delete f[h];
		b = d[h];
		this.dispatcher.removeListener("element", g, "painted", "forceRefresh", b);
		b.destroy();
		delete d[h];
		return true
	},
	onElementResize: function (c, a, b) {
		Ext.TaskQueue.requestRead("dispatch", this, [c, "resize", [a, b]])
	}
});
Ext.define("Ext.event.publisher.TouchGesture", {
	extend: Ext.event.publisher.Dom,
	isNotPreventable: /^(select|a)$/i,
	handledEvents: ["touchstart", "touchmove", "touchend", "touchcancel"],
	mouseToTouchMap: {
		mousedown: "touchstart",
		mousemove: "touchmove",
		mouseup: "touchend"
	},
	lastEventType: null,
	config: {
		moveThrottle: 0,
		recognizers: {}
	},
	constructor: function (a) {
		this.eventProcessors = {
			touchstart: this.onTouchStart,
			touchmove: this.onTouchMove,
			touchend: this.onTouchEnd,
			touchcancel: this.onTouchEnd
		};
		this.eventToRecognizerMap = {};
		this.activeRecognizers = [];
		this.touchesMap = {};
		this.currentIdentifiers = [];
		if (Ext.browser.is.Chrome && Ext.os.is.Android) {
			this.screenPositionRatio = Ext.browser.version.gt("18") ? 1 : 1 / window.devicePixelRatio
		} else {
			if (Ext.browser.is.AndroidStock4) {
				this.screenPositionRatio = 1
			} else {
				if (Ext.os.is.BlackBerry) {
					this.screenPositionRatio = 1 / window.devicePixelRatio
				} else {
					if (Ext.browser.engineName == "WebKit" && Ext.os.is.Desktop) {
						this.screenPositionRatio = 1
					} else {
						this.screenPositionRatio = window.innerWidth / window.screen.width
					}
				}
			}
		}
		this.initConfig(a);
		return this.callSuper()
	},
	applyRecognizers: function (b) {
		var c, a;
		for (c in b) {
			if (b.hasOwnProperty(c)) {
				a = b[c];
				if (a) {
					this.registerRecognizer(a)
				}
			}
		}
		return b
	},
	handles: function (a) {
		return this.callSuper(arguments) || this.eventToRecognizerMap.hasOwnProperty(a)
	},
	doesEventBubble: function () {
		return true
	},
	onEvent: function (f) {
		var d = f.type,
			b = this.lastEventType,
			c = [f];
		if (this.eventProcessors[d]) {
			this.eventProcessors[d].call(this, f);
			return
		}
		if ("button" in f && f.button > 0) {
			return
		} else {
			if (d === "mousedown" && b && b !== "mouseup") {
				var a = document.createEvent("MouseEvent");
				a.initMouseEvent("mouseup", f.bubbles, f.cancelable, document.defaultView, f.detail, f.screenX, f.screenY, f.clientX, f.clientY, f.ctrlKey, f.altKey, f.shiftKey, f.metaKey, f.metaKey, f.button, f.relatedTarget);
				this.onEvent(a)
			}
			if (d !== "mousemove") {
				this.lastEventType = d
			}
			f.identifier = 1;
			f.touches = (d !== "mouseup") ? c : [];
			f.targetTouches = (d !== "mouseup") ? c : [];
			f.changedTouches = c;
			this.eventProcessors[this.mouseToTouchMap[d]].call(this, f)
		}
	},
	registerRecognizer: function (a) {
		var g = this.eventToRecognizerMap,
			e = this.activeRecognizers,
			c = a.getHandledEvents(),
			d, f, b;
		a.setOnRecognized(this.onRecognized);
		a.setCallbackScope(this);
		for (d = 0, f = c.length; d < f; d++) {
			b = c[d];
			g[b] = a
		}
		e.push(a);
		return this
	},
	onRecognized: function (f, h, d, a) {
		var k = [],
			j = d.length,
			g, c, b;
		if (j === 1) {
			return this.publish(f, d[0].targets, h, a)
		}
		for (c = 0; c < j; c++) {
			b = d[c];
			k.push(b.targets)
		}
		g = this.getCommonTargets(k);
		this.publish(f, g, h, a)
	},
	publish: function (b, a, c, d) {
		c.set(d);
		return this.callSuper([b, a, c])
	},
	getCommonTargets: function (a) {
		var h = a[0],
			f = a.length;
		if (f === 1) {
			return h
		}
		var d = [],
			e = 1,
			g, b, c;
		while (true) {
			g = h[h.length - e];
			if (!g) {
				return d
			}
			for (c = 1; c < f; c++) {
				b = a[c];
				if (b[b.length - e] !== g) {
					return d
				}
			}
			d.unshift(g);
			e++
		}
		return d
	},
	invokeRecognizers: function (c, g) {
		var b = this.activeRecognizers,
			f = b.length,
			d, a;
		if (c === "onStart") {
			for (d = 0; d < f; d++) {
				b[d].isActive = true
			}
		}
		for (d = 0; d < f; d++) {
			a = b[d];
			if (a.isActive && a[c].call(a, g) === false) {
				a.isActive = false
			}
		}
	},
	getActiveRecognizers: function () {
		return this.activeRecognizers
	},
	updateTouch: function (f) {
		var b = f.identifier,
			d = this.touchesMap[b],
			c, a, e;
		if (!d) {
			c = this.getElementTarget(f.target);
			this.touchesMap[b] = d = {
				identifier: b,
				target: c,
				targets: this.getBubblingTargets(c)
			};
			this.currentIdentifiers.push(b)
		}
		a = f.pageX;
		e = f.pageY;
		if (a === d.pageX && e === d.pageY) {
			return false
		}
		d.pageX = a;
		d.pageY = e;
		d.timeStamp = f.timeStamp;
		d.point = new Ext.util.Point(a, e);
		return d
	},
	updateTouches: function (d) {
		var a, c, e, b = [];
		for (a = 0, c = d.length; a < c; a++) {
			e = this.updateTouch(d[a]);
			if (e) {
				b.push(e)
			}
		}
		return b
	},
	factoryEvent: function (a) {
		return new Ext.event.Touch(a, null, this.touchesMap, this.currentIdentifiers)
	},
	onTouchStart: function (h) {
		var d = h.changedTouches,
			g = h.target,
			f = d.length,
			a = this.isNotPreventable,
			b, j, c;
		this.updateTouches(d);
		h = this.factoryEvent(h);
		d = h.changedTouches;
		for (b = 0; b < f; b++) {
			j = d[b];
			this.publish("touchstart", j.targets, h, {
				touch: j
			})
		}
		if (!this.isStarted) {
			this.isStarted = true;
			this.invokeRecognizers("onStart", h)
		}
		this.invokeRecognizers("onTouchStart", h);
		c = g.parentNode || {};
		if (Ext.os.is.iOS && !a.test(g.tagName) && !a.test(c.tagName)) {
			h.preventDefault()
		}
	},
	onTouchMove: function (a) {
		if (!this.isStarted) {
			return
		}
		if (!this.animationQueued) {
			this.animationQueued = true;
			Ext.AnimationQueue.start("onAnimationFrame", this)
		}
		this.lastMoveEvent = a
	},
	onAnimationFrame: function () {
		var a = this.lastMoveEvent;
		if (a) {
			this.lastMoveEvent = null;
			this.doTouchMove(a)
		}
	},
	doTouchMove: function (d) {
		var b, a, c, f;
		b = this.updateTouches(d.changedTouches);
		c = b.length;
		d = this.factoryEvent(d);
		for (a = 0; a < c; a++) {
			f = b[a];
			this.publish("touchmove", f.targets, d, {
				touch: f
			})
		}
		if (c > 0) {
			this.invokeRecognizers("onTouchMove", d)
		}
	},
	onTouchEnd: function (h) {
		if (!this.isStarted) {
			return
		}
		if (this.lastMoveEvent) {
			this.onAnimationFrame()
		}
		var a = this.touchesMap,
			d = this.currentIdentifiers,
			f = h.changedTouches,
			g = f.length,
			b, c, j;
		this.updateTouches(f);
		f = h.changedTouches;
		for (c = 0; c < g; c++) {
			Ext.Array.remove(d, f[c].identifier)
		}
		h = this.factoryEvent(h);
		for (c = 0; c < g; c++) {
			b = f[c].identifier;
			j = a[b];
			delete a[b];
			this.publish("touchend", j.targets, h, {
				touch: j
			})
		}
		this.invokeRecognizers("onTouchEnd", h);
		if (h.touches.length === 1 && d.length) {
			d.length = 0;
			this.touchesMap = {}
		}
		if (d.length === 0) {
			this.isStarted = false;
			this.invokeRecognizers("onEnd", h);
			if (this.animationQueued) {
				this.animationQueued = false;
				Ext.AnimationQueue.stop("onAnimationFrame", this)
			}
		}
	}
}, function () {
	if (Ext.feature.has.Pointer) {
		this.override({
			pointerToTouchMap: {
				MSPointerDown: "touchstart",
				MSPointerMove: "touchmove",
				MSPointerUp: "touchend",
				MSPointerCancel: "touchcancel"
			},
			touchToPointerMap: {
				touchstart: "MSPointerDown",
				touchmove: "MSPointerMove",
				touchend: "MSPointerUp",
				touchcancel: "MSPointerCancel"
			},
			attachListener: function (a, b) {
				a = this.touchToPointerMap[a];
				if (!a) {
					return
				}
				return this.callOverridden([a, b])
			},
			onEvent: function (b) {
				if ("button" in b && b.button > 0) {
					return
				}
				var a = this.pointerToTouchMap[b.type];
				b.identifier = b.pointerId;
				b.changedTouches = [b];
				this.eventProcessors[a].call(this, b)
			}
		})
	} else {
		if (Ext.os.is.ChromeOS || !Ext.feature.has.Touch) {
			this.override({
				handledEvents: ["touchstart", "touchmove", "touchend", "touchcancel", "mousedown", "mousemove", "mouseup"]
			})
		} else {
			if (!Ext.browser.is.Silk && Ext.feature.has.Touch) {
				Ext.onDocumentReady(function () {
					window.document.body.addEventListener("mousedown", function (a) {
						a.preventDefault();
						a.stopPropagation();
						return false
					}, true)
				})
			}
		}
	}
});
Ext.define("Ext.event.recognizer.Recognizer", {
	mixins: [Ext.mixin.Identifiable],
	handledEvents: [],
	config: {
		onRecognized: Ext.emptyFn,
		onFailed: Ext.emptyFn,
		callbackScope: null
	},
	constructor: function (a) {
		this.initConfig(a);
		return this
	},
	getHandledEvents: function () {
		return this.handledEvents
	},
	onStart: Ext.emptyFn,
	onEnd: Ext.emptyFn,
	fail: function () {
		this.getOnFailed().apply(this.getCallbackScope(), arguments);
		return false
	},
	fire: function () {
		this.getOnRecognized().apply(this.getCallbackScope(), arguments)
	}
});
Ext.define("Ext.event.recognizer.Touch", {
	extend: Ext.event.recognizer.Recognizer,
	onTouchStart: Ext.emptyFn,
	onTouchMove: Ext.emptyFn,
	onTouchEnd: Ext.emptyFn
});
Ext.define("Ext.event.recognizer.SingleTouch", {
	extend: Ext.event.recognizer.Touch,
	inheritableStatics: {
		NOT_SINGLE_TOUCH: 1,
		TOUCH_MOVED: 2
	},
	onTouchStart: function (a) {
		if (a.touches.length > 1) {
			return this.fail(this.self.NOT_SINGLE_TOUCH)
		}
	}
});
Ext.define("Ext.event.recognizer.DoubleTap", {
	extend: Ext.event.recognizer.SingleTouch,
	inheritableStatics: {
		DIFFERENT_TARGET: 3
	},
	config: {
		maxDuration: 300
	},
	handledEvents: ["singletap", "doubletap"],
	singleTapTimer: null,
	startTime: 0,
	lastTapTime: 0,
	onTouchStart: function (a) {
		if (this.callParent(arguments) === false) {
			return false
		}
		this.startTime = a.time;
		clearTimeout(this.singleTapTimer)
	},
	onTouchMove: function () {
		return this.fail(this.self.TOUCH_MOVED)
	},
	onEnd: function (g) {
		var j = this,
			d = this.getMaxDuration(),
			f = g.changedTouches[0],
			a = g.time,
			h = g.target,
			k = this.lastTapTime,
			b = this.lastTarget,
			c;
		this.lastTapTime = a;
		this.lastTarget = h;
		if (k) {
			c = a - k;
			if (c <= d) {
				if (h !== b) {
					return this.fail(this.self.DIFFERENT_TARGET)
				}
				this.lastTarget = null;
				this.lastTapTime = 0;
				this.fire("doubletap", g, [f], {
					touch: f,
					duration: c
				});
				return
			}
		}
		if (a - this.startTime > d) {
			this.fireSingleTap(g, f)
		} else {
			this.singleTapTimer = setTimeout(function () {
				j.fireSingleTap(g, f)
			}, d)
		}
	},
	fireSingleTap: function (a, b) {
		this.fire("singletap", a, [b], {
			touch: b
		})
	}
});
Ext.define("Ext.event.recognizer.Drag", {
	extend: Ext.event.recognizer.SingleTouch,
	isStarted: false,
	startPoint: null,
	previousPoint: null,
	lastPoint: null,
	handledEvents: ["dragstart", "drag", "dragend"],
	config: {
		minDistance: 8
	},
	constructor: function () {
		this.callSuper(arguments);
		this.info = {
			touch: null,
			previous: {
				x: 0,
				y: 0
			},
			x: 0,
			y: 0,
			delta: {
				x: 0,
				y: 0
			},
			absDelta: {
				x: 0,
				y: 0
			},
			flick: {
				velocity: {
					x: 0,
					y: 0
				}
			},
			direction: {
				x: 0,
				y: 0
			},
			time: 0,
			previousTime: {
				x: 0,
				y: 0
			}
		}
	},
	onTouchStart: function (a) {
		if (this.callSuper(arguments) === false) {
			if (this.isStarted && this.lastMoveEvent !== null) {
				this.onTouchEnd(this.lastMoveEvent)
			}
			return false
		}
		this.startTime = a.time;
		this.startPoint = a.changedTouches[0].point
	},
	tryDragStart: function (f) {
		var b = this.startPoint,
			d = f.changedTouches,
			h = d[0],
			a = h.point,
			g = this.getMinDistance(),
			c = this.info;
		if (Math.abs(a.getDistanceTo(b)) >= g) {
			this.isStarted = true;
			this.previousPoint = this.lastPoint = a;
			this.resetInfo("x", f, h);
			this.resetInfo("y", f, h);
			c.time = f.time;
			this.fire("dragstart", f, d, c)
		}
	},
	onTouchMove: function (c) {
		if (!this.isStarted) {
			this.tryDragStart(c)
		}
		if (!this.isStarted) {
			return
		}
		var b = c.changedTouches,
			d = b[0],
			a = d.point;
		if (this.lastPoint) {
			this.previousPoint = this.lastPoint
		}
		this.lastPoint = a;
		this.lastMoveEvent = c;
		this.updateInfo("x", c, d, true);
		this.updateInfo("y", c, d, true);
		this.info.time = c.time;
		this.fire("drag", c, b, this.info)
	},
	onAxisDragEnd: function (a, c) {
		var b = c.time - c.previousTime[a];
		if (b > 0) {
			c.flick.velocity[a] = (c[a] - c.previous[a]) / b
		}
	},
	resetInfo: function (c, g, j) {
		var d = this.lastPoint[c],
			b = this.startPoint[c],
			h = d - b,
			a = c.toUpperCase(),
			f = this.info;
		f.touch = j;
		f.delta[c] = h;
		f.absDelta[c] = Math.abs(h);
		f.previousTime[c] = this.startTime;
		f.previous[c] = b;
		f[c] = d;
		f.direction[c] = 0;
		f["start" + a] = this.startPoint[c];
		f["previous" + a] = f.previous[c];
		f["page" + a] = f[c];
		f["delta" + a] = f.delta[c];
		f["absDelta" + a] = f.absDelta[c];
		f["previousDelta" + a] = 0;
		f.startTime = this.startTime
	},
	updateInfo: function (f, l, k, m) {
		var d = l.time,
			o = this.lastPoint[f],
			g = this.previousPoint[f],
			a = this.startPoint[f],
			p = o - a,
			c = this.info,
			n = c.direction,
			j = f.toUpperCase(),
			b = c.previous[f],
			h;
		c.touch = k;
		h = c.delta[f];
		c.delta[f] = p;
		c.absDelta[f] = Math.abs(p);
		if (m && o !== b && o !== c[f] && d - c.previousTime[f] >= 50) {
			c.previous[f] = c[f];
			c.previousTime[f] = c.time
		}
		c[f] = o;
		if (o > g) {
			n[f] = 1
		} else {
			if (o < g) {
				n[f] = -1
			}
		}
		c["start" + j] = this.startPoint[f];
		c["previous" + j] = c.previous[f];
		c["page" + j] = c[f];
		c["delta" + j] = c.delta[f];
		c["absDelta" + j] = c.absDelta[f];
		c["previousDelta" + j] = h;
		c.startTime = this.startTime
	},
	onTouchEnd: function (d) {
		if (!this.isStarted) {
			this.tryDragStart(d)
		}
		if (this.isStarted) {
			var c = d.changedTouches,
				f = c[0],
				a = f.point,
				b = this.info;
			this.isStarted = false;
			this.lastPoint = a;
			this.updateInfo("x", d, f);
			this.updateInfo("y", d, f);
			b.time = d.time;
			this.onAxisDragEnd("x", b);
			this.onAxisDragEnd("y", b);
			this.fire("dragend", d, c, b);
			this.startPoint = null;
			this.previousPoint = null;
			this.lastPoint = null;
			this.lastMoveEvent = null
		}
	}
});
Ext.define("Ext.event.recognizer.Swipe", {
	extend: Ext.event.recognizer.SingleTouch,
	handledEvents: ["swipe"],
	inheritableStatics: {
		MAX_OFFSET_EXCEEDED: 16,
		MAX_DURATION_EXCEEDED: 17,
		DISTANCE_NOT_ENOUGH: 18
	},
	config: {
		minDistance: 80,
		maxOffset: 35,
		maxDuration: 1000
	},
	onTouchStart: function (a) {
		if (this.callParent(arguments) === false) {
			return false
		}
		var b = a.changedTouches[0];
		this.startTime = a.time;
		this.isHorizontal = true;
		this.isVertical = true;
		this.startX = b.pageX;
		this.startY = b.pageY
	},
	onTouchMove: function (f) {
		var h = f.changedTouches[0],
			b = h.pageX,
			g = h.pageY,
			c = Math.abs(b - this.startX),
			a = Math.abs(g - this.startY),
			d = f.time;
		if (d - this.startTime > this.getMaxDuration()) {
			return this.fail(this.self.MAX_DURATION_EXCEEDED)
		}
		if (this.isVertical && c > this.getMaxOffset()) {
			this.isVertical = false
		}
		if (this.isHorizontal && a > this.getMaxOffset()) {
			this.isHorizontal = false
		}
		if (!this.isHorizontal && !this.isVertical) {
			return this.fail(this.self.MAX_OFFSET_EXCEEDED)
		}
	},
	onTouchEnd: function (j) {
		if (this.onTouchMove(j) === false) {
			return false
		}
		var h = j.changedTouches[0],
			m = h.pageX,
			k = h.pageY,
			g = m - this.startX,
			f = k - this.startY,
			c = Math.abs(g),
			b = Math.abs(f),
			n = this.getMinDistance(),
			d = j.time - this.startTime,
			l, a;
		if (this.isVertical && b < n) {
			this.isVertical = false
		}
		if (this.isHorizontal && c < n) {
			this.isHorizontal = false
		}
		if (this.isHorizontal) {
			l = (g < 0) ? "left" : "right";
			a = c
		} else {
			if (this.isVertical) {
				l = (f < 0) ? "up" : "down";
				a = b
			} else {
				return this.fail(this.self.DISTANCE_NOT_ENOUGH)
			}
		}
		this.fire("swipe", j, [h], {
			touch: h,
			direction: l,
			distance: a,
			duration: d
		})
	}
});
Ext.define("Ext.event.recognizer.HorizontalSwipe", {
	extend: Ext.event.recognizer.Swipe,
	handledEvents: ["swipe"],
	onTouchStart: function (a) {
		if (this.callParent(arguments) === false) {
			return false
		}
		var b = a.changedTouches[0];
		this.startTime = a.time;
		this.startX = b.pageX;
		this.startY = b.pageY
	},
	onTouchMove: function (f) {
		var h = f.changedTouches[0],
			g = h.pageY,
			a = Math.abs(g - this.startY),
			d = f.time,
			c = this.getMaxDuration(),
			b = this.getMaxOffset();
		if (d - this.startTime > c) {
			return this.fail(this.self.MAX_DURATION_EXCEEDED)
		}
		if (a > b) {
			return this.fail(this.self.MAX_OFFSET_EXCEEDED)
		}
	},
	onTouchEnd: function (f) {
		if (this.onTouchMove(f) !== false) {
			var j = f.changedTouches[0],
				a = j.pageX,
				b = a - this.startX,
				h = Math.abs(b),
				d = f.time - this.startTime,
				g = this.getMinDistance(),
				c;
			if (h < g) {
				return this.fail(this.self.DISTANCE_NOT_ENOUGH)
			}
			c = (b < 0) ? "left" : "right";
			this.fire("swipe", f, [j], {
				touch: j,
				direction: c,
				distance: h,
				duration: d
			})
		}
	}
});
Ext.define("Ext.event.recognizer.LongPress", {
	extend: Ext.event.recognizer.SingleTouch,
	inheritableStatics: {
		DURATION_NOT_ENOUGH: 32
	},
	config: {
		minDuration: 1000
	},
	handledEvents: ["longpress"],
	fireLongPress: function (a) {
		var b = a.changedTouches[0];
		this.fire("longpress", a, [b], {
			touch: b,
			duration: this.getMinDuration()
		});
		this.isLongPress = true
	},
	onTouchStart: function (b) {
		var a = this;
		if (this.callParent(arguments) === false) {
			return false
		}
		this.isLongPress = false;
		this.timer = setTimeout(function () {
			a.fireLongPress(b)
		}, this.getMinDuration())
	},
	onTouchMove: function () {
		return this.fail(this.self.TOUCH_MOVED)
	},
	onTouchEnd: function () {
		if (!this.isLongPress) {
			return this.fail(this.self.DURATION_NOT_ENOUGH)
		}
	},
	fail: function () {
		clearTimeout(this.timer);
		return this.callParent(arguments)
	}
}, function () {
	this.override({
		handledEvents: ["longpress", "taphold"],
		fire: function (a) {
			if (a === "longpress") {
				var b = Array.prototype.slice.call(arguments);
				b[0] = "taphold";
				this.fire.apply(this, b)
			}
			return this.callOverridden(arguments)
		}
	})
});
Ext.define("Ext.event.recognizer.MultiTouch", {
	extend: Ext.event.recognizer.Touch,
	requiredTouchesCount: 2,
	isTracking: false,
	isStarted: false,
	onTouchStart: function (d) {
		var a = this.requiredTouchesCount,
			c = d.touches,
			b = c.length;
		if (b === a) {
			this.start(d)
		} else {
			if (b > a) {
				this.end(d)
			}
		}
	},
	onTouchEnd: function (a) {
		this.end(a)
	},
	start: function () {
		if (!this.isTracking) {
			this.isTracking = true;
			this.isStarted = false
		}
	},
	end: function (a) {
		if (this.isTracking) {
			this.isTracking = false;
			if (this.isStarted) {
				this.isStarted = false;
				this.fireEnd(a)
			}
		}
	}
});
Ext.define("Ext.event.recognizer.Pinch", {
	extend: Ext.event.recognizer.MultiTouch,
	requiredTouchesCount: 2,
	handledEvents: ["pinchstart", "pinch", "pinchend"],
	startDistance: 0,
	lastTouches: null,
	onTouchMove: function (c) {
		if (!this.isTracking) {
			return
		}
		var b = Array.prototype.slice.call(c.touches),
			d, a, f;
		d = b[0].point;
		a = b[1].point;
		f = d.getDistanceTo(a);
		if (f === 0) {
			return
		}
		if (!this.isStarted) {
			this.isStarted = true;
			this.startDistance = f;
			this.fire("pinchstart", c, b, {
				touches: b,
				distance: f,
				scale: 1
			})
		} else {
			this.fire("pinch", c, b, {
				touches: b,
				distance: f,
				scale: f / this.startDistance
			})
		}
		this.lastTouches = b
	},
	fireEnd: function (a) {
		this.fire("pinchend", a, this.lastTouches)
	},
	fail: function () {
		return this.callParent(arguments)
	}
});
Ext.define("Ext.event.recognizer.Rotate", {
	extend: Ext.event.recognizer.MultiTouch,
	requiredTouchesCount: 2,
	handledEvents: ["rotatestart", "rotate", "rotateend"],
	startAngle: 0,
	lastTouches: null,
	lastAngle: null,
	onTouchMove: function (h) {
		if (!this.isTracking) {
			return
		}
		var g = Array.prototype.slice.call(h.touches),
			b = this.lastAngle,
			d, f, c, a, j, k;
		d = g[0].point;
		f = g[1].point;
		c = d.getAngleTo(f);
		if (b !== null) {
			k = Math.abs(b - c);
			a = c + 360;
			j = c - 360;
			if (Math.abs(a - b) < k) {
				c = a
			} else {
				if (Math.abs(j - b) < k) {
					c = j
				}
			}
		}
		this.lastAngle = c;
		if (!this.isStarted) {
			this.isStarted = true;
			this.startAngle = c;
			this.fire("rotatestart", h, g, {
				touches: g,
				angle: c,
				rotation: 0
			})
		} else {
			this.fire("rotate", h, g, {
				touches: g,
				angle: c,
				rotation: c - this.startAngle
			})
		}
		this.lastTouches = g
	},
	fireEnd: function (a) {
		this.lastAngle = null;
		this.fire("rotateend", a, this.lastTouches)
	}
});
Ext.define("Ext.event.recognizer.Tap", {
	extend: Ext.event.recognizer.SingleTouch,
	handledEvents: ["tap", "tapcancel"],
	config: {
		moveDistance: 8
	},
	onTouchStart: function (a) {
		if (this.callSuper(arguments) === false) {
			return false
		}
		this.startPoint = a.changedTouches[0].point
	},
	onTouchMove: function (b) {
		var c = b.changedTouches[0],
			a = c.point;
		if (Math.abs(a.getDistanceTo(this.startPoint)) >= this.getMoveDistance()) {
			this.fire("tapcancel", b, [c], {
				touch: c
			});
			return this.fail(this.self.TOUCH_MOVED)
		}
	},
	onTouchEnd: function (a) {
		var b = a.changedTouches[0];
		this.fire("tap", a, [b], {
			touch: b
		})
	}
});
Ext.define("Ext.field.Checkbox", {
	extend: Ext.field.Field,
	alternateClassName: "Ext.form.Checkbox",
	xtype: "checkboxfield",
	qsaLeftRe: /[\[]/g,
	qsaRightRe: /[\]]/g,
	isCheckbox: true,
	config: {
		ui: "checkbox",
		value: "",
		checked: false,
		tabIndex: -1,
		component: {
			xtype: "input",
			type: "checkbox",
			useMask: true,
			cls: Ext.baseCSSPrefix + "input-checkbox"
		}
	},
	platformConfig: [{
		theme: ["Windows"],
		labelAlign: "left"
	}],
	initialize: function () {
		var b = this,
			a = b.getComponent();
		b.callParent();
		a.on({
			scope: b,
			order: "before",
			masktap: "onMaskTap"
		});
		a.doMaskTap = Ext.emptyFn;
		b.label.on({
			scope: b,
			tap: "onMaskTap"
		})
	},
	doInitValue: function () {
		var a = this,
			b = a.getInitialConfig();
		if (b.hasOwnProperty("value")) {
			a.originalState = b.value
		}
		if (b.hasOwnProperty("checked")) {
			a.originalState = b.checked
		}
		a.callParent(arguments)
	},
	updateInputType: function (a) {
		var b = this.getComponent();
		if (b) {
			b.setType(a)
		}
	},
	updateName: function (a) {
		var b = this.getComponent();
		if (b) {
			b.setName(a)
		}
	},
	getChecked: function () {
		this._checked = this.getComponent().getChecked();
		return this._checked
	},
	getSubmitValue: function () {
		return (this.getChecked()) ? Ext.isEmpty(this._value) ? true : this._value : null
	},
	setChecked: function (a) {
		this.updateChecked(a);
		this._checked = a
	},
	updateChecked: function (a) {
		this.getComponent().setChecked(a);
		if (this.initialized) {
			this.onChange()
		}
	},
	onMaskTap: function (a, c) {
		var b = this,
			d = b.getComponent().input.dom;
		if (b.getDisabled()) {
			return false
		}
		d.checked = !d.checked;
		b.onChange(c);
		return false
	},
	onChange: function (d) {
		var c = this,
			b = c._checked,
			a = c.getChecked();
		if (b != a) {
			if (a) {
				c.fireEvent("check", c, d)
			} else {
				c.fireEvent("uncheck", c, d)
			}
			c.fireEvent("change", c, a, b)
		}
	},
	doChecked: Ext.emptyFn,
	doUnChecked: Ext.emptyFn,
	isChecked: function () {
		return this.getChecked()
	},
	check: function () {
		return this.setChecked(true)
	},
	uncheck: function () {
		return this.setChecked(false)
	},
	getSameGroupFields: function () {
		var j = this.up("formpanel") || this.up("fieldset"),
			b = this.getName(),
			g = this.qsaLeftRe,
			c = this.qsaRightRe,
			f = [],
			a, d, e, h;
		if (!j) {
			j = Ext.Viewport
		}
		b = b.replace(g, "\\[");
		b = b.replace(c, "\\]");
		a = Ext.query("[name=" + b + "]", j.element.dom);
		h = a.length;
		for (e = 0; e < h; e++) {
			d = a[e];
			d = Ext.fly(d).up(".x-field");
			if (d && d.id) {
				f.push(Ext.getCmp(d.id))
			}
		}
		return f
	},
	getGroupValues: function () {
		var a = [];
		this.getSameGroupFields().forEach(function (b) {
			if (b.getChecked()) {
				a.push(b.getValue())
			}
		});
		return a
	},
	setGroupValues: function (a) {
		this.getSameGroupFields().forEach(function (b) {
			b.setChecked((a.indexOf(b.getValue()) !== -1))
		});
		return this
	},
	resetGroupValues: function () {
		this.getSameGroupFields().forEach(function (a) {
			a.setChecked(a.originalState)
		});
		return this
	},
	reset: function () {
		this.setChecked(this.originalState);
		return this
	}
});
Ext.define("Ext.picker.Slot", {
	extend: Ext.dataview.DataView,
	xtype: "pickerslot",
	alternateClassName: "Ext.Picker.Slot",
	isSlot: true,
	config: {
		title: null,
		showTitle: true,
		cls: Ext.baseCSSPrefix + "picker-slot",
		name: null,
		value: null,
		flex: 1,
		align: "left",
		displayField: "text",
		valueField: "value",
		itemTpl: null,
		scrollable: {
			direction: "vertical",
			indicators: false,
			momentumEasing: {
				minVelocity: 2
			},
			slotSnapEasing: {
				duration: 100
			}
		},
		verticallyCenterItems: true
	},
	platformConfig: [{
		theme: ["Windows"],
		title: "choose an item"
	}],
	constructor: function () {
		this.selectedIndex = 0;
		this.callParent(arguments)
	},
	applyTitle: function (a) {
		if (a) {
			a = Ext.create("Ext.Component", {
				cls: Ext.baseCSSPrefix + "picker-slot-title",
				docked: "top",
				html: a
			})
		}
		return a
	},
	updateTitle: function (b, a) {
		if (b) {
			this.add(b);
			this.setupBar()
		}
		if (a) {
			this.remove(a)
		}
	},
	updateShowTitle: function (a) {
		var c = this.getTitle(),
			b = a ? "show" : "hide";
		if (c) {
			c.on(b, this.setupBar, this, {
				single: true,
				delay: 50
			});
			c[a ? "show" : "hide"]()
		}
	},
	updateDisplayField: function (a) {
		if (!this.config.itemTpl) {
			this.setItemTpl('<div class="' + Ext.baseCSSPrefix + 'picker-item {cls} <tpl if="extra">' + Ext.baseCSSPrefix + 'picker-invalid</tpl>">{' + a + "}</div>")
		}
	},
	updateAlign: function (a, c) {
		var b = this.element;
		b.addCls(Ext.baseCSSPrefix + "picker-" + a);
		b.removeCls(Ext.baseCSSPrefix + "picker-" + c)
	},
	applyData: function (d) {
		var f = [],
			c = d && d.length,
			a, b, e;
		if (d && Ext.isArray(d) && c) {
			for (a = 0; a < c; a++) {
				b = d[a];
				e = {};
				if (Ext.isArray(b)) {
					e[this.valueField] = b[0];
					e[this.displayField] = b[1]
				} else {
					if (Ext.isString(b)) {
						e[this.valueField] = b;
						e[this.displayField] = b
					} else {
						if (Ext.isObject(b)) {
							e = b
						}
					}
				}
				f.push(e)
			}
		}
		return d
	},
	initialize: function () {
		this.callParent();
		var a = this.getScrollable().getScroller();
		this.on({
			scope: this,
			painted: "onPainted",
			itemtap: "doItemTap"
		});
		a.on({
			scope: this,
			scrollend: "onScrollEnd"
		})
	},
	onPainted: function () {
		this.setupBar()
	},
	getPicker: function () {
		if (!this.picker) {
			this.picker = this.getParent()
		}
		return this.picker
	},
	setupBar: function () {
		if (!this.rendered) {
			return
		}
		var a = this.element,
			e = this.innerElement,
			f = this.getPicker(),
			g = f.bar,
			l = this.getValue(),
			b = this.getShowTitle(),
			k = this.getTitle(),
			h = this.getScrollable(),
			d = h.getScroller(),
			c = 0,
			m, j;
		m = g.dom.getBoundingClientRect().height;
		if (b && k) {
			c = k.element.getHeight()
		}
		j = Math.ceil((a.getHeight() - c - m) / 2);
		if (this.getVerticallyCenterItems()) {
			e.setStyle({
				padding: j + "px 0 " + j + "px"
			})
		}
		d.refresh();
		d.setSlotSnapSize(m);
		this.setValue(l)
	},
	doItemTap: function (d, a, c, f) {
		var b = this;
		b.selectedIndex = a;
		b.selectedNode = c;
		b.scrollToItem(c, true)
	},
	scrollToItem: function (e, d) {
		var h = e.getY(),
			c = e.parent(),
			f = c.getY(),
			b = this.getScrollable(),
			a = b.getScroller(),
			g;
		g = h - f;
		a.scrollTo(0, g, d)
	},
	onScrollEnd: function (b, a, g) {
		var f = this,
			d = Math.round(g / f.picker.bar.dom.getBoundingClientRect().height),
			c = f.getViewItems(),
			e = c[d];
		if (e) {
			f.selectedIndex = d;
			f.selectedNode = e;
			f.fireEvent("slotpick", f, f.getValue(), f.selectedNode)
		}
	},
	getValue: function (c) {
		var b = this.getStore(),
			a, d;
		if (!b) {
			return
		}
		if (!this.rendered || !c) {
			return this._value
		}
		if (this._value === false) {
			return null
		}
		a = b.getAt(this.selectedIndex);
		d = a ? a.get(this.getValueField()) : null;
		return d
	},
	setValue: function (a) {
		return this.doSetValue(a)
	},
	setValueAnimated: function (a) {
		return this.doSetValue(a, true)
	},
	doSetValue: function (g, f) {
		if (!this.rendered) {
			this._value = g;
			return
		}
		var b = this.getStore(),
			a = this.getViewItems(),
			d = this.getValueField(),
			c, e;
		c = b.findExact(d, g);
		if (c == -1) {
			c = 0
		}
		e = Ext.get(a[c]);
		this.selectedIndex = c;
		if (e) {
			this.scrollToItem(e, (f) ? {
				duration: 100
			} : false);
			this.select(this.selectedIndex)
		}
		this._value = g
	}
});
Ext.define("Ext.picker.Picker", {
	extend: Ext.Sheet,
	alias: "widget.picker",
	alternateClassName: "Ext.Picker",
	isPicker: true,
	config: {
		baseCls: Ext.baseCSSPrefix + "picker",
		doneButton: true,
		cancelButton: true,
		useTitles: false,
		slots: null,
		value: null,
		height: 220,
		layout: {
			type: "hbox",
			align: "stretch"
		},
		centered: false,
		left: 0,
		right: 0,
		bottom: 0,
		defaultType: "pickerslot",
		toolbarPosition: "top",
		toolbar: {
			xtype: "titlebar"
		}
	},
	platformConfig: [{
		theme: ["Windows"],
		height: "100%",
		toolbarPosition: "bottom",
		toolbar: {
			xtype: "toolbar",
			layout: {
				type: "hbox",
				pack: "center"
			}
		},
		doneButton: {
			iconCls: "check2",
			ui: "round",
			text: ""
		},
		cancelButton: {
			iconCls: "delete",
			ui: "round",
			text: ""
		}
	}],
	initialize: function () {
		var b = this,
			a = Ext.baseCSSPrefix,
			c = this.innerElement;
		this.mask = c.createChild({
			cls: a + "picker-mask"
		});
		this.bar = this.mask.createChild({
			cls: a + "picker-bar"
		});
		b.on({
			scope: this,
			delegate: "pickerslot",
			slotpick: "onSlotPick"
		});
		b.inputBlocker = new Ext.util.InputBlocker()
	},
	applyToolbar: function (a) {
		if (a === true) {
			a = {}
		}
		Ext.applyIf(a, {
			docked: this.getToolbarPosition()
		});
		return Ext.factory(a, "Ext.TitleBar", this.getToolbar())
	},
	updateToolbar: function (a, b) {
		if (a) {
			this.add(a)
		}
		if (b) {
			this.remove(b)
		}
	},
	applyDoneButton: function (a) {
		if (a) {
			if (Ext.isBoolean(a)) {
				a = {}
			}
			if (typeof a == "string") {
				a = {
					text: a
				}
			}
			Ext.applyIf(a, {
				ui: "action",
				align: "right",
				text: "Done"
			})
		}
		return Ext.factory(a, "Ext.Button", this.getDoneButton())
	},
	updateDoneButton: function (c, a) {
		var b = this.getToolbar();
		if (c) {
			b.add(c);
			c.on("tap", this.onDoneButtonTap, this)
		} else {
			if (a) {
				b.remove(a)
			}
		}
	},
	applyCancelButton: function (a) {
		if (a) {
			if (Ext.isBoolean(a)) {
				a = {}
			}
			if (typeof a == "string") {
				a = {
					text: a
				}
			}
			Ext.applyIf(a, {
				align: "left",
				text: "Cancel"
			})
		}
		return Ext.factory(a, "Ext.Button", this.getCancelButton())
	},
	updateCancelButton: function (b, a) {
		var c = this.getToolbar();
		if (b) {
			c.add(b);
			b.on("tap", this.onCancelButtonTap, this)
		} else {
			if (a) {
				c.remove(a)
			}
		}
	},
	updateUseTitles: function (d) {
		var f = this.getInnerItems(),
			e = f.length,
			a = Ext.baseCSSPrefix + "use-titles",
			c, b;
		if (d) {
			this.addCls(a)
		} else {
			this.removeCls(a)
		}
		for (c = 0; c < e; c++) {
			b = f[c];
			if (b.isSlot) {
				b.setShowTitle(d)
			}
		}
	},
	applySlots: function (b) {
		if (b) {
			var c = b.length,
				a;
			for (a = 0; a < c; a++) {
				b[a].picker = this
			}
		}
		return b
	},
	updateSlots: function (a) {
		var b = Ext.baseCSSPrefix,
			c;
		this.removeAll();
		if (a) {
			this.add(a)
		}
		c = this.getInnerItems();
		if (c.length > 0) {
			c[0].addCls(b + "first");
			c[c.length - 1].addCls(b + "last")
		}
		this.updateUseTitles(this.getUseTitles())
	},
	onDoneButtonTap: function () {
		var a = this._value,
			b = this.getValue(true);
		if (b != a) {
			this.fireEvent("change", this, b)
		}
		this.hide();
		this.inputBlocker.unblockInputs()
	},
	onCancelButtonTap: function () {
		this.fireEvent("cancel", this);
		this.hide();
		this.inputBlocker.unblockInputs()
	},
	onSlotPick: function (a) {
		this.fireEvent("pick", this, this.getValue(true), a)
	},
	show: function () {
		if (this.getParent() === undefined) {
			Ext.Viewport.add(this)
		}
		this.callParent(arguments);
		if (!this.isHidden()) {
			this.setValue(this._value)
		}
		this.inputBlocker.blockInputs()
	},
	setValue: function (k, a) {
		var f = this,
			d = f.getInnerItems(),
			e = d.length,
			j, h, c, b, g;
		if (!k) {
			k = {};
			for (b = 0; b < e; b++) {
				k[d[b].config.name] = null
			}
		}
		for (j in k) {
			h = null;
			g = k[j];
			for (b = 0; b < d.length; b++) {
				c = d[b];
				if (c.config.name == j) {
					h = c;
					break
				}
			}
			if (h) {
				if (a) {
					h.setValueAnimated(g)
				} else {
					h.setValue(g)
				}
			}
		}
		f._values = f._value = k;
		return f
	},
	setValueAnimated: function (a) {
		this.setValue(a, true)
	},
	getValue: function (c) {
		var b = {},
			a = this.getItems().items,
			f = a.length,
			e, d;
		if (c) {
			for (d = 0; d < f; d++) {
				e = a[d];
				if (e && e.isSlot) {
					b[e.getName()] = e.getValue(c)
				}
			}
			this._values = b
		}
		return this._values
	},
	getValues: function () {
		return this.getValue()
	},
	destroy: function () {
		this.callParent();
		Ext.destroy(this.mask, this.bar)
	}
}, function () {});
Ext.define("Ext.field.Email", {
	extend: Ext.field.Text,
	alternateClassName: "Ext.form.Email",
	xtype: "emailfield",
	config: {
		component: {
			type: "email"
		},
		autoCapitalize: false
	}
});
Ext.define("Ext.field.Hidden", {
	extend: Ext.field.Text,
	alternateClassName: "Ext.form.Hidden",
	xtype: "hiddenfield",
	config: {
		component: {
			xtype: "input",
			type: "hidden"
		},
		ui: "hidden",
		hidden: true,
		tabIndex: -1
	}
});
Ext.define("Ext.field.Number", {
	extend: Ext.field.Text,
	xtype: "numberfield",
	alternateClassName: "Ext.form.Number",
	config: {
		component: {
			type: "number"
		},
		ui: "number"
	},
	proxyConfig: {
		minValue: null,
		maxValue: null,
		stepValue: null
	},
	doInitValue: function () {
		var a = this.getInitialConfig().value;
		if (a) {
			a = this.applyValue(a)
		}
		this.originalValue = a
	},
	applyValue: function (b) {
		var a = this.getMinValue(),
			c = this.getMaxValue();
		if (Ext.isNumber(a) && Ext.isNumber(b)) {
			b = Math.max(b, a)
		}
		if (Ext.isNumber(c) && Ext.isNumber(b)) {
			b = Math.min(b, c)
		}
		b = parseFloat(b);
		return (isNaN(b)) ? "" : b
	},
	getValue: function () {
		var a = parseFloat(this.callParent(), 10);
		return (isNaN(a)) ? null : a
	},
	doClearIconTap: function (a, b) {
		a.getComponent().setValue("");
		a.getValue();
		a.hideClearIcon()
	}
});
Ext.define("Ext.field.Password", {
	extend: Ext.field.Text,
	xtype: "passwordfield",
	alternateClassName: "Ext.form.Password",
	config: {
		autoCapitalize: false,
		component: {
			type: "password"
		}
	}
});
Ext.define("Ext.field.Search", {
	extend: Ext.field.Text,
	xtype: "searchfield",
	alternateClassName: "Ext.form.Search",
	config: {
		component: {
			type: "search"
		},
		ui: "search"
	},
	platformConfig: [{
		platform: "blackberry",
		component: {
			type: "text"
		}
	}]
});
Ext.define("Ext.field.Select", {
	extend: Ext.field.Text,
	xtype: "selectfield",
	alternateClassName: "Ext.form.Select",
	config: {
		ui: "select",
		valueField: "value",
		displayField: "text",
		store: null,
		options: null,
		hiddenName: null,
		component: {
			useMask: true
		},
		clearIcon: false,
		usePicker: (Ext.os.is.BlackBerry && Ext.os.version.getMajor() === 10) ? false : "auto",
		autoSelect: true,
		defaultPhonePickerConfig: null,
		defaultTabletPickerConfig: null,
		name: "picker",
		pickerSlotAlign: "center"
	},
	platformConfig: [{
		theme: ["Windows"],
		pickerSlotAlign: "left"
	}],
	initialize: function () {
		var b = this,
			a = b.getComponent();
		b.callParent();
		a.on({
			scope: b,
			masktap: "onMaskTap"
		});
		a.doMaskTap = Ext.emptyFn;
		if (Ext.browser.is.AndroidStock2) {
			a.input.dom.disabled = true
		}
	},
	updateDefaultPhonePickerConfig: function (b) {
		var a = this.picker;
		if (a) {
			a.setConfig(b)
		}
	},
	updateDefaultTabletPickerConfig: function (a) {
		var b = this.listPanel;
		if (b) {
			b.setConfig(a)
		}
	},
	applyUsePicker: function (a) {
		if (a == "auto") {
			a = (Ext.os.deviceType == "Phone")
		}
		return Boolean(a)
	},
	syncEmptyCls: Ext.emptyFn,
	applyValue: function (d) {
		var a = d,
			c, b;
		this.getOptions();
		b = this.getStore();
		if ((d != undefined && !d.isModel) && b) {
			c = b.find(this.getValueField(), d, null, null, null, true);
			if (c == -1) {
				c = b.find(this.getDisplayField(), d, null, null, null, true)
			}
			a = b.getAt(c)
		}
		return a
	},
	updateValue: function (b, a) {
		this.record = b;
		this.callParent([(b && b.isModel) ? b.get(this.getDisplayField()) : ""])
	},
	getValue: function () {
		var a = this.record;
		return (a && a.isModel) ? a.get(this.getValueField()) : null
	},
	getRecord: function () {
		return this.record
	},
	getPhonePicker: function () {
		var a = this.getDefaultPhonePickerConfig();
		if (!this.picker) {
			this.picker = Ext.create("Ext.picker.Picker", Ext.apply({
				slots: [{
					align: this.getPickerSlotAlign(),
					name: this.getName(),
					valueField: this.getValueField(),
					displayField: this.getDisplayField(),
					value: this.getValue(),
					store: this.getStore()
				}],
				listeners: {
					change: this.onPickerChange,
					scope: this
				}
			}, a))
		}
		return this.picker
	},
	getTabletPicker: function () {
		var a = this.getDefaultTabletPickerConfig();
		if (!this.listPanel) {
			this.listPanel = Ext.create("Ext.Panel", Ext.apply({
				left: 0,
				top: 0,
				modal: true,
				cls: Ext.baseCSSPrefix + "select-overlay",
				layout: "fit",
				hideOnMaskTap: true,
				width: Ext.os.is.Phone ? "14em" : "18em",
				height: (Ext.os.is.BlackBerry && Ext.os.version.getMajor() === 10) ? "12em" : (Ext.os.is.Phone ? "12.5em" : "22em"),
				items: {
					xtype: "list",
					store: this.getStore(),
					itemTpl: '<span class="x-list-label">{' + this.getDisplayField() + ":htmlEncode}</span>",
					listeners: {
						select: this.onListSelect,
						itemtap: this.onListTap,
						scope: this
					}
				}
			}, a))
		}
		return this.listPanel
	},
	onMaskTap: function () {
		this.onFocus();
		return false
	},
	showPicker: function () {
		var b = this.getStore();
		if (!b || b.getCount() === 0) {
			return
		}
		if (this.getReadOnly()) {
			return
		}
		this.isFocused = true;
		if (this.getUsePicker()) {
			var e = this.getPhonePicker(),
				d = this.getName(),
				h = {};
			h[d] = this.getValue();
			e.setValue(h);
			if (!e.getParent()) {
				Ext.Viewport.add(e)
			}
			e.show()
		} else {
			var f = this.getTabletPicker(),
				g = f.down("list"),
				c, a;
			b = g.getStore();
			c = b.find(this.getValueField(), this.getValue(), null, null, null, true);
			a = b.getAt((c == -1) ? 0 : c);
			if (!f.getParent()) {
				Ext.Viewport.add(f)
			}
			f.showBy(this.getComponent(), null);
			g.select(a, null, true)
		}
	},
	onListSelect: function (c, a) {
		var b = this;
		if (a) {
			b.setValue(a)
		}
	},
	onListTap: function () {
		this.listPanel.hide({
			type: "fade",
			out: true,
			scope: this
		})
	},
	onPickerChange: function (d, f) {
		var e = this,
			g = f[e.getName()],
			b = e.getStore(),
			c = b.find(e.getValueField(), g, null, null, null, true),
			a = b.getAt(c);
		e.setValue(a)
	},
	onChange: function (f, h, e) {
		var g = this,
			b = g.getStore(),
			d = (b) ? b.find(g.getDisplayField(), e, null, null, null, true) : -1,
			c = g.getValueField(),
			a = (b) ? b.getAt(d) : null;
		e = (a) ? a.get(c) : null;
		g.fireEvent("change", g, g.getValue(), e)
	},
	updateOptions: function (b) {
		var a = this.getStore();
		if (!a) {
			this.setStore(true);
			a = this._store
		}
		if (!b) {
			a.clearData()
		} else {
			a.setData(b);
			this.onStoreDataChanged(a)
		}
		return this
	},
	applyStore: function (a) {
		if (a === true) {
			a = Ext.create("Ext.data.Store", {
				fields: [this.getValueField(), this.getDisplayField()],
				autoDestroy: true
			})
		}
		if (a) {
			a = Ext.data.StoreManager.lookup(a);
			a.on({
				scope: this,
				addrecords: "onStoreDataChanged",
				removerecords: "onStoreDataChanged",
				updaterecord: "onStoreDataChanged",
				refresh: "onStoreDataChanged"
			})
		}
		return a
	},
	updateStore: function (a) {
		if (a) {
			this.onStoreDataChanged(a)
		}
		if (this.getUsePicker() && this.picker) {
			this.picker.down("pickerslot").setStore(a)
		} else {
			if (this.listPanel) {
				this.listPanel.down("dataview").setStore(a)
			}
		}
	},
	onStoreDataChanged: function (a) {
		var c = this.getInitialConfig(),
			b = this.getValue();
		if (b || b == 0) {
			this.updateValue(this.applyValue(b))
		}
		if (this.getValue() === null) {
			if (c.hasOwnProperty("value")) {
				this.setValue(c.value)
			}
			if (this.getValue() === null && this.getAutoSelect()) {
				if (a.getCount() > 0) {
					this.setValue(a.getAt(0))
				}
			}
		}
	},
	doSetDisabled: function (b) {
		var a = this.getComponent();
		if (a) {
			a.setDisabled(b)
		}
		Ext.Component.prototype.doSetDisabled.apply(this, arguments)
	},
	setDisabled: function () {
		Ext.Component.prototype.setDisabled.apply(this, arguments)
	},
	reset: function () {
		var b = this.getStore(),
			a = (this.originalValue) ? this.originalValue : b.getAt(0);
		if (b && a) {
			this.setValue(a)
		}
		return this
	},
	onFocus: function (b) {
		if (this.getDisabled()) {
			return false
		}
		var a = this.getComponent();
		this.fireEvent("focus", this, b);
		if (Ext.os.is.Android4) {
			a.input.dom.focus()
		}
		a.input.dom.blur();
		this.isFocused = true;
		this.showPicker()
	},
	destroy: function () {
		this.callParent(arguments);
		var a = this.getStore();
		if (a && a.getAutoDestroy()) {
			Ext.destroy(a)
		}
		Ext.destroy(this.listPanel, this.picker)
	}
});
Ext.define("Ext.slider.Thumb", {
	extend: Ext.Component,
	xtype: "thumb",
	config: {
		baseCls: Ext.baseCSSPrefix + "thumb",
		draggable: {
			direction: "horizontal"
		}
	},
	platformConfig: [{
		platform: ["ie10"],
		draggable: {
			translatable: {
				translationMethod: "csstransform"
			}
		}
	}],
	elementWidth: 0,
	initialize: function () {
		this.callParent();
		this.getDraggable().onBefore({
			dragstart: "onDragStart",
			drag: "onDrag",
			dragend: "onDragEnd",
			scope: this
		});
		this.element.on("resize", "onElementResize", this)
	},
	onDragStart: function () {
		if (this.isDisabled()) {
			return false
		}
		this.relayEvent(arguments)
	},
	onDrag: function () {
		if (this.isDisabled()) {
			return false
		}
		this.relayEvent(arguments)
	},
	onDragEnd: function () {
		if (this.isDisabled()) {
			return false
		}
		this.relayEvent(arguments)
	},
	onElementResize: function (a, b) {
		this.elementWidth = b.width
	},
	getElementWidth: function () {
		return this.elementWidth
	}
});
Ext.define("Ext.slider.Slider", {
	extend: Ext.Container,
	xtype: "slider",
	config: {
		baseCls: "x-slider",
		thumbConfig: {
			draggable: {
				translatable: {
					easingX: {
						duration: 300,
						type: "ease-out"
					}
				}
			}
		},
		increment: 1,
		value: 0,
		minValue: 0,
		maxValue: 100,
		allowThumbsOverlapping: false,
		animation: true,
		readOnly: false
	},
	elementWidth: 0,
	offsetValueRatio: 0,
	activeThumb: null,
	constructor: function (a) {
		a = a || {};
		if (a.hasOwnProperty("values")) {
			a.value = a.values
		}
		this.callParent([a])
	},
	initialize: function () {
		var b = this.element;
		this.callParent();
		b.on({
			scope: this,
			tap: "onTap",
			resize: "onResize"
		});
		this.on({
			scope: this,
			delegate: "> thumb",
			tap: "onTap",
			dragstart: "onThumbDragStart",
			drag: "onThumbDrag",
			dragend: "onThumbDragEnd"
		});
		var a = this.getThumb(0);
		if (a) {
			a.on("resize", "onThumbResize", this)
		}
	},
	factoryThumb: function () {
		return Ext.factory(this.getThumbConfig(), Ext.slider.Thumb)
	},
	getThumbs: function () {
		return this.innerItems
	},
	getThumb: function (a) {
		if (typeof a != "number") {
			a = 0
		}
		return this.innerItems[a]
	},
	refreshOffsetValueRatio: function () {
		var b = this.getMaxValue() - this.getMinValue(),
			a = this.elementWidth - this.thumbWidth;
		this.offsetValueRatio = a / b
	},
	onThumbResize: function () {
		var a = this.getThumb(0);
		if (a) {
			this.thumbWidth = a.getElementWidth()
		}
		this.refresh()
	},
	onResize: function (a, b) {
		this.elementWidth = b.width;
		this.refresh()
	},
	refresh: function () {
		this.refreshValue()
	},
	setActiveThumb: function (b) {
		var a = this.activeThumb;
		if (a && a !== b) {
			a.setZIndex(null)
		}
		this.activeThumb = b;
		b.setZIndex(2);
		return this
	},
	onThumbDragStart: function (a, b) {
		if (b.absDeltaX <= b.absDeltaY || this.getReadOnly()) {
			return false
		} else {
			b.stopPropagation()
		}
		if (this.getAllowThumbsOverlapping()) {
			this.setActiveThumb(a)
		}
		this.dragStartValue = this.getValue()[this.getThumbIndex(a)];
		this.fireEvent("dragstart", this, a, this.dragStartValue, b)
	},
	onThumbDrag: function (c, g, a) {
		var d = this.getThumbIndex(c),
			f = this.offsetValueRatio,
			b = this.constrainValue(this.getMinValue() + a / f);
		g.stopPropagation();
		this.setIndexValue(d, b);
		this.fireEvent("drag", this, c, this.getValue(), g);
		return false
	},
	setIndexValue: function (d, f, b) {
		var a = this.getThumb(d),
			h = this.getValue(),
			e = this.getMinValue(),
			c = this.offsetValueRatio,
			g = this.getIncrement(),
			j = a.getDraggable();
		j.setOffset((f - e) * c, null, b);
		h[d] = e + Math.round((j.offset.x / c) / g) * g
	},
	onThumbDragEnd: function (a, f) {
		this.refreshThumbConstraints(a);
		var c = this.getThumbIndex(a),
			d = this.getValue()[c],
			b = this.dragStartValue;
		this.fireEvent("dragend", this, a, this.getValue(), f);
		if (b !== d) {
			this.fireEvent("change", this, a, d, b)
		}
	},
	getThumbIndex: function (a) {
		return this.getThumbs().indexOf(a)
	},
	refreshThumbConstraints: function (d) {
		var b = this.getAllowThumbsOverlapping(),
			a = d.getDraggable().getOffset().x,
			c = this.getThumbs(),
			e = this.getThumbIndex(d),
			g = c[e - 1],
			h = c[e + 1],
			f = this.thumbWidth;
		if (g) {
			g.getDraggable().addExtraConstraint({
				max: {
					x: a - ((b) ? 0 : f)
				}
			})
		}
		if (h) {
			h.getDraggable().addExtraConstraint({
				min: {
					x: a + ((b) ? 0 : f)
				}
			})
		}
	},
	onTap: function (j) {
		if (this.isDisabled()) {
			return
		}
		var k = Ext.get(j.target);
		if (!k || (Ext.browser.engineName == "WebKit" && k.hasCls("x-thumb"))) {
			return
		}
		var n = j.touch.point.x,
			h = this.element,
			c = h.getX(),
			d = n - c - (this.thumbWidth / 2),
			o = this.constrainValue(this.getMinValue() + d / this.offsetValueRatio),
			r = this.getValue(),
			q = Infinity,
			m = r.length,
			g, f, l, p, b, a;
		if (m === 1) {
			p = 0
		} else {
			for (g = 0; g < m; g++) {
				l = r[g];
				f = Math.abs(l - o);
				if (f < q) {
					q = f;
					p = g
				}
			}
		}
		b = r[p];
		a = this.getThumb(p);
		this.setIndexValue(p, o, this.getAnimation());
		this.refreshThumbConstraints(a);
		if (b !== o) {
			this.fireEvent("change", this, a, o, b)
		}
	},
	updateThumbs: function (a) {
		this.add(a)
	},
	applyValue: function (g) {
		var d = Ext.Array.from(g || 0),
			b = [],
			c = this.getMinValue(),
			a, e, f;
		for (e = 0, f = d.length; e < f; e++) {
			a = this.constrainValue(d[e]);
			if (a < c) {
				a = c
			}
			b.push(a);
			c = a
		}
		return b
	},
	updateValue: function (f, b) {
		var a = this.getThumbs(),
			d = f.length,
			e = this.getMinValue(),
			g = this.offsetValueRatio,
			c;
		this.setThumbsCount(d);
		for (c = 0; c < d; c++) {
			a[c].getDraggable().setExtraConstraint(null).setOffset((f[c] - e) * g)
		}
		for (c = 0; c < d; c++) {
			this.refreshThumbConstraints(a[c])
		}
	},
	refreshValue: function () {
		this.refreshOffsetValueRatio();
		this.setValue(this.getValue())
	},
	constrainValue: function (e) {
		var b = this,
			d = b.getMinValue(),
			f = b.getMaxValue(),
			a = b.getIncrement(),
			c;
		e = parseFloat(e);
		if (isNaN(e)) {
			e = d
		}
		c = (e - d) % a;
		e -= c;
		if (Math.abs(c) >= (a / 2)) {
			e += (c > 0) ? a : -a
		}
		e = Math.max(d, e);
		e = Math.min(f, e);
		return e
	},
	setThumbsCount: function (e) {
		var a = this.getThumbs(),
			f = a.length,
			c, d, b;
		if (f > e) {
			for (c = 0, d = f - e; c < d; c++) {
				b = a[a.length - 1];
				b.destroy()
			}
		} else {
			if (f < e) {
				for (c = 0, d = e - f; c < d; c++) {
					this.add(this.factoryThumb())
				}
			}
		}
		return this
	},
	setValues: function (a) {
		this.setValue(a)
	},
	getValues: function () {
		return this.getValue()
	},
	applyIncrement: function (a) {
		if (a === 0) {
			a = 1
		}
		return Math.abs(a)
	},
	updateAllowThumbsOverlapping: function (b, a) {
		if (typeof a != "undefined") {
			this.refreshValue()
		}
	},
	updateMinValue: function (b, a) {
		if (typeof a != "undefined") {
			this.refreshValue()
		}
	},
	updateMaxValue: function (b, a) {
		if (typeof a != "undefined") {
			this.refreshValue()
		}
	},
	updateIncrement: function (b, a) {
		if (typeof a != "undefined") {
			this.refreshValue()
		}
	},
	doSetDisabled: function (c) {
		this.callParent(arguments);
		var a = this.getItems().items,
			d = a.length,
			b;
		for (b = 0; b < d; b++) {
			a[b].setDisabled(c)
		}
	}
}, function () {});
Ext.define("Ext.field.Slider", {
	extend: Ext.field.Field,
	xtype: "sliderfield",
	alternateClassName: "Ext.form.Slider",
	config: {
		cls: Ext.baseCSSPrefix + "slider-field",
		tabIndex: -1,
		readOnly: false
	},
	proxyConfig: {
		increment: 1,
		value: 0,
		minValue: 0,
		maxValue: 100
	},
	constructor: function (a) {
		a = a || {};
		if (a.hasOwnProperty("values")) {
			a.value = a.values
		}
		this.callParent([a]);
		this.updateMultipleState()
	},
	initialize: function () {
		this.callParent();
		this.getComponent().on({
			scope: this,
			change: "onSliderChange",
			dragstart: "onSliderDragStart",
			drag: "onSliderDrag",
			dragend: "onSliderDragEnd"
		})
	},
	applyComponent: function (a) {
		return Ext.factory(a, Ext.slider.Slider)
	},
	updateComponent: function (a) {
		this.callSuper(arguments);
		a.setMinValue(this.getMinValue());
		a.setMaxValue(this.getMaxValue())
	},
	onSliderChange: function () {
		this.fireEvent.apply(this, [].concat("change", this, Array.prototype.slice.call(arguments)))
	},
	onSliderDragStart: function () {
		this.fireEvent.apply(this, [].concat("dragstart", this, Array.prototype.slice.call(arguments)))
	},
	onSliderDrag: function () {
		this.fireEvent.apply(this, [].concat("drag", this, Array.prototype.slice.call(arguments)))
	},
	onSliderDragEnd: function () {
		this.fireEvent.apply(this, [].concat("dragend", this, Array.prototype.slice.call(arguments)))
	},
	setValues: function (a) {
		this.setValue(a);
		this.updateMultipleState()
	},
	getValues: function () {
		return this.getValue()
	},
	reset: function () {
		var b = this.config,
			a = (this.config.hasOwnProperty("values")) ? b.values : b.value;
		this.setValue(a)
	},
	doSetDisabled: function (a) {
		this.callParent(arguments);
		this.getComponent().setDisabled(a)
	},
	updateReadOnly: function (a) {
		this.getComponent().setReadOnly(a)
	},
	isDirty: function () {
		if (this.getDisabled()) {
			return false
		}
		return this.getValue() !== this.originalValue
	},
	updateMultipleState: function () {
		var a = this.getValue();
		if (a && a.length > 1) {
			this.addCls(Ext.baseCSSPrefix + "slider-multiple")
		}
	}
});
Ext.define("Ext.form.FieldSet", {
	extend: Ext.Container,
	alias: "widget.fieldset",
	config: {
		baseCls: Ext.baseCSSPrefix + "form-fieldset",
		title: null,
		instructions: null
	},
	applyTitle: function (a) {
		if (typeof a == "string") {
			a = {
				title: a
			}
		}
		Ext.applyIf(a, {
			docked: "top",
			baseCls: this.getBaseCls() + "-title"
		});
		return Ext.factory(a, Ext.Title, this._title)
	},
	updateTitle: function (b, a) {
		if (b) {
			this.add(b)
		}
		if (a) {
			this.remove(a)
		}
	},
	getTitle: function () {
		var a = this._title;
		if (a && a instanceof Ext.Title) {
			return a.getTitle()
		}
		return a
	},
	applyInstructions: function (a) {
		if (typeof a == "string") {
			a = {
				title: a
			}
		}
		Ext.applyIf(a, {
			docked: "bottom",
			baseCls: this.getBaseCls() + "-instructions"
		});
		return Ext.factory(a, Ext.Title, this._instructions)
	},
	updateInstructions: function (b, a) {
		if (b) {
			this.add(b)
		}
		if (a) {
			this.remove(a)
		}
	},
	getInstructions: function () {
		var a = this._instructions;
		if (a && a instanceof Ext.Title) {
			return a.getTitle()
		}
		return a
	},
	doSetDisabled: function (a) {
		this.getFieldsAsArray().forEach(function (b) {
			b.setDisabled(a)
		});
		return this
	},
	getFieldsAsArray: function () {
		var a = [],
			b = function (c) {
				if (c.isField) {
					a.push(c)
				}
				if (c.isContainer) {
					c.getItems().each(b)
				}
			};
		this.getItems().each(b);
		return a
	}
});
Ext.define("Ext.form.Panel", {
	alternateClassName: "Ext.form.FormPanel",
	extend: Ext.Panel,
	xtype: "formpanel",
	config: {
		baseCls: Ext.baseCSSPrefix + "form",
		standardSubmit: false,
		url: null,
		baseParams: null,
		submitOnAction: false,
		record: null,
		method: "post",
		scrollable: {
			translatable: {
				translationMethod: "scrollposition"
			}
		},
		trackResetOnLoad: false
	},
	getElementConfig: function () {
		var a = this.callParent();
		a.tag = "form";
		a.children.push({
			tag: "input",
			type: "submit",
			style: "visibility: hidden;"
		});
		return a
	},
	initialize: function () {
		var a = this;
		a.callParent();
		a.element.on({
			submit: "onSubmit",
			scope: a
		})
	},
	updateRecord: function (c) {
		var a, b, d;
		if (c && (a = c.fields)) {
			b = this.getValues();
			for (d in b) {
				if (b.hasOwnProperty(d) && a.containsKey(d)) {
					c.set(d, b[d])
				}
			}
		}
		return this
	},
	setRecord: function (a) {
		var b = this;
		if (a && a.data) {
			b.setValues(a.data)
		}
		b._record = a;
		return this
	},
	onSubmit: function (b) {
		var a = this;
		if (b && !a.getStandardSubmit()) {
			b.stopEvent()
		} else {
			this.submit(null, b)
		}
	},
	updateSubmitOnAction: function (a) {
		if (a) {
			this.on({
				action: "onFieldAction",
				scope: this
			})
		} else {
			this.un({
				action: "onFieldAction",
				scope: this
			})
		}
	},
	onFieldAction: function (a) {
		if (this.getSubmitOnAction()) {
			a.blur();
			this.submit()
		}
	},
	submit: function (a, f) {
		var c = this,
			b = c.element.dom || {},
			d;
		a = Ext.apply({
			url: c.getUrl() || b.action,
			submit: false,
			method: c.getMethod() || b.method || "post",
			autoAbort: false,
			params: null,
			waitMsg: null,
			headers: null,
			success: null,
			failure: null
		}, a || {});
		d = c.getValues(c.getStandardSubmit() || !a.submitDisabled);
		return c.fireAction("beforesubmit", [c, d, a, f], "doBeforeSubmit")
	},
	doBeforeSubmit: function (f, h, b) {
		var e = f.element.dom || {};
		if (f.getStandardSubmit()) {
			if (b.url && Ext.isEmpty(e.action)) {
				e.action = b.url
			}
			var a = this.query("spinnerfield"),
				d = a.length,
				c, g;
			for (c = 0; c < d; c++) {
				g = a[c];
				if (!g.getDisabled()) {
					g.getComponent().setDisabled(false)
				}
			}
			e.method = (b.method || e.method).toLowerCase();
			e.submit()
		} else {
			if (b.waitMsg) {
				f.setMasked(b.waitMsg)
			}
			return Ext.Ajax.request({
				url: b.url,
				method: b.method,
				rawData: Ext.urlEncode(Ext.apply(Ext.apply({}, f.getBaseParams() || {}), b.params || {}, h)),
				autoAbort: b.autoAbort,
				headers: Ext.apply({
					"Content-Type": "application/x-www-form-urlencoded; charset=UTF-8"
				}, b.headers || {}),
				scope: f,
				callback: function (j, p, k) {
					var n = this,
						o = k.responseText,
						m = Ext.Ajax.parseStatus(k.status, k),
						l;
					n.setMasked(false);
					l = function () {
						if (Ext.isFunction(b.failure)) {
							b.failure.call(b.scope || n, n, k, o)
						}
						n.fireEvent("exception", n, k)
					};
					if (p) {
						if (m && o.length == 0) {
							p = true
						} else {
							k = Ext.decode(o);
							p = !! k.success
						}
						if (p) {
							if (Ext.isFunction(b.success)) {
								b.success.call(b.scope || n, n, k, o)
							}
							n.fireEvent("submit", n, k)
						} else {
							l()
						}
					} else {
						l()
					}
				}
			})
		}
	},
	setValues: function (k) {
		var c = this.getFields(),
			g = this,
			a, h, j, e, b, d;
		k = k || {};
		for (a in k) {
			if (k.hasOwnProperty(a)) {
				h = c[a];
				j = k[a];
				if (h) {
					if (Ext.isArray(h)) {
						e = h.length;
						for (b = 0; b < e; b++) {
							d = h[b];
							if (d.isRadio) {
								d.setGroupValue(j);
								break
							} else {
								if (d.isCheckbox) {
									if (Ext.isArray(j)) {
										d.setChecked((j.indexOf(d._value) != -1))
									} else {
										d.setChecked((j == d._value))
									}
								} else {
									if (Ext.isArray(j)) {
										d.setValue(j[b])
									}
								}
							}
						}
					} else {
						if (h.isRadio || h.isCheckbox) {
							h.setChecked(j)
						} else {
							h.setValue(j)
						}
					}
					if (g.getTrackResetOnLoad()) {
						h.resetOriginalValue()
					}
				}
			}
		}
		return this
	},
	getValues: function (g, l) {
		var f = this.getFields(),
			m = {},
			e = Ext.isArray,
			j, k, b, c, a, h, d;
		b = function (o, n) {
			if (!l && (!n || n === "null")) {
				return
			}
			if (o.isCheckbox) {
				k = o.getSubmitValue()
			} else {
				k = o.getValue()
			}
			if (!(g && o.getDisabled())) {
				if (o.isRadio) {
					if (o.isChecked()) {
						m[n] = k
					}
				} else {
					c = m[n];
					if (!Ext.isEmpty(c)) {
						if (!e(c)) {
							c = m[n] = [c]
						}
						if (e(k)) {
							c = m[n] = c.concat(k)
						} else {
							c.push(k)
						}
					} else {
						m[n] = k
					}
				}
			}
		};
		for (a in f) {
			if (f.hasOwnProperty(a)) {
				j = f[a];
				if (e(j)) {
					h = j.length;
					for (d = 0; d < h; d++) {
						b(j[d], a)
					}
				} else {
					b(j, a)
				}
			}
		}
		return m
	},
	reset: function () {
		this.getFieldsAsArray().forEach(function (a) {
			a.reset()
		});
		return this
	},
	doSetDisabled: function (a) {
		this.getFieldsAsArray().forEach(function (b) {
			b.setDisabled(a)
		});
		return this
	},
	getFieldsAsArray: function () {
		var a = [],
			b = function (c) {
				if (c.isField) {
					a.push(c)
				}
				if (c.isContainer) {
					c.getItems().each(b)
				}
			};
		this.getItems().each(b);
		return a
	},
	getFields: function (b) {
		var a = {},
			d;
		var c = function (e) {
				if (e.isField) {
					d = e.getName();
					if ((b && d == b) || typeof b == "undefined") {
						if (a.hasOwnProperty(d)) {
							if (!Ext.isArray(a[d])) {
								a[d] = [a[d]]
							}
							a[d].push(e)
						} else {
							a[d] = e
						}
					}
				}
				if (e.isContainer) {
					e.items.each(c)
				}
			};
		this.getItems().each(c);
		return (b) ? (a[b] || []) : a
	},
	getFieldsArray: function () {
		var a = [];
		var b = function (c) {
				if (c.isField) {
					a.push(c)
				}
				if (c.isContainer) {
					c.items.each(b)
				}
			};
		this.items.each(b);
		return a
	},
	getFieldsFromItem: Ext.emptyFn,
	showMask: function (a, b) {
		a = Ext.isObject(a) ? a.message : a;
		if (a) {
			this.setMasked({
				xtype: "loadmask",
				message: a
			})
		} else {
			this.setMasked(true)
		}
		return this
	},
	hideMask: function () {
		this.setMasked(false);
		return this
	},
	getFocusedField: function () {
		var a = this.getFieldsArray(),
			c = a.length,
			d, b;
		for (b = 0; b < c; b++) {
			d = a[b];
			if (d.isFocused) {
				return d
			}
		}
		return null
	},
	getNextField: function () {
		var a = this.getFieldsArray(),
			c = this.getFocusedField(),
			b;
		if (c) {
			b = a.indexOf(c);
			if (b !== a.length - 1) {
				b++;
				return a[b]
			}
		}
		return false
	},
	focusNextField: function () {
		var a = this.getNextField();
		if (a) {
			a.focus();
			return a
		}
		return false
	},
	getPreviousField: function () {
		var a = this.getFieldsArray(),
			c = this.getFocusedField(),
			b;
		if (c) {
			b = a.indexOf(c);
			if (b !== 0) {
				b--;
				return a[b]
			}
		}
		return false
	},
	focusPreviousField: function () {
		var a = this.getPreviousField();
		if (a) {
			a.focus();
			return a
		}
		return false
	}
}, function () {});
Ext.define("Ext.fx.runner.Css", {
	extend: Ext.Evented,
	prefixedProperties: {
		transform: true,
		"transform-origin": true,
		perspective: true,
		"transform-style": true,
		transition: true,
		"transition-property": true,
		"transition-duration": true,
		"transition-timing-function": true,
		"transition-delay": true,
		animation: true,
		"animation-name": true,
		"animation-duration": true,
		"animation-iteration-count": true,
		"animation-direction": true,
		"animation-timing-function": true,
		"animation-delay": true
	},
	lengthProperties: {
		top: true,
		right: true,
		bottom: true,
		left: true,
		width: true,
		height: true,
		"max-height": true,
		"max-width": true,
		"min-height": true,
		"min-width": true,
		"margin-bottom": true,
		"margin-left": true,
		"margin-right": true,
		"margin-top": true,
		"padding-bottom": true,
		"padding-left": true,
		"padding-right": true,
		"padding-top": true,
		"border-bottom-width": true,
		"border-left-width": true,
		"border-right-width": true,
		"border-spacing": true,
		"border-top-width": true,
		"border-width": true,
		"outline-width": true,
		"letter-spacing": true,
		"line-height": true,
		"text-indent": true,
		"word-spacing": true,
		"font-size": true,
		translate: true,
		translateX: true,
		translateY: true,
		translateZ: true,
		translate3d: true
	},
	durationProperties: {
		"transition-duration": true,
		"transition-delay": true,
		"animation-duration": true,
		"animation-delay": true
	},
	angleProperties: {
		rotate: true,
		rotateX: true,
		rotateY: true,
		rotateZ: true,
		skew: true,
		skewX: true,
		skewY: true
	},
	lengthUnitRegex: /([a-z%]*)$/,
	DEFAULT_UNIT_LENGTH: "px",
	DEFAULT_UNIT_ANGLE: "deg",
	DEFAULT_UNIT_DURATION: "ms",
	formattedNameCache: {},
	constructor: function () {
		var a = Ext.feature.has.Css3dTransforms;
		if (a) {
			this.transformMethods = ["translateX", "translateY", "translateZ", "rotate", "rotateX", "rotateY", "rotateZ", "skewX", "skewY", "scaleX", "scaleY", "scaleZ"]
		} else {
			this.transformMethods = ["translateX", "translateY", "rotate", "skewX", "skewY", "scaleX", "scaleY"]
		}
		this.vendorPrefix = Ext.browser.getStyleDashPrefix();
		this.ruleStylesCache = {};
		return this
	},
	getStyleSheet: function () {
		var c = this.styleSheet,
			a, b;
		if (!c) {
			a = document.createElement("style");
			a.type = "text/css";
			(document.head || document.getElementsByTagName("head")[0]).appendChild(a);
			b = document.styleSheets;
			this.styleSheet = c = b[b.length - 1]
		}
		return c
	},
	applyRules: function (j) {
		var g = this.getStyleSheet(),
			l = this.ruleStylesCache,
			k = g.cssRules,
			c, e, h, b, d, a, f;
		for (c in j) {
			e = j[c];
			h = l[c];
			if (h === undefined) {
				d = k.length;
				g.insertRule(c + "{}", d);
				h = l[c] = k.item(d).style
			}
			b = h.$cache;
			if (!b) {
				b = h.$cache = {}
			}
			for (a in e) {
				f = this.formatValue(e[a], a);
				a = this.formatName(a);
				if (b[a] !== f) {
					b[a] = f;
					if (f === null) {
						h.removeProperty(a)
					} else {
						h.setProperty(a, f, "important")
					}
				}
			}
		}
		return this
	},
	applyStyles: function (d) {
		var g, c, f, b, a, e;
		for (g in d) {
			if (d.hasOwnProperty(g)) {
				c = document.getElementById(g);
				if (!c) {
					return this
				}
				f = c.style;
				b = d[g];
				for (a in b) {
					if (b.hasOwnProperty(a)) {
						e = this.formatValue(b[a], a);
						a = this.formatName(a);
						if (e === null) {
							f.removeProperty(a)
						} else {
							f.setProperty(a, e, "important")
						}
					}
				}
			}
		}
		return this
	},
	formatName: function (b) {
		var a = this.formattedNameCache,
			c = a[b];
		if (!c) {
			if (!Ext.feature.has.CssTransformNoPrefix && this.prefixedProperties[b]) {
				c = this.vendorPrefix + b
			} else {
				c = b
			}
			a[b] = c
		}
		return c
	},
	formatValue: function (j, b) {
		var g = typeof j,
			l = this.DEFAULT_UNIT_LENGTH,
			e, a, d, f, c, k, h;
		if (j === null) {
			return ""
		}
		if (g == "string") {
			if (this.lengthProperties[b]) {
				h = j.match(this.lengthUnitRegex)[1];
				if (h.length > 0) {} else {
					return j + l
				}
			}
			return j
		} else {
			if (g == "number") {
				if (j == 0) {
					return "0"
				}
				if (this.lengthProperties[b]) {
					return j + l
				}
				if (this.angleProperties[b]) {
					return j + this.DEFAULT_UNIT_ANGLE
				}
				if (this.durationProperties[b]) {
					return j + this.DEFAULT_UNIT_DURATION
				}
			} else {
				if (b === "transform") {
					e = this.transformMethods;
					c = [];
					for (d = 0, f = e.length; d < f; d++) {
						a = e[d];
						c.push(a + "(" + this.formatValue(j[a], a) + ")")
					}
					return c.join(" ")
				} else {
					if (Ext.isArray(j)) {
						k = [];
						for (d = 0, f = j.length; d < f; d++) {
							k.push(this.formatValue(j[d], b))
						}
						return (k.length > 0) ? k.join(", ") : "none"
					}
				}
			}
		}
		return j
	}
});
Ext.define("Ext.fx.runner.CssTransition", {
	extend: Ext.fx.runner.Css,
	listenersAttached: false,
	constructor: function () {
		this.runningAnimationsData = {};
		return this.callParent(arguments)
	},
	attachListeners: function () {
		this.listenersAttached = true;
		this.getEventDispatcher().addListener("element", "*", "transitionend", "onTransitionEnd", this)
	},
	onTransitionEnd: function (b) {
		var a = b.target,
			c = a.id;
		if (c && this.runningAnimationsData.hasOwnProperty(c)) {
			this.refreshRunningAnimationsData(Ext.get(a), [b.browserEvent.propertyName])
		}
	},
	onAnimationEnd: function (g, f, d, j, n) {
		var c = g.getId(),
			k = this.runningAnimationsData[c],
			o = {},
			m = {},
			b, h, e, l, a;
		d.un("stop", "onAnimationStop", this);
		if (k) {
			b = k.nameMap
		}
		o[c] = m;
		if (f.onBeforeEnd) {
			f.onBeforeEnd.call(f.scope || this, g, j)
		}
		d.fireEvent("animationbeforeend", d, g, j);
		this.fireEvent("animationbeforeend", this, d, g, j);
		if (n || (!j && !f.preserveEndState)) {
			h = f.toPropertyNames;
			for (e = 0, l = h.length; e < l; e++) {
				a = h[e];
				if (b && !b.hasOwnProperty(a)) {
					m[a] = null
				}
			}
		}
		if (f.after) {
			Ext.merge(m, f.after)
		}
		this.applyStyles(o);
		if (f.onEnd) {
			f.onEnd.call(f.scope || this, g, j)
		}
		d.fireEvent("animationend", d, g, j);
		this.fireEvent("animationend", this, d, g, j);
		Ext.AnimationQueue.stop(Ext.emptyFn, d)
	},
	onAllAnimationsEnd: function (b) {
		var c = b.getId(),
			a = {};
		delete this.runningAnimationsData[c];
		a[c] = {
			"transition-property": null,
			"transition-duration": null,
			"transition-timing-function": null,
			"transition-delay": null
		};
		this.applyStyles(a);
		this.fireEvent("animationallend", this, b)
	},
	hasRunningAnimations: function (a) {
		var c = a.getId(),
			b = this.runningAnimationsData;
		return b.hasOwnProperty(c) && b[c].sessions.length > 0
	},
	refreshRunningAnimationsData: function (d, k, t, p) {
		var g = d.getId(),
			q = this.runningAnimationsData,
			a = q[g];
		if (!a) {
			return
		}
		var m = a.nameMap,
			s = a.nameList,
			b = a.sessions,
			f, h, e, u, l, c, r, o, n = false;
		t = Boolean(t);
		p = Boolean(p);
		if (!b) {
			return this
		}
		f = b.length;
		if (f === 0) {
			return this
		}
		if (p) {
			a.nameMap = {};
			s.length = 0;
			for (l = 0; l < f; l++) {
				c = b[l];
				this.onAnimationEnd(d, c.data, c.animation, t, p)
			}
			b.length = 0
		} else {
			for (l = 0; l < f; l++) {
				c = b[l];
				r = c.map;
				o = c.list;
				for (h = 0, e = k.length; h < e; h++) {
					u = k[h];
					if (r[u]) {
						delete r[u];
						Ext.Array.remove(o, u);
						c.length--;
						if (--m[u] == 0) {
							delete m[u];
							Ext.Array.remove(s, u)
						}
					}
				}
				if (c.length == 0) {
					b.splice(l, 1);
					l--;
					f--;
					n = true;
					this.onAnimationEnd(d, c.data, c.animation, t)
				}
			}
		}
		if (!p && !t && b.length == 0 && n) {
			this.onAllAnimationsEnd(d)
		}
	},
	getRunningData: function (b) {
		var a = this.runningAnimationsData;
		if (!a.hasOwnProperty(b)) {
			a[b] = {
				nameMap: {},
				nameList: [],
				sessions: []
			}
		}
		return a[b]
	},
	getTestElement: function () {
		var c = this.testElement,
			b, d, a;
		if (!c) {
			b = document.createElement("iframe");
			a = b.style;
			a.setProperty("visibility", "hidden", "important");
			a.setProperty("width", "0px", "important");
			a.setProperty("height", "0px", "important");
			a.setProperty("position", "absolute", "important");
			a.setProperty("border", "0px", "important");
			a.setProperty("zIndex", "-1000", "important");
			document.body.appendChild(b);
			d = b.contentDocument;
			d.open();
			d.writeln("</body>");
			d.close();
			this.testElement = c = d.createElement("div");
			c.style.setProperty("position", "absolute", "important");
			d.body.appendChild(c);
			this.testElementComputedStyle = window.getComputedStyle(c)
		}
		return c
	},
	getCssStyleValue: function (b, e) {
		var d = this.getTestElement(),
			a = this.testElementComputedStyle,
			c = d.style;
		c.setProperty(b, e);
		if (Ext.browser.is.Firefox) {
			d.offsetHeight
		}
		e = a.getPropertyValue(b);
		c.removeProperty(b);
		return e
	},
	run: function (q) {
		var G = this,
			h = this.lengthProperties,
			y = {},
			F = {},
			H = {},
			d, t, z, e, v, J, w, r, s, a, n, B, A, p, C, l, u, g, D, I, k, f, x, o, c, E, b, m;
		if (!this.listenersAttached) {
			this.attachListeners()
		}
		q = Ext.Array.from(q);
		for (B = 0, p = q.length; B < p; B++) {
			C = q[B];
			C = Ext.factory(C, Ext.fx.Animation);
			d = C.getElement();
			Ext.AnimationQueue.start(Ext.emptyFn, C);
			g = window.getComputedStyle(d.dom);
			t = d.getId();
			H = Ext.merge({}, C.getData());
			if (C.onBeforeStart) {
				C.onBeforeStart.call(C.scope || this, d)
			}
			C.fireEvent("animationstart", C);
			this.fireEvent("animationstart", this, C);
			H[t] = H;
			v = H.before;
			z = H.from;
			e = H.to;
			H.fromPropertyNames = J = [];
			H.toPropertyNames = w = [];
			for (I in e) {
				if (e.hasOwnProperty(I)) {
					e[I] = k = this.formatValue(e[I], I);
					D = this.formatName(I);
					o = h.hasOwnProperty(I);
					if (!o) {
						k = this.getCssStyleValue(D, k)
					}
					if (z.hasOwnProperty(I)) {
						z[I] = x = this.formatValue(z[I], I);
						if (!o) {
							x = this.getCssStyleValue(D, x)
						}
						if (k !== x) {
							J.push(D);
							w.push(D)
						}
					} else {
						f = g.getPropertyValue(D);
						if (k !== f) {
							w.push(D)
						}
					}
				}
			}
			l = w.length;
			if (l === 0) {
				this.onAnimationEnd(d, H, C);
				continue
			}
			a = this.getRunningData(t);
			b = a.sessions;
			if (b.length > 0) {
				this.refreshRunningAnimationsData(d, Ext.Array.merge(J, w), true, H.replacePrevious)
			}
			c = a.nameMap;
			E = a.nameList;
			u = {};
			for (A = 0; A < l; A++) {
				I = w[A];
				u[I] = true;
				if (!c.hasOwnProperty(I)) {
					c[I] = 1;
					E.push(I)
				} else {
					c[I]++
				}
			}
			m = {
				element: d,
				map: u,
				list: w.slice(),
				length: l,
				data: H,
				animation: C
			};
			b.push(m);
			C.on("stop", "onAnimationStop", this);
			n = Ext.apply({}, v);
			Ext.apply(n, z);
			if (E.length > 0) {
				J = Ext.Array.difference(E, J);
				w = Ext.Array.merge(J, w);
				n["transition-property"] = J
			}
			y[t] = n;
			F[t] = Ext.apply({}, e);
			F[t]["transition-property"] = w;
			F[t]["transition-duration"] = H.duration;
			F[t]["transition-timing-function"] = H.easing;
			F[t]["transition-delay"] = H.delay;
			C.startTime = Date.now()
		}
		s = this.$className;
		this.applyStyles(y);
		r = function (j) {
			if (j.data === s && j.source === window) {
				window.removeEventListener("message", r, false);
				G.applyStyles(F)
			}
		};
		window.addEventListener("message", r, false);
		window.postMessage(s, "*")
	},
	onAnimationStop: function (d) {
		var f = this.runningAnimationsData,
			h, a, g, b, c, e;
		for (h in f) {
			if (f.hasOwnProperty(h)) {
				a = f[h];
				g = a.sessions;
				for (b = 0, c = g.length; b < c; b++) {
					e = g[b];
					if (e.animation === d) {
						this.refreshRunningAnimationsData(e.element, e.list.slice(), false)
					}
				}
			}
		}
	}
});
Ext.define("Ext.fx.Runner", {
	constructor: function () {
		return new Ext.fx.runner.CssTransition()
	}
});
Ext.define("Ext.navigation.Bar", {
	extend: Ext.TitleBar,
	isToolbar: true,
	config: {
		baseCls: Ext.baseCSSPrefix + "toolbar",
		cls: Ext.baseCSSPrefix + "navigation-bar",
		ui: "dark",
		title: null,
		defaultType: "button",
		layout: {
			type: "hbox"
		},
		defaultBackButtonText: "Back",
		animation: {
			duration: 300
		},
		useTitleForBackButtonText: null,
		view: null,
		android2Transforms: false,
		backButton: {
			align: "left",
			ui: "back",
			hidden: true
		}
	},
	platformConfig: [{
		platform: ["blackberry"],
		animation: false
	}],
	constructor: function (a) {
		a = a || {};
		if (!a.items) {
			a.items = []
		}
		this.backButtonStack = [];
		this.activeAnimations = [];
		this.callParent([a])
	},
	applyBackButton: function (a) {
		return Ext.factory(a, Ext.Button, this.getBackButton())
	},
	updateBackButton: function (a, b) {
		if (b) {
			this.remove(b)
		}
		if (a) {
			this.add(a);
			a.on({
				scope: this,
				tap: this.onBackButtonTap
			})
		}
	},
	onBackButtonTap: function () {
		this.fireEvent("back", this)
	},
	updateView: function (b) {
		var d = this,
			j = d.getBackButton(),
			a, c, f, g, e, h;
		d.getItems();
		if (b) {
			a = b.getInnerItems();
			for (c = 0; c < a.length; c++) {
				g = a[c];
				e = (g.getTitle) ? g.getTitle() : g.config.title;
				d.backButtonStack.push(e || "&nbsp;")
			}
			h = d.getTitleText();
			if (h === undefined) {
				h = ""
			}
			d.setTitle(h);
			f = d.getBackButtonText();
			if (f) {
				j.setText(f);
				j.show()
			}
		}
	},
	onViewAdd: function (c, e) {
		var d = this,
			b = d.backButtonStack,
			a, f;
		d.endAnimation();
		f = (e.getTitle) ? e.getTitle() : e.config.title;
		b.push(f || "&nbsp;");
		a = b.length > 1;
		d.doChangeView(c, a, false)
	},
	onViewRemove: function (c) {
		var d = this,
			b = d.backButtonStack,
			a;
		d.endAnimation();
		b.pop();
		a = b.length > 1;
		d.doChangeView(c, a, true)
	},
	doChangeView: function (l, c, g) {
		var s = this,
			p = s.leftBox,
			e = p.element,
			f = s.titleComponent,
			n = f.element,
			o = s.getBackButton(),
			m = s.getTitleText(),
			h = s.getBackButtonText(),
			r = s.getAnimation() && l.getLayout().getAnimation(),
			q = r && r.isAnimation && l.isPainted(),
			d, j, a, k, b;
		if (q) {
			j = s.createProxy(p.element);
			e.setStyle("opacity", "0");
			o.setText(h);
			o[c ? "show" : "hide"]();
			a = s.createProxy(f.element.getParent());
			n.setStyle("opacity", "0");
			s.setTitle(m);
			d = s.measureView(j, a, g);
			k = d.left;
			b = d.title;
			s.isAnimating = true;
			s.animate(e, k.element);
			s.animate(n, b.element, function () {
				n.setLeft(d.titleLeft);
				s.isAnimating = false;
				s.refreshTitlePosition()
			});
			if (Ext.browser.is.AndroidStock2 && !this.getAndroid2Transforms()) {
				j.ghost.destroy();
				a.ghost.destroy()
			} else {
				s.animate(j.ghost, k.ghost);
				s.animate(a.ghost, b.ghost, function () {
					j.ghost.destroy();
					a.ghost.destroy()
				})
			}
		} else {
			if (c) {
				o.setText(h);
				o.show()
			} else {
				o.hide()
			}
			s.setTitle(m)
		}
	},
	measureView: function (e, v, l) {
		var x = this,
			k = x.element,
			w = x.leftBox.element,
			q = x.titleComponent.element,
			m = Math.min(k.getWidth() / 3, 200),
			r = w.getWidth(),
			c = k.getX(),
			n = k.getWidth(),
			o = q.getX(),
			d = q.getLeft(),
			t = q.getWidth(),
			s = e.x,
			u = e.width,
			a = e.left,
			h = Ext.browser.is.AndroidStock2 && !this.getAndroid2Transforms(),
			j, b, f, y, p, g;
		g = c - s - u;
		if (l) {
			j = g;
			b = Math.min(o - u, m)
		} else {
			b = g;
			j = Math.min(o - c, m)
		}
		if (h) {
			f = {
				element: {
					from: {
						left: j,
						opacity: 1
					},
					to: {
						left: 0,
						opacity: 1
					}
				}
			}
		} else {
			f = {
				element: {
					from: {
						transform: {
							translateX: j
						},
						opacity: 0
					},
					to: {
						transform: {
							translateX: 0
						},
						opacity: 1
					}
				},
				ghost: {
					to: {
						transform: {
							translateX: b
						},
						opacity: 0
					}
				}
			}
		}
		g = c - o + r;
		if ((a + t) > o) {
			p = c - o - t
		}
		if (l) {
			q.setLeft(0);
			b = c + n - o - t;
			if (p !== undefined) {
				j = p
			} else {
				j = g
			}
		} else {
			j = c + n - o - t;
			if (p !== undefined) {
				b = p
			} else {
				b = g
			}
			j = Math.max(d, j)
		}
		if (h) {
			y = {
				element: {
					from: {
						left: j,
						opacity: 1
					},
					to: {
						left: d,
						opacity: 1
					}
				}
			}
		} else {
			y = {
				element: {
					from: {
						transform: {
							translateX: j
						},
						opacity: 0
					},
					to: {
						transform: {
							translateX: d
						},
						opacity: 1
					}
				},
				ghost: {
					to: {
						transform: {
							translateX: b
						},
						opacity: 0
					}
				}
			}
		}
		return {
			left: f,
			title: y,
			titleLeft: d
		}
	},
	animate: function (b, a, e) {
		var c = this,
			d;
		b.setLeft(0);
		a = Ext.apply(a, {
			element: b,
			easing: "ease-in-out",
			duration: c.getAnimation().duration || 250,
			preserveEndState: true
		});
		d = new Ext.fx.Animation(a);
		d.on("animationend", function () {
			if (e) {
				e.call(c)
			}
		}, c);
		Ext.Animator.run(d);
		c.activeAnimations.push(d)
	},
	endAnimation: function () {
		var a = this.activeAnimations,
			d, b, c;
		if (a) {
			c = a.length;
			for (b = 0; b < c; b++) {
				d = a[b];
				if (d.isAnimating) {
					d.stopAnimation()
				} else {
					d.destroy()
				}
			}
			this.activeAnimations = []
		}
	},
	refreshTitlePosition: function () {
		if (!this.isAnimating) {
			this.callParent()
		}
	},
	getBackButtonText: function () {
		var b = this.backButtonStack[this.backButtonStack.length - 2],
			a = this.getUseTitleForBackButtonText();
		if (!a) {
			if (b) {
				b = this.getDefaultBackButtonText()
			}
		}
		return b
	},
	getTitleText: function () {
		return this.backButtonStack[this.backButtonStack.length - 1]
	},
	beforePop: function (b) {
		b--;
		for (var a = 0; a < b; a++) {
			this.backButtonStack.pop()
		}
	},
	doSetHidden: function (a) {
		if (!a) {
			this.element.setStyle({
				position: "relative",
				top: "auto",
				left: "auto",
				width: "auto"
			})
		} else {
			this.element.setStyle({
				position: "absolute",
				top: "-1000px",
				left: "-1000px",
				width: this.element.getWidth() + "px"
			})
		}
	},
	createProxy: function (b) {
		var e, a, f, d, c;
		e = b.dom.cloneNode(true);
		e.id = b.id + "-proxy";
		b.getParent().dom.appendChild(e);
		e = Ext.get(e);
		a = b.getX();
		f = b.getY();
		d = b.getLeft();
		c = b.getWidth();
		e.setStyle("position", "absolute");
		e.setX(a);
		e.setY(f);
		e.setHeight(b.getHeight());
		e.setWidth(c);
		return {
			x: a,
			y: f,
			left: d,
			width: c,
			ghost: e
		}
	}
});
Ext.define("Ext.navigation.View", {
	extend: Ext.Container,
	alternateClassName: "Ext.NavigationView",
	xtype: "navigationview",
	config: {
		baseCls: Ext.baseCSSPrefix + "navigationview",
		navigationBar: {
			docked: "top"
		},
		defaultBackButtonText: "Back",
		useTitleForBackButtonText: false,
		layout: {
			type: "card",
			animation: {
				duration: 300,
				easing: "ease-out",
				type: "slide",
				direction: "left"
			}
		}
	},
	initialize: function () {
		var b = this,
			a = b.getNavigationBar();
		a.on({
			back: b.onBackButtonTap,
			scope: b
		});
		b.relayEvents(a, "rightbuttontap");
		b.relayEvents(b, {
			add: "push",
			remove: "pop"
		})
	},
	applyLayout: function (a) {
		a = a || {};
		return a
	},
	onBackButtonTap: function () {
		this.pop();
		this.fireEvent("back", this)
	},
	push: function (a) {
		return this.add(a)
	},
	pop: function (a) {
		if (this.beforePop(a)) {
			return this.doPop()
		}
	},
	beforePop: function (f) {
		var e = this,
			g = e.getInnerItems();
		if (Ext.isString(f) || Ext.isObject(f)) {
			var d = g.length - 1,
				a;
			for (a = d; a >= 0; a--) {
				if ((Ext.isString(f) && Ext.ComponentQuery.is(g[a], f)) || (Ext.isObject(f) && f == g[a])) {
					f = d - a;
					break
				}
			}
			if (!Ext.isNumber(f)) {
				return false
			}
		}
		var c = g.length,
			b;
		if (!Ext.isNumber(f) || f < 1) {
			f = 1
		}
		f = Math.min(f, c - 1);
		if (f) {
			e.getNavigationBar().beforePop(f);
			b = g.splice(-f, f - 1);
			for (a = 0; a < b.length; a++) {
				this.remove(b[a])
			}
			return true
		}
		return false
	},
	doPop: function () {
		var a = this,
			b = this.getInnerItems();
		a.remove(b[b.length - 1]);
		return this.getActiveItem()
	},
	getPreviousItem: function () {
		var a = this.getInnerItems();
		return a[a.length - 2]
	},
	updateUseTitleForBackButtonText: function (b) {
		var a = this.getNavigationBar();
		if (a) {
			a.setUseTitleForBackButtonText(b)
		}
	},
	updateDefaultBackButtonText: function (b) {
		var a = this.getNavigationBar();
		if (a) {
			a.setDefaultBackButtonText(b)
		}
	},
	applyNavigationBar: function (a) {
		if (!a) {
			a = {
				hidden: true,
				docked: "top"
			}
		}
		if (a.title) {
			delete a.title
		}
		a.view = this;
		a.useTitleForBackButtonText = this.getUseTitleForBackButtonText();
		return Ext.factory(a, Ext.navigation.Bar, this.getNavigationBar())
	},
	updateNavigationBar: function (a, b) {
		if (b) {
			this.remove(b, true)
		}
		if (a) {
			this.add(a)
		}
	},
	applyActiveItem: function (d, a) {
		var b = this,
			c = b.getInnerItems();
		b.getItems();
		if (!b.initialized) {
			d = c.length - 1
		}
		return this.callParent([d, a])
	},
	doResetActiveItem: function (d) {
		var a = this,
			c = a.getInnerItems(),
			b = a.getLayout().getAnimation();
		if (d > 0) {
			if (b && b.isAnimation) {
				b.setReverse(true)
			}
			a.setActiveItem(d - 1);
			a.getNavigationBar().onViewRemove(a, c[d], d)
		}
	},
	doRemove: function () {
		var a = this.getLayout().getAnimation();
		if (a && a.isAnimation) {
			a.setReverse(false)
		}
		this.callParent(arguments)
	},
	onItemAdd: function (b, a) {
		this.doItemLayoutAdd(b, a);
		if (!this.isItemsInitializing && b.isInnerItem()) {
			this.setActiveItem(b);
			this.getNavigationBar().onViewAdd(this, b, a)
		}
		if (this.initialized) {
			this.fireEvent("add", this, b, a)
		}
	},
	reset: function () {
		return this.pop(this.getInnerItems().length)
	}
});
Ext.define("AppMici.view.override.Template", {
	override: "Ext.navigation.View",
	push: function (a) {
		if (this.getActiveItem().xtype != a.xtype) {
			this.callParent(arguments)
		}
	}
});
Ext.define("Ext.plugin.PullRefresh", {
	extend: Ext.Component,
	alias: "plugin.pullrefresh",
	config: {
		list: null,
		pullRefreshText: "Pull down to refresh...",
		releaseRefreshText: "Release to refresh...",
		lastUpdatedText: "Last Updated:",
		lastUpdatedDateFormat: "m/d/Y h:iA",
		loadingText: "Loading...",
		loadedText: "Loaded.",
		autoSnapBack: true,
		snappingAnimationDuration: 300,
		overpullSnapBackDuration: 300,
		pullTpl: ['<div class="x-list-pullrefresh">', '<div class="x-list-pullrefresh-arrow"></div>', '<div class="x-loading-spinner">', '<span class="x-loading-top"></span>', '<span class="x-loading-right"></span>', '<span class="x-loading-bottom"></span>', '<span class="x-loading-left"></span>', "</div>", '<div class="x-list-pullrefresh-wrap">', '<h3 class="x-list-pullrefresh-message"></h3>', '<div class="x-list-pullrefresh-updated"></div>', "</div>", "</div>"].join(""),
		translatable: true
	},
	isRefreshing: false,
	currentViewState: "",
	initialize: function () {
		this.callParent();
		this.on({
			painted: "onPainted",
			scope: this
		})
	},
	init: function (b) {
		var a = this;
		a.setList(b);
		a.initScrollable()
	},
	initScrollable: function () {
		var d = this,
			g = d.getList(),
			b = g.getStore(),
			f = d.getPullTpl(),
			c = d.element,
			e = g.getScrollable(),
			a;
		if (!e) {
			return
		}
		a = e.getScroller();
		a.setAutoRefresh(false);
		d.lastUpdated = new Date();
		g.insert(0, d);
		if (b) {
			if (b.isAutoLoading()) {
				g.setLoadingText(null)
			} else {
				b.on({
					load: {
						single: true,
						fn: function () {
							g.setLoadingText(null)
						}
					}
				})
			}
		}
		f.overwrite(c, []);
		d.loadingElement = c.getFirstChild();
		d.messageEl = c.down(".x-list-pullrefresh-message");
		d.updatedEl = c.down(".x-list-pullrefresh-updated");
		d.maxScroller = a.getMaxPosition();
		a.on({
			maxpositionchange: d.setMaxScroller,
			scroll: d.onScrollChange,
			scope: d
		});
		d.resetRefreshState()
	},
	onScrollableChange: function () {
		this.initScrollable()
	},
	updateList: function (a, c) {
		var b = this;
		if (a && a != c) {
			a.on({
				order: "after",
				scrollablechange: b.onScrollableChange,
				scope: b
			})
		} else {
			if (c) {
				c.un({
					order: "after",
					scrollablechange: b.onScrollableChange,
					scope: b
				})
			}
		}
	},
	fetchLatest: function () {
		var b = this.getList().getStore(),
			c = b.getProxy(),
			a;
		a = Ext.create("Ext.data.Operation", {
			page: 1,
			start: 0,
			model: b.getModel(),
			limit: b.getPageSize(),
			action: "read",
			sorters: b.getSorters(),
			filters: b.getRemoteFilter() ? b.getFilters() : []
		});
		c.read(a, this.onLatestFetched, this)
	},
	onLatestFetched: function (d) {
		var n = this.getList().getStore(),
			m = this.getList(),
			j = m.getScrollable().getScroller(),
			h = j.position.x,
			f = j.position.y,
			b = n.getData(),
			c = d.getRecords(),
			a = c.length,
			k = [],
			l, g, e;
		for (e = 0; e < a; e++) {
			l = c[e];
			g = b.getByKey(l.getId());
			if (g) {
				g.set(l.getData())
			} else {
				k.push(l)
			}
			g = undefined
		}
		n.insert(0, k);
		j.scrollTo(h, f);
		this.setViewState("loaded");
		this.fireEvent("latestfetched");
		if (this.getAutoSnapBack()) {
			this.snapBack()
		}
	},
	snapBack: function () {
		var b = this,
			c = b.getList(),
			a = c.getScrollable().getScroller();
		a.on({
			scrollend: function () {
				this.resetRefreshState()
			},
			single: true,
			scope: b
		});
		if (a.position.y < 0) {
			a.minPosition.y = 0;
			a.scrollTo(null, 0, {
				duration: a.isTouching ? 0 : b.getSnappingAnimationDuration()
			})
		}
	},
	onPainted: function () {
		this.pullHeight = this.loadingElement.getHeight()
	},
	setMaxScroller: function (b, a) {
		this.maxScroller = a
	},
	onScrollChange: function (b, a, c) {
		if (c <= 0) {
			this.onBounceTop(c)
		}
		if (c > this.maxScroller.y) {
			this.onBounceBottom(c)
		}
	},
	applyPullTpl: function (a) {
		return (Ext.isObject(a) && a.isTemplate) ? a : new Ext.XTemplate(a)
	},
	onBounceTop: function (e) {
		var b = this,
			d = b.pullHeight,
			c = b.getList(),
			a = c.getScrollable().getScroller();
		if (!b.isReleased) {
			if (!d) {
				b.onPainted();
				d = b.pullHeight
			}
			if (!b.isRefreshing && -e >= d + 10) {
				b.isRefreshing = true;
				b.setViewState("release");
				a.getContainer().onBefore({
					dragend: "onScrollerDragEnd",
					single: true,
					scope: b
				})
			} else {
				if (b.isRefreshing && -e < d + 10) {
					b.isRefreshing = false;
					b.setViewState("pull")
				}
			}
		}
		b.getTranslatable().translate(0, -e)
	},
	onScrollerDragEnd: function () {
		var c = this;
		if (c.isRefreshing) {
			var d = c.getList(),
				a = d.getScrollable().getScroller(),
				b = a.getTranslatable();
			b.setEasingY({
				duration: this.getOverpullSnapBackDuration()
			});
			a.minPosition.y = -c.pullHeight;
			a.on({
				scrollend: "loadStore",
				single: true,
				scope: c
			});
			c.isReleased = true
		}
	},
	loadStore: function () {
		var a = this;
		a.setViewState("loading");
		a.isReleased = false;
		a.fetchLatest()
	},
	onBounceBottom: Ext.emptyFn,
	setViewState: function (d) {
		var b = this,
			c = Ext.baseCSSPrefix,
			e = b.messageEl,
			a = b.loadingElement;
		if (d === b.currentViewState) {
			return b
		}
		b.currentViewState = d;
		if (e && a) {
			switch (d) {
			case "pull":
				e.setHtml(b.getPullRefreshText());
				a.removeCls([c + "list-pullrefresh-release", c + "list-pullrefresh-loading"]);
				break;
			case "release":
				e.setHtml(b.getReleaseRefreshText());
				a.addCls(c + "list-pullrefresh-release");
				break;
			case "loading":
				e.setHtml(b.getLoadingText());
				a.addCls(c + "list-pullrefresh-loading");
				break;
			case "loaded":
				e.setHtml(b.getLoadedText());
				a.addCls(c + "list-pullrefresh-loaded");
				break
			}
		}
		return b
	},
	resetRefreshState: function () {
		var a = this;
		a.isRefreshing = false;
		a.lastUpdated = new Date();
		a.setViewState("pull");
		a.updatedEl.setHtml(this.getLastUpdatedText() + "&nbsp;" + Ext.util.Format.date(a.lastUpdated, a.getLastUpdatedDateFormat()))
	}
});
Ext.define("Ext.tab.Tab", {
	extend: Ext.Button,
	xtype: "tab",
	alternateClassName: "Ext.Tab",
	isTab: true,
	config: {
		baseCls: Ext.baseCSSPrefix + "tab",
		pressedCls: Ext.baseCSSPrefix + "tab-pressed",
		activeCls: Ext.baseCSSPrefix + "tab-active",
		active: false,
		title: "&nbsp;"
	},
	updateIconCls: function (b, a) {
		this.callParent([b, a]);
		if (a) {
			this.removeCls("x-tab-icon")
		}
		if (b) {
			this.addCls("x-tab-icon")
		}
	},
	updateTitle: function (a) {
		this.setText(a)
	},
	updateActive: function (c, b) {
		var a = this.getActiveCls();
		if (c && !b) {
			this.element.addCls(a);
			this.fireEvent("activate", this)
		} else {
			if (b) {
				this.element.removeCls(a);
				this.fireEvent("deactivate", this)
			}
		}
	}
}, function () {
	this.override({
		activate: function () {
			this.setActive(true)
		},
		deactivate: function () {
			this.setActive(false)
		}
	})
});
Ext.define("Ext.tab.Bar", {
	extend: Ext.Toolbar,
	alternateClassName: "Ext.TabBar",
	xtype: "tabbar",
	config: {
		baseCls: Ext.baseCSSPrefix + "tabbar",
		defaultType: "tab",
		layout: {
			type: "hbox",
			align: "middle"
		}
	},
	eventedConfig: {
		activeTab: null
	},
	platformConfig: [{
		theme: ["Blackberry"],
		defaults: {
			flex: 1
		}
	}],
	initialize: function () {
		var a = this;
		a.callParent();
		a.on({
			tap: "onTabTap",
			delegate: "> tab",
			scope: a
		})
	},
	onTabTap: function (a) {
		this.setActiveTab(a)
	},
	applyActiveTab: function (b, c) {
		if (!b && b !== 0) {
			return
		}
		var a = this.parseActiveTab(b);
		if (!a) {
			return
		}
		return a
	},
	doSetDocked: function (a) {
		var c = this.getLayout(),
			d = this.getInitialConfig(),
			b;
		if (!d.layout || !d.layout.pack) {
			b = (a == "bottom") ? "center" : "left";
			if (c.isLayout) {
				c.setPack(b)
			} else {
				c.pack = (c && c.pack) ? c.pack : b
			}
		}
		this.callParent(arguments)
	},
	doSetActiveTab: function (b, a) {
		if (b) {
			b.setActive(true)
		}
		if (a && a.parent) {
			a.setActive(false)
		}
	},
	parseActiveTab: function (a) {
		if (typeof a == "number") {
			return this.getItems().items[a]
		} else {
			if (typeof a == "string") {
				a = Ext.getCmp(a)
			}
		}
		return a
	}
});
Ext.define("Ext.tab.Panel", {
	extend: Ext.Container,
	xtype: "tabpanel",
	alternateClassName: "Ext.TabPanel",
	config: {
		ui: "dark",
		tabBar: true,
		tabBarPosition: "top",
		layout: {
			type: "card",
			animation: {
				type: "slide",
				direction: "left"
			}
		},
		cls: Ext.baseCSSPrefix + "tabpanel"
	},
	initialize: function () {
		this.callParent();
		this.on({
			order: "before",
			activetabchange: "doTabChange",
			delegate: "> tabbar",
			scope: this
		});
		this.on({
			disabledchange: "onItemDisabledChange",
			delegate: "> component",
			scope: this
		})
	},
	applyScrollable: function () {
		return false
	},
	updateUi: function (a, b) {
		this.callParent(arguments);
		if (this.initialized) {
			this.getTabBar().setUi(a)
		}
	},
	doSetActiveItem: function (d, k) {
		if (d) {
			var f = this.getInnerItems(),
				g = f.indexOf(k),
				j = f.indexOf(d),
				e = g > j,
				c = this.getLayout().getAnimation(),
				b = this.getTabBar(),
				h = b.parseActiveTab(g),
				a = b.parseActiveTab(j);
			if (c && c.setReverse) {
				c.setReverse(e)
			}
			this.callParent(arguments);
			if (j != -1) {
				this.forcedChange = true;
				b.setActiveTab(j);
				this.forcedChange = false;
				if (h) {
					h.setActive(false)
				}
				if (a) {
					a.setActive(true)
				}
			}
		}
	},
	doTabChange: function (a, d) {
		var b = this.getActiveItem(),
			c;
		this.setActiveItem(a.indexOf(d));
		c = this.getActiveItem();
		return this.forcedChange || b !== c
	},
	applyTabBar: function (a) {
		if (a === true) {
			a = {}
		}
		if (a) {
			Ext.applyIf(a, {
				ui: this.getUi(),
				docked: this.getTabBarPosition()
			})
		}
		return Ext.factory(a, Ext.tab.Bar, this.getTabBar())
	},
	updateTabBar: function (a) {
		if (a) {
			this.add(a);
			this.setTabBarPosition(a.getDocked())
		}
	},
	updateTabBarPosition: function (b) {
		var a = this.getTabBar();
		if (a) {
			a.setDocked(b)
		}
	},
	onItemAdd: function (e) {
		var l = this;
		if (!e.isInnerItem()) {
			return l.callParent(arguments)
		}
		var c = l.getTabBar(),
			p = e.getInitialConfig(),
			d = p.tab || {},
			g = (e.getTitle) ? e.getTitle() : p.title,
			j = (e.getIconCls) ? e.getIconCls() : p.iconCls,
			k = (e.getHidden) ? e.getHidden() : p.hidden,
			o = (e.getDisabled) ? e.getDisabled() : p.disabled,
			q = (e.getBadgeText) ? e.getBadgeText() : p.badgeText,
			b = l.getInnerItems(),
			h = b.indexOf(e),
			m = c.getItems(),
			a = c.getActiveTab(),
			n = (m.length >= b.length) && m.getAt(h),
			f;
		if (g && !d.title) {
			d.title = g
		}
		if (j && !d.iconCls) {
			d.iconCls = j
		}
		if (k && !d.hidden) {
			d.hidden = k
		}
		if (o && !d.disabled) {
			d.disabled = o
		}
		if (q && !d.badgeText) {
			d.badgeText = q
		}
		f = Ext.factory(d, Ext.tab.Tab, n);
		if (!n) {
			c.insert(h, f)
		}
		e.tab = f;
		l.callParent(arguments);
		if (!a && a !== 0) {
			c.setActiveTab(c.getActiveItem())
		}
	},
	onItemDisabledChange: function (a, b) {
		if (a && a.tab) {
			a.tab.setDisabled(b)
		}
	},
	onItemRemove: function (b, a) {
		this.getTabBar().remove(b.tab, this.getAutoDestroy());
		this.callParent(arguments)
	}
}, function () {});
Ext.define("Ext.util.InputBlocker", {
	blockInputs: function () {
		if (Ext.browser.is.ie) {
			Ext.select(".x-field-text .x-field-input:not(.x-item-disabled) .x-input-el, .x-field-textarea .x-field-input:not(.x-item-disabled) .x-input-el").each(function (a) {
				if (a.dom.offsetWidth > 0) {
					a.dom.setAttribute("disabled", true);
					a.dom.setAttribute("overlayfix", true)
				}
			})
		}
	},
	unblockInputs: function () {
		if (Ext.browser.is.ie) {
			Ext.select("[overlayfix]").each(function (a) {
				a.dom.removeAttribute("disabled");
				a.dom.removeAttribute("overlayfix")
			})
		}
	}
});
Ext.define("Ext.ux.picker.DateTime", {
	extend: Ext.picker.Picker,
	xtype: "datetimepicker",
	alternateClassName: "Ext.ux.DateTimePicker",
	config: {
		yearFrom: 1980,
		yearTo: new Date().getFullYear(),
		monthText: (Ext.os.deviceType.toLowerCase() == "phone") ? "M" : "Month",
		dayText: (Ext.os.deviceType.toLowerCase() == "phone") ? "j" : "Day",
		yearText: (Ext.os.deviceType.toLowerCase() == "phone") ? "Y" : "Year",
		hourText: (Ext.os.deviceType.toLowerCase() == "phone") ? "H" : "Ora",
		minuteText: (Ext.os.deviceType.toLowerCase() == "phone") ? "i" : "Minuto",
		ampmText: (Ext.os.deviceType.toLowerCase() == "phone") ? "A" : "AM/PM",
		slotOrder: ["day", "month", "year", "hour", "minute", "ampm"],
		minuteInterval: 15,
		ampm: false,
	},
	initialize: function () {
		this.callParent();
		this.on({
			scope: this,
			delegate: "> slot",
			slotpick: this.onSlotPick
		})
	},
	setValue: function (b, a) {
		if (Ext.isDate(b)) {
			ampm = "AM";
			currentHours = hour = b.getHours();
			if (this.getAmpm()) {
				if (currentHours > 12) {
					ampm = "PM";
					hour -= 12
				} else {
					if (currentHours == 12) {
						ampm = "PM"
					} else {
						if (currentHours == 0) {
							hour = 12
						}
					}
				}
			}
			b = {
				day: b.getDate(),
				month: b.getMonth() + 1,
				year: b.getFullYear(),
				hour: hour,
				minute: b.getMinutes(),
				ampm: ampm
			}
		}
		this.callParent([b, a])
	},
	getValue: function () {
		var m = {},
			a, k, d, c, h = this.getItems().items,
			g = h.length,
			o, e;
		for (e = 0; e < g; e++) {
			o = h[e];
			if (o instanceof Ext.picker.Slot) {
				m[o.getName()] = o.getValue()
			}
		}
		a = this.getDaysInMonth(m.month, m.year);
		k = Math.min(m.day, a), d = m.hour, c = m.minute;
		var j = (isNaN(m.year)) ? new Date().getFullYear() : m.year,
			b = (isNaN(m.month)) ? (new Date().getMonth()) : (m.month - 1),
			n = (isNaN(k)) ? (new Date().getDate()) : k,
			l = (isNaN(d)) ? new Date().getHours() : d,
			f = (isNaN(c)) ? new Date().getMinutes() : c;
		if (m.ampm && m.ampm == "PM" && l < 12) {
			l = l + 12
		}
		if (m.ampm && m.ampm == "AM" && l == 12) {
			l = 0
		}
		return new Date(j, b, n, l, f)
	},
	updateYearFrom: function () {
		if (this.initialized) {
			this.createSlots()
		}
	},
	updateYearTo: function () {
		if (this.initialized) {
			this.createSlots()
		}
	},
	updateMonthText: function (a, b) {
		var f = this.getInnerItems,
			e = f.length,
			d, c;
		if (this.initialized) {
			for (c = 0; c < e; c++) {
				d = f[c];
				if ((typeof d.title == "string" && d.title == b) || (d.title.html == b)) {
					d.setTitle(a)
				}
			}
		}
	},
	updateDayText: function (a, c) {
		var f = this.getInnerItems,
			e = f.length,
			d, b;
		if (this.initialized) {
			for (b = 0; b < e; b++) {
				d = f[b];
				if ((typeof d.title == "string" && d.title == c) || (d.title.html == c)) {
					d.setTitle(a)
				}
			}
		}
	},
	updateYearText: function (e) {
		var d = this.getInnerItems,
			c = d.length,
			b, a;
		if (this.initialized) {
			for (a = 0; a < c; a++) {
				b = d[a];
				if (b.title == this.yearText) {
					b.setTitle(e)
				}
			}
		}
	},
	constructor: function () {
		this.callParent(arguments);
		this.createSlots()
	},
	createSlots: function () {
		var r = this,
			f = this.getSlotOrder(),
			c = r.getYearFrom(),
			b = r.getYearTo(),
			m = [],
			d = [],
			g = [],
			p = [],
			n = [],
			l = [],
			j, q, o, a;
		if (!this.getAmpm()) {
			var e = f.indexOf("ampm");
			if (e >= 0) {
				f.splice(e)
			}
		}
		if (c > b) {
			q = c;
			c = b;
			b = q
		}
		for (o = c; o <= b; o++) {
			m.push({
				text: o,
				value: o
			})
		}
		a = this.getDaysInMonth(1, new Date().getFullYear());
		for (o = 0; o < a; o++) {
			d.push({
				text: o + 1,
				value: o + 1
			})
		}
		for (o = 0, j = Ext.Date.monthNames.length; o < j; o++) {
			g.push({
				text: (Ext.os.deviceType.toLowerCase() == "phone") ? Ext.Date.monthNames[o].substring(0, 3) : Ext.Date.monthNames[o],
				value: o + 1
			})
		}
		var s = (this.getAmpm()) ? 12 : 23;
		var h = (this.getAmpm()) ? 1 : 0;
		for (o = h; o <= s; o++) {
			p.push({
				text: this.pad2(o),
				value: o
			})
		}
		for (o = 0; o < 60; o += this.getMinuteInterval()) {
			n.push({
				text: this.pad2(o),
				value: o
			})
		}
		l.push({
			text: "AM",
			value: "AM"
		}, {
			text: "PM",
			value: "PM"
		});
		var k = [];
		f.forEach(function (t) {
			k.push(this.createSlot(t, d, g, m, p, n, l))
		}, this);
		r.setSlots(k)
	},
	createSlot: function (d, g, a, f, b, e, c) {
		switch (d) {
		case "year":
			return {
				name: "year",
				align: (Ext.os.deviceType.toLowerCase() == "phone") ? "left" : "center",
				data: f,
				title: this.getYearText(),
				flex: (Ext.os.deviceType.toLowerCase() == "phone") ? 1.3 : 3
			};
		case "month":
			return {
				name: d,
				align: (Ext.os.deviceType.toLowerCase() == "phone") ? "left" : "right",
				data: a,
				title: this.getMonthText(),
				flex: (Ext.os.deviceType.toLowerCase() == "phone") ? 1.2 : 4
			};
		case "day":
			return {
				name: "day",
				align: (Ext.os.deviceType.toLowerCase() == "phone") ? "left" : "center",
				data: g,
				title: this.getDayText(),
				flex: (Ext.os.deviceType.toLowerCase() == "phone") ? 0.9 : 2
			};
		case "hour":
			return {
				name: "hour",
				align: (Ext.os.deviceType.toLowerCase() == "phone") ? "left" : "center",
				data: b,
				title: this.getHourText(),
				flex: (Ext.os.deviceType.toLowerCase() == "phone") ? 0.9 : 2
			};
		case "minute":
			return {
				name: "minute",
				align: (Ext.os.deviceType.toLowerCase() == "phone") ? "left" : "center",
				data: e,
				title: this.getMinuteText(),
				flex: (Ext.os.deviceType.toLowerCase() == "phone") ? 0.9 : 2
			};
		case "ampm":
			return {
				name: "ampm",
				align: (Ext.os.deviceType.toLowerCase() == "phone") ? "left" : "center",
				data: c,
				title: this.getAmpmText(),
				flex: (Ext.os.deviceType.toLowerCase() == "phone") ? 1.1 : 2
			}
		}
	},
	onSlotPick: function (b, c, e, d) {
		var a = b.getStore().getAt(b.selectedIndex).get(b.getValueField());
		b.setValue(a);
		if (b.getName() === "month" || b.getName() === "year") {
			this.repopulateDaySlot()
		}
	},
	repopulateDaySlot: function () {
		var e = this.getDaySlot(),
			d = [],
			c = this.getSlotByName("month").getValue(),
			b = this.getSlotByName("year").getValue(),
			a;
		a = this.getDaysInMonth(c, b);
		for (i = 0; i < a; i++) {
			d.push({
				text: i + 1,
				value: i + 1
			})
		}
		if (e.getData().length == d.length) {
			return
		}
		e.setData(d)
	},
	getSlotByName: function (a) {
		return this.down("pickerslot[name=" + a + "]")
	},
	getDaySlot: function () {
		return this.getSlotByName("day")
	},
	getDaysInMonth: function (c, b) {
		var a = [31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
		return c == 2 && this.isLeapYear(b) ? 29 : a[c - 1]
	},
	isLeapYear: function (a) {
		return !!((a & 3) === 0 && (a % 100 || (a % 400 === 0 && a)))
	},
	pad2: function (a) {
		return (a < 10 ? "0" : "") + a
	}
});
Ext.define("Ext.ux.field.DateTimePicker", {
	extend: Ext.field.Text,
	alternateClassName: "Ext.form.DateTimePicker",
	xtype: "datetimepickerfield",
	config: {
		ui: "select",
		picker: true,
		clearIcon: false,
		destroyPickerOnHide: false,
		dateTimeFormat: "m/d/Y h:i:A",
		component: {
			useMask: true
		}
	},
	initialize: function () {
		this.callParent();
		this.getComponent().on({
			scope: this,
			masktap: "onMaskTap"
		});
		this.getComponent().input.dom.disabled = true
	},
	syncEmptyCls: Ext.emptyFn,
	applyValue: function (a) {
		if (!Ext.isDate(a) && !Ext.isObject(a)) {
			a = null
		}
		if (Ext.isObject(a)) {
			a = new Date(a.year, a.month - 1, a.day, a.hour, a.minute)
		}
		return a
	},
	updateValue: function (b) {
		var a = this._picker;
		if (a && a.isPicker) {
			a.setValue(b)
		}
		if (b !== null) {
			this.getComponent().setValue(Ext.Date.format(b, this.getDateTimeFormat() || Ext.util.Format.defaultDateFormat))
		} else {
			this.getComponent().setValue("")
		}
		if (this._picker && this._picker instanceof Ext.ux.picker.DateTime) {
			this._picker.setValue(b)
		}
	},
	updateDateFormat: function (c, a) {
		var b = this.getValue();
		if (c != a && Ext.isDate(b) && this._picker && this._picker instanceof Ext.ux.picker.DateTime) {
			this.getComponent().setValue(Ext.Date.format(b, c || Ext.util.Format.defaultDateFormat))
		}
	},
	getValue: function () {
		if (this._picker && this._picker instanceof Ext.ux.picker.DateTime) {
			return this._picker.getValue()
		}
		return this._value
	},
	getFormattedValue: function (b) {
		var a = this.getValue();
		console.log(this.getDateTimeFormat(), "format");
		return (Ext.isDate(a)) ? Ext.Date.format(a, b || this.getDateTimeFormat() || Ext.util.Format.defaultDateFormat) : a
	},
	applyPicker: function (b, a) {
		if (a && a.isPicker) {
			b = a.setConfig(b)
		}
		return b
	},
	getPicker: function () {
		var a = this._picker,
			b = this.getValue();
		if (a && !a.isPicker) {
			a = Ext.factory(a, Ext.ux.picker.DateTime);
			a.on({
				scope: this,
				change: "onPickerChange",
				hide: "onPickerHide"
			});
			if (b !== null) {
				a.setValue(b)
			}
			Ext.Viewport.add(a);
			this._picker = a
		}
		return a
	},
	onMaskTap: function () {
		if (this.getDisabled()) {
			return false
		}
		if (this.getReadOnly()) {
			return false
		}
		this.getPicker().show();
		return false
	},
	onPickerChange: function (a, c) {
		var b = this;
		b.setValue(c);
		b.fireEvent("change", b, b.getValue())
	},
	onPickerHide: function () {
		var b = this,
			a = b.getPicker();
		if (b.getDestroyPickerOnHide() && a) {
			a.destroy();
			b._picker = b.getInitialConfig().picker || true
		}
	},
	reset: function () {
		this.setValue(this.originalValue)
	},
	destroy: function () {
		var a = this.getPicker();
		if (a && a.isPicker) {
			a.destroy()
		}
		this.callParent(arguments)
	}
});
Ext.define("Ext.ux.field.Multiselect", {
	extend: Ext.field.Select,
	alias: "widget.multiselectfield",
	config: {
		delimiter: ",",
		mode: "MULTI",
		doneButton: true
	},
	applyDoneButton: function (a) {
		if (a) {
			if (Ext.isBoolean(a)) {
				a = {}
			}
			if (typeof a == "string") {
				a = {
					text: a
				}
			}
			Ext.applyIf(a, {
				text: "OK",
				ui: "action",
				height: "20px",
				margin: "5px auto 0px auto",
				width: "40%",
				docked: "bottom",
				listeners: {
					tap: this.onButtonTap,
					scope: this
				}
			})
		}
		return Ext.factory(a, "Ext.Button", this.getDoneButton())
	},
	getTabletPicker: function () {
		var b = this,
			a = b.getDefaultTabletPickerConfig(),
			c = b.getMode();
		if (!b.listPanel) {
			b.listPanel = Ext.create("Ext.Panel", Ext.apply({
				left: 0,
				top: 0,
				modal: true,
				cls: Ext.baseCSSPrefix + "select-overlay",
				layout: "fit",
				hideOnMaskTap: true,
				width: Ext.os.is.Phone ? "14em" : "18em",
				height: (Ext.os.is.BlackBerry && Ext.os.version.getMajor() === 10) ? "12em" : (Ext.os.is.Phone ? "12.5em" : "22em"),
				items: [{
					xtype: "list",
					mode: c,
					store: b.getStore(),
					itemTpl: '<span class="x-list-label">{' + b.getDisplayField() + ":htmlEncode}</span>"
				}]
			}, a));
			if (c === "SINGLE") {
				b.listPanel.down("list").on("itemtap", b.onListTap, b)
			} else {
				b.listPanel.add(this.getDoneButton())
			}
		}
		return b.listPanel
	},
	onListTap: function (c, b, d, a) {
		this.setValue(a);
		this.callParent()
	},
	onButtonTap: function () {
		var a = this.listPanel.down("list").getSelection();
		this.setValue(a);
		this.superclass.onListTap.call(this)
	},
	applyValue: function (a) {
		this.getOptions();
		return this.getValueFromRecords(a, this.getValueField())
	},
	updateValue: function (d, a) {
		var b = this,
			c = b.convertValue(d, b.getValueField(), b.getDisplayField());
		c = c.join(b.getDelimiter());
		b.superclass.superclass.updateValue.call(b, [c])
	},
	convertValue: function (g, b, e) {
		var a = this.getDelimiter(),
			h = this.getStore(),
			d = 0,
			c = [],
			f, j;
		if (g) {
			if (a && Ext.isString(g)) {
				g = g.split(a)
			} else {
				if (!Ext.isArray(g)) {
					g = [g]
				}
			}
			for (f = g.length; d < f; ++d) {
				j = h.findRecord(b, g[d]);
				if (j) {
					c.push(j.get(e))
				}
			}
		}
		return c
	},
	getValueFromRecords: function (g) {
		var b = this.getDelimiter(),
			d = this.getValueField(),
			e = 0,
			c = [],
			a, f;
		if (g) {
			if (b && Ext.isString(g)) {
				g = g.split(b)
			} else {
				if (!Ext.isArray(g)) {
					g = [g]
				}
			}
			for (a = g.length; e < a; ++e) {
				f = g[e];
				if (f && f.isModel) {
					c.push(f.get(d))
				}
			}
			c = Ext.Array.unique(c)
		}
		return c.length > 0 ? c : g
	},
	getRecordsFromValue: function (f) {
		var a = [],
			g = this.getStore().getRange(),
			k = this.getValueField(),
			d = 0,
			h = g.length,
			b, c, e;
		if (f) {
			for (e = f.length; d < e; ++d) {
				for (c = 0; c < h; ++c) {
					b = g[c];
					if (b.get(k) == f[d]) {
						a.push(b);
						break
					}
				}
			}
		}
		return a
	},
	getSelection: function () {
		return this.listPanel.down("list").getSelection()
	},
	getValue: function () {
		return this._value
	},
	onChange: function (c, e, b) {
		var d = this,
			a = d.convertValue(b, d.getDisplayField(), d.getValueField());
		d.fireEvent("change", d, d.getValue(), a)
	},
	showPicker: function () {
		var e = this,
			b = this.getStore();
		if (!b || b.getCount() === 0) {
			return
		}
		if (e.getReadOnly()) {
			return
		}
		e.isFocused = true;
		var d = e.getTabletPicker(),
			g = d.down("list"),
			c, a, f = e.getValue();
		if (!d.getParent()) {
			Ext.Viewport.add(d)
		}
		if (f) {
			a = e.getRecordsFromValue(f);
			g.select(a, null, true)
		} else {
			g.deselectAll()
		}
		d.showBy(e.getComponent(), (Ext.os.is.BlackBerry && Ext.os.version.getMajor() === 10) ? "t-b" : null)
	},
	onStoreDataChanged: function (a) {
		var b = this,
			d = b.getInitialConfig(),
			c = b.getValue();
		if (c || c === 0) {
			b.updateValue(b.applyValue(c))
		}
		if (b.getValue() === null) {
			if (d.hasOwnProperty("value")) {
				b.setValue(d.value)
			}
			if (b.getValue() === null && b.getAutoSelect()) {
				if (a.getCount() > 0) {
					b.setValue(a.getAt(0))
				}
			}
		}
	}
});
Ext.define("Ext.viewport.Default", {
	extend: Ext.Container,
	xtype: "viewport",
	PORTRAIT: "portrait",
	LANDSCAPE: "landscape",
	config: {
		autoMaximize: false,
		autoBlurInput: true,
		preventPanning: true,
		preventZooming: false,
		autoRender: true,
		layout: "card",
		width: "100%",
		height: "100%",
		useBodyElement: true
	},
	isReady: false,
	isViewport: true,
	isMaximizing: false,
	id: "ext-viewport",
	isInputRegex: /^(input|textarea|select|a)$/i,
	focusedElement: null,
	fullscreenItemCls: Ext.baseCSSPrefix + "fullscreen",
	constructor: function (a) {
		var b = Ext.Function.bind;
		this.doPreventPanning = b(this.doPreventPanning, this);
		this.doPreventZooming = b(this.doPreventZooming, this);
		this.doBlurInput = b(this.doBlurInput, this);
		this.maximizeOnEvents = ["ready", "orientationchange"];
		this.orientation = this.determineOrientation();
		this.windowWidth = this.getWindowWidth();
		this.windowHeight = this.getWindowHeight();
		this.windowOuterHeight = this.getWindowOuterHeight();
		if (!this.stretchHeights) {
			this.stretchHeights = {}
		}
		window.devicePixelRatio = window.devicePixelRatio || 1;
		this.callParent([a]);
		if (!Ext.os.is.Android || Ext.browser.is.ChromeMobile) {
			if (this.supportsOrientation()) {
				this.addWindowListener("orientationchange", b(this.onOrientationChange, this))
			} else {
				this.addWindowListener("resize", b(this.onResize, this))
			}
		}
		document.addEventListener("focus", b(this.onElementFocus, this), true);
		document.addEventListener("blur", b(this.onElementBlur, this), true);
		Ext.onDocumentReady(this.onDomReady, this);
		this.on("ready", this.onReady, this, {
			single: true
		});
		this.getEventDispatcher().addListener("component", "*", "fullscreen", "onItemFullscreenChange", this);
		return this
	},
	onDomReady: function () {
		this.isReady = true;
		this.updateSize();
		this.fireEvent("ready", this)
	},
	onReady: function () {
		if (this.getAutoRender()) {
			this.render()
		}
	},
	onElementFocus: function (a) {
		this.focusedElement = a.target
	},
	onElementBlur: function () {
		this.focusedElement = null
	},
	render: function () {
		if (!this.rendered) {
			var a = Ext.getBody(),
				b = Ext.baseCSSPrefix,
				h = [],
				d = Ext.os,
				g = d.name.toLowerCase(),
				f = Ext.browser.name.toLowerCase(),
				e = d.version.getMajor(),
				c = this.getOrientation();
			this.renderTo(a);
			h.push(b + d.deviceType.toLowerCase());
			if (d.is.iPad) {
				h.push(b + "ipad")
			}
			h.push(b + g);
			h.push(b + f);
			if (e) {
				h.push(b + g + "-" + e)
			}
			if (d.is.BlackBerry) {
				h.push(b + "bb")
			}
			if (Ext.browser.is.WebKit) {
				h.push(b + "webkit")
			}
			if (Ext.browser.is.Standalone) {
				h.push(b + "standalone")
			}
			h.push(b + c);
			a.addCls(h)
		}
	},
	applyAutoBlurInput: function (a) {
		var b = (Ext.feature.has.Touch) ? "touchstart" : "mousedown";
		if (a) {
			this.addWindowListener(b, this.doBlurInput, false)
		} else {
			this.removeWindowListener(b, this.doBlurInput, false)
		}
		return a
	},
	applyAutoMaximize: function (a) {
		if (Ext.browser.is.WebView) {
			a = false
		}
		if (a) {
			this.on("ready", "doAutoMaximizeOnReady", this, {
				single: true
			});
			this.on("orientationchange", "doAutoMaximizeOnOrientationChange", this)
		} else {
			this.un("ready", "doAutoMaximizeOnReady", this);
			this.un("orientationchange", "doAutoMaximizeOnOrientationChange", this)
		}
		return a
	},
	applyPreventPanning: function (a) {
		if (a) {
			this.addWindowListener("touchmove", this.doPreventPanning, false)
		} else {
			this.removeWindowListener("touchmove", this.doPreventPanning, false)
		}
		return a
	},
	applyPreventZooming: function (a) {
		var b = (Ext.feature.has.Touch) ? "touchstart" : "mousedown";
		if (a) {
			this.addWindowListener(b, this.doPreventZooming, false)
		} else {
			this.removeWindowListener(b, this.doPreventZooming, false)
		}
		return a
	},
	doAutoMaximizeOnReady: function () {
		var a = arguments[arguments.length - 1];
		a.pause();
		this.isMaximizing = true;
		this.on("maximize", function () {
			this.isMaximizing = false;
			this.updateSize();
			a.resume();
			this.fireEvent("ready", this)
		}, this, {
			single: true
		});
		this.maximize()
	},
	doAutoMaximizeOnOrientationChange: function () {
		var a = arguments[arguments.length - 1],
			b = a.firingArguments;
		a.pause();
		this.isMaximizing = true;
		this.on("maximize", function () {
			this.isMaximizing = false;
			this.updateSize();
			b[2] = this.windowWidth;
			b[3] = this.windowHeight;
			a.resume()
		}, this, {
			single: true
		});
		this.maximize()
	},
	doBlurInput: function (b) {
		var a = b.target,
			c = this.focusedElement;
		if (c && c.nodeName.toUpperCase() != "BODY" && !this.isInputRegex.test(a.tagName)) {
			delete this.focusedElement;
			c.blur()
		}
	},
	doPreventPanning: function (a) {
		a.preventDefault()
	},
	doPreventZooming: function (b) {
		if ("button" in b && b.button !== 0) {
			return
		}
		var a = b.target;
		if (a && a.nodeType === 1 && !this.isInputRegex.test(a.tagName)) {
			b.preventDefault()
		}
	},
	addWindowListener: function (b, c, a) {
		window.addEventListener(b, c, Boolean(a))
	},
	removeWindowListener: function (b, c, a) {
		window.removeEventListener(b, c, Boolean(a))
	},
	doAddListener: function (a, d, c, b) {
		if (a === "ready" && this.isReady && !this.isMaximizing) {
			d.call(c);
			return this
		}
		return this.callSuper(arguments)
	},
	supportsOrientation: function () {
		return Ext.feature.has.Orientation
	},
	onResize: function () {
		var c = this.windowWidth,
			f = this.windowHeight,
			e = this.getWindowWidth(),
			a = this.getWindowHeight(),
			d = this.getOrientation(),
			b = this.determineOrientation();
		if ((c !== e && f !== a) && d !== b) {
			this.fireOrientationChangeEvent(b, d)
		}
	},
	onOrientationChange: function () {
		var b = this.getOrientation(),
			a = this.determineOrientation();
		if (a !== b) {
			this.fireOrientationChangeEvent(a, b)
		}
	},
	fireOrientationChangeEvent: function (b, c) {
		var a = Ext.baseCSSPrefix;
		Ext.getBody().replaceCls(a + c, a + b);
		this.orientation = b;
		this.updateSize();
		this.fireEvent("orientationchange", this, b, this.windowWidth, this.windowHeight)
	},
	updateSize: function (b, a) {
		this.windowWidth = b !== undefined ? b : this.getWindowWidth();
		this.windowHeight = a !== undefined ? a : this.getWindowHeight();
		return this
	},
	waitUntil: function (h, e, g, a, f) {
		if (!a) {
			a = 50
		}
		if (!f) {
			f = 2000
		}
		var c = this,
			b = 0;
		setTimeout(function d() {
			b += a;
			if (h.call(c) === true) {
				if (e) {
					e.call(c)
				}
			} else {
				if (b >= f) {
					if (g) {
						g.call(c)
					}
				} else {
					setTimeout(d, a)
				}
			}
		}, a)
	},
	maximize: function () {
		this.fireMaximizeEvent()
	},
	fireMaximizeEvent: function () {
		this.updateSize();
		this.fireEvent("maximize", this)
	},
	doSetHeight: function (a) {
		Ext.getBody().setHeight(a);
		this.callParent(arguments)
	},
	doSetWidth: function (a) {
		Ext.getBody().setWidth(a);
		this.callParent(arguments)
	},
	scrollToTop: function () {
		window.scrollTo(0, -1)
	},
	getWindowWidth: function () {
		return window.innerWidth
	},
	getWindowHeight: function () {
		return window.innerHeight
	},
	getWindowOuterHeight: function () {
		return window.outerHeight
	},
	getWindowOrientation: function () {
		return window.orientation
	},
	getOrientation: function () {
		return this.orientation
	},
	getSize: function () {
		return {
			width: this.windowWidth,
			height: this.windowHeight
		}
	},
	determineOrientation: function () {
		var b = this.PORTRAIT,
			a = this.LANDSCAPE;
		if (!Ext.os.is.Android && this.supportsOrientation()) {
			if (this.getWindowOrientation() % 180 === 0) {
				return b
			}
			return a
		} else {
			if (this.getWindowHeight() >= this.getWindowWidth()) {
				return b
			}
			return a
		}
	},
	onItemFullscreenChange: function (a) {
		a.addCls(this.fullscreenItemCls);
		this.add(a)
	}
});
Ext.define("Ext.viewport.Android", {
	extend: Ext.viewport.Default,
	config: {
		autoBlurInput: false
	},
	constructor: function () {
		this.on("orientationchange", "doFireOrientationChangeEvent", this, {
			prepend: true
		});
		this.on("orientationchange", "hideKeyboardIfNeeded", this, {
			prepend: true
		});
		this.callParent(arguments);
		this.addWindowListener("resize", Ext.Function.bind(this.onResize, this))
	},
	getDummyInput: function () {
		var a = this.dummyInput,
			c = this.focusedElement,
			b = Ext.fly(c).getPageBox();
		if (!a) {
			this.dummyInput = a = document.createElement("input");
			a.style.position = "absolute";
			a.style.opacity = "0";
			a.style.pointerEvents = "none";
			document.body.appendChild(a)
		}
		a.style.left = b.left + "px";
		a.style.top = b.top + "px";
		a.style.display = "";
		return a
	},
	doBlurInput: function (c) {
		var b = c.target,
			d = this.focusedElement,
			a;
		if (d && !this.isInputRegex.test(b.tagName)) {
			a = this.getDummyInput();
			delete this.focusedElement;
			a.focus();
			setTimeout(function () {
				a.style.display = "none"
			}, 100)
		}
	},
	hideKeyboardIfNeeded: function () {
		var a = arguments[arguments.length - 1],
			b = this.focusedElement;
		if (b) {
			delete this.focusedElement;
			a.pause();
			if (Ext.os.version.lt("4")) {
				b.style.display = "none"
			} else {
				b.blur()
			}
			setTimeout(function () {
				b.style.display = "";
				a.resume()
			}, 1000)
		}
	},
	doFireOrientationChangeEvent: function () {
		var a = arguments[arguments.length - 1];
		this.orientationChanging = true;
		a.pause();
		this.waitUntil(function () {
			return this.getWindowOuterHeight() !== this.windowOuterHeight
		}, function () {
			this.windowOuterHeight = this.getWindowOuterHeight();
			this.updateSize();
			a.firingArguments[2] = this.windowWidth;
			a.firingArguments[3] = this.windowHeight;
			a.resume();
			this.orientationChanging = false
		}, function () {});
		return this
	},
	applyAutoMaximize: function (a) {
		a = this.callParent(arguments);
		this.on("add", "fixSize", this, {
			single: true
		});
		if (!a) {
			this.on("ready", "fixSize", this, {
				single: true
			});
			this.onAfter("orientationchange", "doFixSize", this, {
				buffer: 100
			})
		} else {
			this.un("ready", "fixSize", this);
			this.unAfter("orientationchange", "doFixSize", this)
		}
	},
	fixSize: function () {
		this.doFixSize()
	},
	doFixSize: function () {
		this.setHeight(this.getWindowHeight())
	},
	determineOrientation: function () {
		return (this.getWindowHeight() >= this.getWindowWidth()) ? this.PORTRAIT : this.LANDSCAPE
	},
	getActualWindowOuterHeight: function () {
		return Math.round(this.getWindowOuterHeight() / window.devicePixelRatio)
	},
	maximize: function () {
		var c = this.stretchHeights,
			b = this.orientation,
			a;
		a = c[b];
		if (!a) {
			c[b] = a = this.getActualWindowOuterHeight()
		}
		if (!this.addressBarHeight) {
			this.addressBarHeight = a - this.getWindowHeight()
		}
		this.setHeight(a);
		var d = Ext.Function.bind(this.isHeightMaximized, this, [a]);
		this.scrollToTop();
		this.waitUntil(d, this.fireMaximizeEvent, this.fireMaximizeEvent)
	},
	isHeightMaximized: function (a) {
		this.scrollToTop();
		return this.getWindowHeight() === a
	}
}, function () {
	if (!Ext.os.is.Android) {
		return
	}
	var a = Ext.os.version,
		b = Ext.browser.userAgent,
		c = /(htc|desire|incredible|ADR6300)/i.test(b) && a.lt("2.3");
	if (c) {
		this.override({
			constructor: function (d) {
				if (!d) {
					d = {}
				}
				d.autoMaximize = false;
				this.watchDogTick = Ext.Function.bind(this.watchDogTick, this);
				setInterval(this.watchDogTick, 1000);
				return this.callParent([d])
			},
			watchDogTick: function () {
				this.watchDogLastTick = Ext.Date.now()
			},
			doPreventPanning: function () {
				var e = Ext.Date.now(),
					f = this.watchDogLastTick,
					d = e - f;
				if (d >= 2000) {
					return
				}
				return this.callParent(arguments)
			},
			doPreventZooming: function () {
				var e = Ext.Date.now(),
					f = this.watchDogLastTick,
					d = e - f;
				if (d >= 2000) {
					return
				}
				return this.callParent(arguments)
			}
		})
	}
	if (a.match("2")) {
		this.override({
			onReady: function () {
				this.addWindowListener("resize", Ext.Function.bind(this.onWindowResize, this));
				this.callParent(arguments)
			},
			scrollToTop: function () {
				document.body.scrollTop = 100
			},
			onWindowResize: function () {
				var e = this.windowWidth,
					g = this.windowHeight,
					f = this.getWindowWidth(),
					d = this.getWindowHeight();
				if (this.getAutoMaximize() && !this.isMaximizing && !this.orientationChanging && window.scrollY === 0 && e === f && d < g && ((d >= g - this.addressBarHeight) || !this.focusedElement)) {
					this.scrollToTop()
				}
			},
			fixSize: function () {
				var d = this.getOrientation(),
					f = window.outerHeight,
					g = window.outerWidth,
					e;
				if (d === "landscape" && (f < g) || d === "portrait" && (f >= g)) {
					e = this.getActualWindowOuterHeight()
				} else {
					e = this.getWindowHeight()
				}
				this.waitUntil(function () {
					return e > this.getWindowHeight()
				}, this.doFixSize, this.doFixSize, 50, 1000)
			}
		})
	} else {
		if (a.gtEq("3.1")) {
			this.override({
				isHeightMaximized: function (d) {
					this.scrollToTop();
					return this.getWindowHeight() === d - 1
				}
			})
		} else {
			if (a.match("3")) {
				this.override({
					isHeightMaximized: function () {
						this.scrollToTop();
						return true
					}
				})
			}
		}
	}
	if (a.gtEq("4")) {
		this.override({
			onResize: function () {
				this.callParent();
				if (this.getAutoMaximize()) {
					this.doFixSize()
				}
			}
		})
	}
});
Ext.define("Ext.viewport.Ios", {
	extend: Ext.viewport.Default,
	isFullscreen: function () {
		return this.isHomeScreen()
	},
	isHomeScreen: function () {
		return window.navigator.standalone === true
	},
	constructor: function () {
		this.callParent(arguments);
		if (this.getAutoMaximize() && !this.isFullscreen()) {
			this.addWindowListener("touchstart", Ext.Function.bind(this.onTouchStart, this))
		}
	},
	maximize: function () {
		if (this.isFullscreen()) {
			return this.callParent()
		}
		var c = this.stretchHeights,
			b = this.orientation,
			d = this.getWindowHeight(),
			a = c[b];
		if (window.scrollY > 0) {
			this.scrollToTop();
			if (!a) {
				c[b] = a = this.getWindowHeight()
			}
			this.setHeight(a);
			this.fireMaximizeEvent()
		} else {
			if (!a) {
				a = this.getScreenHeight()
			}
			this.setHeight(a);
			this.waitUntil(function () {
				this.scrollToTop();
				return d !== this.getWindowHeight()
			}, function () {
				if (!c[b]) {
					a = c[b] = this.getWindowHeight();
					this.setHeight(a)
				}
				this.fireMaximizeEvent()
			}, function () {
				a = c[b] = this.getWindowHeight();
				this.setHeight(a);
				this.fireMaximizeEvent()
			}, 50, 1000)
		}
	},
	getScreenHeight: function () {
		return window.screen[this.orientation === this.PORTRAIT ? "height" : "width"]
	},
	onElementFocus: function () {
		if (this.getAutoMaximize() && !this.isFullscreen()) {
			clearTimeout(this.scrollToTopTimer)
		}
		this.callParent(arguments)
	},
	onElementBlur: function () {
		if (this.getAutoMaximize() && !this.isFullscreen()) {
			this.scrollToTopTimer = setTimeout(this.scrollToTop, 500)
		}
		this.callParent(arguments)
	},
	onTouchStart: function () {
		if (this.focusedElement === null) {
			this.scrollToTop()
		}
	},
	scrollToTop: function () {
		window.scrollTo(0, 0)
	}
}, function () {
	if (!Ext.os.is.iOS) {
		return
	}
	if (Ext.os.version.lt("3.2")) {
		this.override({
			constructor: function () {
				var a = this.stretchHeights = {};
				a[this.PORTRAIT] = 416;
				a[this.LANDSCAPE] = 268;
				return this.callOverridden(arguments)
			}
		})
	}
	if (Ext.os.version.lt("5")) {
		this.override({
			fieldMaskClsTest: "-field-mask",
			doPreventZooming: function (b) {
				var a = b.target;
				if (a && a.nodeType === 1 && !this.isInputRegex.test(a.tagName) && a.className.indexOf(this.fieldMaskClsTest) == -1) {
					b.preventDefault()
				}
			}
		})
	}
	if (Ext.os.is.iPad) {
		this.override({
			isFullscreen: function () {
				return true
			}
		})
	}
});
Ext.define("Ext.viewport.WindowsPhone", {
	requires: [],
	alternateClassName: "Ext.viewport.WP",
	extend: Ext.viewport.Default,
	initialize: function () {
		var a = function (d) {
				var c = d.srcElement.nodeName.toUpperCase(),
					b = ["INPUT", "TEXTAREA"];
				if (b.indexOf(c) == -1) {
					return false
				}
			};
		document.body.attachEvent("onselectstart", a);
		this.callParent(arguments)
	}
});
Ext.define("Ext.viewport.Viewport", {
	constructor: function (b) {
		var c = Ext.os.name,
			d, a;
		switch (c) {
		case "Android":
			d = (Ext.browser.name == "ChromeMobile") ? "Default" : "Android";
			break;
		case "iOS":
			d = "Ios";
			break;
		case "Windows":
			d = (Ext.browser.name == "IE") ? "WindowsPhone" : "Default";
			break;
		case "WindowsPhone":
			d = "WindowsPhone";
			break;
		default:
			d = "Default";
			break
		}
		a = Ext.create("Ext.viewport." + d, b);
		return a
	}
});
Ext.define("AppMici.view.btn_Aggiungi", {
	extend: Ext.Button,
	alias: "widget.btn_aggiungi",
	config: {
		ui: "round",
		zIndex: 1,
		text: "MyButton",
		cls: ["btnAggiungi", "hoverBack"],
		listeners: [{
			fn: "onButtonTap",
			event: "tap"
		}]
	},
	onButtonTap: function (b, g, a) {
		var d = Ext.getCmp("template");
		var f = d.getActiveItem().id;
		if (f == "diario") {
			var c = Ext.getCmp("formdiario");
			if (!c) {
				c = Ext.create("AppMici.view.FormDiario", {
					fullscreen: true
				})
			}
			c.show()
		} else {
			var c = Ext.getCmp("formcontrollo");
			if (!c) {
				c = Ext.create("AppMici.view.FormControllo", {
					fullscreen: true
				})
			}
			c.show()
		}
	}
});
Ext.define("AppMici.view.btn_InviaMedico", {
	extend: Ext.Button,
	alias: "widget.btn_inviamedico",
	config: {
		ui: "round",
		zIndex: 1,
		text: "MyButton",
		cls: ["btnAggiungi", "hoverBack"],
		listeners: [{
			fn: "onButtonTap",
			event: "tap"
		}]
	},
	onButtonTap: function (b, d, a) {
		if (Ext.StoreManager.get("st_controllo").getCount() === 0) {
			AppMici.app.boxMessaggio("Attenzione", "Nessun controllo da inviare.")
		} else {
			var c = Ext.getCmp("inviamedico");
			if (!c) {
				c = Ext.create("AppMici.view.InviaMedico", {
					fullscreen: true
				})
			}
			c.show()
		}
	}
});
Ext.define("AppMici.view.cercaCosa", {
	extend: Ext.field.Search,
	alias: "widget.cercacosa",
	config: {
		docked: "top",
		itemId: "mysearchfield",
		maxWidth: 130,
		placeHolder: "cerca",
		listeners: [{
			fn: "onMysearchfieldKeyup",
			event: "keyup"
		}, {
			fn: "onMysearchfieldClearicontap",
			event: "clearicontap"
		}]
	},
	onMysearchfieldKeyup: function (c, d, b) {
		var a = Ext.getCmp("cosasignifica").getStore();
		a.clearFilter();
		a.filter("titolo", c._value, true)
	},
	onMysearchfieldClearicontap: function (b, c, a) {
		Ext.getCmp("cosasignifica").getStore().clearFilter()
	}
});
Ext.define("AppMici.view.pullRefresh", {
	extend: Ext.plugin.PullRefresh,
	alias: "plugin.pullrefresh",
	config: {
		lastUpdatedDateFormat: "d/m/Y H:i",
		lastUpdatedText: "Ultimo aggiornamento",
		loadedText: "Caricato",
		loadingText: "Caricamento...",
		pullRefreshText: "Trascina per ricaricare i dati",
		releaseRefreshText: "Rilascia per aggiornare",
		type: "pullrefresh",
		listeners: [{
			fn: "onPullRefreshLatestfetched",
			event: "latestfetched"
		}]
	},
	onPullRefreshLatestfetched: function (a) {
		if (!navigator.onLine) {
			AppMici.app.boxMessaggio("Attenzione", "Connessione ad internet assente, impossibile caricare i dati.")
		}
	}
});
Ext.define("AppMici.view.override.Diario", {
	override: "AppMici.view.Diario",
	lastTapped: 0,
	onItemTap: function (b, j, f, h) {
		var d = Date.now();
		var g = this,
			c = g.getStore(),
			a = c && c.getAt(f);
		if ((d - this.lastTapped) > 500) {
			this.lastTapped = d;
			g.fireEvent("itemtap", g, f, j, a, h)
		}
	}
});
Ext.define("AppMici.view.Diario", {
	extend: Ext.dataview.List,
	alias: "widget.diario",
	config: {
		title: "Il tuo diario",
		id: "diario",
		styleHtmlContent: true,
		disableSelection: false,
		emptyText: '<div style="margin:10px">Nessun evento trovato.<br>Usa il tasto <strong style="font-size:2em;vertical-align: middle;">+</strong> in alto a destra</div>',
		itemCls: "discElimina",
		loadingText: "Caricamento...",
		pressedCls: "lista-selezionata",
		pressedDelay: 60,
		selectedCls: "lista-selezionata",
		store: "st_diario",
		grouped: true,
		preventSelectionOnDisclose: false,
		itemTpl: ['<strong>{data_ora_evento:date("d F Y, H:i:s")}</strong><em>gravità: {gravita_evento}</em>', "<br/><span>{evento}</span>"],
		plugins: [{
			xtype: "pullDiario",
			type: "pullrefresh"
		}],
		listeners: [{
			fn: "onDiarioShow",
			event: "show"
		}, {
			fn: "onDiarioItemTap",
			event: "itemtap"
		}]
	},
	onDiarioShow: function (a, b) {
		AppMici.app.caricaStore("st_diario");
		setTimeout(function () {
			if (Ext.getCmp("diario")) {
				a.deselectAll()
			}
		}, 100)
	},
	onDiarioItemTap: function (b, c, h, a, g, d) {
		var f = Ext.getCmp("formdiario");
		if (!f) {
			f = Ext.create("AppMici.view.FormDiario", {
				fullscreen: true,
				record: a
			})
		}
		f.show()
	}
});
Ext.define("AppMici.view.override.Controllo", {
	override: "AppMici.view.Controllo",
	lastTapped: 0,
	onItemTap: function (b, j, f, h) {
		var d = Date.now();
		var g = this,
			c = g.getStore(),
			a = c && c.getAt(f);
		if ((d - this.lastTapped) > 500) {
			this.lastTapped = d;
			g.fireEvent("itemtap", g, f, j, a, h)
		}
	}
});
Ext.define("AppMici.view.Controllo", {
	extend: Ext.dataview.List,
	alias: "widget.controllo",
	config: {
		title: "Da inviare",
		id: "controllo",
		styleHtmlContent: true,
		allowDeselect: true,
		disableSelection: false,
		itemCls: "discElimina",
		loadingText: "Caricamento...",
		pressedCls: "lista-selezionata",
		pressedDelay: 60,
		selectedCls: "lista-selezionata",
		store: "st_controllo",
		grouped: true,
		preventSelectionOnDisclose: false,
		itemTpl: ['<strong>{data_ora_controllo:date("d F Y, H:i:s")}</strong><br><span>Indice stato di salute: <strong>{stato_salute}</strong></span>'],
		listeners: [{
			fn: "onControlloShow",
			event: "show"
		}, {
			fn: "onControlloItemTap",
			event: "itemtap"
		}],
		plugins: [{
			xtype: "pullControllo",
			type: "pullrefresh"
		}]
	},
	onControlloShow: function (a, b) {
		setTimeout(function () {
			if (Ext.getCmp("controllo")) {
				a.deselectAll()
			}
		}, 100)
	},
	onControlloItemTap: function (b, c, h, a, g, f) {
		var d = Ext.getCmp("formcontrollo");
		if (!d) {
			d = Ext.create("AppMici.view.FormControllo", {
				fullscreen: true,
				record: a
			})
		}
		d.show()
	}
});
Ext.define("AppMici.view.ControlloMain", {
	extend: Ext.tab.Panel,
	alias: "widget.controllomain",
	config: {
		title: "I tuoi controlli",
		id: "controllomain",
		ui: "light",
		layout: {
			animation: false,
			type: "card"
		},
		items: [{
			xtype: "controllo",
			id: "controlloda",
			itemId: "controlloda",
			emptyText: 'Nessun controllo trovato.<br>Usa il tasto <strong style="font-size:2em;vertical-align: middle;">+</strong> in alto a destra',
			iconCls: "reply"
		}, {
			xtype: "controllo",
			title: "Inviati",
			id: "controlloinv",
			itemId: "controlloinv",
			emptyText: "Nessun controllo trovato.",
			iconCls: "bookmarks"
		}],
		tabBar: {
			docked: "bottom",
			layout: {
				pack: "center",
				type: "hbox"
			}
		},
		listeners: [{
			fn: "onControlloShow",
			event: "show",
			delegate: "#controlloda"
		}, {
			fn: "onControlloShow1",
			event: "show",
			delegate: "#controlloinv"
		}]
	},
	onControlloShow: function (a, b) {
		AppMici.app.caricaStore("st_controllo");
		AppMici.app.filtraControlli(0);
		if (Ext.getCmp("btn_aggiungi")) {
			Ext.getCmp("btn_aggiungi").show()
		}
	},
	onControlloShow1: function (a, b) {
		AppMici.app.caricaStore("st_controllo");
		AppMici.app.filtraControlli(1);
		if (Ext.getCmp("btn_aggiungi")) {
			Ext.getCmp("btn_aggiungi").hide()
		}
	}
});
Ext.define("AppMici.view.Accesso", {
	extend: Ext.navigation.View,
	alias: "widget.accesso",
	config: {
		id: "accesso",
		padding: 0,
		style: "border-radius:5px;background:#EEEEEE;",
		zIndex: 2,
		defaultBackButtonText: "Indietro",
		cls: ["principale", "hoverhome"],
		layout: {
			type: "card",
			animation: null
		},
		items: [{
			xtype: "container",
			title: "Accesso richiesto",
			padding: "10 0 0 0",
			scrollable: "vertical",
			items: [{
				xtype: "hiddenfield",
				id: "destinazione"
			}, {
				xtype: "label",
				html: "Per visualizzare la funzione desiderata, è necessario accedere come utente registrato.",
				margin: "0 12 10 12"
			}, {
				xtype: "fieldset",
				margin: "0 10 10 10",
				padding: 10,
				items: [{
					xtype: "label",
					html: "Se è la prima volta che accedi:",
					margin: 0,
					style: "text-align:center;"
				}, {
					xtype: "button",
					centered: false,
					id: "registrati",
					itemId: "registrati",
					margin: "7 auto",
					ui: "decline-round",
					width: "55%",
					iconCls: "compose",
					text: "Registrati"
				}]
			}, {
				xtype: "fieldset",
				margin: "0 10 10 10",
				padding: 10,
				items: [{
					xtype: "label",
					html: "Se ti sei registrato sul nostro sito o hai già utilizzato l'app su un altro smartphone:",
					style: "text-align:center;"
				}, {
					xtype: "button",
					id: "accedi",
					itemId: "accedi",
					margin: "7 auto",
					ui: "decline-round",
					width: "55%",
					iconCls: "user",
					text: "Accedi"
				}]
			}]
		}],
		navigationBar: {
			cls: ["lista-selezionata", "hoverBack"],
			height: 55,
			androidAnimation: false,
			items: [{
				xtype: "button",
				align: "right",
				height: "2em",
				id: "chiudilogin",
				itemId: "chiudilogin",
				margin: "0 8",
				text: "CHIUDI"
			}]
		},
		listeners: [{
			fn: "onMybutton42Tap",
			event: "tap",
			delegate: "#registrati"
		}, {
			fn: "onMybutton42Tap1",
			event: "tap",
			delegate: "#accedi"
		}, {
			fn: "onChiudiLoginTap",
			event: "tap",
			delegate: "#chiudilogin"
		}]
	},
	onMybutton42Tap: function (b, f, a) {
		var c = Ext.getCmp("accesso");
		var d = Ext.getCmp("formaccesso");
		if (!d) {
			c.push({
				xtype: "formaccesso",
				title: "Registrati"
			})
		} else {
			d.destroy();
			d = Ext.create("AppMici.view.FormAccesso", {
				fullscreen: true,
				title: "Registrati"
			});
			c.push(d)
		}
	},
	onMybutton42Tap1: function (b, f, a) {
		var c = Ext.getCmp("accesso");
		var d = Ext.getCmp("formaccesso");
		if (!d) {
			c.push({
				xtype: "formaccesso",
				title: "Accedi"
			})
		} else {
			d.destroy();
			d = Ext.create("AppMici.view.FormAccesso", {
				fullscreen: true,
				title: "Inserisci credenziali"
			});
			c.push(d)
		}
	},
	onChiudiLoginTap: function (b, c, a) {
		AppMici.app.chiudiLogin()
	}
});
Ext.define("AppMici.view.Template", {
	extend: Ext.navigation.View,
	alias: "widget.template",
	config: {
		id: "template",
		style: "background:url('resources/immagini/sfondo.png') #ffffff repeat-x",
		defaultBackButtonText: "Indietro",
		layout: {
			type: "card",
			animation: null
		},
		cls: ["principale", "hoverhome"],
		items: [{
			xtype: "container",
			title: "Home",
			itemId: "mycontainer",
			scrollable: "vertical",
			items: [{
				xtype: "button",
				border: "0px",
				cls: "bottoniHome",
				itemId: "btn_InfoUtili",
				text: "Informazioni utili"
			}, {
				xtype: "button",
				border: "0px",
				cls: "bottoniHome",
				id: "btn_diario",
				itemId: "btn_Diario",
				text: "Il tuo diario"
			}, {
				xtype: "button",
				border: "0px",
				cls: "bottoniHome",
				id: "btn_controlli",
				itemId: "btn_Controlli",
				text: "I tuoi controlli"
			}, {
				xtype: "image",
				docked: "bottom",
				height: "59px",
				margin: "auto auto 15px auto",
				width: "200px",
				src: "resources/immagini/footer.png"
			}, {
				xtype: "label",
				bottom: "",
				centered: false,
				docked: "bottom",
				html: "<center>Realizzato con il supporto non condizionato di</center>",
				margin: "0px 0px 0px 0px",
				style: "font-size:11px;color:#6a747b;"
			}]
		}],
		navigationBar: {
			border: 0,
			id: "templatedeader",
			minHeight: "166px",
			style: "background:url('resources/immagini/header.png') no-repeat;background-size:320px 166px;",
			androidAnimation: false,
			items: [{
				xtype: "image",
				align: "right",
				centered: false,
				height: 119,
				hidden: false,
				right: 0,
				top: 0,
				width: 132,
				src: "resources/immagini/loghidx.png"
			}]
		},
		listeners: [{
			fn: "onBtn_InfoUtiliTap",
			event: "tap",
			delegate: "#btn_InfoUtili"
		}, {
			fn: "onBtn_DiarioTap",
			event: "tap",
			delegate: "#btn_diario"
		}, {
			fn: "onBtn_ControlliTap",
			event: "tap",
			delegate: "#btn_controlli"
		}, {
			fn: "onMycontainerShow",
			event: "show",
			delegate: "#mycontainer"
		}, {
			fn: "onTemplatePainted",
			single: false,
			event: "painted"
		}]
	},
	onBtn_InfoUtiliTap: function (b, c, a) {
		b.up("navigationview").push({
			xtype: "infoutili"
		})
	},
	onBtn_DiarioTap: function (b, c, a) {
		AppMici.app.apriSezione("diario")
	},
	onBtn_ControlliTap: function (b, c, a) {
		AppMici.app.apriSezione("controllo")
	},
	onMycontainerShow: function (a, b) {
		if (Ext.getCmp("btn_aggiungi")) {
			Ext.getCmp("btn_aggiungi").destroy()
		}
		if (Ext.getCmp("btn_inviamedico")) {
			Ext.getCmp("btn_inviamedico").destroy()
		}
	},
	onTemplatePainted: function (b, a) {
		AppMici.app.sincronizzaInfo()
	}
});
Ext.define("AppMici.model.mo_InfoUtili", {
	extend: Ext.data.Model,
	alias: "model.mo_infoutili",
	config: {
		clientIdProperty: "mo_infoutili",
		identifier: {
			type: "uuid"
		},
		fields: [{
			name: "id",
			type: "auto"
		}, {
			name: "titolo"
		}, {
			name: "testo"
		}]
	}
});
Ext.define("AppMici.model.mo_Diario", {
	extend: Ext.data.Model,
	alias: "model.mo_diario",
	config: {
		clientIdProperty: "mo_diario",
		idProperty: "id_evento",
		fields: [{
			name: "id_evento",
			type: "string"
		}, {
			name: "id_utente",
			type: "string"
		}, {
			dateFormat: "timestamp",
			name: "data_ora_evento",
			sortDir: "DESC",
			type: "date"
		}, {
			name: "evento",
			type: "string"
		}, {
			name: "gravita_evento",
			type: "int"
		}, {
			name: "peso_corporeo",
			type: "float"
		}, {
			name: "appetito",
			type: "int"
		}, {
			name: "note_personali",
			type: "string"
		}, {
			name: "gruppo",
			type: "string"
		}],
		proxy: {
			type: "ajax",
			reader: {
				type: "json",
				rootProperty: "dati"
			},
			writer: {
				type: "json",
				allowSingle: false,
				encode: true,
				rootProperty: "dati"
			}
		},
		validations: [{
			type: "presence",
			field: "data_ora_evento"
		}]
	}
});
Ext.define("AppMici.model.mo_Controllo", {
	extend: Ext.data.Model,
	alias: "model.mo_controllo",
	config: {
		clientIdProperty: "mo_controllo",
		idProperty: "id_controllo",
		fields: [{
			name: "id_controllo",
			type: "string"
		}, {
			name: "id_utente",
			type: "string"
		}, {
			dateFormat: "timestamp",
			name: "data_ora_controllo",
			sortDir: "DESC",
			type: "date"
		}, {
			name: "stato_salute",
			type: "int"
		}, {
			name: "dolore_addominale",
			type: "int"
		}, {
			name: "numero_evacuazioni",
			type: "int"
		}, {
			name: "complicanze",
			type: "string"
		}, {
			name: "complicanze_altro",
			type: "string"
		}, {
			name: "emoglobina",
			type: "string"
		}, {
			name: "ematocrito",
			type: "string"
		}, {
			name: "mcv",
			type: "string"
		}, {
			name: "piastrine",
			type: "string"
		}, {
			name: "ves",
			type: "string"
		}, {
			name: "pcr",
			type: "string"
		}, {
			name: "leucociti",
			type: "string"
		}, {
			name: "granulociti_neutrofili",
			type: "string"
		}, {
			name: "eosinofili",
			type: "string"
		}, {
			name: "linfociti",
			type: "string"
		}, {
			name: "monociti",
			type: "string"
		}, {
			name: "ferro",
			type: "string"
		}, {
			name: "ferritina",
			type: "string"
		}, {
			name: "saturazione_transferrina",
			type: "string"
		}, {
			name: "proteine_totali",
			type: "string"
		}, {
			name: "albumina",
			type: "string"
		}, {
			name: "alfa_1_globuline",
			type: "string"
		}, {
			name: "alfa_2_globuline",
			type: "string"
		}, {
			name: "beta_1_globuline",
			type: "string"
		}, {
			name: "beta_2_globuline",
			type: "string"
		}, {
			name: "gamma_globuline",
			type: "string"
		}, {
			name: "creatinina",
			type: "string"
		}, {
			name: "clearance_creatinina",
			type: "string"
		}, {
			name: "azotemia",
			type: "string"
		}, {
			name: "calcio",
			type: "string"
		}, {
			name: "sodio",
			type: "string"
		}, {
			name: "potassio",
			type: "string"
		}, {
			name: "cloro",
			type: "string"
		}, {
			name: "massa_addominale",
			type: "string"
		}, {
			name: "note_personali",
			type: "string"
		}, {
			name: "gruppo",
			type: "string"
		}, {
			name: "controllo_inviato",
			type: "string"
		}],
		proxy: {
			type: "ajax",
			reader: {
				type: "json",
				rootProperty: "dati"
			},
			writer: {
				type: "json",
				allowSingle: false,
				encode: true,
				rootProperty: "dati"
			}
		},
		validations: [{
			type: "presence",
			field: "data_ora_controllo"
		}, {
			type: "presence",
			field: "complicanze"
		}, {
			type: "format",
			field: "numero_evacuazioni",
			matcher: /[0-9]/,
			message: "formato non valido"
		}]
	}
});
Ext.define("AppMici.model.mo_Config", {
	extend: Ext.data.Model,
	alias: "model.mo_config",
	config: {
		clientIdProperty: "mo_config",
		identifier: {
			type: "uuid"
		},
		fields: [{
			name: "id",
			type: "auto"
		}, {
			name: "chiave",
			type: "string"
		}, {
			name: "valore",
			type: "string"
		}],
		proxy: {
			type: "localstorage",
			id: "pr_config"
		}
	}
});
Ext.define("AppMici.model.mo_InfoUtili_OnLine", {
	extend: Ext.data.Model,
	alias: "model.mo_infoutili_online",
	config: {
		clientIdProperty: "mo_infoutili_online",
		idProperty: "titolo",
		fields: [{
			name: "titolo"
		}, {
			name: "testo"
		}, {
			name: "versione"
		}],
		proxy: {
			type: "jsonp",
			url: "https://secure.evolutionlab.it/appmici/informazioni_utili_json.php"
		}
	}
});
Ext.define("AppMici.model.mo_CosaSign_online", {
	extend: Ext.data.Model,
	alias: "model.mo_cosasign_online",
	config: {
		clientIdProperty: "mo_cosasign_online",
		idProperty: "titolo",
		fields: [{
			name: "iniziale"
		}, {
			name: "titolo"
		}, {
			name: "testo"
		}, {
			name: "versione"
		}],
		proxy: {
			type: "jsonp",
			url: "https://secure.evolutionlab.it/appmici/cosa_significa_json.php"
		}
	}
});
Ext.define("AppMici.model.mo_CosaSign", {
	extend: Ext.data.Model,
	alias: "model.mo_cosasign",
	config: {
		clientIdProperty: "mo_cosasign",
		identifier: {
			type: "uuid"
		},
		fields: [{
			name: "id",
			type: "auto"
		}, {
			name: "iniziale"
		}, {
			name: "titolo"
		}, {
			name: "testo"
		}]
	}
});
Ext.define("AppMici.store.st_InfoUtili", {
	extend: Ext.data.Store,
	alias: "store.st_infoutili",
	config: {
		clearOnPageLoad: false,
		model: "AppMici.model.mo_InfoUtili",
		storeId: "st_infoutili",
		listeners: [{
			fn: "onStoreLoad",
			single: true,
			event: "load"
		}]
	},
	onStoreLoad: function (c, b, e, a, d) {
		if (!e) {
			AppMici.app.boxMessaggio("Attenzione", "Connessione ad internet assente, impossibile caricare i dati.")
		}
	}
});
Ext.define("AppMici.store.st_Diario", {
	extend: Ext.data.Store,
	alias: "store.st_diario",
	config: {
		model: "AppMici.model.mo_Diario",
		storeId: "st_diario",
		grouper: {
			groupFn: function (a) {
				return "<div style='display:none'>" + a.data.gruppo.substr(0, a.data.gruppo.indexOf("_")) + "</div>" + a.data.gruppo.substr(a.data.gruppo.indexOf("_") + 1)
			}
		},
		listeners: [{
			fn: "onJsonpstoreBeforeLoad",
			event: "beforeload"
		}, {
			fn: "onJsonpstoreLoad",
			event: "load"
		}]
	},
	onJsonpstoreBeforeLoad: function (b, a, d) {
		var c = b.getModel().getProxy();
		c.setApi({
			create: "https://secure.evolutionlab.it/appmici/il_tuo_diario_json.php?azione=aggiungi&id_utente=" + AppMici.app.idUtente() + "&key=" + encodeURIComponent(AppMici.app.keyUtente()),
			read: "https://secure.evolutionlab.it/appmici/il_tuo_diario_json.php?azione=leggi&id_utente=" + AppMici.app.idUtente() + "&key=" + encodeURIComponent(AppMici.app.keyUtente()),
			update: "https://secure.evolutionlab.it/appmici/il_tuo_diario_json.php?azione=aggiorna&id_utente=" + AppMici.app.idUtente() + "&key=" + encodeURIComponent(AppMici.app.keyUtente()),
			destroy: "https://secure.evolutionlab.it/appmici/il_tuo_diario_json.php?azione=elimina&id_utente=" + AppMici.app.idUtente() + "&key=" + encodeURIComponent(AppMici.app.keyUtente())
		})
	},
	onJsonpstoreLoad: function (c, b, e, a, d) {
		if (!e) {
			AppMici.app.boxMessaggio("Attenzione", "Connessione ad internet assente, impossibile caricare i dati.")
		}
	}
});
Ext.define("AppMici.store.st_Controllo", {
	extend: Ext.data.Store,
	alias: "store.st_controllo",
	config: {
		model: "AppMici.model.mo_Controllo",
		storeId: "st_controllo",
		grouper: {
			groupFn: function (a) {
				return "<div style='display:none'>" + a.data.gruppo.substr(0, a.data.gruppo.indexOf("_")) + "</div>" + a.data.gruppo.substr(a.data.gruppo.indexOf("_") + 1)
			}
		},
		listeners: [{
			fn: "onJsonpstoreBeforeLoad",
			event: "beforeload"
		}, {
			fn: "onJsonpstoreLoad",
			event: "load"
		}, {
			fn: "onJsonpstoreRemoverecords",
			event: "removerecords"
		}]
	},
	onJsonpstoreBeforeLoad: function (b, a, d) {
		var c = b.getModel().getProxy();
		c.setApi({
			create: "https://secure.evolutionlab.it/appmici/i_tuoi_controlli_json.php?azione=aggiungi&id_utente=" + AppMici.app.idUtente() + "&key=" + encodeURIComponent(AppMici.app.keyUtente()),
			read: "https://secure.evolutionlab.it/appmici/i_tuoi_controlli_json.php?azione=leggi&id_utente=" + AppMici.app.idUtente() + "&key=" + encodeURIComponent(AppMici.app.keyUtente()),
			update: "https://secure.evolutionlab.it/appmici/i_tuoi_controlli_json.php?azione=aggiorna&id_utente=" + AppMici.app.idUtente() + "&key=" + encodeURIComponent(AppMici.app.keyUtente()),
			destroy: "https://secure.evolutionlab.it/appmici/i_tuoi_controlli_json.php?azione=elimina&id_utente=" + AppMici.app.idUtente() + "&key=" + encodeURIComponent(AppMici.app.keyUtente())
		})
	},
	onJsonpstoreLoad: function (c, b, e, a, d) {
		if (!e) {
			AppMici.app.boxMessaggio("Attenzione", "Connessione ad internet assente, impossibile caricare i dati.")
		} else {
			AppMici.app.caricaBadge(c)
		}
	},
	onJsonpstoreRemoverecords: function (b, a, d, c) {
		AppMici.app.caricaBadge(b)
	}
});
Ext.define("AppMici.store.st_Config", {
	extend: Ext.data.Store,
	alias: "store.st_config",
	config: {
		autoLoad: true,
		clearOnPageLoad: false,
		model: "AppMici.model.mo_Config",
		storeId: "st_config",
		listeners: [{
			fn: "onStoreLoad",
			single: true,
			event: "load"
		}]
	},
	onStoreLoad: function (c, b, e, a, d) {}
});
Ext.define("AppMici.store.st_InfoUtili_OnLine", {
	extend: Ext.data.Store,
	alias: "store.st_infoutili_online",
	config: {
		autoLoad: true,
		clearOnPageLoad: false,
		model: "AppMici.model.mo_InfoUtili_OnLine",
		storeId: "st_infoutili_online",
		listeners: [{
			fn: "onJsonpstoreLoad",
			event: "load"
		}]
	},
	onJsonpstoreLoad: function (c, b, e, a, d) {
		if (!e) {
			AppMici.app.boxMessaggio("Attenzione", "Connessione ad internet assente, impossibile caricare i dati.")
		} else {
			AppMici.app.caricaStore("st_cosasign_online")
		}
	}
});
Ext.define("AppMici.store.st_CosaSign_OnLine", {
	extend: Ext.data.Store,
	alias: "store.st_cosasign_online",
	config: {
		clearOnPageLoad: false,
		model: "AppMici.model.mo_CosaSign_online",
		storeId: "st_cosasign_online",
		grouper: {
			groupFn: function (a) {
				return a.data.iniziale
			}
		}
	}
});
Ext.define("AppMici.store.st_CosaSign", {
	extend: Ext.data.Store,
	alias: "store.st_cosasign",
	config: {
		clearOnPageLoad: false,
		model: "AppMici.model.mo_CosaSign",
		storeId: "st_cosasign",
		listeners: [{
			fn: "onStoreLoad",
			single: true,
			event: "load"
		}]
	},
	onStoreLoad: function (c, b, e, a, d) {
		if (!e) {
			AppMici.app.boxMessaggio("Attenzione", "Connessione ad internet assente, impossibile caricare i dati.")
		}
	}
});
Ext.define("AppMici.view.clsValidate", {
	extend: Ext.Label,
	alias: "widget.clsvalidate",
	config: {
		cls: "validateDa",
		docked: "bottom",
		html: "Le informazioni qui riportate sono state validate da IG-IBD",
		padding: 4,
		ui: ""
	}
});
Ext.define("AppMici.view.InfoUtili", {
	extend: Ext.dataview.List,
	alias: "widget.infoutili",
	config: {
		title: "Informazioni utili",
		id: "infoutili",
		styleHtmlContent: true,
		emptyText: "Nessun dato disponibile.<br>Trascina in basso per aggiornare.",
		loadingText: "Caricamento...",
		pressedCls: "lista-selezionata",
		pressedDelay: 60,
		selectedCls: "lista-selezionata",
		store: "st_infoutili_online",
		striped: true,
		itemTpl: ["<strong>{titolo}</strong>"],
		listeners: [{
			fn: "onInfoutiliShow",
			event: "show"
		}, {
			fn: "onInfoutiliItemTap",
			event: "itemtap"
		}, {
			fn: "onInfoutiliActivate",
			event: "activate"
		}],
		plugins: [{
			xtype: "pullInfo",
			type: "pullrefresh"
		}],
		items: [{
			xtype: "clsvalidate"
		}]
	},
	onInfoutiliShow: function (a, b) {
		var c = Ext.StoreManager.get("st_cosasign_online");
		if (c.isLoaded()) {
			c.clearFilter()
		}
		setTimeout(function () {
			if (Ext.getCmp("infoutili")) {
				a.deselectAll()
			}
		}, 100)
	},
	onInfoutiliItemTap: function (b, c, g, a, f, d) {
		if (a.data.titolo == "Cosa significa") {
			b.up("navigationview").push({
				xtype: "cosasignifica"
			})
		} else {
			b.up("navigationview").push({
				xtype: "dettagli_info",
				data: a.data,
				title: a.data.titolo
			})
		}
	},
	onInfoutiliActivate: function (e, c, b, d) {
		if (Ext.getCmp("cercacosa")) {
			Ext.getCmp("cercacosa").setValue("");
			Ext.get(Ext.getCmp("cercacosa").element).setStyle("visibility", "hidden")
		}
		var a = Ext.getStore("st_cosasign");
		a.clearFilter()
	}
});
Ext.define("AppMici.view.Dettagli_Info", {
	extend: Ext.dataview.component.DataItem,
	alias: "widget.dettagli_info",
	config: {
		id: "dettagli_info",
		styleHtmlContent: true,
		scrollable: "vertical",
		tpl: ["{testo}"],
		items: [{
			xtype: "clsvalidate"
		}],
		listeners: [{
			fn: "onDettagli_infoPainted",
			event: "painted"
		}]
	},
	onDettagli_infoPainted: function (b, a) {
		if (Ext.getCmp("cercacosa")) {
			Ext.get(Ext.getCmp("cercacosa").element).setStyle("visibility", "hidden")
		}
	}
});
Ext.define("AppMici.view.CosaSignifica", {
	extend: Ext.dataview.List,
	alias: "widget.cosasignifica",
	config: {
		title: "Cosa significa",
		id: "cosasignifica",
		disableSelection: false,
		emptyText: "Nessun dato disponibile.",
		loadingText: "Caricamento...",
		pressedCls: "lista-selezionata",
		pressedDelay: 60,
		scrollToTopOnRefresh: false,
		selectedCls: "lista-selezionata",
		store: "st_cosasign_online",
		grouped: true,
		infinite: true,
		refreshHeightOnUpdate: false,
		striped: true,
		variableHeights: true,
		itemTpl: ["<strong>{titolo}</strong>"],
		listeners: [{
			fn: "onCosaSignificaShow",
			event: "show"
		}, {
			fn: "onCosasignificaItemTap",
			event: "itemtap"
		}, {
			fn: "onCosasignificaPainted",
			event: "painted"
		}],
		plugins: [{
			xtype: "pullCosa",
			type: "pullrefresh"
		}],
		items: [{
			xtype: "clsvalidate"
		}]
	},
	onCosaSignificaShow: function (a, b) {
		setTimeout(function () {
			if (Ext.getCmp("cosasignifica")) {
				a.deselectAll()
			}
		}, 100)
	},
	onCosasignificaItemTap: function (b, c, g, a, f, d) {
		b.up("navigationview").push({
			xtype: "dettagli_info",
			data: a.data,
			title: a.data.titolo
		})
	},
	onCosasignificaPainted: function (b, a) {
		AppMici.app.aggiungiCerca(Ext.getCmp("cosasignifica"))
	}
});
Ext.define("AppMici.view.FormDiario", {
	extend: Ext.form.Panel,
	alias: "widget.formdiario",
	config: {
		title: "Evento diario",
		id: "formdiario",
		zIndex: 4,
		items: [{
			xtype: "fieldset",
			items: [{
				xtype: "hiddenfield",
				name: "id_evento",
				readOnly: true
			}, {
				xtype: "datetimepickerfield",
				dateTimeFormat: "d/m/Y H:i",
				itemId: "data_ora_evento",
				label: "Data",
				name: "data_ora_evento",
				required: true,
				destroyPickerOnHide: true,
				picker: {
					ampm: false,
					minuteInterval: 1,
					itemId: "picker_evento",
					dayText: "Giorno",
					monthText: "Mese",
					yearFrom: 2000,
					yearText: "Anno",
					doneButton: "Seleziona",
					cancelButton: {
						hidden: false,
						text: "Annulla"
					}
				}
			}, {
				xtype: "textareafield",
				padding: "5 3",
				styleHtmlContent: true,
				label: "Evento",
				name: "evento",
				maxLength: 50
			}, {
				xtype: "sliderfield",
				html: '<div style="float:left;">0-min</div><div style="float:right">7-max</div>',
				itemId: "mysliderfield4",
				label: "Gravità",
				name: "gravita_evento",
				maxValue: 7
			}, {
				xtype: "numberfield",
				padding: "5 3",
				styleHtmlContent: true,
				label: "Peso (kg)",
				name: "peso_corporeo"
			}, {
				xtype: "sliderfield",
				html: '<div style="float:left;">0-min</div><div style="float:right">7-max</div>',
				label: "Appetito",
				name: "appetito",
				maxValue: 7
			}, {
				xtype: "textareafield",
				padding: "5 3",
				styleHtmlContent: true,
				label: "Note personali",
				labelWrap: true,
				name: "note_personali",
				maxLength: 200
			}]
		}, {
			xtype: "titlebar",
			cls: ["lista-selezionata", "hoverBack"],
			docked: "top",
			title: "Evento del diario",
			items: [{
				xtype: "button",
				align: "right",
				height: "2em",
				id: "chiudi",
				itemId: "chiudi",
				margin: "0 8",
				text: "CHIUDI"
			}]
		}, {
			xtype: "button",
			id: "btnsalva",
			itemId: "btnsalva",
			margin: "0 10 10 10",
			ui: "confirm",
			iconCls: "compose",
			text: "Salva"
		}, {
			xtype: "button",
			id: "btnelimina",
			itemId: "btnelimina",
			margin: "5 10 10 10",
			ui: "decline",
			iconCls: "trash",
			text: "Elimina",
			listeners: [{
				fn: function (b, a) {
					if (Ext.getCmp("diario").getSelection().length > 0) {
						b.show()
					} else {
						b.hide()
					}
				},
				event: "painted"
			}]
		}],
		listeners: [{
			fn: "onChiudiTap",
			event: "tap",
			delegate: "#chiudi"
		}, {
			fn: "onFormdiarioShow",
			event: "show"
		}, {
			fn: "onMybutton11Tap",
			event: "tap",
			delegate: "#btnsalva"
		}, {
			fn: "onMybutton29Tap",
			event: "tap",
			delegate: "#btnelimina"
		}, {
			fn: "onFormdiarioHide",
			event: "hide"
		}]
	},
	onChiudiTap: function (b, d, a) {
		var c = Ext.getCmp("formdiario");
		c.hide();
		setTimeout(function () {
			c.destroy()
		}, 501)
	},
	onFormdiarioShow: function (a, b) {
		if (!a.getRecord()) {
			setTimeout(function () {
				a.getFields().data_ora_evento.setValue(new Date())
			}, 100)
		}
	},
	onMybutton11Tap: function (b, f, a) {
		aggiunta = false;
		rec = Ext.getCmp("formdiario").getRecord();
		if (!rec) {
			aggiunta = true;
			rec = Ext.create("AppMici.model.mo_Diario")
		}
		rec.set(Ext.getCmp("formdiario").getValues());
		var g = rec.validate();
		if (!g.isValid()) {
			var d = "";
			g.each(function (e) {
				d += e.getField().replace("_", " ") + " " + e.getMessage().replace("must be present", "campo obbligatorio") + ", "
			});
			if (!aggiunta) {
				Ext.getCmp("formdiario").getRecord().reject()
			} else {
				rec.reject()
			}
			AppMici.app.boxMessaggio("Errore", d)
		} else {
			if (AppMici.app.isOnline()) {
				rec.save();
				setTimeout(function () {
					Ext.StoreManager.get("st_diario").load()
				}, 500);
				var c = Ext.getCmp("formdiario");
				c.hide();
				setTimeout(function () {
					c.destroy()
				}, 501)
			} else {
				if (!aggiunta) {
					Ext.getCmp("formdiario").getRecord().reject()
				} else {
					rec.reject()
				}
				AppMici.app.boxMessaggio("Errore", "L'operazione richiede una connessione ad internet!")
			}
		}
	},
	onMybutton29Tap: function (b, c, a) {
		AppMici.app.eliminaRecord("diario", "formdiario", "Vuoi eliminare l'evento?")
	},
	onFormdiarioHide: function (a) {
		Ext.getCmp("diario").deselectAll()
	}
});
Ext.define("AppMici.view.FormAccesso", {
	extend: Ext.form.Panel,
	alias: "widget.formaccesso",
	config: {
		centered: false,
		id: "frmaccesso",
		margin: "20px 0px 0px 0px",
		padding: "0px",
		ui: "",
		items: [{
			xtype: "fieldset",
			id: "fieldlogin",
			margin: "10px",
			items: [{
				xtype: "textfield",
				id: "regnome",
				label: "Nome*",
				labelWidth: "37%",
				name: "nome"
			}, {
				xtype: "textfield",
				id: "regcognome",
				label: "Cogome*",
				labelWidth: "37%",
				name: "cognome"
			}, {
				xtype: "emailfield",
				id: "utente",
				label: "Email",
				labelWidth: "37%",
				name: "utente",
				required: true,
				placeHolder: "indirizzo@email.it"
			}, {
				xtype: "passwordfield",
				label: "Password",
				labelWidth: "37%",
				name: "pwd",
				required: true
			}]
		},
		{
			xtype: "button",
			id: "eseguiaccesso",
			itemId: "eseguiaccesso",
			margin: "15 10 5 10",
			ui: "decline",
			text: "Richiedi accesso"
		},
		{
			xtype: "spacer",
			height: "10px"
		},
		{
			xtype: "label",
			html: "Utilizzando questa App esprimo il mio consenso al trattamento da parte dell’associazione AMICI Onlus dei miei dati qualificati come personali, anche sensibili, per le finalità illustrate nell'<a target='_blank' class='privacy' style='color:#006D6B' href='#' onclick='apriPrivacy()'>Informativa ai sensi del D. Lgs. 30/06/2003 n. 196</a>, di cui dichiaro di aver preso integrale visione.",
			margin: "0 12 10 12"
		}],
		listeners: [{
			fn: "onAccediTap",
			event: "tap",
			delegate: "#eseguiaccesso"
		}, {
			fn: "onFrmaccessoPainted",
			event: "painted"
		}]
	},
	onAccediTap: function (b, c, a) {
		var d = b.up("formaccesso").getValues();
		if (d.utente && d.pwd) {
			if (AppMici.app.isEmail(d.utente)) {
				if (Ext.getCmp("accesso").getNavigationBar().getTitle() == "Registrati") {
					if (d.nome && d.cognome) {
						AppMici.app.gestioneUtente("https://secure.evolutionlab.it/appmici/registraUtente.php", d, Ext.getCmp("destinazione").getValue())
					} else {
						AppMici.app.boxMessaggio("Attenzione", "Tutti i campi sono obbligatori!")
					}
				} else {
					AppMici.app.gestioneUtente("https://secure.evolutionlab.it/appmici/login.php", d, Ext.getCmp("destinazione").getValue())
				}
			} else {
				AppMici.app.boxMessaggio("Attenzione", "Formato email non valido!")
			}
		} else {
			AppMici.app.boxMessaggio("Attenzione", "Tutti i campi sono obbligatori")
		}
	},
	onFrmaccessoPainted: function (c, b) {
		var a = Ext.getCmp("eseguiaccesso");
		var e = Ext.getCmp("regnome");
		var d = Ext.getCmp("regcognome");
		if (Ext.getCmp("accesso").getNavigationBar().getTitle() == "Registrati") {
			a.setIconCls("action");
			a.setText("Richiedi registrazione");
			e.show();
			d.show()
		} else {
			Ext.getCmp("eseguiaccesso").setIconCls("user");
			a.setText("Esegui l'accesso");
			e.hide();
			d.hide()
		}
	}
});
Ext.define("AppMici.view.FormControllo", {
	extend: Ext.form.Panel,
	alias: "widget.formcontrollo",
	config: {
		title: "I tuoi controlli",
		id: "formcontrollo",
		zIndex: 4,
		items: [{
			xtype: "titlebar",
			cls: ["lista-selezionata", "hoverBack"],
			docked: "top",
			title: "I tuoi controlli",
			items: [{
				xtype: "button",
				align: "right",
				height: "2em",
				id: "chiudictr",
				itemId: "chiudictr",
				margin: "0 8",
				text: "CHIUDI"
			}]
		}, {
			xtype: "fieldset",
			styleHtmlContent: true,
			items: [{
				xtype: "hiddenfield",
				name: "id_evento",
				readOnly: true
			}, {
				xtype: "datetimepickerfield",
				dateTimeFormat: "d/m/Y H:i",
				itemId: "data_ora_controllo",
				label: "Data inserimento",
				labelWidth: "40%",
				name: "data_ora_controllo",
				required: true,
				readOnly: true,
				picker: {
					ampm: false,
					minuteInterval: 1,
					itemId: "picker_controllo",
					dayText: "Giorno",
					monthText: "Mese",
					yearFrom: 2000,
					yearText: "Anno",
					doneButton: "Seleziona",
					cancelButton: {
						hidden: true,
						style: "display:none!important;",
						text: "Annulla"
					}
				}
			}, {
				xtype: "sliderfield",
				html: '<div style="float:left;">0-ottimo</div><div style="float:right">4-pessimo</div>',
				itemId: "mysliderfield4",
				label: "Stato generale di salute",
				labelWidth: "40%",
				labelWrap: true,
				name: "stato_salute",
				maxValue: 4
			}, {
				xtype: "sliderfield",
				html: '<div style="float:left;">0-nessuno</div><div style="float:right">3-molto intenso</div>',
				label: "Appetito",
				labelWidth: "40%",
				name: "dolore_addominale",
				maxValue: 3
			}, {
				xtype: "numberfield",
				label: "Evacuazioni liquide al giorno",
				labelWidth: "40%",
				labelWrap: true,
				name: "numero_evacuazioni",
				maxLength: 50
			}, {
				xtype: "multiselectfield",
				delimiter: ",",
				mode: "MULTI",
				label: "Complicanze",
				labelWidth: "40%",
				labelWrap: true,
				name: "complicanze",
				defaultPhonePickerConfig: {
					doneButton: "Seleziona",
					cancelButton: "Annulla"
				},
				options: [{
					text: "Nessuna",
					value: "Nessuna"
				}, {
					text: "Artralgia",
					value: "Artralgia"
				}, {
					text: "Uveite",
					value: "Uveite"
				}, {
					text: "Eritema nodoso",
					value: "Eritema nodoso"
				}, {
					text: "Afte",
					value: "Afte"
				}, {
					text: "Pioderma gangrenoso",
					value: "Pioderma gangrenoso"
				}, {
					text: "Ragade anale",
					value: "Ragade anale"
				}, {
					text: "Nuova fistola",
					value: "Nuova fistola"
				}, {
					text: "Altro",
					value: "Altro (specificare)"
				}]
			}, {
				xtype: "textfield",
				label: "Complicanze (Altro)",
				labelWidth: "40%",
				labelWrap: true,
				name: "complicanze_altro",
				maxLength: 200
			}, {
				xtype: "textfield",
				label: "Emoglobina (g/dl)",
				labelWidth: "40%",
				labelWrap: true,
				name: "emoglobina",
				maxLength: 50,
				placeHolder: "Controllo non richiesto"
			}, {
				xtype: "textfield",
				label: "Ematocrito (%)",
				labelWidth: "40%",
				labelWrap: true,
				name: "ematocrito",
				maxLength: 50,
				placeHolder: "Controllo non richiesto"
			}, {
				xtype: "textfield",
				label: "MCV (fl o μm³)",
				labelWidth: "40%",
				labelWrap: true,
				name: "mcv",
				maxLength: 50,
				placeHolder: "Controllo non richiesto"
			}, {
				xtype: "textfield",
				label: "Piastrine (/mm³)",
				labelWidth: "40%",
				labelWrap: true,
				name: "piastrine",
				maxLength: 50,
				placeHolder: "Controllo non richiesto"
			}, {
				xtype: "textfield",
				label: "VES (mm/h)",
				labelWidth: "40%",
				labelWrap: true,
				name: "ves",
				maxLength: 50,
				placeHolder: "Controllo non richiesto"
			}, {
				xtype: "textfield",
				label: "PCR (mg/dl)<br>Anche valore di riferimento tra parentesi",
				labelWidth: "40%",
				labelWrap: true,
				name: "pcr",
				maxLength: 50,
				placeHolder: "Controllo non richiesto"
			}, {
				xtype: "textfield",
				label: "Leucociti (/mm³)",
				labelWidth: "40%",
				labelWrap: true,
				name: "leucociti",
				maxLength: 50,
				placeHolder: "Controllo non richiesto"
			}, {
				xtype: "textfield",
				label: "Granulociti<br>neutrofili (%)",
				labelWidth: "40%",
				labelWrap: true,
				name: "granulociti_neutrofili",
				maxLength: 50,
				placeHolder: "Controllo non richiesto"
			}, {
				xtype: "textfield",
				label: "Eosinofili (%)",
				labelWidth: "40%",
				labelWrap: true,
				name: "eosinofili",
				maxLength: 50,
				placeHolder: "Controllo non richiesto"
			}, {
				xtype: "textfield",
				label: "Linfociti (%)",
				labelWidth: "40%",
				labelWrap: true,
				name: "linfociti",
				maxLength: 50,
				placeHolder: "Controllo non richiesto"
			}, {
				xtype: "textfield",
				label: "Monociti (%)",
				labelWidth: "40%",
				labelWrap: true,
				name: "monociti",
				maxLength: 50,
				placeHolder: "Controllo non richiesto"
			}, {
				xtype: "textfield",
				label: "Ferro (μg/dl)",
				labelWidth: "40%",
				labelWrap: true,
				name: "ferro",
				maxLength: 50,
				placeHolder: "Controllo non richiesto"
			}, {
				xtype: "textfield",
				label: "Ferritina (ng/ml)",
				labelWidth: "40%",
				labelWrap: true,
				name: "ferritina",
				maxLength: 50,
				placeHolder: "Controllo non richiesto"
			}, {
				xtype: "textfield",
				label: "Saturazione transferrina (%)",
				labelWidth: "40%",
				labelWrap: true,
				name: "saturazione_transferrina",
				maxLength: 50,
				placeHolder: "Controllo non richiesto"
			}, {
				xtype: "textfield",
				label: "Proteine totali (g/dl)",
				labelWidth: "40%",
				labelWrap: true,
				name: "proteine_totali",
				maxLength: 50,
				placeHolder: "Controllo non richiesto"
			}, {
				xtype: "textfield",
				label: "Albumina (%)",
				labelWidth: "40%",
				labelWrap: true,
				name: "albumina",
				maxLength: 50,
				placeHolder: "Controllo non richiesto"
			}, {
				xtype: "textfield",
				label: "Alfa 1 globuline (%)",
				labelWidth: "40%",
				labelWrap: true,
				name: "alfa_1_globuline",
				maxLength: 50,
				placeHolder: "Controllo non richiesto"
			}, {
				xtype: "textfield",
				label: "Alfa 2 globuline (%)",
				labelWidth: "40%",
				labelWrap: true,
				name: "alfa_2_globuline",
				maxLength: 50,
				placeHolder: "Controllo non richiesto"
			}, {
				xtype: "textfield",
				label: "Beta 1 globuline (%)",
				labelWidth: "40%",
				labelWrap: true,
				name: "beta_1_globuline",
				maxLength: 50,
				placeHolder: "Controllo non richiesto"
			}, {
				xtype: "textfield",
				label: "Beta 2 globuline (%)",
				labelWidth: "40%",
				labelWrap: true,
				name: "beta_2_globuline",
				maxLength: 50,
				placeHolder: "Controllo non richiesto"
			}, {
				xtype: "textfield",
				label: "Gamma globuline (%)",
				labelWidth: "40%",
				labelWrap: true,
				name: "gamma_globuline",
				maxLength: 50,
				placeHolder: "Controllo non richiesto"
			}, {
				xtype: "textfield",
				label: "Creatinina (mg/dl)",
				labelWidth: "40%",
				labelWrap: true,
				name: "creatinina",
				maxLength: 50,
				placeHolder: "Controllo non richiesto"
			}, {
				xtype: "textfield",
				label: "Clearance creatinina (ml/min)",
				labelWidth: "40%",
				labelWrap: true,
				name: "clearance_creatinina",
				maxLength: 50,
				placeHolder: "Controllo non richiesto"
			}, {
				xtype: "textfield",
				label: "Azotemia (mg/dl)",
				labelWidth: "40%",
				labelWrap: true,
				name: "azotemia",
				maxLength: 50,
				placeHolder: "Controllo non richiesto"
			}, {
				xtype: "textfield",
				label: "Calcio (mg/dl)",
				labelWidth: "40%",
				labelWrap: true,
				name: "calcio",
				maxLength: 50,
				placeHolder: "Controllo non richiesto"
			}, {
				xtype: "textfield",
				label: "Sodio (mEq/l)",
				labelWidth: "40%",
				labelWrap: true,
				name: "sodio",
				maxLength: 50,
				placeHolder: "Controllo non richiesto"
			}, {
				xtype: "textfield",
				label: "Potassio (mEq/l)",
				labelWidth: "40%",
				labelWrap: true,
				name: "potassio",
				maxLength: 50,
				placeHolder: "Controllo non richiesto"
			}, {
				xtype: "textfield",
				label: "Cloro (mEq/l)",
				labelWidth: "40%",
				labelWrap: true,
				name: "cloro",
				maxLength: 50,
				placeHolder: "Controllo non richiesto"
			}, {
				xtype: "textfield",
				label: "Massa addominale",
				labelWidth: "40%",
				labelWrap: true,
				name: "massa_addominale",
				maxLength: 50,
				placeHolder: "Controllo non effettuato"
			}, {
				xtype: "textareafield",
				label: "Note",
				labelWidth: "40%",
				labelWrap: true,
				name: "note_personali",
				maxLength: 200
			}]
		}, {
			xtype: "button",
			id: "btnsalvactr",
			margin: "0 10 10 10",
			ui: "confirm",
			iconCls: "compose",
			text: "Salva"
		}, {
			xtype: "button",
			id: "btneliminactr",
			margin: "5 10 10 10",
			ui: "decline",
			iconCls: "trash",
			text: "Elimina"
		}],
		listeners: [{
			fn: "onChiudictrTap",
			event: "tap",
			delegate: "#chiudictr"
		}, {
			fn: "onFormcontrolloHide",
			event: "hide"
		}, {
			fn: "onBtnSalvaCtrTap",
			event: "tap",
			delegate: "#btnsalvactr"
		}, {
			fn: "onBtnEliminaCtrTap",
			event: "tap",
			delegate: "#btneliminactr"
		}, {
			fn: "onFormcontrolloShow",
			event: "show"
		}]
	},
	onChiudictrTap: function (b, d, a) {
		var c = Ext.getCmp("formcontrollo");
		c.hide();
		setTimeout(function () {
			c.destroy()
		}, 501)
	},
	onFormcontrolloHide: function (a) {
		Ext.getCmp("controlloda").deselectAll();
		Ext.getCmp("controlloinv").deselectAll()
	},
	onBtnSalvaCtrTap: function (b, f, a) {
		aggiunta = false;
		rec = Ext.getCmp("formcontrollo").getRecord();
		if (!rec) {
			aggiunta = true;
			rec = Ext.create("AppMici.model.mo_Controllo")
		}
		rec.set(Ext.getCmp("formcontrollo").getValues());
		var g = rec.validate();
		if (!g.isValid()) {
			var d = "";
			g.each(function (e) {
				d += e.getField().replace("_", " ") + " " + e.getMessage().replace("must be present", "campo obbligatorio") + ", "
			});
			if (!aggiunta) {
				Ext.getCmp("formcontrollo").getRecord().reject()
			} else {
				rec.reject()
			}
			AppMici.app.boxMessaggio("Errore", d)
		} else {
			if (AppMici.app.isOnline()) {
				rec.save();
				setTimeout(function () {
					Ext.StoreManager.get("st_controllo").load()
				}, 500);
				var c = Ext.getCmp("formcontrollo");
				c.hide();
				setTimeout(function () {
					c.destroy()
				}, 501)
			} else {
				if (!aggiunta) {
					Ext.getCmp("formcontrollo").getRecord().reject()
				} else {
					rec.reject()
				}
				AppMici.app.boxMessaggio("Errore", "L'operazione richiede una connessione ad internet!")
			}
		}
	},
	onBtnEliminaCtrTap: function (b, c, a) {
		AppMici.app.eliminaRecord("controlloda", "formcontrollo", "Vuoi eliminare il controllo?")
	},
	onFormcontrolloShow: function (a, b) {
		if (!a.getRecord()) {
			a.getFields().data_ora_controllo.setValue(new Date());
			Ext.getCmp("btneliminactr").hide()
		}
		if (!Ext.getCmp("btn_inviamedico")) {
			Ext.each(a.query("textfield"), function (c) {
				c.setReadOnly(true)
			});
			Ext.each(a.query("sliderfield"), function (c) {
				c.setDisabled(true)
			});
			Ext.getCmp("btneliminactr").hide();
			Ext.getCmp("btnsalvactr").hide()
		} else {
			Ext.each(a.query("textfield"), function (c) {
				Ext.select("#" + c.bodyElement.getId() + " input").setHeight((c.bodyElement.getHeight()))
			})
		}
	}
});
Ext.define("AppMici.view.InviaMedico", {
	extend: Ext.navigation.View,
	alias: "widget.inviamedico",
	config: {
		id: "inviamedico",
		zIndex: 10,
		items: [{
			xtype: "formpanel",
			title: "Invia al medico",
			id: "forminviamedico",
			itemId: "forminviamedico",
			padding: "10 0 0 0",
			scrollable: "vertical",
			items: [{
				xtype: "label",
				html: "Invia al tuo medico gli esiti degli esami e le comunicazioni inserite nel campo Note",
				margin: "0 12 10 12"
			}, {
				xtype: "fieldset",
				margin: "0 10 15 10",
				styleHtmlContent: true,
				items: [{
					xtype: "textfield",
					label: "Nome*",
					labelWidth: "36%",
					labelWrap: true,
					name: "nome"
				}, {
					xtype: "textfield",
					label: "Cognome*",
					labelWidth: "36%",
					name: "cognome"
				}, {
					xtype: "label",
					html: "<em>Nome e Cognome visualizzati nell'oggetto  dell´e-mail inviata al clinico  di riferimento</em>",
					margin: "10 5 10 5",
					ui: ""
				}]
			}, {
				xtype: "fieldset",
				margin: "10 10 15 10",
				styleHtmlContent: true,
				items: [{
					xtype: "emailfield",
					label: "Indirizzo email*",
					labelWidth: "36%",
					name: "emailmedico",
					placeHolder: "indirizzo@email.it"
				}, {
					xtype: "label",
					html: "<em>Email del clinico di riferimento</em>",
					margin: "10 5 10 5",
					ui: ""
				}]
			}, {
				xtype: "button",
				id: "inviamail",
				itemId: "mybutton45",
				margin: 10,
				ui: "decline",
				iconCls: "reply",
				text: "Invia email"
			}]
		}],
		navigationBar: {
			cls: ["lista-selezionata", "hoverBack"],
			height: 55,
			items: [{
				xtype: "button",
				align: "right",
				height: "2em",
				id: "chiudimedico",
				itemId: "chiudimedico",
				margin: "0 8",
				text: "CHIUDI"
			}]
		},
		listeners: [{
			fn: "onInviamailTap",
			event: "tap",
			delegate: "#inviamail"
		}, {
			fn: "onForminviamedicoShow",
			event: "show",
			delegate: "#forminviamedico"
		}, {
			fn: "onChiudiMedicoTap",
			event: "tap",
			delegate: "#chiudimedico"
		}]
	},
	onInviamailTap: function (b, c, a) {
		var d = Ext.getCmp("forminviamedico").getValues();
		if (d.nome && d.cognome && d.emailmedico) {
			if (AppMici.app.isEmail(d.emailmedico)) {
				AppMici.app.inviaMedico(d)
			} else {
				AppMici.app.boxMessaggio("Errore", "Formato email non valido!")
			}
		} else {
			AppMici.app.boxMessaggio("Errore", "Tutti i campi sono obbligatori")
		}
	},
	onForminviamedicoShow: function (a, b) {
		var c = Ext.StoreManager.get("st_config");
		if (!c.isLoaded()) {
			c.load()
		}
		c.clearFilter();
		c.filter("chiave", "nome", false);
		if (c.getData().items[0]) {
			a.getFields().nome.setValue(c.getData().items[0].data.valore)
		}
		c.filter("chiave", "cognome", false);
		if (c.getData().items[0]) {
			a.getFields().cognome.setValue(c.getData().items[0].data.valore)
		}
		c.filter("chiave", "emailMed", false);
		if (c.getData().items[0]) {
			a.getFields().emailmedico.setValue(c.getData().items[0].data.valore)
		}
	},
	onChiudiMedicoTap: function (b, c, a) {
		AppMici.app.chiudiInvio(false)
	}
});
Ext.define("AppMici.view.MyLabel36", {
	extend: Ext.Label,
	config: {}
});
Ext.Loader.setConfig({
	paths: {
		Ext: "./touch/src"
	}
});
Ext.application({
	viewport: {
		itemId: "viewport",
		autoMaximize: true,
		preventZooming: true
	},
	models: ["mo_InfoUtili", "mo_Diario", "mo_Controllo", "mo_Config", "mo_InfoUtili_OnLine", "mo_CosaSign_online", "mo_CosaSign"],
	stores: ["st_InfoUtili", "st_Diario", "st_Controllo", "st_Config", "st_InfoUtili_OnLine", "st_CosaSign_OnLine", "st_CosaSign"],
	views: ["Template", "InfoUtili", "Dettagli_Info", "Diario", "Accesso", "CosaSignifica", "clsValidate", "FormDiario", "btn_Aggiungi", "FormAccesso", "btn_InviaMedico", "FormControllo", "ControlloMain", "Controllo", "InviaMedico", "pullRefresh", "cercaCosa", "MyLabel36"],
	isIconPrecomposed: true,
	name: "AppMici",
	aggiungiBottone: function () {
		if (!Ext.getCmp("btn_aggiungi")) {
			setTimeout(function () {
				Ext.Viewport.add({
					xtype: "btn_aggiungi",
					id: "btn_aggiungi",
					right: 5,
					top: 127,
					iconCls: "add",
					ui: "action",
					text: "",
					padding: "0px 10px 3px 10px"
				})
			}, 100)
		}
	},
	isOnline: function () {
		return navigator.onLine;
	},
	filtraControlli: function (a) {
		var b = Ext.getStore("st_controllo");
		b.clearFilter();
		if (a == "0") {
			b.filter("controllo_inviato", 0, true);
			if (!Ext.getCmp("btn_inviamedico")) {
				setTimeout(function () {
					Ext.Viewport.add({
						xtype: "btn_inviamedico",
						id: "btn_inviamedico",
						right: 70,
						top: 127,
						iconCls: "reply",
						ui: "action",
						text: "",
						padding: "0px 10px 3px 10px"
					})
				}, 100)
			}
			AppMici.app.aggiungiBottone();
			AppMici.app.caricaBadge(b)
		} else {
			if (Ext.getCmp("btn_inviamedico")) {
				Ext.getCmp("btn_inviamedico").destroy()
			}
			if (Ext.getCmp("btn_aggiungi")) {
				Ext.getCmp("btn_aggiungi").destroy()
			}
			b.filter("controllo_inviato", 1, true)
		}
	},
	aggiungiCerca: function (a) {
		if (!Ext.getCmp("cercacosa")) {
			setTimeout(function () {
				if (a.up()) {
					a.up().getNavigationBar().add({
						xtype: "cercacosa",
						id: "cercacosa",
						right: 0,
						top: 121
					})
				}
			}, 100)
		} else {
			setTimeout(function () {
				Ext.get(Ext.getCmp("cercacosa").element).setStyle("visibility", "visible")
			}, 400)
		}
	},
	caricaStore: function (a) {
		var b = Ext.StoreManager.get(a);
		if (!b.isLoaded()) {
			b.load()
		}
	},
	apriSezione: function (b) {
		if (AppMici.app.loggato() === 0) {
			AppMici.app.apriLogin(b, 1)
		} else {
			if (b == "diario") {
				var a = Ext.getCmp("diario");
				if (a) {
					a.destroy()
				}
				a = Ext.create("AppMici.view.Diario", {
					fullscreen: true
				});
				Ext.getCmp("template").push(a);
				AppMici.app.aggiungiBottone()
			} else {
				if (b == "controllo") {
					var a = Ext.getCmp("controllomain");
					if (a) {
						a.destroy()
					}
					a = Ext.create("AppMici.view.ControlloMain", {
						fullscreen: true
					});
					Ext.getCmp("template").push(a)
				}
			}
		}
	},
	sincronizzaInfo: function () {},
	aggiornaStoreOffline: function (a, b) {
		var c = Ext.StoreManager.get(a);
		if (!c.isLoaded()) {
			c.load({
				callback: function (e, d, h) {
					var g = Ext.StoreManager.get(b);
					g.removeAll(true);
					for (var f = 0; f < e.length; f++) {
						g.add(e[f].data)
					}
					g.sync()
				},
				scope: this
			});
			c.removeAll();
			c.sync()
		}
	},
	gestioneUtente: function (a, c, b) {
		if (AppMici.app.isOnline()) {
			Ext.Ajax.request({
				url: a,
				disableCaching: true,
				params: {
					username: c.utente,
					password: c.pwd,
					cognome: c.cognome,
					nome: c.nome
				},
				withCredentials: false,
				useDefaultXhrHeader: false,
				success: function (h) {
					var j = h.responseText;
					var k = j.split("|");
					var g = "";
					var d = "";
					var e = "";
					var o = "";
					var l = "";
					var f = "";
					if (k.length > 0) {
						if (AppMici.app.isNumero(k[0]) === true && AppMici.app.isNumero(k[1]) === true) {
							g = k[0];
							d = k[1];
							e = k[2];
							o = k[3];
							l = k[4];
							f = k[5]
						}
					}
					if (g !== "" && d !== "" && g != "0" && d != "0") {
						var m = Ext.StoreManager.get("st_config");
						var n = m.getAt(0);
						m.removeAll();
						m.add({
							chiave: "login",
							valore: g
						});
						m.add({
							chiave: "idApp",
							valore: d
						});
						m.add({
							chiave: "nome",
							valore: e
						});
						m.add({
							chiave: "cognome",
							valore: o
						});
						m.add({
							chiave: "emailMed",
							valore: l
						});
						m.add({
							chiave: "key",
							valore: f
						});
						m.sync();
						AppMici.app.apriSezione(b);
						AppMici.app.chiudiLogin()
					} else {
						AppMici.app.boxMessaggio("Errore", j)
					}
				},
				failure: function (d) {
					var e = d.responseText;
					AppMici.app.boxMessaggio("Errore", "Impossibile accedere al server di login")
				}
			})
		} else {
			AppMici.app.boxMessaggio("Errore", "L'operazione richiede una connessione ad internet!")
		}
	},
	idUtente: function () {
		var a = Ext.StoreManager.get("st_config");
		if (!a.isLoaded()) {
			a.load()
		}
		a.clearFilter();
		if (a.getCount() > 0) {
			a.filter("chiave", "idApp", false);
			if (a.getData().items[0]) {
				item = a.getData().items[0].data.valore
			} else {
				item = 0
			}
			a.clearFilter();
			return item
		} else {
			return 0
		}
	},
	keyUtente: function () {
		var a = Ext.StoreManager.get("st_config");
		if (!a.isLoaded()) {
			a.load()
		}
		a.clearFilter();
		if (a.getCount() > 0) {
			a.filter("chiave", "key", false);
			if (a.getData().items[0]) {
				item = a.getData().items[0].data.valore
			} else {
				item = ""
			}
			a.clearFilter();
			return item
		} else {
			return ""
		}
	},
	loggato: function () {
		var a = Ext.StoreManager.get("st_config");
		if (!a.isLoaded()) {
			a.load()
		}
		a.clearFilter();
		if (a.getCount() > 0) {
			a.filter("chiave", "key", false);
			if (a.getData().items[0]) {
				item = a.getData().items[0].data.valore
			} else {
				item = 0
			}
			a.clearFilter();
			if (item != "0") {
				a.filter("chiave", "login", false);
				if (a.getData().items[0]) {
					item = a.getData().items[0].data.valore
				} else {
					item = 0
				}
				a.clearFilter()
			}
			return item
		} else {
			return 0
		}
	},
	apriLogin: function (c, b) {
		if (b === 1) {
			var a = Ext.getCmp("accesso");
			if (!a) {
				a = Ext.create("AppMici.view.Accesso", {
					fullscreen: true
				})
			}
			a.show();
			Ext.getCmp("destinazione").setValue(c)
		} else {}
	},
	chiudiLogin: function () {
		var a = Ext.getCmp("accesso");
		a.hide();
		setTimeout(function () {
			a.destroy()
		}, 250)
	},
	chiudiInvio: function (a) {
		var b = Ext.getCmp("inviamedico");
		if (a === true) {
			setTimeout(function () {
				Ext.StoreManager.get("st_controllo").load();
				AppMici.app.apriSezione("controllo")
			}, 400)
		}
		setTimeout(function () {
			b.destroy()
		}, 401)
	},
	isNumero: function (a) {
		return !isNaN(parseFloat(a)) && isFinite(a)
	},
	isEmail: function (b) {
		var a = /^[^\s@]+@[^\s@]+\.[^\s@]+$/;
		return a.test(b)
	},
	boxMessaggio: function (b, a) {
		//Ext.Msg.alert(b, a, Ext.emptyFn);
            Ext.device.Notification.show({
                title: b,
                message: a,
                buttons: 'ok'
            });
	},
	eliminaRecord: function (a, c, b) {
		if (AppMici.app.isOnline()) {
			Ext.device.Notification.show({
				title: "Attenzione",
				message: b,
				buttons: ["ok", "annulla"],
				callback: function (f) {
					console.log(f);
					if (f == "ok") {
						var d = Ext.getCmp(a);
						var e = d.getStore();
						e.removeAt(e.indexOf(d.getSelection()[0]));
						e.sync();
						d.refresh();
						var g = Ext.getCmp(c);
						g.hide();
						setTimeout(function () {
							g.destroy()
						}, 300);
						if (a == "diario") {
							AppMici.app.apriSezione("diario")
						} else {
							AppMici.app.apriSezione("controllo")
						}
					}
				}
			})
		} else {
			AppMici.app.boxMessaggio("Errore", "L'operazione richiede una connessione ad internet!")
		}
	},
	inviaMedico: function (a) {
		if (AppMici.app.isOnline()) {
			Ext.device.Notification.show({
				title: "Attenzione",
				message: "Confermi l'invio degli esami al medico?",
				buttons: ["ok", "annulla"],
				callback: function (e) {
					if (e == "ok") {
						var c = AppMici.app.idUtente();
						var d = AppMici.app.keyUtente();
						var b = a.nome;
						var g = a.cognome;
						var f = a.emailmedico;
						Ext.Ajax.request({
							url: "https://secure.evolutionlab.it/appmici/dati_invia.php",
							disableCaching: true,
							params: {
								nome: b,
								cognome: g,
								email_clinico: f,
								id_utente: c,
								key: d
							},
							withCredentials: false,
							useDefaultXhrHeader: false,
							success: function (h) {
								var k = Ext.StoreManager.get("st_config");
								var j = k.getAt(0);
								k.removeAll();
								k.add({
									chiave: "login",
									valore: "2"
								});
								k.add({
									chiave: "idApp",
									valore: c
								});
								k.add({
									chiave: "nome",
									valore: b
								});
								k.add({
									chiave: "cognome",
									valore: g
								});
								k.add({
									chiave: "emailMed",
									valore: f
								});
								k.add({
									chiave: "key",
									valore: d
								});
								k.sync();
								AppMici.app.chiudiInvio(true)
							},
							failure: function (h) {
								var j = h.responseText;
								AppMici.app.boxMessaggio("Errore", "Impossibile accedere al server di login. Controlla la connessione ad internet.")
							}
						})
					}
				}
			})
		} else {
			AppMici.app.boxMessaggio("Errore", "L'operazione richiede una connessione ad internet!")
		}
	},
	caricaBadge: function (b) {
		var a = Ext.getCmp("controllomain").getActiveItem();
		if (a.getItemId() == "controlloda") {
			Ext.getCmp("controllomain").getTabBar().getComponent(0).setBadgeText(b.getCount())
		}
	},
	checkPrivacy: function(){
		var a = Ext.StoreManager.get("st_config");
		if (!a.isLoaded()) { a.load() }
		a.clearFilter();
		console.log(a.getCount());
		if (a.getCount() > 0) {
			a.filter("chiave", "privacy", false);
			if (!a.getData().items[0]) {
				AppMici.app.msgPrivacy(a);
			}
			a.clearFilter();
		} else {
			AppMici.app.msgPrivacy(a);
		}
	},
	msgPrivacy: function(a){
		a.add({
			chiave: "privacy",
			valore: "1"
		});
		a.sync();
		Ext.Msg.alert("Attenzione", "Utilizzando questa App esprimo il mio consenso al trattamento da parte dell’associazione AMICI Onlus dei miei dati qualificati come personali, anche sensibili, per le finalità illustrate nell'<a target='_blank' class='privacy' style='color:white' href='#' onclick='apriPrivacy()'>Informativa ai sensi del D. Lgs. 30/06/2003 n. 196</a>, di cui dichiaro di aver preso integrale visione.", Ext.emptyFn);
	},
	launch: function () {
		document.addEventListener("deviceready", onDeviceReady, false);
		Ext.Date.monthNames = ["Gennaio", "Febbraio", "Marzo", "Aprile", "Maggio", "Giugno", "Luglio", "Agosto", "Settembre", "Ottobre", "Novembre", "Dicembre"];
		Ext.create("AppMici.view.Template", {
			fullscreen: true
		});
		
		AppMici.app.checkPrivacy();
		Ext.fly("splashImage").destroy();

	}
});